
This is a patch file against 0.4.2.

Change to directory gnupg-0.4.2 (or however you renamed it)
and give this command:

     zcat somepath/gnupg-0.4.3.diff.gz | patch -p1

It is a good idea to rename your current directory to gnupg-0.4.3 now.



Prereq: 0.4.2

diff -urN gnupg-0.4.2/VERSION gnupg-0.4.3/VERSION
--- gnupg-0.4.2/VERSION	Sun Oct 18 17:04:59 1998
+++ gnupg-0.4.3/VERSION	Sun Nov  8 17:48:10 1998
@@ -1 +1 @@
-0.4.2
+0.4.3

diff -urN gnupg-0.4.2/AUTHORS gnupg-0.4.3/AUTHORS
--- gnupg-0.4.2/AUTHORS	Fri Oct  2 11:04:22 1998
+++ gnupg-0.4.3/AUTHORS	Sat Oct 24 16:22:25 1998
@@ -28,3 +28,6 @@
 TRANSLATIONS	Walter Koch	    ??????????
 de.po
 
+TRANSLATIONS	Gregory Steuck	    ??????????
+ru.po
+
diff -urN gnupg-0.4.2/ChangeLog gnupg-0.4.3/ChangeLog
--- gnupg-0.4.2/ChangeLog	Wed Oct 14 14:42:34 1998
+++ gnupg-0.4.3/ChangeLog	Sun Nov  8 18:21:11 1998
@@ -1,3 +1,24 @@
+Sun Nov  8 18:20:35 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* VERSION: Set to 0.4.3
+
+Sun Oct 25 19:49:37 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* Makefile.am (g10defs.h): New macro GNUPG_DATADIR.
+
+Wed Oct 21 17:24:24 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* configure.in: Removed gettext kludge
+	* acinclude.m4: Add patched AM_WITH_NKS macro
+
+Tue Oct 20 19:03:36 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* configure.in: Kludge to make AM_GNU_GETTEXT work,
+	changed some macors to more modern versions. Also
+	changeg the all makefiles to remove duplicate ../intl.
+	* acinclude.m4: Removed the gettext stuff, as this
+	already comes with automake now.
+
 Wed Oct 14 12:11:34 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* configure.in (NAME_OF_DEV_RANDOM): New.
diff -urN gnupg-0.4.2/Makefile.am gnupg-0.4.3/Makefile.am
--- gnupg-0.4.2/Makefile.am	Sat Oct 17 09:04:48 1998
+++ gnupg-0.4.3/Makefile.am	Sun Oct 25 20:02:59 1998
@@ -13,9 +13,11 @@
 	echo "#ifdef __MINGW32__"; \
 	echo "#define G10_LOCALEDIR \"c:/lib/gnupg/locale\""; \
 	echo "#define GNUPG_LIBDIR \"c:/lib/gnupg\""; \
+	echo "#define GNUPG_DATADIR \"c:/lib/gnupg\""; \
 	echo "#else";\
 	echo "#define G10_LOCALEDIR \"$(prefix)/$(DATADIRNAME)/locale\""; \
 	echo "#define GNUPG_LIBDIR \"$(libdir)/gnupg\""; \
+	echo "#define GNUPG_DATADIR \"$(datadir)/gnupg\""; \
 	echo "#endif";\
 	) >g10defs.h
 
@@ -36,12 +38,23 @@
 
 # maintainer only
 cvs-get:
-	rsync -avuzb --exclude '*~' koch@ftp.guug.de:work/gnupg .
+	rsync -Cavuzb  --exclude scratch --exclude .deps \
+		      koch@ftp.guug.de:work/gnupg .
 
 cvs-put:
-	rsync -Cavuzb . koch@ftp.guug.de:work/gnupg
+	rsync -Cavuzb --exclude .deps --exclude scratch \
+		      . koch@ftp.guug.de:work/gnupg
 
 cvs-sync: cvs-get cvs-put
+
+
+tobold-get:
+	rsync -Cavuzb --exclude scratch --exclude .deps \
+		      tobold:gnupg/ .
+
+tobold-put:
+	rsync -Cavuzb --exclude scratch --exclude .deps \
+		      . tobold:gnupg/
 
 
 .PHONY: cvs-get cvs-put cvs-sync
diff -urN gnupg-0.4.2/Makefile.in gnupg-0.4.3/Makefile.in
--- gnupg-0.4.2/Makefile.in	Sun Oct 18 17:07:30 1998
+++ gnupg-0.4.3/Makefile.in	Sun Nov  8 18:22:48 1998
@@ -1,4 +1,4 @@
-# Makefile.in generated automatically by automake 1.2f from Makefile.am
+# Makefile.in generated automatically by automake 1.3 from Makefile.am
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 # This Makefile.in is free software; the Free Software Foundation
@@ -32,6 +32,8 @@
 includedir = @includedir@
 oldincludedir = /usr/include
 
+DISTDIR =
+
 pkgdatadir = $(datadir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
@@ -106,13 +108,13 @@
 
 TAR = tar
 GZIP = --best
-default: all
+all: all-recursive-am all-am
 
 .SUFFIXES:
-$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) 
+$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4)
 	cd $(top_srcdir) && $(AUTOMAKE) --gnu --include-deps Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status
 	cd $(top_builddir) \
 	  && CONFIG_FILES=$@ CONFIG_HEADERS= $(SHELL) ./config.status
 
@@ -282,8 +284,6 @@
 
 uninstall: uninstall-recursive
 
-all: all-recursive-am all-am
-
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs: installdirs-recursive
@@ -324,12 +324,11 @@
 	@echo "it deletes files that may require special tools to rebuild."
 	-rm -f config.status
 
-.PHONY: default mostlyclean-hdr distclean-hdr clean-hdr \
-maintainer-clean-hdr install-data-recursive uninstall-data-recursive \
-install-exec-recursive uninstall-exec-recursive installdirs-recursive \
-uninstalldirs-recursive all-recursive check-recursive \
-installcheck-recursive info-recursive dvi-recursive \
-mostlyclean-recursive distclean-recursive clean-recursive \
+.PHONY: mostlyclean-hdr distclean-hdr clean-hdr maintainer-clean-hdr \
+install-data-recursive uninstall-data-recursive install-exec-recursive \
+uninstall-exec-recursive installdirs-recursive uninstalldirs-recursive \
+all-recursive check-recursive installcheck-recursive info-recursive \
+dvi-recursive mostlyclean-recursive distclean-recursive clean-recursive \
 maintainer-clean-recursive tags tags-recursive mostlyclean-tags \
 distclean-tags clean-tags maintainer-clean-tags distdir info dvi \
 installcheck all-recursive-am all-am install-exec install-data install \
@@ -347,9 +346,11 @@
 	echo "#ifdef __MINGW32__"; \
 	echo "#define G10_LOCALEDIR \"c:/lib/gnupg/locale\""; \
 	echo "#define GNUPG_LIBDIR \"c:/lib/gnupg\""; \
+	echo "#define GNUPG_DATADIR \"c:/lib/gnupg\""; \
 	echo "#else";\
 	echo "#define G10_LOCALEDIR \"$(prefix)/$(DATADIRNAME)/locale\""; \
 	echo "#define GNUPG_LIBDIR \"$(libdir)/gnupg\""; \
+	echo "#define GNUPG_DATADIR \"$(datadir)/gnupg\""; \
 	echo "#endif";\
 	) >g10defs.h
 
@@ -368,12 +369,22 @@
 
 # maintainer only
 cvs-get:
-	rsync -avuzb --exclude '*~' koch@ftp.guug.de:work/gnupg .
+	rsync -Cavuzb  --exclude scratch --exclude .deps \
+		      koch@ftp.guug.de:work/gnupg .
 
 cvs-put:
-	rsync -Cavuzb . koch@ftp.guug.de:work/gnupg
+	rsync -Cavuzb --exclude .deps --exclude scratch \
+		      . koch@ftp.guug.de:work/gnupg
 
 cvs-sync: cvs-get cvs-put
+
+tobold-get:
+	rsync -Cavuzb --exclude scratch --exclude .deps \
+		      tobold:gnupg/ .
+
+tobold-put:
+	rsync -Cavuzb --exclude scratch --exclude .deps \
+		      . tobold:gnupg/
 
 .PHONY: cvs-get cvs-put cvs-sync
 
diff -urN gnupg-0.4.2/NEWS gnupg-0.4.3/NEWS
--- gnupg-0.4.2/NEWS	Sun Oct 18 16:39:06 1998
+++ gnupg-0.4.3/NEWS	Sun Nov  8 17:48:03 1998
@@ -1,3 +1,29 @@
+Noteworthy changes in version 0.4.3
+-----------------------------------
+
+    * Fixed the gettext configure bug.
+
+    * Kludge for RSA keys: keyid and length of a RSA key are
+      correctly reported, but you get an error if you try to use
+      this key (If you do not have the non-US version).
+
+    * Experimental support for keyrings stored in a GDBM database.
+      This is *much* faster than a standard keyring.  You will notice
+      that the import gets slower with time; the reason is that all
+      new keys are used to verify signatures of previous inserted
+      keys.  Use "--keyring gnupg-gdbm:<name-of-gdbm-file>".  This is
+      not (yet) supported for secret keys.
+
+    * A Russian language file in the distribution (alternatives are in
+      the contrib directory of the FTP servers)
+
+    * commandline option processing now works as expected for GNU programs
+      with the execption that you can't mix options and normal arguments.
+
+    * Now --list-key lists all matching keys.  This is needed in some
+      other places too.
+
+
 Noteworthy changes in version 0.4.2
 -----------------------------------
 
diff -urN gnupg-0.4.2/PROJECTS gnupg-0.4.3/PROJECTS
--- gnupg-0.4.2/PROJECTS	Mon Sep 28 20:49:09 1998
+++ gnupg-0.4.3/PROJECTS	Wed Oct 28 18:36:55 1998
@@ -1,6 +1,14 @@
 
-  - abstraction of the MPI
+  * abstraction of the MPI
 
-  - Add a way to override the current cipher/md implementations
+  * Add a way to override the current cipher/md implementations
     by others (using extensions)
+
+  * add a fast-import command which does not do the signature checks
+    of other keys (processing of the sdir hintlist).  The signatures
+    may then be verified by a maintainence pass.
+
+  * Not GnupG replated:  What about option completion in bash?
+    Can "--dump-options" be used for this or should we place the
+    options in a special ELF segment?
 
diff -urN gnupg-0.4.2/README gnupg-0.4.3/README
--- gnupg-0.4.2/README	Sat Oct 17 17:35:18 1998
+++ gnupg-0.4.3/README	Sun Nov  8 17:50:20 1998
@@ -1,333 +1,344 @@
-		  GnuPG - The GNU Privacy Guard
-		 -------------------------------
-			  Version 0.4
-
-    As you can see from the version number, the program may have some
-    bugs and some features may not work at all - please report this to
-    the mailing list.
-
-    On a Linux box (version 2.x.x, alpha or x86 CPU) it should
-    work reliably.  You may create your key on such a machine and
-    use it.  Please verify the tar file; there is a PGP and a GnuPG
-    signature available. My PGP 2 key is well known and published in
-    the "Global Trust Register for 1998", ISBN 0-9532397-0-5.
-
-    I have included my pubring as "g10/pubring.asc", which contains
-    the key used to make GnuPG signatures:
-    "pub  1024D/57548DCD 1998-07-07 Werner Koch (gnupg sig) <dd9jn@gnu.org>"
-    "Key fingerprint = 6BD9 050F D8FC 941B 4341  2DCC 68B7 AB89 5754 8DCD"
-
-    Old version of gnupg are signed with this key:
-    "pub  1312G/FF3EAA0B 1998-02-09 Werner Koch <wk@isil.d.shuttle.de>"
-    "Key fingerprint = 8489 6CD0 1851 0E33 45DA  CD67 036F 11B8 FF3E AA0B"
-
-    My usual key is now:
-    "pub  1024D/621CC013 1998-07-07 Werner Koch <werner.koch@guug.de>"
-    "Key fingerprint = ECAF 7590 EB34 43B5 C7CF  3ACB 6C7E E1B8 621C C013"
-
-    You may add it to your GnuPG pubring and use it in the future to
-    verify new releases.  Because you verified this README file and
-    _checked_that_it_is_really_my PGP2 key 0C9857A5, you can be sure
-    that the above fingerprints are correct.
-
-    Please subscribe to g10@net.lut.ac.uk by sending a mail with
-    the word "subscribe" in the body to "g10-request@net.lut.ac.uk".
-    This mailing is closed (only subscribers can post) to avoid spam.
-
-    See the file COPYING for copyright and warranty information.
-
-    Due to the fact that GnuPG does not use use any patented algorithm,
-    it cannot be compatible with old PGP versions, because those use
-    IDEA (which is patented worldwide) and RSA (which is patented in
-    the United States until Sep 20, 2000).
-
-    GnuPG is in almost all  aspects compatible with other OpenPGP
-    implementations.
-
-    The default algorithms are now DSA and ELGamal.  ELGamal for signing
-    is still available, but due to the larger size of such signatures it
-    is depreciated (Please note that the GnuPG implementation of ElGamal
-    signatures is *not* insecure).  Symmetric algorithms are: 3DES, Blowfish
-    and CAST5,	Digest algorithms are MD5, RIPEMD160, SHA1 and TIGER/192.
-
-
-
-    Installation
-    ------------
-
-    Please read the file INSTALL!
-
-    Here is a quick summary:
-
-    1)	"./configure"
-
-    2) "make"
-
-    3) "make install"
-
-    4) You end up with a binary "gpg" in /usr/local/bin
-
-    5) Optional, but suggested: install the program "gpg" as suid root.
-
-
-
-    Key Generation
-    --------------
-
-	gpg --gen-key
-
-    This asks some questions and then starts key generation. To create
-    good random numbers for prime number generation, it uses a /dev/random
-    which will only emit bytes if the kernel can gather enough entropy.
-    If you see no progress, you should start some other activities such
-    as mouse moves, "find /" or using the keyboard (in another window).
-    Because we have no hardware device to generate randomness we have to
-    use this method.
-
-    You should make a revocation certificate in case someone gets
-    knowledge of your secret key or you forgot your passphrase:
-
-	gpg --gen-revoke your_user_id
-
-    Run this command and store it away; output is always ASCII armored,
-    so that you can print it and (hopefully never) re-create it if
-    your electronic media fails.
-
-    If you decided to create a DSA key, you should add an ElGamal
-    for encryption:
-
-	gpg --add-key user_id_of_your_key
-
-    and follow the displayed instructions (select "ElGamal using v4 packets").
-
-
-    You can sign a key with this command:
-
-	gpg --sign-key Donald
-
-    This let you sign the key of "Donald" with your default userid.
-
-	gpg --sign-key -u Karl -u Joe Donald
-
-    This let you sign the key of of "Donald" with the userids of "Karl"
-    and "Joe".
-    All existing signatures are checked; if some are invalid, a menu is
-    offered to delete some of them, and then you are asked for every user
-    whether you want to sign this key.
-
-    You may remove a signature at any time using the option "--edit-sig",
-    which asks for the sigs to remove.	Self-signatures are not removable.
-
-
-
-
-    Sign
-    ----
-
-	gpg -s file
-
-    This creates a file file.gpg which is compressed and has a signature
-    attached.
-
-	gpg -sa file
-
-    Same as above, but file.gpg is ascii armored.
-
-	gpg -s -o out file
-
-    Creates a signature of file, but writes the output to the file "out".
-
-    If you use the option "--rfc1991", gnupg tries to me more compatible
-    to RFC1991 (pgp 2.x).
-
-
-    Encrypt
-    -------
-
-	gpg -e -r heine file
-
-    This encrypts files with the public key of "heine" and writes it
-    to "file.gpg"
-
-	echo "hallo" | gpg -ea -r heine | mail heine
-
-    Ditto, but encrypts "hallo\n" and mails it as ascii armored message.
-
-
-    Sign and Encrypt
-    ----------------
-
-	gpg -se -r heine file
-
-    This encrypts files with the public key of "heine" and writes it
-    to "file.gpg" after signing it with the default user id.
-
-
-	gpg -se -r heine -u Suttner file
-
-    Ditto, but sign the file with the user id "Suttner"
-
-
-    Keyring Management
-    ------------------
-    To export your complete keyring(s) do this:
-
-	gpg --export
-
-    To export only some user ids do this:
-
-	gpg --export userids
-
-    Use "-a" or "--armor" to create ASCII armored output.
-
-    Importing keys is done with the option, you guessed it, "--import":
-
-	gpg --import [filenames]
-
-    New keys are appended to the default keyring and already existing
-    keys are merged.  Keys without a self-signature are ignored.
-
-
-    How to Specify a UserID
-    -----------------------
-    There are several ways to specify a userID, here are some examples:
-
-    * Only by the short keyid (prepend a zero if it begins with A..F):
-
-	"234567C4"
-	"0F34E556E"
-	"01347A56A"
-	"0xAB123456
-
-    * By a complete keyid:
-
-	"234AABBCC34567C4"
-	"0F323456784E56EAB"
-	"01AB3FED1347A5612"
-	"0x234AABBCC34567C4"
-
-    * By a fingerprint:
-
-	"1234343434343434C434343434343434"
-	"123434343434343C3434343434343734349A3434"
-	"0E12343434343434343434EAB3484343434343434"
-
-      The first one is MD5 the others are ripemd160 or sha1.
-
-    * By an exact string (not yet implemented):
-
-	"=Heinrich Heine <heinrichh@uni-duesseldorf.de>"
-
-    * By an email address:
-
-	"<heinrichh@uni-duesseldorf.de>"
-
-      This can be used by a keyserver instead of a substring to
-      find this key faster.
-
-    * By the Local ID (from the trustdb):
-
-	"#34"
-
-      This can be used by a MUA to specify an exact key after selecting
-      a key from GnuPG (by the use of a special option or an extra utility)
-
-
-    * Or by the usual substring:
-
-	"Heine"
-	"*Heine"
-
-      The '*' indicates substring search explicitly.
-
-
-
-
-    Batch mode
-    ----------
-    If you use the option "--batch", GnuPG runs in non-interactive mode and
-    never prompts for input data.  This does not even allow entering the
-    passphrase; until we have a better solution (something like ssh-agent),
-    you can use the option "--passhrase-fd n", which works like PGPs
-    PGPPASSFD.
-
-    Batch mode also causes GnuPG to terminate as soon as a BAD signature is
-    detected.
-
-
-    Exit status
-    -----------
-    GnuPG returns with an exit status of 1 if in batch mode and a bad signature
-    has been detected or 2 or higher for all other errors.  You should parse
-    stderr or the output of the fd specified with --status-fd to get detailed
-    information about the errors.
-
-
-    Esoteric commands
-    -----------------
-
-	gpg --list-packets datafile
-
-    Use this to list the contents of a data file. If the file is encrypted
-    you are asked for the passphrase, so that GnuPG is able to look at the
-    inner structure of a encrypted packet.
-
-	gpgm --list-trustdb
-
-    List the contents of the trustdb in a human readable format
-
-	gpgm --list-trustdb  <usernames>
-
-    List the tree of certificates for the given usernames
-
-	gpgm --list-trust-path	depth  username
-
-    List the possible trust paths for the given username, up to the specified
-    depth.  If depth is negative, duplicate introducers are not listed,
-    because those would increase the trust probability only minimally.
-    (you must use the special option "--" to stop option parsing when
-     using a negative number). This option may create new entries in the
-    trustdb.
-
-	gpgm --print-mds  filenames
-
-    List all available message digest values for the fiven filenames
-
-    For more options/commands see the file g10/OPTIONS, or use "gpg --help"
-
-
-    Debug Flags
-    -----------
-    Use the option "--debug n" to output debug information. This option
-    can be used multiple times, all values are ORed; n maybe prefixed with
-    0x to use hex-values.
-
-	 value	used for
-	 -----	----------------------------------------------
-	  1	packet reading/writing
-	  2	MPI details
-	  4	ciphers and primes (may reveal sensitive data)
-	  8	iobuf filter functions
-	  16	iobuf stuff
-	  32	memory allocation stuff
-	  64	caching
-	  128	show memory statistics at exit
-	  256	trust verification stuff
-
-
-    Other Notes
-    -----------
-    This is work in progress, so you may find duplicated code fragments,
-    ugly data structures, weird usage of filenames and other things.
-
-    The primary FTP site is "ftp://ftp.guug.de/pub/gcrypt/"
-    The primary WWW page is "http://www.d.shuttle.de/isil/gnupg/"
-
-    If you like, send your keys to <gnupg-keys@isil.d.shuttle.de>; use
-    "gpg --export --armor | mail gnupg-keys@isil.d.shuttle.de" to do this.
-
-    Please direct bug reports to <gnupg-bugs@gnu.org> or better
-    post them to the mailing list <g10@net.lut.ac.uk> (this is a closed list,
-    please subscribe before posting, see above (~line 33)).
-
+-----BEGIN PGP SIGNED MESSAGE-----
 
+		  GnuPG - The GNU Privacy Guard
+		 -------------------------------
+			  Version 0.4
+
+    As you can see from the version number, the program may have some
+    bugs and some features may not work at all - please report this to
+    the mailing list.
+
+    On a Linux box (version 2.x.x, alpha or x86 CPU) it should
+    work reliably.  You may create your key on such a machine and
+    use it.  Please verify the tar file; there is a PGP and a GnuPG
+    signature available. My PGP 2 key is well known and published in
+    the "Global Trust Register for 1998", ISBN 0-9532397-0-5.
+
+    I have included my pubring as "g10/pubring.asc", which contains
+    the key used to make GnuPG signatures:
+    "pub  1024D/57548DCD 1998-07-07 Werner Koch (gnupg sig) <dd9jn@gnu.org>"
+    "Key fingerprint = 6BD9 050F D8FC 941B 4341  2DCC 68B7 AB89 5754 8DCD"
+
+    Old version of gnupg are signed with this key:
+    "pub  1312G/FF3EAA0B 1998-02-09 Werner Koch <wk@isil.d.shuttle.de>"
+    "Key fingerprint = 8489 6CD0 1851 0E33 45DA  CD67 036F 11B8 FF3E AA0B"
+
+    My usual key is now:
+    "pub  1024D/621CC013 1998-07-07 Werner Koch <werner.koch@guug.de>"
+    "Key fingerprint = ECAF 7590 EB34 43B5 C7CF  3ACB 6C7E E1B8 621C C013"
+
+    You may add it to your GnuPG pubring and use it in the future to
+    verify new releases.  Because you verified this README file and
+    _checked_that_it_is_really_my PGP2 key 0C9857A5, you can be sure
+    that the above fingerprints are correct.
+
+    Please subscribe to g10@net.lut.ac.uk by sending a mail with
+    the word "subscribe" in the body to "g10-request@net.lut.ac.uk".
+    This mailing is closed (only subscribers can post) to avoid spam.
+
+    See the file COPYING for copyright and warranty information.
+
+    Due to the fact that GnuPG does not use use any patented algorithm,
+    it cannot be compatible with old PGP versions, because those use
+    IDEA (which is patented worldwide) and RSA (which is patented in
+    the United States until Sep 20, 2000).
+
+    GnuPG is in almost all  aspects compatible with other OpenPGP
+    implementations.
+
+    The default algorithms are now DSA and ELGamal.  ELGamal for signing
+    is still available, but due to the larger size of such signatures it
+    is depreciated (Please note that the GnuPG implementation of ElGamal
+    signatures is *not* insecure).  Symmetric algorithms are: 3DES, Blowfish
+    and CAST5,	Digest algorithms are MD5, RIPEMD160, SHA1 and TIGER/192.
+
+
+
+    Installation
+    ------------
+
+    Please read the file INSTALL!
+
+    Here is a quick summary:
+
+    1)	"./configure"
+
+    2) "make"
+
+    3) "make install"
+
+    4) You end up with a binary "gpg" in /usr/local/bin
+
+    5) Optional, but suggested: install the program "gpg" as suid root.
+
+
+
+    Key Generation
+    --------------
+
+	gpg --gen-key
+
+    This asks some questions and then starts key generation. To create
+    good random numbers for prime number generation, it uses a /dev/random
+    which will only emit bytes if the kernel can gather enough entropy.
+    If you see no progress, you should start some other activities such
+    as mouse moves, "find /" or using the keyboard (in another window).
+    Because we have no hardware device to generate randomness we have to
+    use this method.
+
+    You should make a revocation certificate in case someone gets
+    knowledge of your secret key or you forgot your passphrase:
+
+	gpg --gen-revoke your_user_id
+
+    Run this command and store it away; output is always ASCII armored,
+    so that you can print it and (hopefully never) re-create it if
+    your electronic media fails.
+
+    If you decided to create a DSA key, you should add an ElGamal
+    for encryption:
+
+	gpg --add-key user_id_of_your_key
+
+    and follow the displayed instructions (select "ElGamal using v4 packets").
+
+
+    You can sign a key with this command:
+
+	gpg --sign-key Donald
+
+    This let you sign the key of "Donald" with your default userid.
+
+	gpg --sign-key -u Karl -u Joe Donald
+
+    This let you sign the key of of "Donald" with the userids of "Karl"
+    and "Joe".
+    All existing signatures are checked; if some are invalid, a menu is
+    offered to delete some of them, and then you are asked for every user
+    whether you want to sign this key.
+
+    You may remove a signature at any time using the option "--edit-sig",
+    which asks for the sigs to remove.	Self-signatures are not removable.
+
+
+
+
+    Sign
+    ----
+
+	gpg -s file
+
+    This creates a file file.gpg which is compressed and has a signature
+    attached.
+
+	gpg -sa file
+
+    Same as above, but file.gpg is ascii armored.
+
+	gpg -s -o out file
+
+    Creates a signature of file, but writes the output to the file "out".
+
+    If you use the option "--rfc1991", gnupg tries to me more compatible
+    to RFC1991 (pgp 2.x).
+
+
+    Encrypt
+    -------
+
+	gpg -e -r heine file
+
+    This encrypts files with the public key of "heine" and writes it
+    to "file.gpg"
+
+	echo "hallo" | gpg -ea -r heine | mail heine
+
+    Ditto, but encrypts "hallo\n" and mails it as ascii armored message.
+
+
+    Sign and Encrypt
+    ----------------
+
+	gpg -se -r heine file
+
+    This encrypts files with the public key of "heine" and writes it
+    to "file.gpg" after signing it with the default user id.
+
+
+	gpg -se -r heine -u Suttner file
+
+    Ditto, but sign the file with the user id "Suttner"
+
+
+    Keyring Management
+    ------------------
+    To export your complete keyring(s) do this:
+
+	gpg --export
+
+    To export only some user ids do this:
+
+	gpg --export userids
+
+    Use "-a" or "--armor" to create ASCII armored output.
+
+    Importing keys is done with the option, you guessed it, "--import":
+
+	gpg --import [filenames]
+
+    New keys are appended to the default keyring and already existing
+    keys are merged.  Keys without a self-signature are ignored.
+
+
+    How to Specify a UserID
+    -----------------------
+    There are several ways to specify a userID, here are some examples:
+
+    * Only by the short keyid (prepend a zero if it begins with A..F):
+
+	"234567C4"
+	"0F34E556E"
+	"01347A56A"
+	"0xAB123456
+
+    * By a complete keyid:
+
+	"234AABBCC34567C4"
+	"0F323456784E56EAB"
+	"01AB3FED1347A5612"
+	"0x234AABBCC34567C4"
+
+    * By a fingerprint:
+
+	"1234343434343434C434343434343434"
+	"123434343434343C3434343434343734349A3434"
+	"0E12343434343434343434EAB3484343434343434"
+
+      The first one is MD5 the others are ripemd160 or sha1.
+
+    * By an exact string (not yet implemented):
+
+	"=Heinrich Heine <heinrichh@uni-duesseldorf.de>"
+
+    * By an email address:
+
+	"<heinrichh@uni-duesseldorf.de>"
+
+      This can be used by a keyserver instead of a substring to
+      find this key faster.
+
+    * By the Local ID (from the trustdb):
+
+	"#34"
+
+      This can be used by a MUA to specify an exact key after selecting
+      a key from GnuPG (by the use of a special option or an extra utility)
+
+
+    * Or by the usual substring:
+
+	"Heine"
+	"*Heine"
+
+      The '*' indicates substring search explicitly.
+
+
+
+
+    Batch mode
+    ----------
+    If you use the option "--batch", GnuPG runs in non-interactive mode and
+    never prompts for input data.  This does not even allow entering the
+    passphrase; until we have a better solution (something like ssh-agent),
+    you can use the option "--passhrase-fd n", which works like PGPs
+    PGPPASSFD.
+
+    Batch mode also causes GnuPG to terminate as soon as a BAD signature is
+    detected.
+
+
+    Exit status
+    -----------
+    GnuPG returns with an exit status of 1 if in batch mode and a bad signature
+    has been detected or 2 or higher for all other errors.  You should parse
+    stderr or the output of the fd specified with --status-fd to get detailed
+    information about the errors.
+
+
+    Esoteric commands
+    -----------------
+
+	gpg --list-packets datafile
+
+    Use this to list the contents of a data file. If the file is encrypted
+    you are asked for the passphrase, so that GnuPG is able to look at the
+    inner structure of a encrypted packet.
+
+	gpgm --list-trustdb
+
+    List the contents of the trustdb in a human readable format
+
+	gpgm --list-trustdb  <usernames>
+
+    List the tree of certificates for the given usernames
+
+	gpgm --list-trust-path	depth  username
+
+    List the possible trust paths for the given username, up to the specified
+    depth.  If depth is negative, duplicate introducers are not listed,
+    because those would increase the trust probability only minimally.
+    (you must use the special option "--" to stop option parsing when
+     using a negative number). This option may create new entries in the
+    trustdb.
+
+	gpgm --print-mds  filenames
+
+    List all available message digest values for the fiven filenames
+
+    For more options/commands see the file g10/OPTIONS, or use "gpg --help"
+
+
+    Debug Flags
+    -----------
+    Use the option "--debug n" to output debug information. This option
+    can be used multiple times, all values are ORed; n maybe prefixed with
+    0x to use hex-values.
+
+	 value	used for
+	 -----	----------------------------------------------
+	  1	packet reading/writing
+	  2	MPI details
+	  4	ciphers and primes (may reveal sensitive data)
+	  8	iobuf filter functions
+	  16	iobuf stuff
+	  32	memory allocation stuff
+	  64	caching
+	  128	show memory statistics at exit
+	  256	trust verification stuff
+
+
+    Other Notes
+    -----------
+    This is work in progress, so you may find duplicated code fragments,
+    ugly data structures, weird usage of filenames and other things.
+
+    The primary FTP site is "ftp://ftp.guug.de/pub/gcrypt/"
+    The primary WWW page is "http://www.d.shuttle.de/isil/gnupg/"
+
+    If you like, send your keys to <gnupg-keys@isil.d.shuttle.de>; use
+    "gpg --export --armor | mail gnupg-keys@isil.d.shuttle.de" to do this.
+
+    Please direct bug reports to <gnupg-bugs@gnu.org> or better
+    post them to the mailing list <g10@net.lut.ac.uk> (this is a closed list,
+    please subscribe before posting, see above (~line 33)).
+
+
+-----BEGIN PGP SIGNATURE-----
+Version: GNUPG v0.4.2 (GNU/Linux)
+Comment: For info finger gcrypt@ftp.guug.de
+
+iQB1AwUBNkXLyx0Z9MEMmFelAQExuwMArLtkLI3vpxZ7tCoit6hELkpyEHe10Bo6
+Ms72TXasJ8L0tKNKRE2kagV7Ie7wxl0dyENlumOxsZIKLq8DGSyjSoE7GmMQEEff
+ZU+4xpO3KMw6XpJMvUWwlxpm2/WDpYTa
+=Y10x
+-----END PGP SIGNATURE-----
diff -urN gnupg-0.4.2/THANKS gnupg-0.4.3/THANKS
--- gnupg-0.4.2/THANKS	Wed Oct 14 09:57:00 1998
+++ gnupg-0.4.3/THANKS	Tue Nov  3 19:34:16 1998
@@ -12,11 +12,15 @@
 Christian von Roques	roques@pond.sub.org
 Christopher Oliver	oliver@fritz.traverse.net
 Daniel Eisenbud 	eisenbud@cs.swarthmore.edu
+David Ellement		ellement@sdd.hp.com
 Detlef Lannert		lannert@lannert.rz.uni-duesseldorf.de
 Ed Boraas		ecxjo@esperanto.org
 Ernst Molitor		ernst.molitor@uni-bonn.de
+Fabio Coatti		cova@felix.unife.it
 Frank Heckenbach	heckenb@mi.uni-erlangen.de
 Gal Quri		gqueri@mail.dotcom.fr
+Greg Louis		glouis@dynamicro.on.ca
+Gregory Steuck		steuck@iname.com
 Hendrik Buschkamp	buschkamp@rheumanet.org
 Holger Schurig		holger@d.om.org
 Hugh Daniel		hugh@toad.com
@@ -47,9 +51,11 @@
 Peter Gutmann		pgut001@cs.auckland.ac.nz
 QingLong		qinglong@bolizm.ihep.su
 Ralph Gillen		gillen@theochem.uni-duesseldorf.de
+Roddy Strachan		roddy@satlink.com.au
 Roland Rosenfeld	roland@spinnaker.rhein.de
 Serge Munhoven		munhoven@mema.ucl.ac.be
 SL Baur 		steve@xemacs.org
+Stefan Karrmann 	S.Karrmann@gmx.net
 Steffen Ullrich 	ccrlphr@xensei.com
 Steffen Zahn		zahn@berlin.snafu.de
 Thomas Roessler 	roessler@guug.de
diff -urN gnupg-0.4.2/TODO gnupg-0.4.3/TODO
--- gnupg-0.4.2/TODO	Sun Oct 18 16:39:23 1998
+++ gnupg-0.4.3/TODO	Sun Nov  8 17:46:45 1998
@@ -1,8 +1,26 @@
 
-    * There is a new memory leak in update-trustdb :-(
+    * use zlib 1.1.13 to avoid a bug with 13 bit windows
+
+    * FreeBSD:
+	#define USE_DYNAMIC_LINKING
+	#define HAVE_DL_DLOPEN
+	and the ld option -export-dynamic.
+
+    *
+     Well, there was one thing extra I needed to do.  While configure found the
+     gdbm library, it didn't add the path the the include file list.  I had to
+     re-run configure with CPPFLAGS set:
+
+     env CPPFLAGS='-I/usr/local/include' configure ...
+
+
+    * clearsig: keep lineendings as they are. Remember that trailings
+      blanks are not hashed.
 
     * Fix ;) revocation and expire stuff.
 
+    * check preferences (cipher and compress)
+
     * OpenBSD: dynamic loading with dlopen works on OpenBSD, but:
 	OpenBSD binaries are a.out, so every symbol begins with "_"
 
@@ -11,13 +29,9 @@
     * prefer a type 16 subkey for encryption because pgp cannot handle
       type 20?
 
-    * calculation of marginals never yields a completely trusted key.
-
     * The critical bit of signature subpackets is not yet supported; i.e.
       it is ignored.
 
-    * Exportable Certification Flag is ignored
-
     * We need a maintainence pass over the trustdb which flags
       signatures as expired if the key used to make the signature has
       expired.	Maybe it is a good idea to store the exiration time
@@ -57,6 +71,15 @@
 
     * add an option to re-create a public key from a secret key; we
       can do this in trustdb.c:verify_own_keys.
+
+    * signature verification is done duplicated on import: in import.c and
+      tehn in trustdb.c too.  Maybe we can use a flag to skip the actual
+      verification process (this should work if we use the same keyblock,
+      but I'm not sure how to accomplish that).  Another way is to allow
+      the import of bogus data and let trustdb mark these keys as invalid;
+      I see an advantage in this that it may help to prevent a DoS on a
+      keyserver by sending him a lot of bogus signatures which he has
+      to check - Needs further investigation.
 
     * change the fake_data stuff to mpi_set_opaque
 
diff -urN gnupg-0.4.2/acinclude.m4 gnupg-0.4.3/acinclude.m4
--- gnupg-0.4.2/acinclude.m4	Mon Sep 21 15:42:22 1998
+++ gnupg-0.4.3/acinclude.m4	Tue Oct 27 19:35:52 1998
@@ -209,83 +209,12 @@
   ])
 
 
-######################################################################
-# progtest.m4 from gettext 0.35
-######################################################################
-# Search path for a program which passes the given test.
-# Ulrich Drepper <drepper@cygnus.com>, 1996.
-#
-# This file can be copied and used freely without restrictions.  It can
-# be used in projects which are not available under the GNU Public License
-# but which still want to provide support for the GNU gettext functionality.
-# Please note that the actual code is *not* freely available.
 
-# serial 1
 
-dnl AM_PATH_PROG_WITH_TEST(VARIABLE, PROG-TO-CHECK-FOR,
-dnl   TEST-PERFORMED-ON-FOUND_PROGRAM [, VALUE-IF-NOT-FOUND [, PATH]])
-AC_DEFUN(AM_PATH_PROG_WITH_TEST,
-[# Extract the first word of "$2", so it can be a program name with args.
-set dummy $2; ac_word=[$]2
-AC_MSG_CHECKING([for $ac_word])
-AC_CACHE_VAL(ac_cv_path_$1,
-[case "[$]$1" in
-  /*)
-  ac_cv_path_$1="[$]$1" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS=   }"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in ifelse([$5], , $PATH, [$5]); do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      if [$3]; then
-	ac_cv_path_$1="$ac_dir/$ac_word"
-	break
-      fi
-    fi
-  done
-  IFS="$ac_save_ifs"
-dnl If no 4th arg is given, leave the cache variable unset,
-dnl so AC_PATH_PROGS will keep looking.
-ifelse([$4], , , [  test -z "[$]ac_cv_path_$1" && ac_cv_path_$1="$4"
-])dnl
-  ;;
-esac])dnl
-$1="$ac_cv_path_$1"
-if test -n "[$]$1"; then
-  AC_MSG_RESULT([$]$1)
-else
-  AC_MSG_RESULT(no)
-fi
-AC_SUBST($1)dnl
-])
-
-######################################################################
-# lcmessage.m4 from gettext 0.35
-######################################################################
-# Check whether LC_MESSAGES is available in <locale.h>.
-# Ulrich Drepper <drepper@cygnus.com>, 1995.
-#
-# This file can be copied and used freely without restrictions.  It can
-# be used in projects which are not available under the GNU Public License
-# but which still want to provide support for the GNU gettext functionality.
-# Please note that the actual code is *not* freely available.
 
-# serial 1
 
-AC_DEFUN(AM_LC_MESSAGES,
-  [if test $ac_cv_header_locale_h = yes; then
-    AC_CACHE_CHECK([for LC_MESSAGES], am_cv_val_LC_MESSAGES,
-      [AC_TRY_LINK([#include <locale.h>], [return LC_MESSAGES],
-       am_cv_val_LC_MESSAGES=yes, am_cv_val_LC_MESSAGES=no)])
-    if test $am_cv_val_LC_MESSAGES = yes; then
-      AC_DEFINE(HAVE_LC_MESSAGES)
-    fi
-  fi])
 
-######################################################################
-# gettext.m4 from gettext 0.35
-######################################################################
+
 # Macro to add for using GNU gettext.
 # Ulrich Drepper <drepper@cygnus.com>, 1995.
 #
@@ -294,7 +223,7 @@
 # but which still want to provide support for the GNU gettext functionality.
 # Please note that the actual code is *not* freely available.
 
-# serial 5
+# serial 5 + patch (wk 21.10.98)
 
 AC_DEFUN(AM_WITH_NLS,
   [AC_MSG_CHECKING([whether NLS is requested])
@@ -334,14 +263,15 @@
 
 	   if test "$gt_cv_func_gettext_libc" != "yes"; then
 	     AC_CHECK_LIB(intl, bindtextdomain,
-	       [AC_CACHE_CHECK([for gettext in libintl],
-		 gt_cv_func_gettext_libintl,
-		 [AC_CHECK_LIB(intl, gettext,
-		  gt_cv_func_gettext_libintl=yes,
-		  gt_cv_func_gettext_libintl=no)],
+	       [AC_CHECK_LIB(intl, gettext,
+		 gt_cv_func_gettext_libintl=yes,
 		 gt_cv_func_gettext_libintl=no)])
 	   fi
 
+	   if test "$gt_cv_func_gettext_libintl" = "yes" ; then
+	     LIBS="-lintl $LIBS"
+	   fi
+
 	   if test "$gt_cv_func_gettext_libc" = "yes" \
 	      || test "$gt_cv_func_gettext_libintl" = "yes"; then
 	      AC_DEFINE(HAVE_GETTEXT)
@@ -480,6 +410,7 @@
     AC_SUBST(POFILES)
     AC_SUBST(POSUB)
   ])
+
 
 AC_DEFUN(AM_GNU_GETTEXT,
   [AC_REQUIRE([AC_PROG_MAKE_SET])dnl
diff -urN gnupg-0.4.2/aclocal.m4 gnupg-0.4.3/aclocal.m4
--- gnupg-0.4.2/aclocal.m4	Sat Oct 17 17:07:02 1998
+++ gnupg-0.4.3/aclocal.m4	Tue Oct 27 19:35:52 1998
@@ -1,4 +1,4 @@
-dnl aclocal.m4 generated automatically by aclocal 1.2f
+dnl aclocal.m4 generated automatically by aclocal 1.3
 
 dnl Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 dnl This Makefile.in is free software; the Free Software Foundation
@@ -217,77 +217,12 @@
   ])
 
 
-# progtest.m4 from gettext 0.35
-# Search path for a program which passes the given test.
-# Ulrich Drepper <drepper@cygnus.com>, 1996.
-#
-# This file can be copied and used freely without restrictions.  It can
-# be used in projects which are not available under the GNU Public License
-# but which still want to provide support for the GNU gettext functionality.
-# Please note that the actual code is *not* freely available.
 
-# serial 1
 
-dnl AM_PATH_PROG_WITH_TEST(VARIABLE, PROG-TO-CHECK-FOR,
-dnl   TEST-PERFORMED-ON-FOUND_PROGRAM [, VALUE-IF-NOT-FOUND [, PATH]])
-AC_DEFUN(AM_PATH_PROG_WITH_TEST,
-[# Extract the first word of "$2", so it can be a program name with args.
-set dummy $2; ac_word=[$]2
-AC_MSG_CHECKING([for $ac_word])
-AC_CACHE_VAL(ac_cv_path_$1,
-[case "[$]$1" in
-  /*)
-  ac_cv_path_$1="[$]$1" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS=   }"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in ifelse([$5], , $PATH, [$5]); do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      if [$3]; then
-	ac_cv_path_$1="$ac_dir/$ac_word"
-	break
-      fi
-    fi
-  done
-  IFS="$ac_save_ifs"
-dnl If no 4th arg is given, leave the cache variable unset,
-dnl so AC_PATH_PROGS will keep looking.
-ifelse([$4], , , [  test -z "[$]ac_cv_path_$1" && ac_cv_path_$1="$4"
-])dnl
-  ;;
-esac])dnl
-$1="$ac_cv_path_$1"
-if test -n "[$]$1"; then
-  AC_MSG_RESULT([$]$1)
-else
-  AC_MSG_RESULT(no)
-fi
-AC_SUBST($1)dnl
-])
 
-# lcmessage.m4 from gettext 0.35
-# Check whether LC_MESSAGES is available in <locale.h>.
-# Ulrich Drepper <drepper@cygnus.com>, 1995.
-#
-# This file can be copied and used freely without restrictions.  It can
-# be used in projects which are not available under the GNU Public License
-# but which still want to provide support for the GNU gettext functionality.
-# Please note that the actual code is *not* freely available.
 
-# serial 1
 
-AC_DEFUN(AM_LC_MESSAGES,
-  [if test $ac_cv_header_locale_h = yes; then
-    AC_CACHE_CHECK([for LC_MESSAGES], am_cv_val_LC_MESSAGES,
-      [AC_TRY_LINK([#include <locale.h>], [return LC_MESSAGES],
-       am_cv_val_LC_MESSAGES=yes, am_cv_val_LC_MESSAGES=no)])
-    if test $am_cv_val_LC_MESSAGES = yes; then
-      AC_DEFINE(HAVE_LC_MESSAGES)
-    fi
-  fi])
 
-# gettext.m4 from gettext 0.35
 # Macro to add for using GNU gettext.
 # Ulrich Drepper <drepper@cygnus.com>, 1995.
 #
@@ -296,7 +231,7 @@
 # but which still want to provide support for the GNU gettext functionality.
 # Please note that the actual code is *not* freely available.
 
-# serial 5
+# serial 5 + patch (wk 21.10.98)
 
 AC_DEFUN(AM_WITH_NLS,
   [AC_MSG_CHECKING([whether NLS is requested])
@@ -336,14 +271,15 @@
 
 	   if test "$gt_cv_func_gettext_libc" != "yes"; then
 	     AC_CHECK_LIB(intl, bindtextdomain,
-	       [AC_CACHE_CHECK([for gettext in libintl],
-		 gt_cv_func_gettext_libintl,
-		 [AC_CHECK_LIB(intl, gettext,
-		  gt_cv_func_gettext_libintl=yes,
-		  gt_cv_func_gettext_libintl=no)],
+	       [AC_CHECK_LIB(intl, gettext,
+		 gt_cv_func_gettext_libintl=yes,
 		 gt_cv_func_gettext_libintl=no)])
 	   fi
 
+	   if test "$gt_cv_func_gettext_libintl" = "yes" ; then
+	     LIBS="-lintl $LIBS"
+	   fi
+
 	   if test "$gt_cv_func_gettext_libc" = "yes" \
 	      || test "$gt_cv_func_gettext_libintl" = "yes"; then
 	      AC_DEFINE(HAVE_GETTEXT)
@@ -483,6 +419,7 @@
     AC_SUBST(POSUB)
   ])
 
+
 AC_DEFUN(AM_GNU_GETTEXT,
   [AC_REQUIRE([AC_PROG_MAKE_SET])dnl
    AC_REQUIRE([AC_PROG_CC])dnl
@@ -605,6 +542,74 @@
   ])
 
 
+# Search path for a program which passes the given test.
+# Ulrich Drepper <drepper@cygnus.com>, 1996.
+#
+# This file can be copied and used freely without restrictions.  It can
+# be used in projects which are not available under the GNU Public License
+# but which still want to provide support for the GNU gettext functionality.
+# Please note that the actual code is *not* freely available.
+
+# serial 1
+
+dnl AM_PATH_PROG_WITH_TEST(VARIABLE, PROG-TO-CHECK-FOR,
+dnl   TEST-PERFORMED-ON-FOUND_PROGRAM [, VALUE-IF-NOT-FOUND [, PATH]])
+AC_DEFUN(AM_PATH_PROG_WITH_TEST,
+[# Extract the first word of "$2", so it can be a program name with args.
+set dummy $2; ac_word=[$]2
+AC_MSG_CHECKING([for $ac_word])
+AC_CACHE_VAL(ac_cv_path_$1,
+[case "[$]$1" in
+  /*)
+  ac_cv_path_$1="[$]$1" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in ifelse([$5], , $PATH, [$5]); do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      if [$3]; then
+	ac_cv_path_$1="$ac_dir/$ac_word"
+	break
+      fi
+    fi
+  done
+  IFS="$ac_save_ifs"
+dnl If no 4th arg is given, leave the cache variable unset,
+dnl so AC_PATH_PROGS will keep looking.
+ifelse([$4], , , [  test -z "[$]ac_cv_path_$1" && ac_cv_path_$1="$4"
+])dnl
+  ;;
+esac])dnl
+$1="$ac_cv_path_$1"
+if test -n "[$]$1"; then
+  AC_MSG_RESULT([$]$1)
+else
+  AC_MSG_RESULT(no)
+fi
+AC_SUBST($1)dnl
+])
+
+# Check whether LC_MESSAGES is available in <locale.h>.
+# Ulrich Drepper <drepper@cygnus.com>, 1995.
+#
+# This file can be copied and used freely without restrictions.  It can
+# be used in projects which are not available under the GNU Public License
+# but which still want to provide support for the GNU gettext functionality.
+# Please note that the actual code is *not* freely available.
+
+# serial 1
+
+AC_DEFUN(AM_LC_MESSAGES,
+  [if test $ac_cv_header_locale_h = yes; then
+    AC_CACHE_CHECK([for LC_MESSAGES], am_cv_val_LC_MESSAGES,
+      [AC_TRY_LINK([#include <locale.h>], [return LC_MESSAGES],
+       am_cv_val_LC_MESSAGES=yes, am_cv_val_LC_MESSAGES=no)])
+    if test $am_cv_val_LC_MESSAGES = yes; then
+      AC_DEFINE(HAVE_LC_MESSAGES)
+    fi
+  fi])
+
 # Like AC_CONFIG_HEADER, but automatically create stamp file.
 
 AC_DEFUN(AM_CONFIG_HEADER,
@@ -627,6 +632,49 @@
   am_indx=`expr "<<$>>am_indx" + 1`
 done<<>>dnl>>)
 changequote([,]))])
+
+#
+# Check to make sure that the build environment is sane.
+#
+
+AC_DEFUN(AM_SANITY_CHECK,
+[AC_MSG_CHECKING([whether build environment is sane])
+# Just in case
+sleep 1
+echo timestamp > conftestfile
+# Do `set' in a subshell so we don't clobber the current shell's
+# arguments.  Must try -L first in case configure is actually a
+# symlink; some systems play weird games with the mod time of symlinks
+# (eg FreeBSD returns the mod time of the symlink's containing
+# directory).
+if (
+   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
+   if test "[$]*" = "X"; then
+      # -L didn't work.
+      set X `ls -t $srcdir/configure conftestfile`
+   fi
+   if test "[$]*" != "X $srcdir/configure conftestfile" \
+      && test "[$]*" != "X conftestfile $srcdir/configure"; then
+
+      # If neither matched, then we have a broken ls.  This can happen
+      # if, for instance, CONFIG_SHELL is bash and it inherits a
+      # broken ls alias from the environment.  This has actually
+      # happened.  Such a system could not be considered "sane".
+      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
+alias in your environment])
+   fi
+
+   test "[$]2" = conftestfile
+   )
+then
+   # Ok.
+   :
+else
+   AC_MSG_ERROR([newly created file is older than distributed files!
+Check your system clock])
+fi
+rm -f conftest*
+AC_MSG_RESULT(yes)])
 
 dnl AM_MISSING_PROG(NAME, PROGRAM, DIRECTORY)
 dnl The program must properly implement --version.
diff -urN gnupg-0.4.2/checks/ChangeLog gnupg-0.4.3/checks/ChangeLog
--- gnupg-0.4.2/checks/ChangeLog	Wed Sep 23 12:25:39 1998
+++ gnupg-0.4.3/checks/ChangeLog	Sun Oct 25 18:22:20 1998
@@ -1,3 +1,8 @@
+Sun Oct 25 18:19:35 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* mds.test: Check whether TIGER is available.
+	* sigs.tesr: Ditto.
+
 Wed Sep 23 12:25:07 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* run-gpg.patterns: New (because Solaris fgrep does not like -f -).
diff -urN gnupg-0.4.2/checks/Makefile.in gnupg-0.4.3/checks/Makefile.in
--- gnupg-0.4.2/checks/Makefile.in	Sun Oct 18 17:08:35 1998
+++ gnupg-0.4.3/checks/Makefile.in	Sun Nov  8 18:23:59 1998
@@ -1,4 +1,4 @@
-# Makefile.in generated automatically by automake 1.2f from Makefile.am
+# Makefile.in generated automatically by automake 1.3 from Makefile.am
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 # This Makefile.in is free software; the Free Software Foundation
@@ -32,6 +32,8 @@
 includedir = @includedir@
 oldincludedir = /usr/include
 
+DISTDIR =
+
 pkgdatadir = $(datadir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
@@ -122,13 +124,13 @@
 
 TAR = tar
 GZIP = --best
-default: all
+all: Makefile
 
 .SUFFIXES:
-$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) 
+$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4)
 	cd $(top_srcdir) && $(AUTOMAKE) --gnu --include-deps checks/Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status
 	cd $(top_builddir) \
 	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
 
@@ -188,8 +190,6 @@
 
 uninstall: 
 
-all: Makefile
-
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs:
@@ -220,10 +220,10 @@
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
-.PHONY: default tags distdir check-TESTS info dvi installcheck \
-install-exec install-data install uninstall all installdirs \
-mostlyclean-generic distclean-generic clean-generic \
-maintainer-clean-generic clean mostlyclean distclean maintainer-clean
+.PHONY: tags distdir check-TESTS info dvi installcheck install-exec \
+install-data install uninstall all installdirs mostlyclean-generic \
+distclean-generic clean-generic maintainer-clean-generic clean \
+mostlyclean distclean maintainer-clean
 
 
 check: prepared.stamp
diff -urN gnupg-0.4.2/checks/defs.inc gnupg-0.4.3/checks/defs.inc
--- gnupg-0.4.2/checks/defs.inc	Sat Aug  8 21:21:07 1998
+++ gnupg-0.4.3/checks/defs.inc	Sun Oct 25 18:18:31 1998
@@ -60,6 +60,10 @@
 #}
 
 
+have_hash_algo () {
+    ../g10/gpgm --homedir .  --version | grep "Hash:.*$1" >/dev/null
+}
+
 set -e
 pgmname=`basename $0`
 #trap cleanup SIGHUP SIGINT SIGQUIT
diff -urN gnupg-0.4.2/checks/mds.test gnupg-0.4.3/checks/mds.test
--- gnupg-0.4.2/checks/mds.test	Wed Sep 23 12:22:10 1998
+++ gnupg-0.4.3/checks/mds.test	Sun Oct 25 18:19:23 1998
@@ -1,7 +1,9 @@
 #!/bin/sh
 
+
 . $srcdir/defs.inc || exit 3
 
+
 test_one () {
    if [ "`grep $1 y | sed -e 's/.*=[ ]\(.*\)/\1/' -e 's/ //g'`" != "$2" ]; then
 	failed="$failed $1"
@@ -11,11 +13,15 @@
 failed=""
 
 #info Checking message digests
-echo -n "" | $srcdir/run-gpgm --print-mds >y
+echo -n "" | $srcdir/run-gpgm -v --print-mds >y
 test_one "MD5"    "D41D8CD98F00B204E9800998ECF8427E"
 test_one "SHA1"   "DA39A3EE5E6B4B0D3255BFEF95601890AFD80709"
 test_one "RMD160" "9C1185A5C5E9FC54612808977EE8F548B2258D31"
-test_one "TIGER"  "24F0130C63AC933216166E76B1BB925FF373DE2D49584E7A"
+if have_hash_algo "TIGER"; then
+  test_one "TIGER"  "24F0130C63AC933216166E76B1BB925FF373DE2D49584E7A"
+else
+  echo "Hash algorithm TIGER/192 is not installed"
+fi
 
 [ "$failed" != "" ] && error "$failed failed for empty string"
 
@@ -23,7 +29,9 @@
 test_one "MD5"    "C3FCD3D76192E4007DFB496CCA67E13B"
 test_one "SHA1"   "32D10C7B8CF96570CA04CE37F2A19D84240D3A89"
 test_one "RMD160" "F71C27109C692C1B56BBDCEB5B9D2865B3708DBC"
-test_one "TIGER"  "307DE5EE72A414172A0355CCBF120404E9EE7BF32F60110B"
+if have_hash_algo "TIGER"; then
+  test_one "TIGER"  "307DE5EE72A414172A0355CCBF120404E9EE7BF32F60110B"
+fi
 
 
 [ "$failed" != "" ] && error "$failed failed for a..z"
diff -urN gnupg-0.4.2/checks/sigs.test gnupg-0.4.3/checks/sigs.test
--- gnupg-0.4.2/checks/sigs.test	Mon Sep 14 14:35:12 1998
+++ gnupg-0.4.3/checks/sigs.test	Sun Oct 25 18:21:34 1998
@@ -9,7 +9,12 @@
     cmp $i y || error "$i: mismatch"
 done
 
-for da in ripemd160 sha1 md5 tiger; do
+hash_algo_list="ripemd160 sha1 md5"
+if have_hash_algo "TIGER"; then
+  hash_algo_list="$hash_algo_list tiger"
+fi
+
+for da in $hash_algo_list ; do
     for i in $plain_files; do
 	echo "$usrpass1" | $srcdir/run-gpg --passphrase-fd 0 --digest-algo $da \
 				-s -o x --yes $i
diff -urN gnupg-0.4.2/cipher/ChangeLog gnupg-0.4.3/cipher/ChangeLog
--- gnupg-0.4.2/cipher/ChangeLog	Thu Oct 15 11:48:11 1998
+++ gnupg-0.4.3/cipher/ChangeLog	Sun Nov  8 17:44:49 1998
@@ -1,3 +1,11 @@
+Sun Nov  8 17:44:36 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* radn-unix.c (read_random_source): Removed the assert.
+
+Mon Oct 19 18:34:30 1998  me,,,  (wk@tobold)
+
+	* pubkey.c: Hack to allow us to give some info about RSA keys back.
+
 Thu Oct 15 11:47:57 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* dynload.c: Support for DLD
diff -urN gnupg-0.4.2/cipher/Makefile.am gnupg-0.4.3/cipher/Makefile.am
--- gnupg-0.4.2/cipher/Makefile.am	Wed Oct 14 14:42:57 1998
+++ gnupg-0.4.3/cipher/Makefile.am	Tue Oct 20 18:21:45 1998
@@ -2,7 +2,7 @@
 
 gnupg_extensions = tiger twofish
 
-INCLUDES =  -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
+INCLUDES =  -I$(top_srcdir)/include -I$(top_srcdir)/intl
 
 noinst_LIBRARIES = libcipher.a
 if ENABLE_GNUPG_EXTENSIONS
diff -urN gnupg-0.4.2/cipher/Makefile.in gnupg-0.4.3/cipher/Makefile.in
--- gnupg-0.4.2/cipher/Makefile.in	Sun Oct 18 17:08:22 1998
+++ gnupg-0.4.3/cipher/Makefile.in	Sun Nov  8 18:23:46 1998
@@ -1,4 +1,4 @@
-# Makefile.in generated automatically by automake 1.2f from Makefile.am
+# Makefile.in generated automatically by automake 1.3 from Makefile.am
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 # This Makefile.in is free software; the Free Software Foundation
@@ -32,6 +32,8 @@
 includedir = @includedir@
 oldincludedir = /usr/include
 
+DISTDIR =
+
 pkgdatadir = $(datadir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
@@ -92,7 +94,7 @@
 
 gnupg_extensions = tiger twofish
 
-INCLUDES =  -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
+INCLUDES =  -I$(top_srcdir)/include -I$(top_srcdir)/intl
 
 noinst_LIBRARIES = libcipher.a
 @ENABLE_GNUPG_EXTENSIONS_TRUE@pkglib_PROGRAMS  = $(gnupg_extensions)
@@ -173,14 +175,14 @@
 SOURCES = $(libcipher_a_SOURCES) tiger.c $(EXTRA_tiger_SOURCES) twofish.c $(EXTRA_twofish_SOURCES)
 OBJECTS = $(libcipher_a_OBJECTS) tiger.o twofish.o
 
-default: all
+all: Makefile $(LIBRARIES) $(PROGRAMS)
 
 .SUFFIXES:
 .SUFFIXES: .S .c .o .s
-$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) 
+$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4)
 	cd $(top_srcdir) && $(AUTOMAKE) --gnu --include-deps cipher/Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status
 	cd $(top_builddir) \
 	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
 
@@ -229,18 +231,18 @@
 
 install-pkglibPROGRAMS: $(pkglib_PROGRAMS)
 	@$(NORMAL_INSTALL)
-	$(mkinstalldirs) $(pkglibdir)
+	$(mkinstalldirs) $(DESTDIR)$(pkglibdir)
 	@list='$(pkglib_PROGRAMS)'; for p in $$list; do \
 	  if test -f $$p; then \
-	    echo "  $(INSTALL_PROGRAM) $$p $(pkglibdir)/`echo $$p|sed '$(transform)'`"; \
-	     $(INSTALL_PROGRAM) $$p $(pkglibdir)/`echo $$p|sed '$(transform)'`; \
+	    echo "  $(INSTALL_PROGRAM) $$p $(DESTDIR)$(pkglibdir)/`echo $$p|sed '$(transform)'`"; \
+	     $(INSTALL_PROGRAM) $$p $(DESTDIR)$(pkglibdir)/`echo $$p|sed '$(transform)'`; \
 	  else :; fi; \
 	done
 
 uninstall-pkglibPROGRAMS:
 	@$(NORMAL_UNINSTALL)
 	list='$(pkglib_PROGRAMS)'; for p in $$list; do \
-	  rm -f $(pkglibdir)/`echo $$p|sed '$(transform)'`; \
+	  rm -f $(DESTDIR)$(pkglibdir)/`echo $$p|sed '$(transform)'`; \
 	done
 
 tags: TAGS
@@ -368,12 +370,10 @@
 
 uninstall: uninstall-pkglibPROGRAMS
 
-all: Makefile $(LIBRARIES) $(PROGRAMS)
-
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs:
-	$(mkinstalldirs)  $(pkglibdir)
+	$(mkinstalldirs)  $(DATADIR)$(pkglibdir)
 
 
 mostlyclean-generic:
@@ -409,7 +409,7 @@
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
-.PHONY: default mostlyclean-noinstLIBRARIES distclean-noinstLIBRARIES \
+.PHONY: mostlyclean-noinstLIBRARIES distclean-noinstLIBRARIES \
 clean-noinstLIBRARIES maintainer-clean-noinstLIBRARIES \
 mostlyclean-compile distclean-compile clean-compile \
 maintainer-clean-compile mostlyclean-pkglibPROGRAMS \
diff -urN gnupg-0.4.2/cipher/pubkey.c gnupg-0.4.3/cipher/pubkey.c
--- gnupg-0.4.2/cipher/pubkey.c	Mon Sep 28 15:03:14 1998
+++ gnupg-0.4.3/cipher/pubkey.c	Mon Oct 19 18:39:18 1998
@@ -309,6 +309,8 @@
 	    if( pubkey_table[i].algo == algo )
 		return pubkey_table[i].npkey;
     } while( load_pubkey_modules() );
+    if( is_RSA(algo) )	  /* special hack, so that we are able to */
+	return 2;	  /* see the RSA keyids */
     return 0;
 }
 
@@ -324,6 +326,8 @@
 	    if( pubkey_table[i].algo == algo )
 		return pubkey_table[i].nskey;
     } while( load_pubkey_modules() );
+    if( is_RSA(algo) )	  /* special hack, so that we are able to */
+	return 6;	  /* see the RSA keyids */
     return 0;
 }
 
@@ -339,6 +343,8 @@
 	    if( pubkey_table[i].algo == algo )
 		return pubkey_table[i].nsig;
     } while( load_pubkey_modules() );
+    if( is_RSA(algo) )	  /* special hack, so that we are able to */
+	return 1;	  /* see the RSA keyids */
     return 0;
 }
 
@@ -354,6 +360,8 @@
 	    if( pubkey_table[i].algo == algo )
 		return pubkey_table[i].nenc;
     } while( load_pubkey_modules() );
+    if( is_RSA(algo) )	  /* special hack, so that we are able to */
+	return 1;	  /* see the RSA keyids */
     return 0;
 }
 
@@ -370,6 +378,8 @@
 	    if( pubkey_table[i].algo == algo )
 		return (*pubkey_table[i].get_nbits)( algo, pkey );
     } while( load_pubkey_modules() );
+    if( is_RSA(algo) )	/* we always wanna see the length of a key :-) */
+	return mpi_get_nbits( pkey[0] );
     return 0;
 }
 
diff -urN gnupg-0.4.2/cipher/rand-unix.c gnupg-0.4.3/cipher/rand-unix.c
--- gnupg-0.4.2/cipher/rand-unix.c	Thu Oct 15 11:20:08 1998
+++ gnupg-0.4.3/cipher/rand-unix.c	Sun Nov  8 17:44:51 1998
@@ -157,7 +157,6 @@
 	    continue;
 	}
 
-	assert( length < 500 );
 	do {
 	    n = read(fd, buffer, length );
 	    if( n >= 0 && n > length ) {
diff -urN gnupg-0.4.2/configure gnupg-0.4.3/configure
--- gnupg-0.4.2/configure	Sun Oct 18 12:08:22 1998
+++ gnupg-0.4.3/configure	Tue Oct 27 19:36:04 1998
@@ -560,7 +560,7 @@
 
 VERSION=`cat $srcdir/VERSION`
 PACKAGE=gnupg
-ALL_LINGUAS="en de it fr"
+ALL_LINGUAS="en de it fr ru"
 
 
 cat >> confdefs.h <<EOF
@@ -625,9 +625,9 @@
 #define M_GUARD 1
 EOF
 
-    CFLAGS="-g -Wall"
+    CFLAGS="$CFLAGS -g -Wall"
 else
-    CFLAGS="-O2 -Wall"
+    CFLAGS="$CFLAGS -O2 -Wall"
 fi
 
 
@@ -733,28 +733,27 @@
     NONENONEs,x,x, &&
   program_prefix=${target_alias}-
 
- echo $ac_n "checking cached information""... $ac_c" 1>&6
-echo "configure:738: checking cached information" >&5
-    wk_hostcheck="$target"
-    if eval "test \"`echo '$''{'wk_cv_hostcheck'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
+if test "$program_transform_name" = s,x,x,; then
+  program_transform_name=
 else
-   wk_cv_hostcheck="$wk_hostcheck" 
+  # Double any \ or $.  echo might interpret backslashes.
+  cat <<\EOF_SED > conftestsed
+s,\\,\\\\,g; s,\$,$$,g
+EOF_SED
+  program_transform_name="`echo $program_transform_name|sed -f conftestsed`"
+  rm -f conftestsed
 fi
+test "$program_prefix" != NONE &&
+  program_transform_name="s,^,${program_prefix},; $program_transform_name"
+# Use a double $ so make ignores it.
+test "$program_suffix" != NONE &&
+  program_transform_name="s,\$\$,${program_suffix},; $program_transform_name"
 
-    if test "$wk_cv_hostcheck" != "$wk_hostcheck"; then
-	echo "$ac_t""changed" 1>&6
-	echo "configure: warning: config.cache exists!" 1>&2
-	{ echo "configure: error: you must do 'make distclean' first to compile for
-		 different target or different parameters." 1>&2; exit 1; }
-    else
-	echo "$ac_t""ok" 1>&6
-    fi
-  
-
+# sed with no file args requires a program.
+test "$program_transform_name" = "" && program_transform_name="s,x,x,"
 
 echo $ac_n "checking whether ${MAKE-make} sets \${MAKE}""... $ac_c" 1>&6
-echo "configure:758: checking whether ${MAKE-make} sets \${MAKE}" >&5
+echo "configure:757: checking whether ${MAKE-make} sets \${MAKE}" >&5
 set dummy ${MAKE-make}; ac_make=`echo "$2" | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_prog_make_${ac_make}_set'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -780,29 +779,47 @@
   SET_MAKE="MAKE=${MAKE-make}"
 fi
 
-if test "$program_transform_name" = s,x,x,; then
-  program_transform_name=
-else
-  # Double any \ or $.  echo might interpret backslashes.
-  cat <<\EOF_SED > conftestsed
-s,\\,\\\\,g; s,\$,$$,g
-EOF_SED
-  program_transform_name="`echo $program_transform_name|sed -f conftestsed`"
-  rm -f conftestsed
-fi
-test "$program_prefix" != NONE &&
-  program_transform_name="s,^,${program_prefix},; $program_transform_name"
-# Use a double $ so make ignores it.
-test "$program_suffix" != NONE &&
-  program_transform_name="s,\$\$,${program_suffix},; $program_transform_name"
-
-# sed with no file args requires a program.
-test "$program_transform_name" = "" && program_transform_name="s,x,x,"
+echo $ac_n "checking whether build environment is sane""... $ac_c" 1>&6
+echo "configure:784: checking whether build environment is sane" >&5
+# Just in case
+sleep 1
+echo timestamp > conftestfile
+# Do `set' in a subshell so we don't clobber the current shell's
+# arguments.  Must try -L first in case configure is actually a
+# symlink; some systems play weird games with the mod time of symlinks
+# (eg FreeBSD returns the mod time of the symlink's containing
+# directory).
+if (
+   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
+   if test "$*" = "X"; then
+      # -L didn't work.
+      set X `ls -t $srcdir/configure conftestfile`
+   fi
+   if test "$*" != "X $srcdir/configure conftestfile" \
+      && test "$*" != "X conftestfile $srcdir/configure"; then
 
+      # If neither matched, then we have a broken ls.  This can happen
+      # if, for instance, CONFIG_SHELL is bash and it inherits a
+      # broken ls alias from the environment.  This has actually
+      # happened.  Such a system could not be considered "sane".
+      { echo "configure: error: ls -t appears to fail.  Make sure there is not a broken
+alias in your environment" 1>&2; exit 1; }
+   fi
 
+   test "$2" = conftestfile
+   )
+then
+   # Ok.
+   :
+else
+   { echo "configure: error: newly created file is older than distributed files!
+Check your system clock" 1>&2; exit 1; }
+fi
+rm -f conftest*
+echo "$ac_t""yes" 1>&6
 missing_dir=`cd $ac_aux_dir && pwd`
 echo $ac_n "checking for working aclocal""... $ac_c" 1>&6
-echo "configure:806: checking for working aclocal" >&5
+echo "configure:823: checking for working aclocal" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -815,7 +832,7 @@
 fi
 
 echo $ac_n "checking for working autoconf""... $ac_c" 1>&6
-echo "configure:819: checking for working autoconf" >&5
+echo "configure:836: checking for working autoconf" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -828,7 +845,7 @@
 fi
 
 echo $ac_n "checking for working automake""... $ac_c" 1>&6
-echo "configure:832: checking for working automake" >&5
+echo "configure:849: checking for working automake" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -841,7 +858,7 @@
 fi
 
 echo $ac_n "checking for working autoheader""... $ac_c" 1>&6
-echo "configure:845: checking for working autoheader" >&5
+echo "configure:862: checking for working autoheader" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -856,7 +873,7 @@
 # Extract the first word of "gcc", so it can be a program name with args.
 set dummy gcc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:860: checking for $ac_word" >&5
+echo "configure:877: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -885,7 +902,7 @@
   # Extract the first word of "cc", so it can be a program name with args.
 set dummy cc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:889: checking for $ac_word" >&5
+echo "configure:906: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -933,7 +950,7 @@
 fi
 
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works""... $ac_c" 1>&6
-echo "configure:937: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
+echo "configure:954: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
 
 ac_ext=c
 # CFLAGS is not in ac_cpp because -g, -O, etc. are not valid cpp options.
@@ -943,11 +960,11 @@
 cross_compiling=$ac_cv_prog_cc_cross
 
 cat > conftest.$ac_ext <<EOF
-#line 947 "configure"
+#line 964 "configure"
 #include "confdefs.h"
 main(){return(0);}
 EOF
-if { (eval echo configure:951: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:968: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   ac_cv_prog_cc_works=yes
   # If we can't run a trivial program, we are probably using a cross compiler.
   if (./conftest; exit) 2>/dev/null; then
@@ -967,12 +984,12 @@
   { echo "configure: error: installation or configuration problem: C compiler cannot create executables." 1>&2; exit 1; }
 fi
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler""... $ac_c" 1>&6
-echo "configure:971: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
+echo "configure:988: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
 echo "$ac_t""$ac_cv_prog_cc_cross" 1>&6
 cross_compiling=$ac_cv_prog_cc_cross
 
 echo $ac_n "checking whether we are using GNU C""... $ac_c" 1>&6
-echo "configure:976: checking whether we are using GNU C" >&5
+echo "configure:993: checking whether we are using GNU C" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_gcc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -981,7 +998,7 @@
   yes;
 #endif
 EOF
-if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:985: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
+if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:1002: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
   ac_cv_prog_gcc=yes
 else
   ac_cv_prog_gcc=no
@@ -996,7 +1013,7 @@
   ac_save_CFLAGS="$CFLAGS"
   CFLAGS=
   echo $ac_n "checking whether ${CC-cc} accepts -g""... $ac_c" 1>&6
-echo "configure:1000: checking whether ${CC-cc} accepts -g" >&5
+echo "configure:1017: checking whether ${CC-cc} accepts -g" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_cc_g'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1024,7 +1041,7 @@
 fi
 
 echo $ac_n "checking how to run the C preprocessor""... $ac_c" 1>&6
-echo "configure:1028: checking how to run the C preprocessor" >&5
+echo "configure:1045: checking how to run the C preprocessor" >&5
 # On Suns, sometimes $CPP names a directory.
 if test -n "$CPP" && test -d "$CPP"; then
   CPP=
@@ -1039,13 +1056,13 @@
   # On the NeXT, cc -E runs the code through the compiler's parser,
   # not just through cpp.
   cat > conftest.$ac_ext <<EOF
-#line 1043 "configure"
+#line 1060 "configure"
 #include "confdefs.h"
 #include <assert.h>
 Syntax Error
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1049: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1066: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   :
@@ -1056,13 +1073,13 @@
   rm -rf conftest*
   CPP="${CC-cc} -E -traditional-cpp"
   cat > conftest.$ac_ext <<EOF
-#line 1060 "configure"
+#line 1077 "configure"
 #include "confdefs.h"
 #include <assert.h>
 Syntax Error
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1066: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1083: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   :
@@ -1085,7 +1102,7 @@
 echo "$ac_t""$CPP" 1>&6
 
 echo $ac_n "checking for POSIXized ISC""... $ac_c" 1>&6
-echo "configure:1089: checking for POSIXized ISC" >&5
+echo "configure:1106: checking for POSIXized ISC" >&5
 if test -d /etc/conf/kconfig.d &&
   grep _POSIX_VERSION /usr/include/sys/unistd.h >/dev/null 2>&1
 then
@@ -1108,7 +1125,7 @@
 # Extract the first word of "ranlib", so it can be a program name with args.
 set dummy ranlib; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:1112: checking for $ac_word" >&5
+echo "configure:1129: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_RANLIB'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1145,7 +1162,7 @@
 # SVR4 /usr/ucb/install, which tries to use the nonexistent group "staff"
 # ./install, which can be erroneously created by make from ./install.sh.
 echo $ac_n "checking for a BSD compatible install""... $ac_c" 1>&6
-echo "configure:1149: checking for a BSD compatible install" >&5
+echo "configure:1166: checking for a BSD compatible install" >&5
 if test -z "$INSTALL"; then
 if eval "test \"`echo '$''{'ac_cv_path_install'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1195,19 +1212,19 @@
 test -z "$INSTALL_DATA" && INSTALL_DATA='${INSTALL} -m 644'
 
 echo $ac_n "checking for Cygwin32 environment""... $ac_c" 1>&6
-echo "configure:1199: checking for Cygwin32 environment" >&5
+echo "configure:1216: checking for Cygwin32 environment" >&5
 if eval "test \"`echo '$''{'am_cv_cygwin32'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1204 "configure"
+#line 1221 "configure"
 #include "confdefs.h"
 
 int main() {
 return __CYGWIN32__;
 ; return 0; }
 EOF
-if { (eval echo configure:1211: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1228: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   am_cv_cygwin32=yes
 else
@@ -1239,6 +1256,15 @@
 EOF
 
 	;;
+    *-*-hpux*)
+	if test -z "$GCC" ; then
+	    CFLAGS="$CFLAGS -Ae -D_HPUX_SOURCE"
+	fi
+	cat >> confdefs.h <<\EOF
+#define USE_RAND_UNIX 1
+EOF
+
+	;;
     *)
 	cat >> confdefs.h <<\EOF
 #define USE_RAND_UNIX 1
@@ -1286,203 +1312,13 @@
 
 
 
-echo $ac_n "checking for gdbm_firstkey in -lgdbm""... $ac_c" 1>&6
-echo "configure:1291: checking for gdbm_firstkey in -lgdbm" >&5
-ac_lib_var=`echo gdbm'_'gdbm_firstkey | sed 'y%./+-%__p_%'`
-if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  ac_save_LIBS="$LIBS"
-LIBS="-lgdbm  $LIBS"
-cat > conftest.$ac_ext <<EOF
-#line 1299 "configure"
-#include "confdefs.h"
-/* Override any gcc2 internal prototype to avoid an error.  */
-/* We use char because int might match the return type of a gcc2
-    builtin and then its argument prototype would still apply.  */
-char gdbm_firstkey();
-
-int main() {
-gdbm_firstkey()
-; return 0; }
-EOF
-if { (eval echo configure:1310: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
-  rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=yes"
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=no"
-fi
-rm -f conftest*
-LIBS="$ac_save_LIBS"
-
-fi
-if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_lib=HAVE_LIB`echo gdbm | sed -e 's/[^a-zA-Z0-9_]/_/g' \
-    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_lib 1
-EOF
-
-  LIBS="-lgdbm $LIBS"
-
-else
-  echo "$ac_t""no" 1>&6
-fi
-
-
-if test "$try_dynload" = yes ; then
-echo $ac_n "checking for dlopen in -ldl""... $ac_c" 1>&6
-echo "configure:1340: checking for dlopen in -ldl" >&5
-ac_lib_var=`echo dl'_'dlopen | sed 'y%./+-%__p_%'`
-if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  ac_save_LIBS="$LIBS"
-LIBS="-ldl  $LIBS"
-cat > conftest.$ac_ext <<EOF
-#line 1348 "configure"
-#include "confdefs.h"
-/* Override any gcc2 internal prototype to avoid an error.  */
-/* We use char because int might match the return type of a gcc2
-    builtin and then its argument prototype would still apply.  */
-char dlopen();
-
-int main() {
-dlopen()
-; return 0; }
-EOF
-if { (eval echo configure:1359: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
-  rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=yes"
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=no"
-fi
-rm -f conftest*
-LIBS="$ac_save_LIBS"
-
-fi
-if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_lib=HAVE_LIB`echo dl | sed -e 's/[^a-zA-Z0-9_]/_/g' \
-    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_lib 1
-EOF
-
-  LIBS="-ldl $LIBS"
-
-else
-  echo "$ac_t""no" 1>&6
-fi
-
-if test "$ac_cv_lib_dl_dlopen" = "yes"; then
-  cat >> confdefs.h <<\EOF
-#define USE_DYNAMIC_LINKING 1
-EOF
-
-  cat >> confdefs.h <<\EOF
-#define HAVE_DL_DLOPEN 1
-EOF
-
-  DYNLINK_LDFLAGS=-rdynamic
-  use_gnupg_extensions=yes
-else
-echo $ac_n "checking for dld_link in -ldld""... $ac_c" 1>&6
-echo "configure:1399: checking for dld_link in -ldld" >&5
-ac_lib_var=`echo dld'_'dld_link | sed 'y%./+-%__p_%'`
-if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  ac_save_LIBS="$LIBS"
-LIBS="-ldld  $LIBS"
-cat > conftest.$ac_ext <<EOF
-#line 1407 "configure"
-#include "confdefs.h"
-/* Override any gcc2 internal prototype to avoid an error.  */
-/* We use char because int might match the return type of a gcc2
-    builtin and then its argument prototype would still apply.  */
-char dld_link();
-
-int main() {
-dld_link()
-; return 0; }
-EOF
-if { (eval echo configure:1418: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
-  rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=yes"
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=no"
-fi
-rm -f conftest*
-LIBS="$ac_save_LIBS"
-
-fi
-if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_lib=HAVE_LIB`echo dld | sed -e 's/[^a-zA-Z0-9_]/_/g' \
-    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_lib 1
-EOF
-
-  LIBS="-ldld $LIBS"
-
-else
-  echo "$ac_t""no" 1>&6
-fi
-
-if test "$ac_cv_lib_dld_dld_link" = "yes"; then
-  cat >> confdefs.h <<\EOF
-#define USE_DYNAMIC_LINKING 1
-EOF
-
-  cat >> confdefs.h <<\EOF
-#define HAVE_DLD_DLD_LINK 1
-EOF
-
-  DYNLINK_LDFLAGS=-rdynamic
-  use_gnupg_extensions=yes
-fi
-fi
-else
-  echo $ac_n "checking for dynamic loading""... $ac_c" 1>&6
-echo "configure:1460: checking for dynamic loading" >&5
-  DYNLINK_LDFLAGS=
-  DYNLINK_MOD_CFLAGS=
-  use_gnupg_extensions=no
-  echo "$ac_t""has been disabled" 1>&6
-fi
-
-
-
-if test "$use_gnupg_extensions" = yes ; then
-  ENABLE_GNUPG_EXTENSIONS_TRUE=
-  ENABLE_GNUPG_EXTENSIONS_FALSE='#'
-else
-  ENABLE_GNUPG_EXTENSIONS_TRUE='#'
-  ENABLE_GNUPG_EXTENSIONS_FALSE=
-fi
-
-
-
-
 echo $ac_n "checking for ANSI C header files""... $ac_c" 1>&6
-echo "configure:1481: checking for ANSI C header files" >&5
+echo "configure:1317: checking for ANSI C header files" >&5
 if eval "test \"`echo '$''{'ac_cv_header_stdc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1486 "configure"
+#line 1322 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 #include <stdarg.h>
@@ -1490,7 +1326,7 @@
 #include <float.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1494: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1330: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -1507,7 +1343,7 @@
 if test $ac_cv_header_stdc = yes; then
   # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1511 "configure"
+#line 1347 "configure"
 #include "confdefs.h"
 #include <string.h>
 EOF
@@ -1525,7 +1361,7 @@
 if test $ac_cv_header_stdc = yes; then
   # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1529 "configure"
+#line 1365 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 EOF
@@ -1546,7 +1382,7 @@
   :
 else
   cat > conftest.$ac_ext <<EOF
-#line 1550 "configure"
+#line 1386 "configure"
 #include "confdefs.h"
 #include <ctype.h>
 #define ISLOWER(c) ('a' <= (c) && (c) <= 'z')
@@ -1557,7 +1393,7 @@
 exit (0); }
 
 EOF
-if { (eval echo configure:1561: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1397: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   :
 else
@@ -1580,55 +1416,13 @@
 
 fi
 
-for ac_hdr in unistd.h
-do
-ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
-echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:1588: checking for $ac_hdr" >&5
-if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
+echo $ac_n "checking for working const""... $ac_c" 1>&6
+echo "configure:1421: checking for working const" >&5
+if eval "test \"`echo '$''{'ac_cv_c_const'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1593 "configure"
-#include "confdefs.h"
-#include <$ac_hdr>
-EOF
-ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1598: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
-ac_err=`grep -v '^ *+' conftest.out`
-if test -z "$ac_err"; then
-  rm -rf conftest*
-  eval "ac_cv_header_$ac_safe=yes"
-else
-  echo "$ac_err" >&5
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  eval "ac_cv_header_$ac_safe=no"
-fi
-rm -f conftest*
-fi
-if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_hdr 1
-EOF
- 
-else
-  echo "$ac_t""no" 1>&6
-fi
-done
-
-
-
-echo $ac_n "checking for working const""... $ac_c" 1>&6
-echo "configure:1627: checking for working const" >&5
-if eval "test \"`echo '$''{'ac_cv_c_const'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  cat > conftest.$ac_ext <<EOF
-#line 1632 "configure"
+#line 1426 "configure"
 #include "confdefs.h"
 
 int main() {
@@ -1677,7 +1471,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:1681: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1475: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_const=yes
 else
@@ -1698,21 +1492,21 @@
 fi
 
 echo $ac_n "checking for inline""... $ac_c" 1>&6
-echo "configure:1702: checking for inline" >&5
+echo "configure:1496: checking for inline" >&5
 if eval "test \"`echo '$''{'ac_cv_c_inline'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   ac_cv_c_inline=no
 for ac_kw in inline __inline__ __inline; do
   cat > conftest.$ac_ext <<EOF
-#line 1709 "configure"
+#line 1503 "configure"
 #include "confdefs.h"
 
 int main() {
 } $ac_kw foo() {
 ; return 0; }
 EOF
-if { (eval echo configure:1716: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1510: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_inline=$ac_kw; break
 else
@@ -1737,13 +1531,46 @@
  ;;
 esac
 
+echo $ac_n "checking for off_t""... $ac_c" 1>&6
+echo "configure:1536: checking for off_t" >&5
+if eval "test \"`echo '$''{'ac_cv_type_off_t'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 1541 "configure"
+#include "confdefs.h"
+#include <sys/types.h>
+#if STDC_HEADERS
+#include <stdlib.h>
+#include <stddef.h>
+#endif
+EOF
+if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
+  egrep "off_t[^a-zA-Z_0-9]" >/dev/null 2>&1; then
+  rm -rf conftest*
+  ac_cv_type_off_t=yes
+else
+  rm -rf conftest*
+  ac_cv_type_off_t=no
+fi
+rm -f conftest*
+
+fi
+echo "$ac_t""$ac_cv_type_off_t" 1>&6
+if test $ac_cv_type_off_t = no; then
+  cat >> confdefs.h <<\EOF
+#define off_t long
+EOF
+
+fi
+
 echo $ac_n "checking for size_t""... $ac_c" 1>&6
-echo "configure:1742: checking for size_t" >&5
+echo "configure:1569: checking for size_t" >&5
 if eval "test \"`echo '$''{'ac_cv_type_size_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1747 "configure"
+#line 1574 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #if STDC_HEADERS
@@ -1770,614 +1597,610 @@
 
 fi
 
-echo $ac_n "checking return type of signal handlers""... $ac_c" 1>&6
-echo "configure:1775: checking return type of signal handlers" >&5
-if eval "test \"`echo '$''{'ac_cv_type_signal'+set}'`\" = set"; then
+# The Ultrix 4.2 mips builtin alloca declared by alloca.h only works
+# for constant arguments.  Useless!
+echo $ac_n "checking for working alloca.h""... $ac_c" 1>&6
+echo "configure:1604: checking for working alloca.h" >&5
+if eval "test \"`echo '$''{'ac_cv_header_alloca_h'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1780 "configure"
+#line 1609 "configure"
 #include "confdefs.h"
-#include <sys/types.h>
-#include <signal.h>
-#ifdef signal
-#undef signal
-#endif
-#ifdef __cplusplus
-extern "C" void (*signal (int, void (*)(int)))(int);
-#else
-void (*signal ()) ();
-#endif
-
+#include <alloca.h>
 int main() {
-int i;
+char *p = alloca(2 * sizeof(int));
 ; return 0; }
 EOF
-if { (eval echo configure:1797: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1616: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  ac_cv_type_signal=void
+  ac_cv_header_alloca_h=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  ac_cv_type_signal=int
+  ac_cv_header_alloca_h=no
 fi
 rm -f conftest*
 fi
 
-echo "$ac_t""$ac_cv_type_signal" 1>&6
-cat >> confdefs.h <<EOF
-#define RETSIGTYPE $ac_cv_type_signal
+echo "$ac_t""$ac_cv_header_alloca_h" 1>&6
+if test $ac_cv_header_alloca_h = yes; then
+  cat >> confdefs.h <<\EOF
+#define HAVE_ALLOCA_H 1
 EOF
 
+fi
 
-echo $ac_n "checking for sys_siglist declaration in signal.h or unistd.h""... $ac_c" 1>&6
-echo "configure:1816: checking for sys_siglist declaration in signal.h or unistd.h" >&5
-if eval "test \"`echo '$''{'ac_cv_decl_sys_siglist'+set}'`\" = set"; then
+echo $ac_n "checking for alloca""... $ac_c" 1>&6
+echo "configure:1637: checking for alloca" >&5
+if eval "test \"`echo '$''{'ac_cv_func_alloca_works'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1821 "configure"
+#line 1642 "configure"
 #include "confdefs.h"
-#include <sys/types.h>
-#include <signal.h>
-/* NetBSD declares sys_siglist in unistd.h.  */
-#ifdef HAVE_UNISTD_H
-#include <unistd.h>
+
+#ifdef __GNUC__
+# define alloca __builtin_alloca
+#else
+# if HAVE_ALLOCA_H
+#  include <alloca.h>
+# else
+#  ifdef _AIX
+ #pragma alloca
+#  else
+#   ifndef alloca /* predefined by HP cc +Olibcalls */
+char *alloca ();
+#   endif
+#  endif
+# endif
 #endif
+
 int main() {
-char *msg = *(sys_siglist + 1);
+char *p = (char *) alloca(1);
 ; return 0; }
 EOF
-if { (eval echo configure:1833: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1665: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  ac_cv_decl_sys_siglist=yes
+  ac_cv_func_alloca_works=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  ac_cv_decl_sys_siglist=no
+  ac_cv_func_alloca_works=no
 fi
 rm -f conftest*
 fi
 
-echo "$ac_t""$ac_cv_decl_sys_siglist" 1>&6
-if test $ac_cv_decl_sys_siglist = yes; then
+echo "$ac_t""$ac_cv_func_alloca_works" 1>&6
+if test $ac_cv_func_alloca_works = yes; then
   cat >> confdefs.h <<\EOF
-#define SYS_SIGLIST_DECLARED 1
+#define HAVE_ALLOCA 1
 EOF
 
 fi
 
+if test $ac_cv_func_alloca_works = no; then
+  # The SVR3 libPW and SVR4 libucb both contain incompatible functions
+  # that cause trouble.  Some versions do not even contain alloca or
+  # contain a buggy version.  If you still want to use their alloca,
+  # use ar to extract alloca.o from them instead of compiling alloca.c.
+  ALLOCA=alloca.o
+  cat >> confdefs.h <<\EOF
+#define C_ALLOCA 1
+EOF
+
 
- if test "$cross_compiling" = yes; then
-	echo "configure: warning: cross compiling; assuming little endianess" 1>&2
-    fi
-    echo $ac_n "checking endianess""... $ac_c" 1>&6
-echo "configure:1858: checking endianess" >&5
-    if eval "test \"`echo '$''{'wk_cv_c_endian'+set}'`\" = set"; then
+echo $ac_n "checking whether alloca needs Cray hooks""... $ac_c" 1>&6
+echo "configure:1697: checking whether alloca needs Cray hooks" >&5
+if eval "test \"`echo '$''{'ac_cv_os_cray'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-   wk_cv_c_endian=unknown
-	# See if sys/param.h defines the BYTE_ORDER macro.
-	cat > conftest.$ac_ext <<EOF
-#line 1865 "configure"
+  cat > conftest.$ac_ext <<EOF
+#line 1702 "configure"
 #include "confdefs.h"
-#include <sys/types.h>
-	#include <sys/param.h>
-int main() {
+#if defined(CRAY) && ! defined(CRAY2)
+webecray
+#else
+wenotbecray
+#endif
 
-	#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
-	 bogus endian macros
-	#endif
-; return 0; }
 EOF
-if { (eval echo configure:1876: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
+  egrep "webecray" >/dev/null 2>&1; then
   rm -rf conftest*
-  # It does; now see whether it defined to BIG_ENDIAN or not.
-	cat > conftest.$ac_ext <<EOF
-#line 1880 "configure"
+  ac_cv_os_cray=yes
+else
+  rm -rf conftest*
+  ac_cv_os_cray=no
+fi
+rm -f conftest*
+
+fi
+
+echo "$ac_t""$ac_cv_os_cray" 1>&6
+if test $ac_cv_os_cray = yes; then
+for ac_func in _getb67 GETB67 getb67; do
+  echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:1727: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 1732 "configure"
 #include "confdefs.h"
-#include <sys/types.h>
-	#include <sys/param.h>
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
+
 int main() {
 
-	#if BYTE_ORDER != BIG_ENDIAN
-	 not big endian
-	#endif
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
+
 ; return 0; }
 EOF
-if { (eval echo configure:1891: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1755: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  wk_cv_c_endian=big
+  eval "ac_cv_func_$ac_func=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  wk_cv_c_endian=little
+  eval "ac_cv_func_$ac_func=no"
 fi
 rm -f conftest*
+fi
+
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+  cat >> confdefs.h <<EOF
+#define CRAY_STACKSEG_END $ac_func
+EOF
+
+  break
 else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
+  echo "$ac_t""no" 1>&6
 fi
-rm -f conftest*
-	if test "$wk_cv_c_endian" = unknown; then
-	    if test "$cross_compiling" = yes; then
-  wk_cv_c_endian=little
-	    
+
+done
+fi
+
+echo $ac_n "checking stack direction for C alloca""... $ac_c" 1>&6
+echo "configure:1782: checking stack direction for C alloca" >&5
+if eval "test \"`echo '$''{'ac_cv_c_stack_direction'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  if test "$cross_compiling" = yes; then
+  ac_cv_c_stack_direction=0
 else
   cat > conftest.$ac_ext <<EOF
-#line 1912 "configure"
+#line 1790 "configure"
 #include "confdefs.h"
-main () {
-	      /* Are we little or big endian?  From Harbison&Steele.  */
-	      union
-	      {
-		long l;
-		char c[sizeof (long)];
-	      } u;
-	      u.l = 1;
-	      exit (u.c[sizeof (long) - 1] == 1);
-	      }
+find_stack_direction ()
+{
+  static char *addr = 0;
+  auto char dummy;
+  if (addr == 0)
+    {
+      addr = &dummy;
+      return find_stack_direction ();
+    }
+  else
+    return (&dummy > addr) ? 1 : -1;
+}
+main ()
+{
+  exit (find_stack_direction() < 0);
+}
 EOF
-if { (eval echo configure:1925: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1809: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
-  wk_cv_c_endian=little
+  ac_cv_c_stack_direction=1
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -fr conftest*
-  wk_cv_c_endian=big
+  ac_cv_c_stack_direction=-1
 fi
 rm -fr conftest*
 fi
 
-	fi
-      
 fi
 
-    echo "$ac_t""$wk_cv_c_endian" 1>&6
-    if test "$wk_cv_c_endian" = little; then
-      cat >> confdefs.h <<\EOF
-#define LITTLE_ENDIAN_HOST 1
-EOF
-
-    else
-      cat >> confdefs.h <<\EOF
-#define BIG_ENDIAN_HOST 1
+echo "$ac_t""$ac_cv_c_stack_direction" 1>&6
+cat >> confdefs.h <<EOF
+#define STACK_DIRECTION $ac_cv_c_stack_direction
 EOF
 
-    fi
-  
-
-
- echo $ac_n "checking for byte typedef""... $ac_c" 1>&6
-echo "configure:1957: checking for byte typedef" >&5
-    if eval "test \"`echo '$''{'wk_cv_typedef_byte'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  cat > conftest.$ac_ext <<EOF
-#line 1962 "configure"
-#include "confdefs.h"
-#include <stdlib.h>
-    #include <sys/types.h>
-int main() {
-
-    #undef byte
-    int a = sizeof(byte);
-    
-; return 0; }
-EOF
-if { (eval echo configure:1973: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
-  rm -rf conftest*
-  wk_cv_typedef_byte=yes
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  wk_cv_typedef_byte=no 
-fi
-rm -f conftest*
 fi
 
-    echo "$ac_t""$wk_cv_typedef_byte" 1>&6
-    if test "$wk_cv_typedef_byte" = yes; then
-	cat >> confdefs.h <<\EOF
-#define HAVE_BYTE_TYPEDEF 1
-EOF
-
-    fi
-  
- echo $ac_n "checking for ushort typedef""... $ac_c" 1>&6
-echo "configure:1994: checking for ushort typedef" >&5
-    if eval "test \"`echo '$''{'wk_cv_typedef_ushort'+set}'`\" = set"; then
+for ac_hdr in unistd.h
+do
+ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
+echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
+echo "configure:1834: checking for $ac_hdr" >&5
+if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1999 "configure"
+#line 1839 "configure"
 #include "confdefs.h"
-#include <stdlib.h>
-    #include <sys/types.h>
-int main() {
-
-    #undef ushort
-    int a = sizeof(ushort);
-    
-; return 0; }
+#include <$ac_hdr>
 EOF
-if { (eval echo configure:2010: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
+{ (eval echo configure:1844: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+ac_err=`grep -v '^ *+' conftest.out`
+if test -z "$ac_err"; then
   rm -rf conftest*
-  wk_cv_typedef_ushort=yes
+  eval "ac_cv_header_$ac_safe=yes"
 else
+  echo "$ac_err" >&5
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  wk_cv_typedef_ushort=no 
+  eval "ac_cv_header_$ac_safe=no"
 fi
 rm -f conftest*
 fi
-
-    echo "$ac_t""$wk_cv_typedef_ushort" 1>&6
-    if test "$wk_cv_typedef_ushort" = yes; then
-	cat >> confdefs.h <<\EOF
-#define HAVE_USHORT_TYPEDEF 1
-EOF
-
-    fi
-  
- echo $ac_n "checking for ulong typedef""... $ac_c" 1>&6
-echo "configure:2031: checking for ulong typedef" >&5
-    if eval "test \"`echo '$''{'wk_cv_typedef_ulong'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  cat > conftest.$ac_ext <<EOF
-#line 2036 "configure"
-#include "confdefs.h"
-#include <stdlib.h>
-    #include <sys/types.h>
-int main() {
-
-    #undef ulong
-    int a = sizeof(ulong);
-    
-; return 0; }
+if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_hdr 1
 EOF
-if { (eval echo configure:2047: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
-  rm -rf conftest*
-  wk_cv_typedef_ulong=yes
+ 
 else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  wk_cv_typedef_ulong=no 
-fi
-rm -f conftest*
+  echo "$ac_t""no" 1>&6
 fi
+done
 
-    echo "$ac_t""$wk_cv_typedef_ulong" 1>&6
-    if test "$wk_cv_typedef_ulong" = yes; then
-	cat >> confdefs.h <<\EOF
-#define HAVE_ULONG_TYPEDEF 1
-EOF
-
-    fi
-  
- echo $ac_n "checking for u16 typedef""... $ac_c" 1>&6
-echo "configure:2068: checking for u16 typedef" >&5
-    if eval "test \"`echo '$''{'wk_cv_typedef_u16'+set}'`\" = set"; then
+for ac_func in getpagesize
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:1873: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2073 "configure"
+#line 1878 "configure"
 #include "confdefs.h"
-#include <stdlib.h>
-    #include <sys/types.h>
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
+
 int main() {
 
-    #undef u16
-    int a = sizeof(u16);
-    
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
+
 ; return 0; }
 EOF
-if { (eval echo configure:2084: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1901: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  wk_cv_typedef_u16=yes
+  eval "ac_cv_func_$ac_func=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  wk_cv_typedef_u16=no 
+  eval "ac_cv_func_$ac_func=no"
 fi
 rm -f conftest*
 fi
 
-    echo "$ac_t""$wk_cv_typedef_u16" 1>&6
-    if test "$wk_cv_typedef_u16" = yes; then
-	cat >> confdefs.h <<\EOF
-#define HAVE_U16_TYPEDEF 1
-EOF
-
-    fi
-  
- echo $ac_n "checking for u32 typedef""... $ac_c" 1>&6
-echo "configure:2105: checking for u32 typedef" >&5
-    if eval "test \"`echo '$''{'wk_cv_typedef_u32'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  cat > conftest.$ac_ext <<EOF
-#line 2110 "configure"
-#include "confdefs.h"
-#include <stdlib.h>
-    #include <sys/types.h>
-int main() {
-
-    #undef u32
-    int a = sizeof(u32);
-    
-; return 0; }
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
 EOF
-if { (eval echo configure:2121: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
-  rm -rf conftest*
-  wk_cv_typedef_u32=yes
+ 
 else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  wk_cv_typedef_u32=no 
-fi
-rm -f conftest*
+  echo "$ac_t""no" 1>&6
 fi
+done
 
-    echo "$ac_t""$wk_cv_typedef_u32" 1>&6
-    if test "$wk_cv_typedef_u32" = yes; then
-	cat >> confdefs.h <<\EOF
-#define HAVE_U32_TYPEDEF 1
-EOF
-
-    fi
-  
-
-echo $ac_n "checking size of unsigned short""... $ac_c" 1>&6
-echo "configure:2143: checking size of unsigned short" >&5
-if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_short'+set}'`\" = set"; then
+echo $ac_n "checking for working mmap""... $ac_c" 1>&6
+echo "configure:1926: checking for working mmap" >&5
+if eval "test \"`echo '$''{'ac_cv_func_mmap_fixed_mapped'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   if test "$cross_compiling" = yes; then
-  ac_cv_sizeof_unsigned_short=2
+  ac_cv_func_mmap_fixed_mapped=no
 else
   cat > conftest.$ac_ext <<EOF
-#line 2151 "configure"
+#line 1934 "configure"
 #include "confdefs.h"
-#include <stdio.h>
-main()
-{
-  FILE *f=fopen("conftestval", "w");
-  if (!f) exit(1);
-  fprintf(f, "%d\n", sizeof(unsigned short));
-  exit(0);
-}
-EOF
-if { (eval echo configure:2162: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
-then
-  ac_cv_sizeof_unsigned_short=`cat conftestval`
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -fr conftest*
-  ac_cv_sizeof_unsigned_short=0
-fi
-rm -fr conftest*
-fi
 
-fi
-echo "$ac_t""$ac_cv_sizeof_unsigned_short" 1>&6
-cat >> confdefs.h <<EOF
-#define SIZEOF_UNSIGNED_SHORT $ac_cv_sizeof_unsigned_short
-EOF
+/* Thanks to Mike Haertel and Jim Avera for this test.
+   Here is a matrix of mmap possibilities:
+	mmap private not fixed
+	mmap private fixed at somewhere currently unmapped
+	mmap private fixed at somewhere already mapped
+	mmap shared not fixed
+	mmap shared fixed at somewhere currently unmapped
+	mmap shared fixed at somewhere already mapped
+   For private mappings, we should verify that changes cannot be read()
+   back from the file, nor mmap's back from the file at a different
+   address.  (There have been systems where private was not correctly
+   implemented like the infamous i386 svr4.0, and systems where the
+   VM page cache was not coherent with the filesystem buffer cache
+   like early versions of FreeBSD and possibly contemporary NetBSD.)
+   For shared mappings, we should conversely verify that changes get
+   propogated back to all the places they're supposed to be.
 
+   Grep wants private fixed already mapped.
+   The main things grep needs to know about mmap are:
+   * does it exist and is it safe to write into the mmap'd area
+   * how to use it (BSD variants)  */
+#include <sys/types.h>
+#include <fcntl.h>
+#include <sys/mman.h>
 
-echo $ac_n "checking size of unsigned int""... $ac_c" 1>&6
-echo "configure:2182: checking size of unsigned int" >&5
-if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_int'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  if test "$cross_compiling" = yes; then
-  ac_cv_sizeof_unsigned_int=4
-else
-  cat > conftest.$ac_ext <<EOF
-#line 2190 "configure"
-#include "confdefs.h"
-#include <stdio.h>
-main()
-{
-  FILE *f=fopen("conftestval", "w");
-  if (!f) exit(1);
-  fprintf(f, "%d\n", sizeof(unsigned int));
-  exit(0);
-}
-EOF
-if { (eval echo configure:2201: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
-then
-  ac_cv_sizeof_unsigned_int=`cat conftestval`
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -fr conftest*
-  ac_cv_sizeof_unsigned_int=0
-fi
-rm -fr conftest*
-fi
+/* This mess was copied from the GNU getpagesize.h.  */
+#ifndef HAVE_GETPAGESIZE
+# ifdef HAVE_UNISTD_H
+#  include <unistd.h>
+# endif
 
-fi
-echo "$ac_t""$ac_cv_sizeof_unsigned_int" 1>&6
-cat >> confdefs.h <<EOF
-#define SIZEOF_UNSIGNED_INT $ac_cv_sizeof_unsigned_int
-EOF
+/* Assume that all systems that can run configure have sys/param.h.  */
+# ifndef HAVE_SYS_PARAM_H
+#  define HAVE_SYS_PARAM_H 1
+# endif
+
+# ifdef _SC_PAGESIZE
+#  define getpagesize() sysconf(_SC_PAGESIZE)
+# else /* no _SC_PAGESIZE */
+#  ifdef HAVE_SYS_PARAM_H
+#   include <sys/param.h>
+#   ifdef EXEC_PAGESIZE
+#    define getpagesize() EXEC_PAGESIZE
+#   else /* no EXEC_PAGESIZE */
+#    ifdef NBPG
+#     define getpagesize() NBPG * CLSIZE
+#     ifndef CLSIZE
+#      define CLSIZE 1
+#     endif /* no CLSIZE */
+#    else /* no NBPG */
+#     ifdef NBPC
+#      define getpagesize() NBPC
+#     else /* no NBPC */
+#      ifdef PAGESIZE
+#       define getpagesize() PAGESIZE
+#      endif /* PAGESIZE */
+#     endif /* no NBPC */
+#    endif /* no NBPG */
+#   endif /* no EXEC_PAGESIZE */
+#  else /* no HAVE_SYS_PARAM_H */
+#   define getpagesize() 8192	/* punt totally */
+#  endif /* no HAVE_SYS_PARAM_H */
+# endif /* no _SC_PAGESIZE */
 
+#endif /* no HAVE_GETPAGESIZE */
 
-echo $ac_n "checking size of unsigned long""... $ac_c" 1>&6
-echo "configure:2221: checking size of unsigned long" >&5
-if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_long'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  if test "$cross_compiling" = yes; then
-  ac_cv_sizeof_unsigned_long=4
-else
-  cat > conftest.$ac_ext <<EOF
-#line 2229 "configure"
-#include "confdefs.h"
-#include <stdio.h>
+#ifdef __cplusplus
+extern "C" { void *malloc(unsigned); }
+#else
+char *malloc();
+#endif
+
+int
 main()
 {
-  FILE *f=fopen("conftestval", "w");
-  if (!f) exit(1);
-  fprintf(f, "%d\n", sizeof(unsigned long));
-  exit(0);
+	char *data, *data2, *data3;
+	int i, pagesize;
+	int fd;
+
+	pagesize = getpagesize();
+
+	/*
+	 * First, make a file with some known garbage in it.
+	 */
+	data = malloc(pagesize);
+	if (!data)
+		exit(1);
+	for (i = 0; i < pagesize; ++i)
+		*(data + i) = rand();
+	umask(0);
+	fd = creat("conftestmmap", 0600);
+	if (fd < 0)
+		exit(1);
+	if (write(fd, data, pagesize) != pagesize)
+		exit(1);
+	close(fd);
+
+	/*
+	 * Next, try to mmap the file at a fixed address which
+	 * already has something else allocated at it.  If we can,
+	 * also make sure that we see the same garbage.
+	 */
+	fd = open("conftestmmap", O_RDWR);
+	if (fd < 0)
+		exit(1);
+	data2 = malloc(2 * pagesize);
+	if (!data2)
+		exit(1);
+	data2 += (pagesize - ((int) data2 & (pagesize - 1))) & (pagesize - 1);
+	if (data2 != mmap(data2, pagesize, PROT_READ | PROT_WRITE,
+	    MAP_PRIVATE | MAP_FIXED, fd, 0L))
+		exit(1);
+	for (i = 0; i < pagesize; ++i)
+		if (*(data + i) != *(data2 + i))
+			exit(1);
+
+	/*
+	 * Finally, make sure that changes to the mapped area
+	 * do not percolate back to the file as seen by read().
+	 * (This is a bug on some variants of i386 svr4.0.)
+	 */
+	for (i = 0; i < pagesize; ++i)
+		*(data2 + i) = *(data2 + i) + 1;
+	data3 = malloc(pagesize);
+	if (!data3)
+		exit(1);
+	if (read(fd, data3, pagesize) != pagesize)
+		exit(1);
+	for (i = 0; i < pagesize; ++i)
+		if (*(data + i) != *(data3 + i))
+			exit(1);
+	close(fd);
+	unlink("conftestmmap");
+	exit(0);
 }
+
 EOF
-if { (eval echo configure:2240: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2074: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
-  ac_cv_sizeof_unsigned_long=`cat conftestval`
+  ac_cv_func_mmap_fixed_mapped=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -fr conftest*
-  ac_cv_sizeof_unsigned_long=0
+  ac_cv_func_mmap_fixed_mapped=no
 fi
 rm -fr conftest*
 fi
 
 fi
-echo "$ac_t""$ac_cv_sizeof_unsigned_long" 1>&6
-cat >> confdefs.h <<EOF
-#define SIZEOF_UNSIGNED_LONG $ac_cv_sizeof_unsigned_long
-EOF
-
 
+echo "$ac_t""$ac_cv_func_mmap_fixed_mapped" 1>&6
+if test $ac_cv_func_mmap_fixed_mapped = yes; then
+  cat >> confdefs.h <<\EOF
+#define HAVE_MMAP 1
+EOF
 
-if test "$ac_cv_sizeof_unsigned_short" = "0" \
-   || test "$ac_cv_sizeof_unsigned_int" = "0" \
-   || test "$ac_cv_sizeof_unsigned_long" = "0"; then
-    echo "configure: warning: Hmmm, something is wrong with the sizes - using defaults" 1>&2;
 fi
 
-
-
-echo $ac_n "checking for vprintf""... $ac_c" 1>&6
-echo "configure:2269: checking for vprintf" >&5
-if eval "test \"`echo '$''{'ac_cv_func_vprintf'+set}'`\" = set"; then
+                              
+   for ac_hdr in argz.h limits.h locale.h nl_types.h malloc.h string.h \
+unistd.h sys/param.h
+do
+ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
+echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
+echo "configure:2102: checking for $ac_hdr" >&5
+if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2274 "configure"
+#line 2107 "configure"
 #include "confdefs.h"
-/* System header to define __stub macros and hopefully few prototypes,
-    which can conflict with char vprintf(); below.  */
-#include <assert.h>
-/* Override any gcc2 internal prototype to avoid an error.  */
-/* We use char because int might match the return type of a gcc2
-    builtin and then its argument prototype would still apply.  */
-char vprintf();
-
-int main() {
-
-/* The GNU C library defines this for functions which it implements
-    to always fail with ENOSYS.  Some functions are actually named
-    something starting with __ and the normal name is an alias.  */
-#if defined (__stub_vprintf) || defined (__stub___vprintf)
-choke me
-#else
-vprintf();
-#endif
-
-; return 0; }
+#include <$ac_hdr>
 EOF
-if { (eval echo configure:2297: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
+{ (eval echo configure:2112: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+ac_err=`grep -v '^ *+' conftest.out`
+if test -z "$ac_err"; then
   rm -rf conftest*
-  eval "ac_cv_func_vprintf=yes"
+  eval "ac_cv_header_$ac_safe=yes"
 else
+  echo "$ac_err" >&5
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_func_vprintf=no"
+  eval "ac_cv_header_$ac_safe=no"
 fi
 rm -f conftest*
 fi
-
-if eval "test \"`echo '$ac_cv_func_'vprintf`\" = yes"; then
+if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
   echo "$ac_t""yes" 1>&6
-  cat >> confdefs.h <<\EOF
-#define HAVE_VPRINTF 1
+    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_hdr 1
 EOF
-
+ 
 else
   echo "$ac_t""no" 1>&6
 fi
+done
 
-if test "$ac_cv_func_vprintf" != yes; then
-echo $ac_n "checking for _doprnt""... $ac_c" 1>&6
-echo "configure:2321: checking for _doprnt" >&5
-if eval "test \"`echo '$''{'ac_cv_func__doprnt'+set}'`\" = set"; then
+   for ac_func in getcwd munmap putenv setenv setlocale strchr strcasecmp \
+strdup __argz_count __argz_stringify __argz_next
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:2142: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2326 "configure"
+#line 2147 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
-    which can conflict with char _doprnt(); below.  */
+    which can conflict with char $ac_func(); below.  */
 #include <assert.h>
 /* Override any gcc2 internal prototype to avoid an error.  */
 /* We use char because int might match the return type of a gcc2
     builtin and then its argument prototype would still apply.  */
-char _doprnt();
+char $ac_func();
 
 int main() {
 
 /* The GNU C library defines this for functions which it implements
     to always fail with ENOSYS.  Some functions are actually named
     something starting with __ and the normal name is an alias.  */
-#if defined (__stub__doprnt) || defined (__stub____doprnt)
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
 choke me
 #else
-_doprnt();
+$ac_func();
 #endif
 
 ; return 0; }
 EOF
-if { (eval echo configure:2349: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2170: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  eval "ac_cv_func__doprnt=yes"
+  eval "ac_cv_func_$ac_func=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_func__doprnt=no"
+  eval "ac_cv_func_$ac_func=no"
 fi
 rm -f conftest*
 fi
 
-if eval "test \"`echo '$ac_cv_func_'_doprnt`\" = yes"; then
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
   echo "$ac_t""yes" 1>&6
-  cat >> confdefs.h <<\EOF
-#define HAVE_DOPRNT 1
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
 EOF
-
+ 
 else
   echo "$ac_t""no" 1>&6
 fi
+done
 
-fi
 
-for ac_func in strerror stpcpy strlwr tcgetattr rand strtoul mmap
+   if test "${ac_cv_func_stpcpy+set}" != "set"; then
+     for ac_func in stpcpy
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2376: checking for $ac_func" >&5
+echo "configure:2199: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2381 "configure"
+#line 2204 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2400,7 +2223,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2404: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2227: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2424,126 +2247,277 @@
 fi
 done
 
-for ac_func in memmove gettimeofday getrusage gethrtime setrlimit
-do
-echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2431: checking for $ac_func" >&5
-if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+   fi
+   if test "${ac_cv_func_stpcpy}" = "yes"; then
+     cat >> confdefs.h <<\EOF
+#define HAVE_STPCPY 1
+EOF
+
+   fi
+
+   if test $ac_cv_header_locale_h = yes; then
+    echo $ac_n "checking for LC_MESSAGES""... $ac_c" 1>&6
+echo "configure:2261: checking for LC_MESSAGES" >&5
+if eval "test \"`echo '$''{'am_cv_val_LC_MESSAGES'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2436 "configure"
+#line 2266 "configure"
 #include "confdefs.h"
-/* System header to define __stub macros and hopefully few prototypes,
-    which can conflict with char $ac_func(); below.  */
-#include <assert.h>
-/* Override any gcc2 internal prototype to avoid an error.  */
-/* We use char because int might match the return type of a gcc2
-    builtin and then its argument prototype would still apply.  */
-char $ac_func();
-
+#include <locale.h>
 int main() {
-
-/* The GNU C library defines this for functions which it implements
-    to always fail with ENOSYS.  Some functions are actually named
-    something starting with __ and the normal name is an alias.  */
-#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
-choke me
-#else
-$ac_func();
-#endif
-
+return LC_MESSAGES
 ; return 0; }
 EOF
-if { (eval echo configure:2459: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2273: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=yes"
+  am_cv_val_LC_MESSAGES=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=no"
+  am_cv_val_LC_MESSAGES=no
 fi
 rm -f conftest*
 fi
 
-if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_func 1
+echo "$ac_t""$am_cv_val_LC_MESSAGES" 1>&6
+    if test $am_cv_val_LC_MESSAGES = yes; then
+      cat >> confdefs.h <<\EOF
+#define HAVE_LC_MESSAGES 1
 EOF
- 
+
+    fi
+  fi
+   echo $ac_n "checking whether NLS is requested""... $ac_c" 1>&6
+echo "configure:2294: checking whether NLS is requested" >&5
+        # Check whether --enable-nls or --disable-nls was given.
+if test "${enable_nls+set}" = set; then
+  enableval="$enable_nls"
+  USE_NLS=$enableval
 else
-  echo "$ac_t""no" 1>&6
+  USE_NLS=yes
 fi
-done
 
-for ac_func in memicmp atexit raise getpagesize strftime
-do
-echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2486: checking for $ac_func" >&5
-if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+    echo "$ac_t""$USE_NLS" 1>&6
+    
+
+    USE_INCLUDED_LIBINTL=no
+
+        if test "$USE_NLS" = "yes"; then
+      cat >> confdefs.h <<\EOF
+#define ENABLE_NLS 1
+EOF
+
+      echo $ac_n "checking whether included gettext is requested""... $ac_c" 1>&6
+echo "configure:2314: checking whether included gettext is requested" >&5
+      # Check whether --with-included-gettext or --without-included-gettext was given.
+if test "${with_included_gettext+set}" = set; then
+  withval="$with_included_gettext"
+  nls_cv_force_use_gnu_gettext=$withval
+else
+  nls_cv_force_use_gnu_gettext=no
+fi
+
+      echo "$ac_t""$nls_cv_force_use_gnu_gettext" 1>&6
+
+      nls_cv_use_gnu_gettext="$nls_cv_force_use_gnu_gettext"
+      if test "$nls_cv_force_use_gnu_gettext" != "yes"; then
+					nls_cv_header_intl=
+	nls_cv_header_libgt=
+	CATOBJEXT=NONE
+
+	ac_safe=`echo "libintl.h" | sed 'y%./+-%__p_%'`
+echo $ac_n "checking for libintl.h""... $ac_c" 1>&6
+echo "configure:2333: checking for libintl.h" >&5
+if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2491 "configure"
+#line 2338 "configure"
+#include "confdefs.h"
+#include <libintl.h>
+EOF
+ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
+{ (eval echo configure:2343: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+ac_err=`grep -v '^ *+' conftest.out`
+if test -z "$ac_err"; then
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=yes"
+else
+  echo "$ac_err" >&5
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=no"
+fi
+rm -f conftest*
+fi
+if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+  echo $ac_n "checking for gettext in libc""... $ac_c" 1>&6
+echo "configure:2360: checking for gettext in libc" >&5
+if eval "test \"`echo '$''{'gt_cv_func_gettext_libc'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 2365 "configure"
+#include "confdefs.h"
+#include <libintl.h>
+int main() {
+return (int) gettext ("")
+; return 0; }
+EOF
+if { (eval echo configure:2372: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  gt_cv_func_gettext_libc=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  gt_cv_func_gettext_libc=no
+fi
+rm -f conftest*
+fi
+
+echo "$ac_t""$gt_cv_func_gettext_libc" 1>&6
+
+	   if test "$gt_cv_func_gettext_libc" != "yes"; then
+	     echo $ac_n "checking for bindtextdomain in -lintl""... $ac_c" 1>&6
+echo "configure:2388: checking for bindtextdomain in -lintl" >&5
+ac_lib_var=`echo intl'_'bindtextdomain | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  ac_save_LIBS="$LIBS"
+LIBS="-lintl  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 2396 "configure"
 #include "confdefs.h"
-/* System header to define __stub macros and hopefully few prototypes,
-    which can conflict with char $ac_func(); below.  */
-#include <assert.h>
 /* Override any gcc2 internal prototype to avoid an error.  */
 /* We use char because int might match the return type of a gcc2
     builtin and then its argument prototype would still apply.  */
-char $ac_func();
+char bindtextdomain();
 
 int main() {
+bindtextdomain()
+; return 0; }
+EOF
+if { (eval echo configure:2407: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=yes"
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_lib_$ac_lib_var=no"
+fi
+rm -f conftest*
+LIBS="$ac_save_LIBS"
 
-/* The GNU C library defines this for functions which it implements
-    to always fail with ENOSYS.  Some functions are actually named
-    something starting with __ and the normal name is an alias.  */
-#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
-choke me
-#else
-$ac_func();
-#endif
+fi
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+  echo $ac_n "checking for gettext in -lintl""... $ac_c" 1>&6
+echo "configure:2423: checking for gettext in -lintl" >&5
+ac_lib_var=`echo intl'_'gettext | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  ac_save_LIBS="$LIBS"
+LIBS="-lintl  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 2431 "configure"
+#include "confdefs.h"
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char gettext();
 
+int main() {
+gettext()
 ; return 0; }
 EOF
-if { (eval echo configure:2514: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2442: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=yes"
+  eval "ac_cv_lib_$ac_lib_var=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=no"
+  eval "ac_cv_lib_$ac_lib_var=no"
 fi
 rm -f conftest*
-fi
+LIBS="$ac_save_LIBS"
 
-if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+fi
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
   echo "$ac_t""yes" 1>&6
-    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_func 1
-EOF
- 
+  gt_cv_func_gettext_libintl=yes
+else
+  echo "$ac_t""no" 1>&6
+gt_cv_func_gettext_libintl=no
+fi
+
 else
   echo "$ac_t""no" 1>&6
 fi
-done
 
+	   fi
 
- for ac_func in mlock
+	   if test "$gt_cv_func_gettext_libintl" = "yes" ; then
+	     LIBS="-lintl $LIBS"
+	   fi
+
+	   if test "$gt_cv_func_gettext_libc" = "yes" \
+	      || test "$gt_cv_func_gettext_libintl" = "yes"; then
+	      cat >> confdefs.h <<\EOF
+#define HAVE_GETTEXT 1
+EOF
+
+	      # Extract the first word of "msgfmt", so it can be a program name with args.
+set dummy msgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2482: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$MSGFMT" in
+  /*)
+  ac_cv_path_MSGFMT="$MSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"; then
+	ac_cv_path_MSGFMT="$ac_dir/$ac_word"
+	break
+      fi
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_MSGFMT" && ac_cv_path_MSGFMT="no"
+  ;;
+esac
+fi
+MSGFMT="$ac_cv_path_MSGFMT"
+if test -n "$MSGFMT"; then
+  echo "$ac_t""$MSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+	      if test "$MSGFMT" != "no"; then
+		for ac_func in dcgettext
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2542: checking for $ac_func" >&5
+echo "configure:2516: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2547 "configure"
+#line 2521 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2566,7 +2540,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2570: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2544: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2590,288 +2564,566 @@
 fi
 done
 
-    if test "$ac_cv_func_mlock" = "yes"; then
-	echo $ac_n "checking whether mlock is broken""... $ac_c" 1>&6
-echo "configure:2596: checking whether mlock is broken" >&5
-	  if test "$cross_compiling" = yes; then
-  echo "$ac_t""assuming no" 1>&6
+		# Extract the first word of "gmsgfmt", so it can be a program name with args.
+set dummy gmsgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2571: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
 else
-  cat > conftest.$ac_ext <<EOF
-#line 2601 "configure"
-#include "confdefs.h"
-
-		#include <stdlib.h>
-		#include <unistd.h>
-		#include <errno.h>
-		#include <sys/mman.h>
-		#include <sys/types.h>
-		#include <fcntl.h>
-
-		int main()
-		{
-		    char *pool;
-		    int err;
-		    long int pgsize = getpagesize();
-
-		    pool = malloc( 4096 + pgsize );
-		    if( !pool )
-			return 2;
-		    pool += (pgsize - ((long int)pool % pgsize));
+  case "$GMSGFMT" in
+  /*)
+  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="$MSGFMT"
+  ;;
+esac
+fi
+GMSGFMT="$ac_cv_path_GMSGFMT"
+if test -n "$GMSGFMT"; then
+  echo "$ac_t""$GMSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
 
-		    err = mlock( pool, 4096 );
-		    if( !err || errno == EPERM )
-			return 0; /* okay */
+		# Extract the first word of "xgettext", so it can be a program name with args.
+set dummy xgettext; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2603: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$XGETTEXT" in
+  /*)
+  ac_cv_path_XGETTEXT="$XGETTEXT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"; then
+	ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
+	break
+      fi
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_XGETTEXT" && ac_cv_path_XGETTEXT=":"
+  ;;
+esac
+fi
+XGETTEXT="$ac_cv_path_XGETTEXT"
+if test -n "$XGETTEXT"; then
+  echo "$ac_t""$XGETTEXT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
 
-		    return 1;  /* hmmm */
-		}
+		cat > conftest.$ac_ext <<EOF
+#line 2635 "configure"
+#include "confdefs.h"
 
-	    
+int main() {
+extern int _nl_msg_cat_cntr;
+			       return _nl_msg_cat_cntr
+; return 0; }
 EOF
-if { (eval echo configure:2631: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
-then
-  echo "$ac_t""no" 1>&6
+if { (eval echo configure:2643: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  CATOBJEXT=.gmo
+		   DATADIRNAME=share
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
-  rm -fr conftest*
-  cat >> confdefs.h <<\EOF
-#define HAVE_BROKEN_MLOCK 1
-EOF
-
-	    echo "$ac_t""yes" 1>&6
+  rm -rf conftest*
+  CATOBJEXT=.mo
+		   DATADIRNAME=lib
 fi
-rm -fr conftest*
+rm -f conftest*
+		INSTOBJEXT=.mo
+	      fi
+	    fi
+	
+else
+  echo "$ac_t""no" 1>&6
 fi
 
-    fi
-  
 
- for ac_hdr in sys/ipc.h sys/shm.h
-do
-ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
-echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2654: checking for $ac_hdr" >&5
-if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
+	if test "$CATOBJEXT" = "NONE"; then
+	  echo $ac_n "checking whether catgets can be used""... $ac_c" 1>&6
+echo "configure:2666: checking whether catgets can be used" >&5
+	  # Check whether --with-catgets or --without-catgets was given.
+if test "${with_catgets+set}" = set; then
+  withval="$with_catgets"
+  nls_cv_use_catgets=$withval
+else
+  nls_cv_use_catgets=no
+fi
+
+	  echo "$ac_t""$nls_cv_use_catgets" 1>&6
+
+	  if test "$nls_cv_use_catgets" = "yes"; then
+	    	    echo $ac_n "checking for main in -li""... $ac_c" 1>&6
+echo "configure:2679: checking for main in -li" >&5
+ac_lib_var=`echo i'_'main | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  cat > conftest.$ac_ext <<EOF
-#line 2659 "configure"
+  ac_save_LIBS="$LIBS"
+LIBS="-li  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 2687 "configure"
 #include "confdefs.h"
-#include <$ac_hdr>
+
+int main() {
+main()
+; return 0; }
 EOF
-ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2664: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
-ac_err=`grep -v '^ *+' conftest.out`
-if test -z "$ac_err"; then
+if { (eval echo configure:2694: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  eval "ac_cv_header_$ac_safe=yes"
+  eval "ac_cv_lib_$ac_lib_var=yes"
 else
-  echo "$ac_err" >&5
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_header_$ac_safe=no"
+  eval "ac_cv_lib_$ac_lib_var=no"
 fi
 rm -f conftest*
+LIBS="$ac_save_LIBS"
+
 fi
-if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
   echo "$ac_t""yes" 1>&6
-    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
+    ac_tr_lib=HAVE_LIB`echo i | sed -e 's/[^a-zA-Z0-9_]/_/g' \
+    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
   cat >> confdefs.h <<EOF
-#define $ac_tr_hdr 1
+#define $ac_tr_lib 1
 EOF
- 
+
+  LIBS="-li $LIBS"
+
 else
   echo "$ac_t""no" 1>&6
 fi
-done
 
-    if test "$ac_cv_header_sys_shm_h" = "yes"; then
-      echo $ac_n "checking whether shmctl IPC_RMID allowes subsequent attaches""... $ac_c" 1>&6
-echo "configure:2692: checking whether shmctl IPC_RMID allowes subsequent attaches" >&5
-      if test "$cross_compiling" = yes; then
-  echo "$ac_t""assuming no" 1>&6
+	    echo $ac_n "checking for catgets""... $ac_c" 1>&6
+echo "configure:2722: checking for catgets" >&5
+if eval "test \"`echo '$''{'ac_cv_func_catgets'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2697 "configure"
+#line 2727 "configure"
 #include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char catgets(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char catgets();
 
-	    #include <sys/types.h>
-	    #include <sys/ipc.h>
-	    #include <sys/shm.h>
-	    int main()
-	    {
-	      int id;
-	      char *shmaddr;
-	    id = shmget (IPC_PRIVATE, 4, IPC_CREAT | 0777);
-	    if (id == -1)
-	      exit (2);
-	      shmaddr = shmat (id, 0, 0);
-	      shmctl (id, IPC_RMID, 0);
-	      if ((char*) shmat (id, 0, 0) == (char*) -1)
-	      {
-		shmdt (shmaddr);
-		exit (1);
-	      }
-	      shmdt (shmaddr);
-	      shmdt (shmaddr);
-	      exit (0);
-	    }
-	
-EOF
-if { (eval echo configure:2723: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
-then
-  cat >> confdefs.h <<\EOF
-#define IPC_RMID_DEFERRED_RELEASE 1
-EOF
-
-	echo "$ac_t""yes" 1>&6
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -fr conftest*
-  echo "$ac_t""no" 1>&6
-fi
-rm -fr conftest*
-fi
-
-      echo $ac_n "checking whether SHM_LOCK is available""... $ac_c" 1>&6
-echo "configure:2740: checking whether SHM_LOCK is available" >&5
-      cat > conftest.$ac_ext <<EOF
-#line 2742 "configure"
-#include "confdefs.h"
-#include <sys/types.h>
-	    #include <sys/ipc.h>
-	    #include <sys/shm.h>
 int main() {
 
-	    int foo( int shm_id ) {  shmctl(shm_id, SHM_LOCK, 0); }
-	    
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_catgets) || defined (__stub___catgets)
+choke me
+#else
+catgets();
+#endif
+
 ; return 0; }
 EOF
-if { (eval echo configure:2753: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:2750: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  cat >> confdefs.h <<\EOF
-#define IPC_HAVE_SHM_LOCK 1
-EOF
-
-	echo "$ac_t""yes" 1>&6
+  eval "ac_cv_func_catgets=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  echo "$ac_t""no" 1>&6
+  eval "ac_cv_func_catgets=no"
 fi
 rm -f conftest*
-    fi
-  
-if test "$ac_cv_header_sys_shm_h" = "yes"; then
+fi
+
+if eval "test \"`echo '$ac_cv_func_'catgets`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
   cat >> confdefs.h <<\EOF
-#define USE_SHM_COPROCESSING 1
+#define HAVE_CATGETS 1
 EOF
 
+	       INTLOBJS="\$(CATOBJS)"
+	       # Extract the first word of "gencat", so it can be a program name with args.
+set dummy gencat; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2772: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_GENCAT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$GENCAT" in
+  /*)
+  ac_cv_path_GENCAT="$GENCAT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_GENCAT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_GENCAT" && ac_cv_path_GENCAT="no"
+  ;;
+esac
 fi
-
-if test "$try_dev_random" = yes ; then
-echo $ac_n "checking for random device""... $ac_c" 1>&6
-echo "configure:2778: checking for random device" >&5
-if eval "test \"`echo '$''{'ac_cv_have_dev_random'+set}'`\" = set"; then
+GENCAT="$ac_cv_path_GENCAT"
+if test -n "$GENCAT"; then
+  echo "$ac_t""$GENCAT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+	       if test "$GENCAT" != "no"; then
+		 # Extract the first word of "gmsgfmt", so it can be a program name with args.
+set dummy gmsgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2804: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  if test -c "$NAME_OF_DEV_RANDOM" && test -c "$NAME_OF_DEV_URANDOM" ; then
-  ac_cv_have_dev_random=yes; else ac_cv_have_dev_random=no; fi
+  case "$GMSGFMT" in
+  /*)
+  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="no"
+  ;;
+esac
+fi
+GMSGFMT="$ac_cv_path_GMSGFMT"
+if test -n "$GMSGFMT"; then
+  echo "$ac_t""$GMSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
 fi
 
-echo "$ac_t""$ac_cv_have_dev_random" 1>&6
-if test "$ac_cv_have_dev_random" = yes; then
-    cat >> confdefs.h <<\EOF
-#define HAVE_DEV_RANDOM 1
-EOF
+		 if test "$GMSGFMT" = "no"; then
+		   # Extract the first word of "msgfmt", so it can be a program name with args.
+set dummy msgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2837: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$GMSGFMT" in
+  /*)
+  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"; then
+	ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
+	break
+      fi
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="no"
+  ;;
+esac
+fi
+GMSGFMT="$ac_cv_path_GMSGFMT"
+if test -n "$GMSGFMT"; then
+  echo "$ac_t""$GMSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
 
+		 fi
+		 # Extract the first word of "xgettext", so it can be a program name with args.
+set dummy xgettext; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2872: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$XGETTEXT" in
+  /*)
+  ac_cv_path_XGETTEXT="$XGETTEXT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"; then
+	ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
+	break
+      fi
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_XGETTEXT" && ac_cv_path_XGETTEXT=":"
+  ;;
+esac
 fi
+XGETTEXT="$ac_cv_path_XGETTEXT"
+if test -n "$XGETTEXT"; then
+  echo "$ac_t""$XGETTEXT" 1>&6
 else
-    echo $ac_n "checking for random device""... $ac_c" 1>&6
-echo "configure:2795: checking for random device" >&5
-    ac_cv_have_dev_random=no
-    echo "$ac_t""has been disabled" 1>&6
+  echo "$ac_t""no" 1>&6
 fi
 
+		 USE_INCLUDED_LIBINTL=yes
+		 CATOBJEXT=.cat
+		 INSTOBJEXT=.cat
+		 DATADIRNAME=lib
+		 INTLDEPS='$(top_builddir)/intl/libintl.a'
+		 INTLLIBS=$INTLDEPS
+		 LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+		 nls_cv_header_intl=intl/libintl.h
+		 nls_cv_header_libgt=intl/libgettext.h
+	       fi
+else
+  echo "$ac_t""no" 1>&6
+fi
 
-echo $ac_n "checking for mpi assembler functions""... $ac_c" 1>&6
-echo "configure:2802: checking for mpi assembler functions" >&5
-if test -f $srcdir/mpi/config.links ; then
-    . $srcdir/mpi/config.links
-     if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="$mpi_ln_src"
-	wk_link_files_dst="$mpi_ln_dst"
-    else
-	wk_link_files_src="$wk_link_files_src $mpi_ln_src"
-	wk_link_files_dst="$wk_link_files_dst $mpi_ln_dst"
+	  fi
+	fi
+
+	if test "$CATOBJEXT" = "NONE"; then
+	  	  	  nls_cv_use_gnu_gettext=yes
+	fi
+      fi
+
+      if test "$nls_cv_use_gnu_gettext" = "yes"; then
+		INTLOBJS="\$(GETTOBJS)"
+	# Extract the first word of "msgfmt", so it can be a program name with args.
+set dummy msgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2930: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$MSGFMT" in
+  /*)
+  ac_cv_path_MSGFMT="$MSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"; then
+	ac_cv_path_MSGFMT="$ac_dir/$ac_word"
+	break
+      fi
     fi
-  
-    ac_cv_mpi_extra_asm_modules="$mpi_extra_modules"
-    ac_cv_mpi_config_done="yes"
-    echo "$ac_t""done" 1>&6
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_MSGFMT" && ac_cv_path_MSGFMT="msgfmt"
+  ;;
+esac
+fi
+MSGFMT="$ac_cv_path_MSGFMT"
+if test -n "$MSGFMT"; then
+  echo "$ac_t""$MSGFMT" 1>&6
 else
-    echo "$ac_t""failed" 1>&6
-    { echo "configure: error: mpi/config.links missing!" 1>&2; exit 1; }
+  echo "$ac_t""no" 1>&6
 fi
-MPI_EXTRA_ASM_OBJS=""
-if test "$ac_cv_mpi_extra_asm_modules" != ""; then
- echo $ac_n "mpi extra asm functions:"" $ac_c" 1>&6
-  
-for i in $ac_cv_mpi_extra_asm_modules; do
-     echo $ac_n "$i"" $ac_c" 1>&6
-  
-    MPI_EXTRA_ASM_OBJS="$MPI_EXTRA_ASM_OBJS $i.o"
-done
-echo "$ac_t""" 1>&6
+
+	# Extract the first word of "gmsgfmt", so it can be a program name with args.
+set dummy gmsgfmt; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2964: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$GMSGFMT" in
+  /*)
+  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="$MSGFMT"
+  ;;
+esac
+fi
+GMSGFMT="$ac_cv_path_GMSGFMT"
+if test -n "$GMSGFMT"; then
+  echo "$ac_t""$GMSGFMT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+
+	# Extract the first word of "xgettext", so it can be a program name with args.
+set dummy xgettext; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:2996: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$XGETTEXT" in
+  /*)
+  ac_cv_path_XGETTEXT="$XGETTEXT" # Let the user override the test with a path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
+  for ac_dir in $PATH; do
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"; then
+	ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
+	break
+      fi
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_XGETTEXT" && ac_cv_path_XGETTEXT=":"
+  ;;
+esac
+fi
+XGETTEXT="$ac_cv_path_XGETTEXT"
+if test -n "$XGETTEXT"; then
+  echo "$ac_t""$XGETTEXT" 1>&6
+else
+  echo "$ac_t""no" 1>&6
 fi
 
+	
+	USE_INCLUDED_LIBINTL=yes
+	CATOBJEXT=.gmo
+	INSTOBJEXT=.mo
+	DATADIRNAME=share
+	INTLDEPS='$(top_builddir)/intl/libintl.a'
+	INTLLIBS=$INTLDEPS
+	LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+	nls_cv_header_intl=intl/libintl.h
+	nls_cv_header_libgt=intl/libgettext.h
+      fi
 
-if test "$g10_force_zlib" = "yes"; then
-    ZLIBS="../zlib/libzlib.a"
-    
+            if test "$XGETTEXT" != ":"; then
+			if $XGETTEXT --omit-header /dev/null 2> /dev/null; then
+	  : ;
+	else
+	  echo "$ac_t""found xgettext program is not GNU xgettext; ignore it" 1>&6
+	  XGETTEXT=":"
+	fi
+      fi
 
-if true; then
-  ENABLE_LOCAL_ZLIB_TRUE=
-  ENABLE_LOCAL_ZLIB_FALSE='#'
-else
-  ENABLE_LOCAL_ZLIB_TRUE='#'
-  ENABLE_LOCAL_ZLIB_FALSE=
-fi
-     if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="zlib/zlib.h"
-	wk_link_files_dst="zlib.h "
+      # We need to process the po/ directory.
+      POSUB=po
     else
-	wk_link_files_src="$wk_link_files_src zlib/zlib.h"
-	wk_link_files_dst="$wk_link_files_dst zlib.h "
+      DATADIRNAME=share
+      nls_cv_header_intl=intl/libintl.h
+      nls_cv_header_libgt=intl/libgettext.h
     fi
-  
-     if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="zlib/zconf.h"
-	wk_link_files_dst="zconf.h "
-    else
-	wk_link_files_src="$wk_link_files_src zlib/zconf.h"
-	wk_link_files_dst="$wk_link_files_dst zconf.h "
+    
+    
+
+
+    # If this is used in GNU gettext we have to set USE_NLS to `yes'
+    # because some of the sources are only built for this goal.
+    if test "$PACKAGE" = gettext; then
+      USE_NLS=yes
+      USE_INCLUDED_LIBINTL=yes
     fi
+
+                for lang in $ALL_LINGUAS; do
+      GMOFILES="$GMOFILES $lang.gmo"
+      POFILES="$POFILES $lang.po"
+    done
+
+        
+    
+    
+    
+    
+    
+    
+    
+    
+    
+    
   
-else
-for ac_hdr in zlib.h
-do
-ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
-echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2865: checking for $ac_hdr" >&5
+
+   if test "x$CATOBJEXT" != "x"; then
+     if test "x$ALL_LINGUAS" = "x"; then
+       LINGUAS=
+     else
+       echo $ac_n "checking for catalogs to be installed""... $ac_c" 1>&6
+echo "configure:3089: checking for catalogs to be installed" >&5
+       NEW_LINGUAS=
+       for lang in ${LINGUAS=$ALL_LINGUAS}; do
+	 case "$ALL_LINGUAS" in
+	  *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
+	 esac
+       done
+       LINGUAS=$NEW_LINGUAS
+       echo "$ac_t""$LINGUAS" 1>&6
+     fi
+
+          if test -n "$LINGUAS"; then
+       for lang in $LINGUAS; do CATALOGS="$CATALOGS $lang$CATOBJEXT"; done
+     fi
+   fi
+
+            if test $ac_cv_header_locale_h = yes; then
+     INCLUDE_LOCALE_H="#include <locale.h>"
+   else
+     INCLUDE_LOCALE_H="\
+/* The system does not provide the header <locale.h>.  Take care yourself.  */"
+   fi
+   
+
+            test -d intl || mkdir intl
+   if test "$CATOBJEXT" = ".cat"; then
+     ac_safe=`echo "linux/version.h" | sed 'y%./+-%__p_%'`
+echo $ac_n "checking for linux/version.h""... $ac_c" 1>&6
+echo "configure:3117: checking for linux/version.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2870 "configure"
+#line 3122 "configure"
 #include "confdefs.h"
-#include <$ac_hdr>
+#include <linux/version.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2875: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3127: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2887,330 +3139,345 @@
 fi
 if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
   echo "$ac_t""yes" 1>&6
-    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_hdr 1
-EOF
- 
+  msgformat=linux
 else
   echo "$ac_t""no" 1>&6
+msgformat=xopen
 fi
-done
-
-if test "$ac_cv_header_zlib_h" = yes ; then
-    LIBS="$LIBS -lz"
-    ZLIBS=
-    
 
-if false; then
-  ENABLE_LOCAL_ZLIB_TRUE=
-  ENABLE_LOCAL_ZLIB_FALSE='#'
-else
-  ENABLE_LOCAL_ZLIB_TRUE='#'
-  ENABLE_LOCAL_ZLIB_FALSE=
-fi
-else
-    ZLIBS="../zlib/libzlib.a"
-    
 
-if true; then
-  ENABLE_LOCAL_ZLIB_TRUE=
-  ENABLE_LOCAL_ZLIB_FALSE='#'
-else
-  ENABLE_LOCAL_ZLIB_TRUE='#'
-  ENABLE_LOCAL_ZLIB_FALSE=
-fi
-     if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="zlib/zlib.h"
-	wk_link_files_dst="zlib.h "
-    else
-	wk_link_files_src="$wk_link_files_src zlib/zlib.h"
-	wk_link_files_dst="$wk_link_files_dst zlib.h "
-    fi
-  
-     if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="zlib/zconf.h"
-	wk_link_files_dst="zconf.h "
-    else
-	wk_link_files_src="$wk_link_files_src zlib/zconf.h"
-	wk_link_files_dst="$wk_link_files_dst zconf.h "
-    fi
-  
-fi
-fi
+               sed -e '/^#/d' $srcdir/intl/$msgformat-msg.sed > intl/po2msg.sed
+   fi
+      sed -e '/^#.*[^\\]$/d' -e '/^#$/d' \
+     $srcdir/intl/po2tbl.sed.in > intl/po2tbl.sed
 
+            if test "$PACKAGE" = "gettext"; then
+     GT_NO="#NO#"
+     GT_YES=
+   else
+     GT_NO=
+     GT_YES="#YES#"
+   fi
+   
+   
 
+            MKINSTALLDIRS=
+   if test -n "$ac_aux_dir"; then
+     MKINSTALLDIRS="$ac_aux_dir/mkinstalldirs"
+   fi
+   if test -z "$MKINSTALLDIRS"; then
+     MKINSTALLDIRS="\$(top_srcdir)/mkinstalldirs"
+   fi
+   
 
- if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="$nls_cv_header_libgt"
-	wk_link_files_dst="$nls_cv_header_intl "
-    else
-	wk_link_files_src="$wk_link_files_src $nls_cv_header_libgt"
-	wk_link_files_dst="$wk_link_files_dst $nls_cv_header_intl "
-    fi
-  
+      l=
+   
 
- 
+         test -d po || mkdir po
+   if test "x$srcdir" != "x."; then
+     if test "x`echo $srcdir | sed 's@/.*@@'`" = "x"; then
+       posrcprefix="$srcdir/"
+     else
+       posrcprefix="../$srcdir/"
+     fi
+   else
+     posrcprefix="../"
+   fi
+   rm -f po/POTFILES
+   sed -e "/^#/d" -e "/^\$/d" -e "s,.*, $posrcprefix& \\\\," -e "\$s/\(.*\) \\\\/\1/" \
+	< $srcdir/po/POTFILES.in > po/POTFILES
   
 
-echo $ac_n "checking for off_t""... $ac_c" 1>&6
-echo "configure:2958: checking for off_t" >&5
-if eval "test \"`echo '$''{'ac_cv_type_off_t'+set}'`\" = set"; then
+echo $ac_n "checking for gdbm_firstkey in -lgdbm""... $ac_c" 1>&6
+echo "configure:3193: checking for gdbm_firstkey in -lgdbm" >&5
+ac_lib_var=`echo gdbm'_'gdbm_firstkey | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  cat > conftest.$ac_ext <<EOF
-#line 2963 "configure"
+  ac_save_LIBS="$LIBS"
+LIBS="-lgdbm  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 3201 "configure"
 #include "confdefs.h"
-#include <sys/types.h>
-#if STDC_HEADERS
-#include <stdlib.h>
-#include <stddef.h>
-#endif
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char gdbm_firstkey();
+
+int main() {
+gdbm_firstkey()
+; return 0; }
 EOF
-if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
-  egrep "off_t[^a-zA-Z_0-9]" >/dev/null 2>&1; then
+if { (eval echo configure:3212: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  ac_cv_type_off_t=yes
+  eval "ac_cv_lib_$ac_lib_var=yes"
 else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
   rm -rf conftest*
-  ac_cv_type_off_t=no
+  eval "ac_cv_lib_$ac_lib_var=no"
 fi
 rm -f conftest*
+LIBS="$ac_save_LIBS"
 
 fi
-echo "$ac_t""$ac_cv_type_off_t" 1>&6
-if test $ac_cv_type_off_t = no; then
-  cat >> confdefs.h <<\EOF
-#define off_t long
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_lib=HAVE_LIB`echo gdbm | sed -e 's/[^a-zA-Z0-9_]/_/g' \
+    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_lib 1
 EOF
 
+  LIBS="-lgdbm $LIBS"
+
+else
+  echo "$ac_t""no" 1>&6
 fi
 
-# The Ultrix 4.2 mips builtin alloca declared by alloca.h only works
-# for constant arguments.  Useless!
-echo $ac_n "checking for working alloca.h""... $ac_c" 1>&6
-echo "configure:2993: checking for working alloca.h" >&5
-if eval "test \"`echo '$''{'ac_cv_header_alloca_h'+set}'`\" = set"; then
+
+if test "$try_dynload" = yes ; then
+echo $ac_n "checking for dlopen in -ldl""... $ac_c" 1>&6
+echo "configure:3242: checking for dlopen in -ldl" >&5
+ac_lib_var=`echo dl'_'dlopen | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  cat > conftest.$ac_ext <<EOF
-#line 2998 "configure"
+  ac_save_LIBS="$LIBS"
+LIBS="-ldl  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 3250 "configure"
 #include "confdefs.h"
-#include <alloca.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char dlopen();
+
 int main() {
-char *p = alloca(2 * sizeof(int));
+dlopen()
 ; return 0; }
 EOF
-if { (eval echo configure:3005: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3261: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  ac_cv_header_alloca_h=yes
+  eval "ac_cv_lib_$ac_lib_var=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  ac_cv_header_alloca_h=no
+  eval "ac_cv_lib_$ac_lib_var=no"
 fi
 rm -f conftest*
+LIBS="$ac_save_LIBS"
+
+fi
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_lib=HAVE_LIB`echo dl | sed -e 's/[^a-zA-Z0-9_]/_/g' \
+    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_lib 1
+EOF
+
+  LIBS="-ldl $LIBS"
+
+else
+  echo "$ac_t""no" 1>&6
 fi
 
-echo "$ac_t""$ac_cv_header_alloca_h" 1>&6
-if test $ac_cv_header_alloca_h = yes; then
+if test "$ac_cv_lib_dl_dlopen" = "yes"; then
   cat >> confdefs.h <<\EOF
-#define HAVE_ALLOCA_H 1
+#define USE_DYNAMIC_LINKING 1
 EOF
 
-fi
+  cat >> confdefs.h <<\EOF
+#define HAVE_DL_DLOPEN 1
+EOF
 
-echo $ac_n "checking for alloca""... $ac_c" 1>&6
-echo "configure:3026: checking for alloca" >&5
-if eval "test \"`echo '$''{'ac_cv_func_alloca_works'+set}'`\" = set"; then
+  DYNLINK_LDFLAGS=-rdynamic
+  use_gnupg_extensions=yes
+else
+echo $ac_n "checking for dld_link in -ldld""... $ac_c" 1>&6
+echo "configure:3301: checking for dld_link in -ldld" >&5
+ac_lib_var=`echo dld'_'dld_link | sed 'y%./+-%__p_%'`
+if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  cat > conftest.$ac_ext <<EOF
-#line 3031 "configure"
+  ac_save_LIBS="$LIBS"
+LIBS="-ldld  $LIBS"
+cat > conftest.$ac_ext <<EOF
+#line 3309 "configure"
 #include "confdefs.h"
-
-#ifdef __GNUC__
-# define alloca __builtin_alloca
-#else
-# if HAVE_ALLOCA_H
-#  include <alloca.h>
-# else
-#  ifdef _AIX
- #pragma alloca
-#  else
-#   ifndef alloca /* predefined by HP cc +Olibcalls */
-char *alloca ();
-#   endif
-#  endif
-# endif
-#endif
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char dld_link();
 
 int main() {
-char *p = (char *) alloca(1);
+dld_link()
 ; return 0; }
 EOF
-if { (eval echo configure:3054: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3320: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  ac_cv_func_alloca_works=yes
+  eval "ac_cv_lib_$ac_lib_var=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  ac_cv_func_alloca_works=no
+  eval "ac_cv_lib_$ac_lib_var=no"
 fi
 rm -f conftest*
-fi
+LIBS="$ac_save_LIBS"
 
-echo "$ac_t""$ac_cv_func_alloca_works" 1>&6
-if test $ac_cv_func_alloca_works = yes; then
-  cat >> confdefs.h <<\EOF
-#define HAVE_ALLOCA 1
+fi
+if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_lib=HAVE_LIB`echo dld | sed -e 's/[^a-zA-Z0-9_]/_/g' \
+    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_lib 1
 EOF
 
+  LIBS="-ldld $LIBS"
+
+else
+  echo "$ac_t""no" 1>&6
 fi
 
-if test $ac_cv_func_alloca_works = no; then
-  # The SVR3 libPW and SVR4 libucb both contain incompatible functions
-  # that cause trouble.  Some versions do not even contain alloca or
-  # contain a buggy version.  If you still want to use their alloca,
-  # use ar to extract alloca.o from them instead of compiling alloca.c.
-  ALLOCA=alloca.o
+if test "$ac_cv_lib_dld_dld_link" = "yes"; then
   cat >> confdefs.h <<\EOF
-#define C_ALLOCA 1
+#define USE_DYNAMIC_LINKING 1
 EOF
 
+  cat >> confdefs.h <<\EOF
+#define HAVE_DLD_DLD_LINK 1
+EOF
 
-echo $ac_n "checking whether alloca needs Cray hooks""... $ac_c" 1>&6
-echo "configure:3086: checking whether alloca needs Cray hooks" >&5
-if eval "test \"`echo '$''{'ac_cv_os_cray'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
+  DYNLINK_LDFLAGS=-rdynamic
+  use_gnupg_extensions=yes
+fi
+fi
 else
-  cat > conftest.$ac_ext <<EOF
-#line 3091 "configure"
-#include "confdefs.h"
-#if defined(CRAY) && ! defined(CRAY2)
-webecray
-#else
-wenotbecray
-#endif
+  echo $ac_n "checking for dynamic loading""... $ac_c" 1>&6
+echo "configure:3362: checking for dynamic loading" >&5
+  DYNLINK_LDFLAGS=
+  DYNLINK_MOD_CFLAGS=
+  use_gnupg_extensions=no
+  echo "$ac_t""has been disabled" 1>&6
+fi
 
-EOF
-if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
-  egrep "webecray" >/dev/null 2>&1; then
-  rm -rf conftest*
-  ac_cv_os_cray=yes
+
+
+if test "$use_gnupg_extensions" = yes ; then
+  ENABLE_GNUPG_EXTENSIONS_TRUE=
+  ENABLE_GNUPG_EXTENSIONS_FALSE='#'
 else
-  rm -rf conftest*
-  ac_cv_os_cray=no
+  ENABLE_GNUPG_EXTENSIONS_TRUE='#'
+  ENABLE_GNUPG_EXTENSIONS_FALSE=
 fi
-rm -f conftest*
 
-fi
 
-echo "$ac_t""$ac_cv_os_cray" 1>&6
-if test $ac_cv_os_cray = yes; then
-for ac_func in _getb67 GETB67 getb67; do
-  echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3116: checking for $ac_func" >&5
-if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+
+
+echo $ac_n "checking for ANSI C header files""... $ac_c" 1>&6
+echo "configure:3383: checking for ANSI C header files" >&5
+if eval "test \"`echo '$''{'ac_cv_header_stdc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3121 "configure"
+#line 3388 "configure"
 #include "confdefs.h"
-/* System header to define __stub macros and hopefully few prototypes,
-    which can conflict with char $ac_func(); below.  */
-#include <assert.h>
-/* Override any gcc2 internal prototype to avoid an error.  */
-/* We use char because int might match the return type of a gcc2
-    builtin and then its argument prototype would still apply.  */
-char $ac_func();
-
-int main() {
-
-/* The GNU C library defines this for functions which it implements
-    to always fail with ENOSYS.  Some functions are actually named
-    something starting with __ and the normal name is an alias.  */
-#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
-choke me
-#else
-$ac_func();
-#endif
-
-; return 0; }
+#include <stdlib.h>
+#include <stdarg.h>
+#include <string.h>
+#include <float.h>
 EOF
-if { (eval echo configure:3144: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
+{ (eval echo configure:3396: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+ac_err=`grep -v '^ *+' conftest.out`
+if test -z "$ac_err"; then
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=yes"
+  ac_cv_header_stdc=yes
 else
+  echo "$ac_err" >&5
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=no"
+  ac_cv_header_stdc=no
 fi
 rm -f conftest*
-fi
 
-if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-  cat >> confdefs.h <<EOF
-#define CRAY_STACKSEG_END $ac_func
+if test $ac_cv_header_stdc = yes; then
+  # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
+cat > conftest.$ac_ext <<EOF
+#line 3413 "configure"
+#include "confdefs.h"
+#include <string.h>
 EOF
-
-  break
+if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
+  egrep "memchr" >/dev/null 2>&1; then
+  :
 else
-  echo "$ac_t""no" 1>&6
+  rm -rf conftest*
+  ac_cv_header_stdc=no
 fi
+rm -f conftest*
 
-done
 fi
 
-echo $ac_n "checking stack direction for C alloca""... $ac_c" 1>&6
-echo "configure:3171: checking stack direction for C alloca" >&5
-if eval "test \"`echo '$''{'ac_cv_c_stack_direction'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  if test "$cross_compiling" = yes; then
-  ac_cv_c_stack_direction=0
-else
-  cat > conftest.$ac_ext <<EOF
-#line 3179 "configure"
+if test $ac_cv_header_stdc = yes; then
+  # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
+cat > conftest.$ac_ext <<EOF
+#line 3431 "configure"
 #include "confdefs.h"
-find_stack_direction ()
-{
-  static char *addr = 0;
-  auto char dummy;
-  if (addr == 0)
-    {
-      addr = &dummy;
-      return find_stack_direction ();
-    }
-  else
-    return (&dummy > addr) ? 1 : -1;
-}
-main ()
-{
-  exit (find_stack_direction() < 0);
-}
+#include <stdlib.h>
+EOF
+if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
+  egrep "free" >/dev/null 2>&1; then
+  :
+else
+  rm -rf conftest*
+  ac_cv_header_stdc=no
+fi
+rm -f conftest*
+
+fi
+
+if test $ac_cv_header_stdc = yes; then
+  # /bin/cc in Irix-4.0.5 gets non-ANSI ctype macros unless using -ansi.
+if test "$cross_compiling" = yes; then
+  :
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3452 "configure"
+#include "confdefs.h"
+#include <ctype.h>
+#define ISLOWER(c) ('a' <= (c) && (c) <= 'z')
+#define TOUPPER(c) (ISLOWER(c) ? 'A' + ((c) - 'a') : (c))
+#define XOR(e, f) (((e) && !(f)) || (!(e) && (f)))
+int main () { int i; for (i = 0; i < 256; i++)
+if (XOR (islower (i), ISLOWER (i)) || toupper (i) != TOUPPER (i)) exit(2);
+exit (0); }
+
 EOF
-if { (eval echo configure:3198: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:3463: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
-  ac_cv_c_stack_direction=1
+  :
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -fr conftest*
-  ac_cv_c_stack_direction=-1
+  ac_cv_header_stdc=no
 fi
 rm -fr conftest*
 fi
 
 fi
+fi
 
-echo "$ac_t""$ac_cv_c_stack_direction" 1>&6
-cat >> confdefs.h <<EOF
-#define STACK_DIRECTION $ac_cv_c_stack_direction
+echo "$ac_t""$ac_cv_header_stdc" 1>&6
+if test $ac_cv_header_stdc = yes; then
+  cat >> confdefs.h <<\EOF
+#define STDC_HEADERS 1
 EOF
 
 fi
@@ -3219,17 +3486,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:3223: checking for $ac_hdr" >&5
+echo "configure:3490: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3228 "configure"
+#line 3495 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3233: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3500: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -3255,662 +3522,764 @@
 fi
 done
 
-for ac_func in getpagesize
-do
-echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3262: checking for $ac_func" >&5
-if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+
+
+echo $ac_n "checking for working const""... $ac_c" 1>&6
+echo "configure:3529: checking for working const" >&5
+if eval "test \"`echo '$''{'ac_cv_c_const'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3267 "configure"
+#line 3534 "configure"
 #include "confdefs.h"
-/* System header to define __stub macros and hopefully few prototypes,
-    which can conflict with char $ac_func(); below.  */
-#include <assert.h>
-/* Override any gcc2 internal prototype to avoid an error.  */
-/* We use char because int might match the return type of a gcc2
-    builtin and then its argument prototype would still apply.  */
-char $ac_func();
 
 int main() {
 
-/* The GNU C library defines this for functions which it implements
-    to always fail with ENOSYS.  Some functions are actually named
-    something starting with __ and the normal name is an alias.  */
-#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
-choke me
-#else
-$ac_func();
-#endif
+/* Ultrix mips cc rejects this.  */
+typedef int charset[2]; const charset x;
+/* SunOS 4.1.1 cc rejects this.  */
+char const *const *ccp;
+char **p;
+/* NEC SVR4.0.2 mips cc rejects this.  */
+struct point {int x, y;};
+static struct point const zero = {0,0};
+/* AIX XL C 1.02.0.0 rejects this.
+   It does not let you subtract one const X* pointer from another in an arm
+   of an if-expression whose if-part is not a constant expression */
+const char *g = "string";
+ccp = &g + (g ? g-g : 0);
+/* HPUX 7.0 cc rejects these. */
+++ccp;
+p = (char**) ccp;
+ccp = (char const *const *) p;
+{ /* SCO 3.2v4 cc rejects this.  */
+  char *t;
+  char const *s = 0 ? (char *) 0 : (char const *) 0;
+
+  *t++ = 0;
+}
+{ /* Someone thinks the Sun supposedly-ANSI compiler will reject this.  */
+  int x[] = {25, 17};
+  const int *foo = &x[0];
+  ++foo;
+}
+{ /* Sun SC1.0 ANSI compiler rejects this -- but not the above. */
+  typedef const int *iptr;
+  iptr p = 0;
+  ++p;
+}
+{ /* AIX XL C 1.02.0.0 rejects this saying
+     "k.c", line 2.27: 1506-025 (S) Operand must be a modifiable lvalue. */
+  struct s { int j; const int *ap[3]; };
+  struct s *b; b->j = 5;
+}
+{ /* ULTRIX-32 V3.1 (Rev 9) vcc rejects this */
+  const int foo = 10;
+}
 
 ; return 0; }
 EOF
-if { (eval echo configure:3290: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3583: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=yes"
+  ac_cv_c_const=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=no"
+  ac_cv_c_const=no
 fi
 rm -f conftest*
 fi
 
-if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_func 1
+echo "$ac_t""$ac_cv_c_const" 1>&6
+if test $ac_cv_c_const = no; then
+  cat >> confdefs.h <<\EOF
+#define const 
 EOF
- 
-else
-  echo "$ac_t""no" 1>&6
+
 fi
-done
 
-echo $ac_n "checking for working mmap""... $ac_c" 1>&6
-echo "configure:3315: checking for working mmap" >&5
-if eval "test \"`echo '$''{'ac_cv_func_mmap_fixed_mapped'+set}'`\" = set"; then
+echo $ac_n "checking for inline""... $ac_c" 1>&6
+echo "configure:3604: checking for inline" >&5
+if eval "test \"`echo '$''{'ac_cv_c_inline'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  if test "$cross_compiling" = yes; then
-  ac_cv_func_mmap_fixed_mapped=no
-else
+  ac_cv_c_inline=no
+for ac_kw in inline __inline__ __inline; do
   cat > conftest.$ac_ext <<EOF
-#line 3323 "configure"
+#line 3611 "configure"
 #include "confdefs.h"
 
-/* Thanks to Mike Haertel and Jim Avera for this test.
-   Here is a matrix of mmap possibilities:
-	mmap private not fixed
-	mmap private fixed at somewhere currently unmapped
-	mmap private fixed at somewhere already mapped
-	mmap shared not fixed
-	mmap shared fixed at somewhere currently unmapped
-	mmap shared fixed at somewhere already mapped
-   For private mappings, we should verify that changes cannot be read()
-   back from the file, nor mmap's back from the file at a different
-   address.  (There have been systems where private was not correctly
-   implemented like the infamous i386 svr4.0, and systems where the
-   VM page cache was not coherent with the filesystem buffer cache
-   like early versions of FreeBSD and possibly contemporary NetBSD.)
-   For shared mappings, we should conversely verify that changes get
-   propogated back to all the places they're supposed to be.
+int main() {
+} $ac_kw foo() {
+; return 0; }
+EOF
+if { (eval echo configure:3618: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  ac_cv_c_inline=$ac_kw; break
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+fi
+rm -f conftest*
+done
 
-   Grep wants private fixed already mapped.
-   The main things grep needs to know about mmap are:
-   * does it exist and is it safe to write into the mmap'd area
-   * how to use it (BSD variants)  */
+fi
+
+echo "$ac_t""$ac_cv_c_inline" 1>&6
+case "$ac_cv_c_inline" in
+  inline | yes) ;;
+  no) cat >> confdefs.h <<\EOF
+#define inline 
+EOF
+ ;;
+  *)  cat >> confdefs.h <<EOF
+#define inline $ac_cv_c_inline
+EOF
+ ;;
+esac
+
+echo $ac_n "checking for size_t""... $ac_c" 1>&6
+echo "configure:3644: checking for size_t" >&5
+if eval "test \"`echo '$''{'ac_cv_type_size_t'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3649 "configure"
+#include "confdefs.h"
 #include <sys/types.h>
-#include <fcntl.h>
-#include <sys/mman.h>
+#if STDC_HEADERS
+#include <stdlib.h>
+#include <stddef.h>
+#endif
+EOF
+if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
+  egrep "size_t[^a-zA-Z_0-9]" >/dev/null 2>&1; then
+  rm -rf conftest*
+  ac_cv_type_size_t=yes
+else
+  rm -rf conftest*
+  ac_cv_type_size_t=no
+fi
+rm -f conftest*
 
-/* This mess was copied from the GNU getpagesize.h.  */
-#ifndef HAVE_GETPAGESIZE
-# ifdef HAVE_UNISTD_H
-#  include <unistd.h>
-# endif
+fi
+echo "$ac_t""$ac_cv_type_size_t" 1>&6
+if test $ac_cv_type_size_t = no; then
+  cat >> confdefs.h <<\EOF
+#define size_t unsigned
+EOF
 
-/* Assume that all systems that can run configure have sys/param.h.  */
-# ifndef HAVE_SYS_PARAM_H
-#  define HAVE_SYS_PARAM_H 1
-# endif
+fi
 
-# ifdef _SC_PAGESIZE
-#  define getpagesize() sysconf(_SC_PAGESIZE)
-# else /* no _SC_PAGESIZE */
-#  ifdef HAVE_SYS_PARAM_H
-#   include <sys/param.h>
-#   ifdef EXEC_PAGESIZE
-#    define getpagesize() EXEC_PAGESIZE
-#   else /* no EXEC_PAGESIZE */
-#    ifdef NBPG
-#     define getpagesize() NBPG * CLSIZE
-#     ifndef CLSIZE
-#      define CLSIZE 1
-#     endif /* no CLSIZE */
-#    else /* no NBPG */
-#     ifdef NBPC
-#      define getpagesize() NBPC
-#     else /* no NBPC */
-#      ifdef PAGESIZE
-#       define getpagesize() PAGESIZE
-#      endif /* PAGESIZE */
-#     endif /* no NBPC */
-#    endif /* no NBPG */
-#   endif /* no EXEC_PAGESIZE */
-#  else /* no HAVE_SYS_PARAM_H */
-#   define getpagesize() 8192	/* punt totally */
-#  endif /* no HAVE_SYS_PARAM_H */
-# endif /* no _SC_PAGESIZE */
+echo $ac_n "checking return type of signal handlers""... $ac_c" 1>&6
+echo "configure:3677: checking return type of signal handlers" >&5
+if eval "test \"`echo '$''{'ac_cv_type_signal'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3682 "configure"
+#include "confdefs.h"
+#include <sys/types.h>
+#include <signal.h>
+#ifdef signal
+#undef signal
+#endif
+#ifdef __cplusplus
+extern "C" void (*signal (int, void (*)(int)))(int);
+#else
+void (*signal ()) ();
+#endif
+
+int main() {
+int i;
+; return 0; }
+EOF
+if { (eval echo configure:3699: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  ac_cv_type_signal=void
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  ac_cv_type_signal=int
+fi
+rm -f conftest*
+fi
 
-#endif /* no HAVE_GETPAGESIZE */
+echo "$ac_t""$ac_cv_type_signal" 1>&6
+cat >> confdefs.h <<EOF
+#define RETSIGTYPE $ac_cv_type_signal
+EOF
 
-#ifdef __cplusplus
-extern "C" { void *malloc(unsigned); }
-#else
-char *malloc();
+
+echo $ac_n "checking for sys_siglist declaration in signal.h or unistd.h""... $ac_c" 1>&6
+echo "configure:3718: checking for sys_siglist declaration in signal.h or unistd.h" >&5
+if eval "test \"`echo '$''{'ac_cv_decl_sys_siglist'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3723 "configure"
+#include "confdefs.h"
+#include <sys/types.h>
+#include <signal.h>
+/* NetBSD declares sys_siglist in unistd.h.  */
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
 #endif
+int main() {
+char *msg = *(sys_siglist + 1);
+; return 0; }
+EOF
+if { (eval echo configure:3735: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  ac_cv_decl_sys_siglist=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  ac_cv_decl_sys_siglist=no
+fi
+rm -f conftest*
+fi
 
-int
-main()
-{
-	char *data, *data2, *data3;
-	int i, pagesize;
-	int fd;
+echo "$ac_t""$ac_cv_decl_sys_siglist" 1>&6
+if test $ac_cv_decl_sys_siglist = yes; then
+  cat >> confdefs.h <<\EOF
+#define SYS_SIGLIST_DECLARED 1
+EOF
 
-	pagesize = getpagesize();
+fi
 
-	/*
-	 * First, make a file with some known garbage in it.
-	 */
-	data = malloc(pagesize);
-	if (!data)
-		exit(1);
-	for (i = 0; i < pagesize; ++i)
-		*(data + i) = rand();
-	umask(0);
-	fd = creat("conftestmmap", 0600);
-	if (fd < 0)
-		exit(1);
-	if (write(fd, data, pagesize) != pagesize)
-		exit(1);
-	close(fd);
 
-	/*
-	 * Next, try to mmap the file at a fixed address which
-	 * already has something else allocated at it.  If we can,
-	 * also make sure that we see the same garbage.
-	 */
-	fd = open("conftestmmap", O_RDWR);
-	if (fd < 0)
-		exit(1);
-	data2 = malloc(2 * pagesize);
-	if (!data2)
-		exit(1);
-	data2 += (pagesize - ((int) data2 & (pagesize - 1))) & (pagesize - 1);
-	if (data2 != mmap(data2, pagesize, PROT_READ | PROT_WRITE,
-	    MAP_PRIVATE | MAP_FIXED, fd, 0L))
-		exit(1);
-	for (i = 0; i < pagesize; ++i)
-		if (*(data + i) != *(data2 + i))
-			exit(1);
+ if test "$cross_compiling" = yes; then
+	echo "configure: warning: cross compiling; assuming little endianess" 1>&2
+    fi
+    echo $ac_n "checking endianess""... $ac_c" 1>&6
+echo "configure:3760: checking endianess" >&5
+    if eval "test \"`echo '$''{'wk_cv_c_endian'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+   wk_cv_c_endian=unknown
+	# See if sys/param.h defines the BYTE_ORDER macro.
+	cat > conftest.$ac_ext <<EOF
+#line 3767 "configure"
+#include "confdefs.h"
+#include <sys/types.h>
+	#include <sys/param.h>
+int main() {
 
-	/*
-	 * Finally, make sure that changes to the mapped area
-	 * do not percolate back to the file as seen by read().
-	 * (This is a bug on some variants of i386 svr4.0.)
-	 */
-	for (i = 0; i < pagesize; ++i)
-		*(data2 + i) = *(data2 + i) + 1;
-	data3 = malloc(pagesize);
-	if (!data3)
-		exit(1);
-	if (read(fd, data3, pagesize) != pagesize)
-		exit(1);
-	for (i = 0; i < pagesize; ++i)
-		if (*(data + i) != *(data3 + i))
-			exit(1);
-	close(fd);
-	unlink("conftestmmap");
-	exit(0);
-}
+	#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
+	 bogus endian macros
+	#endif
+; return 0; }
+EOF
+if { (eval echo configure:3778: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  # It does; now see whether it defined to BIG_ENDIAN or not.
+	cat > conftest.$ac_ext <<EOF
+#line 3782 "configure"
+#include "confdefs.h"
+#include <sys/types.h>
+	#include <sys/param.h>
+int main() {
 
+	#if BYTE_ORDER != BIG_ENDIAN
+	 not big endian
+	#endif
+; return 0; }
 EOF
-if { (eval echo configure:3463: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:3793: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  wk_cv_c_endian=big
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  wk_cv_c_endian=little
+fi
+rm -f conftest*
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+fi
+rm -f conftest*
+	if test "$wk_cv_c_endian" = unknown; then
+	    if test "$cross_compiling" = yes; then
+  wk_cv_c_endian=little
+	    
+else
+  cat > conftest.$ac_ext <<EOF
+#line 3814 "configure"
+#include "confdefs.h"
+main () {
+	      /* Are we little or big endian?  From Harbison&Steele.  */
+	      union
+	      {
+		long l;
+		char c[sizeof (long)];
+	      } u;
+	      u.l = 1;
+	      exit (u.c[sizeof (long) - 1] == 1);
+	      }
+EOF
+if { (eval echo configure:3827: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
-  ac_cv_func_mmap_fixed_mapped=yes
+  wk_cv_c_endian=little
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -fr conftest*
-  ac_cv_func_mmap_fixed_mapped=no
+  wk_cv_c_endian=big
 fi
 rm -fr conftest*
 fi
 
+	fi
+      
 fi
 
-echo "$ac_t""$ac_cv_func_mmap_fixed_mapped" 1>&6
-if test $ac_cv_func_mmap_fixed_mapped = yes; then
-  cat >> confdefs.h <<\EOF
-#define HAVE_MMAP 1
+    echo "$ac_t""$wk_cv_c_endian" 1>&6
+    if test "$wk_cv_c_endian" = little; then
+      cat >> confdefs.h <<\EOF
+#define LITTLE_ENDIAN_HOST 1
 EOF
 
-fi
+    else
+      cat >> confdefs.h <<\EOF
+#define BIG_ENDIAN_HOST 1
+EOF
 
-                              
-   for ac_hdr in argz.h limits.h locale.h nl_types.h malloc.h string.h \
-unistd.h sys/param.h
-do
-ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
-echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:3491: checking for $ac_hdr" >&5
-if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
+    fi
+  
+
+
+ echo $ac_n "checking for byte typedef""... $ac_c" 1>&6
+echo "configure:3859: checking for byte typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_byte'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3496 "configure"
+#line 3864 "configure"
 #include "confdefs.h"
-#include <$ac_hdr>
+#include <stdlib.h>
+    #include <sys/types.h>
+int main() {
+
+    #undef byte
+    int a = sizeof(byte);
+    
+; return 0; }
 EOF
-ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3501: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
-ac_err=`grep -v '^ *+' conftest.out`
-if test -z "$ac_err"; then
+if { (eval echo configure:3875: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
-  eval "ac_cv_header_$ac_safe=yes"
+  wk_cv_typedef_byte=yes
 else
-  echo "$ac_err" >&5
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_header_$ac_safe=no"
+  wk_cv_typedef_byte=no 
 fi
 rm -f conftest*
 fi
-if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_hdr 1
+
+    echo "$ac_t""$wk_cv_typedef_byte" 1>&6
+    if test "$wk_cv_typedef_byte" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_BYTE_TYPEDEF 1
 EOF
- 
+
+    fi
+  
+ echo $ac_n "checking for ushort typedef""... $ac_c" 1>&6
+echo "configure:3896: checking for ushort typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_ushort'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
 else
-  echo "$ac_t""no" 1>&6
+  cat > conftest.$ac_ext <<EOF
+#line 3901 "configure"
+#include "confdefs.h"
+#include <stdlib.h>
+    #include <sys/types.h>
+int main() {
+
+    #undef ushort
+    int a = sizeof(ushort);
+    
+; return 0; }
+EOF
+if { (eval echo configure:3912: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  wk_cv_typedef_ushort=yes
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  wk_cv_typedef_ushort=no 
 fi
-done
+rm -f conftest*
+fi
+
+    echo "$ac_t""$wk_cv_typedef_ushort" 1>&6
+    if test "$wk_cv_typedef_ushort" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_USHORT_TYPEDEF 1
+EOF
 
-   for ac_func in getcwd munmap putenv setenv setlocale strchr strcasecmp \
-strdup __argz_count __argz_stringify __argz_next
-do
-echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3531: checking for $ac_func" >&5
-if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+    fi
+  
+ echo $ac_n "checking for ulong typedef""... $ac_c" 1>&6
+echo "configure:3933: checking for ulong typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_ulong'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3536 "configure"
+#line 3938 "configure"
 #include "confdefs.h"
-/* System header to define __stub macros and hopefully few prototypes,
-    which can conflict with char $ac_func(); below.  */
-#include <assert.h>
-/* Override any gcc2 internal prototype to avoid an error.  */
-/* We use char because int might match the return type of a gcc2
-    builtin and then its argument prototype would still apply.  */
-char $ac_func();
-
+#include <stdlib.h>
+    #include <sys/types.h>
 int main() {
 
-/* The GNU C library defines this for functions which it implements
-    to always fail with ENOSYS.  Some functions are actually named
-    something starting with __ and the normal name is an alias.  */
-#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
-choke me
-#else
-$ac_func();
-#endif
-
+    #undef ulong
+    int a = sizeof(ulong);
+    
 ; return 0; }
 EOF
-if { (eval echo configure:3559: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3949: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=yes"
+  wk_cv_typedef_ulong=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=no"
+  wk_cv_typedef_ulong=no 
 fi
 rm -f conftest*
 fi
 
-if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_func 1
+    echo "$ac_t""$wk_cv_typedef_ulong" 1>&6
+    if test "$wk_cv_typedef_ulong" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_ULONG_TYPEDEF 1
 EOF
- 
-else
-  echo "$ac_t""no" 1>&6
-fi
-done
 
-
-   if test "${ac_cv_func_stpcpy+set}" != "set"; then
-     for ac_func in stpcpy
-do
-echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3588: checking for $ac_func" >&5
-if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
+    fi
+  
+ echo $ac_n "checking for u16 typedef""... $ac_c" 1>&6
+echo "configure:3970: checking for u16 typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_u16'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3593 "configure"
+#line 3975 "configure"
 #include "confdefs.h"
-/* System header to define __stub macros and hopefully few prototypes,
-    which can conflict with char $ac_func(); below.  */
-#include <assert.h>
-/* Override any gcc2 internal prototype to avoid an error.  */
-/* We use char because int might match the return type of a gcc2
-    builtin and then its argument prototype would still apply.  */
-char $ac_func();
-
+#include <stdlib.h>
+    #include <sys/types.h>
 int main() {
 
-/* The GNU C library defines this for functions which it implements
-    to always fail with ENOSYS.  Some functions are actually named
-    something starting with __ and the normal name is an alias.  */
-#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
-choke me
-#else
-$ac_func();
-#endif
-
+    #undef u16
+    int a = sizeof(u16);
+    
 ; return 0; }
 EOF
-if { (eval echo configure:3616: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3986: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=yes"
+  wk_cv_typedef_u16=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_func_$ac_func=no"
+  wk_cv_typedef_u16=no 
 fi
 rm -f conftest*
 fi
 
-if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_func 1
-EOF
- 
-else
-  echo "$ac_t""no" 1>&6
-fi
-done
-
-   fi
-   if test "${ac_cv_func_stpcpy}" = "yes"; then
-     cat >> confdefs.h <<\EOF
-#define HAVE_STPCPY 1
+    echo "$ac_t""$wk_cv_typedef_u16" 1>&6
+    if test "$wk_cv_typedef_u16" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_U16_TYPEDEF 1
 EOF
 
-   fi
-
-   if test $ac_cv_header_locale_h = yes; then
-    echo $ac_n "checking for LC_MESSAGES""... $ac_c" 1>&6
-echo "configure:3650: checking for LC_MESSAGES" >&5
-if eval "test \"`echo '$''{'am_cv_val_LC_MESSAGES'+set}'`\" = set"; then
+    fi
+  
+ echo $ac_n "checking for u32 typedef""... $ac_c" 1>&6
+echo "configure:4007: checking for u32 typedef" >&5
+    if eval "test \"`echo '$''{'wk_cv_typedef_u32'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3655 "configure"
+#line 4012 "configure"
 #include "confdefs.h"
-#include <locale.h>
+#include <stdlib.h>
+    #include <sys/types.h>
 int main() {
-return LC_MESSAGES
+
+    #undef u32
+    int a = sizeof(u32);
+    
 ; return 0; }
 EOF
-if { (eval echo configure:3662: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:4023: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
-  am_cv_val_LC_MESSAGES=yes
+  wk_cv_typedef_u32=yes
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  am_cv_val_LC_MESSAGES=no
+  wk_cv_typedef_u32=no 
 fi
 rm -f conftest*
 fi
 
-echo "$ac_t""$am_cv_val_LC_MESSAGES" 1>&6
-    if test $am_cv_val_LC_MESSAGES = yes; then
-      cat >> confdefs.h <<\EOF
-#define HAVE_LC_MESSAGES 1
+    echo "$ac_t""$wk_cv_typedef_u32" 1>&6
+    if test "$wk_cv_typedef_u32" = yes; then
+	cat >> confdefs.h <<\EOF
+#define HAVE_U32_TYPEDEF 1
 EOF
 
     fi
-  fi
-   echo $ac_n "checking whether NLS is requested""... $ac_c" 1>&6
-echo "configure:3683: checking whether NLS is requested" >&5
-        # Check whether --enable-nls or --disable-nls was given.
-if test "${enable_nls+set}" = set; then
-  enableval="$enable_nls"
-  USE_NLS=$enableval
-else
-  USE_NLS=yes
-fi
-
-    echo "$ac_t""$USE_NLS" 1>&6
-    
-
-    USE_INCLUDED_LIBINTL=no
+  
 
-        if test "$USE_NLS" = "yes"; then
-      cat >> confdefs.h <<\EOF
-#define ENABLE_NLS 1
+echo $ac_n "checking size of unsigned short""... $ac_c" 1>&6
+echo "configure:4045: checking size of unsigned short" >&5
+if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_short'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  if test "$cross_compiling" = yes; then
+  ac_cv_sizeof_unsigned_short=2
+else
+  cat > conftest.$ac_ext <<EOF
+#line 4053 "configure"
+#include "confdefs.h"
+#include <stdio.h>
+main()
+{
+  FILE *f=fopen("conftestval", "w");
+  if (!f) exit(1);
+  fprintf(f, "%d\n", sizeof(unsigned short));
+  exit(0);
+}
 EOF
-
-      echo $ac_n "checking whether included gettext is requested""... $ac_c" 1>&6
-echo "configure:3703: checking whether included gettext is requested" >&5
-      # Check whether --with-included-gettext or --without-included-gettext was given.
-if test "${with_included_gettext+set}" = set; then
-  withval="$with_included_gettext"
-  nls_cv_force_use_gnu_gettext=$withval
+if { (eval echo configure:4064: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+then
+  ac_cv_sizeof_unsigned_short=`cat conftestval`
 else
-  nls_cv_force_use_gnu_gettext=no
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -fr conftest*
+  ac_cv_sizeof_unsigned_short=0
+fi
+rm -fr conftest*
 fi
 
-      echo "$ac_t""$nls_cv_force_use_gnu_gettext" 1>&6
+fi
+echo "$ac_t""$ac_cv_sizeof_unsigned_short" 1>&6
+cat >> confdefs.h <<EOF
+#define SIZEOF_UNSIGNED_SHORT $ac_cv_sizeof_unsigned_short
+EOF
 
-      nls_cv_use_gnu_gettext="$nls_cv_force_use_gnu_gettext"
-      if test "$nls_cv_force_use_gnu_gettext" != "yes"; then
-					nls_cv_header_intl=
-	nls_cv_header_libgt=
-	CATOBJEXT=NONE
 
-	ac_safe=`echo "libintl.h" | sed 'y%./+-%__p_%'`
-echo $ac_n "checking for libintl.h""... $ac_c" 1>&6
-echo "configure:3722: checking for libintl.h" >&5
-if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
+echo $ac_n "checking size of unsigned int""... $ac_c" 1>&6
+echo "configure:4084: checking size of unsigned int" >&5
+if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_int'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
+  if test "$cross_compiling" = yes; then
+  ac_cv_sizeof_unsigned_int=4
+else
   cat > conftest.$ac_ext <<EOF
-#line 3727 "configure"
+#line 4092 "configure"
 #include "confdefs.h"
-#include <libintl.h>
+#include <stdio.h>
+main()
+{
+  FILE *f=fopen("conftestval", "w");
+  if (!f) exit(1);
+  fprintf(f, "%d\n", sizeof(unsigned int));
+  exit(0);
+}
 EOF
-ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3732: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
-ac_err=`grep -v '^ *+' conftest.out`
-if test -z "$ac_err"; then
-  rm -rf conftest*
-  eval "ac_cv_header_$ac_safe=yes"
+if { (eval echo configure:4103: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+then
+  ac_cv_sizeof_unsigned_int=`cat conftestval`
 else
-  echo "$ac_err" >&5
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  eval "ac_cv_header_$ac_safe=no"
+  rm -fr conftest*
+  ac_cv_sizeof_unsigned_int=0
 fi
-rm -f conftest*
+rm -fr conftest*
 fi
-if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-  echo $ac_n "checking for gettext in libc""... $ac_c" 1>&6
-echo "configure:3749: checking for gettext in libc" >&5
-if eval "test \"`echo '$''{'gt_cv_func_gettext_libc'+set}'`\" = set"; then
+
+fi
+echo "$ac_t""$ac_cv_sizeof_unsigned_int" 1>&6
+cat >> confdefs.h <<EOF
+#define SIZEOF_UNSIGNED_INT $ac_cv_sizeof_unsigned_int
+EOF
+
+
+echo $ac_n "checking size of unsigned long""... $ac_c" 1>&6
+echo "configure:4123: checking size of unsigned long" >&5
+if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_long'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
+  if test "$cross_compiling" = yes; then
+  ac_cv_sizeof_unsigned_long=4
+else
   cat > conftest.$ac_ext <<EOF
-#line 3754 "configure"
+#line 4131 "configure"
 #include "confdefs.h"
-#include <libintl.h>
-int main() {
-return (int) gettext ("")
-; return 0; }
+#include <stdio.h>
+main()
+{
+  FILE *f=fopen("conftestval", "w");
+  if (!f) exit(1);
+  fprintf(f, "%d\n", sizeof(unsigned long));
+  exit(0);
+}
 EOF
-if { (eval echo configure:3761: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
-  rm -rf conftest*
-  gt_cv_func_gettext_libc=yes
+if { (eval echo configure:4142: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+then
+  ac_cv_sizeof_unsigned_long=`cat conftestval`
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  gt_cv_func_gettext_libc=no
+  rm -fr conftest*
+  ac_cv_sizeof_unsigned_long=0
 fi
-rm -f conftest*
+rm -fr conftest*
 fi
 
-echo "$ac_t""$gt_cv_func_gettext_libc" 1>&6
+fi
+echo "$ac_t""$ac_cv_sizeof_unsigned_long" 1>&6
+cat >> confdefs.h <<EOF
+#define SIZEOF_UNSIGNED_LONG $ac_cv_sizeof_unsigned_long
+EOF
 
-	   if test "$gt_cv_func_gettext_libc" != "yes"; then
-	     echo $ac_n "checking for bindtextdomain in -lintl""... $ac_c" 1>&6
-echo "configure:3777: checking for bindtextdomain in -lintl" >&5
-ac_lib_var=`echo intl'_'bindtextdomain | sed 'y%./+-%__p_%'`
-if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
+
+
+if test "$ac_cv_sizeof_unsigned_short" = "0" \
+   || test "$ac_cv_sizeof_unsigned_int" = "0" \
+   || test "$ac_cv_sizeof_unsigned_long" = "0"; then
+    echo "configure: warning: Hmmm, something is wrong with the sizes - using defaults" 1>&2;
+fi
+
+
+
+echo $ac_n "checking for vprintf""... $ac_c" 1>&6
+echo "configure:4171: checking for vprintf" >&5
+if eval "test \"`echo '$''{'ac_cv_func_vprintf'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  ac_save_LIBS="$LIBS"
-LIBS="-lintl  $LIBS"
-cat > conftest.$ac_ext <<EOF
-#line 3785 "configure"
+  cat > conftest.$ac_ext <<EOF
+#line 4176 "configure"
 #include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char vprintf(); below.  */
+#include <assert.h>
 /* Override any gcc2 internal prototype to avoid an error.  */
 /* We use char because int might match the return type of a gcc2
     builtin and then its argument prototype would still apply.  */
-char bindtextdomain();
+char vprintf();
 
 int main() {
-bindtextdomain()
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_vprintf) || defined (__stub___vprintf)
+choke me
+#else
+vprintf();
+#endif
+
 ; return 0; }
 EOF
-if { (eval echo configure:3796: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:4199: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=yes"
+  eval "ac_cv_func_vprintf=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=no"
+  eval "ac_cv_func_vprintf=no"
 fi
 rm -f conftest*
-LIBS="$ac_save_LIBS"
-
 fi
-if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+
+if eval "test \"`echo '$ac_cv_func_'vprintf`\" = yes"; then
   echo "$ac_t""yes" 1>&6
-  echo $ac_n "checking for gettext in libintl""... $ac_c" 1>&6
-echo "configure:3812: checking for gettext in libintl" >&5
-if eval "test \"`echo '$''{'gt_cv_func_gettext_libintl'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
+  cat >> confdefs.h <<\EOF
+#define HAVE_VPRINTF 1
+EOF
+
 else
-  echo $ac_n "checking for gettext in -lintl""... $ac_c" 1>&6
-echo "configure:3817: checking for gettext in -lintl" >&5
-ac_lib_var=`echo intl'_'gettext | sed 'y%./+-%__p_%'`
-if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
+  echo "$ac_t""no" 1>&6
+fi
+
+if test "$ac_cv_func_vprintf" != yes; then
+echo $ac_n "checking for _doprnt""... $ac_c" 1>&6
+echo "configure:4223: checking for _doprnt" >&5
+if eval "test \"`echo '$''{'ac_cv_func__doprnt'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  ac_save_LIBS="$LIBS"
-LIBS="-lintl  $LIBS"
-cat > conftest.$ac_ext <<EOF
-#line 3825 "configure"
+  cat > conftest.$ac_ext <<EOF
+#line 4228 "configure"
 #include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char _doprnt(); below.  */
+#include <assert.h>
 /* Override any gcc2 internal prototype to avoid an error.  */
 /* We use char because int might match the return type of a gcc2
     builtin and then its argument prototype would still apply.  */
-char gettext();
+char _doprnt();
 
 int main() {
-gettext()
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub__doprnt) || defined (__stub____doprnt)
+choke me
+#else
+_doprnt();
+#endif
+
 ; return 0; }
 EOF
-if { (eval echo configure:3836: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:4251: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=yes"
+  eval "ac_cv_func__doprnt=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=no"
+  eval "ac_cv_func__doprnt=no"
 fi
 rm -f conftest*
-LIBS="$ac_save_LIBS"
-
-fi
-if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-  gt_cv_func_gettext_libintl=yes
-else
-  echo "$ac_t""no" 1>&6
-gt_cv_func_gettext_libintl=no
 fi
 
-fi
+if eval "test \"`echo '$ac_cv_func_'_doprnt`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+  cat >> confdefs.h <<\EOF
+#define HAVE_DOPRNT 1
+EOF
 
-echo "$ac_t""$gt_cv_func_gettext_libintl" 1>&6
 else
   echo "$ac_t""no" 1>&6
 fi
 
-	   fi
-
-	   if test "$gt_cv_func_gettext_libc" = "yes" \
-	      || test "$gt_cv_func_gettext_libintl" = "yes"; then
-	      cat >> confdefs.h <<\EOF
-#define HAVE_GETTEXT 1
-EOF
-
-	      # Extract the first word of "msgfmt", so it can be a program name with args.
-set dummy msgfmt; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3875: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  case "$MSGFMT" in
-  /*)
-  ac_cv_path_MSGFMT="$MSGFMT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS=   }"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"; then
-	ac_cv_path_MSGFMT="$ac_dir/$ac_word"
-	break
-      fi
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_MSGFMT" && ac_cv_path_MSGFMT="no"
-  ;;
-esac
-fi
-MSGFMT="$ac_cv_path_MSGFMT"
-if test -n "$MSGFMT"; then
-  echo "$ac_t""$MSGFMT" 1>&6
-else
-  echo "$ac_t""no" 1>&6
 fi
-	      if test "$MSGFMT" != "no"; then
-		for ac_func in dcgettext
+
+for ac_func in strerror stpcpy strlwr tcgetattr rand strtoul mmap
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3909: checking for $ac_func" >&5
+echo "configure:4278: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3914 "configure"
+#line 4283 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3933,590 +4302,478 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3937: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:4306: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  eval "ac_cv_func_$ac_func=no"
-fi
-rm -f conftest*
-fi
-
-if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
-  echo "$ac_t""yes" 1>&6
-    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
-  cat >> confdefs.h <<EOF
-#define $ac_tr_func 1
-EOF
- 
-else
-  echo "$ac_t""no" 1>&6
-fi
-done
-
-		# Extract the first word of "gmsgfmt", so it can be a program name with args.
-set dummy gmsgfmt; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3964: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  case "$GMSGFMT" in
-  /*)
-  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
-      break
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="$MSGFMT"
-  ;;
-esac
-fi
-GMSGFMT="$ac_cv_path_GMSGFMT"
-if test -n "$GMSGFMT"; then
-  echo "$ac_t""$GMSGFMT" 1>&6
-else
-  echo "$ac_t""no" 1>&6
-fi
-
-		# Extract the first word of "xgettext", so it can be a program name with args.
-set dummy xgettext; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3996: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  case "$XGETTEXT" in
-  /*)
-  ac_cv_path_XGETTEXT="$XGETTEXT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS=   }"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"; then
-	ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
-	break
-      fi
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_XGETTEXT" && ac_cv_path_XGETTEXT=":"
-  ;;
-esac
-fi
-XGETTEXT="$ac_cv_path_XGETTEXT"
-if test -n "$XGETTEXT"; then
-  echo "$ac_t""$XGETTEXT" 1>&6
-else
-  echo "$ac_t""no" 1>&6
-fi
-
-		cat > conftest.$ac_ext <<EOF
-#line 4028 "configure"
-#include "confdefs.h"
-
-int main() {
-extern int _nl_msg_cat_cntr;
-			       return _nl_msg_cat_cntr
-; return 0; }
-EOF
-if { (eval echo configure:4036: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
-  rm -rf conftest*
-  CATOBJEXT=.gmo
-		   DATADIRNAME=share
-else
-  echo "configure: failed program was:" >&5
-  cat conftest.$ac_ext >&5
-  rm -rf conftest*
-  CATOBJEXT=.mo
-		   DATADIRNAME=lib
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=no"
 fi
 rm -f conftest*
-		INSTOBJEXT=.mo
-	      fi
-	    fi
-	
-else
-  echo "$ac_t""no" 1>&6
 fi
 
-
-	if test "$CATOBJEXT" = "NONE"; then
-	  echo $ac_n "checking whether catgets can be used""... $ac_c" 1>&6
-echo "configure:4059: checking whether catgets can be used" >&5
-	  # Check whether --with-catgets or --without-catgets was given.
-if test "${with_catgets+set}" = set; then
-  withval="$with_catgets"
-  nls_cv_use_catgets=$withval
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
+EOF
+ 
 else
-  nls_cv_use_catgets=no
+  echo "$ac_t""no" 1>&6
 fi
+done
 
-	  echo "$ac_t""$nls_cv_use_catgets" 1>&6
-
-	  if test "$nls_cv_use_catgets" = "yes"; then
-	    	    echo $ac_n "checking for main in -li""... $ac_c" 1>&6
-echo "configure:4072: checking for main in -li" >&5
-ac_lib_var=`echo i'_'main | sed 'y%./+-%__p_%'`
-if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
+for ac_func in memmove gettimeofday getrusage gethrtime setrlimit
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:4333: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  ac_save_LIBS="$LIBS"
-LIBS="-li  $LIBS"
-cat > conftest.$ac_ext <<EOF
-#line 4080 "configure"
+  cat > conftest.$ac_ext <<EOF
+#line 4338 "configure"
 #include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
 
 int main() {
-main()
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
+
 ; return 0; }
 EOF
-if { (eval echo configure:4087: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:4361: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=yes"
+  eval "ac_cv_func_$ac_func=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_lib_$ac_lib_var=no"
+  eval "ac_cv_func_$ac_func=no"
 fi
 rm -f conftest*
-LIBS="$ac_save_LIBS"
-
 fi
-if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
+
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
   echo "$ac_t""yes" 1>&6
-    ac_tr_lib=HAVE_LIB`echo i | sed -e 's/[^a-zA-Z0-9_]/_/g' \
-    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
   cat >> confdefs.h <<EOF
-#define $ac_tr_lib 1
+#define $ac_tr_func 1
 EOF
-
-  LIBS="-li $LIBS"
-
+ 
 else
   echo "$ac_t""no" 1>&6
 fi
+done
 
-	    echo $ac_n "checking for catgets""... $ac_c" 1>&6
-echo "configure:4115: checking for catgets" >&5
-if eval "test \"`echo '$''{'ac_cv_func_catgets'+set}'`\" = set"; then
+for ac_func in memicmp atexit raise getpagesize strftime
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:4388: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 4120 "configure"
+#line 4393 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
-    which can conflict with char catgets(); below.  */
+    which can conflict with char $ac_func(); below.  */
 #include <assert.h>
 /* Override any gcc2 internal prototype to avoid an error.  */
 /* We use char because int might match the return type of a gcc2
     builtin and then its argument prototype would still apply.  */
-char catgets();
+char $ac_func();
 
 int main() {
 
 /* The GNU C library defines this for functions which it implements
     to always fail with ENOSYS.  Some functions are actually named
     something starting with __ and the normal name is an alias.  */
-#if defined (__stub_catgets) || defined (__stub___catgets)
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
 choke me
 #else
-catgets();
+$ac_func();
 #endif
 
 ; return 0; }
 EOF
-if { (eval echo configure:4143: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:4416: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
-  eval "ac_cv_func_catgets=yes"
+  eval "ac_cv_func_$ac_func=yes"
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
-  eval "ac_cv_func_catgets=no"
+  eval "ac_cv_func_$ac_func=no"
 fi
 rm -f conftest*
 fi
 
-if eval "test \"`echo '$ac_cv_func_'catgets`\" = yes"; then
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
   echo "$ac_t""yes" 1>&6
-  cat >> confdefs.h <<\EOF
-#define HAVE_CATGETS 1
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
 EOF
-
-	       INTLOBJS="\$(CATOBJS)"
-	       # Extract the first word of "gencat", so it can be a program name with args.
-set dummy gencat; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:4165: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_GENCAT'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  case "$GENCAT" in
-  /*)
-  ac_cv_path_GENCAT="$GENCAT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      ac_cv_path_GENCAT="$ac_dir/$ac_word"
-      break
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_GENCAT" && ac_cv_path_GENCAT="no"
-  ;;
-esac
-fi
-GENCAT="$ac_cv_path_GENCAT"
-if test -n "$GENCAT"; then
-  echo "$ac_t""$GENCAT" 1>&6
+ 
 else
   echo "$ac_t""no" 1>&6
 fi
-	       if test "$GENCAT" != "no"; then
-		 # Extract the first word of "gmsgfmt", so it can be a program name with args.
-set dummy gmsgfmt; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:4197: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
+done
+
+
+ for ac_func in mlock
+do
+echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
+echo "configure:4444: checking for $ac_func" >&5
+if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  case "$GMSGFMT" in
-  /*)
-  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
-      break
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="no"
-  ;;
-esac
-fi
-GMSGFMT="$ac_cv_path_GMSGFMT"
-if test -n "$GMSGFMT"; then
-  echo "$ac_t""$GMSGFMT" 1>&6
-else
-  echo "$ac_t""no" 1>&6
-fi
+  cat > conftest.$ac_ext <<EOF
+#line 4449 "configure"
+#include "confdefs.h"
+/* System header to define __stub macros and hopefully few prototypes,
+    which can conflict with char $ac_func(); below.  */
+#include <assert.h>
+/* Override any gcc2 internal prototype to avoid an error.  */
+/* We use char because int might match the return type of a gcc2
+    builtin and then its argument prototype would still apply.  */
+char $ac_func();
 
-		 if test "$GMSGFMT" = "no"; then
-		   # Extract the first word of "msgfmt", so it can be a program name with args.
-set dummy msgfmt; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:4230: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
+int main() {
+
+/* The GNU C library defines this for functions which it implements
+    to always fail with ENOSYS.  Some functions are actually named
+    something starting with __ and the normal name is an alias.  */
+#if defined (__stub_$ac_func) || defined (__stub___$ac_func)
+choke me
+#else
+$ac_func();
+#endif
+
+; return 0; }
+EOF
+if { (eval echo configure:4472: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=yes"
 else
-  case "$GMSGFMT" in
-  /*)
-  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS=   }"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"; then
-	ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
-	break
-      fi
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="no"
-  ;;
-esac
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_func_$ac_func=no"
 fi
-GMSGFMT="$ac_cv_path_GMSGFMT"
-if test -n "$GMSGFMT"; then
-  echo "$ac_t""$GMSGFMT" 1>&6
-else
-  echo "$ac_t""no" 1>&6
+rm -f conftest*
 fi
 
-		 fi
-		 # Extract the first word of "xgettext", so it can be a program name with args.
-set dummy xgettext; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:4265: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
-else
-  case "$XGETTEXT" in
-  /*)
-  ac_cv_path_XGETTEXT="$XGETTEXT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS=   }"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"; then
-	ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
-	break
-      fi
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_XGETTEXT" && ac_cv_path_XGETTEXT=":"
-  ;;
-esac
-fi
-XGETTEXT="$ac_cv_path_XGETTEXT"
-if test -n "$XGETTEXT"; then
-  echo "$ac_t""$XGETTEXT" 1>&6
+if eval "test \"`echo '$ac_cv_func_'$ac_func`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_func=HAVE_`echo $ac_func | tr 'abcdefghijklmnopqrstuvwxyz' 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_func 1
+EOF
+ 
 else
   echo "$ac_t""no" 1>&6
 fi
+done
 
-		 USE_INCLUDED_LIBINTL=yes
-		 CATOBJEXT=.cat
-		 INSTOBJEXT=.cat
-		 DATADIRNAME=lib
-		 INTLDEPS='$(top_builddir)/intl/libintl.a'
-		 INTLLIBS=$INTLDEPS
-		 LIBS=`echo $LIBS | sed -e 's/-lintl//'`
-		 nls_cv_header_intl=intl/libintl.h
-		 nls_cv_header_libgt=intl/libgettext.h
-	       fi
+    if test "$ac_cv_func_mlock" = "yes"; then
+	echo $ac_n "checking whether mlock is broken""... $ac_c" 1>&6
+echo "configure:4498: checking whether mlock is broken" >&5
+	  if test "$cross_compiling" = yes; then
+  echo "$ac_t""assuming no" 1>&6
 else
+  cat > conftest.$ac_ext <<EOF
+#line 4503 "configure"
+#include "confdefs.h"
+
+		#include <stdlib.h>
+		#include <unistd.h>
+		#include <errno.h>
+		#include <sys/mman.h>
+		#include <sys/types.h>
+		#include <fcntl.h>
+
+		int main()
+		{
+		    char *pool;
+		    int err;
+		    long int pgsize = getpagesize();
+
+		    pool = malloc( 4096 + pgsize );
+		    if( !pool )
+			return 2;
+		    pool += (pgsize - ((long int)pool % pgsize));
+
+		    err = mlock( pool, 4096 );
+		    if( !err || errno == EPERM )
+			return 0; /* okay */
+
+		    return 1;  /* hmmm */
+		}
+
+	    
+EOF
+if { (eval echo configure:4533: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+then
   echo "$ac_t""no" 1>&6
-fi
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -fr conftest*
+  cat >> confdefs.h <<\EOF
+#define HAVE_BROKEN_MLOCK 1
+EOF
 
-	  fi
-	fi
+	    echo "$ac_t""yes" 1>&6
+fi
+rm -fr conftest*
+fi
 
-	if test "$CATOBJEXT" = "NONE"; then
-	  	  	  nls_cv_use_gnu_gettext=yes
-	fi
-      fi
+    fi
+  
 
-      if test "$nls_cv_use_gnu_gettext" = "yes"; then
-		INTLOBJS="\$(GETTOBJS)"
-	# Extract the first word of "msgfmt", so it can be a program name with args.
-set dummy msgfmt; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:4323: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
+ for ac_hdr in sys/ipc.h sys/shm.h
+do
+ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
+echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
+echo "configure:4556: checking for $ac_hdr" >&5
+if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  case "$MSGFMT" in
-  /*)
-  ac_cv_path_MSGFMT="$MSGFMT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS=   }"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"; then
-	ac_cv_path_MSGFMT="$ac_dir/$ac_word"
-	break
-      fi
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_MSGFMT" && ac_cv_path_MSGFMT="msgfmt"
-  ;;
-esac
+  cat > conftest.$ac_ext <<EOF
+#line 4561 "configure"
+#include "confdefs.h"
+#include <$ac_hdr>
+EOF
+ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
+{ (eval echo configure:4566: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+ac_err=`grep -v '^ *+' conftest.out`
+if test -z "$ac_err"; then
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=yes"
+else
+  echo "$ac_err" >&5
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
+  eval "ac_cv_header_$ac_safe=no"
 fi
-MSGFMT="$ac_cv_path_MSGFMT"
-if test -n "$MSGFMT"; then
-  echo "$ac_t""$MSGFMT" 1>&6
+rm -f conftest*
+fi
+if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
+  echo "$ac_t""yes" 1>&6
+    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_hdr 1
+EOF
+ 
 else
   echo "$ac_t""no" 1>&6
 fi
+done
 
-	# Extract the first word of "gmsgfmt", so it can be a program name with args.
-set dummy gmsgfmt; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:4357: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
-  echo $ac_n "(cached) $ac_c" 1>&6
+    if test "$ac_cv_header_sys_shm_h" = "yes"; then
+      echo $ac_n "checking whether shmctl IPC_RMID allowes subsequent attaches""... $ac_c" 1>&6
+echo "configure:4594: checking whether shmctl IPC_RMID allowes subsequent attaches" >&5
+      if test "$cross_compiling" = yes; then
+  echo "$ac_t""assuming no" 1>&6
 else
-  case "$GMSGFMT" in
-  /*)
-  ac_cv_path_GMSGFMT="$GMSGFMT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
-      break
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_GMSGFMT" && ac_cv_path_GMSGFMT="$MSGFMT"
-  ;;
-esac
+  cat > conftest.$ac_ext <<EOF
+#line 4599 "configure"
+#include "confdefs.h"
+
+	    #include <sys/types.h>
+	    #include <sys/ipc.h>
+	    #include <sys/shm.h>
+	    int main()
+	    {
+	      int id;
+	      char *shmaddr;
+	    id = shmget (IPC_PRIVATE, 4, IPC_CREAT | 0777);
+	    if (id == -1)
+	      exit (2);
+	      shmaddr = shmat (id, 0, 0);
+	      shmctl (id, IPC_RMID, 0);
+	      if ((char*) shmat (id, 0, 0) == (char*) -1)
+	      {
+		shmdt (shmaddr);
+		exit (1);
+	      }
+	      shmdt (shmaddr);
+	      shmdt (shmaddr);
+	      exit (0);
+	    }
+	
+EOF
+if { (eval echo configure:4625: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+then
+  cat >> confdefs.h <<\EOF
+#define IPC_RMID_DEFERRED_RELEASE 1
+EOF
+
+	echo "$ac_t""yes" 1>&6
+else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -fr conftest*
+  echo "$ac_t""no" 1>&6
 fi
-GMSGFMT="$ac_cv_path_GMSGFMT"
-if test -n "$GMSGFMT"; then
-  echo "$ac_t""$GMSGFMT" 1>&6
+rm -fr conftest*
+fi
+
+      echo $ac_n "checking whether SHM_LOCK is available""... $ac_c" 1>&6
+echo "configure:4642: checking whether SHM_LOCK is available" >&5
+      cat > conftest.$ac_ext <<EOF
+#line 4644 "configure"
+#include "confdefs.h"
+#include <sys/types.h>
+	    #include <sys/ipc.h>
+	    #include <sys/shm.h>
+int main() {
+
+	    int foo( int shm_id ) {  shmctl(shm_id, SHM_LOCK, 0); }
+	    
+; return 0; }
+EOF
+if { (eval echo configure:4655: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+  rm -rf conftest*
+  cat >> confdefs.h <<\EOF
+#define IPC_HAVE_SHM_LOCK 1
+EOF
+
+	echo "$ac_t""yes" 1>&6
 else
+  echo "configure: failed program was:" >&5
+  cat conftest.$ac_ext >&5
+  rm -rf conftest*
   echo "$ac_t""no" 1>&6
 fi
+rm -f conftest*
+    fi
+  
+if test "$ac_cv_header_sys_shm_h" = "yes"; then
+  cat >> confdefs.h <<\EOF
+#define USE_SHM_COPROCESSING 1
+EOF
+
+fi
 
-	# Extract the first word of "xgettext", so it can be a program name with args.
-set dummy xgettext; ac_word=$2
-echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:4389: checking for $ac_word" >&5
-if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
+if test "$try_dev_random" = yes ; then
+echo $ac_n "checking for random device""... $ac_c" 1>&6
+echo "configure:4680: checking for random device" >&5
+if eval "test \"`echo '$''{'ac_cv_have_dev_random'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
-  case "$XGETTEXT" in
-  /*)
-  ac_cv_path_XGETTEXT="$XGETTEXT" # Let the user override the test with a path.
-  ;;
-  *)
-  IFS="${IFS=   }"; ac_save_ifs="$IFS"; IFS="${IFS}:"
-  for ac_dir in $PATH; do
-    test -z "$ac_dir" && ac_dir=.
-    if test -f $ac_dir/$ac_word; then
-      if test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"; then
-	ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
-	break
-      fi
-    fi
-  done
-  IFS="$ac_save_ifs"
-  test -z "$ac_cv_path_XGETTEXT" && ac_cv_path_XGETTEXT=":"
-  ;;
-esac
+  if test -c "$NAME_OF_DEV_RANDOM" && test -c "$NAME_OF_DEV_URANDOM" ; then
+  ac_cv_have_dev_random=yes; else ac_cv_have_dev_random=no; fi
+fi
+
+echo "$ac_t""$ac_cv_have_dev_random" 1>&6
+if test "$ac_cv_have_dev_random" = yes; then
+    cat >> confdefs.h <<\EOF
+#define HAVE_DEV_RANDOM 1
+EOF
+
 fi
-XGETTEXT="$ac_cv_path_XGETTEXT"
-if test -n "$XGETTEXT"; then
-  echo "$ac_t""$XGETTEXT" 1>&6
 else
-  echo "$ac_t""no" 1>&6
+    echo $ac_n "checking for random device""... $ac_c" 1>&6
+echo "configure:4697: checking for random device" >&5
+    ac_cv_have_dev_random=no
+    echo "$ac_t""has been disabled" 1>&6
 fi
 
-	
-	USE_INCLUDED_LIBINTL=yes
-	CATOBJEXT=.gmo
-	INSTOBJEXT=.mo
-	DATADIRNAME=share
-	INTLDEPS='$(top_builddir)/intl/libintl.a'
-	INTLLIBS=$INTLDEPS
-	LIBS=`echo $LIBS | sed -e 's/-lintl//'`
-	nls_cv_header_intl=intl/libintl.h
-	nls_cv_header_libgt=intl/libgettext.h
-      fi
-
-            if test "$XGETTEXT" != ":"; then
-			if $XGETTEXT --omit-header /dev/null 2> /dev/null; then
-	  : ;
-	else
-	  echo "$ac_t""found xgettext program is not GNU xgettext; ignore it" 1>&6
-	  XGETTEXT=":"
-	fi
-      fi
 
-      # We need to process the po/ directory.
-      POSUB=po
+echo $ac_n "checking for mpi assembler functions""... $ac_c" 1>&6
+echo "configure:4704: checking for mpi assembler functions" >&5
+if test -f $srcdir/mpi/config.links ; then
+    . $srcdir/mpi/config.links
+     if test "x$wk_link_files_src" = "x"; then
+	wk_link_files_src="$mpi_ln_src"
+	wk_link_files_dst="$mpi_ln_dst"
     else
-      DATADIRNAME=share
-      nls_cv_header_intl=intl/libintl.h
-      nls_cv_header_libgt=intl/libgettext.h
-    fi
-    
-    
-
-
-    # If this is used in GNU gettext we have to set USE_NLS to `yes'
-    # because some of the sources are only built for this goal.
-    if test "$PACKAGE" = gettext; then
-      USE_NLS=yes
-      USE_INCLUDED_LIBINTL=yes
+	wk_link_files_src="$wk_link_files_src $mpi_ln_src"
+	wk_link_files_dst="$wk_link_files_dst $mpi_ln_dst"
     fi
-
-                for lang in $ALL_LINGUAS; do
-      GMOFILES="$GMOFILES $lang.gmo"
-      POFILES="$POFILES $lang.po"
-    done
-
-        
-    
-    
-    
-    
-    
-    
-    
-    
-    
-    
   
+    ac_cv_mpi_extra_asm_modules="$mpi_extra_modules"
+    ac_cv_mpi_config_done="yes"
+    echo "$ac_t""done" 1>&6
+else
+    echo "$ac_t""failed" 1>&6
+    { echo "configure: error: mpi/config.links missing!" 1>&2; exit 1; }
+fi
+MPI_EXTRA_ASM_OBJS=""
+if test "$ac_cv_mpi_extra_asm_modules" != ""; then
+ echo $ac_n "mpi extra asm functions:"" $ac_c" 1>&6
+  
+for i in $ac_cv_mpi_extra_asm_modules; do
+     echo $ac_n "$i"" $ac_c" 1>&6
+  
+    MPI_EXTRA_ASM_OBJS="$MPI_EXTRA_ASM_OBJS $i.o"
+done
+echo "$ac_t""" 1>&6
+fi
 
-   if test "x$CATOBJEXT" != "x"; then
-     if test "x$ALL_LINGUAS" = "x"; then
-       LINGUAS=
-     else
-       echo $ac_n "checking for catalogs to be installed""... $ac_c" 1>&6
-echo "configure:4482: checking for catalogs to be installed" >&5
-       NEW_LINGUAS=
-       for lang in ${LINGUAS=$ALL_LINGUAS}; do
-	 case "$ALL_LINGUAS" in
-	  *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
-	 esac
-       done
-       LINGUAS=$NEW_LINGUAS
-       echo "$ac_t""$LINGUAS" 1>&6
-     fi
-
-          if test -n "$LINGUAS"; then
-       for lang in $LINGUAS; do CATALOGS="$CATALOGS $lang$CATOBJEXT"; done
-     fi
-   fi
 
-            if test $ac_cv_header_locale_h = yes; then
-     INCLUDE_LOCALE_H="#include <locale.h>"
-   else
-     INCLUDE_LOCALE_H="\
-/* The system does not provide the header <locale.h>.  Take care yourself.  */"
-   fi
-   
+if test "$g10_force_zlib" = "yes"; then
+    ZLIBS="../zlib/libzlib.a"
+    
 
-            test -d intl || mkdir intl
-   if test "$CATOBJEXT" = ".cat"; then
-     ac_safe=`echo "linux/version.h" | sed 'y%./+-%__p_%'`
-echo $ac_n "checking for linux/version.h""... $ac_c" 1>&6
-echo "configure:4510: checking for linux/version.h" >&5
+if true; then
+  ENABLE_LOCAL_ZLIB_TRUE=
+  ENABLE_LOCAL_ZLIB_FALSE='#'
+else
+  ENABLE_LOCAL_ZLIB_TRUE='#'
+  ENABLE_LOCAL_ZLIB_FALSE=
+fi
+     if test "x$wk_link_files_src" = "x"; then
+	wk_link_files_src="zlib/zlib.h"
+	wk_link_files_dst="zlib.h "
+    else
+	wk_link_files_src="$wk_link_files_src zlib/zlib.h"
+	wk_link_files_dst="$wk_link_files_dst zlib.h "
+    fi
+  
+     if test "x$wk_link_files_src" = "x"; then
+	wk_link_files_src="zlib/zconf.h"
+	wk_link_files_dst="zconf.h "
+    else
+	wk_link_files_src="$wk_link_files_src zlib/zconf.h"
+	wk_link_files_dst="$wk_link_files_dst zconf.h "
+    fi
+  
+else
+for ac_hdr in zlib.h
+do
+ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
+echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
+echo "configure:4767: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 4515 "configure"
+#line 4772 "configure"
 #include "confdefs.h"
-#include <linux/version.h>
+#include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:4520: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:4777: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -4532,55 +4789,63 @@
 fi
 if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
   echo "$ac_t""yes" 1>&6
-  msgformat=linux
+    ac_tr_hdr=HAVE_`echo $ac_hdr | sed 'y%abcdefghijklmnopqrstuvwxyz./-%ABCDEFGHIJKLMNOPQRSTUVWXYZ___%'`
+  cat >> confdefs.h <<EOF
+#define $ac_tr_hdr 1
+EOF
+ 
 else
   echo "$ac_t""no" 1>&6
-msgformat=xopen
 fi
+done
 
+if test "$ac_cv_header_zlib_h" = yes ; then
+    LIBS="$LIBS -lz"
+    ZLIBS=
+    
 
-               sed -e '/^#/d' $srcdir/intl/$msgformat-msg.sed > intl/po2msg.sed
-   fi
-      sed -e '/^#.*[^\\]$/d' -e '/^#$/d' \
-     $srcdir/intl/po2tbl.sed.in > intl/po2tbl.sed
-
-            if test "$PACKAGE" = "gettext"; then
-     GT_NO="#NO#"
-     GT_YES=
-   else
-     GT_NO=
-     GT_YES="#YES#"
-   fi
-   
-   
+if false; then
+  ENABLE_LOCAL_ZLIB_TRUE=
+  ENABLE_LOCAL_ZLIB_FALSE='#'
+else
+  ENABLE_LOCAL_ZLIB_TRUE='#'
+  ENABLE_LOCAL_ZLIB_FALSE=
+fi
+else
+    ZLIBS="../zlib/libzlib.a"
+    
 
-            MKINSTALLDIRS=
-   if test -n "$ac_aux_dir"; then
-     MKINSTALLDIRS="$ac_aux_dir/mkinstalldirs"
-   fi
-   if test -z "$MKINSTALLDIRS"; then
-     MKINSTALLDIRS="\$(top_srcdir)/mkinstalldirs"
-   fi
-   
+if true; then
+  ENABLE_LOCAL_ZLIB_TRUE=
+  ENABLE_LOCAL_ZLIB_FALSE='#'
+else
+  ENABLE_LOCAL_ZLIB_TRUE='#'
+  ENABLE_LOCAL_ZLIB_FALSE=
+fi
+     if test "x$wk_link_files_src" = "x"; then
+	wk_link_files_src="zlib/zlib.h"
+	wk_link_files_dst="zlib.h "
+    else
+	wk_link_files_src="$wk_link_files_src zlib/zlib.h"
+	wk_link_files_dst="$wk_link_files_dst zlib.h "
+    fi
+  
+     if test "x$wk_link_files_src" = "x"; then
+	wk_link_files_src="zlib/zconf.h"
+	wk_link_files_dst="zconf.h "
+    else
+	wk_link_files_src="$wk_link_files_src zlib/zconf.h"
+	wk_link_files_dst="$wk_link_files_dst zconf.h "
+    fi
+  
+fi
+fi
 
-      l=
-   
 
-         test -d po || mkdir po
-   if test "x$srcdir" != "x."; then
-     if test "x`echo $srcdir | sed 's@/.*@@'`" = "x"; then
-       posrcprefix="$srcdir/"
-     else
-       posrcprefix="../$srcdir/"
-     fi
-   else
-     posrcprefix="../"
-   fi
-   rm -f po/POTFILES
-   sed -e "/^#/d" -e "/^\$/d" -e "s,.*, $posrcprefix& \\\\," -e "\$s/\(.*\) \\\\/\1/" \
-	< $srcdir/po/POTFILES.in > po/POTFILES
+ 
   
 
+
 trap '' 1 2 15
 cat > confcache <<\EOF
 # This file is a shell script that caches the results of configure
@@ -4751,14 +5016,6 @@
 s%@RANLIB@%$RANLIB%g
 s%@INSTALL_PROGRAM@%$INSTALL_PROGRAM%g
 s%@INSTALL_DATA@%$INSTALL_DATA%g
-s%@ENABLE_GNUPG_EXTENSIONS_TRUE@%$ENABLE_GNUPG_EXTENSIONS_TRUE%g
-s%@ENABLE_GNUPG_EXTENSIONS_FALSE@%$ENABLE_GNUPG_EXTENSIONS_FALSE%g
-s%@DYNLINK_LDFLAGS@%$DYNLINK_LDFLAGS%g
-s%@DYNLINK_MOD_CFLAGS@%$DYNLINK_MOD_CFLAGS%g
-s%@MPI_EXTRA_ASM_OBJS@%$MPI_EXTRA_ASM_OBJS%g
-s%@ENABLE_LOCAL_ZLIB_TRUE@%$ENABLE_LOCAL_ZLIB_TRUE%g
-s%@ENABLE_LOCAL_ZLIB_FALSE@%$ENABLE_LOCAL_ZLIB_FALSE%g
-s%@ZLIBS@%$ZLIBS%g
 s%@ALLOCA@%$ALLOCA%g
 s%@USE_NLS@%$USE_NLS%g
 s%@MSGFMT@%$MSGFMT%g
@@ -4781,6 +5038,14 @@
 s%@GT_YES@%$GT_YES%g
 s%@MKINSTALLDIRS@%$MKINSTALLDIRS%g
 s%@l@%$l%g
+s%@ENABLE_GNUPG_EXTENSIONS_TRUE@%$ENABLE_GNUPG_EXTENSIONS_TRUE%g
+s%@ENABLE_GNUPG_EXTENSIONS_FALSE@%$ENABLE_GNUPG_EXTENSIONS_FALSE%g
+s%@DYNLINK_LDFLAGS@%$DYNLINK_LDFLAGS%g
+s%@DYNLINK_MOD_CFLAGS@%$DYNLINK_MOD_CFLAGS%g
+s%@MPI_EXTRA_ASM_OBJS@%$MPI_EXTRA_ASM_OBJS%g
+s%@ENABLE_LOCAL_ZLIB_TRUE@%$ENABLE_LOCAL_ZLIB_TRUE%g
+s%@ENABLE_LOCAL_ZLIB_FALSE@%$ENABLE_LOCAL_ZLIB_FALSE%g
+s%@ZLIBS@%$ZLIBS%g
 
 CEOF
 EOF
@@ -5002,8 +5267,8 @@
 EOF
 
 cat >> $CONFIG_STATUS <<EOF
-ac_sources="$wk_link_files_src $nls_cv_header_libgt"
-ac_dests="$wk_link_files_dst  $nls_cv_header_intl"
+ac_sources="$nls_cv_header_libgt $wk_link_files_src"
+ac_dests="$nls_cv_header_intl $wk_link_files_dst "
 EOF
 
 cat >> $CONFIG_STATUS <<\EOF
@@ -5055,8 +5320,6 @@
 case "$CONFIG_FILES" in *po/Makefile.in*)
 	sed -e "/POTFILES =/r po/POTFILES" po/Makefile.in > po/Makefile
       esac
-echo timestamp >stamp-h; \
-   sed -e "/POTFILES =/r po/POTFILES" po/Makefile.in > po/Makefile
 
 exit 0
 EOF
diff -urN gnupg-0.4.2/configure.in gnupg-0.4.3/configure.in
--- gnupg-0.4.2/configure.in	Sat Oct 17 00:01:03 1998
+++ gnupg-0.4.3/configure.in	Tue Oct 27 19:32:35 1998
@@ -3,6 +3,9 @@
 dnl
 dnl (Process this file with autoconf to produce a configure script.)
 
+dnl Must reset CDPATH so that bash's cd does not print to stdout
+CDPATH=
+
 AC_INIT(g10/g10.c)
 AC_CONFIG_AUX_DIR(scripts)
 AM_CONFIG_HEADER(config.h)
@@ -10,7 +13,7 @@
 
 VERSION=`cat $srcdir/VERSION`
 PACKAGE=gnupg
-ALL_LINGUAS="en de it fr"
+ALL_LINGUAS="en de it fr ru"
 AC_SUBST(VERSION)
 AC_SUBST(PACKAGE)
 AC_DEFINE_UNQUOTED(VERSION, "$VERSION")
@@ -41,9 +44,9 @@
 fi
 if test "$use_m_guard" = yes ; then
     AC_DEFINE(M_GUARD)
-    CFLAGS="-g -Wall"
+    CFLAGS="$CFLAGS -g -Wall"
 else
-    CFLAGS="-O2 -Wall"
+    CFLAGS="$CFLAGS -O2 -Wall"
 fi
 
 
@@ -53,15 +56,12 @@
 [g10_force_zlib=yes], [g10_force_zlib=no] )
 AC_MSG_RESULT($g10_force_zlib)
 
-
-AC_CANONICAL_SYSTEM
-WK_CHECK_CACHE
-
 dnl Checks for programs.
 
-AC_PROG_MAKE_SET
+AC_CANONICAL_SYSTEM
 AC_ARG_PROGRAM
-
+AC_PROG_MAKE_SET
+AM_SANITY_CHECK
 missing_dir=`cd $ac_aux_dir && pwd`
 AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
 AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
@@ -87,6 +87,12 @@
 	ac_cv_have_dev_random=no
 	AC_DEFINE(USE_RAND_W32)
 	;;
+    *-*-hpux*)
+	if test -z "$GCC" ; then
+	    CFLAGS="$CFLAGS -Ae -D_HPUX_SOURCE"
+	fi
+	AC_DEFINE(USE_RAND_UNIX)
+	;;
     *)
 	AC_DEFINE(USE_RAND_UNIX)
        ;;
@@ -124,6 +130,8 @@
 
 dnl Checks for libraries.
 
+AM_GNU_GETTEXT
+
 AC_CHECK_LIB(gdbm,gdbm_firstkey)
 
 if test "$try_dynload" = yes ; then
@@ -261,12 +269,8 @@
 fi
 AC_SUBST(ZLIBS)
 
-
-WK_LINK_FILES($nls_cv_header_libgt, $nls_cv_header_intl )
-
 WK_DO_LINK_FILES
 
-AM_GNU_GETTEXT
 
 AC_OUTPUT([
 Makefile
@@ -280,7 +284,5 @@
 tools/Makefile
 zlib/Makefile
 checks/Makefile
-],[echo timestamp >stamp-h; \
-   sed -e "/POTFILES =/r po/POTFILES" po/Makefile.in > po/Makefile
 ])
 
diff -urN gnupg-0.4.2/doc/DETAILS gnupg-0.4.3/doc/DETAILS
--- gnupg-0.4.2/doc/DETAILS	Sat Oct 17 17:35:17 1998
+++ gnupg-0.4.3/doc/DETAILS	Wed Oct 21 15:48:50 1998
@@ -349,6 +349,28 @@
 +  that this is the last packet.
 
 
+Usage of gdbm files for keyrings
+================================
+    The key to store the keyblokc is it's fingerpint, other records
+    are used for secondary keys.  fingerprints are always 20 bytes
+    where 16 bit fingerprints are appded with zero.
+    The first byte of the key gives some information on the type of the
+    key.
+      1 = key is a 20 bit fingerprint (16 bytes fpr are padded with zeroes)
+	  data is the keyblock
+      2 = key is the complete 8 byte keyid
+	  data is a list of 20 byte fingerprints
+      3 = key is the short 4 byte keyid
+	  data is a list of 20 byte fingerprints
+      4 = key is the email address
+	  data is a list of 20 byte fingerprints
+
+    Data is prepended with a type byte:
+      1 = keyblock
+      2 = list of 20 byte padded fingerprints
+      3 = list of list fingerprints (but how to we key them?)
+
+
 
 
 Other Notes
diff -urN gnupg-0.4.2/doc/FAQ gnupg-0.4.3/doc/FAQ
--- gnupg-0.4.2/doc/FAQ	Sun Oct 18 12:15:07 1998
+++ gnupg-0.4.3/doc/FAQ	Wed Nov  4 07:41:13 1998
@@ -282,6 +282,20 @@
      For more see the chapter "The Web of Trust" in the
      Manual [gpg: Oops: Internal error: manual not found - sorry]
 
-
-
+  Q: How do interpret some of the informational outputs:
+  A: While checking the validness of a key, GnuPG sometimes print
+     some informations which are prefixed with information about
+     the checked item:
+	"key 12345678.3456"
+     This is about the key with key ID 12345678 and the internal
+     number 3456, which is the record number of the so called
+     directory record in the trustdb.
+	"uid 12345678.3456/ACDE"
+     This is about the user ID for the same key; to identify the
+     user ID the last two bytes of a ripe-md-160 over the user ID
+     tring is printed.
+	"sig 12345678.3456/ACDE/9A8B7C6D"
+     This is about the signature with key ID 9A8B7C6D for the
+     above key and user ID, if it is a signature which is direct
+     on a key, the user ID part is empty (..//..).
 
diff -urN gnupg-0.4.2/doc/Makefile.in gnupg-0.4.3/doc/Makefile.in
--- gnupg-0.4.2/doc/Makefile.in	Sun Oct 18 17:08:33 1998
+++ gnupg-0.4.3/doc/Makefile.in	Sun Nov  8 18:23:57 1998
@@ -1,4 +1,4 @@
-# Makefile.in generated automatically by automake 1.2f from Makefile.am
+# Makefile.in generated automatically by automake 1.3 from Makefile.am
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 # This Makefile.in is free software; the Free Software Foundation
@@ -32,6 +32,8 @@
 includedir = @includedir@
 oldincludedir = /usr/include
 
+DISTDIR =
+
 pkgdatadir = $(datadir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
@@ -108,19 +110,19 @@
 
 TAR = tar
 GZIP = --best
-default: all
+all: Makefile $(MANS)
 
 .SUFFIXES:
-$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) 
+$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4)
 	cd $(top_srcdir) && $(AUTOMAKE) --gnu --include-deps doc/Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status
 	cd $(top_builddir) \
 	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
 
 
 install-man1:
-	$(mkinstalldirs) $(man1dir)
+	$(mkinstalldirs) $(DESTDIR)$(man1dir)
 	@list='$(man1_MANS)'; \
 	l2='$(man_MANS)'; for i in $$l2; do \
 	  case "$$i" in \
@@ -133,8 +135,8 @@
 	  ext=`echo $$i | sed -e 's/^.*\\.//'`; \
 	  inst=`echo $$i | sed -e 's/\\.[0-9a-z]*$$//'`; \
 	  inst=`echo $$inst | sed '$(transform)'`.$$ext; \
-	  echo " $(INSTALL_DATA) $$file $(man1dir)/$$inst"; \
-	  $(INSTALL_DATA) $$file $(man1dir)/$$inst; \
+	  echo " $(INSTALL_DATA) $$file $(DESTDIR)$(man1dir)/$$inst"; \
+	  $(INSTALL_DATA) $$file $(DESTDIR)$(man1dir)/$$inst; \
 	done
 
 uninstall-man1:
@@ -148,8 +150,8 @@
 	  ext=`echo $$i | sed -e 's/^.*\\.//'`; \
 	  inst=`echo $$i | sed -e 's/\\.[0-9a-z]*$$//'`; \
 	  inst=`echo $$inst | sed '$(transform)'`.$$ext; \
-	  echo " rm -f $(man1dir)/$$inst"; \
-	  rm -f $(man1dir)/$$inst; \
+	  echo " rm -f $(DESTDIR)$(man1dir)/$$inst"; \
+	  rm -f $(DESTDIR)$(man1dir)/$$inst; \
 	done
 install-man: $(MANS)
 	@$(NORMAL_INSTALL)
@@ -189,12 +191,10 @@
 
 uninstall: uninstall-man
 
-all: Makefile $(MANS)
-
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs:
-	$(mkinstalldirs)  $(mandir)/man1
+	$(mkinstalldirs)  $(DESTDIR)$(mandir)/man1
 
 
 mostlyclean-generic:
@@ -222,8 +222,8 @@
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
-.PHONY: default install-man1 uninstall-man1 install-man uninstall-man \
-tags distdir info dvi installcheck install-exec install-data install \
+.PHONY: install-man1 uninstall-man1 install-man uninstall-man tags \
+distdir info dvi installcheck install-exec install-data install \
 uninstall all installdirs mostlyclean-generic distclean-generic \
 clean-generic maintainer-clean-generic clean mostlyclean distclean \
 maintainer-clean
diff -urN gnupg-0.4.2/doc/gpg.1 gnupg-0.4.3/doc/gpg.1
--- gnupg-0.4.2/doc/gpg.1	Sun Oct 18 16:42:46 1998
+++ gnupg-0.4.3/doc/gpg.1	Fri Nov  6 12:12:27 1998
@@ -45,16 +45,36 @@
 .if (\n(.H=4u)&(1m=20u) .ds -- \(*W\h'-12u'\(*W\h'-8u'-\" diablo 12 pitch
 .ds L" ""
 .ds R" ""
+'''   \*(M", \*(S", \*(N" and \*(T" are the equivalent of
+'''   \*(L" and \*(R", except that they are used on ".xx" lines,
+'''   such as .IP and .SH, which do another additional levels of
+'''   double-quote interpretation
+.ds M" """
+.ds S" """
+.ds N" """""
+.ds T" """""
 .ds L' '
 .ds R' '
+.ds M' '
+.ds S' '
+.ds N' '
+.ds T' '
 'br\}
 .el\{\
 .ds -- \(em\|
 .tr \*(Tr
 .ds L" ``
 .ds R" ''
+.ds M" ``
+.ds S" ''
+.ds N" ``
+.ds T" ''
 .ds L' `
 .ds R' '
+.ds M' `
+.ds S' '
+.ds N' `
+.ds T' '
 .ds PI \(*p
 'br\}
 .\"	If the F register is turned on, we'll generate
@@ -73,10 +93,8 @@
 .nr % 0
 .rr F
 .\}
-.TH gpg gpg.1 "18 Oct 1998" " " "GNU Tools"
-.IX Title "gpg gpg.1"
+.TH gpg.1pod gpg.1 "03 Nov 1998" " " "GNU Tools"
 .UC
-.IX Name "gpg - GNU Privacy Guard"
 .if n .hy 0
 .if n .na
 .ds C+ C\v'-.1v'\h'-1p'\s-2+\h'-1p'+\s0\v'.1v'\h'-1p'
@@ -170,21 +188,17 @@
 .\}
 .rm #[ #] #H #V #F C
 .SH "NAME"
-.IX Header "NAME"
 gpg \- GNU Privacy Guard
 .SH "SYNOPSIS"
-.IX Header "SYNOPSIS"
 \fBgpg\fR [--homedir name] [--options file] [options] command [args]
 .PP
 \fBgpgm\fR [--homedir name] [--options file] [options] command [args]
 .SH "DESCRIPTION"
-.IX Header "DESCRIPTION"
 \fBgpg\fR is the main program for the GNUPG system. \fBgpgm\fR is a maintenance
 tool which has some commands \fBgpgm\fR does not have; it is there because
 it does not handle sensitive data and therefore has no need to allocate
 secure memory.
 .SH "COMMANDS"
-.IX Header "COMMANDS"
 \fBgpg\fR recognizes these commands:
 .PP
 \fB\-s\fR, \fB--sign\fR
@@ -243,7 +257,7 @@
     \fB\-kvc\fR   List fingerprints
     \fB\-kvvc\fR  List fingerprints and signatures
 .PP
-\fB--list-keys\fR	[\fInames\fR]
+\fB--list-keys\fR  [\fInames\fR]
     List all keys from the public keyrings, or just the
     ones given on the command line.
 .PP
@@ -251,7 +265,7 @@
     List all keys from the secret keyrings, or just the
     ones given on the command line.
 .PP
-\fB--list-sigs\fR	[\fInames\fR]
+\fB--list-sigs\fR  [\fInames\fR]
     Same as \fB--list-keys\fR, but the signatures are listed
     too.
 .PP
@@ -296,7 +310,7 @@
     \fBdelkey\fR
        Remove a subkey.
     \fBexpire\fR
-       Change the key expiration time.	If a key is
+       Change the key expiration time.  If a key is
        select, the time of this key will be changed.
        With no selection the key expiration of the
        primary key is changed.
@@ -355,8 +369,10 @@
     Same as \fB--export\fR, but does export the secret keys.
     This is normally not very useful.
 .PP
-\fB--import\fR
-    import/merge keys
+\fB--import\fR, \fB--fast-import\fR
+    Import/merge keys.  The fast version does not build
+    the trustdb; this can be deon at anytime with the
+    command \fB--update-trustdb\fR.
 .PP
 \fB--export-ownertrust\fR
     List the assigned ownertrust values in ascii format
@@ -367,10 +383,9 @@
     in \fIfilename\fR (or stdin if not given); existing
     values will be overwritten. [\fBgpgm\fR only].
 .SH "OPTIONS"
-.IX Header "OPTIONS"
 Long options can be put in an options file (default \fI~/.gnupg/options\fR);
 do not write the 2 dashes, but simply the name of the option and any
-arguments if required.	Lines with a hash as the first non-white-space
+arguments if required.  Lines with a hash as the first non-white-space
 character are ignored. Commands may be put in this file too, but that
 does not make sense.
 .PP
@@ -401,14 +416,21 @@
     Give more information during processing. If used
     twice, the input data is listed in detail.
 .PP
+\fB\-q\fR, \fB--quiet\fR
+    Be somewhat more quiet in some cases.
+.PP
 \fB\-z\fR \fIn\fR
     Set compress level to \fIn\fR. A value of 0 for \fIn\fR
     disables compression. Default is to use the default
     compression level of zlib (which is 6).
 .PP
 \fB\-t\fR, \fB--textmode\fR
-    Use canonical text mode.  Used to make clear-text
-    signatures.
+    Use canonical text mode.  If \fB\-t\fR (but not
+    \fB--textmode\fR) is used together with armoring
+    and signing, this enables clearsigned messages.
+    This kludge is needed for PGP compatibility;
+    normally you would use \fB--sign\fR or b<--clearsign>
+    to selected the type os signatures.
 .PP
 \fB\-n\fR, \fB--dry-run\fR
     Don't make any changes (not yet implemented).
@@ -422,10 +444,10 @@
     is used in the options file.
 .PP
 \fB--yes\fR
-    Assume yes on most questions.
+    Assume \*(L"yes\*(R" on most questions.
 .PP
 \fB--no\fR
-    Assume no on most questions.
+    Assume \*(L"no\*(R" on most questions.
 .PP
 \fB--keyring\fR \fIfile\fR
     Add \fIfile\fR to the list of keyrings.
@@ -433,6 +455,9 @@
     are replaced by the HOME directory. If the filename
     does not contain a slash, it is assumed to be in the
     home-directory (\fI~/.gnupg\fR if \fB--homedir\fR) is not used.
+    The filename may be prefixed with a scheme:
+      \*(L"gnupg-ring:\*(R" is the default one.
+      \*(L"gnupg-gdbm:\*(R" may be used for a GDBM ring.
 .PP
 \fB--secret-keyring\fR \fIfile\fR
     Same as \fB--keyring\fR but for secret keyrings.
@@ -588,11 +613,9 @@
 \fB\-h\fR, \fB--help\fR
     Print usage information.
 .SH "RETURN VALUE"
-.IX Header "RETURN VALUE"
 The Program returns 0 if everything was fine, 1 if at least
 a signature was bad and other errorcode for fatal errors.
 .SH "EXAMPLES"
-.IX Header "EXAMPLES"
 .PP
 .Vb 5
 \&  -se -r Bob [file]          sign and encrypt for user Bob
@@ -602,25 +625,21 @@
 \&  -kc  [userid]              show fingerprint
 .Ve
 .SH "ENVIRONMENT"
-.IX Header "ENVIRONMENT"
 \f(CWHOME\fR       Used to locate the default home directory.
 \f(CWGNUPGHOME\fR  If set, direcory used instead of \fI~/.gnupg\fR.
 .SH "FILES"
-.IX Header "FILES"
 \fI~/.gnupg/secring.gpg\fR     The secret keyring
 .PP
 \fI~/.gnupg/pubring.gpg\fR     The public keyring
 .PP
 \fI~/.gnupg/trustdb.gpg\fR     The trust database
 .PP
-\fI~/.gnupg/options\fR	    May contain options
+\fI~/.gnupg/options\fR         May contain options
 .PP
 \fI/usr[/local]/lib/gnupg/\fR  Default location for extensions
 .SH "SEE ALSO"
-.IX Header "SEE ALSO"
-\fIgpg\fR\|(1)	\fIgpgm\fR\|(1)
+\fIgpg\fR\|(1)  \fIgpgm\fR\|(1)
 .SH "WARNINGS"
-.IX Header "WARNINGS"
 Use a \fBgood\fR password for your user account and a \fBgood\fR passphrase
 to protect your secret key.  This passphrase is the weakest part of the
 whole system.  Programs to do dictionary attacks on your secret keyring
@@ -630,10 +649,36 @@
 Keep in mind that, if this program is used over a network (telnet), it
 is \fBvery\fR easy to spy out your passphrase!
 .SH "BUGS"
-.IX Header "BUGS"
 On many systems this program should be installed as \fIsetuid\fR\|(root); this
 is necessary to lock some pages of memory. If you get no warning message
 about insecure memory your OS kernel supports locking without being root;
 setuid is dropped as soon as this memory is allocated.
 
 .rn }` ''
+.IX Title "gpg.1pod gpg.1"
+.IX Name "gpg - GNU Privacy Guard"
+
+.IX Header "NAME"
+
+.IX Header "SYNOPSIS"
+
+.IX Header "DESCRIPTION"
+
+.IX Header "COMMANDS"
+
+.IX Header "OPTIONS"
+
+.IX Header "RETURN VALUE"
+
+.IX Header "EXAMPLES"
+
+.IX Header "ENVIRONMENT"
+
+.IX Header "FILES"
+
+.IX Header "SEE ALSO"
+
+.IX Header "WARNINGS"
+
+.IX Header "BUGS"
+
diff -urN gnupg-0.4.2/doc/gpg.1pod gnupg-0.4.3/doc/gpg.1pod
--- gnupg-0.4.2/doc/gpg.1pod	Sun Oct 18 16:41:41 1998
+++ gnupg-0.4.3/doc/gpg.1pod	Tue Nov  3 16:33:57 1998
@@ -75,7 +75,7 @@
     B<-kvc>   List fingerprints
     B<-kvvc>  List fingerprints and signatures
 
-B<--list-keys>	[I<names>]
+B<--list-keys>  [I<names>]
     List all keys from the public keyrings, or just the
     ones given on the command line.
 
@@ -83,7 +83,7 @@
     List all keys from the secret keyrings, or just the
     ones given on the command line.
 
-B<--list-sigs>	[I<names>]
+B<--list-sigs>  [I<names>]
     Same as B<--list-keys>, but the signatures are listed
     too.
 
@@ -129,7 +129,7 @@
     B<delkey>
        Remove a subkey.
     B<expire>
-       Change the key expiration time.	If a key is
+       Change the key expiration time.  If a key is
        select, the time of this key will be changed.
        With no selection the key expiration of the
        primary key is changed.
@@ -190,8 +190,10 @@
     Same as B<--export>, but does export the secret keys.
     This is normally not very useful.
 
-B<--import>
-    import/merge keys
+B<--import>, B<--fast-import>
+    Import/merge keys.  The fast version does not build
+    the trustdb; this can be deon at anytime with the
+    command B<--update-trustdb>.
 
 B<--export-ownertrust>
     List the assigned ownertrust values in ascii format
@@ -206,7 +208,7 @@
 
 Long options can be put in an options file (default F<~/.gnupg/options>);
 do not write the 2 dashes, but simply the name of the option and any
-arguments if required.	Lines with a hash as the first non-white-space
+arguments if required.  Lines with a hash as the first non-white-space
 character are ignored. Commands may be put in this file too, but that
 does not make sense.
 
@@ -238,6 +240,8 @@
     Give more information during processing. If used
     twice, the input data is listed in detail.
 
+B<-q>, B<--quiet>
+    Be somewhat more quiet in some cases.
 
 B<-z> I<n>
     Set compress level to I<n>. A value of 0 for I<n>
@@ -245,8 +249,12 @@
     compression level of zlib (which is 6).
 
 B<-t>, B<--textmode>
-    Use canonical text mode.  Used to make clear-text
-    signatures.
+    Use canonical text mode.  If B<-t> (but not
+    B<--textmode>) is used together with armoring
+    and signing, this enables clearsigned messages.
+    This kludge is needed for PGP compatibility;
+    normally you would use B<--sign> or b<--clearsign>
+    to selected the type os signatures.
 
 B<-n>, B<--dry-run>
     Don't make any changes (not yet implemented).
@@ -260,10 +268,10 @@
     is used in the options file.
 
 B<--yes>
-    Assume yes on most questions.
+    Assume "yes" on most questions.
 
 B<--no>
-    Assume no on most questions.
+    Assume "no" on most questions.
 
 B<--keyring> I<file>
     Add I<file> to the list of keyrings.
@@ -271,6 +279,9 @@
     are replaced by the HOME directory. If the filename
     does not contain a slash, it is assumed to be in the
     home-directory (F<~/.gnupg> if B<--homedir>) is not used.
+    The filename may be prefixed with a scheme:
+      "gnupg-ring:" is the default one.
+      "gnupg-gdbm:" may be used for a GDBM ring.
 
 B<--secret-keyring> I<file>
     Same as B<--keyring> but for secret keyrings.
@@ -436,11 +447,11 @@
 
 =head1 EXAMPLES
 
-  -se -r Bob [file]	     sign and encrypt for user Bob
-  -sat [file]		     make a clear text signature
-  -sb  [file]		     make a detached signature
-  -k   [userid] 	     show keys
-  -kc  [userid] 	     show fingerprint
+  -se -r Bob [file]          sign and encrypt for user Bob
+  -sat [file]                make a clear text signature
+  -sb  [file]                make a detached signature
+  -k   [userid]              show keys
+  -kc  [userid]              show fingerprint
 
 =head1 ENVIRONMENT
 
@@ -455,13 +466,13 @@
 
 F<~/.gnupg/trustdb.gpg>     The trust database
 
-F<~/.gnupg/options>	    May contain options
+F<~/.gnupg/options>         May contain options
 
 F</usr[/local]/lib/gnupg/>  Default location for extensions
 
 =head1 SEE ALSO
 
-gpg(1)	gpgm(1)
+gpg(1)  gpgm(1)
 
 
 =head1 WARNINGS
diff -urN gnupg-0.4.2/g10/ChangeLog gnupg-0.4.3/g10/ChangeLog
--- gnupg-0.4.2/g10/ChangeLog	Sun Oct 18 15:36:57 1998
+++ gnupg-0.4.3/g10/ChangeLog	Sun Nov  8 17:42:37 1998
@@ -1,3 +1,115 @@
+Sun Nov  8 17:20:39 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* mainproc.c (check_sig_and_print): Why did I use strlen()-1
+	in the printf? - This truncated the TZ.
+
+Sat Nov  7 15:57:28 1998  me,,,  (wk@tobold)
+
+	* getkey.c (lookup): Changes to support a read_next.
+	(get_pubkey): Fixed a memory leak.
+
+	* keylist.c (list_one): Now lists all matching user IDs.
+
+Tue Nov  3 16:19:21 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* keygen.c (ask_user_id): Now converted to UTF-8
+
+	* g10.c (main): Kludge for pgp clearsigs and textmode.
+
+Fri Oct 30 16:40:39 1998  me,,,  (wk@tobold)
+
+	* signal.c (block_all_signals): New.
+	(unblock_all_signals): New
+	* tdbio.c (tdbio_end_transaction): Now blocks all signals.
+
+	* trustdb.c (new_lid_table): Changed the representation of the
+	former local_lid_info stuff.
+
+	* trustdb.c (update_trust_record): Reorganized the whole thing.
+	* sig-check.c (check_key_signature): Now handles class 0x28
+
+
+Wed Oct 28 18:56:33 1998  me,,,  (wk@tobold)
+
+	* export.c (do_export): Takes care of the exportable sig flag.
+
+Tue Oct 27 14:53:04 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* trustdb.c (update_trust_record): New "fast" parameter.
+
+Sun Oct 25 19:32:05 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* openfile.c (copy_options_File): New.
+	* ringedit.c (add_keyblock_resource): Creates options file
+	* tdbio.c (tdbio_set_dbname): Ditto.
+
+Sat Oct 24 14:10:53 1998  brian moore <bem@cmc.net>
+
+	* mainproc.c (proc_pubkey_enc): Don't release the DEK
+	(do_proc_packets): Ditto.
+
+Fri Oct 23 06:49:38 1998  me,,,  (wk@tobold)
+
+	* keyedit.c (keyedit_menu): Comments are now allowed
+
+	* trustdb.c: Rewrote large parts.
+
+
+Thu Oct 22 15:56:45 1998  Michael Roth	(mroth@nessie.de)
+
+	* encode.c: (encode_simple): Only the plain filename without
+	a given directory is stored in generated packets.
+	(encode_crypt): Ditto.
+
+	* sign.c: (sign_file) Ditto.
+
+
+Thu Oct 22 10:53:41 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* trustdb.c (update_trust_record): Add new optional arg.
+
+	* import.c (import_keys): Add statistics output
+	* trustdb.c (update_trustdb): Ditto.
+	(insert_trustdb): Ditto.
+
+	* tdbio.c (tdbio_begin_transaction): New.
+	(tdbio_end_transaction): New.
+	(tdbio_cancel_transaction): New.
+
+	* g10.c (main): New option --quit.
+
+	* trustdb.c (check_hint_sig): No tests for user-id w/o sig.
+	This caused an assert while checking the sigs.
+
+	* trustdb.c (upd_sig_record): Splitted into several functions.
+
+	* import.c (import_keys): New arg "fast".
+	* g10.c (main): New command --fast-import.
+
+Wed Oct 21 18:19:36 1998  Michael Roth <mroth@nessie.de>
+
+	* ringedit.c (add_keyblock_resource): Directory is now created.
+	* tdbio.c (tdbio_set_dbname): New info message.
+
+Wed Oct 21 11:52:04 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* trustdb.c (update_trustdb): released keyblock in loop.
+
+	* keylist.c (list_block): New.
+	(list_all): Changed to use list_block.
+
+	* trustdb.c: Completed support for GDBM
+
+	* sign.c (only_old_style): Changed the way force_v3 is handled
+	(sign_file): Ditto.
+	(clearsign_file): Ditto.
+
+	* keygen.c (has_invalid_email_chars): Splitted into mailbox and
+	host part.
+
+	* keylist.c (list_one): Add a merge_keys_and_selfsig.
+	* mainproc.c (proc_tree): Ditto.
+
 Sun Oct 18 11:49:03 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* sign.c (only_old_style): Add option force_v3_sigs
diff -urN gnupg-0.4.2/g10/Makefile.am gnupg-0.4.3/g10/Makefile.am
--- gnupg-0.4.2/g10/Makefile.am	Thu Oct  8 10:15:57 1998
+++ gnupg-0.4.3/g10/Makefile.am	Sun Oct 25 19:54:13 1998
@@ -1,7 +1,7 @@
 ## Process this file with automake to produce Makefile.in
 
-INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
-EXTRA_DIST = OPTIONS  pubring.asc
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl
+EXTRA_DIST = OPTIONS  pubring.asc  options.skel
 OMIT_DEPENDENCIES = zlib.h zconf.h
 LDFLAGS = @LDFLAGS@ @DYNLINK_LDFLAGS@
 needed_libs = ../cipher/libcipher.a ../mpi/libmpi.a ../util/libutil.a
@@ -76,7 +76,7 @@
 #	       $(common_source)
 
 
-LDADD = @INTLLIBS@ $(needed_libs) @ZLIBS@
+LDADD =  $(needed_libs) @ZLIBS@ @INTLLIBS@
 
 gpgm_LDADD = g10maint.o $(LDADD)
 
@@ -85,5 +85,11 @@
 
 
 $(PROGRAMS): $(needed_libs)
+
+
+install-data-local:
+	$(mkinstalldirs) $(pkgdatadir)
+	$(INSTALL_DATA) $(srcdir)/options.skel $(pkgdatadir)/options.skel
+
 
 
diff -urN gnupg-0.4.2/g10/Makefile.in gnupg-0.4.3/g10/Makefile.in
--- gnupg-0.4.2/g10/Makefile.in	Sun Oct 18 17:08:30 1998
+++ gnupg-0.4.3/g10/Makefile.in	Sun Nov  8 18:23:54 1998
@@ -1,4 +1,4 @@
-# Makefile.in generated automatically by automake 1.2f from Makefile.am
+# Makefile.in generated automatically by automake 1.3 from Makefile.am
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 # This Makefile.in is free software; the Free Software Foundation
@@ -32,6 +32,8 @@
 includedir = @includedir@
 oldincludedir = /usr/include
 
+DISTDIR =
+
 pkgdatadir = $(datadir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
@@ -91,8 +93,8 @@
 ZLIBS = @ZLIBS@
 l = @l@
 
-INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
-EXTRA_DIST = OPTIONS  pubring.asc
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl
+EXTRA_DIST = OPTIONS  pubring.asc  options.skel
 OMIT_DEPENDENCIES = zlib.h zconf.h
 LDFLAGS = @LDFLAGS@ @DYNLINK_LDFLAGS@
 needed_libs = ../cipher/libcipher.a ../mpi/libmpi.a ../util/libutil.a
@@ -165,7 +167,7 @@
 #	       ks-db.h \
 #	       $(common_source)
 
-LDADD = @INTLLIBS@ $(needed_libs) @ZLIBS@
+LDADD =  $(needed_libs) @ZLIBS@ @INTLLIBS@
 
 gpgm_LDADD = g10maint.o $(LDADD)
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
@@ -211,14 +213,14 @@
 SOURCES = $(gpg_SOURCES) $(gpgm_SOURCES)
 OBJECTS = $(gpg_OBJECTS) $(gpgm_OBJECTS)
 
-default: all
+all: Makefile $(PROGRAMS)
 
 .SUFFIXES:
 .SUFFIXES: .S .c .o .s
-$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) 
+$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4)
 	cd $(top_srcdir) && $(AUTOMAKE) --gnu --include-deps g10/Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status
 	cd $(top_builddir) \
 	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
 
@@ -234,18 +236,18 @@
 
 install-binPROGRAMS: $(bin_PROGRAMS)
 	@$(NORMAL_INSTALL)
-	$(mkinstalldirs) $(bindir)
+	$(mkinstalldirs) $(DESTDIR)$(bindir)
 	@list='$(bin_PROGRAMS)'; for p in $$list; do \
 	  if test -f $$p; then \
-	    echo "  $(INSTALL_PROGRAM) $$p $(bindir)/`echo $$p|sed '$(transform)'`"; \
-	     $(INSTALL_PROGRAM) $$p $(bindir)/`echo $$p|sed '$(transform)'`; \
+	    echo "  $(INSTALL_PROGRAM) $$p $(DESTDIR)$(bindir)/`echo $$p|sed '$(transform)'`"; \
+	     $(INSTALL_PROGRAM) $$p $(DESTDIR)$(bindir)/`echo $$p|sed '$(transform)'`; \
 	  else :; fi; \
 	done
 
 uninstall-binPROGRAMS:
 	@$(NORMAL_UNINSTALL)
 	list='$(bin_PROGRAMS)'; for p in $$list; do \
-	  rm -f $(bindir)/`echo $$p|sed '$(transform)'`; \
+	  rm -f $(DESTDIR)$(bindir)/`echo $$p|sed '$(transform)'`; \
 	done
 
 .c.o:
@@ -380,11 +382,6 @@
 	../include/iobuf.h ../include/memory.h packet.h \
 	../include/cipher.h ../include/../cipher/random.h filter.h \
 	keydb.h options.h main.h ../include/i18n.h
-gpgd.o: gpgd.c ../config.h ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h ../include/cipher.h \
-	../include/../cipher/random.h options.h main.h keydb.h packet.h \
-	filter.h
 import.o: import.c ../config.h ../g10defs.h options.h packet.h \
 	../include/types.h ../include/iobuf.h ../include/mpi.h \
 	../include/memory.h ../include/cipher.h \
@@ -417,12 +414,6 @@
 	../include/memory.h ../include/cipher.h \
 	../include/../cipher/random.h filter.h ../include/errors.h \
 	keydb.h ../include/util.h trustdb.h main.h ../include/i18n.h
-ks-db.o: ks-db.c ../config.h ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h ks-db.h
-ks-proto.o: ks-proto.c ../config.h ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h ks-proto.h
 mainproc.o: mainproc.c ../config.h ../g10defs.h packet.h \
 	../include/types.h ../include/iobuf.h ../include/mpi.h \
 	../include/memory.h ../include/cipher.h \
@@ -485,7 +476,8 @@
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h packet.h \
 	../include/cipher.h ../include/../cipher/random.h filter.h \
-	keydb.h options.h ../include/i18n.h
+	keydb.h ../include/host2net.h options.h main.h \
+	../include/i18n.h
 seckey-cert.o: seckey-cert.c ../config.h ../g10defs.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h packet.h \
@@ -527,7 +519,8 @@
 	../include/iobuf.h ../include/types.h ../include/memory.h \
 	../include/util.h ../include/mpi.h options.h main.h \
 	../include/cipher.h ../include/../cipher/random.h keydb.h \
-	packet.h filter.h ../include/i18n.h trustdb.h tdbio.h
+	packet.h filter.h ../include/i18n.h trustdb.h tdbio.h \
+	../include/host2net.h
 textfilter.o: textfilter.c ../config.h ../g10defs.h ../include/errors.h \
 	../include/iobuf.h ../include/types.h ../include/memory.h \
 	../include/util.h ../include/mpi.h filter.h ../include/cipher.h \
@@ -536,7 +529,8 @@
 	../include/iobuf.h ../include/types.h keydb.h packet.h \
 	../include/mpi.h ../include/memory.h ../include/cipher.h \
 	../include/../cipher/random.h filter.h ../include/util.h \
-	trustdb.h options.h main.h ../include/i18n.h tdbio.h
+	trustdb.h options.h main.h ../include/i18n.h tdbio.h \
+	../include/host2net.h
 verify.o: verify.c ../config.h ../g10defs.h options.h packet.h \
 	../include/types.h ../include/iobuf.h ../include/mpi.h \
 	../include/memory.h ../include/cipher.h \
@@ -552,7 +546,7 @@
 install-exec: install-binPROGRAMS
 	@$(NORMAL_INSTALL)
 
-install-data: 
+install-data: install-data-local
 	@$(NORMAL_INSTALL)
 
 install: install-exec install-data all
@@ -560,12 +554,10 @@
 
 uninstall: uninstall-binPROGRAMS
 
-all: Makefile $(PROGRAMS)
-
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs:
-	$(mkinstalldirs)  $(bindir)
+	$(mkinstalldirs)  $(DATADIR)$(bindir)
 
 
 mostlyclean-generic:
@@ -598,9 +590,9 @@
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
-.PHONY: default mostlyclean-binPROGRAMS distclean-binPROGRAMS \
-clean-binPROGRAMS maintainer-clean-binPROGRAMS uninstall-binPROGRAMS \
-install-binPROGRAMS mostlyclean-compile distclean-compile clean-compile \
+.PHONY: mostlyclean-binPROGRAMS distclean-binPROGRAMS clean-binPROGRAMS \
+maintainer-clean-binPROGRAMS uninstall-binPROGRAMS install-binPROGRAMS \
+mostlyclean-compile distclean-compile clean-compile \
 maintainer-clean-compile tags mostlyclean-tags distclean-tags \
 clean-tags maintainer-clean-tags distdir info dvi installcheck \
 install-exec install-data install uninstall all installdirs \
@@ -612,6 +604,10 @@
 	$(COMPILE) -DIS_G10MAINT  -o g10maint.o -c $(srcdir)/g10.c
 
 $(PROGRAMS): $(needed_libs)
+
+install-data-local:
+	$(mkinstalldirs) $(pkgdatadir)
+	$(INSTALL_DATA) $(srcdir)/options.skel $(pkgdatadir)/options.skel
 
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
diff -urN gnupg-0.4.2/g10/delkey.c gnupg-0.4.3/g10/delkey.c
--- gnupg-0.4.2/g10/delkey.c	Tue Sep  8 20:03:08 1998
+++ gnupg-0.4.3/g10/delkey.c	Mon Oct 19 07:09:10 1998
@@ -1,4 +1,4 @@
-/* delkey.c - delte keys
+/* delkey.c - delete keys
  *	Copyright (C) 1998 Free Software Foundation, Inc.
  *
  * This file is part of GNUPG.
diff -urN gnupg-0.4.2/g10/encode.c gnupg-0.4.3/g10/encode.c
--- gnupg-0.4.2/g10/encode.c	Wed Oct 14 10:21:17 1998
+++ gnupg-0.4.3/g10/encode.c	Sat Oct 24 14:21:54 1998
@@ -140,10 +140,11 @@
 
     /* setup the inner packet */
     if( filename || opt.set_filename ) {
-	const char *s = opt.set_filename ? opt.set_filename : filename;
+	char *s = make_basename( opt.set_filename ? opt.set_filename : filename );
 	pt = m_alloc( sizeof *pt + strlen(s) - 1 );
 	pt->namelen = strlen(s);
 	memcpy(pt->name, s, pt->namelen );
+	m_free(s);
     }
     else { /* no filename */
 	pt = m_alloc( sizeof *pt - 1 );
@@ -253,10 +254,11 @@
 
     /* setup the inner packet */
     if( filename || opt.set_filename ) {
-	const char *s = opt.set_filename ? opt.set_filename : filename;
+	char *s = make_basename( opt.set_filename ? opt.set_filename : filename );
 	pt = m_alloc( sizeof *pt + strlen(s) - 1 );
 	pt->namelen = strlen(s);
 	memcpy(pt->name, s, pt->namelen );
+	m_free(s);
     }
     else { /* no filename */
 	pt = m_alloc( sizeof *pt - 1 );
diff -urN gnupg-0.4.2/g10/export.c gnupg-0.4.3/g10/export.c
--- gnupg-0.4.2/g10/export.c	Wed Oct 14 10:31:08 1998
+++ gnupg-0.4.3/g10/export.c	Thu Oct 29 18:49:32 1998
@@ -128,6 +128,15 @@
 	     * secret keyring */
 	    if( !secret && node->pkt->pkttype == PKT_COMMENT )
 		continue;
+	    /* do not export packets which are marked as not exportable */
+	    if( node->pkt->pkttype == PKT_SIGNATURE ) {
+		const char *p;
+		p = parse_sig_subpkt2( node->pkt->pkt.signature,
+				       SIGSUBPKT_EXPORTABLE, NULL );
+		if( p && !*p )
+		    continue; /* not exportable */
+	    }
+
 	    if( (rc = build_packet( out, node->pkt )) ) {
 		log_error("build_packet(%d) failed: %s\n",
 			    node->pkt->pkttype, g10_errstr(rc) );
diff -urN gnupg-0.4.2/g10/g10.c gnupg-0.4.3/g10/g10.c
--- gnupg-0.4.2/g10/g10.c	Sun Oct 18 11:44:56 1998
+++ gnupg-0.4.3/g10/g10.c	Tue Nov  3 16:34:03 1998
@@ -57,9 +57,10 @@
     oKOption	  = 'k',
     oDryRun	  = 'n',
     oOutput	  = 'o',
+    oQuiet	  = 'q',
     oRemote	  = 'r',
     aSign	  = 's',
-    oTextmode	  = 't',
+    oTextmodeShort= 't',
     oUser	  = 'u',
     oVerbose	  = 'v',
     oCompress	  = 'z',
@@ -76,6 +77,7 @@
     aKMode,
     aKModeC,
     aImport,
+    aFastImport,
     aVerify,
     aListKeys,
     aListSigs,
@@ -98,6 +100,7 @@
     aEnArmor,
     aGenRandom,
 
+    oTextmode,
     oFingerprint,
     oAnswerYes,
     oAnswerNo,
@@ -174,6 +177,7 @@
     { aExport, "export"          , 256, N_("export keys") },
     { aExportSecret, "export-secret-keys" , 256, "@" },
     { aImport, "import",      256     , N_("import/merge keys")},
+    { aFastImport, "fast-import",  256 , "@"},
     { aListPackets, "list-packets",256,N_("list only the sequence of packets")},
   #ifdef IS_G10MAINT
     { aExportOwnerTrust,
@@ -202,10 +206,12 @@
     { oUser, "local-user",2, N_("use this user-id to sign or decrypt")},
     { oRemote, "remote-user", 2, N_("use this user-id for encryption")},
     { oCompress, NULL,	      1, N_("|N|set compress level N (0 disables)") },
+    { oTextmodeShort, NULL,   0, "@"},
     { oTextmode, "textmode",  0, N_("use canonical text mode")},
   #endif
     { oOutput, "output",    2, N_("use as output file")},
     { oVerbose, "verbose",   0, N_("verbose") },
+    { oQuiet,	"quiet",   0, N_("be somewhat more quiet") },
     { oForceV3Sigs, "force-v3-sigs", 0, N_("force v3 signatures") },
  /* { oDryRun, "dry-run",   0, N_("do not make any changes") }, */
     { oBatch, "batch",     0, N_("batch mode: never ask")},
@@ -614,6 +620,7 @@
 	  case aCheckKeys: set_cmd( &cmd, aCheckKeys); break;
 	  case aListPackets: set_cmd( &cmd, aListPackets); break;
 	  case aImport: set_cmd( &cmd, aImport); break;
+	  case aFastImport: set_cmd( &cmd, aFastImport); break;
 	  case aExport: set_cmd( &cmd, aExport); break;
 	  case aListKeys: set_cmd( &cmd, aListKeys); break;
 	  case aListSigs: set_cmd( &cmd, aListSigs); break;
@@ -657,6 +664,7 @@
 
 	  case oArmor: opt.armor = 1; opt.no_armor=0; break;
 	  case oOutput: opt.outfile = pargs.r.ret_str; break;
+	  case oQuiet: opt.quiet = 1; break;
 	  case oVerbose: g10_opt_verbose++;
 		    opt.verbose++; opt.list_sigs=1; break;
 	  case oKOption: set_cmd( &cmd, aKMode ); break;
@@ -728,6 +736,7 @@
 	    sl->next = remusr;
 	    remusr = sl;
 	    break;
+	  case oTextmodeShort: opt.textmode = 2; break;
 	  case oTextmode: opt.textmode=1;  break;
 	  case oUser: /* store the local users */
 	    sl = m_alloc( sizeof *sl + strlen(pargs.r.ret_str));
@@ -833,7 +842,7 @@
 
 
     /* kludge to let -sat generate a clear text signature */
-    if( opt.textmode && !detached_sig && opt.armor && cmd == aSign )
+    if( opt.textmode == 2 && !detached_sig && opt.armor && cmd == aSign )
 	cmd = aClearsign;
 
     if( opt.verbose > 1 )
@@ -1022,14 +1031,15 @@
 	break;
     #endif
 
+      case aFastImport:
       case aImport:
 	if( !argc  ) {
-	    rc = import_keys( NULL );
+	    rc = import_keys( NULL, (cmd == aFastImport) );
 	    if( rc )
 		log_error("import failed: %s\n", g10_errstr(rc) );
 	}
 	for( ; argc; argc--, argv++ ) {
-	    rc = import_keys( *argv );
+	    rc = import_keys( *argv, (cmd == aFastImport) );
 	    if( rc )
 		log_error("import from '%s' failed: %s\n",
 						*argv, g10_errstr(rc) );
diff -urN gnupg-0.4.2/g10/getkey.c gnupg-0.4.3/g10/getkey.c
--- gnupg-0.4.2/g10/getkey.c	Sun Oct 18 16:25:37 1998
+++ gnupg-0.4.3/g10/getkey.c	Sun Nov  8 18:18:44 1998
@@ -18,6 +18,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
  */
 
+#define DEFINES_GETKEY_CTX 1
+
 #include <config.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -33,10 +35,30 @@
 #include "main.h"
 #include "i18n.h"
 
-#define MAX_UNK_CACHE_ENTRIES 1000
+#define MAX_UNK_CACHE_ENTRIES 1000   /* we use a linked list - so I guess
+				      * this is a reasonable limit */
 #define MAX_PK_CACHE_ENTRIES	50
 #define MAX_UID_CACHE_ENTRIES	50
 
+
+struct getkey_ctx_s {
+    int mode;
+    int internal;
+    u32 keyid[2];
+    char *namebuf;
+    const char *name;
+    int primary;
+    KBNODE keyblock;
+    KBPOS kbpos;
+    int last_rc;
+    ulong count;
+};
+
+
+
+
+
+
 static struct {
     int any;
     int okay_count;
@@ -82,9 +104,12 @@
 
 
 
-static int lookup( PKT_public_key *pk,
+static int lookup( GETKEY_CTX *ctx, PKT_public_key *pk,
 		   int mode,  u32 *keyid, const char *name,
 		   KBNODE *ret_keyblock, int primary  );
+static void lookup_close( GETKEY_CTX ctx );
+static int  lookup_read( GETKEY_CTX ctx,
+			 PKT_public_key *pk, KBNODE *ret_keyblock );
 static int lookup_sk( PKT_secret_key *sk,
 		   int mode,  u32 *keyid, const char *name, int primary );
 
@@ -223,7 +248,7 @@
 
 
     /* do a lookup */
-    rc = lookup( pk, 11, keyid, NULL, NULL, 0 );
+    rc = lookup( NULL, pk, 11, keyid, NULL, NULL, 0 );
     if( !rc )
 	goto leave;
 
@@ -251,7 +276,7 @@
     if( !rc )
 	cache_public_key( pk );
     if( internal )
-	m_free(pk);
+	free_public_key(pk);
     return rc;
 }
 
@@ -282,12 +307,24 @@
 }
 
 
+
 /****************
- * Try to get the pubkey by the userid. This function looks for the
- * first pubkey certificate which has the given name in a user_id.
- * if pk has the pubkey algo set, the function will only return
- * a pubkey with that algo.
+ * Return the type of the user id:
+ *
+ *  0 = Invalid user ID
+ *  1 = exact match
+ *  2 = match a substring
+ *  3 = match an email address
+ *  4 = match a substring of an email address
+ *  5 = match an email address, but compare from end
+ * 10 = it is a short KEYID (don't care about keyid[0])
+ * 11 = it is a long  KEYID
+ * 16 = it is a 16 byte fingerprint
+ * 20 = it is a 20 byte fingerprint
+ *
+ * if fprint is not NULL, it should be an array of at least 20 bytes.
  *
+ * Rules used:
  * - If the username starts with 8,9,16 or 17 hex-digits (the first one
  *   must be in the range 0..9), this is considered a keyid; depending
  *   on the length a short or complete one.
@@ -301,19 +338,14 @@
  *   email address
  * - If the userid start with an '=' an exact compare is done.
  * - If the userid starts with a '*' a case insensitive substring search is
- *   done (This is also the default).
+ *   done (This is the default).
  */
 
-
-static int
-key_byname( int secret,
-	    PKT_public_key *pk, PKT_secret_key *sk, const char *name )
+int
+classify_user_id( const char *name, u32 *keyid, byte *fprint,
+		  const char **retstr, size_t *retlen )
 {
-    int internal = 0;
-    int rc = 0;
     const char *s;
-    u32 keyid[2] = {0}; /* init to avoid compiler warning */
-    byte fprint[20];
     int mode = 0;
 
     /* check what kind of name it is */
@@ -328,11 +360,14 @@
 	for(i=0; isxdigit(s[i]); i++ )
 	    ;
 	if( s[i] && !isspace(s[i]) ) /* not terminated by EOS or blank*/
-	    rc = G10ERR_INV_USER_ID;
+	    return 0;
 	else if( i == 8 || (i == 9 && *s == '0') ) { /* short keyid */
 	    if( i==9 )
 		s++;
-	    keyid[1] = strtoul( s, NULL, 16 );
+	    if( keyid ) {
+		keyid[0] = 0;
+		keyid[1] = strtoul( s, NULL, 16 );
+	    }
 	    mode = 10;
 	}
 	else if( i == 16 || (i == 17 && *s == '0') ) { /* complete keyid */
@@ -347,29 +382,27 @@
 	    if( i==33 )
 		s++;
 	    memset(fprint+16, 4, 0);
-	    for(j=0; !rc && j < 16; j++, s+=2 ) {
+	    for(j=0; j < 16; j++, s+=2 ) {
 		int c = hextobyte( s );
 		if( c == -1 )
-		    rc = G10ERR_INV_USER_ID;
-		else
-		    fprint[j] = c;
+		    return 0;
+		fprint[j] = c;
 	    }
 	    mode = 16;
 	}
 	else if( i == 40 || ( i == 41 && *s == '0' ) ) { /* sha1/rmd160 fprint*/
 	    if( i==33 )
 		s++;
-	    for(j=0; !rc && j < 20; j++, s+=2 ) {
+	    for(j=0; j < 20; j++, s+=2 ) {
 		int c = hextobyte( s );
 		if( c == -1 )
-		    rc = G10ERR_INV_USER_ID;
-		else
-		    fprint[j] = c;
+		    return 0;
+		fprint[j] = c;
 	    }
 	    mode = 20;
 	}
 	else
-	    rc = G10ERR_INV_USER_ID;
+	    return 0;
     }
     else if( *s == '=' ) { /* exact search */
 	mode = 1;
@@ -391,15 +424,47 @@
 	s++;
     }
     else if( *s == '#' ) { /* use local id */
-	rc = G10ERR_INV_USER_ID; /* not yet implemented */
+	return 0;
     }
     else if( !*s )  /* empty string */
-	rc = G10ERR_INV_USER_ID;
+	return 0;
     else
 	mode = 2;
 
-    if( rc )
+    if( retstr )
+	*retstr = s;
+    if( retlen )
+	*retlen = strlen(s);
+
+    return mode;
+}
+
+
+
+/****************
+ * Try to get the pubkey by the userid. This function looks for the
+ * first pubkey certificate which has the given name in a user_id.
+ * if pk has the pubkey algo set, the function will only return
+ * a pubkey with that algo.
+ */
+
+static int
+key_byname( int secret, GETKEY_CTX *retctx,
+	    PKT_public_key *pk, PKT_secret_key *sk,
+	    const char *name, KBNODE *ret_kb )
+{
+    int internal = 0;
+    int rc = 0;
+    const char *s;
+    u32 keyid[2] = {0}; /* init to avoid compiler warning */
+    byte fprint[20];
+    int mode;
+
+    mode = classify_user_id( name, keyid, fprint, &s, NULL );
+    if( !mode ) {
+	rc = G10ERR_INV_USER_ID;
 	goto leave;
+    }
 
     if( secret ) {
 	if( !sk ) {
@@ -414,8 +479,8 @@
 	    pk = m_alloc_clear( sizeof *pk );
 	    internal++;
 	}
-	rc = mode < 16? lookup( pk, mode, keyid, s, NULL, 1 )
-		      : lookup( pk, mode, keyid, fprint, NULL, 1 );
+	rc = mode < 16? lookup( retctx, pk, mode, keyid, s, ret_kb, 1 )
+		      : lookup( retctx, pk, mode, keyid, fprint, ret_kb, 1 );
     }
 
 
@@ -428,11 +493,46 @@
 }
 
 int
-get_pubkey_byname( PKT_public_key *pk, const char *name )
+get_pubkey_byname( GETKEY_CTX *retctx, PKT_public_key *pk,
+		   const char *name, KBNODE *ret_keyblock )
+{
+    int rc;
+
+    if( !pk ) {
+	/* fixme: key_byname should not need a pk in this case */
+	pk = m_alloc_clear( sizeof *pk );
+	rc = key_byname( 0, retctx, pk, NULL, name, ret_keyblock );
+	free_public_key( pk );
+    }
+    else
+	rc = key_byname( 0, retctx, pk, NULL, name, ret_keyblock );
+    return rc;
+}
+
+int
+get_pubkey_next( GETKEY_CTX ctx, PKT_public_key *pk, KBNODE *ret_keyblock )
 {
-    return key_byname( 0, pk, NULL, name );
+    int rc;
+
+    if( !pk ) {
+	/* fixme: lookup_read should not need a pk in this case */
+	pk = m_alloc_clear( sizeof *pk );
+	rc = lookup_read( ctx, pk, ret_keyblock );
+	free_public_key( pk );
+    }
+    else
+	rc = lookup_read( ctx, pk, ret_keyblock );
+    return rc;
 }
 
+void
+get_pubkey_end( GETKEY_CTX ctx )
+{
+    if( ctx ) {
+	lookup_close( ctx );
+	m_free( ctx );
+    }
+}
 
 /****************
  * Search for a key with the given fingerprint.
@@ -443,7 +543,7 @@
     int rc;
 
     if( fprint_len == 20 || fprint_len == 16 )
-	rc = lookup( pk, fprint_len, NULL, fprint, NULL, 0 );
+	rc = lookup( NULL, pk, fprint_len, NULL, fprint, NULL, 0 );
     else
 	rc = G10ERR_GENERAL; /* Oops */
     return rc;
@@ -461,7 +561,7 @@
     PKT_public_key *pk = m_alloc_clear( sizeof *pk );
 
     if( fprint_len == 20 || fprint_len == 16 )
-	rc = lookup( pk, fprint_len, NULL, fprint, ret_keyblock, 0 );
+	rc = lookup( NULL, pk, fprint_len, NULL, fprint, ret_keyblock, 0 );
     else
 	rc = G10ERR_GENERAL; /* Oops */
 
@@ -517,11 +617,11 @@
     int rc;
 
     if( !name && opt.def_secret_key && *opt.def_secret_key )
-	rc = key_byname( 1, NULL, sk, opt.def_secret_key );
+	rc = key_byname( 1, NULL, NULL, sk, opt.def_secret_key, NULL );
     else if( !name ) /* use the first one as default key */
 	rc = lookup_sk( sk, 15, NULL, NULL, 1 );
     else
-	rc = key_byname( 1, NULL, sk, name );
+	rc = key_byname( 1, NULL, NULL, sk, name, NULL );
     if( !rc && unprotect )
 	rc = check_secret_key( sk, 0 );
 
@@ -683,8 +783,182 @@
 }
 
 
+static KBNODE
+find_by_name( KBNODE keyblock, PKT_public_key *pk, const char *name,
+	      int mode, byte *namehash, int *use_namehash )
+{
+    KBNODE k, kk;
+
+    for(k=keyblock; k; k = k->next ) {
+	if( k->pkt->pkttype == PKT_USER_ID
+	    && !compare_name( k->pkt->pkt.user_id->name,
+			      k->pkt->pkt.user_id->len, name, mode)) {
+	    /* we found a matching name, look for the key */
+	    for(kk=keyblock; kk; kk = kk->next ) {
+		if( (	 kk->pkt->pkttype == PKT_PUBLIC_KEY
+		      || kk->pkt->pkttype == PKT_PUBLIC_SUBKEY )
+		    && ( !pk->pubkey_algo
+			 || pk->pubkey_algo
+			    == kk->pkt->pkt.public_key->pubkey_algo)
+		    && ( !pk->pubkey_usage
+			 || !check_pubkey_algo2(
+			       kk->pkt->pkt.public_key->pubkey_algo,
+						   pk->pubkey_usage ))
+		  )
+		    break;
+	    }
+	    if( kk ) {
+		u32 aki[2];
+		keyid_from_pk( kk->pkt->pkt.public_key, aki );
+		cache_user_id( k->pkt->pkt.user_id, aki );
+		rmd160_hash_buffer( namehash,
+				    k->pkt->pkt.user_id->name,
+				    k->pkt->pkt.user_id->len );
+		*use_namehash = 1;
+		return kk;
+	    }
+	    else if( is_RSA(pk->pubkey_algo) )
+		log_error("RSA key cannot be used in this version\n");
+	    else
+		log_error("No key for userid\n");
+	}
+    }
+    return NULL;
+}
+
 
+static KBNODE
+find_by_keyid( KBNODE keyblock, PKT_public_key *pk, u32 *keyid, int mode )
+{
+    KBNODE k;
 
+    if( DBG_CACHE )
+	log_debug("lookup keyid=%08lx%08lx req_algo=%d mode=%d\n",
+		   (ulong)keyid[0], (ulong)keyid[1], pk->pubkey_algo, mode );
+
+    for(k=keyblock; k; k = k->next ) {
+	if(    k->pkt->pkttype == PKT_PUBLIC_KEY
+	    || k->pkt->pkttype == PKT_PUBLIC_SUBKEY ) {
+	    u32 aki[2];
+	    keyid_from_pk( k->pkt->pkt.public_key, aki );
+	    if( DBG_CACHE )
+		log_debug("         aki=%08lx%08lx algo=%d\n",
+				(ulong)aki[0], (ulong)aki[1],
+				 k->pkt->pkt.public_key->pubkey_algo	);
+
+	    if( aki[1] == keyid[1]
+		&& ( mode == 10 || aki[0] == keyid[0] )
+		&& ( !pk->pubkey_algo
+		     || pk->pubkey_algo
+			== k->pkt->pkt.public_key->pubkey_algo) ){
+		KBNODE kk;
+		/* cache the userid */
+		for(kk=keyblock; kk; kk = kk->next )
+		    if( kk->pkt->pkttype == PKT_USER_ID )
+			break;
+		if( kk )
+		    cache_user_id( kk->pkt->pkt.user_id, aki );
+		else
+		    log_error("No userid for key\n");
+		return k; /* found */
+	    }
+	}
+    }
+    return NULL;
+}
+
+
+static KBNODE
+find_first( KBNODE keyblock, PKT_public_key *pk )
+{
+    KBNODE k;
+
+    for(k=keyblock; k; k = k->next ) {
+	if(    k->pkt->pkttype == PKT_PUBLIC_KEY
+	    || k->pkt->pkttype == PKT_PUBLIC_SUBKEY )
+	{
+	    if( !pk->pubkey_algo
+		|| pk->pubkey_algo == k->pkt->pkt.public_key->pubkey_algo )
+		return k;
+	}
+    }
+    return NULL;
+}
+
+
+static KBNODE
+find_by_fpr( KBNODE keyblock, PKT_public_key *pk, const char *name, int mode )
+{
+    KBNODE k;
+
+    for(k=keyblock; k; k = k->next ) {
+	if(    k->pkt->pkttype == PKT_PUBLIC_KEY
+	    || k->pkt->pkttype == PKT_PUBLIC_SUBKEY ) {
+	    byte afp[MAX_FINGERPRINT_LEN];
+	    size_t an;
+
+	    fingerprint_from_pk(k->pkt->pkt.public_key, afp, &an );
+
+	    if( DBG_CACHE ) {
+		u32 aki[2];
+		keyid_from_pk( k->pkt->pkt.public_key, aki );
+		log_debug("         aki=%08lx%08lx algo=%d mode=%d an=%u\n",
+				(ulong)aki[0], (ulong)aki[1],
+			k->pkt->pkt.public_key->pubkey_algo, mode, an );
+	    }
+
+	    if( an == mode
+		&& !memcmp( afp, name, an)
+		&& ( !pk->pubkey_algo
+		     || pk->pubkey_algo == k->pkt->pkt.public_key->pubkey_algo) )
+		return k;
+	}
+    }
+    return NULL;
+}
+
+
+static void
+finish_lookup( KBNODE keyblock, PKT_public_key *pk, KBNODE k, byte *namehash,
+					       int use_namehash, int primary )
+{
+    assert(    k->pkt->pkttype == PKT_PUBLIC_KEY
+	    || k->pkt->pkttype == PKT_PUBLIC_SUBKEY );
+    assert( keyblock->pkt->pkttype == PKT_PUBLIC_KEY );
+    if( primary && !pk->pubkey_usage ) {
+	copy_public_key_new_namehash( pk, keyblock->pkt->pkt.public_key,
+				      use_namehash? namehash:NULL);
+	merge_one_pk_and_selfsig( keyblock, keyblock );
+    }
+    else {
+	if( primary && pk->pubkey_usage
+	    && check_pubkey_algo2( k->pkt->pkt.public_key->pubkey_algo,
+		       pk->pubkey_usage ) == G10ERR_WR_PUBKEY_ALGO ) {
+	    /* if the usage is not correct, try to use a subkey */
+	    KBNODE save_k = k;
+
+	    for( ; k; k = k->next ) {
+		if( k->pkt->pkttype == PKT_PUBLIC_SUBKEY
+		    && !check_pubkey_algo2(
+			    k->pkt->pkt.public_key->pubkey_algo,
+					     pk->pubkey_usage ) )
+		    break;
+	    }
+	    if( !k )
+		k = save_k;
+	    else
+		log_info(_("using secondary key %08lX "
+			   "instead of primary key %08lX\n"),
+		      (ulong)keyid_from_pk( k->pkt->pkt.public_key, NULL),
+		      (ulong)keyid_from_pk( save_k->pkt->pkt.public_key, NULL)
+			);
+	}
+
+	copy_public_key_new_namehash( pk, k->pkt->pkt.public_key,
+				      use_namehash? namehash:NULL);
+	merge_one_pk_and_selfsig( keyblock, k );
+    }
+}
 
 /****************
  * Lookup a key by scanning all keyresources
@@ -704,181 +978,142 @@
  * and the caller must release it.
  */
 static int
-lookup( PKT_public_key *pk, int mode,  u32 *keyid,
+lookup( GETKEY_CTX *retctx, PKT_public_key *pk, int mode, u32 *keyid,
 	const char *name, KBNODE *ret_keyblock, int primary )
 {
+    struct getkey_ctx_s help_ctx;
+    GETKEY_CTX ctx;
     int rc;
-    KBNODE keyblock = NULL;
-    KBPOS kbpos;
+
+    if( !retctx )
+	ctx = &help_ctx;
+    else {
+	ctx = m_alloc( sizeof *ctx );
+	*retctx = ctx;
+    }
+
+    memset( ctx, 0, sizeof *ctx );
+    ctx->mode = mode;
+    if( keyid ) {
+	ctx->keyid[0] = keyid[0];
+	ctx->keyid[1] = keyid[1];
+    }
+    if( retctx ) {
+	ctx->namebuf = name? m_strdup(name) : NULL;
+	ctx->name = ctx->namebuf;
+    }
+    else
+	ctx->name = name;
+    ctx->primary = primary;
+    rc = lookup_read( ctx, pk, ret_keyblock );
+    if( !retctx )
+	lookup_close( ctx );
+    return rc;
+}
+
+static void
+lookup_close( GETKEY_CTX ctx )
+{
+    enum_keyblocks( 2, &ctx->kbpos, NULL ); /* close */
+    m_free( ctx->namebuf );
+}
+
+static int
+lookup_read( GETKEY_CTX ctx, PKT_public_key *pk, KBNODE *ret_keyblock )
+{
+    int rc;
+    KBNODE k;
     int oldmode = set_packet_list_mode(0);
     byte namehash[20];
     int use_namehash=0;
 
-    rc = enum_keyblocks( 0, &kbpos, &keyblock );
-    if( rc ) {
-	if( rc == -1 )
-	    rc = G10ERR_NO_PUBKEY;
-	else if( rc )
-	    log_error("enum_keyblocks(open) failed: %s\n", g10_errstr(rc) );
-	goto leave;
+    /* try the quick functions */
+    if( !ctx->count ) {
+	k = NULL;
+	switch( ctx->mode ) {
+	  case 10:
+	  case 11:
+	    rc = locate_keyblock_by_keyid( &ctx->kbpos, ctx->keyid,
+							ctx->mode==10, 0 );
+	    if( !rc )
+		rc = read_keyblock( &ctx->kbpos, &ctx->keyblock );
+	    if( !rc )
+		k = find_by_keyid( ctx->keyblock, pk, ctx->keyid, ctx->mode );
+	    break;
+
+	  case 16:
+	  case 20:
+	    rc = locate_keyblock_by_fpr( &ctx->kbpos, ctx->name, ctx->mode, 0 );
+	    if( !rc )
+		rc = read_keyblock( &ctx->kbpos, &ctx->keyblock );
+	    if( !rc )
+		k = find_by_fpr( ctx->keyblock, pk, ctx->name, ctx->mode );
+	    break;
+
+	  default: rc = G10ERR_UNSUPPORTED;
+	}
+	if( !rc ) {
+	    if( !k ) {
+		log_error("lookup: key has been located but was not found\n");
+		rc = G10ERR_INV_KEYRING;
+	    }
+	    else
+		finish_lookup( ctx->keyblock, pk, k, namehash, 0, ctx->primary );
+	}
     }
+    else
+	rc = G10ERR_UNSUPPORTED;
 
-    while( !(rc = enum_keyblocks( 1, &kbpos, &keyblock )) ) {
-	KBNODE k, kk;
-	if( mode < 10 ) { /* name lookup */
-	    for(k=keyblock; k; k = k->next ) {
-		if( k->pkt->pkttype == PKT_USER_ID
-		    && !compare_name( k->pkt->pkt.user_id->name,
-				      k->pkt->pkt.user_id->len, name, mode)) {
-		    /* we found a matching name, look for the key */
-		    for(kk=keyblock; kk; kk = kk->next ) {
-			if( (	 kk->pkt->pkttype == PKT_PUBLIC_KEY
-			      || kk->pkt->pkttype == PKT_PUBLIC_SUBKEY )
-			    && ( !pk->pubkey_algo
-				 || pk->pubkey_algo
-				    == kk->pkt->pkt.public_key->pubkey_algo)
-			    && ( !pk->pubkey_usage
-				 || !check_pubkey_algo2(
-				       kk->pkt->pkt.public_key->pubkey_algo,
-							   pk->pubkey_usage ))
-			  )
-			    break;
-		    }
-		    if( kk ) {
-			u32 aki[2];
-			keyid_from_pk( kk->pkt->pkt.public_key, aki );
-			cache_user_id( k->pkt->pkt.user_id, aki );
-			rmd160_hash_buffer( namehash,
-					    k->pkt->pkt.user_id->name,
-					    k->pkt->pkt.user_id->len );
-			use_namehash = 1;
-			k = kk;
-			break;
-		    }
-		    else
-			log_error("No key for userid\n");
+    /* if this was not possible, loop over all keyblocks
+     * fixme: If one of the resources in the quick functions above
+     *	      works, but the key was not found, we will not find it
+     *	      in the other resources */
+    if( rc == G10ERR_UNSUPPORTED ) {
+	if( !ctx->count )
+	    rc = enum_keyblocks( 0, &ctx->kbpos, &ctx->keyblock );
+	else
+	    rc = 0;
+	if( !rc ) {
+	    while( !(rc = enum_keyblocks( 1, &ctx->kbpos, &ctx->keyblock )) ) {
+		/* fixme: we dont enum the complete keyblock, but
+		 * use the first match and that continue with the next keyblock
+		 */
+		if( ctx->mode < 10 )
+		    k = find_by_name( ctx->keyblock, pk, ctx->name, ctx->mode,
+						    namehash, &use_namehash);
+		else if( ctx->mode == 10 ||ctx-> mode == 11 )
+		    k = find_by_keyid( ctx->keyblock, pk, ctx->keyid,
+								ctx->mode );
+		else if( ctx->mode == 15 )
+		    k = find_first( ctx->keyblock, pk );
+		else if( ctx->mode == 16 || ctx->mode == 20 )
+		    k = find_by_fpr( ctx->keyblock, pk, ctx->name, ctx->mode );
+		else
+		    BUG();
+		if( k ) {
+		    finish_lookup( ctx->keyblock, pk, k, namehash,
+						 use_namehash, ctx->primary );
+		    break; /* found */
 		}
+		release_kbnode( ctx->keyblock );
+		ctx->keyblock = NULL;
 	    }
 	}
-	else { /* keyid or fingerprint lookup */
-	    if( DBG_CACHE && (mode== 10 || mode==11) ) {
-		log_debug("lookup keyid=%08lx%08lx req_algo=%d mode=%d\n",
-				(ulong)keyid[0], (ulong)keyid[1],
-				 pk->pubkey_algo, mode );
-	    }
-	    for(k=keyblock; k; k = k->next ) {
-		if(    k->pkt->pkttype == PKT_PUBLIC_KEY
-		    || k->pkt->pkttype == PKT_PUBLIC_SUBKEY ) {
-		    if( mode == 10 || mode == 11 ) {
-			u32 aki[2];
-			keyid_from_pk( k->pkt->pkt.public_key, aki );
-			if( DBG_CACHE ) {
-			    log_debug("         aki=%08lx%08lx algo=%d\n",
-					    (ulong)aki[0], (ulong)aki[1],
-				    k->pkt->pkt.public_key->pubkey_algo    );
-			}
-			if( aki[1] == keyid[1]
-			    && ( mode == 10 || aki[0] == keyid[0] )
-			    && ( !pk->pubkey_algo
-				 || pk->pubkey_algo
-				    == k->pkt->pkt.public_key->pubkey_algo) ){
-			    /* cache the userid */
-			    for(kk=keyblock; kk; kk = kk->next )
-				if( kk->pkt->pkttype == PKT_USER_ID )
-				    break;
-			    if( kk )
-				cache_user_id( kk->pkt->pkt.user_id, aki );
-			    else
-				log_error("No userid for key\n");
-			    break; /* found */
-			}
-		    }
-		    else if( mode == 15 ) { /* get the first key */
-			if( !pk->pubkey_algo
-			    || pk->pubkey_algo
-				  == k->pkt->pkt.public_key->pubkey_algo )
-			    break;
-		    }
-		    else if( mode == 16 || mode == 20 ) {
-			byte afp[MAX_FINGERPRINT_LEN];
-			size_t an;
-
-			fingerprint_from_pk(k->pkt->pkt.public_key, afp, &an );
-
-			if( DBG_CACHE ) {
-			    u32 aki[2];
-			    keyid_from_pk( k->pkt->pkt.public_key, aki );
-			    log_debug("         aki=%08lx%08lx algo=%d mode=%d an=%u\n",
-					    (ulong)aki[0], (ulong)aki[1],
-				    k->pkt->pkt.public_key->pubkey_algo,
-							mode, an );
-			}
-			if( an == mode && !memcmp( afp, name, an)
-			    && ( !pk->pubkey_algo
-				 || pk->pubkey_algo
-				    == k->pkt->pkt.public_key->pubkey_algo) ) {
-			    break;
-			}
-		    }
-		    else
-			BUG();
-		} /* end compare public keys */
-	    }
-	}
-	if( k ) { /* found */
-	    assert(    k->pkt->pkttype == PKT_PUBLIC_KEY
-		    || k->pkt->pkttype == PKT_PUBLIC_SUBKEY );
-	    assert( keyblock->pkt->pkttype == PKT_PUBLIC_KEY );
-	    if( primary && !pk->pubkey_usage ) {
-		copy_public_key_new_namehash( pk, keyblock->pkt->pkt.public_key,
-					      use_namehash? namehash:NULL);
-		merge_one_pk_and_selfsig( keyblock, keyblock );
-	    }
-	    else {
-		if( primary && pk->pubkey_usage
-		    && check_pubkey_algo2( k->pkt->pkt.public_key->pubkey_algo,
-			       pk->pubkey_usage ) == G10ERR_WR_PUBKEY_ALGO ) {
-		    /* if the usage is not correct, try to use a subkey */
-		    KBNODE save_k = k;
-
-		    for( ; k; k = k->next ) {
-			if( k->pkt->pkttype == PKT_PUBLIC_SUBKEY
-			    && !check_pubkey_algo2(
-				    k->pkt->pkt.public_key->pubkey_algo,
-						     pk->pubkey_usage ) )
-			    break;
-		    }
-		    if( !k )
-			k = save_k;
-		    else
-			log_info(_("using secondary key %08lX "
-				   "instead of primary key %08lX\n"),
-		      (ulong)keyid_from_pk( k->pkt->pkt.public_key, NULL),
-		      (ulong)keyid_from_pk( save_k->pkt->pkt.public_key, NULL)
-				);
-		}
+	if( rc && rc != -1 )
+	    log_error("enum_keyblocks failed: %s\n", g10_errstr(rc));
+    }
 
-		copy_public_key_new_namehash( pk, k->pkt->pkt.public_key,
-					      use_namehash? namehash:NULL);
-		merge_one_pk_and_selfsig( keyblock, k );
-	    }
-	    if( ret_keyblock ) {
-		*ret_keyblock = keyblock;
-		keyblock = NULL;
-	    }
-	    break; /* enumeration */
+    if( !rc ) {
+	if( ret_keyblock ) {
+	    *ret_keyblock = ctx->keyblock;
+	    ctx->keyblock = NULL;
 	}
-	release_kbnode( keyblock );
-	keyblock = NULL;
     }
-    if( rc == -1 )
+    else if( rc == -1 )
 	rc = G10ERR_NO_PUBKEY;
-    else if( rc )
-	log_error("enum_keyblocks(read) failed: %s\n", g10_errstr(rc));
 
-  leave:
-    enum_keyblocks( 2, &kbpos, &keyblock ); /* close */
-    release_kbnode( keyblock );
+    release_kbnode( ctx->keyblock );
+    ctx->keyblock = NULL;
     set_packet_list_mode(oldmode);
     if( opt.debug & DBG_MEMSTAT_VALUE ) {
 	static int initialized;
@@ -888,18 +1123,21 @@
 	    atexit( print_stats );
 	}
 
-	assert( mode < DIM(lkup_stats) );
-	lkup_stats[mode].any = 1;
+	assert( ctx->mode < DIM(lkup_stats) );
+	lkup_stats[ctx->mode].any = 1;
 	if( !rc )
-	    lkup_stats[mode].okay_count++;
+	    lkup_stats[ctx->mode].okay_count++;
 	else if ( rc == G10ERR_NO_PUBKEY )
-	    lkup_stats[mode].nokey_count++;
+	    lkup_stats[ctx->mode].nokey_count++;
 	else
-	    lkup_stats[mode].error_count++;
+	    lkup_stats[ctx->mode].error_count++;
     }
 
+    ctx->last_rc = rc;
+    ctx->count++;
     return rc;
 }
+
 
 /****************
  * Ditto for secret keys
diff -urN gnupg-0.4.2/g10/import.c gnupg-0.4.3/g10/import.c
--- gnupg-0.4.2/g10/import.c	Wed Oct 14 10:46:26 1998
+++ gnupg-0.4.3/g10/import.c	Tue Oct 27 14:52:31 1998
@@ -36,9 +36,24 @@
 #include "i18n.h"
 
 
+static struct {
+    ulong no_user_id;
+    ulong imported;
+    ulong imported_rsa;
+    ulong n_uids;
+    ulong n_sigs;
+    ulong n_subk;
+    ulong unchanged;
+    ulong n_revoc;
+    ulong secret_read;
+    ulong secret_imported;
+    ulong secret_dups;
+} stats;
+
+
 static int read_block( IOBUF a, compress_filter_context_t *cfx,
 			     PACKET **pending_pkt, KBNODE *ret_root );
-static int import_one( const char *fname, KBNODE keyblock );
+static int import_one( const char *fname, KBNODE keyblock, int fast );
 static int import_secret_one( const char *fname, KBNODE keyblock );
 static int import_revoke_cert( const char *fname, KBNODE node );
 static int chk_self_sigs( const char *fname, KBNODE keyblock,
@@ -59,7 +74,7 @@
  * least one userid. Only user ids which are self signed will be imported.
  * Other signatures are not checked.
  *
- * Actually this functtion does a merge. It works like this:
+ * Actually this function does a merge. It works like this:
  *
  *  - get the keyblock
  *  - check self-signatures and remove all userids and their signatures
@@ -85,7 +100,7 @@
  *
  */
 int
-import_keys( const char *fname )
+import_keys( const char *fname, int fast )
 {
     armor_filter_context_t afx;
     compress_filter_context_t cfx;
@@ -93,11 +108,15 @@
     IOBUF inp = NULL;
     KBNODE keyblock;
     int rc = 0;
+    ulong count=0;
 
     memset( &afx, 0, sizeof afx);
     memset( &cfx, 0, sizeof cfx);
     afx.only_keyblocks = 1;
 
+    /* fixme: don't use static variables */
+    memset( &stats, 0, sizeof( stats ) );
+
     /* open file */
     inp = iobuf_open(fname);
     if( !fname )
@@ -112,7 +131,7 @@
 
     while( !(rc = read_block( inp, &cfx, &pending_pkt, &keyblock) )) {
 	if( keyblock->pkt->pkttype == PKT_PUBLIC_KEY )
-	    rc = import_one( fname, keyblock );
+	    rc = import_one( fname, keyblock, fast );
 	else if( keyblock->pkt->pkttype == PKT_SECRET_KEY )
 	    rc = import_secret_one( fname, keyblock );
 	else if( keyblock->pkt->pkttype == PKT_SIGNATURE
@@ -125,12 +144,41 @@
 	release_kbnode(keyblock);
 	if( rc )
 	    break;
+	if( !(++count % 100) )
+	    log_info(_("%lu keys so far processed\n"), count );
     }
     if( rc == -1 )
 	rc = 0;
     else if( rc && rc != G10ERR_INV_KEYRING )
 	log_error_f( fname, _("read error: %s\n"), g10_errstr(rc));
 
+    log_info(_("Total number processed: %lu\n"), count );
+    if( stats.no_user_id )
+	log_info(_("          w/o user IDs: %lu\n"), stats.no_user_id );
+    if( stats.imported || stats.imported_rsa ) {
+	log_info(_("              imported: %lu"), stats.imported );
+	if( stats.imported_rsa )
+	    fprintf(stderr, "  (RSA: %lu)", stats.imported_rsa );
+	putc('\n', stderr);
+    }
+    if( stats.unchanged )
+	log_info(_("             unchanged: %lu\n"), stats.unchanged );
+    if( stats.n_uids )
+	log_info(_("          new user IDs: %lu\n"), stats.n_uids );
+    if( stats.n_subk )
+	log_info(_("           new subkeys: %lu\n"), stats.n_subk );
+    if( stats.n_sigs )
+	log_info(_("        new signatures: %lu\n"), stats.n_sigs );
+    if( stats.n_revoc )
+	log_info(_("   new key revocations: %lu\n"), stats.n_revoc );
+    if( stats.secret_read )
+	log_info(_("      secret keys read: %lu\n"), stats.secret_read );
+    if( stats.secret_imported )
+	log_info(_("  secret keys imported: %lu\n"), stats.secret_imported );
+    if( stats.secret_dups )
+	log_info(_(" secret keys unchanged: %lu\n"), stats.secret_dups );
+
+
     iobuf_close(inp);
     return rc;
 }
@@ -238,7 +286,7 @@
  * which called g10.
  */
 static int
-import_one( const char *fname, KBNODE keyblock )
+import_one( const char *fname, KBNODE keyblock, int fast )
 {
     PKT_public_key *pk;
     PKT_public_key *pk_orig;
@@ -280,9 +328,12 @@
 	return rc== -1? 0:rc;
 
     if( !delete_inv_parts( fname, keyblock, keyid ) ) {
-	log_info_f( fname, _("key %08lX: no valid user ids\n"),
-						    (ulong)keyid[1]);
-	log_info(_("this may be caused by a missing self-signature\n"));
+	if( !opt.quiet ) {
+	    log_info_f( fname, _("key %08lX: no valid user ids\n"),
+							(ulong)keyid[1]);
+	    log_info(_("this may be caused by a missing self-signature\n"));
+	}
+	stats.no_user_id++;
 	return 0;
     }
 
@@ -311,7 +362,12 @@
 			_("can't write to keyring: %s\n"), g10_errstr(rc) );
 	unlock_keyblock( &kbpos );
 	/* we are ready */
-	log_info_f( fname, _("key %08lX: public key imported\n"), (ulong)keyid[1]);
+	if( !opt.quiet )
+	    log_info_f( fname, _("key %08lX: public key imported\n"),
+						      (ulong)keyid[1]);
+	stats.imported++;
+	if( is_RSA( pk->pubkey_algo ) )
+	    stats.imported_rsa++;
 	new_key = 1;
     }
     else { /* merge */
@@ -366,29 +422,39 @@
 			    _("can't write keyblock: %s\n"), g10_errstr(rc) );
 	    unlock_keyblock( &kbpos );
 	    /* we are ready */
-	    if( n_uids == 1 )
-		log_info_f(fname, _("key %08lX: 1 new user-id\n"),
-					 (ulong)keyid[1]);
-	    else if( n_uids )
-		log_info_f(fname, _("key %08lX: %d new user-ids\n"),
-					 (ulong)keyid[1], n_uids );
-	    if( n_sigs == 1 )
-		log_info_f(fname, _("key %08lX: 1 new signature\n"),
-					 (ulong)keyid[1]);
-	    else if( n_sigs )
-		log_info_f(fname, _("key %08lX: %d new signatures\n"),
-					 (ulong)keyid[1], n_sigs );
-	    if( n_subk == 1 )
-		log_info_f(fname, _("key %08lX: 1 new subkey\n"),
-					 (ulong)keyid[1]);
-	    else if( n_subk )
-		log_info_f(fname, _("key %08lX: %d new subkeys\n"),
-					 (ulong)keyid[1], n_subk );
+	    if( !opt.quiet ) {
+		if( n_uids == 1 )
+		    log_info_f(fname, _("key %08lX: 1 new user-id\n"),
+					     (ulong)keyid[1]);
+		else if( n_uids )
+		    log_info_f(fname, _("key %08lX: %d new user-ids\n"),
+					     (ulong)keyid[1], n_uids );
+		if( n_sigs == 1 )
+		    log_info_f(fname, _("key %08lX: 1 new signature\n"),
+					     (ulong)keyid[1]);
+		else if( n_sigs )
+		    log_info_f(fname, _("key %08lX: %d new signatures\n"),
+					     (ulong)keyid[1], n_sigs );
+		if( n_subk == 1 )
+		    log_info_f(fname, _("key %08lX: 1 new subkey\n"),
+					     (ulong)keyid[1]);
+		else if( n_subk )
+		    log_info_f(fname, _("key %08lX: %d new subkeys\n"),
+					     (ulong)keyid[1], n_subk );
+	    }
+
+	    stats.n_uids +=n_uids;
+	    stats.n_sigs +=n_sigs;
+	    stats.n_subk +=n_subk;
+	}
+	else {
+	    if( !opt.quiet )
+		log_info_f(fname, _("key %08lX: not changed\n"),
+						    (ulong)keyid[1] );
+	    stats.unchanged++;
 	}
-	else
-	    log_info_f(fname, _("key %08lX: not changed\n"), (ulong)keyid[1] );
     }
-    if( !rc ) {
+    if( !rc && !fast ) {
 	rc = query_trust_record( new_key? pk : pk_orig );
 	if( rc && rc != -1 )
 	    log_error("trustdb error: %s\n", g10_errstr(rc) );
@@ -399,7 +465,7 @@
 					(ulong)keyid[1], g10_errstr(rc) );
 	}
 	else if( mod_key )
-	    rc = update_trust_record( keyblock_orig );
+	    rc = update_trust_record( keyblock_orig, 1, NULL );
 	else
 	    rc = clear_trust_checked_flag( new_key? pk : pk_orig );
     }
@@ -442,6 +508,7 @@
 				  uidnode->pkt->pkt.user_id->len, 0 );
 	putc('\n', stderr);
     }
+    stats.secret_read++;
     if( !uidnode ) {
 	log_error_f(fname, _("key %08lX: no user id\n"), (ulong)keyid[1]);
 	return 0;
@@ -468,10 +535,12 @@
 	unlock_keyblock( &kbpos );
 	/* we are ready */
 	log_info_f(fname, _("key %08lX: secret key imported\n"), (ulong)keyid[1]);
+	stats.secret_imported++;
     }
     else if( !rc ) { /* we can't merge secret keys */
 	log_error_f(fname, _("key %08lX: already in secret keyring\n"),
 						(ulong)keyid[1]);
+	stats.secret_dups++;
     }
     else
 	log_error_f(fname, _("key %08lX: secret key not found: %s\n"),
@@ -569,8 +638,10 @@
 		    _("can't write keyblock: %s\n"), g10_errstr(rc) );
     unlock_keyblock( &kbpos );
     /* we are ready */
-    log_info_f(fname, _("key %08lX: revocation certificate imported\n"),
+    if( !opt.quiet )
+	log_info_f(fname, _("key %08lX: revocation certificate imported\n"),
 					(ulong)keyid[1]);
+    stats.n_revoc++;
 
   leave:
     release_kbnode( keyblock );
diff -urN gnupg-0.4.2/g10/kbnode.c gnupg-0.4.3/g10/kbnode.c
--- gnupg-0.4.2/g10/kbnode.c	Thu Oct  8 15:07:54 1998
+++ gnupg-0.4.3/g10/kbnode.c	Mon Oct 19 07:55:54 1998
@@ -46,6 +46,7 @@
     n->pkt = pkt;
     n->flag = 0;
     n->private_flag=0;
+    n->recno = 0;
     return n;
 }
 
diff -urN gnupg-0.4.2/g10/keydb.h gnupg-0.4.3/g10/keydb.h
--- gnupg-0.4.2/g10/keydb.h	Sat Oct 17 00:33:21 1998
+++ gnupg-0.4.3/g10/keydb.h	Sat Nov  7 12:53:55 1998
@@ -31,6 +31,10 @@
 
 #define MAX_FINGERPRINT_LEN 20
 
+typedef struct getkey_ctx_s *GETKEY_CTX;
+#ifndef DEFINES_GETKEY_CTX
+struct getkey_ctx_s { char hidden[1]; };
+#endif
 
 /****************
  * A Keyblock is all packets which form an entire certificate;
@@ -46,6 +50,7 @@
     PACKET *pkt;
     int flag;
     int private_flag;
+    ulong recno;  /* used while updating the trustdb */
 };
 
 
@@ -69,6 +74,7 @@
     int secret;      /* working on a secret keyring */
   #ifdef HAVE_LIBGDBM
     GDBM_FILE dbf;
+    byte keybuf[21];
   #endif
     PACKET *pkt;     /* ditto */
 };
@@ -122,8 +128,13 @@
 char *get_last_passphrase(void);
 
 /*-- getkey.c --*/
+int classify_user_id( const char *name, u32 *keyid, byte *fprint,
+		      const char **retstr, size_t *retlen );
 int get_pubkey( PKT_public_key *pk, u32 *keyid );
-int get_pubkey_byname( PKT_public_key *pk, const char *name );
+int get_pubkey_byname( GETKEY_CTX *rx, PKT_public_key *pk,
+		       const char *name, KBNODE *ret_keyblock );
+int get_pubkey_next( GETKEY_CTX ctx, PKT_public_key *pk, KBNODE *ret_keyblock );
+void get_pubkey_end( GETKEY_CTX ctx );
 int get_seckey( PKT_secret_key *sk, u32 *keyid );
 int get_pubkey_byfprint( PKT_public_key *pk, const byte *fprint,
 						 size_t fprint_len );
@@ -172,6 +183,10 @@
 int add_keyblock_resource( const char *resname, int force, int secret );
 const char *keyblock_resource_name( KBPOS *kbpos );
 int get_keyblock_handle( const char *filename, int secret, KBPOS *kbpos );
+int locate_keyblock_by_fpr( KBPOS *kbpos, const byte *fpr,
+					    int fprlen, int secret );
+int locate_keyblock_by_keyid( KBPOS *kbpos, u32 *keyid,
+					    int shortkid, int secret );
 int find_keyblock( PUBKEY_FIND_INFO info, KBPOS *kbpos );
 int find_keyblock_byname( KBPOS *kbpos, const char *username );
 int find_keyblock_bypk( KBPOS *kbpos, PKT_public_key *pk );
diff -urN gnupg-0.4.2/g10/keyedit.c gnupg-0.4.3/g10/keyedit.c
--- gnupg-0.4.2/g10/keyedit.c	Sun Oct 18 16:15:33 1998
+++ gnupg-0.4.3/g10/keyedit.c	Sun Nov  8 18:06:15 1998
@@ -215,7 +215,7 @@
     SK_LIST sk_rover = NULL;
     PKT_secret_key *sk = NULL;
     KBNODE node, uidnode;
-    PKT_public_key *primary_pk;
+    PKT_public_key *primary_pk=NULL;
     int select_all = !count_selected_uids(keyblock);
     int upd_trust = 0;
 
@@ -571,10 +571,12 @@
 	    tty_printf("\n");
 	    redisplay = 0;
 	}
-	m_free(answer);
-	answer = cpr_get(N_("keyedit.cmd"), _("Command> "));
-	cpr_kill_prompt();
-	trim_spaces(answer);
+	do {
+	    m_free(answer);
+	    answer = cpr_get(N_("keyedit.cmd"), _("Command> "));
+	    cpr_kill_prompt();
+	    trim_spaces(answer);
+	} while( *answer == '#' );
 
 	arg_number = 0;
 	if( !*answer )
@@ -645,7 +647,7 @@
 	    }
 	    else
 		tty_printf(_("Key not changed so no update needed.\n"));
-	    rc = update_trust_record( keyblock );
+	    rc = update_trust_record( keyblock, 0, NULL );
 	    if( rc )
 		log_error(_("update of trust db failed: %s\n"),
 			    g10_errstr(rc) );
@@ -703,7 +705,7 @@
 		sec_modified = modified = 1;
 		/* must update the trustdb already here, so that preferences
 		 * get listed correctly */
-		rc = update_trust_record( keyblock );
+		rc = update_trust_record( keyblock, 0, NULL );
 		if( rc ) {
 		    log_error(_("update of trust db failed: %s\n"),
 				g10_errstr(rc) );
diff -urN gnupg-0.4.2/g10/keygen.c gnupg-0.4.3/g10/keygen.c
--- gnupg-0.4.2/g10/keygen.c	Sun Oct 18 14:56:18 1998
+++ gnupg-0.4.3/g10/keygen.c	Tue Nov  3 16:03:40 1998
@@ -541,10 +541,18 @@
 static int
 has_invalid_email_chars( const char *s )
 {
+    int at_seen=0;
+
     for( ; *s; s++ ) {
 	if( *s & 0x80 )
 	    return 1;
-	if( !strchr("01234567890abcdefghijklmnopqrstuvwxyz_-.@", *s ) )
+	if( *s == '@' )
+	    at_seen=1;
+	else if( !at_seen
+		 && !strchr("01234567890abcdefghijklmnopqrstuvwxyz_-.+", *s ))
+	    return 1;
+	else if( at_seen
+		 && !strchr("01234567890abcdefghijklmnopqrstuvwxyz_-.", *s ) )
 	    return 1;
     }
     return 0;
@@ -680,6 +688,11 @@
 	if( !amail && !acomment && !amail )
 	    break;
 	m_free(uid); uid = NULL;
+    }
+    if( uid ) {
+	char *p = native_to_utf8( uid );
+	m_free( uid );
+	uid = p;
     }
     return uid;
 }
diff -urN gnupg-0.4.2/g10/keylist.c gnupg-0.4.3/g10/keylist.c
--- gnupg-0.4.2/g10/keylist.c	Fri Oct 16 10:34:39 1998
+++ gnupg-0.4.3/g10/keylist.c	Sun Nov  8 18:15:59 1998
@@ -37,6 +37,7 @@
 
 static void list_all(int);
 static void list_one(const char *name, int secret);
+static void list_keyblock( KBNODE keyblock, int secret );
 static void fingerprint( PKT_public_key *pk, PKT_secret_key *sk );
 
 
@@ -70,63 +71,105 @@
 static void
 list_all( int secret )
 {
-    int i, seq=0;
-    const char *s;
-    IOBUF a;
-
-    /* FIXME: this assumes a keyring resource is a plain keyring file */
-    while( (s = enum_keyblock_resources( &seq, secret )) ) {
-	if( !(a = iobuf_open(s)) ) {
-	    log_error(_("can't open %s: %s\n"), s, strerror(errno));
-	    continue;
-	}
-	if( seq > 1 )
-	    putchar('\n');
-	printf("%s\n", s );
-	for(i=strlen(s); i; i-- )
-	    putchar('-');
-	putchar('\n');
+    KBPOS kbpos;
+    KBNODE keyblock = NULL;
+    int rc=0;
+    int lastresno;
 
-	proc_packets( a );
-	iobuf_close(a);
+    rc = enum_keyblocks( secret? 5:0, &kbpos, &keyblock );
+    if( rc ) {
+	if( rc != -1 )
+	    log_error("enum_keyblocks(open) failed: %s\n", g10_errstr(rc) );
+	goto leave;
     }
+
+    lastresno = -1;
+    while( !(rc = enum_keyblocks( 1, &kbpos, &keyblock )) ) {
+	if( lastresno != kbpos.resno ) {
+	    const char *s = keyblock_resource_name( &kbpos );
+	    int i;
+
+	    lastresno = kbpos.resno;
+	    printf("%s\n", s );
+	    for(i=strlen(s); i; i-- )
+		putchar('-');
+	    putchar('\n');
+	}
+	merge_keys_and_selfsig( keyblock );
+	list_keyblock( keyblock, secret );
+	release_kbnode( keyblock ); keyblock = NULL;
+    }
+
+    if( rc && rc != -1 )
+	log_error("enum_keyblocks(read) failed: %s\n", g10_errstr(rc));
+
+  leave:
+    enum_keyblocks( 2, &kbpos, &keyblock ); /* close */
+    release_kbnode( keyblock );
 }
 
+
+
 static void
 list_one( const char *name, int secret )
 {
     int rc = 0;
     KBNODE keyblock = NULL;
+
+    if( secret ) {
+	KBPOS kbpos;
+
+	rc = secret? find_secret_keyblock_byname( &kbpos, name )
+		   : find_keyblock_byname( &kbpos, name );
+	if( rc ) {
+	    log_error("%s: user not found\n", name );
+	    return;
+	}
+
+	rc = read_keyblock( &kbpos, &keyblock );
+	if( rc ) {
+	    log_error("%s: keyblock read problem: %s\n", name, g10_errstr(rc) );
+	    return;
+	}
+	merge_keys_and_selfsig( keyblock );
+	list_keyblock( keyblock, secret );
+	release_kbnode( keyblock );
+    }
+    else {
+	GETKEY_CTX ctx;
+
+	rc = get_pubkey_byname( &ctx, NULL, name, &keyblock );
+	if( rc ) {
+	    log_error("%s: %s\n", name, g10_errstr(rc) );
+	    get_pubkey_end( ctx );
+	    return;
+	}
+	do {
+	    list_keyblock( keyblock, 0 );
+	    release_kbnode( keyblock );
+	} while( !get_pubkey_next( ctx, NULL, &keyblock ) );
+	get_pubkey_end( ctx );
+    }
+}
+
+
+static void
+list_keyblock( KBNODE keyblock, int secret )
+{
+    int rc = 0;
     KBNODE kbctx;
     KBNODE node;
-    KBPOS kbpos;
     PKT_public_key *pk;
     PKT_secret_key *sk;
     u32 keyid[2];
     int any=0;
     int trustletter = 0;
 
-    /* search the userid */
-    rc = secret? find_secret_keyblock_byname( &kbpos, name )
-	       : find_keyblock_byname( &kbpos, name );
-    if( rc ) {
-	log_error("%s: user not found\n", name );
-	goto leave;
-    }
-
-    /* read the keyblock */
-    rc = read_keyblock( &kbpos, &keyblock );
-    if( rc ) {
-	log_error("%s: keyblock read problem: %s\n", name, g10_errstr(rc) );
-	goto leave;
-    }
-
-
     /* get the keyid from the keyblock */
     node = find_kbnode( keyblock, secret? PKT_SECRET_KEY : PKT_PUBLIC_KEY );
     if( !node ) {
 	log_error("Oops; key lost!\n");
-	goto leave;
+	return;
     }
 
     if( secret ) {
@@ -336,11 +379,9 @@
 	    putchar(':');
 	putchar('\n');
     }
+}
 
 
-  leave:
-    release_kbnode( keyblock );
-}
 
 static void
 fingerprint( PKT_public_key *pk, PKT_secret_key *sk )
diff -urN gnupg-0.4.2/g10/main.h gnupg-0.4.3/g10/main.h
--- gnupg-0.4.2/g10/main.h	Sun Oct 18 14:56:00 1998
+++ gnupg-0.4.3/g10/main.h	Sun Nov  8 18:04:52 1998
@@ -88,6 +88,7 @@
 int overwrite_filep( const char *fname );
 int   open_outfile( const char *iname, int mode, IOBUF *a );
 IOBUF open_sigfile( const char *iname );
+void copy_options_file( const char *destdir );
 
 /*-- seskey.c --*/
 void make_session_key( DEK *dek );
@@ -100,7 +101,7 @@
 KBNODE make_mpi_comment_node( const char *s, MPI a );
 
 /*-- import.c --*/
-int import_keys( const char *filename );
+int import_keys( const char *filename, int fast );
 /*-- export.c --*/
 int export_pubkeys( STRLIST users );
 int export_seckeys( STRLIST users );
@@ -129,5 +130,7 @@
 /*-- signal.c --*/
 void init_signals(void);
 void pause_on_sigusr( int which );
+void block_all_signals(void);
+void unblock_all_signals(void);
 
 #endif /*G10_MAIN_H*/
diff -urN gnupg-0.4.2/g10/mainproc.c gnupg-0.4.3/g10/mainproc.c
--- gnupg-0.4.2/g10/mainproc.c	Wed Oct 14 12:30:17 1998
+++ gnupg-0.4.3/g10/mainproc.c	Sun Nov  8 17:43:46 1998
@@ -180,11 +180,12 @@
     if( is_ELGAMAL(enc->pubkey_algo)
 	|| enc->pubkey_algo == PUBKEY_ALGO_DSA
 	|| is_RSA(enc->pubkey_algo)  ) {
-	m_free(c->dek ); /* paranoid: delete a pending DEK */
-	c->dek = m_alloc_secure( sizeof *c->dek );
-	if( (result = get_session_key( enc, c->dek )) ) {
-	    /* error: delete the DEK */
-	    m_free(c->dek); c->dek = NULL;
+	if ( !c->dek ) {
+	    c->dek = m_alloc_secure( sizeof *c->dek );
+	    if( (result = get_session_key( enc, c->dek )) ) {
+		/* error: delete the DEK */
+		m_free(c->dek); c->dek = NULL;
+	    }
 	}
     }
     else
@@ -716,13 +717,6 @@
     c->iobuf = a;
     init_packet(pkt);
     while( (rc=parse_packet(a, pkt)) != -1 ) {
-	/* cleanup if we have an illegal data structure */
-	if( c->dek && pkt->pkttype != PKT_ENCRYPTED ) {
-	    /* FIXME: do we need to ave it in case we have no secret
-	     * key for one of the next reciepents- we should check it
-	     * here. */
-	    m_free(c->dek); c->dek = NULL; /* burn it */
-	}
 
 	if( rc ) {
 	    free_packet(pkt);
@@ -846,7 +840,7 @@
     tstr = asctimestamp(sig->timestamp);
     astr = pubkey_algo_to_string( sig->pubkey_algo );
     log_info(_("Signature made %.*s using %s key ID %08lX\n"),
-	    (int)strlen(tstr)-1, tstr, astr? astr: "?", (ulong)sig->keyid[1] );
+	    (int)strlen(tstr), tstr, astr? astr: "?", (ulong)sig->keyid[1] );
 
     rc = do_check_sig(c, node, NULL );
     if( !rc || rc == G10ERR_BAD_SIGN ) {
@@ -886,10 +880,14 @@
     c->local_id = 0;
     c->trustletter = ' ';
     if( node->pkt->pkttype == PKT_PUBLIC_KEY
-	|| node->pkt->pkttype == PKT_PUBLIC_SUBKEY )
+	|| node->pkt->pkttype == PKT_PUBLIC_SUBKEY ) {
+	merge_keys_and_selfsig( node );
 	list_node( c, node );
-    else if( node->pkt->pkttype == PKT_SECRET_KEY )
+    }
+    else if( node->pkt->pkttype == PKT_SECRET_KEY ) {
+	merge_keys_and_selfsig( node );
 	list_node( c, node );
+    }
     else if( node->pkt->pkttype == PKT_ONEPASS_SIG ) {
 	/* check all signatures */
 	if( !c->have_data ) {
diff -urN gnupg-0.4.2/g10/openfile.c gnupg-0.4.3/g10/openfile.c
--- gnupg-0.4.2/g10/openfile.c	Tue Aug 11 16:31:15 1998
+++ gnupg-0.4.3/g10/openfile.c	Sun Oct 25 19:47:52 1998
@@ -78,11 +78,11 @@
     *a = NULL;
     if( (!iname || (*iname=='-' && !iname[1])) && !opt.outfile ) {
 	if( !(*a = iobuf_create(NULL)) ) {
-	    log_error("can't open [stdout]: %s\n", strerror(errno) );
+	    log_error(_("%s: can't open: %s\n"), "[stdout]", strerror(errno) );
 	    rc = G10ERR_CREATE_FILE;
 	}
 	else if( opt.verbose )
-	    log_info("writing to stdout\n");
+	    log_info(_("writing to stdout\n"));
     }
     else {
 	char *buf=NULL;
@@ -98,11 +98,11 @@
 	}
 	if( overwrite_filep( name ) ) {
 	    if( !(*a = iobuf_create( name )) ) {
-		log_error("can't create %s: %s\n", name, strerror(errno) );
+		log_error(_("%s: can't create: %s\n"), name, strerror(errno) );
 		rc = G10ERR_CREATE_FILE;
 	    }
 	    else if( opt.verbose )
-		log_info("writing to '%s'\n", name );
+		log_info(_("writing to '%s'\n"), name );
 	}
 	else
 	    rc = G10ERR_FILE_EXISTS;
@@ -131,10 +131,54 @@
 	    buf[len-4] = 0 ;
 	    a = iobuf_open( buf );
 	    if( opt.verbose )
-		log_info("assuming signed data in '%s'\n", buf );
+		log_info(_("assuming signed data in '%s'\n"), buf );
 	    m_free(buf);
 	}
     }
     return a;
+}
+
+
+/****************
+ * Copy the option file skeleton to the given directory.
+ */
+void
+copy_options_file( const char *destdir )
+{
+    const char *datadir = GNUPG_DATADIR;
+    char *fname;
+    FILE *src, *dst;
+    int linefeeds=0;
+    int c;
+
+    fname = m_alloc( strlen(datadir) + strlen(destdir) + 15 );
+    strcpy(stpcpy(fname, datadir), "/options.skel" );
+    src = fopen( fname, "r" );
+    if( !src ) {
+	log_error(_("%s: can't open: %s\n"), fname, strerror(errno) );
+	m_free(fname);
+	return;
+    }
+    strcpy(stpcpy(fname, destdir), "/options" );
+    dst = fopen( fname, "w" );
+    if( !dst ) {
+	log_error(_("%s: can't create: %s\n"), fname, strerror(errno) );
+	fclose( src );
+	m_free(fname);
+	return;
+    }
+
+    while( (c=getc(src)) != EOF ) {
+	if( linefeeds < 3 ) {
+	    if( c == '\n' )
+		linefeeds++;
+	}
+	else
+	    putc( c, dst );
+    }
+    fclose( dst );
+    fclose( src );
+    log_info(_("%s: new options file created\n"), fname );
+    m_free(fname);
 }
 
diff -urN gnupg-0.4.2/g10/options.h gnupg-0.4.3/g10/options.h
--- gnupg-0.4.2/g10/options.h	Sun Oct 18 11:42:44 1998
+++ gnupg-0.4.3/g10/options.h	Thu Oct 22 17:35:02 1998
@@ -26,6 +26,7 @@
 
 struct {
     int verbose;
+    int quiet;
     unsigned debug;
     int armor;
     int compress;
diff -urN gnupg-0.4.2/g10/options.skel gnupg-0.4.3/g10/options.skel
--- gnupg-0.4.2/g10/options.skel	Thu Jan  1 01:00:00 1970
+++ gnupg-0.4.3/g10/options.skel	Sun Oct 25 19:59:56 1998
@@ -0,0 +1,37 @@
+These first three lines are not copied to the options file in
+the users home directory.
+$Id: options.skel,v 1.1 1998/10/25 18:59:56 koch Exp $
+# Options for GnuPG
+#
+# Unless you you specify which option file to use (with the
+# commandline option "--options filename"), GnuPG uses the
+# file ~/.gnupg/options by default.
+#
+# An option file can contain all long options which are
+# available in GnuPG. If the first non white space character of
+# a line is a '#', this line is ignored.  Empty lines are also
+# ignored.
+#
+# See the man page for a list of options.
+
+# Uncomment the next line to get rid of the copyright notice
+#no-greeting
+
+# If you have more than 1 secret key in your keyring, you may want
+# to uncomment the following option and set your preffered keyid
+
+# default-key 621CC013
+
+# The next option is enabled because this one is needed for interoperation
+# with PGP 5 users.  To enable full OpenPGP compliance you have to remove
+# this option.
+
+force-v3-sigs
+
+# Default is to use the newer compress algo 2, but PGP 5 does not
+# like this, so we use the old one
+# Hmm: Do we really need this ... preferences should decide which compress
+# algo to use.
+
+compress-algo 1
+
diff -urN gnupg-0.4.2/g10/parse-packet.c gnupg-0.4.3/g10/parse-packet.c
--- gnupg-0.4.2/g10/parse-packet.c	Sun Oct 18 16:55:17 1998
+++ gnupg-0.4.3/g10/parse-packet.c	Wed Oct 28 18:48:44 1998
@@ -633,7 +633,8 @@
 	    printf("sig expires %s", strtimestamp( buffer_to_u32(buffer) ) );
 	break;
       case SIGSUBPKT_EXPORTABLE:
-	p = "exportable";
+	if( length )
+	    printf("%sexportable", *buffer? "":"not ");
 	break;
       case SIGSUBPKT_TRUST:
 	p = "trust signature";
@@ -757,6 +758,10 @@
       case SIGSUBPKT_SIG_EXPIRE:
       case SIGSUBPKT_KEY_EXPIRE:
 	if( n < 4 )
+	    break;
+	return buffer;
+      case SIGSUBPKT_EXPORTABLE:
+	if( !n )
 	    break;
 	return buffer;
       case SIGSUBPKT_ISSUER:/* issuer key ID */
diff -urN gnupg-0.4.2/g10/pkclist.c gnupg-0.4.3/g10/pkclist.c
--- gnupg-0.4.2/g10/pkclist.c	Mon Oct 12 13:38:02 1998
+++ gnupg-0.4.3/g10/pkclist.c	Sat Nov  7 12:51:11 1998
@@ -432,7 +432,7 @@
 		free_public_key( pk );
 	    pk = m_alloc_clear( sizeof *pk );
 	    pk->pubkey_usage = usage;
-	    rc = get_pubkey_byname( pk, answer );
+	    rc = get_pubkey_byname( NULL, pk, answer, NULL );
 	    if( rc )
 		tty_printf(_("No such user ID.\n"));
 	    else if( !(rc=check_pubkey_algo2(pk->pubkey_algo, usage)) ) {
@@ -466,7 +466,7 @@
 
 	    pk = m_alloc_clear( sizeof *pk );
 	    pk->pubkey_usage = usage;
-	    if( (rc = get_pubkey_byname( pk, remusr->d )) ) {
+	    if( (rc = get_pubkey_byname( NULL, pk, remusr->d, NULL )) ) {
 		free_public_key( pk ); pk = NULL;
 		log_error(_("%s: skipped: %s\n"), remusr->d, g10_errstr(rc) );
 	    }
diff -urN gnupg-0.4.2/g10/ringedit.c gnupg-0.4.3/g10/ringedit.c
--- gnupg-0.4.2/g10/ringedit.c	Sat Oct 17 19:07:56 1998
+++ gnupg-0.4.3/g10/ringedit.c	Sat Nov  7 12:51:33 1998
@@ -35,8 +35,6 @@
  *
  *  - Delete a key block
  *
- * FIXME:  Keep track of all nodes, so that a change is propagated
- *	   to all nodes. (or use shallow copies and ref-counting?)
  */
 
 
@@ -59,10 +57,11 @@
 #include "mpi.h"
 #include "iobuf.h"
 #include "keydb.h"
+#include "host2net.h"
 #include "options.h"
+#include "main.h"
 #include "i18n.h"
 
-#undef HAVE_LIBGDBM  /* <--- not ready */
 
 struct resource_table_struct {
     int used;
@@ -88,6 +87,14 @@
 static int keyring_enum( KBPOS *kbpos, KBNODE *ret_root, int skipsigs );
 static int keyring_copy( KBPOS *kbpos, int mode, KBNODE root );
 
+#ifdef HAVE_LIBGDBM
+static int do_gdbm_store( KBPOS *kbpos, KBNODE root, int update );
+static int do_gdbm_locate( GDBM_FILE dbf, KBPOS *kbpos,
+					  const byte *fpr, int fprlen );
+static int do_gdbm_locate_by_keyid( GDBM_FILE dbf, KBPOS *kbpos, u32 *keyid );
+static int do_gdbm_read( KBPOS *kbpos, KBNODE *ret_root );
+static int do_gdbm_enum( KBPOS *kbpos, KBNODE *ret_root );
+#endif
 
 
 static RESTBL *
@@ -100,6 +107,14 @@
     return resource_table + kbpos->resno;
 }
 
+#ifdef HAVE_LIBGDBM
+static void
+fatal_gdbm_error( const char *string )
+{
+    log_fatal("gdbm failed: %s\n", string);
+}
+
+#endif /* HAVE_LIBGDBM */
 
 /****************************************************************
  ****************** public functions ****************************
@@ -139,7 +154,7 @@
 {
     static int any_secret, any_public;
     const char *resname = url;
-    IOBUF iobuf;
+    IOBUF iobuf = NULL;
     int i;
     char *filename = NULL;
     int rc = 0;
@@ -188,9 +203,35 @@
 	goto leave;
     }
 
+    /* see whether we can determine the filetype */
+    if( rt == rt_UNKNOWN ) {
+	FILE *fp = fopen( filename, "rb" );
+
+	if( fp ) {
+	    u32 magic;
+
+	    if( fread( &magic, 4, 1, fp) == 1 ) {
+		if( magic == 0x13579ace )
+		    rt = rt_GDBM;
+		else if( magic == 0xce9a5713 )
+		    log_error("%s: endianess does not match\n", url );
+		else
+		    rt = rt_RING;
+	    }
+	    else /* maybe empty: assume ring */
+		rt = rt_RING;
+	    fclose( fp );
+	}
+	else /* no file yet: create ring */
+	    rt = rt_RING;
+    }
 
     switch( rt ) {
       case rt_UNKNOWN:
+	log_error("%s: unknown resource type\n", url );
+	rc = G10ERR_GENERAL;
+	goto leave;
+
       case rt_RING:
 	iobuf = iobuf_fopen( filename, "rb" );
 	if( !iobuf && !force ) {
@@ -199,20 +240,47 @@
 	}
 
 	if( !iobuf ) {
+	    char *last_slash_in_filename;
+
+	    last_slash_in_filename = strrchr(filename, '/');
+	    *last_slash_in_filename = 0;
+
+	    if( access(filename, F_OK) ) {
+		if( strlen(filename) >= 7
+		    && !strcmp(filename+strlen(filename)-7, "/.gnupg") ) {
+		  #if __MINGW32__
+		    if( mkdir(filename) )
+		  #else
+		    if( mkdir(filename, S_IRUSR|S_IWUSR|S_IXUSR) )
+		  #endif
+		    {
+			log_error( _("%s: can't create directory: %s\n"),
+				  filename, strerror(errno));
+			rc = G10ERR_OPEN_FILE;
+			goto leave;
+		    }
+		    else
+			log_info( _("%s: directory created\n"), filename );
+		    copy_options_file( filename );
+		}
+		else
+		{
+		    rc = G10ERR_OPEN_FILE;
+		    goto leave;
+		}
+	    }
+
+	    *last_slash_in_filename = '/';
+
 	    iobuf = iobuf_create( filename );
 	    if( !iobuf ) {
-		log_error("%s: can't create: %s\n", filename, strerror(errno));
+		log_error("%s: can't create keyring: %s\n", filename, strerror(errno));
 		rc = G10ERR_OPEN_FILE;
 		goto leave;
 	    }
 	    else
 		log_info("%s: keyring created\n", filename );
 	}
-	/* fixme: see whether it is really a ring or if type is unknown,
-	 * try to figure out of what type it is
-	 */
-	rt = rt_RING; /* <--- FIXME */
-
       #ifdef __MINGW32__
 	/* must close it again */
 	iobuf_close( iobuf );
@@ -222,6 +290,17 @@
 
     #ifdef HAVE_LIBGDBM
       case rt_GDBM:
+	resource_table[i].dbf = gdbm_open( filename, 0,
+					   force? GDBM_WRCREAT : GDBM_WRITER,
+					   S_IRUSR | S_IWUSR |
+					   S_IRGRP | S_IWGRP | S_IROTH,
+					   fatal_gdbm_error );
+	if( !resource_table[i].dbf ) {
+	    log_error("%s: can't open gdbm file: %s\n",
+			    filename, gdbm_strerror(gdbm_errno));
+	    rc = G10ERR_OPEN_FILE;
+	    goto leave;
+	}
 	break;
     #endif
 
@@ -310,14 +389,21 @@
 						 resource_table[i].fname );
 		break;
 	     #ifdef HAVE_LIBGDBM
-	      case rt_GDBM
-		rc = do_gdbm_search( pkt, kbpos, resource_table[i].dbf,
-						 resource_table[i].fname );
+	      case rt_GDBM: {
+		    PKT_public_key *req_pk = pkt->pkt.public_key;
+		    byte fpr[20];
+		    size_t fprlen;
+
+		    fingerprint_from_pk( req_pk, fpr, &fprlen );
+		    rc = do_gdbm_locate( resource_table[i].dbf,
+					 kbpos, fpr, fprlen );
+		}
 		break;
 	     #endif
 	      default: BUG();
 	    }
 
+	    kbpos->rt = resource_table[i].rt;
 	    if( !rc ) {
 		kbpos->resno = i;
 		kbpos->fp = NULL;
@@ -345,7 +431,7 @@
     PKT_public_key *pk = m_alloc_clear( sizeof *pk );
     int rc;
 
-    rc = get_pubkey_byname( pk, username );
+    rc = get_pubkey_byname( NULL, pk, username, NULL );
     if( rc ) {
 	free_public_key(pk);
 	return rc;
@@ -404,6 +490,94 @@
 }
 
 
+/****************
+ * Locate a keyblock in a database which is capable of direct access
+ * Put all information into KBPOS, which can be later be to access this
+ * key block.
+ * This function looks into all registered keyblock sources.
+ *
+ * Returns: 0 if found,
+ *	    -1 if not found
+ *	    G10ERR_UNSUPPORTED if no resource is able to handle this
+ *	    or another errorcode.
+ */
+int
+locate_keyblock_by_fpr( KBPOS *kbpos, const byte *fpr, int fprlen, int secret )
+{
+    RESTBL *rentry;
+    int i, rc, any=0, last_rc=-1;
+
+
+    for(i=0, rentry = resource_table; i < MAX_RESOURCES; i++, rentry++ ) {
+	if( rentry->used && !rentry->secret == !secret ) {
+	    kbpos->rt = rentry->rt;
+	    switch( rentry->rt ) {
+	      case rt_GDBM:
+		any = 1;
+		rc = do_gdbm_locate( rentry->dbf, kbpos, fpr, fprlen );
+		break;
+	      default:
+		rc = G10ERR_UNSUPPORTED;
+		break;
+	    }
+
+	    if( !rc ) {
+		kbpos->resno = i;
+		kbpos->fp = NULL;
+		return 0;
+	    }
+	    else if( rc != -1 && rc != G10ERR_UNSUPPORTED ) {
+		log_error("error searching resource %d: %s\n",
+						  i, g10_errstr(rc));
+		last_rc = rc;
+	    }
+	}
+    }
+
+    return (last_rc == -1 && !any)? G10ERR_UNSUPPORTED : last_rc;
+}
+
+
+int
+locate_keyblock_by_keyid( KBPOS *kbpos, u32 *keyid, int shortkid, int secret )
+{
+    RESTBL *rentry;
+    int i, rc, any=0, last_rc=-1;
+
+    if( shortkid )
+	return G10ERR_UNSUPPORTED;
+
+    for(i=0, rentry = resource_table; i < MAX_RESOURCES; i++, rentry++ ) {
+	if( rentry->used && !rentry->secret == !secret ) {
+	    kbpos->rt = rentry->rt;
+	    switch( rentry->rt ) {
+	      case rt_GDBM:
+		any = 1;
+		rc = do_gdbm_locate_by_keyid( rentry->dbf, kbpos, keyid );
+		break;
+	      default:
+		rc = G10ERR_UNSUPPORTED;
+		break;
+	    }
+
+	    if( !rc ) {
+		kbpos->resno = i;
+		kbpos->fp = NULL;
+		return 0;
+	    }
+	    else if( rc != -1 && rc != G10ERR_UNSUPPORTED ) {
+		log_error("error searching resource %d: %s\n",
+						  i, g10_errstr(rc));
+		last_rc = rc;
+	    }
+	}
+    }
+
+    return (last_rc == -1 && !any)? G10ERR_UNSUPPORTED : last_rc;
+}
+
+
+
 
 /****************
  * Lock the keyblock; wait until it's available
@@ -502,7 +676,8 @@
 	    break;
 	 #ifdef HAVE_LIBGDBM
 	  case rt_GDBM:
-	    /* FIXME!!!! */
+	    /* FIXME: make sure that there is only one enum at a time */
+	    kbpos->offset = 0;
 	    break;
 	 #endif
 	  default: BUG();
@@ -521,7 +696,7 @@
 		break;
 	     #ifdef HAVE_LIBGDBM
 	      case rt_GDBM:
-		/* FIXME!!!! */
+		rc = do_gdbm_enum( kbpos, ret_root );
 		break;
 	     #endif
 	      default: BUG();
@@ -548,12 +723,12 @@
 		kbpos->fp = NULL;
 	    }
 	    break;
-	 #ifdef HAVE_LIBGDBM
 	  case rt_GDBM:
-	    /* FIXME!!!! */
 	    break;
-	 #endif
-	  default: BUG();
+	  default:
+	    log_error("OOPS in close enum_keyblocks - ignored\n");
+	    return rc;
+	    break;
 	}
 	/* release pending packet */
 	free_packet( kbpos->pkt );
@@ -583,7 +758,7 @@
 	break;
      #ifdef HAVE_LIBGDBM
       case rt_GDBM:
-	/* FIXME!!!! */
+	rc = do_gdbm_store( kbpos, root, 0 );
 	break;
      #endif
       default: BUG();
@@ -612,7 +787,8 @@
 	break;
      #ifdef HAVE_LIBGDBM
       case rt_GDBM:
-	/* FIXME!!!! */
+	log_debug("deleting gdbm keyblock is not yet implemented\n");
+	rc = 0;
 	break;
      #endif
       default: BUG();
@@ -639,7 +815,7 @@
 	break;
      #ifdef HAVE_LIBGDBM
       case rt_GDBM:
-	/* FIXME!!!! */
+	rc = do_gdbm_store( kbpos, root, 1 );
 	break;
      #endif
       default: BUG();
@@ -1129,58 +1305,179 @@
  ********** Functions which operates on GDM files ***************
  ****************************************************************/
 
+#if MAX_FINGERPRINT_LEN > 20
+  #error A GDBM keyring assumes that fingerprints are less than 21
+#endif
+
 /****************
- * search one keybox, return 0 if found, -1 if not found or an errorcode.
+ * Insert the keyblock into the GDBM database
  */
+
 static int
-do_gdbm_search( PACKET *req, KBPOS *kbpos, GDBM_FILE dbf, const char *fname )
+do_gdbm_store( KBPOS *kbpos, KBNODE root, int update )
 {
-    int rc;
-    PACKET pkt;
-    int save_mode;
-    ulong offset;
-    int pkttype = req->pkttype;
-    PKT_public_key *req_pk = req->pkt.public_key;
-    PKT_secret_key *req_sk = req->pkt.secret_key;
-
-    init_packet(&pkt);
-    save_mode = set_packet_list_mode(0);
-
+    RESTBL *rentry;
+    PKT_public_key *pk;
+    KBNODE kbctx, node;
+    IOBUF fp = NULL;
+    byte fpr[20];
+    byte contbuf[21];
+    byte keybuf[21];
+    size_t fprlen;
+    datum key, content;
+    int i, rc;
 
-    while( !(rc=search_packet(iobuf, &pkt, pkttype, &offset)) ) {
-	if( pkt.pkttype == PKT_SECRET_KEY ) {
-	    PKT_secret_key *sk = pkt.pkt.secret_key;
+    if( !(rentry = check_pos( kbpos )) )
+	return G10ERR_GENERAL;
 
-	    if(   req_sk->timestamp == sk->timestamp
-	       && req_sk->pubkey_algo == sk->pubkey_algo
-	       && !cmp_seckey( req_sk, sk) )
-		break; /* found */
+    /* construct the fingerprint which is used as the primary key */
+    node = find_kbnode( root, PKT_PUBLIC_KEY );
+    if( !node )
+	log_bug("a gdbm database can't store secret keys\n");
+    pk = node->pkt->pkt.public_key;
+
+    fingerprint_from_pk( pk, fpr, &fprlen );
+    for(i=fprlen; i < DIM(fpr); i++ )
+	fpr[i] = 0;
+
+    /* build the keyblock */
+    kbctx=NULL;
+    fp = iobuf_temp();
+    iobuf_put( fp, 1 ); /* data is a keyblock */
+    while( (node = walk_kbnode( root, &kbctx, 0 )) ) {
+	if( (rc = build_packet( fp, node->pkt )) ) {
+	    log_error("build_packet(%d) failed: %s\n",
+			node->pkt->pkttype, g10_errstr(rc) );
+	    rc = G10ERR_WRITE_FILE;
+	    goto leave;
 	}
-	else if( pkt.pkttype == PKT_PUBLIC_KEY ) {
-	    PKT_public_key *pk = pkt.pkt.public_key;
-
-	    if(   req_pk->timestamp == pk->timestamp
-	       && req_pk->pubkey_algo == pk->pubkey_algo
-	       && !cmp_pubkey( req_pk, pk ) )
-		break; /* found */
+    }
+    /* store data and key */
+    *keybuf = 1;   /* key is a padded fingerprint */
+    memcpy(keybuf+1, fpr, 20 );
+    key.dptr  = keybuf;
+    key.dsize = 21;
+    content.dptr  = iobuf_get_temp_buffer( fp );
+    content.dsize = iobuf_get_temp_length( fp );
+    rc = gdbm_store( rentry->dbf, key, content,
+				  update? GDBM_REPLACE : GDBM_INSERT );
+    if( rc ) {
+	log_error("%s: gdbm_store failed: %s\n", rentry->fname,
+			    rc == 1 ? "already stored"
+				    : gdbm_strerror(gdbm_errno) );
+	rc = G10ERR_WRITE_FILE;
+	goto leave;
+    }
+    /* now store all keyids */
+    *contbuf = 2;  /* data is a list of fingerprints */
+    memcpy(contbuf+1, fpr, 20 );
+    content.dptr = contbuf;
+    content.dsize= 21;
+    kbctx=NULL;
+    while( (node = walk_kbnode( root, &kbctx, 0 )) ) {
+	if(    node->pkt->pkttype == PKT_PUBLIC_KEY
+	    || node->pkt->pkttype == PKT_PUBLIC_SUBKEY ) {
+	    u32 aki[2];
+
+	    keyid_from_pk( node->pkt->pkt.public_key, aki );
+	    *keybuf = 2; /* key is a 8 byte keyid */
+	    u32tobuf( keybuf+1	, aki[0] );
+	    u32tobuf( keybuf+5, aki[1] );
+	    key.dptr = keybuf;
+	    key.dsize= 9;
+	    /* fixme: must be more clever when a insert failed:
+	     *	      build a list of fingerprints in this case */
+	    rc = gdbm_store( rentry->dbf, key, content,
+					  update? GDBM_REPLACE : GDBM_INSERT );
+	    if( rc ) {
+		log_info("%s: gdbm_store keyid failed: %s\n", rentry->fname,
+				    rc == 1 ? "already stored"
+					    : gdbm_strerror(gdbm_errno) );
+		rc = 0;
+	    }
 	}
-	else
-	    BUG();
-	free_packet(&pkt);
     }
-    if( !rc )
-	kbpos->offset = offset;
 
   leave:
-    free_packet(&pkt);
-    set_packet_list_mode(save_mode);
-  #if __MINGW32__
-    iobuf_close(iobuf);
-  #endif
+    iobuf_close(fp); /* don't need a cancel because it is a temp iobuf */
     return rc;
 }
 
 
+
+/****************
+ * search one keybox, return 0 if found, -1 if not found or an errorcode.
+ */
+static int
+do_gdbm_locate( GDBM_FILE dbf, KBPOS *kbpos, const byte *fpr, int fprlen )
+{
+    byte *keybuf = kbpos->keybuf;
+    datum key;
+    int i;
+
+    *keybuf = 1;
+    for(i=0; i < fprlen; i++ )
+	keybuf[i+1] = fpr[i];
+    for(; i < 20; i++ )
+	keybuf[i+1] = 0;
+
+    /* fetch the data */
+    key.dptr  = keybuf;
+    key.dsize = 21;
+    if( !gdbm_exists( dbf, key ) )
+	return -1; /* not found */
+    return 0;
+}
+
+/****************
+ * locate by keyid.
+ * FIXME: we must have a way to enumerate thru the list opf fingerprints
+ */
+static int
+do_gdbm_locate_by_keyid( GDBM_FILE dbf, KBPOS *kbpos, u32 *keyid )
+{
+    byte keybuf[9];
+    datum key, content;
+    int rc;
+
+    /* construct the fingerprint which is used as the primary key */
+    *keybuf = 2;
+    u32tobuf( keybuf+1, keyid[0] );
+    u32tobuf( keybuf+5, keyid[1] );
+
+    /* fetch the data */
+    key.dptr  = keybuf;
+    key.dsize = 9;
+    content = gdbm_fetch( dbf, key );
+    if( !content.dptr )
+	return -1;
+
+    if( content.dsize < 2 ) {
+	log_error("gdbm_fetch did not return enough data\n" );
+	free( content.dptr ); /* can't use m_free() here */
+	return G10ERR_INV_KEYRING;
+    }
+    if( *content.dptr != 2 ) {
+	log_error("gdbm_fetch returned unexpected type %d\n",
+		    *(byte*)content.dptr );
+	free( content.dptr ); /* can't use m_free() here */
+	return G10ERR_INV_KEYRING;
+    }
+    if( content.dsize < 21 ) {
+	log_error("gdbm_fetch did not return a complete fingerprint\n" );
+	free( content.dptr ); /* can't use m_free() here */
+	return G10ERR_INV_KEYRING;
+    }
+    if( content.dsize > 21 )
+	log_info("gdbm_fetch: warning: more than one fingerprint\n" );
+
+    rc = do_gdbm_locate( dbf, kbpos, content.dptr+1, 20 );
+    free( content.dptr ); /* can't use m_free() here */
+    return rc;
+}
+
+
+
 static int
 do_gdbm_read( KBPOS *kbpos, KBNODE *ret_root )
 {
@@ -1189,22 +1486,32 @@
     RESTBL *rentry;
     KBNODE root = NULL;
     IOBUF a;
-    int in_cert = 0;
+    datum key, content;
 
     if( !(rentry=check_pos(kbpos)) )
 	return G10ERR_GENERAL;
 
-    a = iobuf_fopen( rentry->fname, "rb" );
-    if( !a ) {
-	log_error("can't open '%s'\n", rentry->fname );
-	return G10ERR_OPEN_FILE;
+    key.dptr  = kbpos->keybuf;
+    key.dsize = 21;
+    content = gdbm_fetch( rentry->dbf, key );
+    if( !content.dptr ) {
+	log_error("gdbm_fetch failed: %s\n", gdbm_strerror(gdbm_errno) );
+	return G10ERR_INV_KEYRING;
+    }
+    if( content.dsize < 2 ) {
+	log_error("gdbm_fetch did not return enough data\n" );
+	free( content.dptr ); /* can't use m_free() here */
+	return G10ERR_INV_KEYRING;
+    }
+    if( *content.dptr != 1 ) {
+	log_error("gdbm_fetch returned unexpected type %d\n",
+		    *(byte*)content.dptr );
+	free( content.dptr ); /* can't use m_free() here */
+	return G10ERR_INV_KEYRING;
     }
 
-    if( iobuf_seek( a, kbpos->offset ) ) {
-	log_error("can't seek to %lu\n", kbpos->offset);
-	iobuf_close(a);
-	return G10ERR_KEYRING_OPEN;
-    }
+    a = iobuf_temp_with_content( content.dptr+1, content.dsize-1 );
+    free( content.dptr ); /* can't use m_free() here */
 
     pkt = m_alloc( sizeof *pkt );
     init_packet(pkt);
@@ -1214,7 +1521,7 @@
 	    if( rc != G10ERR_UNKNOWN_PACKET ) {
 		log_error("read_keyblock: read error: %s\n", g10_errstr(rc) );
 		rc = G10ERR_INV_KEYRING;
-		goto ready;
+		break;
 	    }
 	    kbpos->count++;
 	    free_packet( pkt );
@@ -1222,27 +1529,16 @@
 	    continue;
 	}
 	/* make a linked list of all packets */
-	switch( pkt->pkttype ) {
-	  case PKT_PUBLIC_KEY:
-	  case PKT_SECRET_KEY:
-	    if( in_cert )
-		goto ready;
-	    in_cert = 1;
-	  default:
-	    kbpos->count++;
-	    if( !root )
-		root = new_kbnode( pkt );
-	    else
-		add_kbnode( root, new_kbnode( pkt ) );
-	    pkt = m_alloc( sizeof *pkt );
-	    init_packet(pkt);
-	    break;
-	}
+	kbpos->count++;
+	if( !root )
+	    root = new_kbnode( pkt );
+	else
+	    add_kbnode( root, new_kbnode( pkt ) );
+	pkt = m_alloc( sizeof *pkt );
+	init_packet(pkt);
     }
-  ready:
     if( rc == -1 && root )
 	rc = 0;
-
     if( rc )
 	release_kbnode( root );
     else
@@ -1254,84 +1550,43 @@
 }
 
 
+/****************
+ * Enum over keyblok data
+ */
 static int
-do_gdbm_enum( KBPOS *kbpos, KBNODE *ret_root, int skipsigs )
+do_gdbm_enum( KBPOS *kbpos, KBNODE *ret_root )
 {
-    PACKET *pkt;
-    int rc;
     RESTBL *rentry;
-    KBNODE root = NULL;
+    datum key, helpkey;
 
     if( !(rentry=check_pos(kbpos)) )
 	return G10ERR_GENERAL;
 
-    if( kbpos->pkt ) {
-	root = new_kbnode( kbpos->pkt );
-	kbpos->pkt = NULL;
+    if( !kbpos->offset ) {
+	kbpos->offset = 1;
+	key = gdbm_firstkey( rentry->dbf );
     }
-
-    pkt = m_alloc( sizeof *pkt );
-    init_packet(pkt);
-    while( (rc=parse_packet(kbpos->fp, pkt)) != -1 ) {
-	if( rc ) {  /* ignore errors */
-	    if( rc != G10ERR_UNKNOWN_PACKET ) {
-		log_error("read_keyblock: read error: %s\n", g10_errstr(rc) );
-		rc = G10ERR_INV_KEYRING;
-		goto ready;
-	    }
-	    free_packet( pkt );
-	    init_packet( pkt );
-	    continue;
-	}
-	/* make a linked list of all packets */
-	switch( pkt->pkttype ) {
-	  case PKT_PUBLIC_KEY:
-	  case PKT_SECRET_KEY:
-	    if( root ) { /* store this packet */
-		kbpos->pkt = pkt;
-		pkt = NULL;
-		goto ready;
-	    }
-	    root = new_kbnode( pkt );
-	    pkt = m_alloc( sizeof *pkt );
-	    init_packet(pkt);
-	    break;
-
-	  default:
-	    /* skip pakets at the beginning of a keyring, until we find
-	     * a start packet; issue a warning if it is not a comment */
-	    if( !root && pkt->pkttype != PKT_COMMENT
-		      && pkt->pkttype != PKT_OLD_COMMENT ) {
-		log_info("keyring_enum: skipped packet of type %d\n",
-			    pkt->pkttype );
-		break;
-	    }
-	    if( !root || (skipsigs && ( pkt->pkttype == PKT_SIGNATURE
-				      ||pkt->pkttype == PKT_COMMENT
-				      ||pkt->pkttype == PKT_OLD_COMMENT )) ) {
-		init_packet(pkt);
-		break;
-	    }
-	    add_kbnode( root, new_kbnode( pkt ) );
-	    pkt = m_alloc( sizeof *pkt );
-	    init_packet(pkt);
-	    break;
-	}
-    }
-  ready:
-    if( rc == -1 && root )
-	rc = 0;
-
-    if( rc )
-	release_kbnode( root );
-    else
-	*ret_root = root;
-    free_packet( pkt );
-    m_free( pkt );
-
-    return rc;
+    else {
+	helpkey.dptr = kbpos->keybuf;
+	helpkey.dsize= 21;
+	key = gdbm_nextkey( rentry->dbf, helpkey );
+    }
+    while( key.dptr && (!key.dsize || *key.dptr != 1) ) {
+	helpkey = key;
+	key = gdbm_nextkey( rentry->dbf, helpkey );
+	free( helpkey.dptr ); /* free and not m_free() ! */
+    }
+    if( !key.dptr )
+	return -1; /* eof */
+
+    if( key.dsize < 21 ) {
+	free( key.dptr ); /* free and not m_free() ! */
+	log_error("do_gdm_enum: key is too short\n" );
+	return G10ERR_INV_KEYRING;
+    }
+    memcpy( kbpos->keybuf, key.dptr, 21 );
+    free( key.dptr ); /* free and not m_free() ! */
+    return do_gdbm_read( kbpos, ret_root );
 }
 
 #endif /*HAVE_LIBGDBM*/
-
-
diff -urN gnupg-0.4.2/g10/sig-check.c gnupg-0.4.3/g10/sig-check.c
--- gnupg-0.4.2/g10/sig-check.c	Wed Oct 14 12:33:46 1998
+++ gnupg-0.4.3/g10/sig-check.c	Fri Oct 30 16:43:31 1998
@@ -278,12 +278,27 @@
 	rc = do_check( pk, sig, md );
 	md_close(md);
     }
+    else if( sig->sig_class == 0x28 ) { /* subkey revocation */
+	KBNODE snode = find_prev_kbnode( root, node, PKT_PUBLIC_SUBKEY );
+
+	if( snode ) {
+	    md = md_open( algo, 0 );
+	    hash_public_key( md, pk );
+	    hash_public_key( md, snode->pkt->pkt.public_key );
+	    rc = do_check( pk, sig, md );
+	    md_close(md);
+	}
+	else {
+	    log_error("no subkey for subkey revocation packet\n");
+	    rc = G10ERR_SIG_CLASS;
+	}
+    }
     else if( sig->sig_class == 0x18 ) {
 	KBNODE snode = find_prev_kbnode( root, node, PKT_PUBLIC_SUBKEY );
 
 	if( snode ) {
-	    if( is_selfsig ) {
-		u32 keyid[2];
+	    if( is_selfsig ) {	/* does this make sense????? */
+		u32 keyid[2];	/* it should always be a selfsig */
 
 		keyid_from_pk( pk, keyid );
 		if( keyid[0] == sig->keyid[0] && keyid[1] == sig->keyid[1] )
diff -urN gnupg-0.4.2/g10/sign.c gnupg-0.4.3/g10/sign.c
--- gnupg-0.4.2/g10/sign.c	Sun Oct 18 11:49:01 1998
+++ gnupg-0.4.3/g10/sign.c	Sun Oct 25 19:21:33 1998
@@ -108,9 +108,6 @@
     SK_LIST sk_rover = NULL;
     int old_style = 0;
 
-    if( opt.force_v3_sigs )
-	return 1;
-
     /* if there are only old style capable key we use the old sytle */
     for( sk_rover = sk_list; sk_rover; sk_rover = sk_rover->next ) {
 	PKT_secret_key *sk = sk_rover->sk;
@@ -159,7 +156,6 @@
     int compr_algo = -1; /* unknown */
 
 
-
     memset( &afx, 0, sizeof afx);
     memset( &zfx, 0, sizeof zfx);
     memset( &mfx, 0, sizeof mfx);
@@ -181,6 +177,7 @@
 	goto leave;
     if( !old_style )
 	old_style = only_old_style( sk_list );
+
     if( encrypt ) {
 	if( (rc=build_pk_list( remusr, &pk_list, PUBKEY_USAGE_ENC )) )
 	    goto leave;
@@ -256,7 +253,7 @@
 	int skcount=0;
 	/* loop over the secret certificates and build headers
 	 * The specs now say that the data should be bracket by
-	 * the onepass-sig and signature-packet; so we muts build it
+	 * the onepass-sig and signature-packet; so we must build it
 	 * here in reverse order */
 	for( sk_rover = sk_list; sk_rover; sk_rover = sk_rover->next )
 	    skcount++;
@@ -323,10 +320,11 @@
     }
     else {
 	if( fname || opt.set_filename ) {
-	    const char *s = opt.set_filename ? opt.set_filename : fname;
+	    char *s = make_basename( opt.set_filename ? opt.set_filename : fname );
 	    pt = m_alloc( sizeof *pt + strlen(s) - 1 );
 	    pt->namelen = strlen(s);
 	    memcpy(pt->name, s, pt->namelen );
+	    m_free(s);
 	}
 	else { /* no filename */
 	    pt = m_alloc( sizeof *pt - 1 );
@@ -372,7 +370,7 @@
 	/* build the signature packet */
 	/* fixme: this code is partly duplicated in make_keysig_packet */
 	sig = m_alloc_clear( sizeof *sig );
-	sig->version = old_style? 3 : sk->version;
+	sig->version = old_style || opt.force_v3_sigs ? 3 : sk->version;
 	keyid_from_sk( sk, sig->keyid );
 	sig->digest_algo = hash_for(sk->pubkey_algo);
 	sig->pubkey_algo = sk->pubkey_algo;
@@ -608,7 +606,7 @@
 	/* build the signature packet */
 	/* fixme: this code is duplicated above */
 	sig = m_alloc_clear( sizeof *sig );
-	sig->version = old_style? 3 : sk->version;
+	sig->version = old_style || opt.force_v3_sigs ? 3 : sk->version;
 	keyid_from_sk( sk, sig->keyid );
 	sig->digest_algo = hash_for(sk->pubkey_algo);
 	sig->pubkey_algo = sk->pubkey_algo;
diff -urN gnupg-0.4.2/g10/signal.c gnupg-0.4.3/g10/signal.c
--- gnupg-0.4.2/g10/signal.c	Wed Oct  7 17:01:08 1998
+++ gnupg-0.4.3/g10/signal.c	Thu Oct 29 18:51:10 1998
@@ -121,3 +121,42 @@
   #endif
 }
 
+
+static void
+do_block( int block )
+{
+  #ifndef __MINGW32__
+    static int is_blocked;
+    static sigset_t oldmask;
+
+    if( block ) {
+	sigset_t newmask;
+
+	if( is_blocked )
+	    log_bug("signals are already blocked\n");
+	sigfillset( &newmask );
+	sigprocmask( SIG_BLOCK, &newmask, &oldmask );
+	is_blocked = 1;
+    }
+    else {
+	if( !is_blocked )
+	    log_bug("signals are not blocked\n");
+	sigprocmask( SIG_SETMASK, &oldmask, NULL );
+	is_blocked = 0;
+    }
+  #endif /*__MINGW32__*/
+}
+
+
+void
+block_all_signals()
+{
+    do_block(1);
+}
+
+void
+unblock_all_signals()
+{
+    do_block(0);
+}
+
diff -urN gnupg-0.4.2/g10/tdbio.c gnupg-0.4.3/g10/tdbio.c
--- gnupg-0.4.2/g10/tdbio.c	Sat Oct 17 17:40:15 1998
+++ gnupg-0.4.3/g10/tdbio.c	Sun Nov  8 18:05:29 1998
@@ -56,9 +56,11 @@
     char data[TRUST_RECORD_LEN];
 };
 
-#define MAX_CACHE_ENTRIES    200
+#define MAX_CACHE_ENTRIES_SOFT	200   /* may be increased while in a */
+#define MAX_CACHE_ENTRIES_HARD	1000  /* transaction to this one */
 static CACHE_CTRL cache_list;
 static int cache_entries;
+static int cache_is_dirty;
 
 /* a type used to pass infomation to cmp_krec_fpr */
 struct cmp_krec_fpr_struct {
@@ -76,6 +78,7 @@
 
 static char *db_name;
 static int  db_fd = -1;
+static int in_transaction;
 
 
 static void open_db(void);
@@ -143,8 +146,10 @@
 	else if( r->recno == recno ) {
 	    if( !r->flags.dirty ) {
 		/* Hmmm: should we use a a copy and compare? */
-		if( memcmp(r->data, data, TRUST_RECORD_LEN ) )
+		if( memcmp(r->data, data, TRUST_RECORD_LEN ) ) {
 		    r->flags.dirty = 1;
+		    cache_is_dirty = 1;
+		}
 	    }
 	    memcpy( r->data, data, TRUST_RECORD_LEN );
 	    return 0;
@@ -163,11 +168,12 @@
 	r->recno = recno;
 	memcpy( r->data, data, TRUST_RECORD_LEN );
 	r->flags.dirty = 1;
+	cache_is_dirty = 1;
 	cache_entries++;
 	return 0;
     }
     /* see whether we reached the limit */
-    if( cache_entries < MAX_CACHE_ENTRIES ) { /* no */
+    if( cache_entries < MAX_CACHE_ENTRIES_SOFT ) { /* no */
 	r = m_alloc( sizeof *r );
 	r->flags.used = 1;
 	r->recno = recno;
@@ -175,6 +181,7 @@
 	r->flags.dirty = 1;
 	r->next = cache_list;
 	cache_list = r;
+	cache_is_dirty = 1;
 	cache_entries++;
 	return 0;
     }
@@ -199,10 +206,31 @@
 	r->recno = recno;
 	memcpy( r->data, data, TRUST_RECORD_LEN );
 	r->flags.dirty = 1;
+	cache_is_dirty = 1;
 	cache_entries++;
 	return 0;
     }
     /* no clean entries: have to flush some dirty entries */
+    if( in_transaction ) {
+	/* but we can't do this while in a transaction
+	 * we increase the cache size instead */
+	if( cache_entries < MAX_CACHE_ENTRIES_HARD ) { /* no */
+	    if( !(cache_entries % 100) )
+		log_info("increasing tdbio cache size\n");
+	    r = m_alloc( sizeof *r );
+	    r->flags.used = 1;
+	    r->recno = recno;
+	    memcpy( r->data, data, TRUST_RECORD_LEN );
+	    r->flags.dirty = 1;
+	    r->next = cache_list;
+	    cache_list = r;
+	    cache_is_dirty = 1;
+	    cache_entries++;
+	    return 0;
+	}
+	log_info("hard cache size limit reached\n");
+	return G10ERR_RESOURCE_LIMIT;
+    }
     if( dirty_count ) {
 	int n = dirty_count / 5; /* discard some dirty entries */
 	if( !n )
@@ -226,6 +254,7 @@
 	r->recno = recno;
 	memcpy( r->data, data, TRUST_RECORD_LEN );
 	r->flags.dirty = 1;
+	cache_is_dirty = 1;
 	cache_entries++;
 	return 0;
     }
@@ -233,16 +262,27 @@
 }
 
 
+int
+tdbio_is_dirty()
+{
+    return cache_is_dirty;
+}
+
 
 /****************
- * Sync the cache to disk
+ * Flush the cache.  This cannot be used while in a transaction.
  */
-
 int
 tdbio_sync()
 {
     CACHE_CTRL r;
 
+    if( in_transaction )
+	log_bug("tdbio: syncing while in transaction\n");
+
+    if( !cache_is_dirty )
+	return 0;
+
     for( r = cache_list; r; r = r->next ) {
 	if( r->flags.used && r->flags.dirty ) {
 	    int rc = write_cache_item( r );
@@ -250,6 +290,68 @@
 		return rc;
 	}
     }
+    cache_is_dirty = 0;
+    return 0;
+}
+
+
+
+/****************
+ * Simple transactions system:
+ * Everything between begin_transaction and end/cancel_transaction
+ * is not immediatly written but at the time of end_transaction.
+ *
+ */
+int
+tdbio_begin_transaction()
+{
+    int rc;
+
+    if( in_transaction )
+	log_bug("tdbio: nested transactions\n");
+    /* flush everything out */
+    rc = tdbio_sync();
+    if( rc )
+	return rc;
+    in_transaction = 1;
+    return 0;
+}
+
+int
+tdbio_end_transaction()
+{
+    int rc;
+
+    if( !in_transaction )
+	log_bug("tdbio: no active transaction\n");
+    block_all_signals();
+    in_transaction = 0;
+    rc = tdbio_sync();
+    unblock_all_signals();
+    return rc;
+}
+
+int
+tdbio_cancel_transaction()
+{
+    CACHE_CTRL r;
+
+    if( !in_transaction )
+	log_bug("tdbio: no active transaction\n");
+
+    /* remove all dirty marked entries, so that the original ones
+     * are read back the next time */
+    if( cache_is_dirty ) {
+	for( r = cache_list; r; r = r->next ) {
+	    if( r->flags.used && r->flags.dirty ) {
+		r->flags.used = 0;
+		cache_entries--;
+	    }
+	}
+	cache_is_dirty = 0;
+    }
+
+    in_transaction = 0;
     return 0;
 }
 
@@ -269,7 +371,7 @@
 
     if( access( fname, R_OK ) ) {
 	if( errno != ENOENT ) {
-	    log_error_f( fname, _("can't access: %s\n"), strerror(errno) );
+	    log_error( _("%s: can't access: %s\n"), fname, strerror(errno) );
 	    m_free(fname);
 	    return G10ERR_TRUSTDB;
 	}
@@ -289,17 +391,20 @@
 		  #else
 		    if( mkdir( fname, S_IRUSR|S_IWUSR|S_IXUSR ) )
 		  #endif
-			log_fatal_f( fname, _("can't create directory: %s\n"),
-							    strerror(errno) );
+			log_fatal( _("%s: can't create directory: %s\n"),
+						    fname,  strerror(errno) );
+		    else
+			log_info( _("%s: directory created\n"), fname );
+		    copy_options_file( fname );
 		}
 		else
-		    log_fatal_f(fname, _("directory does not exist!\n") );
+		    log_fatal( _("%s: directory does not exist!\n"), fname );
 	    }
 	    *p = '/';
 
 	    fp =fopen( fname, "wb" );
 	    if( !fp )
-		log_fatal_f( fname, _("can't create: %s\n"), strerror(errno) );
+		log_fatal( _("%s: can't create: %s\n"), fname, strerror(errno) );
 	    fclose(fp);
 	    m_free(db_name);
 	    db_name = fname;
@@ -309,7 +414,7 @@
 	    db_fd = open( db_name, O_RDWR );
 	  #endif
 	    if( db_fd == -1 )
-		log_fatal_f( db_name, _("can't open: %s\n"), strerror(errno) );
+		log_fatal( _("%s: can't open: %s\n"), db_name, strerror(errno) );
 
 	    memset( &rec, 0, sizeof rec );
 	    rec.r.ver.version = 2;
@@ -320,11 +425,14 @@
 	    if( !rc )
 		tdbio_sync();
 	    if( rc )
-		log_fatal_f( fname, _("failed to create version record: %s"),
-							       g10_errstr(rc));
+		log_fatal( _("%s: failed to create version record: %s"),
+						   fname, g10_errstr(rc));
 	    /* and read again to check that we are okay */
 	    if( tdbio_read_record( 0, &rec, RECTYPE_VER ) )
-		log_fatal_f( db_name, "invalid trust-db created\n" );
+		log_fatal( _("%s: invalid trust-db created\n"), db_name );
+
+	    log_info(_("%s: trust-db created\n"), db_name);
+
 	    return 0;
 	}
     }
@@ -354,9 +462,9 @@
     db_fd = open( db_name, O_RDWR );
   #endif
     if( db_fd == -1 )
-	log_fatal_f( db_name, _("can't open: %s\n"), strerror(errno) );
+	log_fatal( _("%s: can't open: %s\n"), db_name, strerror(errno) );
     if( tdbio_read_record( 0, &rec, RECTYPE_VER ) )
-	log_fatal_f( db_name, _("invalid trust-db\n") );
+	log_fatal( _("%s: invalid trust-db\n"), db_name );
     /* fixme: check ->locked and other stuff */
 }
 
@@ -390,16 +498,16 @@
 	 rec.recnum = recnum;
 	 rc = tdbio_write_record( &rec );
 	 if( rc )
-	     log_fatal_f(db_name,_("failed to create hashtable: %s\n"),
-						 g10_errstr(rc));
+	     log_fatal( _("%s: failed to create hashtable: %s\n"),
+					db_name, g10_errstr(rc));
     }
     /* update the version record */
     rc = tdbio_write_record( vr );
     if( !rc )
 	rc = tdbio_sync();
     if( rc )
-	log_fatal_f( db_name, _("error updating version record: %s\n"),
-							     g10_errstr(rc));
+	log_fatal( _("%s: error updating version record: %s\n"),
+						  db_name, g10_errstr(rc));
 }
 
 
@@ -418,8 +526,8 @@
 
 	rc = tdbio_read_record( 0, &vr, RECTYPE_VER );
 	if( rc )
-	    log_fatal_f( db_name, _("error reading version record: %s\n"),
-							    g10_errstr(rc) );
+	    log_fatal( _("%s: error reading version record: %s\n"),
+					    db_name, g10_errstr(rc) );
 	if( !vr.r.ver.keyhashtbl )
 	    create_hashtable( &vr, 0 );
 
@@ -443,8 +551,8 @@
 
 	rc = tdbio_read_record( 0, &vr, RECTYPE_VER );
 	if( rc )
-	    log_fatal_f( db_name, _("error reading version record: %s\n"),
-							    g10_errstr(rc) );
+	    log_fatal( _("%s: error reading version record: %s\n"),
+						    db_name, g10_errstr(rc) );
 	if( !vr.r.ver.sdirhashtbl )
 	    create_hashtable( &vr, 1 );
 
@@ -744,14 +852,14 @@
 		    rec->r.dir.uidlist,
 		    rec->r.dir.cacherec,
 		    rec->r.dir.ownertrust );
-	if( rec->r.dir.dirflags & DIRF_ERROR )
-	    fputs(", error", fp );
-	if( rec->r.dir.dirflags & DIRF_CHECKED )
-	    fputs(", checked", fp );
-	if( rec->r.dir.dirflags & DIRF_REVOKED )
-	    fputs(", revoked", fp );
-	if( rec->r.dir.dirflags & DIRF_MISKEY )
-	    fputs(", miskey", fp );
+	if( rec->r.dir.dirflags & DIRF_CHECKED ) {
+	    if( rec->r.dir.dirflags & DIRF_VALID )
+		fputs(", valid", fp );
+	    if( rec->r.dir.dirflags & DIRF_EXPIRED )
+		fputs(", expired", fp );
+	    if( rec->r.dir.dirflags & DIRF_REVOKED )
+		fputs(", revoked", fp );
+	}
 	putc('\n', fp);
 	break;
       case RECTYPE_KEY:
@@ -761,8 +869,14 @@
 		   rec->r.key.pubkey_algo );
 	for(i=0; i < rec->r.key.fingerprint_len; i++ )
 	    fprintf(fp, "%02X", rec->r.key.fingerprint[i] );
-	if( rec->r.key.keyflags & KEYF_REVOKED )
-	    fputs(", revoked", fp );
+	if( rec->r.key.keyflags & KEYF_CHECKED ) {
+	    if( rec->r.key.keyflags & KEYF_VALID )
+		fputs(", valid", fp );
+	    if( rec->r.key.keyflags & KEYF_EXPIRED )
+		fputs(", expired", fp );
+	    if( rec->r.key.keyflags & KEYF_REVOKED )
+		fputs(", revoked", fp );
+	}
 	putc('\n', fp);
 	break;
       case RECTYPE_UID:
@@ -772,12 +886,12 @@
 		    rec->r.uid.prefrec,
 		    rec->r.uid.siglist,
 		    rec->r.uid.namehash[18], rec->r.uid.namehash[19]);
-	if( rec->r.uid.uidflags & UIDF_CHECKED )
-	    fputs(", checked", fp );
-	if( rec->r.uid.uidflags & UIDF_VALID )
-	    fputs(", valid", fp );
-	if( rec->r.uid.uidflags & UIDF_REVOKED )
-	    fputs(", revoked", fp );
+	if( rec->r.uid.uidflags & UIDF_CHECKED ) {
+	    if( rec->r.uid.uidflags & UIDF_VALID )
+		fputs(", valid", fp );
+	    if( rec->r.uid.uidflags & UIDF_REVOKED )
+		fputs(", revoked", fp );
+	}
 	putc('\n', fp);
 	break;
       case RECTYPE_PREF:
@@ -795,9 +909,19 @@
 	fprintf(fp, "sig %lu, next=%lu,",
 			 rec->r.sig.lid, rec->r.sig.next );
 	for(i=0; i < SIGS_PER_RECORD; i++ ) {
-	    if( rec->r.sig.sig[i].lid )
-		fprintf(fp, " %lu:%02x", rec->r.sig.sig[i].lid,
-					  rec->r.sig.sig[i].flag );
+	    if( rec->r.sig.sig[i].lid ) {
+		fprintf(fp, " %lu:", rec->r.sig.sig[i].lid );
+		if( rec->r.sig.sig[i].flag & SIGF_CHECKED ) {
+		    fprintf(fp,"%c%c%c",
+		       (rec->r.sig.sig[i].flag & SIGF_VALID)   ? 'V':'-',
+		       (rec->r.sig.sig[i].flag & SIGF_EXPIRED) ? 'E':'-',
+		       (rec->r.sig.sig[i].flag & SIGF_REVOKED) ? 'R':'-');
+		}
+		else if( rec->r.sig.sig[i].flag & SIGF_NOPUBKEY)
+		    fputs("?--", fp);
+		else
+		    fputs("---", fp);
+	    }
 	}
 	putc('\n', fp);
 	break;
@@ -876,7 +1000,7 @@
 	break;
       case RECTYPE_VER: /* version record */
 	if( memcmp(buf+1, "gpg", 3 ) ) {
-	    log_error_f( db_name, _("not a trustdb file\n") );
+	    log_error( _("%s: not a trustdb file\n"), db_name );
 	    rc = G10ERR_TRUSTDB;
 	}
 	p += 2; /* skip "pgp" */
@@ -890,12 +1014,12 @@
 	rec->r.ver.firstfree =buftoulong(p); p += 4;
 	rec->r.ver.sdirhashtbl =buftoulong(p); p += 4;
 	if( recnum ) {
-	    log_error_f( db_name, "version record with recnum %lu\n",
+	    log_error( _("%s: version record with recnum %lu\n"), db_name,
 							     (ulong)recnum );
 	    rc = G10ERR_TRUSTDB;
 	}
 	else if( rec->r.ver.version != 2 ) {
-	    log_error_f( db_name, "invalid file version %d\n",
+	    log_error( _("%s: invalid file version %d\n"), db_name,
 							rec->r.ver.version );
 	    rc = G10ERR_TRUSTDB;
 	}
@@ -911,8 +1035,8 @@
 	rec->r.dir.ownertrust = *p++;
 	rec->r.dir.dirflags   = *p++;
 	if( rec->r.dir.lid != recnum ) {
-	    log_error_f( db_name, "dir LID != recnum (%lu,%lu)\n",
-					 rec->r.dir.lid, (ulong)recnum );
+	    log_error( "%s: dir LID != recnum (%lu,%lu)\n",
+			      db_name, rec->r.dir.lid, (ulong)recnum );
 	    rc = G10ERR_TRUSTDB;
 	}
 	break;
@@ -957,8 +1081,8 @@
 	p += 3;
 	rec->r.sdir.hintlist = buftoulong(p);
 	if( rec->r.sdir.lid != recnum ) {
-	    log_error_f( db_name, "sdir LID != recnum (%lu,%lu)\n",
-					 rec->r.sdir.lid, (ulong)recnum );
+	    log_error( "%s: sdir LID != recnum (%lu,%lu)\n",
+			       db_name, rec->r.sdir.lid, (ulong)recnum );
 	    rc = G10ERR_TRUSTDB;
 	}
 	break;
@@ -979,8 +1103,8 @@
 	}
 	break;
       default:
-	log_error_f( db_name, "invalid record type %d at recnum %lu\n",
-					      rec->rectype, (ulong)recnum );
+	log_error( "%s: invalid record type %d at recnum %lu\n",
+				   db_name, rec->rectype, (ulong)recnum );
 	rc = G10ERR_TRUSTDB;
 	break;
     }
@@ -1122,8 +1246,8 @@
 
     rc = tdbio_read_record( 0, &vr, RECTYPE_VER );
     if( rc )
-	log_fatal_f( db_name, _("error reading version record: %s\n"),
-							g10_errstr(rc) );
+	log_fatal( _("%s: error reading version record: %s\n"),
+				       db_name, g10_errstr(rc) );
 
     rec.recnum = recnum;
     rec.rectype = RECTYPE_FREE;
@@ -1149,22 +1273,22 @@
     /* look for unused records */
     rc = tdbio_read_record( 0, &vr, RECTYPE_VER );
     if( rc )
-	log_fatal_f( db_name, _("error reading version record: %s\n"),
-							g10_errstr(rc) );
+	log_fatal( _("%s: error reading version record: %s\n"),
+					     db_name, g10_errstr(rc) );
     if( vr.r.ver.firstfree ) {
 	recnum = vr.r.ver.firstfree;
 	rc = tdbio_read_record( recnum, &rec, RECTYPE_FREE );
 	if( rc ) {
-	    log_error_f( db_name, _("error reading free record: %s\n"),
-							    g10_errstr(rc) );
+	    log_error( _("%s: error reading free record: %s\n"),
+						  db_name,  g10_errstr(rc) );
 	    return rc;
 	}
 	/* update dir record */
 	vr.r.ver.firstfree = rec.r.free.next;
 	rc = tdbio_write_record( &vr );
 	if( rc ) {
-	    log_error_f( db_name, _("error writing dir record: %s\n"),
-							    g10_errstr(rc) );
+	    log_error( _("%s: error writing dir record: %s\n"),
+						     db_name, g10_errstr(rc) );
 	    return rc;
 	}
 	/*zero out the new record */
@@ -1173,8 +1297,8 @@
 	rec.recnum = recnum;
 	rc = tdbio_write_record( &rec );
 	if( rc )
-	    log_fatal_f(db_name,_("failed to zero a record: %s\n"),
-						g10_errstr(rc));
+	    log_fatal(_("%s: failed to zero a record: %s\n"),
+				       db_name, g10_errstr(rc));
     }
     else { /* not found, append a new record */
 	offset = lseek( db_fd, 0, SEEK_END );
@@ -1203,8 +1327,8 @@
 	}
 
 	if( rc )
-	    log_fatal_f(db_name,_("failed to append a record: %s\n"),
-						g10_errstr(rc));
+	    log_fatal(_("%s: failed to append a record: %s\n"),
+				    db_name,	g10_errstr(rc));
     }
     return recnum ;
 }
@@ -1230,10 +1354,9 @@
 
     if( !rc ) {
 	if( pk->local_id && pk->local_id != rec->recnum )
-	    log_error_f(db_name,
-		       "found record, but LID from memory does "
+	    log_error("%s: found record, but LID from memory does "
 		       "not match recnum (%lu,%lu)\n",
-				      pk->local_id, rec->recnum );
+			    db_name,  pk->local_id, rec->recnum );
 	pk->local_id = rec->recnum;
     }
     return rc;
@@ -1272,8 +1395,8 @@
 	/* Now read the dir record */
 	rc = tdbio_read_record( recnum, rec, RECTYPE_DIR);
 	if( rc )
-	    log_error_f(db_name, "can't read dirrec %lu: %s\n",
-						    recnum, g10_errstr(rc) );
+	    log_error("%s: can't read dirrec %lu: %s\n",
+				     db_name, recnum, g10_errstr(rc) );
     }
     return rc;
 }
diff -urN gnupg-0.4.2/g10/tdbio.h gnupg-0.4.3/g10/tdbio.h
--- gnupg-0.4.2/g10/tdbio.h	Sat Oct 17 17:49:02 1998
+++ gnupg-0.4.3/g10/tdbio.h	Thu Oct 22 14:56:48 1998
@@ -21,6 +21,7 @@
 #ifndef G10_TDBIO_H
 #define G10_TDBIO_H
 
+#include "host2net.h"
 
 #define TRUST_RECORD_LEN 40
 #define SIGS_PER_RECORD 	((TRUST_RECORD_LEN-10)/5)
@@ -46,15 +47,14 @@
 #define RECTYPE_FREE 254
 
 
-#define DIRF_CHECKED  1 /* everything has been checked, the other bits are
-			   valid */
-#define DIRF_MISKEY   2 /* not all signatures are checked */
-			/* this flag is used as a quick hint, that we */
-			/* do not need to look at the sig records */
-#define DIRF_ERROR    4 /* severe errors: the key is not valid for some reasons
-			   but we mark it to avoid duplicate checks */
+#define DIRF_CHECKED  1 /* has been checkd - other bits are valid */
+#define DIRF_VALID    2 /* This key is valid:  There is at least */
+			/* one uid with a selfsignature or an revocation */
+#define DIRF_EXPIRED  4 /* the complete key has expired */
 #define DIRF_REVOKED  8 /* the complete key has been revoked */
 
+#define KEYF_CHECKED  1 /* This key has been checked */
+#define KEYF_VALID    2 /* This is a valid (sub)key */
 #define KEYF_EXPIRED  4 /* this key is expired */
 #define KEYF_REVOKED  8 /* this key has been revoked */
 
@@ -64,6 +64,7 @@
 
 #define SIGF_CHECKED  1 /* signature has been checked - bits 0..6 are valid */
 #define SIGF_VALID    2 /* the signature is valid */
+#define SIGF_EXPIRED  4 /* the key of this signature has expired */
 #define SIGF_REVOKED  8 /* this signature has been revoked */
 #define SIGF_NOPUBKEY 128 /* there is no pubkey for this sig */
 
@@ -167,31 +168,17 @@
 void tdbio_dump_record( TRUSTREC *rec, FILE *fp );
 int tdbio_read_record( ulong recnum, TRUSTREC *rec, int expected );
 int tdbio_write_record( TRUSTREC *rec );
+int tdbio_is_dirty(void);
 int tdbio_sync(void);
+int tdbio_begin_transaction(void);
+int tdbio_end_transaction(void);
+int tdbio_cancel_transaction(void);
 int tdbio_delete_record( ulong recnum );
 ulong tdbio_new_recnum(void);
 int tdbio_search_dir_bypk( PKT_public_key *pk, TRUSTREC *rec );
 int tdbio_search_dir_byfpr( const byte *fingerprint, size_t fingerlen,
 					int pubkey_algo, TRUSTREC *rec );
 int tdbio_search_sdir( u32 *keyid, int pubkey_algo, TRUSTREC *rec );
-
-
-#define buftoulong( p )  ((*(byte*)(p) << 24) | (*((byte*)(p)+1)<< 16) | \
-		       (*((byte*)(p)+2) << 8) | (*((byte*)(p)+3)))
-#define buftoushort( p )  ((*((byte*)(p)) << 8) | (*((byte*)(p)+1)))
-#define ulongtobuf( p, a ) do { 			  \
-			    ((byte*)p)[0] = a >> 24;	\
-			    ((byte*)p)[1] = a >> 16;	\
-			    ((byte*)p)[2] = a >>  8;	\
-			    ((byte*)p)[3] = a	   ;	\
-			} while(0)
-#define ushorttobuf( p, a ) do {			   \
-			    ((byte*)p)[0] = a >>  8;	\
-			    ((byte*)p)[1] = a	   ;	\
-			} while(0)
-#define buftou32( p)	buftoulong( (p) )
-#define u32tobuf( p, a) ulongtobuf( (p), (a) )
-
 
 
 #endif /*G10_TDBIO_H*/
diff -urN gnupg-0.4.2/g10/trustdb.c gnupg-0.4.3/g10/trustdb.c
--- gnupg-0.4.2/g10/trustdb.c	Sun Oct 18 12:42:50 1998
+++ gnupg-0.4.3/g10/trustdb.c	Sun Nov  8 18:03:05 1998
@@ -47,27 +47,33 @@
   #error Must change structure of trustdb
 #endif
 
-typedef struct local_id_info *LOCAL_ID_INFO;
-struct local_id_info {
-    LOCAL_ID_INFO next;
+struct local_id_item {
+    struct local_id_item *next;
     ulong lid;
     unsigned flag;
 };
 
+struct local_id_table {
+    struct local_id_table *next; /* only used to keep a list of unused tables */
+    struct local_id_item *items[16];
+};
+
+
+typedef struct local_id_table *LOCAL_ID_TABLE;
+
 
 typedef struct trust_info TRUST_INFO;
 struct trust_info {
     ulong    lid;
-    unsigned trust;
+    byte     otrust; /* ownertrust (assigned trust) */
+    byte     trust; /* calculated trust (validity) */
 };
 
-
 typedef struct trust_seg_list *TRUST_SEG_LIST;
 struct trust_seg_list {
     TRUST_SEG_LIST next;
-    int   nseg;     /* number of segmens */
-    int   dup;
-    TRUST_INFO seg[1];	 /* segment list */
+    int  pathlen;
+    TRUST_INFO path[1];
 };
 
 
@@ -82,28 +88,29 @@
 
 static int walk_sigrecs( SIGREC_CONTEXT *c );
 
-static LOCAL_ID_INFO *new_lid_table(void);
-static void release_lid_table( LOCAL_ID_INFO *tbl );
-static int ins_lid_table_item( LOCAL_ID_INFO *tbl, ulong lid, unsigned flag );
-static int qry_lid_table_flag( LOCAL_ID_INFO *tbl, ulong lid, unsigned *flag );
-static void upd_lid_table_flag( LOCAL_ID_INFO *tbl, ulong lid, unsigned flag );
+static LOCAL_ID_TABLE new_lid_table(void);
+static void release_lid_table( LOCAL_ID_TABLE tbl );
+static int ins_lid_table_item( LOCAL_ID_TABLE tbl, ulong lid, unsigned flag );
+static int qry_lid_table_flag( LOCAL_ID_TABLE tbl, ulong lid, unsigned *flag );
 
 static void print_user_id( const char *text, u32 *keyid );
-static int do_list_path( TRUST_INFO *stack, int depth, int max_depth,
-			 LOCAL_ID_INFO *lids, TRUST_SEG_LIST *tslist );
-
 static int list_sigs( ulong pubkey_id );
-static int propagate_trust( TRUST_SEG_LIST tslist );
 static int do_check( TRUSTREC *drec, unsigned *trustlevel );
 static int get_dir_record( PKT_public_key *pk, TRUSTREC *rec );
 
+static void upd_pref_record( TRUSTREC *urec, u32 *keyid, PKT_signature *sig );
+static void upd_cert_record( KBNODE keyblock, KBNODE signode, u32 *keyid,
+		 TRUSTREC *drec, RECNO_LIST *recno_list, int recheck,
+		 TRUSTREC *urec, const byte *uidhash, int revoke );
+
 
 /* a table used to keep track of ultimately trusted keys
  * which are the ones from our secrings */
-static LOCAL_ID_INFO *ultikey_table;
+static LOCAL_ID_TABLE ultikey_table;
 
-static ulong last_trust_web_key;
-static TRUST_SEG_LIST last_trust_web_tslist;
+/* list of unused lid items and tables */
+static LOCAL_ID_TABLE unused_lid_tables;
+static struct local_id_item *unused_lid_items;
 
 
 #define HEXTOBIN(a) ( (a) >= '0' && (a) <= '9' ? ((a)-'0') : \
@@ -222,53 +229,67 @@
     *head = NULL;
 }
 
-static LOCAL_ID_INFO *
+static LOCAL_ID_TABLE
 new_lid_table(void)
 {
-    return m_alloc_clear( 16 * sizeof(LOCAL_ID_INFO));
+    LOCAL_ID_TABLE a;
+
+    a = unused_lid_tables;
+    if( a ) {
+	unused_lid_tables = a->next;
+	a->next = NULL;
+    }
+    else
+	a = m_alloc_clear( sizeof *a );
+    return a;
 }
 
 static void
-release_lid_table( LOCAL_ID_INFO *tbl )
+release_lid_table( LOCAL_ID_TABLE tbl )
 {
-    LOCAL_ID_INFO a, a2;
+    struct local_id_item *a, *a2;
     int i;
 
     for(i=0; i < 16; i++ ) {
-	for(a=tbl[i]; a; a = a2 ) {
+	for(a=tbl->items[i]; a; a = a2 ) {
 	    a2 = a->next;
-	    m_free(a);
+	    a->next = unused_lid_items;
+	    unused_lid_items = a;
 	}
     }
-    m_free(tbl);
+    tbl->next = unused_lid_tables;
+    unused_lid_tables = tbl;
 }
 
 /****************
  * Add a new item to the table or return 1 if we already have this item
- * fixme: maybe it's a good idea to take items from an unused item list.
  */
 static int
-ins_lid_table_item( LOCAL_ID_INFO *tbl, ulong lid, unsigned flag )
+ins_lid_table_item( LOCAL_ID_TABLE tbl, ulong lid, unsigned flag )
 {
-    LOCAL_ID_INFO a;
+    struct local_id_item *a;
 
-    for( a = tbl[lid & 0x0f]; a; a = a->next )
+    for( a = tbl->items[lid & 0x0f]; a; a = a->next )
 	if( a->lid == lid )
 	    return 1;
-    a = m_alloc( sizeof *a );
+    a = unused_lid_items;
+    if( a )
+	unused_lid_items = a->next;
+    else
+	a = m_alloc( sizeof *a );
     a->lid = lid;
     a->flag = flag;
-    a->next = tbl[lid & 0x0f];
-    tbl[lid & 0x0f] = a;
+    a->next = tbl->items[lid & 0x0f];
+    tbl->items[lid & 0x0f] = a;
     return 0;
 }
 
 static int
-qry_lid_table_flag( LOCAL_ID_INFO *tbl, ulong lid, unsigned *flag )
+qry_lid_table_flag( LOCAL_ID_TABLE tbl, ulong lid, unsigned *flag )
 {
-    LOCAL_ID_INFO a;
+    struct local_id_item *a;
 
-    for( a = tbl[lid & 0x0f]; a; a = a->next )
+    for( a = tbl->items[lid & 0x0f]; a; a = a->next )
 	if( a->lid == lid ) {
 	    if( flag )
 		*flag = a->flag;
@@ -277,19 +298,6 @@
     return -1;
 }
 
-static void
-upd_lid_table_flag( LOCAL_ID_INFO *tbl, ulong lid, unsigned flag )
-{
-    LOCAL_ID_INFO a;
-
-    for( a = tbl[lid & 0x0f]; a; a = a->next )
-	if( a->lid == lid ) {
-	    a->flag = flag;
-	    return;
-	}
-    BUG();
-}
-
 
 
 /****************
@@ -301,12 +309,19 @@
     TRUSTREC rec;
     int rc;
 
-    rc = tdbio_read_record( lid, &rec, RECTYPE_DIR );
+    rc = tdbio_read_record( lid, &rec, 0 );
     if( rc ) {
 	log_error("error reading dir record for LID %lu: %s\n",
 						    lid, g10_errstr(rc));
 	return G10ERR_TRUSTDB;
     }
+    if( rec.rectype == RECTYPE_SDIR )
+	return 0;
+    if( rec.rectype != RECTYPE_DIR ) {
+	log_error("lid %lu: expected dir record, got type %d\n",
+						    lid, rec.rectype );
+	return G10ERR_TRUSTDB;
+    }
     if( !rec.r.dir.keylist ) {
 	log_error("no primary key for LID %lu\n", lid );
 	return G10ERR_TRUSTDB;
@@ -342,7 +357,6 @@
 
 
 
-
 /****************
  * Walk through the signatures of a public key.
  * The caller must provide a context structure, with all fields set
@@ -364,9 +378,13 @@
     r = &c->ctl.rec;
     if( !c->ctl.init_done ) {
 	c->ctl.init_done = 1;
-	read_record( c->lid, r, RECTYPE_DIR );
+	read_record( c->lid, r, 0 );
+	if( r->rectype != RECTYPE_DIR ) {
+	    c->ctl.eof = 1;
+	    return -1;	/* return eof */
+	}
 	c->ctl.nextuid = r->r.dir.uidlist;
-	/* force a read (what a bad bad hack) */
+	/* force a read */
 	c->ctl.index = SIGS_PER_RECORD;
 	r->r.sig.next = 0;
     }
@@ -503,17 +521,18 @@
     m_free(p);
 }
 
-static void
+#if 0
+static int
 print_keyid( FILE *fp, ulong lid )
 {
     u32 ki[2];
     if( keyid_from_lid( lid, ki ) )
-	fprintf(fp, "????????.%lu", lid );
+	return fprintf(fp, "????????.%lu", lid );
     else
-	fprintf(fp, "%08lX.%lu", (ulong)ki[1], lid );
+	return fprintf(fp, "%08lX.%lu", (ulong)ki[1], lid );
 }
 
-static void
+static int
 print_trust( FILE *fp, unsigned trust )
 {
     int c;
@@ -525,41 +544,62 @@
       case TRUST_MARGINAL:  c = 'm'; break;
       case TRUST_FULLY:     c = 'f'; break;
       case TRUST_ULTIMATE:  c = 'u'; break;
-      default: fprintf(fp, "%02x", trust ); return;
+      default: fprintf(fp, "%02x", trust ); return 2;
     }
     putc(c, fp);
+    return 1;
+}
+#endif
+
+static int
+print_sigflags( FILE *fp, unsigned flags )
+{
+    if( flags & SIGF_CHECKED ) {
+	fprintf(fp,"%c%c%c",
+	   (flags & SIGF_VALID)   ? 'V':'-',
+	   (flags & SIGF_EXPIRED) ? 'E':'-',
+	   (flags & SIGF_REVOKED) ? 'R':'-');
+    }
+    else if( flags & SIGF_NOPUBKEY)
+	fputs("?--", fp);
+    else
+	fputs("---", fp);
+    return 3;
 }
 
 /* (a non-recursive algorithm would be easier) */
 static int
-do_list_sigs( ulong root, ulong pubkey, int depth,
-	      LOCAL_ID_INFO *lids, unsigned *lineno )
+do_list_sigs( ulong root, ulong pk_lid, int depth,
+	      LOCAL_ID_TABLE lids, unsigned *lineno )
 {
     SIGREC_CONTEXT sx;
     int rc;
     u32 keyid[2];
 
     memset( &sx, 0, sizeof sx );
-    sx.lid = pubkey;
+    sx.lid = pk_lid;
     for(;;) {
-	rc = walk_sigrecs( &sx );
-	if( rc )
+	rc = walk_sigrecs( &sx ); /* should we replace it and use */
+	if( rc )		  /* use a loop like in collect_paths ??*/
 	    break;
 	rc = keyid_from_lid( sx.sig_lid, keyid );
 	if( rc ) {
-	    printf("%6u: %*s????????.%lu:%02x\n", *lineno, depth*4, "",
-						   sx.sig_lid, sx.sig_flag );
+	    printf("%6u: %*s????????.%lu:", *lineno, depth*4, "", sx.sig_lid );
+	    print_sigflags( stdout, sx.sig_flag );
+	    putchar('\n');
 	    ++*lineno;
 	}
 	else {
-	    printf("%6u: %*s%08lX.%lu:%02x ", *lineno, depth*4, "",
-			      (ulong)keyid[1], sx.sig_lid, sx.sig_flag );
-	    /* check whether we already checked this pubkey */
+	    printf("%6u: %*s%08lX.%lu:", *lineno, depth*4, "",
+			      (ulong)keyid[1], sx.sig_lid );
+	    print_sigflags( stdout, sx.sig_flag );
+	    putchar(' ');
+	    /* check whether we already checked this pk_lid */
 	    if( !qry_lid_table_flag( ultikey_table, sx.sig_lid, NULL ) ) {
 		print_user_id("[ultimately trusted]", keyid);
 		++*lineno;
 	    }
-	    else if( sx.sig_lid == pubkey ) {
+	    else if( sx.sig_lid == pk_lid ) {
 		printf("[self-signature]\n");
 		++*lineno;
 	    }
@@ -597,7 +637,7 @@
 {
     int rc;
     u32 keyid[2];
-    LOCAL_ID_INFO *lids;
+    LOCAL_ID_TABLE lids;
     unsigned lineno = 1;
 
     rc = keyid_from_lid( pubkey_id, keyid );
@@ -632,7 +672,7 @@
     tdbio_dump_record( &dr, stdout );
 
     for( recno=dr.r.dir.keylist; recno; recno = rec.r.key.next ) {
-	rc = tdbio_read_record( recno, &rec, RECTYPE_KEY );
+	rc = tdbio_read_record( recno, &rec, 0 );
 	if( rc ) {
 	    log_error("lid %lu: read key record failed: %s\n",
 						lid, g10_errstr(rc));
@@ -680,198 +720,178 @@
 
 
 
+
 /****************
- * Function to collect all trustpaths
+ * stack is an array of (max_path+1) elements. If trust_seg_head is not
+ * NULL it is a pointer to a variable which will receive a linked list
+ * of trust paths - The caller has to free the memory.
  */
 static int
-do_list_path( TRUST_INFO *stack, int depth, int max_depth,
-	      LOCAL_ID_INFO *lids, TRUST_SEG_LIST *tslist )
+collect_paths( int depth, int max_depth, int all, TRUSTREC *drec,
+	       TRUST_INFO *stack, TRUST_SEG_LIST *trust_seg_head )
 {
-    SIGREC_CONTEXT sx;
-    unsigned last_depth;
-    int rc;
-
-    assert(depth);
-
-    /*printf("%2lu/%d: scrutinizig\n", stack[depth-1], depth);*/
-    if( depth >= max_depth || depth >= MAX_LIST_SIGS_DEPTH-1 ) {
-	/*printf("%2lu/%d: too deeply nested\n", stack[depth-1], depth);*/
-	return 0;
-    }
-    memset( &sx, 0, sizeof sx );
-    sx.lid = stack[depth-1].lid;
-    /* loop over all signatures. If we do not have any, try to create them */
-    while( !(rc = walk_sigrecs( &sx )) ) {
-	TRUST_SEG_LIST tsl, t2, tl;
+    ulong rn, uidrn;
+    int marginal=0;
+    int fully=0;
+    LOCAL_ID_TABLE sigs_seen = NULL;
+
+    if( depth >= max_depth )  /* max cert_depth reached */
+	return TRUST_UNDEFINED;
+    {	int i;
+
+	for(i=0; i < depth; i++ )
+	    if( stack[i].lid == drec->r.dir.lid )
+		return TRUST_UNDEFINED; /* closed (we already visited this lid) */
+    }
+
+    stack[depth].lid = drec->r.dir.lid;
+    stack[depth].otrust = drec->r.dir.ownertrust;
+    stack[depth].trust = 0;
+    if( !qry_lid_table_flag( ultikey_table, drec->r.dir.lid, NULL ) ) {
+	/* we are at the end of a path */
+	TRUST_SEG_LIST tsl;
 	int i;
 
-	if( !(sx.sig_flag & SIGF_CHECKED) )
-	    continue;  /* only checked sigs */
-	if( !(sx.sig_flag & SIGF_VALID) )
-	    continue;  /* and, of course, only valid sigs */
-	if( (sx.sig_flag & SIGF_REVOKED) )
-	    continue;  /* and skip revoked sigs */
-
-	stack[depth].lid = sx.sig_lid;
-	stack[depth].trust = 0;
-	if( qry_lid_table_flag( lids, sx.sig_lid, &last_depth) ) {
-	    /*printf("%2lu/%d: marked\n", sx.sig_lid, depth );*/
-	    ins_lid_table_item( lids, sx.sig_lid, depth);
-	    last_depth = depth;
-	}
-	else if( depth	< last_depth ) {
-	    /*printf("%2lu/%d: last_depth=%u - updated\n", sx.sig_lid, depth, last_depth);*/
-	    last_depth = depth;
-	    upd_lid_table_flag( lids, sx.sig_lid, depth);
-	}
-
-	if( last_depth < depth )
-	    /*printf("%2lu/%d: already visited\n", sx.sig_lid, depth)*/;
-	else if( !qry_lid_table_flag( ultikey_table, sx.sig_lid, NULL ) ) {
-	    /* found end of path; store it, ordered by path length */
-	    tsl = m_alloc( sizeof *tsl + depth*sizeof(TRUST_INFO) );
-	    tsl->nseg = depth+1;
-	    tsl->dup = 0;
+	stack[depth].trust = TRUST_ULTIMATE;
+	if( trust_seg_head ) {
+	    /* we can now put copy our current stack to the trust_seg_list */
+	    tsl = m_alloc( sizeof *tsl + (depth+1)*sizeof( TRUST_INFO ) );
 	    for(i=0; i <= depth; i++ )
-		tsl->seg[i] = stack[i];
-	    for(t2=*tslist,tl=NULL; t2; tl=t2, t2 = t2->next )
-		if( depth < t2->nseg )
-		    break;
-	    if( !tl ) {
-		tsl->next = t2;
-		*tslist = tsl;
-	    }
-	    else {
-		tsl->next = t2;
-		tl->next = tsl;
-	    }
-	    /*putchar('.'); fflush(stdout);*/
-	    /*printf("%2lu/%d: found\n", sx.sig_lid, depth);*/
-	}
-	else {
-	    rc = do_list_path( stack, depth+1, max_depth, lids, tslist);
-	    if( rc && rc != -1 )
-		break;
-	}
-    }
-    return rc==-1? 0 : rc;
-}
+		tsl->path[i] = stack[i];
+	    tsl->pathlen = i;
+	    tsl->next = *trust_seg_head;
+	    *trust_seg_head = tsl;
+	}
+	return TRUST_ULTIMATE;
+    }
+
+    /* loop over all user-ids */
+    if( !all )
+	sigs_seen = new_lid_table();
+    for( rn = drec->r.dir.uidlist; rn; rn = uidrn ) {
+	TRUSTREC rec;  /* used for uids and sigs */
+	ulong sigrn;
+
+	read_record( rn, &rec, RECTYPE_UID );
+	uidrn = rec.r.uid.next;
+	if( !(rec.r.uid.uidflags & UIDF_CHECKED) )
+	    continue; /* user id has not been checked */
+	if( !(rec.r.uid.uidflags & UIDF_VALID) )
+	    continue; /* user id is not valid */
+	if( (rec.r.uid.uidflags & UIDF_REVOKED) )
+	    continue; /* user id has been revoked */
 
+	/* loop over all signature records */
+	for( rn = rec.r.uid.siglist; rn; rn = sigrn ) {
+	    int i;
 
-/****************
- * Make a list of trust paths
- */
-static int
-make_tsl( ulong lid, TRUST_SEG_LIST *ret_tslist )
-{
-    int i, rc;
-    LOCAL_ID_INFO *lids = new_lid_table();
-    TRUST_INFO stack[MAX_LIST_SIGS_DEPTH];
-    TRUST_SEG_LIST tsl, tslist;
-    int max_depth = 4;
-
-    tslist = *ret_tslist = NULL;
-
-    if( !qry_lid_table_flag( ultikey_table, lid, NULL ) ) {
-	tslist = m_alloc( sizeof *tslist );
-	tslist->nseg = 1;
-	tslist->dup = 0;
-	tslist->seg[0].lid = lid;
-	tslist->seg[0].trust = 0;
-	tslist->next = NULL;
-	rc = 0;
-    }
-    else {
-	stack[0].lid = lid;
-	stack[0].trust = 0;
-	rc = do_list_path( stack, 1, max_depth, lids, &tslist );
-    }
-    if( !rc ) { /* wipe out duplicates */
-	LOCAL_ID_INFO *work = new_lid_table();
-	for( tsl=tslist; tsl; tsl = tsl->next ) {
-	    for(i=1; i < tsl->nseg-1; i++ ) {
-		if( ins_lid_table_item( work, tsl->seg[i].lid, 0 ) ) {
-		    tsl->dup = 1; /* mark as duplicate */
-		    break;
+	    read_record( rn, &rec, RECTYPE_SIG );
+	    sigrn = rec.r.sig.next;
+
+	    for(i=0; i < SIGS_PER_RECORD; i++ ) {
+		TRUSTREC tmp;
+		int ot, nt;
+
+		if( !rec.r.sig.sig[i].lid )
+		    continue; /* skip deleted sigs */
+		if( !(rec.r.sig.sig[i].flag & SIGF_CHECKED) )
+		    continue; /* skip unchecked signatures */
+		if( !(rec.r.sig.sig[i].flag & SIGF_VALID) )
+		    continue; /* skip invalid signatures */
+		if( (rec.r.sig.sig[i].flag & SIGF_EXPIRED) )
+		    continue; /* skip expired signatures */
+		if( (rec.r.sig.sig[i].flag & SIGF_REVOKED) )
+		    continue; /* skip revoked signatures */
+
+		/* visit every signer only once (a signer may have
+		 * signed multizple user IDs */
+		if( sigs_seen && ins_lid_table_item( sigs_seen,
+						     rec.r.sig.sig[i].lid, 0) )
+		    continue; /* we alread have this one */
+
+		read_record( rec.r.sig.sig[i].lid, &tmp, 0 );
+		if( tmp.rectype != RECTYPE_DIR ) {
+		    log_info("oops: lid %lu: sig %lu has rectype %d"
+			     " - skipped\n",
+			    drec->r.dir.lid, tmp.recnum, tmp.rectype );
+		    continue;
+		}
+		ot = tmp.r.dir.ownertrust & TRUST_MASK;
+		if( ot >= TRUST_FULLY )
+		    ot = TRUST_FULLY;  /* just in case */
+		nt = collect_paths( depth+1, max_depth, all, &tmp, stack,
+							trust_seg_head );
+		nt &= TRUST_MASK;
+
+		if( nt < TRUST_MARGINAL ) {
+		    continue;
+		}
+
+		if( nt == TRUST_ULTIMATE ) {
+		    /* we have signed this key and only in this special case
+		     * we assume that this one is fully trusted */
+		    if( !all ) {
+			if( sigs_seen )
+			    release_lid_table( sigs_seen );
+			return (stack[depth].trust = TRUST_FULLY);
+		    }
+		}
+
+		if( nt >= TRUST_FULLY )
+		    fully++;
+		if( nt >= TRUST_MARGINAL )
+		    marginal++;
+
+		if( fully >= opt.completes_needed
+		    || marginal >= opt.marginals_needed ) {
+		    if( !all ) {
+			if( sigs_seen )
+			    release_lid_table( sigs_seen );
+			return (stack[depth].trust = TRUST_FULLY);
+		    }
 		}
 	    }
 	}
-	release_lid_table(work);
-	*ret_tslist = tslist;
     }
-    else { /* error: release tslist */
-	while( tslist ) {
-	    tsl = tslist->next;
-	    m_free(tslist);
-	    tslist = tsl;
-	}
+    if( sigs_seen )
+	release_lid_table( sigs_seen );
+    if( all && ( fully >= opt.completes_needed
+		 || marginal >= opt.marginals_needed ) ) {
+	return (stack[depth].trust = TRUST_FULLY );
     }
-    release_lid_table(lids);
-    return rc;
+    if( marginal ) {
+	return (stack[depth].trust = TRUST_MARGINAL);
+    }
+    return (stack[depth].trust=TRUST_UNDEFINED);
 }
 
 
 /****************
- * Given a trust segment list tslist, walk over all paths and fill in
- * the trust information for each segment.  What this function does is
- * to assign a trustvalue to the first segment (which is the requested key)
- * of each path.
- *
- * FIXME: We have to do more thinking here. e.g. we should never increase
- *	  the trust value.
- *
- * Do not do it for duplicates.
+ * Given the directory record of a key, check whether we can
+ * find a path to an ultimately trusted key.  We do this by
+ * checking all key signatures up to a some depth.
  */
 static int
-propagate_trust( TRUST_SEG_LIST tslist )
+verify_key( int max_depth, TRUSTREC *drec )
 {
-    int i;
-    unsigned trust, tr;
-    TRUST_SEG_LIST tsl;
+    TRUST_INFO *tmppath = m_alloc_clear( (max_depth+1)* sizeof *tmppath );
+    int tr;
 
-    for(tsl = tslist; tsl; tsl = tsl->next ) {
-	if( tsl->dup )
-	    continue;
-	assert( tsl->nseg );
-	/* the last segment is always an ultimately trusted one, so we can
-	 * assign a fully trust to the next one */
-	i = tsl->nseg-1;
-	tsl->seg[i].trust = TRUST_ULTIMATE;
-	trust = TRUST_FULLY;
-	for(i-- ; i >= 0; i-- ) {
-	    tsl->seg[i].trust = trust;
-	    if( i > 0 ) {
-		/* get the trust of this pubkey */
-		tr = get_ownertrust( tsl->seg[i].lid );
-		if( tr < trust )
-		    trust = tr;
-	    }
-	}
-    }
-    return 0;
+    tr = collect_paths( 0, max_depth, 0, drec, tmppath, NULL );
+    m_free( tmppath );
+    return tr;
 }
 
 
+
+
 /****************
  * we have the pubkey record and all needed informations are in the trustdb
  * but nothing more is known.
- * (this function may re-read the dir record dr)
  */
 static int
 do_check( TRUSTREC *dr, unsigned *trustlevel )
 {
-    int i, rc=0;
-    TRUST_SEG_LIST tsl, tsl2, tslist;
-    int marginal, fully;
-    int fully_needed = opt.completes_needed;
-    int marginal_needed = opt.marginals_needed;
-    unsigned tflags = 0;
-
-    assert( fully_needed > 0 && marginal_needed > 1 );
-
-
-    *trustlevel = TRUST_UNDEFINED;
-
     if( !dr->r.dir.keylist ) {
 	log_error("Ooops, no keys\n");
 	return G10ERR_TRUSTDB;
@@ -881,92 +901,15 @@
 	return G10ERR_TRUSTDB;
     }
 
-    /* did we already check the signatures */
-    /* fixme:.... */
+    *trustlevel = verify_key( 5, dr );
 
     if( dr->r.dir.dirflags & DIRF_REVOKED )
-	tflags |= TRUST_FLAG_REVOKED;
-
-  #if 0   /* Do we still need this?? */
-    if( !rc && !dr->r.dir.siglist ) {
-	/* We do not have any signatures; check whether it is one of our
-	 * secret keys */
-	if( !qry_lid_table_flag( ultikey_table, dr->r.dir.lid, NULL ) )
-	    *trustlevel = tflags | TRUST_ULTIMATE;
-	return 0;
-    }
-  #endif
-    if( rc )
-	return rc;  /* error while looking for sigrec or building sigrecs */
-
-    /* fixme: take it from the cache if it is valid */
-
-    /* Make a list of all possible trust-paths */
-    rc = make_tsl( dr->r.dir.lid, &tslist );
-    if( rc )
-	return rc;
-    rc = propagate_trust( tslist );
-    if( rc )
-	return rc;
-    for(tsl = tslist; tsl; tsl = tsl->next ) {
-	if( tsl->dup )
-	    continue;
-
-	if( opt.verbose ) {
-	    log_info("trust path:" );
-	    for(i=0; i < tsl->nseg; i++ ) {
-		putc(' ',stderr);
-		print_keyid( stderr, tsl->seg[i].lid );
-		putc(':',stderr);
-		print_trust( stderr, tsl->seg[i].trust );
-	    }
-	    putc('\n',stderr);
-	}
-    }
-
-    /* and see whether there is a trusted path.
-     * We only have to look at the first segment, because
-     * propagate_trust has investigated all other segments */
-    marginal = fully = 0;
-    for(tsl = tslist; tsl; tsl = tsl->next ) {
-	if( tsl->dup )
-	    continue;
-	if( tsl->seg[0].trust == TRUST_ULTIMATE ) {
-	    *trustlevel = tflags | TRUST_ULTIMATE; /* our own key */
-	    break;
-	}
-	if( tsl->seg[0].trust == TRUST_FULLY ) {
-	    marginal++;
-	    fully++;
-	}
-	else if( tsl->seg[0].trust == TRUST_MARGINAL )
-	    marginal++;
+	*trustlevel |= TRUST_FLAG_REVOKED;
 
-	if( fully >= fully_needed ) {
-	    *trustlevel = tflags | TRUST_FULLY;
-	    break;
-	}
-    }
-    if( !tsl && marginal >= marginal_needed )
-	*trustlevel = tflags | TRUST_MARGINAL;
-
-    /* cache the tslist */
-    if( last_trust_web_key ) {
-	for( tsl = last_trust_web_tslist; tsl; tsl = tsl2 ) {
-	    tsl2 = tsl->next;
-	    m_free(tsl);
-	}
-    }
-    last_trust_web_key = dr->r.dir.lid;
-    last_trust_web_tslist = tslist;
     return 0;
 }
 
 
-/***********************************************
- ****************  API	************************
- ***********************************************/
-
 /****************
  * Perform some checks over the trustdb
  *  level 0: only open the db
@@ -1020,7 +963,7 @@
 	PKT_public_key *pk = m_alloc_clear( sizeof *pk );
 	int rc;
 
-	if( (rc = get_pubkey_byname( pk, username )) )
+	if( (rc = get_pubkey_byname( NULL, pk, username, NULL )) )
 	    log_error("user '%s' not found: %s\n", username, g10_errstr(rc) );
 	else if( (rc=tdbio_search_dir_bypk( pk, &rec )) && rc != -1 )
 	    log_error("problem finding '%s' in trustdb: %s\n",
@@ -1059,6 +1002,9 @@
     byte *p;
     int rc;
 
+    printf("# List of assigned trustvalues, created %s\n"
+	   "# (Use \"gpgm --import-ownertrust\" to restore them)\n",
+	   asctimestamp( make_timestamp() ) );
     for(recnum=0; !tdbio_read_record( recnum, &rec, 0); recnum++ ) {
 	if( rec.rectype == RECTYPE_DIR ) {
 	    if( !rec.r.dir.keylist ) {
@@ -1110,6 +1056,7 @@
 	n = strlen(line);
 	if( line[n-1] != '\n' ) {
 	    log_error_f(fname, "line to long\n" );
+	    /* ... or last line does not have a LF */
 	    break; /* can't continue */
 	}
 	for(p = line; *p && *p != ':' ; p++ )
@@ -1179,13 +1126,38 @@
 }
 
 
+
+
+static void
+print_path( int pathlen, TRUST_INFO *path )
+{
+    int rc, i;
+    u32 keyid[2];
+
+    fputs("path:", stdout);
+    for( i = 0; i < pathlen; i++ )  {
+	if( i && !(i%4) )
+	    fputs("     ", stdout );
+	rc = keyid_from_lid( path[i].lid, keyid );
+	if( rc )
+	    printf(" ????????.%lu:", path[i].lid );
+	else
+	    printf(" %08lX.%lu:", (ulong)keyid[1], path[i].lid );
+	print_sigflags( stdout, path[i].otrust );
+    }
+    putchar('\n');
+}
+
+
+
 void
 list_trust_path( int max_depth, const char *username )
 {
     int rc;
     int wipe=0;
-    int i;
     TRUSTREC rec;
+    TRUST_INFO *tmppath;
+    TRUST_SEG_LIST trust_seg_list, tsl, tsl2;
     PKT_public_key *pk = m_alloc_clear( sizeof *pk );
 
     if( max_depth < 0 ) {
@@ -1193,7 +1165,7 @@
 	max_depth = -max_depth;
     }
 
-    if( (rc = get_pubkey_byname( pk, username )) )
+    if( (rc = get_pubkey_byname(NULL, pk, username, NULL )) )
 	log_error("user '%s' not found: %s\n", username, g10_errstr(rc) );
     else if( (rc=tdbio_search_dir_bypk( pk, &rec )) && rc != -1 )
 	log_error("problem finding '%s' in trustdb: %s\n",
@@ -1207,69 +1179,30 @@
 	    assert( pk->local_id );
 	}
     }
+    free_public_key( pk );
 
-    if( !rc ) {
-	TRUST_SEG_LIST tsl, tslist = NULL;
-
-	if( !qry_lid_table_flag( ultikey_table, pk->local_id, NULL ) ) {
-	    tslist = m_alloc( sizeof *tslist );
-	    tslist->nseg = 1;
-	    tslist->dup = 0;
-	    tslist->seg[0].lid = pk->local_id;
-	    tslist->seg[0].trust = 0;
-	    tslist->next = NULL;
-	    rc = 0;
-	}
-	else {
-	    LOCAL_ID_INFO *lids = new_lid_table();
-	    TRUST_INFO stack[MAX_LIST_SIGS_DEPTH];
-
-	    stack[0].lid = pk->local_id;
-	    stack[0].trust = 0;
-	    rc = do_list_path( stack, 1, max_depth, lids, &tslist );
-	    if( wipe ) { /* wipe out duplicates */
-		LOCAL_ID_INFO *work;
-
-		work = new_lid_table();
-		for( tsl=tslist; tsl; tsl = tsl->next ) {
-		    for(i=1; i < tsl->nseg-1; i++ ) {
-			if( ins_lid_table_item( work, tsl->seg[i].lid, 0 ) ) {
-			    tsl->dup = 1; /* mark as duplicate */
-			    break;
-			}
-		    }
-		}
-		release_lid_table(work);
-	    }
-	    release_lid_table(lids);
-	}
-	if( rc )
-	    log_error("user '%s' list problem: %s\n", username, g10_errstr(rc));
-	rc = propagate_trust( tslist );
-	if( rc )
-	    log_error("user '%s' trust problem: %s\n", username, g10_errstr(rc));
-	for(tsl = tslist; tsl; tsl = tsl->next ) {
-	    int i;
-
-	    if( tsl->dup )
-		continue;
-	    printf("trust path:" );
-	    for(i=0; i < tsl->nseg; i++ ) {
-		putc(' ',stdout);
-		print_keyid( stdout, tsl->seg[i].lid );
-		putc(':',stdout);
-		print_trust( stdout, tsl->seg[i].trust );
-	    }
-	    putchar('\n');
-	}
+    /* collect the paths */
+    tmppath = m_alloc_clear( (max_depth+1)* sizeof *tmppath );
+    trust_seg_list = NULL;
+    collect_paths( 0, max_depth, 1, &rec, tmppath, &trust_seg_list );
+    m_free( tmppath );
+    /* and now print them */
+    for(tsl = trust_seg_list; tsl; tsl = tsl->next ) {
+	print_path( tsl->pathlen, tsl->path );
+    }
+
+    /* release the list */
+    for(tsl = trust_seg_list; tsl; tsl = tsl2 ) {
+	tsl2 = tsl->next;
+	m_free( tsl );
     }
-
-    free_public_key( pk );
+    trust_seg_list = NULL;
 }
 
 
 /****************
  * Check the complete trustdb or only the entries for the given username.
+ * We check the complete database and recalculate all flags.
  */
 void
 check_trustdb( const char *username )
@@ -1288,7 +1221,9 @@
 				    username, g10_errstr(rc));
 	}
 	else {
-	    rc = update_trust_record( keyblock );
+	    int modified;
+
+	    rc = update_trust_record( keyblock, 0, &modified );
 	    if( rc == -1 ) { /* not yet in trustdb: insert */
 		rc = insert_trust_record(
 			    find_kbnode( keyblock, PKT_PUBLIC_KEY
@@ -1298,20 +1233,27 @@
 	    if( rc )
 		log_error("%s: update failed: %s\n",
 					   username, g10_errstr(rc) );
-	    else
+	    else if( modified )
 		log_info("%s: updated\n", username );
+	    else
+		log_info("%s: okay\n", username );
 
 	}
 	release_kbnode( keyblock ); keyblock = NULL;
     }
     else {
 	ulong recnum;
+	ulong count=0, upd_count=0, err_count=0, skip_count=0;
 
 	for(recnum=0; !tdbio_read_record( recnum, &rec, 0); recnum++ ) {
 	    if( rec.rectype == RECTYPE_DIR ) {
 		TRUSTREC tmp;
+		int modified;
+
 		if( !rec.r.dir.keylist ) {
 		    log_info("lid %lu: dir record w/o key - skipped\n", recnum);
+		    count++;
+		    skip_count++;
 		    continue;
 		}
 
@@ -1323,22 +1265,45 @@
 		if( rc ) {
 		    log_error("lid %lu: keyblock not found: %s\n",
 						 recnum, g10_errstr(rc) );
+		    count++;
+		    skip_count++;
 		    continue;
 		}
-		rc = update_trust_record( keyblock );
-		if( rc )
+
+		rc = update_trust_record( keyblock, 0, &modified );
+		if( rc ) {
 		    log_error("lid %lu: update failed: %s\n",
 						 recnum, g10_errstr(rc) );
-		else
-		    log_info("lid %lu: updated\n", recnum );
+		    err_count++;
+		}
+		else if( modified ) {
+		    if( opt.verbose )
+			log_info("lid %lu: updated\n", recnum );
+		    upd_count++;
+		}
+		else if( opt.verbose > 1 )
+		    log_info("lid %lu: okay\n", recnum );
 
 		release_kbnode( keyblock ); keyblock = NULL;
+		if( !(++count % 100) )
+		    log_info(_("%lu keys so far processed\n"), count);
 	    }
 	}
+	log_info(_("%lu keys processed\n"), count);
+	if( skip_count )
+	    log_info(_("\t%lu keys skipped\n"), skip_count);
+	if( err_count )
+	    log_info(_("\t%lu keys with errors\n"), err_count);
+	if( upd_count )
+	    log_info(_("\t%lu keys updated\n"), upd_count);
     }
 }
 
 
+/****************
+ * Put new entries  from the pubrings into the trustdb.
+ * This function honors the sig flags to speed up the check.
+ */
 void
 update_trustdb( )
 {
@@ -1348,29 +1313,57 @@
 
     rc = enum_keyblocks( 0, &kbpos, &keyblock );
     if( !rc ) {
+	ulong count=0, upd_count=0, err_count=0, new_count=0;
+
 	while( !(rc = enum_keyblocks( 1, &kbpos, &keyblock )) ) {
-	    rc = update_trust_record( keyblock );
+	    int modified;
+
+	    rc = update_trust_record( keyblock, 1, &modified );
 	    if( rc == -1 ) { /* not yet in trustdb: insert */
 		PKT_public_key *pk =
 			    find_kbnode( keyblock, PKT_PUBLIC_KEY
 				       ) ->pkt->pkt.public_key;
 		rc = insert_trust_record( pk );
-		if( rc && !pk->local_id )
+		if( rc && !pk->local_id ) {
 		    log_error("lid ?: insert failed: %s\n",
 						     g10_errstr(rc) );
-		else if( rc )
+		    err_count++;
+		}
+		else if( rc ) {
 		    log_error("lid %lu: insert failed: %s\n",
 				       pk->local_id, g10_errstr(rc) );
-		else
-		     log_info("lid %lu: inserted\n", pk->local_id );
+		    err_count++;
+		}
+		else {
+		    if( opt.verbose )
+			log_info("lid %lu: inserted\n", pk->local_id );
+		    new_count++;
+		}
 	    }
-	    else if( rc )
+	    else if( rc ) {
 		log_error("lid %lu: update failed: %s\n",
 			 lid_from_keyblock(keyblock), g10_errstr(rc) );
-	    else
-		log_info("lid %lu: updated\n",
-				lid_from_keyblock(keyblock) );
-	}
+		err_count++;
+	    }
+	    else if( modified ) {
+		if( opt.verbose )
+		    log_info("lid %lu: updated\n", lid_from_keyblock(keyblock));
+		upd_count++;
+	    }
+	    else if( opt.verbose > 1 )
+		log_info("lid %lu: okay\n", lid_from_keyblock(keyblock) );
+
+	    release_kbnode( keyblock ); keyblock = NULL;
+	    if( !(++count % 100) )
+		log_info(_("%lu keys so far processed\n"), count);
+	}
+	log_info(_("%lu keys processed\n"), count);
+	if( err_count )
+	    log_info(_("\t%lu keys with errors\n"), err_count);
+	if( upd_count )
+	    log_info(_("\t%lu keys updated\n"), upd_count);
+	if( new_count )
+	    log_info(_("\t%lu keys inserted\n"), new_count);
     }
     if( rc && rc != -1 )
 	log_error("enum_keyblocks failed: %s\n", g10_errstr(rc));
@@ -1508,54 +1501,8 @@
 int
 enum_trust_web( void **context, ulong *lid )
 {
-    struct {
-       TRUST_SEG_LIST tsl;
-       int index;
-    } *c = *context;
-
-    if( !c ) { /* make a new context */
-	c = m_alloc_clear( sizeof *c );
-	*context = c;
-	if( *lid == last_trust_web_key && last_trust_web_tslist )
-	    c->tsl = last_trust_web_tslist;
-	else {
-	    TRUST_SEG_LIST tsl, tsl2, tslist;
-	    int rc;
-
-	    rc = make_tsl( *lid, &tslist );
-	    if( rc ) {
-		log_error("failed to build the TSL\n");
-		return rc;
-	    }
-	    /* cache the tslist, so that we do not need to free it */
-	    if( last_trust_web_key ) {
-		for( tsl = last_trust_web_tslist; tsl; tsl = tsl2 ) {
-		    tsl2 = tsl->next;
-		    m_free(tsl);
-		}
-	    }
-	    last_trust_web_key = *lid;
-	    last_trust_web_tslist = tslist;
-	    c->tsl = last_trust_web_tslist;
-	}
-	c->index = 1;
-    }
-
-    if( !lid ) { /* free the context */
-	m_free( c );
-	*context = NULL;
-	return 0;
-    }
+    /* REPLACE THIS with a BETTER ONE  */
 
-    while( c->tsl ) {
-	if( !c->tsl->dup && c->index < c->tsl->nseg-1 ) {
-	    *lid = c->tsl->seg[c->index].lid;
-	    c->index++;
-	    return 0;
-	}
-	c->index = 1;
-	c->tsl = c->tsl->next;
-    }
     return -1; /* eof */
 }
 
@@ -1707,12 +1654,13 @@
 		TRUSTREC *sigrec, int sigidx, ulong hint_owner )
 {
     KBNODE node;
-    int rc, state=0;
+    int rc, state;
     byte uhash[20];
     int is_selfsig;
     PKT_signature *sigpkt = NULL;
     TRUSTREC tmp;
     u32 sigkid[2];
+    int revoke = 0;
 
     if( sigrec->r.sig.sig[sigidx].flag & SIGF_CHECKED )
 	log_info(_("note: sig rec %lu[%d] in hintlist "
@@ -1727,7 +1675,7 @@
     if( tmp.rectype != RECTYPE_DIR ) {
 	/* we need the dir record */
 	log_error(_("sig rec %lu[%d] in hintlist "
-		    "of %u does not point to a dir record\n"),
+		    "of %lu does not point to a dir record\n"),
 		    sigrec->recnum, sigidx, hint_owner );
 	return;
     }
@@ -1741,6 +1689,7 @@
 
 
     /* find the correct signature packet */
+    state = 0;
     for( node=keyblock; node; node = node->next ) {
 	if( node->pkt->pkttype == PKT_USER_ID ) {
 	    PKT_user_id *uidpkt = node->pkt->pkt.user_id;
@@ -1755,13 +1704,20 @@
 	    sigpkt = node->pkt->pkt.signature;
 	    if( sigpkt->keyid[0] == sigkid[0]
 		&& sigpkt->keyid[1] == sigkid[1]
-		&& (sigpkt->sig_class&~3) == 0x10 )
+		&& ( (sigpkt->sig_class&~3) == 0x10
+		     || ( revoke = (sigpkt->sig_class == 0x30)) ) ) {
+		state = 2;
 		break; /* found */
+	    }
 	}
     }
 
     if( !node ) {
-	log_error(_("lid %lu: user id not found in keyblock\n"), lid );
+	log_info(_("lid %lu: user id not found in keyblock\n"), lid );
+	return ;
+    }
+    if( state != 2 ) {
+	log_info(_("lid %lu: user id without signature\n"), lid );
 	return ;
     }
 
@@ -1771,24 +1727,29 @@
 	log_error(_("lid %lu: self-signature in hintlist\n"), lid );
 	return;
     }
+
+    /* FiXME: handling fo SIGF_REVOKED is not correct! */
+
     if( !rc ) { /* valid signature */
 	if( opt.verbose )
-	    log_info(_("key %08lX.%lu, uid %02X%02X, sig %08lX: "
-		       "good signature (3)\n"),
+	    log_info("sig %08lX.%lu/%02X%02X/%08lX: %s\n",
 		    (ulong)keyid[1], lid, uhash[18], uhash[19],
-		    (ulong)sigpkt->keyid[1] );
+		    (ulong)sigpkt->keyid[1],
+		    revoke? _("Valid certificate revocation")
+			  : _("Good certificate") );
 	sigrec->r.sig.sig[sigidx].flag = SIGF_CHECKED | SIGF_VALID;
+	if( revoke )
+	    sigrec->r.sig.sig[sigidx].flag |= SIGF_REVOKED;
     }
     else if( rc == G10ERR_NO_PUBKEY ) {
-	log_info(_("key %08lX.%lu, uid %02X%02X, sig %08lX: "
-		   "very strange: no public key\n"),
+	log_info("sig %08lX.%lu/%02X%02X/%08lX: %s\n",
 	      (ulong)keyid[1], lid, uhash[18], uhash[19],
-	       (ulong)sigpkt->keyid[1] );
+	       (ulong)sigpkt->keyid[1],
+		 _("very strange: no public key\n") );
 	sigrec->r.sig.sig[sigidx].flag = SIGF_NOPUBKEY;
     }
     else {
-	log_info(_("key %08lX.%lu, uid %02X%02X, sig %08lX: "
-		   "invalid signature: %s\n"),
+	log_info("sig %08lX.%lu/%02X%02X/%08lX: %s\n",
 		    (ulong)keyid[1], lid, uhash[18], uhash[19],
 		    (ulong)sigpkt->keyid[1], g10_errstr(rc) );
 	sigrec->r.sig.sig[sigidx].flag = SIGF_CHECKED;
@@ -1891,14 +1852,103 @@
 }
 
 
+/****************
+ * Create or update shadow dir record and return the LID of the record
+ */
+static ulong
+create_shadow_dir( PKT_signature *sig, ulong lid  )
+{
+    TRUSTREC sdir, hlst, tmphlst;
+    ulong recno, newlid;
+    int tmpidx=0; /* avoids gcc warnign - this is controlled by tmphlst */
+    int rc;
+
+    /* first see whether we already have such a record */
+    rc = tdbio_search_sdir( sig->keyid, sig->pubkey_algo, &sdir );
+    if( rc && rc != -1 ) {
+	log_error("tdbio_search_dir failed: %s\n", g10_errstr(rc));
+	die_invalid_db();
+    }
+    if( rc == -1 ) { /* not found: create */
+	memset( &sdir, 0, sizeof sdir );
+	sdir.recnum = tdbio_new_recnum();
+	sdir.rectype= RECTYPE_SDIR;
+	sdir.r.sdir.lid = sdir.recnum;
+	sdir.r.sdir.keyid[0] = sig->keyid[0];
+	sdir.r.sdir.keyid[1] = sig->keyid[1];
+	sdir.r.sdir.pubkey_algo = sig->pubkey_algo;
+	sdir.r.sdir.hintlist = 0;
+	write_record( &sdir );
+    }
+    newlid = sdir.recnum;
+    /* Put the record number into the hintlist.
+     * (It is easier to use the lid and not the record number of the
+     *	key to save some space (assuming that a signator has
+     *	signed more than one user id - and it is easier to implement.)
+     */
+    tmphlst.recnum = 0;
+    for( recno=sdir.r.sdir.hintlist; recno; recno = hlst.r.hlst.next) {
+	int i;
+	read_record( recno, &hlst, RECTYPE_HLST );
+	for( i=0; i < ITEMS_PER_HLST_RECORD; i++ ) {
+	    if( !hlst.r.hlst.rnum[i] ) {
+		if( !tmphlst.recnum ) {
+		    tmphlst = hlst;
+		    tmpidx = i;
+		}
+	    }
+	    else if( hlst.r.hlst.rnum[i] == lid )
+		return newlid; /* the signature is already in the hintlist */
+	}
+    }
+    /* not yet in the hint list, write it */
+    if( tmphlst.recnum ) { /* we have an empty slot */
+	tmphlst.r.hlst.rnum[tmpidx] = lid;
+	write_record( &tmphlst );
+    }
+    else { /* must append a new hlst record */
+	memset( &hlst, 0, sizeof hlst );
+	hlst.recnum = tdbio_new_recnum();
+	hlst.rectype = RECTYPE_HLST;
+	hlst.r.hlst.next = sdir.r.sdir.hintlist;
+	hlst.r.hlst.rnum[0] = lid;
+	write_record( &hlst );
+	sdir.r.sdir.hintlist = hlst.recnum;
+	write_record( &sdir );
+    }
+
+    return newlid;
+}
+
 
+/****************
+ * This function checks the given public key and inserts or updates
+ * the keyrecord from the trustdb.  Revocation certificates
+ * are handled here and the keybinding of subkeys is checked.
+ * Hmmm: Should we check here, that the key has at least one valid
+ * user ID or do we allow keys w/o user ID?
+ *
+ * keyblock points to the first node in the keyblock,
+ * keynode is the node with the public key to check
+ * (either primary or secondary), keyid is the keyid of
+ * the primary key, drec is the directory record and recno_list
+ * is a list used to keep track of visited records.
+ * Existing keyflags are recalculated if recheck is true.
+ */
 static void
-upd_key_record( PKT_public_key *pk, TRUSTREC *drec, RECNO_LIST *recno_list )
+upd_key_record( KBNODE keyblock, KBNODE keynode, u32 *keyid,
+		TRUSTREC *drec, RECNO_LIST *recno_list, int recheck )
 {
     TRUSTREC krec;
+    KBNODE  node;
+    PKT_public_key *pk = keynode->pkt->pkt.public_key;
+    ulong lid = drec->recnum;
     byte fpr[MAX_FINGERPRINT_LEN];
     size_t fprlen;
     ulong recno, newrecno;
+    int keybind_seen = 0;
+    int revoke_seen = 0;
+    int rc;
 
     fingerprint_from_pk( pk, fpr, &fprlen );
     /* do we already have this key? */
@@ -1910,12 +1960,12 @@
     }
     if( recno ) { /* yes */
 	ins_recno_list( recno_list, recno, RECTYPE_KEY );
-	/* here we would compare/update the keyflags */
     }
     else { /* no: insert this new key */
+	recheck = 1;
 	memset( &krec, 0, sizeof(krec) );
 	krec.rectype = RECTYPE_KEY;
-	krec.r.key.lid = drec->recnum;
+	krec.r.key.lid = lid;
 	krec.r.key.pubkey_algo = pk->pubkey_algo;
 	krec.r.key.fingerprint_len = fprlen;
 	memcpy(krec.r.key.fingerprint, fpr, fprlen );
@@ -1928,34 +1978,143 @@
 	    drec->r.dir.keylist = newrecno;
 	    drec->dirty = 1;
 	}
-	else { /* we already have a key, append it to the list */
+	else { /* we already have a key, append the new one */
+	    TRUSTREC save = krec;
 	    for( ; recno; recno = krec.r.key.next )
 		read_record( recno, &krec, RECTYPE_KEY );
 	    krec.r.key.next = newrecno;
 	    write_record( &krec );
+	    krec = save;
+	}
+    }
+
+    if( !recheck && (krec.r.key.keyflags & KEYF_CHECKED) )
+	return;
+
+    /* check keybindings and revocations */
+    krec.r.key.keyflags = 0;
+    if( keynode->pkt->pkttype == PKT_PUBLIC_KEY ) {
+	/* we assume that a primary key is always valid
+	 * and check later whether we have a revocation */
+	krec.r.key.keyflags |= KEYF_CHECKED | KEYF_VALID;
+    }
+
+    for( node=keynode->next; node; node = node->next ) {
+	PKT_signature *sig;
+
+	if( node->pkt->pkttype == PKT_PUBLIC_SUBKEY )
+	    break; /* ready */
+	else if( node->pkt->pkttype != PKT_SIGNATURE )
+	    continue;
+
+	sig = node->pkt->pkt.signature;
+
+	if( keyid[0] != sig->keyid[0] || keyid[1] != sig->keyid[1] )
+	    continue; /* not a self signature */
+	if( sig->sig_class == 0x18 && !keybind_seen ) { /* a keybinding */
+	    if( keynode->pkt->pkttype == PKT_PUBLIC_KEY )
+		continue; /* oops, not for a main key */
+	    /* we check until we find a valid keybinding */
+	    rc = check_key_signature( keyblock, node, NULL );
+	    if( !rc ) {
+		if( opt.verbose )
+		    log_info(_(
+			"key %08lX.%lu: Good subkey binding\n"),
+			 (ulong)keyid_from_pk(pk,NULL), lid );
+		krec.r.key.keyflags |= KEYF_CHECKED | KEYF_VALID;
+	    }
+	    else {
+		log_info(_(
+		  "key %08lX.%lu: Invalid subkey binding: %s\n"),
+		    (ulong)keyid_from_pk(pk,NULL), lid, g10_errstr(rc) );
+		krec.r.key.keyflags |= KEYF_CHECKED;
+		krec.r.key.keyflags &= ~KEYF_VALID;
+	    }
+	    keybind_seen = 1;
+	}
+	else if( sig->sig_class == 0x20 && !revoke_seen ) {
+	    if( keynode->pkt->pkttype == PKT_PUBLIC_SUBKEY )
+		continue; /* a subkey is not expected here */
+	    /* This is a key revocation certificate: check it */
+	    rc = check_key_signature( keyblock, node, NULL );
+	    if( !rc ) {
+		if( opt.verbose )
+		    log_info(_(
+			"key %08lX.%lu: Valid key revocation\n"),
+			 (ulong)keyid_from_pk(pk,NULL), lid );
+		krec.r.key.keyflags |= KEYF_REVOKED;
+	    }
+	    else {
+		log_info(_(
+		  "key %08lX.%lu: Invalid key revocation: %s\n"),
+		  (ulong)keyid_from_pk(pk,NULL), lid, g10_errstr(rc) );
+	    }
+	    revoke_seen = 1;
+	}
+	else if( sig->sig_class == 0x28 && !revoke_seen ) {
+	    if( keynode->pkt->pkttype == PKT_PUBLIC_KEY )
+		continue; /* a mainkey is not expected here */
+	    /* This is a subkey revocation certificate: check it */
+	    /* fixme: we should also check the revocation
+	     * is newer than the key (OpenPGP) */
+	    rc = check_key_signature( keyblock, node, NULL );
+	    if( !rc ) {
+		if( opt.verbose )
+		    log_info(_(
+			"key %08lX.%lu: Valid subkey revocation\n"),
+			 (ulong)keyid_from_pk(pk,NULL), lid );
+		krec.r.key.keyflags |= KEYF_REVOKED;
+	    }
+	    else {
+		log_info(_(
+		  "key %08lX.%lu: Invalid subkey binding: %s\n"),
+		  (ulong)keyid_from_pk(pk,NULL), lid, g10_errstr(rc) );
+	    }
+	    revoke_seen = 1;
 	}
     }
+
+    write_record( &krec );
 }
 
 
+/****************
+ * This function checks the given user ID and inserts or updates
+ * the uid record of the trustdb.  Revocation certificates
+ * are handled here.
+ *
+ * keyblock points to the first node in the keyblock,
+ * uidnode is the node with the user id to check
+ * keyid is the keyid of
+ * the primary key, drec is the directory record and recno_list
+ * is a list used to keep track of visited records.
+ * Existing uidflags are recalculated if recheck is true.
+ */
 static void
-upd_uid_record( PKT_user_id *uid, TRUSTREC *drec, RECNO_LIST *recno_list,
-		u32 *keyid, ulong *uidrecno, byte *uidhash )
+upd_uid_record( KBNODE keyblock, KBNODE uidnode, u32 *keyid,
+		TRUSTREC *drec, RECNO_LIST *recno_list, int recheck )
 {
+    ulong lid = drec->recnum;
+    PKT_user_id *uid = uidnode->pkt->pkt.user_id;
     TRUSTREC urec;
+    PKT_signature *selfsig = NULL;
+    byte uidhash[20];
+    KBNODE node;
     ulong recno, newrecno;
+    int rc;
 
+    /* see whether we already have an uid record */
     rmd160_hash_buffer( uidhash, uid->name, uid->len );
     for( recno=drec->r.dir.uidlist; recno; recno = urec.r.uid.next ) {
 	read_record( recno, &urec, RECTYPE_UID );
 	if( !memcmp( uidhash, urec.r.uid.namehash, 20 ) )
 	    break;
     }
-    if( recno ) {
+    if( recno ) { /* we already have this record */
 	ins_recno_list( recno_list, recno, RECTYPE_UID );
-	*uidrecno = recno;
     }
     else { /* new user id */
+	recheck = 1;
 	memset( &urec, 0 , sizeof(urec) );
 	urec.rectype = RECTYPE_UID;
 	urec.r.uid.lid = drec->recnum;
@@ -1969,438 +2128,450 @@
 	    drec->dirty = 1;
 	}
 	else { /* we already have an uid, append it to the list */
+	    TRUSTREC save = urec;
 	    for( ; recno; recno = urec.r.key.next )
 		read_record( recno, &urec, RECTYPE_UID );
 	    urec.r.uid.next = newrecno;
 	    write_record( &urec );
+	    urec = save;
 	}
-	*uidrecno = newrecno;
     }
+
+    if( recheck || !(urec.r.uid.uidflags & UIDF_CHECKED) ) {
+	/* check self signatures */
+	urec.r.uid.uidflags = 0;
+	for( node=uidnode->next; node; node = node->next ) {
+	    PKT_signature *sig;
+
+	    if( node->pkt->pkttype == PKT_USER_ID )
+		break; /* ready */
+	    if( node->pkt->pkttype == PKT_PUBLIC_SUBKEY )
+		break; /* ready */
+	    if( node->pkt->pkttype != PKT_SIGNATURE )
+		continue;
+
+	    sig = node->pkt->pkt.signature;
+
+	    if( keyid[0] != sig->keyid[0] || keyid[1] != sig->keyid[1] )
+		continue; /* not a self signature */
+
+	    if( (sig->sig_class&~3) == 0x10 ) { /* regular self signature */
+		rc = check_key_signature( keyblock, node, NULL );
+		if( !rc ) {
+		    if( opt.verbose )
+			log_info( "uid %08lX.%lu/%02X%02X: %s\n",
+			   (ulong)keyid[1], lid, uidhash[18], uidhash[19],
+				  _("Good self-signature") );
+		    urec.r.uid.uidflags |= UIDF_CHECKED | UIDF_VALID;
+		    if( !selfsig )
+			selfsig = sig; /* use the first valid sig */
+		}
+		else {
+		    log_info( "uid %08lX/%02X%02X: %s: %s\n",
+			       (ulong)keyid[1], uidhash[18], uidhash[19],
+			      _("Invalid self-signature"),
+			       g10_errstr(rc) );
+		    urec.r.uid.uidflags |= UIDF_CHECKED;
+		}
+	    }
+	    else if( sig->sig_class == 0x30 ) { /* cert revocation */
+		rc = check_key_signature( keyblock, node, NULL );
+		if( !rc ) {
+		    if( opt.verbose )
+			log_info( "uid %08lX.%lu/%02X%02X: %s\n",
+			   (ulong)keyid[1], lid, uidhash[18], uidhash[19],
+				 _("Valid user ID revocation\n") );
+		    urec.r.uid.uidflags |= UIDF_CHECKED | UIDF_VALID;
+		    urec.r.uid.uidflags |= UIDF_REVOKED;
+		}
+		else {
+		    log_info("uid %08lX/%02X%02X: %s: %s\n",
+				(ulong)keyid[1], uidhash[18], uidhash[19],
+			       _("Invalid user ID revocation"),
+							g10_errstr(rc) );
+		}
+	    }
+	}
+	write_record( &urec );
+    } /* end check self-signatures */
+
+
+    if( (urec.r.uid.uidflags & (UIDF_CHECKED|UIDF_VALID))
+	!= (UIDF_CHECKED|UIDF_VALID) )
+	return; /* user ID is not valid, so no need to check more things */
+
+    /* check the preferences */
+    if( selfsig )
+	upd_pref_record( &urec, keyid, selfsig );
+
+    /* check non-self signatures */
+    for( node=uidnode->next; node; node = node->next ) {
+	PKT_signature *sig;
+
+	if( node->pkt->pkttype == PKT_USER_ID )
+	    break; /* ready */
+	if( node->pkt->pkttype == PKT_PUBLIC_SUBKEY )
+	    break; /* ready */
+	if( node->pkt->pkttype != PKT_SIGNATURE )
+	    continue;
+
+	sig = node->pkt->pkt.signature;
+
+	if( keyid[0] == sig->keyid[0] || keyid[1] == sig->keyid[1] )
+	    continue; /* skip self signature */
+
+	if( (sig->sig_class&~3) == 0x10 ) { /* regular certification */
+	    upd_cert_record( keyblock, node, keyid, drec, recno_list,
+			     recheck, &urec, uidhash, 0 );
+	}
+	else if( sig->sig_class == 0x30 ) { /* cert revocation */
+	    upd_cert_record( keyblock, node, keyid, drec, recno_list,
+			     recheck, &urec, uidhash, 1 );
+	}
+    } /* end check certificates */
+
+    write_record( &urec );
 }
 
 
+
+/****************
+ *
+ *
+ */
 static void
-upd_pref_record( PKT_signature *sig, TRUSTREC *drec,
-		 u32 *keyid, TRUSTREC *urec, byte *uidhash )
+upd_pref_record( TRUSTREC *urec, u32 *keyid, PKT_signature *sig )
 {
     static struct {
 	sigsubpkttype_t subpkttype;
 	int preftype;
-    } prefs[] = {
+    } ptable[] = {
 	{ SIGSUBPKT_PREF_SYM,	PREFTYPE_SYM	},
 	{ SIGSUBPKT_PREF_HASH,	PREFTYPE_HASH	},
 	{ SIGSUBPKT_PREF_COMPR, PREFTYPE_COMPR	},
 	{ 0, 0 }
     };
     TRUSTREC prec;
+    ulong lid = urec->r.uid.lid ;
+    const byte *uidhash = urec->r.uid.namehash;
     const byte *s;
     size_t n;
     int k, i;
-    ulong recno_tbl[10];
-    int recno_idx = 0;
     ulong recno;
+    byte prefs_sig[200];
+    int n_prefs_sig = 0;
+    byte prefs_rec[200];
+    int n_prefs_rec = 0;
+
+    /* check for changed preferences */
+    for(k=0; ptable[k].subpkttype; k++ ) {
+	s = parse_sig_subpkt2( sig, ptable[k].subpkttype, &n );
+	if( s ) {
+	    if( n_prefs_sig >= DIM(prefs_sig)-1 ) {
+		log_info("uid %08lX.%lu/%02X%02X: %s\n",
+			  (ulong)keyid[1], lid, uidhash[18], uidhash[19],
+			  _("Too many preferences") );
+		break;
+	    }
+	    prefs_sig[n_prefs_sig++] = ptable[k].preftype;
+	    prefs_sig[n_prefs_sig++] = *s;
+	}
+    }
+    for( recno=urec->r.uid.prefrec; recno; recno = prec.r.pref.next ) {
+	read_record( recno, &prec, RECTYPE_PREF );
+	for(i = 0; i < ITEMS_PER_PREF_RECORD; i +=2 )  {
+	    if( n_prefs_rec >= DIM(prefs_rec)-1 ) {
+		log_info("uid %08lX.%lu/%02X%02X: %s\n",
+			  (ulong)keyid[1], lid, uidhash[18], uidhash[19],
+			  _("Too many preferences items") );
+		break;
+	    }
+	    prefs_rec[n_prefs_rec++] = prec.r.pref.data[i];
+	    prefs_rec[n_prefs_rec++] = prec.r.pref.data[i+1];
+	}
+    }
+    if( n_prefs_sig == n_prefs_rec
+	&& !memcmp( prefs_sig, prefs_rec, n_prefs_sig ) )
+	return;  /* not chnaged */
 
-    /* First delete all pref records
+    /* Preferences have changed:  Delete all pref records
      * This is much simpler than checking whether we have to
-     * do update the record at all - the record cache may care about it */
+     * do update the record at all - the record cache may care about it
+     */
     for( recno=urec->r.uid.prefrec; recno; recno = prec.r.pref.next ) {
 	read_record( recno, &prec, RECTYPE_PREF );
 	delete_record( recno );
     }
 
-    /* and write the new ones */
-    i = 0;
-    for(k=0; prefs[k].subpkttype; k++ ) {
-	s = parse_sig_subpkt2( sig, prefs[k].subpkttype, &n );
-	if( s ) {
-	    while( n ) {
-		if( !i || i >= ITEMS_PER_PREF_RECORD ) {
-		    if( recno_idx >= DIM(recno_tbl)-1 ) {
-			log_info("too many preferences\n");
-			break;
-		    }
-		    if( i ) {
-			recno_tbl[recno_idx]=tdbio_new_recnum();
-			prec.recnum = recno_tbl[recno_idx++];
-			write_record( &prec );
-		    }
-		    memset( &prec, 0, sizeof prec );
-		    prec.rectype = RECTYPE_PREF;
-		    prec.r.pref.lid = drec->recnum;
-		    i = 0;
-		}
-		prec.r.pref.data[i++] = prefs[k].preftype;
-		prec.r.pref.data[i++] = *s++;
-		n--;
+    if( n_prefs_sig > ITEMS_PER_PREF_RECORD )
+	log_info("cannot yet handle long preferences");
+
+    memset( &prec, 0, sizeof prec );
+    prec.recnum = tdbio_new_recnum();
+    prec.rectype = RECTYPE_PREF;
+    prec.r.pref.lid = lid;
+    if( n_prefs_sig <= ITEMS_PER_PREF_RECORD )
+	memcpy( prec.r.pref.data, prefs_sig, n_prefs_sig );
+    else { /* need more than one pref record */
+	TRUSTREC tmp;
+	ulong nextrn;
+	int n = n_prefs_sig;
+	byte *pp = prefs_sig;
+
+	memcpy( prec.r.pref.data, pp, ITEMS_PER_PREF_RECORD );
+	n -= ITEMS_PER_PREF_RECORD;
+	pp += ITEMS_PER_PREF_RECORD;
+	nextrn = prec.r.pref.next = tdbio_new_recnum();
+	do {
+	    memset( &tmp, 0, sizeof tmp );
+	    tmp.recnum = nextrn;
+	    tmp.rectype = RECTYPE_PREF;
+	    tmp.r.pref.lid = lid;
+	    if( n <= ITEMS_PER_PREF_RECORD ) {
+		memcpy( tmp.r.pref.data, pp, n );
+		n = 0;
 	    }
-	}
-    }
-    if( i ) { /* write the last one */
-	recno_tbl[recno_idx]=tdbio_new_recnum();
-	prec.recnum = recno_tbl[recno_idx++];
-	write_record( &prec );
-    }
-    /* now link them together */
-    for(i=0; i < recno_idx-1; i++ ) {
-	read_record( recno_tbl[i], &prec, RECTYPE_PREF );
-	prec.r.pref.next = recno_tbl[i+1];
-	write_record( &prec );
+	    else {
+		memcpy( tmp.r.pref.data, pp, ITEMS_PER_PREF_RECORD );
+		n -= ITEMS_PER_PREF_RECORD;
+		pp += ITEMS_PER_PREF_RECORD;
+		nextrn = tmp.r.pref.next = tdbio_new_recnum();
+	    }
+	    write_record( &tmp );
+	} while( n );
     }
-    /* don't need to write the last one, but update the uid */
-    urec->r.uid.prefrec = recno_idx? recno_tbl[0] : 0;
+    write_record( &prec );
+    urec->r.uid.prefrec = prec.recnum;
     urec->dirty = 1;
 }
 
 
 
-/****************
- * Note: A signature made with a secondary key is not considered a
- *	 self-signature.
- */
 static void
-upd_sig_record( PKT_signature *sig, TRUSTREC *drec,
-		u32 *keyid, ulong *uidrecno, byte *uidhash,
-		KBNODE keyblock, KBNODE signode )
-{
-    TRUSTREC urec;
-    int rc;
+upd_cert_record( KBNODE keyblock, KBNODE signode, u32 *keyid,
+		 TRUSTREC *drec, RECNO_LIST *recno_list, int recheck,
+		 TRUSTREC *urec, const byte *uidhash, int revoke )
+{
+    /* We simply insert the signature into the sig records but
+     * avoid duplicate ones.  We do not check them here because
+     * there is a big chance, that we import required public keys
+     * later.  The problem with this is that we must somewhere store
+     * the information about this signature (we need a record id).
+     * We do this by using the record type shadow dir, which will
+     * be converted to a dir record as soon as a new public key is
+     * inserted into the trustdb.
+     */
     ulong lid = drec->recnum;
+    PKT_signature *sig = signode->pkt->pkt.signature;
+    TRUSTREC rec;
+    ulong recno;
+    TRUSTREC delrec;
+    int delrecidx=0;
+    int newflag = 0;
+    ulong newlid = 0;
+    PKT_public_key *pk = m_alloc_clear( sizeof *pk );
+    ulong pk_lid = 0;
+    int found_sig = 0;
+    int found_delrec = 0;
+    int rc;
 
-    if( !*uidrecno ) {
-	switch( sig->sig_class ) {
-	  case 0x20:
-	  case 0x28: /* We do not need uids for [sub]key revications */
-	  case 0x18: /* or subkey binding */
-	    memset( &urec, 0, sizeof urec ); /* to catch errors */
-	    break;
+    delrec.recnum = 0;
 
-	  default:
-	    log_error("key %08lX: signature (class %02x) without user id\n",
-					 (ulong)keyid[1], sig->sig_class );
-	    return;
-	}
-    }
-    else
-	read_record( *uidrecno, &urec, RECTYPE_UID );
+    /* get the LID of the pubkey of the signature under verification */
+    rc = get_pubkey( pk, sig->keyid );
+    if( !rc ) {
+	if( pk->local_id )
+	    pk_lid = pk->local_id;
+	else {
+	    rc = tdbio_search_dir_bypk( pk, &rec );
+	    if( !rc )
+		pk_lid = rec.recnum;
+	    else if( rc == -1 ) { /* see whether there is a sdir instead */
+		u32 akid[2];
 
-    if( keyid[0] == sig->keyid[0] && keyid[1] == sig->keyid[1] ) {
-	if( (sig->sig_class&~3) == 0x10 ) {
-	    /* must verify this selfsignature here, so that we can
-	     * build the preference record and validate the uid record
-	     */
-	    if( !(urec.r.uid.uidflags & UIDF_CHECKED) ) {
-		rc = check_key_signature( keyblock, signode, NULL );
-		if( !rc ) {
-		    if( opt.verbose )
-			log_info(_(
-			       "key %08lX.%lu, uid %02X%02X: "
-			       "good self-signature\n"),
-				(ulong)keyid[1], lid, uidhash[18],
-						 uidhash[19] );
-		    upd_pref_record( sig, drec, keyid, &urec, uidhash );
-		    urec.r.uid.uidflags = UIDF_CHECKED | UIDF_VALID;
-		}
-		else {
-		    log_error("key %08lX, uid %02X%02X: "
-			      "invalid self-signature: %s\n", (ulong)keyid[1],
-				    uidhash[18], uidhash[19], g10_errstr(rc) );
-		    urec.r.uid.uidflags = UIDF_CHECKED;
-		}
-		urec.dirty = 1;
-	    }
-	}
-	else if( sig->sig_class == 0x18 ) { /* key binding */
-	    /* FIXME */
-	}
-	else if( sig->sig_class == 0x20 ) { /* key revocation */
-	    /* FIXME */
-	}
-	else if( sig->sig_class == 0x28 ) { /* subkey revocation */
-	    /* FIXME */
-	}
-	else if( sig->sig_class == 0x30 ) { /* cert revocation */
-	    /* FIXME */
-	}
-    }
-    else if( (sig->sig_class&~3) == 0x10 ) {
-	/* We simply insert the signature into the sig records but
-	 * avoid duplicate ones.  We do not check them here because
-	 * there is a big chance, that we import required public keys
-	 * later.  The problem with this is that we must somewhere store
-	 * the information about this signature (we need a record id).
-	 * We do this by using the record type shadow dir, which will
-	 * be converted to a dir record as soon as a new public key is
-	 * inserted into the trustdb.
-	 */
-	TRUSTREC rec;
-	ulong recno;
-	TRUSTREC delrec;
-	int delrecidx;
-	int newflag = 0;
-	ulong newlid = 0;
-	PKT_public_key *pk = m_alloc_clear( sizeof *pk );
-	ulong pk_lid = 0;
-	int found_sig = 0;
-	int found_delrec = 0;
-
-	delrec.recnum = 0;
-
-	rc = get_pubkey( pk, sig->keyid );
-	if( !rc ) {
-	    if( pk->local_id )
-		pk_lid = pk->local_id;
-	    else {
-		rc = tdbio_search_dir_bypk( pk, &rec );
+		keyid_from_pk( pk, akid );
+		rc = tdbio_search_sdir( akid, pk->pubkey_algo, &rec );
 		if( !rc )
 		    pk_lid = rec.recnum;
-		else if( rc == -1 ) { /* see whether there is a sdir instead */
-		    u32 akid[2];
-
-		    keyid_from_pk( pk, akid );
-		    rc = tdbio_search_sdir( akid, pk->pubkey_algo, &rec );
-		    if( !rc )
-			pk_lid = rec.recnum;
-		}
 	    }
 	}
-	free_public_key( pk ); pk = NULL;
+    }
+    free_public_key( pk ); pk = NULL;
 
-	/* Loop over all signatures just in case one is not correctly
-	 * marked.  If we see the correct signature, set a flag.
-	 * delete duplicate signatures (should not happen but...)
-	 */
-	for( recno = urec.r.uid.siglist; recno; recno = rec.r.sig.next ) {
-	    int i;
+    /* Loop over all signatures just in case one is not correctly
+     * marked.	If we see the correct signature, set a flag.
+     * delete duplicate signatures (should not happen but...) */
+    for( recno = urec->r.uid.siglist; recno; recno = rec.r.sig.next ) {
+	int i;
 
-	    read_record( recno, &rec, RECTYPE_SIG );
-	    for(i=0; i < SIGS_PER_RECORD; i++ ) {
-		TRUSTREC tmp;
-		if( !rec.r.sig.sig[i].lid ) {
-		    if( !found_delrec && !delrec.recnum ) {
-			delrec = rec;
-			delrecidx = i;
-			found_delrec=1;
-		    }
-		    continue; /* skip deleted sigs */
-		}
-		if( rec.r.sig.sig[i].lid == pk_lid ) {
-		    if( found_sig ) {
-			log_info(_("key %08lX.%lu, uid %02X%02X, sig %08lX: "
-				   "duplicated signature - deleted\n"),
-			      (ulong)keyid[1], lid, uidhash[18],
-			       uidhash[19], (ulong)sig->keyid[1] );
-			rec.r.sig.sig[i].lid = 0;
-			rec.dirty = 1;
-		    }
-		    else
-			found_sig = 1;
+	read_record( recno, &rec, RECTYPE_SIG );
+	for(i=0; i < SIGS_PER_RECORD; i++ ) {
+	    TRUSTREC tmp;
+	    if( !rec.r.sig.sig[i].lid ) {
+		if( !found_delrec && !delrec.recnum ) {
+		    delrec = rec;
+		    delrecidx = i;
+		    found_delrec=1;
 		}
-		if( rec.r.sig.sig[i].flag & SIGF_CHECKED )
-		    continue; /* we already checked this signature */
-		if( rec.r.sig.sig[i].flag & SIGF_NOPUBKEY )
-		    continue; /* we do not have the public key */
-
-		read_record( rec.r.sig.sig[i].lid, &tmp, 0 );
-		if( tmp.rectype == RECTYPE_DIR ) {
-		    /* In this case we should now be able to check
-		     * the signature: */
-		    rc = check_key_signature( keyblock, signode, NULL );
-		    if( !rc ) { /* valid signature */
-			if( opt.verbose )
-			    log_info(_(
-				   "key %08lX.%lu, uid %02X%02X, sig %08lX: "
-				   "good signature (1)\n"),
-				    (ulong)keyid[1], lid, uidhash[18],
-				    uidhash[19], (ulong)sig->keyid[1] );
-			rec.r.sig.sig[i].flag = SIGF_CHECKED | SIGF_VALID;
-		    }
-		    else if( rc == G10ERR_NO_PUBKEY ) {
-			log_info(_("key %08lX.%lu, uid %02X%02X, sig %08lX: "
-				   "weird: no public key\n"),
+		continue; /* skip deleted sigs */
+	    }
+	    if( rec.r.sig.sig[i].lid == pk_lid ) {
+		if( found_sig ) {
+		    log_info( "sig %08lX.%lu/%02X%02X/%08lX: %s\n",
 			      (ulong)keyid[1], lid, uidhash[18],
-			       uidhash[19], (ulong)sig->keyid[1] );
-			rec.r.sig.sig[i].flag = SIGF_NOPUBKEY;
-		    }
-		    else {
-			log_info(_("key %08lX.%lu, uid %02X%02X, sig %08lX: "
-				   "invalid signature: %s\n"),
-				    (ulong)keyid[1], lid, uidhash[18],
-				    uidhash[19], (ulong)sig->keyid[1],
-							g10_errstr(rc));
-			rec.r.sig.sig[i].flag = SIGF_CHECKED;
-		    }
+			       uidhash[19], (ulong)sig->keyid[1],
+			     _("Duplicated certificate - deleted") );
+		    rec.r.sig.sig[i].lid = 0;
 		    rec.dirty = 1;
+		    continue;
 		}
-		else if( tmp.rectype == RECTYPE_SDIR ) {
-		    /* must check that it is the right one */
-		    if( tmp.r.sdir.keyid[0] == sig->keyid[0]
-			&& tmp.r.sdir.keyid[1] == sig->keyid[1]
-			&& (!tmp.r.sdir.pubkey_algo
-			     || tmp.r.sdir.pubkey_algo == sig->pubkey_algo )) {
-			log_info(_("key %08lX.%lu, uid %02X%02X: "
-				   "has shadow dir %lu but not yet marked.\n"),
-				    (ulong)keyid[1], lid,
-				    uidhash[18], uidhash[19], tmp.recnum );
-			rec.r.sig.sig[i].flag = SIGF_NOPUBKEY;
-			rec.dirty = 1;
-			/* fixme: should we verify that the record is
-			 * in the hintlist? - This case here should anyway
-			 * never occur */
-		    }
+		found_sig = 1;
+	    }
+	    if( !recheck && !revoke && (rec.r.sig.sig[i].flag & SIGF_CHECKED) )
+		continue; /* we already checked this signature */
+	    if( !recheck && (rec.r.sig.sig[i].flag & SIGF_NOPUBKEY) )
+		continue; /* we do not have the public key */
+
+	    read_record( rec.r.sig.sig[i].lid, &tmp, 0 );
+	    if( tmp.rectype == RECTYPE_DIR ) {
+		/* In this case we should now be able to check the signature */
+		rc = check_key_signature( keyblock, signode, NULL );
+		if( !rc ) { /* valid signature */
+		    if( opt.verbose )
+			log_info("sig %08lX.%lu/%02X%02X/%08lX: %s\n",
+				(ulong)keyid[1], lid, uidhash[18],
+				uidhash[19], (ulong)sig->keyid[1],
+				revoke? _("Valid certificate revocation")
+				      : _("Good certificate") );
+		    rec.r.sig.sig[i].flag = SIGF_CHECKED | SIGF_VALID;
+		    if( revoke )
+			rec.r.sig.sig[i].flag |= SIGF_REVOKED;
+		}
+		else if( rc == G10ERR_NO_PUBKEY ) {
+		    if( (rec.r.sig.sig[i].flag & SIGF_CHECKED) )
+			log_info("sig %08lX.%lu/%02X%02X/%08lX: %s\n",
+				  (ulong)keyid[1], lid, uidhash[18],
+				 uidhash[19], (ulong)sig->keyid[1],
+				 _("public key lost") );
+		    rec.r.sig.sig[i].flag = SIGF_NOPUBKEY;
+		    if( revoke )
+			rec.r.sig.sig[i].flag |= SIGF_REVOKED;
 		}
 		else {
-		    log_error("sig record %lu[%d] points to wrong record.\n",
-				rec.r.sig.sig[i].lid, i );
-		    die_invalid_db();
+		    log_info("sig %08lX.%lu/%02X%02X/%08lX: %s: %s\n",
+				(ulong)keyid[1], lid, uidhash[18],
+				uidhash[19], (ulong)sig->keyid[1],
+				revoke? _("Invalid certificate revocation")
+				      : _("Invalid certificate"),
+						    g10_errstr(rc));
+		    rec.r.sig.sig[i].flag = SIGF_CHECKED;
+		    if( revoke )
+			rec.r.sig.sig[i].flag |= SIGF_REVOKED;
+		}
+		rec.dirty = 1;
+	    }
+	    else if( tmp.rectype == RECTYPE_SDIR ) {
+		/* must check that it is the right one */
+		if( tmp.r.sdir.keyid[0] == sig->keyid[0]
+		    && tmp.r.sdir.keyid[1] == sig->keyid[1]
+		    && (!tmp.r.sdir.pubkey_algo
+			 || tmp.r.sdir.pubkey_algo == sig->pubkey_algo )) {
+		    if( !(rec.r.sig.sig[i].flag & SIGF_NOPUBKEY) )
+			log_info("uid %08lX.%lu/%02X%02X: "
+				 "has shadow dir %lu but not yet marked.\n",
+				(ulong)keyid[1], lid,
+				uidhash[18], uidhash[19], tmp.recnum );
+		    rec.r.sig.sig[i].flag = SIGF_NOPUBKEY;
+		    if( revoke )
+			rec.r.sig.sig[i].flag |= SIGF_REVOKED;
+		    rec.dirty = 1;
+		    /* fixme: should we verify that the record is
+		     * in the hintlist? - This case here should anyway
+		     * never occur */
 		}
 	    }
-	    if( found_delrec && delrec.recnum ) {
-		delrec = rec;
-		found_delrec = 0; /* we onyl want the first one */
+	    else {
+		log_error("sig record %lu[%d] points to wrong record.\n",
+			    rec.r.sig.sig[i].lid, i );
+		die_invalid_db();
 	    }
-	    if( rec.dirty )
-		write_record( &rec );
 	}
-
-	if( found_sig )
-	    goto leave;
-
-	/* at this point, we have verified, that the signature is not in
-	 * our list of signatures.  Add a new record with that signature
-	 * and if the public key is there, check the signature. */
-
-	if( !pk_lid )
-	    rc = G10ERR_NO_PUBKEY;
-	else
-	    rc = check_key_signature( keyblock, signode, NULL );
-
-	if( !rc ) { /* valid signature */
-	    if( opt.verbose )
-		log_info(_("key %08lX.%lu, uid %02X%02X, sig %08lX: "
-			   "good signature (2)\n"),
-			      (ulong)keyid[1], lid, uidhash[18],
-			       uidhash[19], (ulong)sig->keyid[1] );
-	    newlid = pk_lid;  /* this is the pk of the signature */
-	    if( !newlid )
-		BUG();
-	    newflag = SIGF_CHECKED | SIGF_VALID;
-	}
-	else if( rc == G10ERR_NO_PUBKEY ) {
-	    if( opt.verbose > 1 )
-		log_info(_("key %08lX.%lu, uid %02X%02X, sig %08lX: "
-			   "no public key\n"),
-			      (ulong)keyid[1], lid, uidhash[18],
-			       uidhash[19], (ulong)sig->keyid[1] );
-	    newflag = SIGF_NOPUBKEY;
+	if( found_delrec && delrec.recnum ) {
+	    delrec = rec;
+	    found_delrec = 0; /* we only want the first one */
 	}
-	else {
-	    log_info(_("key %08lX.%lu, uid %02X%02X, sig %08lX: "
-		       "invalid signature: %s\n"),
-			(ulong)keyid[1], lid, uidhash[18], uidhash[19],
-				  (ulong)sig->keyid[1], g10_errstr(rc));
-	    newflag = SIGF_CHECKED;
+	if( rec.dirty ) {
+	    write_record( &rec );
+	    rec.dirty = 0;
 	}
+    }
 
-	if( !newlid ) { /* create a shadow dir record */
-	    TRUSTREC sdir, hlst, tmphlst;
-	    int tmpidx;
-	    /* first see whether we already have such a record */
-	    rc = tdbio_search_sdir( sig->keyid, sig->pubkey_algo, &sdir );
-	    if( rc && rc != -1 ) {
-		log_error("tdbio_search_dir failed: %s\n", g10_errstr(rc));
-		die_invalid_db();
-	    }
-	    if( rc == -1 ) { /* not found: create */
-		memset( &sdir, 0, sizeof sdir );
-		sdir.recnum = tdbio_new_recnum();
-		sdir.rectype= RECTYPE_SDIR;
-		sdir.r.sdir.lid = sdir.recnum;
-		sdir.r.sdir.keyid[0] = sig->keyid[0];
-		sdir.r.sdir.keyid[1] = sig->keyid[1];
-		sdir.r.sdir.pubkey_algo = sig->pubkey_algo;
-		sdir.r.sdir.hintlist = 0;
-		write_record( &sdir );
-	    }
-	    newlid = sdir.recnum;
-	    /* Put the record number into the hintlist.
-	     * (It is easier to use the lid and not the record number of the
-	     *	key to save some space (assuming that a signator has
-	     *	signed more than one user id - and it is easier to implement.)
-	     */
-	    tmphlst.recnum = 0;
-	    for( recno=sdir.r.sdir.hintlist; recno; recno = hlst.r.hlst.next) {
-		int i;
-		read_record( recno, &hlst, RECTYPE_HLST );
-		for( i=0; i < ITEMS_PER_HLST_RECORD; i++ ) {
-		    if( !hlst.r.hlst.rnum[i] ) {
-			if( !tmphlst.recnum ) {
-			    tmphlst = hlst;
-			    tmpidx = i;
-			}
-		    }
-		    else if( hlst.r.hlst.rnum[i] == lid )
-			goto have_hint;
-		}
-	    }
-	    /* not yet in the hint list, write it */
-	    if( tmphlst.recnum ) { /* we have an empty slot */
-		tmphlst.r.hlst.rnum[tmpidx] = lid;
-		write_record( &tmphlst );
-	    }
-	    else { /* must append a new hlst record */
-		memset( &hlst, 0, sizeof hlst );
-		hlst.recnum = tdbio_new_recnum();
-		hlst.rectype = RECTYPE_HLST;
-		hlst.r.hlst.next = sdir.r.sdir.hintlist;
-		hlst.r.hlst.rnum[0] = lid;
-		write_record( &hlst );
-		sdir.r.sdir.hintlist = hlst.recnum;
-		write_record( &sdir );
-	    }
-	  have_hint:  /* "goto considered useful" (don't tell Dijkstra) */
-	    ;
-	}
-
-	if( delrec.recnum ) { /* we can reuse a deleted slot */
-	    delrec.r.sig.sig[delrecidx].lid = newlid;
-	    delrec.r.sig.sig[delrecidx].flag= newflag;
-	    write_record( &delrec );
-	}
-	else { /* must insert a new sig record */
-	    TRUSTREC tmp;
+    if( found_sig )
+	return;
 
-	    memset( &tmp, 0, sizeof tmp );
-	    tmp.recnum = tdbio_new_recnum();
-	    tmp.rectype = RECTYPE_SIG;
-	    tmp.r.sig.lid = lid;
-	    tmp.r.sig.next = urec.r.uid.siglist;
-	    tmp.r.sig.sig[0].lid = newlid;
-	    tmp.r.sig.sig[0].flag= newflag;
-	    write_record( &tmp );
-	    urec.r.uid.siglist = tmp.recnum;
-	    urec.dirty = 1;
-	}
+    /* at this point, we have verified, that the signature is not in
+     * our list of signatures.	Add a new record with that signature
+     * and if the public key is there, check the signature. */
 
+    if( !pk_lid ) /* we have already seen that there is no pubkey */
+	rc = G10ERR_NO_PUBKEY;
+    else
+	rc = check_key_signature( keyblock, signode, NULL );
+
+    if( !rc ) { /* valid signature */
+	if( opt.verbose )
+	    log_info("sig %08lX.%lu/%02X%02X/%08lX: %s\n",
+			  (ulong)keyid[1], lid, uidhash[18],
+			   uidhash[19], (ulong)sig->keyid[1],
+				revoke? _("Valid certificate revocation")
+				      : _("Good certificate") );
+	newlid = pk_lid;  /* this is the pk of the signature */
+	newflag = SIGF_CHECKED | SIGF_VALID;
+	if( revoke )
+	    newflag |= SIGF_REVOKED;
     }
-    else if( sig->sig_class == 0x18 ) { /* key binding */
-	log_info(_("key %08lX: bogus key binding by %08lX\n"),
-				 (ulong)keyid[1], (ulong)sig->keyid[1] );
-    }
-    else if( sig->sig_class == 0x20 ) { /* key revocation */
-	log_info(_("key %08lX: bogus key revocation by %08lX\n"),
-				 (ulong)keyid[1], (ulong)sig->keyid[1] );
-    }
-    else if( sig->sig_class == 0x28 ) { /* subkey revocation */
-	log_info(_("key %08lX: bogus subkey revocation by %08lX\n"),
-				 (ulong)keyid[1], (ulong)sig->keyid[1] );
+    else if( rc == G10ERR_NO_PUBKEY ) {
+	if( opt.verbose > 1 )
+	    log_info("sig %08lX.%lu/%02X%02X/%08lX: %s\n",
+		     (ulong)keyid[1], lid, uidhash[18],
+		      uidhash[19], (ulong)sig->keyid[1], g10_errstr(rc) );
+	newlid = create_shadow_dir( sig, lid );
+	newflag = SIGF_NOPUBKEY;
+	if( revoke )
+	    newflag |= SIGF_REVOKED;
     }
-    else if( sig->sig_class == 0x30 ) { /* cert revocation */
-	/* FIXME: a signator wants to revoke his certification signature */
+    else {
+	log_info( "sig %08lX.%lu/%02X%02X/%08lX: %s: %s\n",
+		    (ulong)keyid[1], lid, uidhash[18], uidhash[19],
+			      (ulong)sig->keyid[1],
+		revoke? _("Invalid certificate revocation")
+		      : _("Invalid certificate"),
+					    g10_errstr(rc));
+	newlid = create_shadow_dir( sig, lid );
+	newflag = SIGF_CHECKED;
+	if( revoke )
+	    newflag |= SIGF_REVOKED;
+    }
+
+    if( delrec.recnum ) { /* we can reuse a deleted/unused slot */
+	delrec.r.sig.sig[delrecidx].lid = newlid;
+	delrec.r.sig.sig[delrecidx].flag= newflag;
+	write_record( &delrec );
+    }
+    else { /* must insert a new sig record */
+	TRUSTREC tmp;
+
+	memset( &tmp, 0, sizeof tmp );
+	tmp.recnum = tdbio_new_recnum();
+	tmp.rectype = RECTYPE_SIG;
+	tmp.r.sig.lid = lid;
+	tmp.r.sig.next = urec->r.uid.siglist;
+	tmp.r.sig.sig[0].lid = newlid;
+	tmp.r.sig.sig[0].flag= newflag;
+	write_record( &tmp );
+	urec->r.uid.siglist = tmp.recnum;
+	urec->dirty = 1;
     }
-
-  leave:
-    if( urec.dirty )
-	write_record( &urec );
 }
 
 
@@ -2408,11 +2579,11 @@
  * Update all the info from the public keyblock.
  * The key must already exist in the keydb.
  * This function is responsible for checking the signatures in cases
- * where the public key is already available.  If we no not have the public
+ * where the public key is already available.  If we do not have the public
  * key, the check is done by some special code in insert_trust_record().
  */
 int
-update_trust_record( KBNODE keyblock )
+update_trust_record( KBNODE keyblock, int recheck, int *modified )
 {
     PKT_public_key *primary_pk;
     KBNODE node;
@@ -2424,9 +2595,11 @@
     int rc = 0;
     u32 keyid[2]; /* keyid of primary key */
     ulong recno, lastrecno;
-    ulong uidrecno = 0;
-    byte uidhash[20];
     RECNO_LIST recno_list = NULL; /* list of verified records */
+    /* fixme: replace recno_list by a lookup on node->recno */
+
+    if( modified )
+	*modified = 0;
 
     node = find_kbnode( keyblock, PKT_PUBLIC_KEY );
     primary_pk = node->pkt->pkt.public_key;
@@ -2438,41 +2611,29 @@
 
     keyid_from_pk( primary_pk, keyid );
 
-    /* fixme: start a transaction */
-    /* now update keys and user ids */
-    for( node=keyblock; node; node = node->next ) {
-	switch( node->pkt->pkttype ) {
-	  case PKT_PUBLIC_KEY:
-	  case PKT_PUBLIC_SUBKEY:
-	    uidrecno = 0;
-	    upd_key_record( node->pkt->pkt.public_key, &drec, &recno_list );
-	    break;
-
-	  case PKT_USER_ID:
-	    if( drec.dirty ) { /* upd_pref_record may read the drec */
-		write_record( &drec );
-		drec.dirty = 0;
-	    }
-	    upd_uid_record( node->pkt->pkt.user_id, &drec, &recno_list,
-			    keyid, &uidrecno, uidhash );
-	    break;
+    /* fixme: check that the keyblock has a valid structure */
 
-	  case PKT_SIGNATURE:
-	    if( drec.dirty ) { /* upd_sig_recrod may read the drec */
-		write_record( &drec );
-		drec.dirty = 0;
-	    }
-	    upd_sig_record( node->pkt->pkt.signature, &drec,
-			    keyid, &uidrecno, uidhash, keyblock, node );
-	    break;
-
-	  default:
-	    break;
-	}
-    } /* end loop over all nodes */
+    rc = tdbio_begin_transaction();
+    if( rc )
+	return rc;
 
+    /* update the keys */
+    for( node=keyblock; node; node = node->next ) {
+	if( node->pkt->pkttype == PKT_PUBLIC_KEY
+	    || node->pkt->pkttype == PKT_PUBLIC_SUBKEY )
+	    upd_key_record( keyblock, node, keyid,
+			    &drec, &recno_list, recheck );
+    }
+    /* update the user IDs */
+    for( node=keyblock; node; node = node->next ) {
+	if( node->pkt->pkttype == PKT_USER_ID )
+	    upd_uid_record( keyblock, node, keyid,
+			    &drec, &recno_list, recheck );
+    }
 
     /* delete keyrecords from the trustdb which are not anymore used */
+    /* should we really do this, or is it better to keep them and */
+    /* mark as unused? */
     lastrecno = 0;
     for( recno=drec.r.dir.keylist; recno; recno = krec.r.key.next ) {
 	read_record( recno, &krec, RECTYPE_KEY );
@@ -2526,11 +2687,12 @@
 
 
     if( rc )
-	; /* fixme: cancel transaction */
-    else if( drec.dirty ) {
-	drec.r.dir.dirflags &= ~DIRF_CHECKED; /* reset flag */
+	rc = tdbio_cancel_transaction();
+    else {
 	write_record( &drec );
-	do_sync();
+	if( modified && tdbio_is_dirty() )
+	    *modified = 1;
+	rc = tdbio_end_transaction();
     }
     rel_recno_list( &recno_list );
     return rc;
@@ -2633,7 +2795,7 @@
     }
 
     /* and put all the other stuff into the keydb */
-    rc = update_trust_record( keyblock );
+    rc = update_trust_record( keyblock, 0, NULL );
     if( !rc )
 	process_hintlist( hintlist, dirrec.r.dir.lid );
 
diff -urN gnupg-0.4.2/g10/trustdb.h gnupg-0.4.3/g10/trustdb.h
--- gnupg-0.4.2/g10/trustdb.h	Tue Oct 13 11:04:42 1998
+++ gnupg-0.4.3/g10/trustdb.h	Tue Oct 27 14:52:00 1998
@@ -60,7 +60,7 @@
 int query_trust_record( PKT_public_key *pk );
 int clear_trust_checked_flag( PKT_public_key *pk );
 int insert_trust_record( PKT_public_key *pk );
-int update_trust_record( KBNODE keyblock );
+int update_trust_record( KBNODE keyblock, int fast, int *modified );
 int update_ownertrust( ulong lid, unsigned new_trust );
 
 /*-- pkclist.c --*/
diff -urN gnupg-0.4.2/include/ChangeLog gnupg-0.4.3/include/ChangeLog
--- gnupg-0.4.2/include/ChangeLog	Tue Oct 13 12:41:24 1998
+++ gnupg-0.4.3/include/ChangeLog	Tue Oct 20 11:40:14 1998
@@ -1,3 +1,7 @@
+Tue Oct 20 11:40:00 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* iobuf.h (iobuf_get_temp_buffer): New.
+
 Tue Oct 13 12:40:48 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* iobuf.h (iobuf_get): Now uses .nofast
diff -urN gnupg-0.4.2/include/distfiles gnupg-0.4.3/include/distfiles
--- gnupg-0.4.2/include/distfiles	Sat Jun 13 16:50:33 1998
+++ gnupg-0.4.3/include/distfiles	Wed Oct 21 15:37:42 1998
@@ -7,6 +7,7 @@
 types.h
 util.h
 i18n.h
+host2net.h
 
 g10lib.h
 
diff -urN gnupg-0.4.2/include/host2net.h gnupg-0.4.3/include/host2net.h
--- gnupg-0.4.2/include/host2net.h	Thu Jan  1 01:00:00 1970
+++ gnupg-0.4.3/include/host2net.h	Wed Oct 21 15:38:26 1998
@@ -0,0 +1,43 @@
+/* host2net.h - Some macros
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#ifndef G10_HOST2NET_H
+#define G10_HOST2NET_H
+
+#include "types.h"
+
+#define buftoulong( p )  ((*(byte*)(p) << 24) | (*((byte*)(p)+1)<< 16) | \
+		       (*((byte*)(p)+2) << 8) | (*((byte*)(p)+3)))
+#define buftoushort( p )  ((*((byte*)(p)) << 8) | (*((byte*)(p)+1)))
+#define ulongtobuf( p, a ) do { 			  \
+			    ((byte*)p)[0] = a >> 24;	\
+			    ((byte*)p)[1] = a >> 16;	\
+			    ((byte*)p)[2] = a >>  8;	\
+			    ((byte*)p)[3] = a	   ;	\
+			} while(0)
+#define ushorttobuf( p, a ) do {			   \
+			    ((byte*)p)[0] = a >>  8;	\
+			    ((byte*)p)[1] = a	   ;	\
+			} while(0)
+#define buftou32( p)	buftoulong( (p) )
+#define u32tobuf( p, a) ulongtobuf( (p), (a) )
+
+
+#endif /*G10_HOST2NET_H*/
diff -urN gnupg-0.4.2/include/iobuf.h gnupg-0.4.3/include/iobuf.h
--- gnupg-0.4.2/include/iobuf.h	Fri Oct 16 10:34:56 1998
+++ gnupg-0.4.3/include/iobuf.h	Thu Oct 22 21:46:34 1998
@@ -71,6 +71,7 @@
 
 IOBUF iobuf_alloc(int usage, size_t bufsize);
 IOBUF iobuf_temp(void);
+IOBUF iobuf_temp_with_content( const char *buffer, size_t length );
 IOBUF iobuf_open( const char *fname );
 IOBUF iobuf_fopen( const char *fname, const char *mode );
 IOBUF iobuf_create( const char *fname );
@@ -129,6 +130,7 @@
 #define iobuf_where(a)	"[don't know]"
 #define iobuf_id(a)	((a)->no)
 
+#define iobuf_get_temp_buffer(a) ( (a)->d.buf )
 #define iobuf_get_temp_length(a) ( (a)->d.len )
 #define iobuf_is_temp(a)	 ( (a)->usage == 3 )
 
diff -urN gnupg-0.4.2/include/util.h gnupg-0.4.3/include/util.h
--- gnupg-0.4.2/include/util.h	Tue Oct  6 09:55:28 1998
+++ gnupg-0.4.3/include/util.h	Tue Nov  3 16:14:13 1998
@@ -125,6 +125,8 @@
 
 
 /*-- fileutil.c --*/
+char * make_basename(const char *filepath);
+char * make_dirname(const char *filepath);
 char *make_filename( const char *first_part, ... );
 int compare_filenames( const char *a, const char *b );
 const char *print_fname_stdin( const char *s );
@@ -150,6 +152,8 @@
 char *mem2str( char *, const void *, size_t);
 char *trim_spaces( char *string );
 int string_count_chr( const char *string, int c );
+char *native_to_utf8( const char *string );
+char *utf8_to_native( const char *string );
 
 #define stricmp(a,b) strcasecmp((a),(b))
 
diff -urN gnupg-0.4.2/mpi/ChangeLog gnupg-0.4.3/mpi/ChangeLog
--- gnupg-0.4.2/mpi/ChangeLog	Wed Oct 14 10:00:18 1998
+++ gnupg-0.4.3/mpi/ChangeLog	Tue Oct 27 12:38:26 1998
@@ -1,6 +1,10 @@
+Tue Oct 27 12:37:46 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* config.links (freebsd): Fixes for FreeBSD 3.0
+
 Wed Oct 14 09:59:30 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
-	* config-links (freebsd): ELF patches from Jun Kuriyama.
+	* config.links (freebsd): ELF patches from Jun Kuriyama.
 
 Thu Oct  8 13:28:17 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
diff -urN gnupg-0.4.2/mpi/Makefile.in gnupg-0.4.3/mpi/Makefile.in
--- gnupg-0.4.2/mpi/Makefile.in	Sun Oct 18 17:08:19 1998
+++ gnupg-0.4.3/mpi/Makefile.in	Sun Nov  8 18:23:42 1998
@@ -1,4 +1,4 @@
-# Makefile.in generated automatically by automake 1.2f from Makefile.am
+# Makefile.in generated automatically by automake 1.3 from Makefile.am
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 # This Makefile.in is free software; the Free Software Foundation
@@ -32,6 +32,8 @@
 includedir = @includedir@
 oldincludedir = /usr/include
 
+DISTDIR =
+
 pkgdatadir = $(datadir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
@@ -163,14 +165,14 @@
 SOURCES = $(libmpi_a_SOURCES)
 OBJECTS = $(libmpi_a_OBJECTS)
 
-default: all
+all: Makefile $(LIBRARIES)
 
 .SUFFIXES:
 .SUFFIXES: .S .c .o .s
-$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) 
+$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4)
 	cd $(top_srcdir) && $(AUTOMAKE) --gnu --include-deps mpi/Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status
 	cd $(top_builddir) \
 	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
 
@@ -317,8 +319,6 @@
 
 uninstall: 
 
-all: Makefile $(LIBRARIES)
-
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs:
@@ -354,7 +354,7 @@
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
-.PHONY: default mostlyclean-noinstLIBRARIES distclean-noinstLIBRARIES \
+.PHONY: mostlyclean-noinstLIBRARIES distclean-noinstLIBRARIES \
 clean-noinstLIBRARIES maintainer-clean-noinstLIBRARIES \
 mostlyclean-compile distclean-compile clean-compile \
 maintainer-clean-compile tags mostlyclean-tags distclean-tags \
diff -urN gnupg-0.4.2/mpi/config.links gnupg-0.4.3/mpi/config.links
--- gnupg-0.4.2/mpi/config.links	Wed Oct 14 09:59:28 1998
+++ gnupg-0.4.3/mpi/config.links	Tue Oct 27 12:37:25 1998
@@ -10,12 +10,12 @@
 echo '/* created by config.links - do not edit */' >./mpi/asm-syntax.h
 
 case "${target}" in
-    i[34]86*-*-freebsd*-elf)
+    i[34]86*-*-freebsd*-elf | i[34]86*-*-freebsd3*)
        echo '#define ELF_SYNTAX' >>./mpi/asm-syntax.h
        cat  $srcdir/mpi/i386/syntax.h	   >>./mpi/asm-syntax.h
        path="i386"
        ;;
-    i[56]86*-*-freebsd*-elf)
+    i[56]86*-*-freebsd*-elf | i[56]86*-*-freebsd3*)
        echo '#define ELF_SYNTAX' >>./mpi/asm-syntax.h
        cat  $srcdir/mpi/i386/syntax.h	   >>./mpi/asm-syntax.h
        path="i586 i386"
diff -urN gnupg-0.4.2/po/ChangeLog gnupg-0.4.3/po/ChangeLog
--- gnupg-0.4.2/po/ChangeLog	Mon Oct 12 09:08:22 1998
+++ gnupg-0.4.3/po/ChangeLog	Fri Oct 30 20:03:37 1998
@@ -1,3 +1,7 @@
+Fri Oct 30 20:03:17 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* fr.po: Imported new version
+
 Mon Oct 12 09:08:09 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* it.po: Imported new version.
diff -urN gnupg-0.4.2/po/cat-id-tbl.c gnupg-0.4.3/po/cat-id-tbl.c
--- gnupg-0.4.2/po/cat-id-tbl.c	Sun Oct 18 16:36:41 1998
+++ gnupg-0.4.3/po/cat-id-tbl.c	Sun Nov  8 16:39:11 1998
@@ -54,7 +54,7 @@
   {"Unusable pubkey algorithm", 45},
   {"File exists", 46},
   {"Weak key", 47},
-  {"Ohhhh jeeee ... this is a bug (%s:%d:%s)\n", 48},
+  {"... this is a bug (%s:%d:%s)\n", 48},
   {"you found a bug ... (%s:%d)\n", 49},
   {"warning: using insecure random number generator!!\n", 50},
   {"\
@@ -110,29 +110,30 @@
   {"use canonical text mode", 88},
   {"use as output file", 89},
   {"verbose", 90},
-  {"force v3 signatures", 91},
-  {"batch mode: never ask", 92},
-  {"assume yes on most questions", 93},
-  {"assume no on most questions", 94},
-  {"add this keyring to the list of keyrings", 95},
-  {"add this secret keyring to the list", 96},
-  {"|NAME|use NAME as default secret key", 97},
-  {"read options from file", 98},
-  {"set debugging flags", 99},
-  {"enable full debugging", 100},
-  {"|FD|write status info to this FD", 101},
-  {"do not write comment packets", 102},
-  {"(default is 1)", 103},
-  {"(default is 3)", 104},
-  {"|FILE|load extension module FILE", 105},
-  {"emulate the mode described in RFC1991", 106},
-  {"|N|use passphrase mode N", 107},
-  {"|NAME|use message digest algorithm NAME for passphrases", 108},
-  {"|NAME|use cipher algorithm NAME for passphrases", 109},
-  {"|NAME|use cipher algorithm NAME", 110},
-  {"|NAME|use message digest algorithm NAME", 111},
-  {"|N|use compress algorithm N", 112},
-  {"throw keyid field of encrypted packets", 113},
+  {"be somewhat more quiet", 91},
+  {"force v3 signatures", 92},
+  {"batch mode: never ask", 93},
+  {"assume yes on most questions", 94},
+  {"assume no on most questions", 95},
+  {"add this keyring to the list of keyrings", 96},
+  {"add this secret keyring to the list", 97},
+  {"|NAME|use NAME as default secret key", 98},
+  {"read options from file", 99},
+  {"set debugging flags", 100},
+  {"enable full debugging", 101},
+  {"|FD|write status info to this FD", 102},
+  {"do not write comment packets", 103},
+  {"(default is 1)", 104},
+  {"(default is 3)", 105},
+  {"|FILE|load extension module FILE", 106},
+  {"emulate the mode described in RFC1991", 107},
+  {"|N|use passphrase mode N", 108},
+  {"|NAME|use message digest algorithm NAME for passphrases", 109},
+  {"|NAME|use cipher algorithm NAME for passphrases", 110},
+  {"|NAME|use cipher algorithm NAME", 111},
+  {"|NAME|use message digest algorithm NAME", 112},
+  {"|N|use compress algorithm N", 113},
+  {"throw keyid field of encrypted packets", 114},
   {"\
 @\n\
 Examples:\n\
@@ -141,71 +142,71 @@
  --clearsign [file]         make a clear text signature\n\
  --detach-sign [file]       make a detached signature\n\
  --list-keys [names]        show keys\n\
- --fingerprint [names]      show fingerprints\n", 114},
-  {"Please report bugs to <gnupg-bugs@gnu.org>.\n", 115},
-  {"Usage: gpgm [options] [files] (-h for help)", 116},
-  {"Usage: gpg [options] [files] (-h for help)", 117},
+ --fingerprint [names]      show fingerprints\n", 115},
+  {"Please report bugs to <gnupg-bugs@gnu.org>.\n", 116},
+  {"Usage: gpgm [options] [files] (-h for help)", 117},
+  {"Usage: gpg [options] [files] (-h for help)", 118},
   {"\
 Syntax: gpgm [options] [files]\n\
-GnuPG maintenance utility\n", 118},
+GnuPG maintenance utility\n", 119},
   {"\
 Syntax: gpg [options] [files]\n\
 sign, check, encrypt or decrypt\n\
-default operation depends on the input data\n", 119},
+default operation depends on the input data\n", 120},
   {"\
 \n\
-Supported algorithms:\n", 120},
-  {"usage: gpgm [options] ", 121},
-  {"usage: gpg [options] ", 122},
-  {"conflicting commands\n", 123},
-  {"note: no default option file '%s'\n", 124},
-  {"option file '%s': %s\n", 125},
-  {"reading options from '%s'\n", 126},
-  {"selected cipher algorithm is invalid\n", 127},
-  {"selected digest algorithm is invalid\n", 128},
-  {"compress algorithm must be in range %d..%d\n", 129},
-  {"completes-needed must be greater than 0\n", 130},
-  {"marginals-needed must be greater than 1\n", 131},
-  {"note: simple S2K mode (0) is strongly discouraged\n", 132},
-  {"invalid S2K mode; must be 0, 1 or 3\n", 133},
-  {"failed to initialize the TrustDB: %s\n", 134},
-  {"--store [filename]", 135},
-  {"--symmetric [filename]", 136},
-  {"--encrypt [filename]", 137},
-  {"--sign [filename]", 138},
-  {"--sign --encrypt [filename]", 139},
-  {"--clearsign [filename]", 140},
-  {"--decrypt [filename]", 141},
-  {"--edit-key username", 142},
-  {"--delete-secret-key username", 143},
-  {"--delete-key username", 144},
-  {"can't open %s: %s\n", 145},
-  {"-k[v][v][v][c] [userid] [keyring]", 146},
-  {"dearmoring failed: %s\n", 147},
-  {"enarmoring failed: %s\n", 148},
-  {"invalid hash algorithm '%s'\n", 149},
-  {"[filename]", 150},
-  {"can't open '%s'\n", 151},
+Supported algorithms:\n", 121},
+  {"usage: gpgm [options] ", 122},
+  {"usage: gpg [options] ", 123},
+  {"conflicting commands\n", 124},
+  {"note: no default option file '%s'\n", 125},
+  {"option file '%s': %s\n", 126},
+  {"reading options from '%s'\n", 127},
+  {"selected cipher algorithm is invalid\n", 128},
+  {"selected digest algorithm is invalid\n", 129},
+  {"compress algorithm must be in range %d..%d\n", 130},
+  {"completes-needed must be greater than 0\n", 131},
+  {"marginals-needed must be greater than 1\n", 132},
+  {"note: simple S2K mode (0) is strongly discouraged\n", 133},
+  {"invalid S2K mode; must be 0, 1 or 3\n", 134},
+  {"failed to initialize the TrustDB: %s\n", 135},
+  {"--store [filename]", 136},
+  {"--symmetric [filename]", 137},
+  {"--encrypt [filename]", 138},
+  {"--sign [filename]", 139},
+  {"--sign --encrypt [filename]", 140},
+  {"--clearsign [filename]", 141},
+  {"--decrypt [filename]", 142},
+  {"--edit-key username", 143},
+  {"--delete-secret-key username", 144},
+  {"--delete-key username", 145},
+  {"can't open %s: %s\n", 146},
+  {"-k[v][v][v][c] [userid] [keyring]", 147},
+  {"dearmoring failed: %s\n", 148},
+  {"enarmoring failed: %s\n", 149},
+  {"invalid hash algorithm '%s'\n", 150},
+  {"[filename]", 151},
+  {"can't open '%s'\n", 152},
   {"\
 RSA keys are deprecated; please consider creating a new key and use this key \
-in the future\n", 152},
-  {"armor header: ", 153},
-  {"invalid clearsig header\n", 154},
-  {"invalid armor header: ", 155},
-  {"armor: %s\n", 156},
-  {"invalid dash escaped line: ", 157},
-  {"invalid clear text header: ", 158},
-  {"invalid radix64 character %02x skipped\n", 159},
-  {"premature eof (no CRC)\n", 160},
-  {"premature eof (in CRC)\n", 161},
-  {"malformed CRC\n", 162},
-  {"CRC error; %06lx - %06lx\n", 163},
-  {"premature eof (in Trailer)\n", 164},
-  {"error in trailer line\n", 165},
-  {"no valid RFC1991 or OpenPGP data found.\n", 166},
+in the future\n", 153},
+  {"armor header: ", 154},
+  {"invalid clearsig header\n", 155},
+  {"invalid armor header: ", 156},
+  {"armor: %s\n", 157},
+  {"invalid dash escaped line: ", 158},
+  {"invalid clear text header: ", 159},
+  {"invalid radix64 character %02x skipped\n", 160},
+  {"premature eof (no CRC)\n", 161},
+  {"premature eof (in CRC)\n", 162},
+  {"malformed CRC\n", 163},
+  {"CRC error; %06lx - %06lx\n", 164},
+  {"premature eof (in Trailer)\n", 165},
+  {"error in trailer line\n", 166},
+  {"no valid RFC1991 or OpenPGP data found.\n", 167},
   {"\
 No owner trust defined for %lu:\n\
-%4u%c/%08lX %s \"", 167},
+%4u%c/%08lX %s \"", 168},
   {"\
 Please decide how far you trust this user to correctly\n\
 verify other users' keys (by looking at passports,\n\
@@ -215,371 +216,397 @@
  2 = I do NOT trust\n\
  3 = I trust marginally\n\
  4 = I trust fully\n\
- s = please show me more information\n", 168},
-  {" m = back to the main menu\n", 169},
-  {"sSmM", 170},
-  {"edit_ownertrust.value", 171},
-  {"Your decision? ", 172},
-  {"You will see a list of signators etc. here\n", 173},
+ s = please show me more information\n", 169},
+  {" m = back to the main menu\n", 170},
+  {"sSmM", 171},
+  {"edit_ownertrust.value", 172},
+  {"Your decision? ", 173},
+  {"You will see a list of signators etc. here\n", 174},
   {"\
 Could not find a valid trust path to the key.  Let's see whether we\n\
 can assign some missing owner trust values.\n\
-\n", 174},
+\n", 175},
   {"\
 No owner trust values changed.\n\
-\n", 175},
-  {"revoked_key.override", 176},
-  {"Use this key anyway? ", 177},
+\n", 176},
+  {"revoked_key.override", 177},
+  {"Use this key anyway? ", 178},
   {"\
 It is NOT certain that the key belongs to its owner.\n\
 If you *really* know what you are doing, you may answer\n\
 the next question with yes\n\
-\n", 178},
-  {"untrusted_key.override", 179},
-  {"WARNING: Using untrusted key!\n", 180},
-  {"WARNING: This key has been revoked by its owner!\n", 181},
-  {"         This could mean that the signature is forgery.\n", 182},
-  {"Note: This key has expired!\n", 183},
-  {"WARNING: This key is not certified with a trusted signature!\n", 184},
-  {"\
-         There is no indication that the signature belongs to the owner.\n", 185},
-  {"WARNING: We do NOT trust this key!\n", 186},
-  {"         The signature is probably a FORGERY.\n", 187},
+\n", 179},
+  {"untrusted_key.override", 180},
+  {"WARNING: Using untrusted key!\n", 181},
+  {"WARNING: This key has been revoked by its owner!\n", 182},
+  {"         This could mean that the signature is forgery.\n", 183},
+  {"Note: This key has expired!\n", 184},
+  {"WARNING: This key is not certified with a trusted signature!\n", 185},
+  {"\
+         There is no indication that the signature belongs to the owner.\n", 186},
+  {"WARNING: We do NOT trust this key!\n", 187},
+  {"         The signature is probably a FORGERY.\n", 188},
   {"\
-WARNING: This key is not certified with sufficiently trusted signatures!\n", 188},
-  {"         It is not certain that the signature belongs to the owner.\n", 189},
+WARNING: This key is not certified with sufficiently trusted signatures!\n", 189},
+  {"         It is not certain that the signature belongs to the owner.\n", 190},
   {"\
 You did not specify a user ID. (you may use \"-r\")\n\
-\n", 190},
-  {"pklist.user_id.enter", 191},
-  {"Enter the user ID: ", 192},
-  {"No such user ID.\n", 193},
-  {"%s: skipped: %s\n", 194},
-  {"%s: error checking key: %s\n", 195},
-  {"no valid addressees\n", 196},
-  {"writing self signature\n", 197},
-  {"writing key binding signature\n", 198},
-  {"Please select what kind of key you want:\n", 199},
-  {"   (%d) DSA and ElGamal (default)\n", 200},
-  {"   (%d) ElGamal (sign and encrypt)\n", 201},
-  {"   (%d) ElGamal (encrypt only)\n", 202},
-  {"   (%d) DSA (sign only)\n", 203},
-  {"   (%d) ElGamal in a v3 packet\n", 204},
-  {"keygen.algo", 205},
-  {"Your selection? ", 206},
-  {"Invalid selection.\n", 207},
+\n", 191},
+  {"pklist.user_id.enter", 192},
+  {"Enter the user ID: ", 193},
+  {"No such user ID.\n", 194},
+  {"%s: skipped: %s\n", 195},
+  {"%s: error checking key: %s\n", 196},
+  {"no valid addressees\n", 197},
+  {"writing self signature\n", 198},
+  {"writing key binding signature\n", 199},
+  {"Please select what kind of key you want:\n", 200},
+  {"   (%d) DSA and ElGamal (default)\n", 201},
+  {"   (%d) ElGamal (sign and encrypt)\n", 202},
+  {"   (%d) ElGamal (encrypt only)\n", 203},
+  {"   (%d) DSA (sign only)\n", 204},
+  {"   (%d) ElGamal in a v3 packet\n", 205},
+  {"keygen.algo", 206},
+  {"Your selection? ", 207},
+  {"Invalid selection.\n", 208},
   {"\
 About to generate a new %s keypair.\n\
               minimum keysize is  768 bits\n\
               default keysize is 1024 bits\n\
-    highest suggested keysize is 2048 bits\n", 208},
-  {"keygen.size", 209},
-  {"What keysize do you want? (1024) ", 210},
-  {"DSA only allows keysizes from 512 to 1024\n", 211},
-  {"keysize too small; 768 is smallest value allowed.\n", 212},
+    highest suggested keysize is 2048 bits\n", 209},
+  {"keygen.size", 210},
+  {"What keysize do you want? (1024) ", 211},
+  {"DSA only allows keysizes from 512 to 1024\n", 212},
+  {"keysize too small; 768 is smallest value allowed.\n", 213},
   {"\
 Keysizes larger than 2048 are not suggested because\n\
-computations take REALLY long!\n", 213},
-  {"keygen.size.huge.okay", 214},
-  {"Are you sure that you want this keysize? ", 215},
+computations take REALLY long!\n", 214},
+  {"keygen.size.huge.okay", 215},
+  {"Are you sure that you want this keysize? ", 216},
   {"\
 Okay, but keep in mind that your monitor and keyboard radiation is also very \
-vulnerable to attacks!\n", 216},
-  {"keygen.size.large.okay", 217},
-  {"Do you really need such a large keysize? ", 218},
-  {"Requested keysize is %u bits\n", 219},
-  {"rounded up to %u bits\n", 220},
+vulnerable to attacks!\n", 217},
+  {"keygen.size.large.okay", 218},
+  {"Do you really need such a large keysize? ", 219},
+  {"Requested keysize is %u bits\n", 220},
+  {"rounded up to %u bits\n", 221},
   {"\
 Please specify how long the key should be valid.\n\
          0 = key does not expire\n\
       <n>  = key expires in n days\n\
       <n>w = key expires in n weeks\n\
       <n>m = key expires in n months\n\
-      <n>y = key expires in n years\n", 221},
-  {"keygen.valid", 222},
-  {"Key is valid for? (0) ", 223},
-  {"invalid value\n", 224},
-  {"Key does not expire at all\n", 225},
-  {"Key expires at %s\n", 226},
-  {"keygen.valid.okay", 227},
-  {"Is this correct (y/n)? ", 228},
+      <n>y = key expires in n years\n", 222},
+  {"keygen.valid", 223},
+  {"Key is valid for? (0) ", 224},
+  {"invalid value\n", 225},
+  {"Key does not expire at all\n", 226},
+  {"Key expires at %s\n", 227},
+  {"keygen.valid.okay", 228},
+  {"Is this correct (y/n)? ", 229},
   {"\
 \n\
 You need a User-ID to identify your key; the software constructs the user \
 id\n\
 from Real Name, Comment and Email Address in this form:\n\
     \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n\
-\n", 229},
-  {"keygen.name", 230},
-  {"Real name: ", 231},
-  {"Invalid character in name\n", 232},
-  {"Name may not start with a digit\n", 233},
-  {"Name must be at least 5 characters long\n", 234},
-  {"keygen.email", 235},
-  {"Email address: ", 236},
-  {"Not a valid email address\n", 237},
-  {"keygen.comment", 238},
-  {"Comment: ", 239},
-  {"Invalid character in comment\n", 240},
+\n", 230},
+  {"keygen.name", 231},
+  {"Real name: ", 232},
+  {"Invalid character in name\n", 233},
+  {"Name may not start with a digit\n", 234},
+  {"Name must be at least 5 characters long\n", 235},
+  {"keygen.email", 236},
+  {"Email address: ", 237},
+  {"Not a valid email address\n", 238},
+  {"keygen.comment", 239},
+  {"Comment: ", 240},
+  {"Invalid character in comment\n", 241},
   {"\
 You selected this USER-ID:\n\
     \"%s\"\n\
-\n", 241},
-  {"NnCcEeOoQq", 242},
-  {"keygen.userid.cmd", 243},
-  {"Change (N)ame, (C)omment, (E)mail or (O)kay/(Q)uit? ", 244},
+\n", 242},
+  {"NnCcEeOoQq", 243},
+  {"keygen.userid.cmd", 244},
+  {"Change (N)ame, (C)omment, (E)mail or (O)kay/(Q)uit? ", 245},
   {"\
 You need a Passphrase to protect your secret key.\n\
-\n", 245},
-  {"passphrase not correctly repeated; try again.\n", 246},
+\n", 246},
+  {"passphrase not correctly repeated; try again.\n", 247},
   {"\
 You don't want a passphrase - this is probably a *bad* idea!\n\
 I will do it anyway.  You can change your passphrase at any time,\n\
 using this program with the option \"--edit-key\".\n\
-\n", 247},
+\n", 248},
   {"\
 We need to generate a lot of random bytes. It is a good idea to perform\n\
 some other action (work in another window, move the mouse, utilize the\n\
 network and the disks) during the prime generation; this gives the random\n\
-number generator a better chance to gain enough entropy.\n", 248},
-  {"Key generation can only be used in interactive mode\n", 249},
-  {"DSA keypair will have 1024 bits.\n", 250},
-  {"Key generation cancelled.\n", 251},
-  {"writing public certificate to '%s'\n", 252},
-  {"writing secret certificate to '%s'\n", 253},
-  {"public and secret key created and signed.\n", 254},
+number generator a better chance to gain enough entropy.\n", 249},
+  {"Key generation can only be used in interactive mode\n", 250},
+  {"DSA keypair will have 1024 bits.\n", 251},
+  {"Key generation cancelled.\n", 252},
+  {"writing public certificate to '%s'\n", 253},
+  {"writing secret certificate to '%s'\n", 254},
+  {"public and secret key created and signed.\n", 255},
   {"\
 Note that this key cannot be used for encryption.  You may want to use\n\
-the command \"--add-key\" to generate a secondary key for this purpose.\n", 255},
-  {"Key generation failed: %s\n", 256},
-  {"keygen.sub.okay", 257},
-  {"Really create? ", 258},
-  {"%s: can't open: %s\n", 259},
-  {"error creating passphrase: %s\n", 260},
-  {"%s: warning: empty file\n", 261},
-  {"reading from '%s'\n", 262},
-  {"%s encrypted for: %s\n", 263},
-  {"using secondary key %08lX instead of primary key %08lX\n", 264},
-  {"can't open file: %s\n", 265},
-  {"skipping block of type %d\n", 266},
-  {"read error: %s\n", 267},
-  {"key %08lX: no user id\n", 268},
-  {"key %08lX: no valid user ids\n", 269},
-  {"this may be caused by a missing self-signature\n", 270},
-  {"key %08lX: public key not found: %s\n", 271},
-  {"no default public keyring\n", 272},
-  {"writing to '%s'\n", 273},
-  {"can't lock public keyring: %s\n", 274},
-  {"can't write to keyring: %s\n", 275},
-  {"key %08lX: public key imported\n", 276},
-  {"key %08lX: doesn't match our copy\n", 277},
-  {"key %08lX: can't locate original keyblock: %s\n", 278},
-  {"key %08lX: can't read original keyblock: %s\n", 279},
-  {"writing keyblock\n", 280},
-  {"can't write keyblock: %s\n", 281},
-  {"key %08lX: 1 new user-id\n", 282},
-  {"key %08lX: %d new user-ids\n", 283},
-  {"key %08lX: 1 new signature\n", 284},
-  {"key %08lX: %d new signatures\n", 285},
-  {"key %08lX: 1 new subkey\n", 286},
-  {"key %08lX: %d new subkeys\n", 287},
-  {"key %08lX: not changed\n", 288},
-  {"can't lock secret keyring: %s\n", 289},
-  {"can't write keyring: %s\n", 290},
-  {"key %08lX: secret key imported\n", 291},
-  {"key %08lX: already in secret keyring\n", 292},
-  {"key %08lX: secret key not found: %s\n", 293},
-  {"key %08lX: no public key - can't apply revocation certificate\n", 294},
-  {"key %08lX: invalid revocation certificate: %s - rejected\n", 295},
-  {"key %08lX: revocation certificate imported\n", 296},
-  {"key %08lX: no user-id for signature\n", 297},
-  {"key %08lX: unsupported public key algorithm\n", 298},
-  {"key %08lX: invalid self-signature\n", 299},
-  {"key %08lX: skipped userid '", 300},
-  {"key %08lX: revocation certificate at wrong place - skipped\n", 301},
-  {"key %08lX: invalid revocation certificate: %s - skipped\n", 302},
-  {"key %08lX: revocation certificate added\n", 303},
-  {"key %08lX: our copy has no self-signature\n", 304},
-  {"%s: user not found\n", 305},
-  {"[self-signature]", 306},
-  {"1 bad signature\n", 307},
-  {"%d bad signatures\n", 308},
-  {"1 signature not checked due to a missing key\n", 309},
-  {"%d signatures not checked due to missing keys\n", 310},
-  {"1 signature not checked due to an error\n", 311},
-  {"%d signatures not checked due to errors\n", 312},
-  {"1 user id without valid self-signature detected\n", 313},
-  {"%d user ids without valid self-signatures detected\n", 314},
-  {"Already signed by key %08lX\n", 315},
-  {"Nothing to sign with key %08lX\n", 316},
+the command \"--add-key\" to generate a secondary key for this purpose.\n", 256},
+  {"Key generation failed: %s\n", 257},
+  {"keygen.sub.okay", 258},
+  {"Really create? ", 259},
+  {"%s: can't open: %s\n", 260},
+  {"error creating passphrase: %s\n", 261},
+  {"%s: warning: empty file\n", 262},
+  {"reading from '%s'\n", 263},
+  {"%s encrypted for: %s\n", 264},
+  {"using secondary key %08lX instead of primary key %08lX\n", 265},
+  {"can't open file: %s\n", 266},
+  {"skipping block of type %d\n", 267},
+  {"%lu keys so far processed\n", 268},
+  {"read error: %s\n", 269},
+  {"Total number processed: %lu\n", 270},
+  {"          w/o user IDs: %lu\n", 271},
+  {"              imported: %lu", 272},
+  {"             unchanged: %lu\n", 273},
+  {"          new user IDs: %lu\n", 274},
+  {"           new subkeys: %lu\n", 275},
+  {"        new signatures: %lu\n", 276},
+  {"   new key revocations: %lu\n", 277},
+  {"      secret keys read: %lu\n", 278},
+  {"  secret keys imported: %lu\n", 279},
+  {" secret keys unchanged: %lu\n", 280},
+  {"key %08lX: no user id\n", 281},
+  {"key %08lX: no valid user ids\n", 282},
+  {"this may be caused by a missing self-signature\n", 283},
+  {"key %08lX: public key not found: %s\n", 284},
+  {"no default public keyring\n", 285},
+  {"writing to '%s'\n", 286},
+  {"can't lock public keyring: %s\n", 287},
+  {"can't write to keyring: %s\n", 288},
+  {"key %08lX: public key imported\n", 289},
+  {"key %08lX: doesn't match our copy\n", 290},
+  {"key %08lX: can't locate original keyblock: %s\n", 291},
+  {"key %08lX: can't read original keyblock: %s\n", 292},
+  {"writing keyblock\n", 293},
+  {"can't write keyblock: %s\n", 294},
+  {"key %08lX: 1 new user-id\n", 295},
+  {"key %08lX: %d new user-ids\n", 296},
+  {"key %08lX: 1 new signature\n", 297},
+  {"key %08lX: %d new signatures\n", 298},
+  {"key %08lX: 1 new subkey\n", 299},
+  {"key %08lX: %d new subkeys\n", 300},
+  {"key %08lX: not changed\n", 301},
+  {"can't lock secret keyring: %s\n", 302},
+  {"can't write keyring: %s\n", 303},
+  {"key %08lX: secret key imported\n", 304},
+  {"key %08lX: already in secret keyring\n", 305},
+  {"key %08lX: secret key not found: %s\n", 306},
+  {"key %08lX: no public key - can't apply revocation certificate\n", 307},
+  {"key %08lX: invalid revocation certificate: %s - rejected\n", 308},
+  {"key %08lX: revocation certificate imported\n", 309},
+  {"key %08lX: no user-id for signature\n", 310},
+  {"key %08lX: unsupported public key algorithm\n", 311},
+  {"key %08lX: invalid self-signature\n", 312},
+  {"key %08lX: skipped userid '", 313},
+  {"key %08lX: revocation certificate at wrong place - skipped\n", 314},
+  {"key %08lX: invalid revocation certificate: %s - skipped\n", 315},
+  {"key %08lX: revocation certificate added\n", 316},
+  {"key %08lX: our copy has no self-signature\n", 317},
+  {"%s: user not found\n", 318},
+  {"[self-signature]", 319},
+  {"1 bad signature\n", 320},
+  {"%d bad signatures\n", 321},
+  {"1 signature not checked due to a missing key\n", 322},
+  {"%d signatures not checked due to missing keys\n", 323},
+  {"1 signature not checked due to an error\n", 324},
+  {"%d signatures not checked due to errors\n", 325},
+  {"1 user id without valid self-signature detected\n", 326},
+  {"%d user ids without valid self-signatures detected\n", 327},
+  {"Already signed by key %08lX\n", 328},
+  {"Nothing to sign with key %08lX\n", 329},
   {"\
 Are you really sure that you want to sign this key\n\
-with your key: \"", 317},
-  {"sign_uid.okay", 318},
-  {"Really sign? ", 319},
-  {"signing failed: %s\n", 320},
-  {"This key is not protected.\n", 321},
-  {"Key is protected.\n", 322},
-  {"Can't edit this key: %s\n", 323},
+with your key: \"", 330},
+  {"sign_uid.okay", 331},
+  {"Really sign? ", 332},
+  {"signing failed: %s\n", 333},
+  {"This key is not protected.\n", 334},
+  {"Key is protected.\n", 335},
+  {"Can't edit this key: %s\n", 336},
   {"\
 Enter the new passphrase for this secret key.\n\
-\n", 324},
+\n", 337},
   {"\
 You don't want a passphrase - this is probably a *bad* idea!\n\
-\n", 325},
-  {"change_passwd.empty.okay", 326},
-  {"Do you really want to do this? ", 327},
-  {"quit", 328},
-  {"quit this menu", 329},
-  {"q", 330},
-  {"save", 331},
-  {"save and quit", 332},
-  {"help", 333},
-  {"show this help", 334},
-  {"fpr", 335},
-  {"show fingerprint", 336},
-  {"list", 337},
-  {"list key and user ids", 338},
-  {"l", 339},
-  {"uid", 340},
-  {"select user id N", 341},
-  {"key", 342},
-  {"select secondary key N", 343},
-  {"check", 344},
-  {"list signatures", 345},
-  {"c", 346},
-  {"sign", 347},
-  {"sign the key", 348},
-  {"s", 349},
-  {"debug", 350},
-  {"adduid", 351},
-  {"add a user id", 352},
-  {"deluid", 353},
-  {"delete user id", 354},
-  {"addkey", 355},
-  {"add a secondary key", 356},
-  {"delkey", 357},
-  {"delete a secondary key", 358},
-  {"expire", 359},
-  {"change the expire date", 360},
-  {"toggle", 361},
-  {"toggle between secret and public key listing", 362},
-  {"t", 363},
-  {"pref", 364},
-  {"list preferences", 365},
-  {"passwd", 366},
-  {"change the passphrase", 367},
-  {"trust", 368},
-  {"change the ownertrust", 369},
-  {"can't do that in batchmode\n", 370},
-  {"Secret key is available.\n", 371},
-  {"keyedit.cmd", 372},
-  {"Command> ", 373},
-  {"Need the secret key to to this.\n", 374},
-  {"keyedit.save.okay", 375},
-  {"Save changes? ", 376},
-  {"keyedit.cancel.okay", 377},
-  {"Quit without saving? ", 378},
-  {"update failed: %s\n", 379},
-  {"update secret failed: %s\n", 380},
-  {"Key not changed so no update needed.\n", 381},
-  {"update of trust db failed: %s\n", 382},
-  {"keyedit.sign_all.okay", 383},
-  {"Really sign all user ids? ", 384},
-  {"Hint: Select the user ids to sign\n", 385},
-  {"You must select at least one user id.\n", 386},
-  {"You can't delete the last user id!\n", 387},
-  {"keyedit.remove.uid.okay", 388},
-  {"Really remove all selected user ids? ", 389},
-  {"Really remove this user id? ", 390},
-  {"You must select at least one key.\n", 391},
-  {"keyedit.remove.subkey.okay", 392},
-  {"Do you really want to delete the selected keys? ", 393},
-  {"Do you really want to delete this key? ", 394},
-  {"Invalid command  (try \"help\")\n", 395},
-  {"Please remove selections from the secret keys.\n", 396},
-  {"Please select at most one secondary key.\n", 397},
-  {"Changing exiration time for a secondary key.\n", 398},
-  {"Changing exiration time for the primary key.\n", 399},
-  {"No corresponding signature in secret ring\n", 400},
-  {"No user id with index %d\n", 401},
-  {"No secondary key with index %d\n", 402},
-  {"public key decryption failed: %s\n", 403},
-  {"decryption failed: %s\n", 404},
-  {"note: sender requested \"for-your-eyes-only\"\n", 405},
-  {"Signature made %.*s using %s key ID %08lX\n", 406},
-  {"BAD signature from \"", 407},
-  {"Good signature from \"", 408},
-  {"Can't check signature: %s\n", 409},
+\n", 338},
+  {"change_passwd.empty.okay", 339},
+  {"Do you really want to do this? ", 340},
+  {"quit", 341},
+  {"quit this menu", 342},
+  {"q", 343},
+  {"save", 344},
+  {"save and quit", 345},
+  {"help", 346},
+  {"show this help", 347},
+  {"fpr", 348},
+  {"show fingerprint", 349},
+  {"list", 350},
+  {"list key and user ids", 351},
+  {"l", 352},
+  {"uid", 353},
+  {"select user id N", 354},
+  {"key", 355},
+  {"select secondary key N", 356},
+  {"check", 357},
+  {"list signatures", 358},
+  {"c", 359},
+  {"sign", 360},
+  {"sign the key", 361},
+  {"s", 362},
+  {"debug", 363},
+  {"adduid", 364},
+  {"add a user id", 365},
+  {"deluid", 366},
+  {"delete user id", 367},
+  {"addkey", 368},
+  {"add a secondary key", 369},
+  {"delkey", 370},
+  {"delete a secondary key", 371},
+  {"expire", 372},
+  {"change the expire date", 373},
+  {"toggle", 374},
+  {"toggle between secret and public key listing", 375},
+  {"t", 376},
+  {"pref", 377},
+  {"list preferences", 378},
+  {"passwd", 379},
+  {"change the passphrase", 380},
+  {"trust", 381},
+  {"change the ownertrust", 382},
+  {"can't do that in batchmode\n", 383},
+  {"Secret key is available.\n", 384},
+  {"keyedit.cmd", 385},
+  {"Command> ", 386},
+  {"Need the secret key to to this.\n", 387},
+  {"keyedit.save.okay", 388},
+  {"Save changes? ", 389},
+  {"keyedit.cancel.okay", 390},
+  {"Quit without saving? ", 391},
+  {"update failed: %s\n", 392},
+  {"update secret failed: %s\n", 393},
+  {"Key not changed so no update needed.\n", 394},
+  {"update of trust db failed: %s\n", 395},
+  {"keyedit.sign_all.okay", 396},
+  {"Really sign all user ids? ", 397},
+  {"Hint: Select the user ids to sign\n", 398},
+  {"You must select at least one user id.\n", 399},
+  {"You can't delete the last user id!\n", 400},
+  {"keyedit.remove.uid.okay", 401},
+  {"Really remove all selected user ids? ", 402},
+  {"Really remove this user id? ", 403},
+  {"You must select at least one key.\n", 404},
+  {"keyedit.remove.subkey.okay", 405},
+  {"Do you really want to delete the selected keys? ", 406},
+  {"Do you really want to delete this key? ", 407},
+  {"Invalid command  (try \"help\")\n", 408},
+  {"Please remove selections from the secret keys.\n", 409},
+  {"Please select at most one secondary key.\n", 410},
+  {"Changing exiration time for a secondary key.\n", 411},
+  {"Changing exiration time for the primary key.\n", 412},
+  {"No corresponding signature in secret ring\n", 413},
+  {"No user id with index %d\n", 414},
+  {"No secondary key with index %d\n", 415},
+  {"public key decryption failed: %s\n", 416},
+  {"decryption failed: %s\n", 417},
+  {"note: sender requested \"for-your-eyes-only\"\n", 418},
+  {"Signature made %.*s using %s key ID %08lX\n", 419},
+  {"BAD signature from \"", 420},
+  {"Good signature from \"", 421},
+  {"Can't check signature: %s\n", 422},
   {"\
 \n\
 You need a passphrase to unlock the secret key for\n\
-user: \"", 410},
-  {"(%u-bit %s key, ID %08lX, created %s)\n", 411},
-  {"passphrase.enter", 412},
-  {"Enter pass phrase: ", 413},
-  {"passphrase.repeat", 414},
-  {"Repeat pass phrase: ", 415},
-  {"data not saved; use option \"--output\" to save it\n", 416},
-  {"detached_signature.filename", 417},
-  {"Please enter name of data file: ", 418},
-  {"can't open signed data '%s'\n", 419},
-  {"protection algorithm %d is not supported\n", 420},
-  {"Invalid passphrase; please try again ...\n", 421},
-  {"Warning: Weak key detected - please change passphrase again.\n", 422},
-  {"\
-this is a PGP generated ElGamal key which is NOT secure for signatures!\n", 423},
-  {"public key created in future (time warp or clock problem)\n", 424},
-  {"warning: signature key expired %s\n", 425},
-  {"The trust DB is corrupted; please run \"gpgm --fix-trust-db\".\n", 426},
-  {"chained sigrec %lu has a wrong owner\n", 427},
-  {"key %08lX: secret key without public key - skipped\n", 428},
-  {"key %08lX: secret and public key don't match\n", 429},
-  {"key %08lX: can't put it into the trustdb\n", 430},
-  {"key %08lX: query record failed\n", 431},
-  {"key %08lX: already in secret key table\n", 432},
-  {"key %08lX: accepted as secret key.\n", 433},
-  {"enum_secret_keys failed: %s\n", 434},
-  {"key %08lX: insert trust record failed: %s\n", 435},
-  {"key %08lX.%lu: inserted into trustdb\n", 436},
-  {"key %08lX.%lu: created in future (time warp or clock problem)\n", 437},
-  {"key %08lX.%lu: expired at %s\n", 438},
-  {"key %08lX.%lu: trust check failed: %s\n", 439},
-  {"note: sig rec %lu[%d] in hintlist of %lu but marked as checked\n", 440},
-  {"note: sig rec %lu[%d] in hintlist of %lu but not marked\n", 441},
-  {"sig rec %lu[%d] in hintlist of %u does not point to a dir record\n", 442},
-  {"lid %lu: no primary key\n", 443},
-  {"lid %lu: user id not found in keyblock\n", 444},
-  {"lid %lu: self-signature in hintlist\n", 445},
-  {"key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (3)\n", 446},
-  {"key %08lX.%lu, uid %02X%02X, sig %08lX: very strange: no public key\n", 447},
-  {"key %08lX.%lu, uid %02X%02X, sig %08lX: invalid signature: %s\n", 448},
-  {"hintlist %lu[%d] of %lu does not point to a dir record\n", 449},
-  {"lid %lu does not have a key\n", 450},
-  {"lid %lu: can't get keyblock: %s\n", 451},
-  {"key %08lX.%lu, uid %02X%02X: good self-signature\n", 452},
-  {"\
-key %08lX.%lu, uid %02X%02X, sig %08lX: duplicated signature - deleted\n", 453},
-  {"key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (1)\n", 454},
-  {"key %08lX.%lu, uid %02X%02X, sig %08lX: weird: no public key\n", 455},
-  {"key %08lX.%lu, uid %02X%02X: has shadow dir %lu but not yet marked.\n", 456},
-  {"key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (2)\n", 457},
-  {"key %08lX.%lu, uid %02X%02X, sig %08lX: no public key\n", 458},
-  {"key %08lX: bogus key binding by %08lX\n", 459},
-  {"key %08lX: bogus key revocation by %08lX\n", 460},
-  {"key %08lX: bogus subkey revocation by %08lX\n", 461},
-  {"No help available", 462},
-  {"No help available for '%s'", 463},
-  {"anonymous receiver; trying secret key %08lX ...\n", 464},
-  {"okay, we are the anonymous receiver.\n", 465},
-  {"note: cipher algorithm %d not found in preferences\n", 466},
-  {"File '%s' exists. ", 467},
-  {"openfile.overwrite.okay", 468},
-  {"Overwrite (y/N)? ", 469},
-  {"\
-Warning: Message was encrypted with a weak key in the symmetric cipher.\n", 470},
-  {"weak key created - retrying\n", 471},
-  {"cannot avoid weak key for symmetric cipher; tried %d times!\n", 472},
+user: \"", 423},
+  {"(%u-bit %s key, ID %08lX, created %s)\n", 424},
+  {"passphrase.enter", 425},
+  {"Enter pass phrase: ", 426},
+  {"passphrase.repeat", 427},
+  {"Repeat pass phrase: ", 428},
+  {"data not saved; use option \"--output\" to save it\n", 429},
+  {"detached_signature.filename", 430},
+  {"Please enter name of data file: ", 431},
+  {"can't open signed data '%s'\n", 432},
+  {"protection algorithm %d is not supported\n", 433},
+  {"Invalid passphrase; please try again ...\n", 434},
+  {"Warning: Weak key detected - please change passphrase again.\n", 435},
+  {"\
+this is a PGP generated ElGamal key which is NOT secure for signatures!\n", 436},
+  {"public key created in future (time warp or clock problem)\n", 437},
+  {"warning: signature key expired %s\n", 438},
+  {"The trust DB is corrupted; please run \"gpgm --fix-trust-db\".\n", 439},
+  {"chained sigrec %lu has a wrong owner\n", 440},
+  {"key %08lX: secret key without public key - skipped\n", 441},
+  {"key %08lX: secret and public key don't match\n", 442},
+  {"key %08lX: can't put it into the trustdb\n", 443},
+  {"key %08lX: query record failed\n", 444},
+  {"key %08lX: already in secret key table\n", 445},
+  {"key %08lX: accepted as secret key.\n", 446},
+  {"enum_secret_keys failed: %s\n", 447},
+  {"%lu keys processed\n", 448},
+  {"\t%lu keys skipped\n", 449},
+  {"\t%lu keys with errors\n", 450},
+  {"\t%lu keys updated\n", 451},
+  {"\t%lu keys inserted\n", 452},
+  {"key %08lX: insert trust record failed: %s\n", 453},
+  {"key %08lX.%lu: inserted into trustdb\n", 454},
+  {"key %08lX.%lu: created in future (time warp or clock problem)\n", 455},
+  {"key %08lX.%lu: expired at %s\n", 456},
+  {"key %08lX.%lu: trust check failed: %s\n", 457},
+  {"note: sig rec %lu[%d] in hintlist of %lu but marked as checked\n", 458},
+  {"note: sig rec %lu[%d] in hintlist of %lu but not marked\n", 459},
+  {"sig rec %lu[%d] in hintlist of %lu does not point to a dir record\n", 460},
+  {"lid %lu: no primary key\n", 461},
+  {"lid %lu: user id not found in keyblock\n", 462},
+  {"lid %lu: user id without signature\n", 463},
+  {"lid %lu: self-signature in hintlist\n", 464},
+  {"Valid certificate revocation", 465},
+  {"Good certificate", 466},
+  {"very strange: no public key\n", 467},
+  {"hintlist %lu[%d] of %lu does not point to a dir record\n", 468},
+  {"lid %lu does not have a key\n", 469},
+  {"lid %lu: can't get keyblock: %s\n", 470},
+  {"key %08lX.%lu: Good subkey binding\n", 471},
+  {"key %08lX.%lu: Invalid subkey binding: %s\n", 472},
+  {"key %08lX.%lu: Valid key revocation\n", 473},
+  {"key %08lX.%lu: Invalid key revocation: %s\n", 474},
+  {"key %08lX.%lu: Valid subkey revocation\n", 475},
+  {"Good self-signature", 476},
+  {"Invalid self-signature", 477},
+  {"Valid user ID revocation\n", 478},
+  {"Invalid user ID revocation", 479},
+  {"Too many preferences", 480},
+  {"Too many preferences items", 481},
+  {"Duplicated certificate - deleted", 482},
+  {"public key lost", 483},
+  {"Invalid certificate revocation", 484},
+  {"Invalid certificate", 485},
+  {"No help available", 486},
+  {"No help available for '%s'", 487},
+  {"anonymous receiver; trying secret key %08lX ...\n", 488},
+  {"okay, we are the anonymous receiver.\n", 489},
+  {"note: cipher algorithm %d not found in preferences\n", 490},
+  {"File '%s' exists. ", 491},
+  {"openfile.overwrite.okay", 492},
+  {"Overwrite (y/N)? ", 493},
+  {"writing to stdout\n", 494},
+  {"%s: can't create: %s\n", 495},
+  {"assuming signed data in '%s'\n", 496},
+  {"%s: new options file created\n", 497},
+  {"\
+Warning: Message was encrypted with a weak key in the symmetric cipher.\n", 498},
+  {"weak key created - retrying\n", 499},
+  {"cannot avoid weak key for symmetric cipher; tried %d times!\n", 500},
 };
 
-int _msg_tbl_length = 472;
+int _msg_tbl_length = 500;
diff -urN gnupg-0.4.2/po/de.po gnupg-0.4.3/po/de.po
--- gnupg-0.4.2/po/de.po	Sun Oct 18 17:07:45 1998
+++ gnupg-0.4.3/po/de.po	Sun Nov  8 18:23:00 1998
@@ -1,6 +1,6 @@
 msgid ""
 msgstr ""
-"POT-Creation-Date: 1998-10-18 16:36+0200\n"
+"POT-Creation-Date: 1998-11-08 18:21+0100\n"
 "PO-Revision-Date: 1998-10-11 20:10+0200\n"
 "Last-Translator: Walter Koch <walterk@mail.dip.de>\n"
 "Language-Team: German <de@li.org>\n"
@@ -204,8 +204,8 @@
 msgstr "Schwacher Schlssel"
 
 #: util/logger.c:177
-#, c-format
-msgid "Ohhhh jeeee ... this is a bug (%s:%d:%s)\n"
+#, fuzzy, c-format
+msgid "... this is a bug (%s:%d:%s)\n"
 msgstr "Ohhh jeeee ... dies ist eine Wanze (Programmfehler) (%s:%d:%s)\n"
 
 #: util/logger.c:183
@@ -243,7 +243,7 @@
 "Arbeiten durch, damit das Betriebssystem weitere Entropie sammeln kann!\n"
 "(Es werden noch %d Byte bentigt.)\n"
 
-#: g10/g10.c:149
+#: g10/g10.c:152
 msgid ""
 "@Commands:\n"
 " "
@@ -251,128 +251,128 @@
 "@Kommandos:\n"
 " "
 
-#: g10/g10.c:152
+#: g10/g10.c:155
 #, fuzzy
 msgid "|[file]|make a signature"
 msgstr "|[FILE]|eine Signatur erzeugen"
 
-#: g10/g10.c:153
+#: g10/g10.c:156
 #, fuzzy
 msgid "|[file]|make a clear text signature"
 msgstr "|[FILE]|eine Klartextsignatur erzeugen"
 
-#: g10/g10.c:154
+#: g10/g10.c:157
 msgid "make a detached signature"
 msgstr "Eine abgetrennte Signatur erzeugen"
 
-#: g10/g10.c:155
+#: g10/g10.c:158
 msgid "encrypt data"
 msgstr "Daten verschlsseln"
 
-#: g10/g10.c:156
+#: g10/g10.c:159
 msgid "encryption only with symmetric cipher"
 msgstr "Daten nur symmetrisch verschlsseln"
 
-#: g10/g10.c:157
+#: g10/g10.c:160
 msgid "store only"
 msgstr "nur speichern"
 
-#: g10/g10.c:158
+#: g10/g10.c:161
 msgid "decrypt data (default)"
 msgstr "Daten entschlsseln  (Voreinstellung)"
 
-#: g10/g10.c:159
+#: g10/g10.c:162
 msgid "verify a signature"
 msgstr "Signatur prfen"
 
-#: g10/g10.c:161
+#: g10/g10.c:164
 msgid "list keys"
 msgstr "Liste der Schlssel"
 
-#: g10/g10.c:162
+#: g10/g10.c:165
 msgid "list keys and signatures"
 msgstr "Liste der Schlssel und ihrer Signaturen"
 
-#: g10/g10.c:163
+#: g10/g10.c:166
 msgid "check key signatures"
 msgstr "Signaturen der Schlssel prfen"
 
-#: g10/g10.c:164
+#: g10/g10.c:167
 msgid "list keys and fingerprints"
 msgstr "Liste der Schlssel und ihrer \"Fingerabdrcke\""
 
-#: g10/g10.c:165
+#: g10/g10.c:168
 msgid "list secret keys"
 msgstr "Liste der geheimen Schlssel"
 
-#: g10/g10.c:167
+#: g10/g10.c:170
 msgid "generate a new key pair"
 msgstr "Ein neues Schlsselpaar erzeugen"
 
-#: g10/g10.c:169
+#: g10/g10.c:172
 msgid "remove key from the public keyring"
 msgstr "Schlssel entfernen"
 
-#: g10/g10.c:171
+#: g10/g10.c:174
 msgid "sign or edit a key"
 msgstr "Unterschreiben oder Bearbeiten eines Schlssels"
 
-#: g10/g10.c:172
+#: g10/g10.c:175
 msgid "generate a revocation certificate"
 msgstr "Einen Schlsselwiderruf vornehmen"
 
-#: g10/g10.c:174
+#: g10/g10.c:177
 msgid "export keys"
 msgstr "Schlssel exportieren"
 
-#: g10/g10.c:176
+#: g10/g10.c:179
 msgid "import/merge keys"
 msgstr "Schlssel importieren/kombinieren"
 
-#: g10/g10.c:177
+#: g10/g10.c:181
 msgid "list only the sequence of packets"
 msgstr "Lediglich die Struktur der Datenpackete anzeigen"
 
-#: g10/g10.c:180
+#: g10/g10.c:184
 #, fuzzy
 msgid "export the ownertrust values"
 msgstr "Keine \"Owner trust\" Werte gendert.\n"
 
-#: g10/g10.c:182
+#: g10/g10.c:186
 #, fuzzy
 msgid "import ownertrust values"
 msgstr "Keine \"Owner trust\" Werte gendert.\n"
 
-#: g10/g10.c:184
+#: g10/g10.c:188
 #, fuzzy
 msgid "|[NAMES]|update the trust database"
 msgstr "|[NAMES]|berprfen der \"Trust\"-Datenbank"
 
-#: g10/g10.c:186
+#: g10/g10.c:190
 msgid "|[NAMES]|check the trust database"
 msgstr "|[NAMES]|berprfen der \"Trust\"-Datenbank"
 
-#: g10/g10.c:187
+#: g10/g10.c:191
 msgid "fix a corrupted trust database"
 msgstr "Reparieren einer beschdigten \"Trust\"-Datenbank"
 
-#: g10/g10.c:188
+#: g10/g10.c:192
 msgid "De-Armor a file or stdin"
 msgstr "Datei oder stdin von der ASCII-Hlle befreien"
 
-#: g10/g10.c:189
+#: g10/g10.c:193
 msgid "En-Armor a file or stdin"
 msgstr "Datei oder stdin in eine ASCII-Hlle einpacken"
 
-#: g10/g10.c:190
+#: g10/g10.c:194
 msgid "|algo [files]|print message digests"
 msgstr "|algo [files]|Message-Digests fr die Dateien ausgeben"
 
-#: g10/g10.c:191
+#: g10/g10.c:195
 msgid "print all message digests"
 msgstr "Message-Digests fr die Eingabedaten ausgeben"
 
-#: g10/g10.c:198
+#: g10/g10.c:202
 msgid ""
 "@\n"
 "Options:\n"
@@ -382,133 +382,137 @@
 "Optionen:\n"
 " "
 
-#: g10/g10.c:200
+#: g10/g10.c:204
 msgid "create ascii armored output"
 msgstr "Ausgabe mit ASCII-Hlle versehen"
 
-#: g10/g10.c:202
+#: g10/g10.c:206
 msgid "use this user-id to sign or decrypt"
 msgstr "Mit dieser User-ID signieren"
 
-#: g10/g10.c:203
+#: g10/g10.c:207
 msgid "use this user-id for encryption"
 msgstr "Verschlsseln fr diese User-ID"
 
-#: g10/g10.c:204
+#: g10/g10.c:208
 msgid "|N|set compress level N (0 disables)"
 msgstr "Kompressionsstufe auf N setzen (0 fr keine Kompression)"
 
-#: g10/g10.c:205
+#: g10/g10.c:210
 msgid "use canonical text mode"
 msgstr "Textmodus benutzen"
 
-#: g10/g10.c:207
+#: g10/g10.c:212
 msgid "use as output file"
 msgstr "dies als Ausgabedatei benutzen"
 
-#: g10/g10.c:208
+#: g10/g10.c:213
 msgid "verbose"
 msgstr "detaillierte Informationen"
 
-#: g10/g10.c:209
+#: g10/g10.c:214
+msgid "be somewhat more quiet"
+msgstr ""
+
+#: g10/g10.c:215
 #, fuzzy
 msgid "force v3 signatures"
 msgstr "Signaturen der Schlssel prfen"
 
 #. { oDryRun, "dry-run",   0, N_("do not make any changes") },
-#: g10/g10.c:211
+#: g10/g10.c:217
 msgid "batch mode: never ask"
 msgstr "Stapelmodus: Keine Abfragen"
 
-#: g10/g10.c:212
+#: g10/g10.c:218
 msgid "assume yes on most questions"
 msgstr "\"Ja\" als Standardantwort annehmen"
 
-#: g10/g10.c:213
+#: g10/g10.c:219
 msgid "assume no on most questions"
 msgstr "\"Nein\" als Standardantwort annehmen"
 
-#: g10/g10.c:214
+#: g10/g10.c:220
 msgid "add this keyring to the list of keyrings"
 msgstr "Als ffentlichen Schlsselring mitbenutzen"
 
-#: g10/g10.c:215
+#: g10/g10.c:221
 msgid "add this secret keyring to the list"
 msgstr "Als geheimen Schlsselring mitbenutzen"
 
-#: g10/g10.c:216
+#: g10/g10.c:222
 msgid "|NAME|use NAME as default secret key"
 msgstr "|NAME|NAME als voreingestellten Schlssel benutzen"
 
-#: g10/g10.c:217
+#: g10/g10.c:223
 msgid "read options from file"
 msgstr "Optionen aus der Datei lesen"
 
-#: g10/g10.c:219
+#: g10/g10.c:225
 msgid "set debugging flags"
 msgstr "Debug-Flags einschalten"
 
-#: g10/g10.c:220
+#: g10/g10.c:226
 msgid "enable full debugging"
 msgstr "Alle Debug-Flags einschalten"
 
-#: g10/g10.c:221
+#: g10/g10.c:227
 msgid "|FD|write status info to this FD"
 msgstr "|FD|Statusinfo auf diesen Dateihandle (\"FD\") ausgeben"
 
-#: g10/g10.c:222
+#: g10/g10.c:228
 msgid "do not write comment packets"
 msgstr "Keine Kommentarpakete schreiben"
 
-#: g10/g10.c:223
+#: g10/g10.c:229
 msgid "(default is 1)"
 msgstr "(voreingestellt ist 1)"
 
-#: g10/g10.c:224
+#: g10/g10.c:230
 msgid "(default is 3)"
 msgstr "(voreingestellt ist 3)"
 
-#: g10/g10.c:225
+#: g10/g10.c:231
 #, fuzzy
 msgid "|FILE|load extension module FILE"
 msgstr "|FILE|Erweiterungsmodul |FILE| laden"
 
-#: g10/g10.c:226
+#: g10/g10.c:232
 msgid "emulate the mode described in RFC1991"
 msgstr "Den in RFC1991 beschriebenen Modus nachahmen"
 
-#: g10/g10.c:227
+#: g10/g10.c:233
 #, fuzzy
 msgid "|N|use passphrase mode N"
 msgstr "Fehler beim Erzeugen der \"Passphrase\": %s\n"
 
-#: g10/g10.c:229
+#: g10/g10.c:235
 #, fuzzy
 msgid "|NAME|use message digest algorithm NAME for passphrases"
 msgstr "|NAME|Die Hashmethode NAME fr die \"Passphrase\" benutzen"
 
-#: g10/g10.c:231
+#: g10/g10.c:237
 #, fuzzy
 msgid "|NAME|use cipher algorithm NAME for passphrases"
 msgstr "|NAME|Die Verschlsslungsmethode NAME benutzen"
 
-#: g10/g10.c:233
+#: g10/g10.c:239
 msgid "|NAME|use cipher algorithm NAME"
 msgstr "|NAME|Die Verschlsslungsmethode NAME benutzen"
 
-#: g10/g10.c:234
+#: g10/g10.c:240
 msgid "|NAME|use message digest algorithm NAME"
 msgstr "|NAME|Die Hashmethode NAME benutzen"
 
-#: g10/g10.c:235
+#: g10/g10.c:241
 msgid "|N|use compress algorithm N"
 msgstr "|N|Die Kompressionsmethode N benutzen"
 
-#: g10/g10.c:236
+#: g10/g10.c:242
 msgid "throw keyid field of encrypted packets"
 msgstr ""
 
-#: g10/g10.c:244
+#: g10/g10.c:250
 #, fuzzy
 msgid ""
 "@\n"
@@ -529,19 +533,19 @@
 " --list-keys [names]        Die Schlssel anzeigen\n"
 " --fingerprint [names]      Die \"Fingerabdrcke\" anzeigen\n"
 
-#: g10/g10.c:319
+#: g10/g10.c:325
 msgid "Please report bugs to <gnupg-bugs@gnu.org>.\n"
 msgstr "Berichte ber Wanzen bitte an <gnupg-bugs@gnu.org>.\n"
 
-#: g10/g10.c:324
+#: g10/g10.c:330
 msgid "Usage: gpgm [options] [files] (-h for help)"
 msgstr "Aufruf: gpgm [Optionen] [Dateien] (-h fr Hilfe)"
 
-#: g10/g10.c:326
+#: g10/g10.c:332
 msgid "Usage: gpg [options] [files] (-h for help)"
 msgstr "Aufruf: gpg [Optionen] [Dateien] (-h fr Hilfe)"
 
-#: g10/g10.c:331
+#: g10/g10.c:337
 #, fuzzy
 msgid ""
 "Syntax: gpgm [options] [files]\n"
@@ -550,7 +554,7 @@
 "Syntax: gpgm [options] [files]\n"
 "GNUPG Wartungs-Hilfsprogramm\n"
 
-#: g10/g10.c:334
+#: g10/g10.c:340
 msgid ""
 "Syntax: gpg [options] [files]\n"
 "sign, check, encrypt or decrypt\n"
@@ -560,147 +564,147 @@
 "Signieren, prfen, verschlsseln, entschlsseln\n"
 "Die voreingestellte Operation ist abhngig von den Eingabedaten\n"
 
-#: g10/g10.c:340
+#: g10/g10.c:346
 msgid ""
 "\n"
 "Supported algorithms:\n"
 msgstr ""
 
-#: g10/g10.c:415
+#: g10/g10.c:421
 msgid "usage: gpgm [options] "
 msgstr "Aufruf: gpgm [Optionen] "
 
-#: g10/g10.c:417
+#: g10/g10.c:423
 msgid "usage: gpg [options] "
 msgstr "Aufruf: gpg [Optionen] "
 
-#: g10/g10.c:458
+#: g10/g10.c:464
 msgid "conflicting commands\n"
 msgstr "Widersprchliche Kommandos\n"
 
-#: g10/g10.c:596
+#: g10/g10.c:602
 #, c-format
 msgid "note: no default option file '%s'\n"
 msgstr "Hinweis: Keine voreingestellte Optionendatei '%s' vorhanden\n"
 
-#: g10/g10.c:600
+#: g10/g10.c:606
 #, c-format
 msgid "option file '%s': %s\n"
 msgstr "Optionendatei '%s': %s\n"
 
-#: g10/g10.c:607
+#: g10/g10.c:613
 #, c-format
 msgid "reading options from '%s'\n"
 msgstr "Optionen werden von '%s' gelesen\n"
 
-#: g10/g10.c:778 g10/g10.c:790
+#: g10/g10.c:787 g10/g10.c:799
 msgid "selected cipher algorithm is invalid\n"
 msgstr "Die ausgewhlte Verschlsslungsmethode ist ungltig\n"
 
-#: g10/g10.c:784 g10/g10.c:796
+#: g10/g10.c:793 g10/g10.c:805
 msgid "selected digest algorithm is invalid\n"
 msgstr "Die ausgewhlte Message-Digest-Methode ist ungltig\n"
 
-#: g10/g10.c:799
+#: g10/g10.c:808
 #, c-format
 msgid "compress algorithm must be in range %d..%d\n"
 msgstr "Die Kompressionsmethode mu im Bereich %d bis %d liegen\n"
 
-#: g10/g10.c:801
+#: g10/g10.c:810
 msgid "completes-needed must be greater than 0\n"
 msgstr "completes-needed mssen grer als 0 sein\n"
 
-#: g10/g10.c:803
+#: g10/g10.c:812
 msgid "marginals-needed must be greater than 1\n"
 msgstr "marginals-needed mssen grer als 1 sein\n"
 
-#: g10/g10.c:806
+#: g10/g10.c:815
 msgid "note: simple S2K mode (0) is strongly discouraged\n"
 msgstr ""
 
-#: g10/g10.c:810
+#: g10/g10.c:819
 msgid "invalid S2K mode; must be 0, 1 or 3\n"
 msgstr ""
 
-#: g10/g10.c:886
+#: g10/g10.c:895
 #, c-format
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr "Die Trust-DB kann nicht initialisiert werden: %s\n"
 
-#: g10/g10.c:892
+#: g10/g10.c:901
 msgid "--store [filename]"
 msgstr "--store [Dateiname]"
 
-#: g10/g10.c:900
+#: g10/g10.c:909
 msgid "--symmetric [filename]"
 msgstr "--symmetric [Dateiname]"
 
-#: g10/g10.c:908
+#: g10/g10.c:917
 msgid "--encrypt [filename]"
 msgstr "--encrypt [Dateiname]"
 
-#: g10/g10.c:921
+#: g10/g10.c:930
 msgid "--sign [filename]"
 msgstr "--sign [Dateiname]"
 
-#: g10/g10.c:934
+#: g10/g10.c:943
 msgid "--sign --encrypt [filename]"
 msgstr "--sign --encrypt [Dateiname]"
 
-#: g10/g10.c:948
+#: g10/g10.c:957
 msgid "--clearsign [filename]"
 msgstr "--clearsign [Dateiname]"
 
-#: g10/g10.c:960
+#: g10/g10.c:969
 msgid "--decrypt [filename]"
 msgstr "--decrypt [Dateiname]"
 
-#: g10/g10.c:969
+#: g10/g10.c:978
 msgid "--edit-key username"
 msgstr "--edit-key Benutzername"
 
-#: g10/g10.c:977
+#: g10/g10.c:986
 msgid "--delete-secret-key username"
 msgstr "--delete-secret-key Benutzername"
 
-#: g10/g10.c:980
+#: g10/g10.c:989
 msgid "--delete-key username"
 msgstr "--delete-key Benutzername"
 
-#: g10/encode.c:215 g10/g10.c:1003 g10/keylist.c:80
+#: g10/encode.c:216 g10/g10.c:1012
 #, c-format
 msgid "can't open %s: %s\n"
 msgstr "Datei '%s' kann nicht geffnet werden: %s\n"
 
-#: g10/g10.c:1014
+#: g10/g10.c:1023
 msgid "-k[v][v][v][c] [userid] [keyring]"
 msgstr "-k[v][v][v][c] [Benutzername] [Keyring]"
 
-#: g10/g10.c:1069
+#: g10/g10.c:1079
 #, c-format
 msgid "dearmoring failed: %s\n"
 msgstr "De-Armor fehlgeschlagen: %s\n"
 
-#: g10/g10.c:1077
+#: g10/g10.c:1087
 #, c-format
 msgid "enarmoring failed: %s\n"
 msgstr "En-Armor fehlgeschlagen: %s\n"
 
-#: g10/g10.c:1138
+#: g10/g10.c:1148
 #, c-format
 msgid "invalid hash algorithm '%s'\n"
 msgstr "Ungltige Hashmethode '%s'\n"
 
-#: g10/g10.c:1220
+#: g10/g10.c:1230
 msgid "[filename]"
 msgstr "[Dateiname]"
 
-#: g10/decrypt.c:59 g10/g10.c:1222 g10/verify.c:66
+#: g10/decrypt.c:59 g10/g10.c:1232 g10/verify.c:66
 #, c-format
 msgid "can't open '%s'\n"
 msgstr "Datei '%s' kann nicht geffnet werden\n"
 
-#: g10/g10.c:1269
+#: g10/g10.c:1279
 msgid ""
 "RSA keys are deprecated; please consider creating a new key and use this key "
 "in the future\n"
@@ -1114,7 +1118,7 @@
 msgid "Is this correct (y/n)? "
 msgstr "Ist dies richtig? (j/n) "
 
-#: g10/keygen.c:561
+#: g10/keygen.c:569
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user "
@@ -1130,51 +1134,51 @@
 "    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n"
 "\n"
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "keygen.name"
 msgstr ""
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "Real name: "
 msgstr "Ihr Name (\"Vorname Nachname\"): "
 
-#: g10/keygen.c:576
+#: g10/keygen.c:584
 msgid "Invalid character in name\n"
 msgstr "Ungltiges Zeichen im Namen\n"
 
-#: g10/keygen.c:578
+#: g10/keygen.c:586
 msgid "Name may not start with a digit\n"
 msgstr "Der Name darf nicht mit einer Ziffer beginnen.\n"
 
-#: g10/keygen.c:580
+#: g10/keygen.c:588
 msgid "Name must be at least 5 characters long\n"
 msgstr "Der Name mu min. 5 Zeichen lang sein.\n"
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "keygen.email"
 msgstr ""
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "Email address: "
 msgstr "E-Mail-Adresse: "
 
-#: g10/keygen.c:600
+#: g10/keygen.c:608
 msgid "Not a valid email address\n"
 msgstr "E-Mail-Adresse is ungltig\n"
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "keygen.comment"
 msgstr ""
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "Comment: "
 msgstr "Kommentar: "
 
-#: g10/keygen.c:614
+#: g10/keygen.c:622
 msgid "Invalid character in comment\n"
 msgstr "Ungltiges Zeichen im Kommentar.\n"
 
-#: g10/keygen.c:634
+#: g10/keygen.c:642
 #, c-format
 msgid ""
 "You selected this USER-ID:\n"
@@ -1185,21 +1189,21 @@
 "    \"%s\"\n"
 "\n"
 
-#: g10/keygen.c:637
+#: g10/keygen.c:645
 msgid "NnCcEeOoQq"
 msgstr ""
 
-#: g10/keygen.c:646
+#: g10/keygen.c:654
 #, fuzzy
 msgid "keygen.userid.cmd"
 msgstr "Geben Sie bitte \"help\" ein."
 
-#: g10/keygen.c:647
+#: g10/keygen.c:655
 #, fuzzy
 msgid "Change (N)ame, (C)omment, (E)mail or (O)kay/(Q)uit? "
 msgstr "ndern: N=Name, C=Kommentar, E=E-Mail, O=Okay? "
 
-#: g10/keygen.c:694
+#: g10/keygen.c:707
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
@@ -1207,11 +1211,11 @@
 "Sie bentigen eine \"passphrase\", um den geheimen Schlssel zu schtzen.\n"
 "\n"
 
-#: g10/keyedit.c:389 g10/keygen.c:702
+#: g10/keyedit.c:389 g10/keygen.c:715
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr "\"passphrase\" nicht richtig wiederholt; noch einmal.\n"
 
-#: g10/keygen.c:708
+#: g10/keygen.c:721
 msgid ""
 "You don't want a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at any time,\n"
@@ -1224,7 +1228,7 @@
 "aufrufen.\n"
 "\n"
 
-#: g10/keygen.c:729
+#: g10/keygen.c:742
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -1235,35 +1239,35 @@
 "untersttzen, indem Sie z.B. in einem anderen Fenster/Konsole irgendetwas\n"
 "tippen oder irgendwelche anderen Programme benutzen.\n"
 
-#: g10/keygen.c:799
+#: g10/keygen.c:812
 msgid "Key generation can only be used in interactive mode\n"
 msgstr ""
 "Die Schlsselerzeugung kann nur im interaktiven Modus benutzt werden.\n"
 
-#: g10/keygen.c:807
+#: g10/keygen.c:820
 msgid "DSA keypair will have 1024 bits.\n"
 msgstr "Der DSA Schlssel wird 1024 Bits haben.\n"
 
-#: g10/keygen.c:813
+#: g10/keygen.c:826
 #, fuzzy
 msgid "Key generation cancelled.\n"
 msgstr "Schlsselerzeugung fehlgeschlagen: %s\n"
 
-#: g10/keygen.c:823
+#: g10/keygen.c:836
 #, c-format
 msgid "writing public certificate to '%s'\n"
 msgstr "schreiben des ffentlichen Schlssels nach '%s'\n"
 
-#: g10/keygen.c:824
+#: g10/keygen.c:837
 #, c-format
 msgid "writing secret certificate to '%s'\n"
 msgstr "schreiben des geheimen Schlssels nach '%s'\n"
 
-#: g10/keygen.c:901
+#: g10/keygen.c:914
 msgid "public and secret key created and signed.\n"
 msgstr "ffentlichen und geheimen Schlssel erzeugt und signiert.\n"
 
-#: g10/keygen.c:903
+#: g10/keygen.c:916
 msgid ""
 "Note that this key cannot be used for encryption.  You may want to use\n"
 "the command \"--add-key\" to generate a secondary key for this purpose.\n"
@@ -1272,21 +1276,21 @@
 "werden kann.  Sie knnen aber mit dem Kommando \"--add-key\" einen\n"
 "Sekundrschlssel zu diesem Schlssel hinzufgen.\n"
 
-#: g10/keygen.c:917 g10/keygen.c:1002
+#: g10/keygen.c:930 g10/keygen.c:1015
 #, c-format
 msgid "Key generation failed: %s\n"
 msgstr "Schlsselerzeugung fehlgeschlagen: %s\n"
 
-#: g10/keygen.c:979
+#: g10/keygen.c:992
 msgid "keygen.sub.okay"
 msgstr ""
 
-#: g10/keygen.c:980
+#: g10/keygen.c:993
 #, fuzzy
 msgid "Really create? "
 msgstr "Ihr Name (\"Vorname Nachname\"): "
 
-#: g10/encode.c:88
+#: g10/encode.c:88 g10/openfile.c:81 g10/openfile.c:158
 #, c-format
 msgid "%s: can't open: %s\n"
 msgstr "%s: kann nicht geffnet werden: %s\n"
@@ -1296,225 +1300,283 @@
 msgid "error creating passphrase: %s\n"
 msgstr "Fehler beim Erzeugen der \"Passphrase\": %s\n"
 
-#: g10/encode.c:154 g10/encode.c:267
+#: g10/encode.c:155 g10/encode.c:269
 #, c-format
 msgid "%s: warning: empty file\n"
 msgstr "%s: Achtung: Leere Datei.\n"
 
-#: g10/encode.c:221
+#: g10/encode.c:222
 #, c-format
 msgid "reading from '%s'\n"
 msgstr "Lesen von '%s'\n"
 
-#: g10/encode.c:395
+#: g10/encode.c:397
 #, c-format
 msgid "%s encrypted for: %s\n"
 msgstr "%s verschlsselt fr: %s\n"
 
-#: g10/getkey.c:854
+#: g10/getkey.c:950
 #, c-format
 msgid "using secondary key %08lX instead of primary key %08lX\n"
 msgstr ""
 
-#: g10/import.c:106 g10/trustdb.c:1100
+#: g10/import.c:125 g10/trustdb.c:1046
 #, c-format
 msgid "can't open file: %s\n"
 msgstr "Kann die Datei nicht ffnen: %s\n"
 
-#: g10/import.c:122
+#: g10/import.c:141
 #, c-format
 msgid "skipping block of type %d\n"
 msgstr "berspringe den Block vom Typ %d\n"
 
-#: g10/import.c:132 g10/trustdb.c:1175
+#: g10/import.c:148 g10/trustdb.c:1289 g10/trustdb.c:1358
+#, c-format
+msgid "%lu keys so far processed\n"
+msgstr ""
+
+#: g10/import.c:153 g10/trustdb.c:1122
 #, c-format
 msgid "read error: %s\n"
 msgstr "Lesefehler: %s\n"
 
-#: g10/import.c:273 g10/import.c:446
+#: g10/import.c:155
+#, c-format
+msgid "Total number processed: %lu\n"
+msgstr ""
+
+#: g10/import.c:157
+#, c-format
+msgid "          w/o user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:159
+#, c-format
+msgid "              imported: %lu"
+msgstr ""
+
+#: g10/import.c:165
+#, c-format
+msgid "             unchanged: %lu\n"
+msgstr ""
+
+#: g10/import.c:167
+#, c-format
+msgid "          new user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:169
+#, c-format
+msgid "           new subkeys: %lu\n"
+msgstr ""
+
+#: g10/import.c:171
+#, fuzzy, c-format
+msgid "        new signatures: %lu\n"
+msgstr "Schlssel %08lX: %d neue Signaturen\n"
+
+#: g10/import.c:173
+#, fuzzy, c-format
+msgid "   new key revocations: %lu\n"
+msgstr "Schlssel %08lX: ffentlicher Schlssel nicht gefunden: %s\n"
+
+#: g10/import.c:175
+#, fuzzy, c-format
+msgid "      secret keys read: %lu\n"
+msgstr "En-Armor fehlgeschlagen: %s\n"
+
+#: g10/import.c:177
+#, fuzzy, c-format
+msgid "  secret keys imported: %lu\n"
+msgstr "Schlssel %08lX: Privater Schlssel importiert\n"
+
+#: g10/import.c:179
+#, fuzzy, c-format
+msgid " secret keys unchanged: %lu\n"
+msgstr "En-Armor fehlgeschlagen: %s\n"
+
+#: g10/import.c:321 g10/import.c:513
 #, c-format
 msgid "key %08lX: no user id\n"
 msgstr "Schlssel %08lX: Keine User-ID\n"
 
-#: g10/import.c:283
+#: g10/import.c:332
 #, c-format
 msgid "key %08lX: no valid user ids\n"
 msgstr "Schlssel %08lX: Keine gltigen User-IDs\n"
 
-#: g10/import.c:285
+#: g10/import.c:334
 msgid "this may be caused by a missing self-signature\n"
 msgstr ""
 
-#: g10/import.c:294 g10/import.c:512
+#: g10/import.c:345 g10/import.c:581
 #, c-format
 msgid "key %08lX: public key not found: %s\n"
 msgstr "Schlssel %08lX: ffentlicher Schlssel nicht gefunden: %s\n"
 
-#: g10/import.c:300
+#: g10/import.c:351
 msgid "no default public keyring\n"
 msgstr "Kein voreingestellter ffentlicher Schlsselring\n"
 
-#: g10/import.c:304
+#: g10/import.c:355 g10/openfile.c:105
 #, c-format
 msgid "writing to '%s'\n"
 msgstr "Schreiben nach '%s'\n"
 
-#: g10/import.c:308 g10/import.c:363 g10/import.c:566
+#: g10/import.c:359 g10/import.c:419 g10/import.c:635
 #, c-format
 msgid "can't lock public keyring: %s\n"
 msgstr "kann ffentlichen Schlsselring nicht sperren: %s\n"
 
-#: g10/import.c:311
+#: g10/import.c:362
 #, c-format
 msgid "can't write to keyring: %s\n"
 msgstr "kann Schlsselring nicht schreiben: %s\n"
 
-#. we are ready
-#: g10/import.c:314
+#: g10/import.c:366
 #, c-format
 msgid "key %08lX: public key imported\n"
 msgstr "Schlssel %08lX: ffentlicher Schlssel importiert\n"
 
-#: g10/import.c:323
+#: g10/import.c:379
 #, c-format
 msgid "key %08lX: doesn't match our copy\n"
 msgstr "Schlssel %08lX: Stimmt nicht mit unserer Kopie berein\n"
 
-#: g10/import.c:336 g10/import.c:521
+#: g10/import.c:392 g10/import.c:590
 #, c-format
 msgid "key %08lX: can't locate original keyblock: %s\n"
 msgstr ""
 
-#: g10/import.c:343 g10/import.c:528
+#: g10/import.c:399 g10/import.c:597
 #, c-format
 msgid "key %08lX: can't read original keyblock: %s\n"
 msgstr ""
 
-#: g10/import.c:360 g10/import.c:461 g10/import.c:563
+#: g10/import.c:416 g10/import.c:528 g10/import.c:632
 msgid "writing keyblock\n"
 msgstr "schreiben des Schlsselblocks\n"
 
-#: g10/import.c:366 g10/import.c:569
+#: g10/import.c:422 g10/import.c:638
 #, c-format
 msgid "can't write keyblock: %s\n"
 msgstr "Der Schlsselblock kann nicht geschrieben werden: %s\n"
 
-#: g10/import.c:370
+#: g10/import.c:427
 #, c-format
 msgid "key %08lX: 1 new user-id\n"
 msgstr "Schlssel %08lX: 1 neue User-ID\n"
 
-#: g10/import.c:373
+#: g10/import.c:430
 #, c-format
 msgid "key %08lX: %d new user-ids\n"
 msgstr "Schlssel %08lX: %d neue User-IDs\n"
 
-#: g10/import.c:376
+#: g10/import.c:433
 #, c-format
 msgid "key %08lX: 1 new signature\n"
 msgstr "Schlssel %08lX: 1 neue Signatur\n"
 
-#: g10/import.c:379
+#: g10/import.c:436
 #, c-format
 msgid "key %08lX: %d new signatures\n"
 msgstr "Schlssel %08lX: %d neue Signaturen\n"
 
-#: g10/import.c:382
+#: g10/import.c:439
 #, c-format
 msgid "key %08lX: 1 new subkey\n"
 msgstr "Schlssel %08lX: 1 neuer Sekundrschlssel\n"
 
-#: g10/import.c:385
+#: g10/import.c:442
 #, c-format
 msgid "key %08lX: %d new subkeys\n"
 msgstr "Schlssel %08lX: %d neue Sekundrschlssel\n"
 
-#: g10/import.c:389
+#: g10/import.c:452
 #, c-format
 msgid "key %08lX: not changed\n"
 msgstr "Schlssel %08lX: Nicht gendert\n"
 
-#: g10/import.c:464
+#: g10/import.c:531
 #, c-format
 msgid "can't lock secret keyring: %s\n"
 msgstr "kann geheimen Schlsselring nicht sperren: %s\n"
 
-#: g10/import.c:467
+#: g10/import.c:534
 #, fuzzy, c-format
 msgid "can't write keyring: %s\n"
 msgstr "kann Schlsselring nicht schreiben: %s\n"
 
 #. we are ready
-#: g10/import.c:470
+#: g10/import.c:537
 #, c-format
 msgid "key %08lX: secret key imported\n"
 msgstr "Schlssel %08lX: Privater Schlssel importiert\n"
 
 #. we can't merge secret keys
-#: g10/import.c:473
+#: g10/import.c:541
 #, c-format
 msgid "key %08lX: already in secret keyring\n"
 msgstr "Schlssel %08lX: Ist bereits im privaten Schlsselring\n"
 
-#: g10/import.c:477
+#: g10/import.c:546
 #, c-format
 msgid "key %08lX: secret key not found: %s\n"
 msgstr "Schlssel %08lX: Privater Schlssel nicht gefunden: %s\n"
 
-#: g10/import.c:506
+#: g10/import.c:575
 #, c-format
 msgid "key %08lX: no public key - can't apply revocation certificate\n"
 msgstr ""
 "Schlssel %08lX: Kein ffentlicher Schlssel - der Schlsselwiderruf kann "
 "nicht angebracht werden\n"
 
-#: g10/import.c:539
+#: g10/import.c:608
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - rejected\n"
 msgstr "Schlssel %08lX: Ungltiges Widerrufzertifikat: %s - zurckgewiesen\n"
 
-#. we are ready
-#: g10/import.c:572
+#: g10/import.c:642
 #, c-format
 msgid "key %08lX: revocation certificate imported\n"
 msgstr "Schlssel %08lX: Widerruofzertifikat importiert\n"
 
-#: g10/import.c:602
+#: g10/import.c:673
 #, c-format
 msgid "key %08lX: no user-id for signature\n"
 msgstr "Schlssel %08lX: Keine User-ID fr Signatur\n"
 
-#: g10/import.c:609
+#: g10/import.c:680
 #, c-format
 msgid "key %08lX: unsupported public key algorithm\n"
 msgstr "Schlssel %08lX: Public-Key-Algorithmus wird nicht untersttzt\n"
 
-#: g10/import.c:610
+#: g10/import.c:681
 #, c-format
 msgid "key %08lX: invalid self-signature\n"
 msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
 
-#: g10/import.c:639
+#: g10/import.c:710
 #, c-format
 msgid "key %08lX: skipped userid '"
 msgstr "Schlssel %08lX: bergehe User-ID '"
 
-#: g10/import.c:662
+#: g10/import.c:733
 #, c-format
 msgid "key %08lX: revocation certificate at wrong place - skipped\n"
 msgstr "Schlssel %08lX: Widerrufzertifikat an falschem Platz - bergangen\n"
 
-#: g10/import.c:670
+#: g10/import.c:741
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - skipped\n"
 msgstr "Schlssel %08lX: Ungltiges Widerrufzertifikat: %s - bergangen\n"
 
-#: g10/import.c:732
+#: g10/import.c:803
 #, c-format
 msgid "key %08lX: revocation certificate added\n"
 msgstr "Schlssel %08lX: Widerrufzertifikat hinzugefgt\n"
 
-#: g10/import.c:795 g10/import.c:831
+#: g10/import.c:866 g10/import.c:902
 #, c-format
 msgid "key %08lX: our copy has no self-signature\n"
 msgstr "Schlssel %08lX: Unser Kopie hat keine Selbst-Signatur\n"
@@ -1826,173 +1888,173 @@
 msgid "Secret key is available.\n"
 msgstr "ffentlicher Schlssel ist nicht verfgbar.\n"
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 msgid "keyedit.cmd"
 msgstr "Geben Sie bitte \"help\" ein."
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 #, fuzzy
 msgid "Command> "
 msgstr ""
 "@Kommandos:\n"
 " "
 
-#: g10/keyedit.c:600
+#: g10/keyedit.c:602
 #, fuzzy
 msgid "Need the secret key to to this.\n"
 msgstr "Als geheimen Schlsselring mitbenutzen"
 
-#: g10/keyedit.c:619
+#: g10/keyedit.c:621
 msgid "keyedit.save.okay"
 msgstr ""
 
-#: g10/keyedit.c:620
+#: g10/keyedit.c:622
 msgid "Save changes? "
 msgstr ""
 
-#: g10/keyedit.c:622
+#: g10/keyedit.c:624
 #, fuzzy
 msgid "keyedit.cancel.okay"
 msgstr "Geben Sie bitte \"help\" ein."
 
-#: g10/keyedit.c:623
+#: g10/keyedit.c:625
 msgid "Quit without saving? "
 msgstr ""
 
-#: g10/keyedit.c:633
+#: g10/keyedit.c:635
 #, fuzzy, c-format
 msgid "update failed: %s\n"
 msgstr "De-Armor fehlgeschlagen: %s\n"
 
-#: g10/keyedit.c:640
+#: g10/keyedit.c:642
 #, fuzzy, c-format
 msgid "update secret failed: %s\n"
 msgstr "Enschlsselung fehlgeschlagen: %s\n"
 
-#: g10/keyedit.c:647
+#: g10/keyedit.c:649
 msgid "Key not changed so no update needed.\n"
 msgstr ""
 
-#: g10/keyedit.c:650 g10/keyedit.c:708
+#: g10/keyedit.c:652 g10/keyedit.c:710
 #, fuzzy, c-format
 msgid "update of trust db failed: %s\n"
 msgstr "Enschlsselung fehlgeschlagen: %s\n"
 
-#: g10/keyedit.c:681
+#: g10/keyedit.c:683
 msgid "keyedit.sign_all.okay"
 msgstr ""
 
-#: g10/keyedit.c:682
+#: g10/keyedit.c:684
 msgid "Really sign all user ids? "
 msgstr ""
 
-#: g10/keyedit.c:683
+#: g10/keyedit.c:685
 msgid "Hint: Select the user ids to sign\n"
 msgstr ""
 
-#: g10/keyedit.c:719
+#: g10/keyedit.c:721
 msgid "You must select at least one user id.\n"
 msgstr ""
 
-#: g10/keyedit.c:721
+#: g10/keyedit.c:723
 msgid "You can't delete the last user id!\n"
 msgstr ""
 
-#: g10/keyedit.c:723
+#: g10/keyedit.c:725
 msgid "keyedit.remove.uid.okay"
 msgstr ""
 
-#: g10/keyedit.c:724
+#: g10/keyedit.c:726
 #, fuzzy
 msgid "Really remove all selected user ids? "
 msgstr "Mchten Sie die ausgewhlten Signaturen wirklich entfernen? "
 
-#: g10/keyedit.c:725
+#: g10/keyedit.c:727
 #, fuzzy
 msgid "Really remove this user id? "
 msgstr "Die Signatur entfernen? "
 
-#: g10/keyedit.c:748
+#: g10/keyedit.c:750
 msgid "You must select at least one key.\n"
 msgstr ""
 
-#: g10/keyedit.c:750
+#: g10/keyedit.c:752
 msgid "keyedit.remove.subkey.okay"
 msgstr ""
 
-#: g10/keyedit.c:752
+#: g10/keyedit.c:754
 #, fuzzy
 msgid "Do you really want to delete the selected keys? "
 msgstr "Mchten Sie die ausgewhlten Signaturen wirklich entfernen? "
 
-#: g10/keyedit.c:753
+#: g10/keyedit.c:755
 #, fuzzy
 msgid "Do you really want to delete this key? "
 msgstr "Mchten Sie dies wirklich tun? "
 
-#: g10/keyedit.c:800
+#: g10/keyedit.c:802
 msgid "Invalid command  (try \"help\")\n"
 msgstr ""
 
-#: g10/keyedit.c:1178
+#: g10/keyedit.c:1180
 msgid "Please remove selections from the secret keys.\n"
 msgstr ""
 
-#: g10/keyedit.c:1184
+#: g10/keyedit.c:1186
 #, fuzzy
 msgid "Please select at most one secondary key.\n"
 msgstr "Bitte whlen Sie, welche Art von Schlssel Sie mchten:\n"
 
-#: g10/keyedit.c:1188
+#: g10/keyedit.c:1190
 msgid "Changing exiration time for a secondary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1190
+#: g10/keyedit.c:1192
 msgid "Changing exiration time for the primary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1234
+#: g10/keyedit.c:1236
 msgid "No corresponding signature in secret ring\n"
 msgstr ""
 
-#: g10/keyedit.c:1294
+#: g10/keyedit.c:1296
 #, c-format
 msgid "No user id with index %d\n"
 msgstr ""
 
-#: g10/keyedit.c:1339
+#: g10/keyedit.c:1341
 #, c-format
 msgid "No secondary key with index %d\n"
 msgstr ""
 
-#: g10/mainproc.c:200
+#: g10/mainproc.c:201
 #, c-format
 msgid "public key decryption failed: %s\n"
 msgstr "Entschlsselung mit ffentlichem Schlssel fehlgeschlagen: %s\n"
 
-#: g10/mainproc.c:230
+#: g10/mainproc.c:231
 #, c-format
 msgid "decryption failed: %s\n"
 msgstr "Enschlsselung fehlgeschlagen: %s\n"
 
-#: g10/mainproc.c:247
+#: g10/mainproc.c:248
 msgid "note: sender requested \"for-your-eyes-only\"\n"
 msgstr ""
 
-#: g10/mainproc.c:848
+#: g10/mainproc.c:842
 #, c-format
 msgid "Signature made %.*s using %s key ID %08lX\n"
 msgstr "Signatur am %.*s mit %s Schlssel %08lX erzeugt\n"
 
-#: g10/mainproc.c:856
+#: g10/mainproc.c:850
 msgid "BAD signature from \""
 msgstr "FALSCHE Signatur von \""
 
-#: g10/mainproc.c:857
+#: g10/mainproc.c:851
 msgid "Good signature from \""
 msgstr "Gltige Signatur von \""
 
-#: g10/mainproc.c:868
+#: g10/mainproc.c:862
 #, c-format
 msgid "Can't check signature: %s\n"
 msgstr "Signatur kann nicht geprft werden: %s\n"
@@ -2098,194 +2160,242 @@
 msgid "warning: signature key expired %s\n"
 msgstr "Achtung: Schlssel der Signatur ist verfallen am %s.\n"
 
-#: g10/trustdb.c:122
+#: g10/trustdb.c:129
 msgid "The trust DB is corrupted; please run \"gpgm --fix-trust-db\".\n"
 msgstr ""
 "Die \"Trust\"-Datenbank ist beschdigt; verwenden Sie \"gpgm "
 "--fix-trust-db\".\n"
 
-#: g10/trustdb.c:389
+#: g10/trustdb.c:407
 #, c-format
 msgid "chained sigrec %lu has a wrong owner\n"
 msgstr "Verketteter Signatursatz %lu hat einen falschen Besitzer\n"
 
-#: g10/trustdb.c:436
+#: g10/trustdb.c:454
 #, fuzzy, c-format
 msgid "key %08lX: secret key without public key - skipped\n"
 msgstr "Schlssel %08lX: geheimer, aber kein ffentlicher Schlssel.\n"
 
-#: g10/trustdb.c:442
+#: g10/trustdb.c:460
 #, c-format
 msgid "key %08lX: secret and public key don't match\n"
 msgstr ""
 "Schlssel %08lX: geheimer und ffentlicher Schlssel passen nicht zusammen.\n"
 
-#: g10/trustdb.c:452
+#: g10/trustdb.c:470
 #, fuzzy, c-format
 msgid "key %08lX: can't put it into the trustdb\n"
 msgstr "Schlssel %08lX.%lu: in \"trustdb\" eingefgt\n"
 
-#: g10/trustdb.c:458
+#: g10/trustdb.c:476
 #, fuzzy, c-format
 msgid "key %08lX: query record failed\n"
 msgstr "Schlssel %08lX: Keine User-ID\n"
 
-#: g10/trustdb.c:467
+#: g10/trustdb.c:485
 #, fuzzy, c-format
 msgid "key %08lX: already in secret key table\n"
 msgstr "Schlssel %08lX: Ist bereits im privaten Schlsselring\n"
 
-#: g10/trustdb.c:470
+#: g10/trustdb.c:488
 #, fuzzy, c-format
 msgid "key %08lX: accepted as secret key.\n"
 msgstr "Schlssel %08lX: Ist bereits im privaten Schlsselring\n"
 
-#: g10/trustdb.c:477
+#: g10/trustdb.c:495
 #, fuzzy, c-format
 msgid "enum_secret_keys failed: %s\n"
 msgstr "En-Armor fehlgeschlagen: %s\n"
 
-#: g10/trustdb.c:1428
+#: g10/trustdb.c:1292 g10/trustdb.c:1360
+#, c-format
+msgid "%lu keys processed\n"
+msgstr ""
+
+#: g10/trustdb.c:1294
+#, fuzzy, c-format
+msgid "\t%lu keys skipped\n"
+msgstr "%s: bersprungen: %s\n"
+
+#: g10/trustdb.c:1296 g10/trustdb.c:1362
+#, fuzzy, c-format
+msgid "\t%lu keys with errors\n"
+msgstr "Dateischreibfehler"
+
+#: g10/trustdb.c:1298 g10/trustdb.c:1364
+#, c-format
+msgid "\t%lu keys updated\n"
+msgstr ""
+
+#: g10/trustdb.c:1366
+#, c-format
+msgid "\t%lu keys inserted\n"
+msgstr ""
+
+#: g10/trustdb.c:1421
 #, fuzzy, c-format
 msgid "key %08lX: insert trust record failed: %s\n"
 msgstr "Schlssel %08lX.%lu: Vertrauensprfung fehlgeschlagen: %s\n"
 
-#: g10/trustdb.c:1432
+#: g10/trustdb.c:1425
 #, c-format
 msgid "key %08lX.%lu: inserted into trustdb\n"
 msgstr "Schlssel %08lX.%lu: in \"trustdb\" eingefgt\n"
 
-#: g10/trustdb.c:1440
+#: g10/trustdb.c:1433
 #, c-format
 msgid "key %08lX.%lu: created in future (time warp or clock problem)\n"
 msgstr ""
 "Schlssel %08lX.%lu: wurde in der Zukunft erzeugt (Zeitreise oder Uhren "
 "stimmen nicht berein)\n"
 
-#: g10/trustdb.c:1447
+#: g10/trustdb.c:1440
 #, c-format
 msgid "key %08lX.%lu: expired at %s\n"
 msgstr "Schlssel %08lX.%lu: verfallen am %s\n"
 
-#: g10/trustdb.c:1455
+#: g10/trustdb.c:1448
 #, c-format
 msgid "key %08lX.%lu: trust check failed: %s\n"
 msgstr "Schlssel %08lX.%lu: Vertrauensprfung fehlgeschlagen: %s\n"
 
-#: g10/trustdb.c:1718
+#: g10/trustdb.c:1666
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but marked as checked\n"
 msgstr ""
 
-#: g10/trustdb.c:1722
+#: g10/trustdb.c:1670
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but not marked\n"
 msgstr ""
 
 #. we need the dir record
-#: g10/trustdb.c:1729
+#: g10/trustdb.c:1677
 #, c-format
-msgid "sig rec %lu[%d] in hintlist of %u does not point to a dir record\n"
+msgid "sig rec %lu[%d] in hintlist of %lu does not point to a dir record\n"
 msgstr ""
 
-#: g10/trustdb.c:1735
+#: g10/trustdb.c:1683
 #, c-format
 msgid "lid %lu: no primary key\n"
 msgstr ""
 
-#: g10/trustdb.c:1764
+#: g10/trustdb.c:1716
 #, fuzzy, c-format
 msgid "lid %lu: user id not found in keyblock\n"
 msgstr "%s: Benutzer nicht gefunden\n"
 
-#: g10/trustdb.c:1771
+#: g10/trustdb.c:1720
+#, fuzzy, c-format
+msgid "lid %lu: user id without signature\n"
+msgstr "Schlssel %08lX: Keine User-ID fr Signatur\n"
+
+#: g10/trustdb.c:1727
 #, fuzzy, c-format
 msgid "lid %lu: self-signature in hintlist\n"
 msgstr "build_sigrecs: Selbst-Signatur fehlt\n"
 
-#: g10/trustdb.c:1776
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (3)\n"
-msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+#: g10/trustdb.c:1738 g10/trustdb.c:2444 g10/trustdb.c:2526
+#, fuzzy
+msgid "Valid certificate revocation"
+msgstr "Falsches Zertifikat"
 
-#: g10/trustdb.c:1783
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: very strange: no public key\n"
-msgstr "Schlssel %08lX: Keine User-ID fr Signatur\n"
+#: g10/trustdb.c:1739 g10/trustdb.c:2445 g10/trustdb.c:2527
+#, fuzzy
+msgid "Good certificate"
+msgstr "Falsches Zertifikat"
 
-#: g10/trustdb.c:1790 g10/trustdb.c:2225 g10/trustdb.c:2297
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: invalid signature: %s\n"
-msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+#: g10/trustdb.c:1748
+msgid "very strange: no public key\n"
+msgstr ""
 
-#: g10/trustdb.c:1835
+#: g10/trustdb.c:1796
 #, c-format
 msgid "hintlist %lu[%d] of %lu does not point to a dir record\n"
 msgstr ""
 
-#: g10/trustdb.c:1841
+#: g10/trustdb.c:1802
 #, c-format
 msgid "lid %lu does not have a key\n"
 msgstr ""
 
-#: g10/trustdb.c:1851
+#: g10/trustdb.c:1812
 #, fuzzy, c-format
 msgid "lid %lu: can't get keyblock: %s\n"
 msgstr "Der Schlsselblock kann nicht geschrieben werden: %s\n"
 
-#: g10/trustdb.c:2096
+#: g10/trustdb.c:2022
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X: good self-signature\n"
-msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+msgid "key %08lX.%lu: Good subkey binding\n"
+msgstr "Schlssel %08lX: Keine User-ID\n"
 
-#: g10/trustdb.c:2188
+#: g10/trustdb.c:2028 g10/trustdb.c:2070
 #, fuzzy, c-format
-msgid ""
-"key %08lX.%lu, uid %02X%02X, sig %08lX: duplicated signature - deleted\n"
-msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+msgid "key %08lX.%lu: Invalid subkey binding: %s\n"
+msgstr "Schlssel %08lX: Keine gltigen User-IDs\n"
 
-#: g10/trustdb.c:2211
+#: g10/trustdb.c:2043
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (1)\n"
-msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+msgid "key %08lX.%lu: Valid key revocation\n"
+msgstr "Schlssel %08lX: ffentlicher Schlssel nicht gefunden: %s\n"
 
-#: g10/trustdb.c:2218
+#: g10/trustdb.c:2049
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: weird: no public key\n"
-msgstr "Schlssel %08lX: Keine User-ID fr Signatur\n"
+msgid "key %08lX.%lu: Invalid key revocation: %s\n"
+msgstr "Schlssel %08lX: ffentlicher Schlssel nicht gefunden: %s\n"
 
-#: g10/trustdb.c:2240
+#: g10/trustdb.c:2064
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X: has shadow dir %lu but not yet marked.\n"
-msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+msgid "key %08lX.%lu: Valid subkey revocation\n"
+msgstr "Schlssel %08lX: ffentlicher Schlssel nicht gefunden: %s\n"
 
-#: g10/trustdb.c:2279
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (2)\n"
+#: g10/trustdb.c:2164
+#, fuzzy
+msgid "Good self-signature"
+msgstr "Selbst-Signatur bergangen\n"
+
+#: g10/trustdb.c:2172
+#, fuzzy
+msgid "Invalid self-signature"
 msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
 
-#: g10/trustdb.c:2290
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: no public key\n"
-msgstr "Schlssel %08lX: Keine User-ID fr Signatur\n"
+#: g10/trustdb.c:2183
+#, fuzzy
+msgid "Valid user ID revocation\n"
+msgstr "Ungltige Auswahl.\n"
 
-#. key binding
-#: g10/trustdb.c:2386
-#, fuzzy, c-format
-msgid "key %08lX: bogus key binding by %08lX\n"
-msgstr "Schlssel %08lX: Keine User-ID\n"
+#: g10/trustdb.c:2190
+#, fuzzy
+msgid "Invalid user ID revocation"
+msgstr "Ungltige Auswahl.\n"
 
-#. key revocation
-#: g10/trustdb.c:2390
-#, fuzzy, c-format
-msgid "key %08lX: bogus key revocation by %08lX\n"
-msgstr "Schlssel %08lX: ffentlicher Schlssel nicht gefunden: %s\n"
+#: g10/trustdb.c:2273
+#, fuzzy
+msgid "Too many preferences"
+msgstr "Liste der geheimen Schlssel"
 
-#. subkey revocation
-#: g10/trustdb.c:2394
-#, fuzzy, c-format
-msgid "key %08lX: bogus subkey revocation by %08lX\n"
-msgstr "Schlssel %08lX: ffentlicher Schlssel nicht gefunden: %s\n"
+#: g10/trustdb.c:2286
+msgid "Too many preferences items"
+msgstr ""
+
+#: g10/trustdb.c:2423
+msgid "Duplicated certificate - deleted"
+msgstr ""
+
+#: g10/trustdb.c:2455
+#, fuzzy
+msgid "public key lost"
+msgstr "Falscher ffentlicher Schssel"
+
+#: g10/trustdb.c:2464 g10/trustdb.c:2547
+#, fuzzy
+msgid "Invalid certificate revocation"
+msgstr "Falsches Zertifikat"
+
+#: g10/trustdb.c:2465 g10/trustdb.c:2548
+#, fuzzy
+msgid "Invalid certificate"
+msgstr "Falsches Zertifikat"
 
 #: g10/status.c:246
 msgid "No help available"
@@ -2324,6 +2434,26 @@
 msgid "Overwrite (y/N)? "
 msgstr "berschreiben (j/N)? "
 
+#: g10/openfile.c:85
+#, fuzzy
+msgid "writing to stdout\n"
+msgstr "Schreiben nach '%s'\n"
+
+#: g10/openfile.c:101 g10/openfile.c:165
+#, fuzzy, c-format
+msgid "%s: can't create: %s\n"
+msgstr "%s: kann nicht geffnet werden: %s\n"
+
+#: g10/openfile.c:134
+#, fuzzy, c-format
+msgid "assuming signed data in '%s'\n"
+msgstr "kann signierte Datei '%s' nicht ffnen.\n"
+
+#: g10/openfile.c:181
+#, c-format
+msgid "%s: new options file created\n"
+msgstr ""
+
 #: g10/encr-data.c:74
 msgid ""
 "Warning: Message was encrypted with a weak key in the symmetric cipher.\n"
@@ -2340,6 +2470,49 @@
 msgstr ""
 "Trotz %d-fachen Versuch konnte die Erzeugung eines unsicheren Schlsselfr "
 "sym.Verschlsselung nicht vermieden werden!\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (3)\n"
+#~ msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+
+#, fuzzy
+#~ msgid ""
+#~ "key %08lX.%lu, uid %02X%02X, sig %08lX: very strange: no public key\n"
+#~ msgstr "Schlssel %08lX: Keine User-ID fr Signatur\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: invalid signature: %s\n"
+#~ msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X: good self-signature\n"
+#~ msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+
+#, fuzzy
+#~ msgid ""
+#~ "key %08lX.%lu, uid %02X%02X, sig %08lX: duplicated signature - deleted\n"
+#~ msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (1)\n"
+#~ msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: weird: no public key\n"
+#~ msgstr "Schlssel %08lX: Keine User-ID fr Signatur\n"
+
+#, fuzzy
+#~ msgid ""
+#~ "key %08lX.%lu, uid %02X%02X: has shadow dir %lu but not yet marked.\n"
+#~ msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (2)\n"
+#~ msgstr "Schlssel %08lX: Ungltige Selbst-Signatur\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: no public key\n"
+#~ msgstr "Schlssel %08lX: Keine User-ID fr Signatur\n"
 
 #~ msgid "key %08lX: already in ultikey_table\n"
 #~ msgstr "Schlssel %08lX: bereits in der Tabelle der private Schlssel\n"
diff -urN gnupg-0.4.2/po/en.po gnupg-0.4.3/po/en.po
--- gnupg-0.4.2/po/en.po	Sun Oct 18 17:07:33 1998
+++ gnupg-0.4.3/po/en.po	Sun Nov  8 18:22:50 1998
@@ -1,6 +1,6 @@
 msgid ""
 msgstr ""
-"POT-Creation-Date: 1998-10-18 16:36+0200\n"
+"POT-Creation-Date: 1998-11-08 18:21+0100\n"
 "Content-Type: text/plain; charset=\n"
 "Date: 1998-08-08 18:07:50+0200\n"
 "From: Werner Koch <wk@frodo>\n"
@@ -202,7 +202,7 @@
 
 #: util/logger.c:177
 #, c-format
-msgid "Ohhhh jeeee ... this is a bug (%s:%d:%s)\n"
+msgid "... this is a bug (%s:%d:%s)\n"
 msgstr ""
 
 #: util/logger.c:183
@@ -231,93 +231,93 @@
 "the OS a chance to collect more entropy! (Need %d more bytes)\n"
 msgstr ""
 
-#: g10/g10.c:149
+#: g10/g10.c:152
 msgid ""
 "@Commands:\n"
 " "
 msgstr ""
 
-#: g10/g10.c:152
+#: g10/g10.c:155
 msgid "|[file]|make a signature"
 msgstr ""
 
-#: g10/g10.c:153
+#: g10/g10.c:156
 msgid "|[file]|make a clear text signature"
 msgstr ""
 
-#: g10/g10.c:154
+#: g10/g10.c:157
 msgid "make a detached signature"
 msgstr ""
 
-#: g10/g10.c:155
+#: g10/g10.c:158
 msgid "encrypt data"
 msgstr ""
 
-#: g10/g10.c:156
+#: g10/g10.c:159
 msgid "encryption only with symmetric cipher"
 msgstr ""
 
-#: g10/g10.c:157
+#: g10/g10.c:160
 msgid "store only"
 msgstr ""
 
-#: g10/g10.c:158
+#: g10/g10.c:161
 msgid "decrypt data (default)"
 msgstr ""
 
-#: g10/g10.c:159
+#: g10/g10.c:162
 msgid "verify a signature"
 msgstr ""
 
-#: g10/g10.c:161
+#: g10/g10.c:164
 msgid "list keys"
 msgstr ""
 
-#: g10/g10.c:162
+#: g10/g10.c:165
 msgid "list keys and signatures"
 msgstr ""
 
-#: g10/g10.c:163
+#: g10/g10.c:166
 msgid "check key signatures"
 msgstr ""
 
-#: g10/g10.c:164
+#: g10/g10.c:167
 msgid "list keys and fingerprints"
 msgstr ""
 
-#: g10/g10.c:165
+#: g10/g10.c:168
 msgid "list secret keys"
 msgstr ""
 
-#: g10/g10.c:167
+#: g10/g10.c:170
 msgid "generate a new key pair"
 msgstr ""
 
-#: g10/g10.c:169
+#: g10/g10.c:172
 msgid "remove key from the public keyring"
 msgstr ""
 
-#: g10/g10.c:171
+#: g10/g10.c:174
 msgid "sign or edit a key"
 msgstr ""
 
-#: g10/g10.c:172
+#: g10/g10.c:175
 msgid "generate a revocation certificate"
 msgstr ""
 
-#: g10/g10.c:174
+#: g10/g10.c:177
 msgid "export keys"
 msgstr ""
 
-#: g10/g10.c:176
+#: g10/g10.c:179
 msgid "import/merge keys"
 msgstr ""
 
-#: g10/g10.c:177
+#: g10/g10.c:181
 msgid "list only the sequence of packets"
 msgstr ""
 
-#: g10/g10.c:180
+#: g10/g10.c:184
 #, fuzzy
 msgid "export the ownertrust values"
 msgstr ""
@@ -325,7 +325,7 @@
 "to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n"
 "to do with the (implicitly created) web-of-certificates."
 
-#: g10/g10.c:182
+#: g10/g10.c:186
 #, fuzzy
 msgid "import ownertrust values"
 msgstr ""
@@ -333,163 +333,167 @@
 "to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n"
 "to do with the (implicitly created) web-of-certificates."
 
-#: g10/g10.c:184
+#: g10/g10.c:188
 msgid "|[NAMES]|update the trust database"
 msgstr ""
 
-#: g10/g10.c:186
+#: g10/g10.c:190
 msgid "|[NAMES]|check the trust database"
 msgstr ""
 
-#: g10/g10.c:187
+#: g10/g10.c:191
 msgid "fix a corrupted trust database"
 msgstr ""
 
-#: g10/g10.c:188
+#: g10/g10.c:192
 msgid "De-Armor a file or stdin"
 msgstr ""
 
-#: g10/g10.c:189
+#: g10/g10.c:193
 msgid "En-Armor a file or stdin"
 msgstr ""
 
-#: g10/g10.c:190
+#: g10/g10.c:194
 msgid "|algo [files]|print message digests"
 msgstr ""
 
-#: g10/g10.c:191
+#: g10/g10.c:195
 msgid "print all message digests"
 msgstr ""
 
-#: g10/g10.c:198
+#: g10/g10.c:202
 msgid ""
 "@\n"
 "Options:\n"
 " "
 msgstr ""
 
-#: g10/g10.c:200
+#: g10/g10.c:204
 msgid "create ascii armored output"
 msgstr ""
 
-#: g10/g10.c:202
+#: g10/g10.c:206
 msgid "use this user-id to sign or decrypt"
 msgstr ""
 
-#: g10/g10.c:203
+#: g10/g10.c:207
 msgid "use this user-id for encryption"
 msgstr ""
 
-#: g10/g10.c:204
+#: g10/g10.c:208
 msgid "|N|set compress level N (0 disables)"
 msgstr ""
 
-#: g10/g10.c:205
+#: g10/g10.c:210
 msgid "use canonical text mode"
 msgstr ""
 
-#: g10/g10.c:207
+#: g10/g10.c:212
 msgid "use as output file"
 msgstr ""
 
-#: g10/g10.c:208
+#: g10/g10.c:213
 msgid "verbose"
 msgstr ""
 
-#: g10/g10.c:209
+#: g10/g10.c:214
+msgid "be somewhat more quiet"
+msgstr ""
+
+#: g10/g10.c:215
 msgid "force v3 signatures"
 msgstr ""
 
 #. { oDryRun, "dry-run",   0, N_("do not make any changes") },
-#: g10/g10.c:211
+#: g10/g10.c:217
 msgid "batch mode: never ask"
 msgstr ""
 
-#: g10/g10.c:212
+#: g10/g10.c:218
 msgid "assume yes on most questions"
 msgstr ""
 
-#: g10/g10.c:213
+#: g10/g10.c:219
 msgid "assume no on most questions"
 msgstr ""
 
-#: g10/g10.c:214
+#: g10/g10.c:220
 msgid "add this keyring to the list of keyrings"
 msgstr ""
 
-#: g10/g10.c:215
+#: g10/g10.c:221
 msgid "add this secret keyring to the list"
 msgstr ""
 
-#: g10/g10.c:216
+#: g10/g10.c:222
 msgid "|NAME|use NAME as default secret key"
 msgstr ""
 
-#: g10/g10.c:217
+#: g10/g10.c:223
 msgid "read options from file"
 msgstr ""
 
-#: g10/g10.c:219
+#: g10/g10.c:225
 msgid "set debugging flags"
 msgstr ""
 
-#: g10/g10.c:220
+#: g10/g10.c:226
 msgid "enable full debugging"
 msgstr ""
 
-#: g10/g10.c:221
+#: g10/g10.c:227
 msgid "|FD|write status info to this FD"
 msgstr ""
 
-#: g10/g10.c:222
+#: g10/g10.c:228
 msgid "do not write comment packets"
 msgstr ""
 
-#: g10/g10.c:223
+#: g10/g10.c:229
 msgid "(default is 1)"
 msgstr ""
 
-#: g10/g10.c:224
+#: g10/g10.c:230
 msgid "(default is 3)"
 msgstr ""
 
-#: g10/g10.c:225
+#: g10/g10.c:231
 msgid "|FILE|load extension module FILE"
 msgstr ""
 
-#: g10/g10.c:226
+#: g10/g10.c:232
 msgid "emulate the mode described in RFC1991"
 msgstr ""
 
-#: g10/g10.c:227
+#: g10/g10.c:233
 msgid "|N|use passphrase mode N"
 msgstr ""
 
-#: g10/g10.c:229
+#: g10/g10.c:235
 msgid "|NAME|use message digest algorithm NAME for passphrases"
 msgstr ""
 
-#: g10/g10.c:231
+#: g10/g10.c:237
 msgid "|NAME|use cipher algorithm NAME for passphrases"
 msgstr ""
 
-#: g10/g10.c:233
+#: g10/g10.c:239
 msgid "|NAME|use cipher algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:234
+#: g10/g10.c:240
 msgid "|NAME|use message digest algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:235
+#: g10/g10.c:241
 msgid "|N|use compress algorithm N"
 msgstr ""
 
-#: g10/g10.c:236
+#: g10/g10.c:242
 msgid "throw keyid field of encrypted packets"
 msgstr ""
 
-#: g10/g10.c:244
+#: g10/g10.c:250
 msgid ""
 "@\n"
 "Examples:\n"
@@ -501,172 +505,172 @@
 " --fingerprint [names]      show fingerprints\n"
 msgstr ""
 
-#: g10/g10.c:319
+#: g10/g10.c:325
 msgid "Please report bugs to <gnupg-bugs@gnu.org>.\n"
 msgstr ""
 
-#: g10/g10.c:324
+#: g10/g10.c:330
 msgid "Usage: gpgm [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:326
+#: g10/g10.c:332
 msgid "Usage: gpg [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:331
+#: g10/g10.c:337
 msgid ""
 "Syntax: gpgm [options] [files]\n"
 "GnuPG maintenance utility\n"
 msgstr ""
 
-#: g10/g10.c:334
+#: g10/g10.c:340
 msgid ""
 "Syntax: gpg [options] [files]\n"
 "sign, check, encrypt or decrypt\n"
 "default operation depends on the input data\n"
 msgstr ""
 
-#: g10/g10.c:340
+#: g10/g10.c:346
 msgid ""
 "\n"
 "Supported algorithms:\n"
 msgstr ""
 
-#: g10/g10.c:415
+#: g10/g10.c:421
 msgid "usage: gpgm [options] "
 msgstr ""
 
-#: g10/g10.c:417
+#: g10/g10.c:423
 msgid "usage: gpg [options] "
 msgstr ""
 
-#: g10/g10.c:458
+#: g10/g10.c:464
 msgid "conflicting commands\n"
 msgstr ""
 
-#: g10/g10.c:596
+#: g10/g10.c:602
 #, c-format
 msgid "note: no default option file '%s'\n"
 msgstr ""
 
-#: g10/g10.c:600
+#: g10/g10.c:606
 #, c-format
 msgid "option file '%s': %s\n"
 msgstr ""
 
-#: g10/g10.c:607
+#: g10/g10.c:613
 #, c-format
 msgid "reading options from '%s'\n"
 msgstr ""
 
-#: g10/g10.c:778 g10/g10.c:790
+#: g10/g10.c:787 g10/g10.c:799
 msgid "selected cipher algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:784 g10/g10.c:796
+#: g10/g10.c:793 g10/g10.c:805
 msgid "selected digest algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:799
+#: g10/g10.c:808
 #, c-format
 msgid "compress algorithm must be in range %d..%d\n"
 msgstr ""
 
-#: g10/g10.c:801
+#: g10/g10.c:810
 msgid "completes-needed must be greater than 0\n"
 msgstr ""
 
-#: g10/g10.c:803
+#: g10/g10.c:812
 msgid "marginals-needed must be greater than 1\n"
 msgstr ""
 
-#: g10/g10.c:806
+#: g10/g10.c:815
 msgid "note: simple S2K mode (0) is strongly discouraged\n"
 msgstr ""
 
-#: g10/g10.c:810
+#: g10/g10.c:819
 msgid "invalid S2K mode; must be 0, 1 or 3\n"
 msgstr ""
 
-#: g10/g10.c:886
+#: g10/g10.c:895
 #, c-format
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr ""
 
-#: g10/g10.c:892
+#: g10/g10.c:901
 msgid "--store [filename]"
 msgstr ""
 
-#: g10/g10.c:900
+#: g10/g10.c:909
 msgid "--symmetric [filename]"
 msgstr ""
 
-#: g10/g10.c:908
+#: g10/g10.c:917
 msgid "--encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:921
+#: g10/g10.c:930
 msgid "--sign [filename]"
 msgstr ""
 
-#: g10/g10.c:934
+#: g10/g10.c:943
 msgid "--sign --encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:948
+#: g10/g10.c:957
 msgid "--clearsign [filename]"
 msgstr ""
 
-#: g10/g10.c:960
+#: g10/g10.c:969
 msgid "--decrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:969
+#: g10/g10.c:978
 msgid "--edit-key username"
 msgstr ""
 
-#: g10/g10.c:977
+#: g10/g10.c:986
 msgid "--delete-secret-key username"
 msgstr ""
 
-#: g10/g10.c:980
+#: g10/g10.c:989
 msgid "--delete-key username"
 msgstr ""
 
-#: g10/encode.c:215 g10/g10.c:1003 g10/keylist.c:80
+#: g10/encode.c:216 g10/g10.c:1012
 #, c-format
 msgid "can't open %s: %s\n"
 msgstr ""
 
-#: g10/g10.c:1014
+#: g10/g10.c:1023
 msgid "-k[v][v][v][c] [userid] [keyring]"
 msgstr ""
 
-#: g10/g10.c:1069
+#: g10/g10.c:1079
 #, c-format
 msgid "dearmoring failed: %s\n"
 msgstr ""
 
-#: g10/g10.c:1077
+#: g10/g10.c:1087
 #, c-format
 msgid "enarmoring failed: %s\n"
 msgstr ""
 
-#: g10/g10.c:1138
+#: g10/g10.c:1148
 #, c-format
 msgid "invalid hash algorithm '%s'\n"
 msgstr ""
 
-#: g10/g10.c:1220
+#: g10/g10.c:1230
 msgid "[filename]"
 msgstr ""
 
-#: g10/decrypt.c:59 g10/g10.c:1222 g10/verify.c:66
+#: g10/decrypt.c:59 g10/g10.c:1232 g10/verify.c:66
 #, c-format
 msgid "can't open '%s'\n"
 msgstr ""
 
-#: g10/g10.c:1269
+#: g10/g10.c:1279
 msgid ""
 "RSA keys are deprecated; please consider creating a new key and use this key "
 "in the future\n"
@@ -1049,7 +1053,7 @@
 msgid "Is this correct (y/n)? "
 msgstr ""
 
-#: g10/keygen.c:561
+#: g10/keygen.c:569
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user "
@@ -1059,51 +1063,51 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "keygen.name"
 msgstr ""
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "Real name: "
 msgstr ""
 
-#: g10/keygen.c:576
+#: g10/keygen.c:584
 msgid "Invalid character in name\n"
 msgstr ""
 
-#: g10/keygen.c:578
+#: g10/keygen.c:586
 msgid "Name may not start with a digit\n"
 msgstr ""
 
-#: g10/keygen.c:580
+#: g10/keygen.c:588
 msgid "Name must be at least 5 characters long\n"
 msgstr ""
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "keygen.email"
 msgstr ""
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "Email address: "
 msgstr ""
 
-#: g10/keygen.c:600
+#: g10/keygen.c:608
 msgid "Not a valid email address\n"
 msgstr ""
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "keygen.comment"
 msgstr ""
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "Comment: "
 msgstr ""
 
-#: g10/keygen.c:614
+#: g10/keygen.c:622
 msgid "Invalid character in comment\n"
 msgstr ""
 
-#: g10/keygen.c:634
+#: g10/keygen.c:642
 #, c-format
 msgid ""
 "You selected this USER-ID:\n"
@@ -1111,11 +1115,11 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:637
+#: g10/keygen.c:645
 msgid "NnCcEeOoQq"
 msgstr ""
 
-#: g10/keygen.c:646
+#: g10/keygen.c:654
 msgid "keygen.userid.cmd"
 msgstr ""
 "N  to change the name.\n"
@@ -1124,21 +1128,21 @@
 "O  to continue with key generation.\n"
 "Q  to to quit the key generation."
 
-#: g10/keygen.c:647
+#: g10/keygen.c:655
 msgid "Change (N)ame, (C)omment, (E)mail or (O)kay/(Q)uit? "
 msgstr ""
 
-#: g10/keygen.c:694
+#: g10/keygen.c:707
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
 msgstr ""
 
-#: g10/keyedit.c:389 g10/keygen.c:702
+#: g10/keyedit.c:389 g10/keygen.c:715
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr ""
 
-#: g10/keygen.c:708
+#: g10/keygen.c:721
 msgid ""
 "You don't want a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at any time,\n"
@@ -1146,7 +1150,7 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:729
+#: g10/keygen.c:742
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -1154,52 +1158,52 @@
 "number generator a better chance to gain enough entropy.\n"
 msgstr ""
 
-#: g10/keygen.c:799
+#: g10/keygen.c:812
 msgid "Key generation can only be used in interactive mode\n"
 msgstr ""
 
-#: g10/keygen.c:807
+#: g10/keygen.c:820
 msgid "DSA keypair will have 1024 bits.\n"
 msgstr ""
 
-#: g10/keygen.c:813
+#: g10/keygen.c:826
 msgid "Key generation cancelled.\n"
 msgstr ""
 
-#: g10/keygen.c:823
+#: g10/keygen.c:836
 #, c-format
 msgid "writing public certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:824
+#: g10/keygen.c:837
 #, c-format
 msgid "writing secret certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:901
+#: g10/keygen.c:914
 msgid "public and secret key created and signed.\n"
 msgstr ""
 
-#: g10/keygen.c:903
+#: g10/keygen.c:916
 msgid ""
 "Note that this key cannot be used for encryption.  You may want to use\n"
 "the command \"--add-key\" to generate a secondary key for this purpose.\n"
 msgstr ""
 
-#: g10/keygen.c:917 g10/keygen.c:1002
+#: g10/keygen.c:930 g10/keygen.c:1015
 #, c-format
 msgid "Key generation failed: %s\n"
 msgstr ""
 
-#: g10/keygen.c:979
+#: g10/keygen.c:992
 msgid "keygen.sub.okay"
 msgstr "Answer \"yes\" (or just \"y\") if it is okay to generate the sub key."
 
-#: g10/keygen.c:980
+#: g10/keygen.c:993
 msgid "Really create? "
 msgstr ""
 
-#: g10/encode.c:88
+#: g10/encode.c:88 g10/openfile.c:81 g10/openfile.c:158
 #, c-format
 msgid "%s: can't open: %s\n"
 msgstr ""
@@ -1209,223 +1213,281 @@
 msgid "error creating passphrase: %s\n"
 msgstr ""
 
-#: g10/encode.c:154 g10/encode.c:267
+#: g10/encode.c:155 g10/encode.c:269
 #, c-format
 msgid "%s: warning: empty file\n"
 msgstr ""
 
-#: g10/encode.c:221
+#: g10/encode.c:222
 #, c-format
 msgid "reading from '%s'\n"
 msgstr ""
 
-#: g10/encode.c:395
+#: g10/encode.c:397
 #, c-format
 msgid "%s encrypted for: %s\n"
 msgstr ""
 
-#: g10/getkey.c:854
+#: g10/getkey.c:950
 #, c-format
 msgid "using secondary key %08lX instead of primary key %08lX\n"
 msgstr ""
 
-#: g10/import.c:106 g10/trustdb.c:1100
+#: g10/import.c:125 g10/trustdb.c:1046
 #, c-format
 msgid "can't open file: %s\n"
 msgstr ""
 
-#: g10/import.c:122
+#: g10/import.c:141
 #, c-format
 msgid "skipping block of type %d\n"
 msgstr ""
 
-#: g10/import.c:132 g10/trustdb.c:1175
+#: g10/import.c:148 g10/trustdb.c:1289 g10/trustdb.c:1358
+#, c-format
+msgid "%lu keys so far processed\n"
+msgstr ""
+
+#: g10/import.c:153 g10/trustdb.c:1122
 #, c-format
 msgid "read error: %s\n"
 msgstr ""
 
-#: g10/import.c:273 g10/import.c:446
+#: g10/import.c:155
+#, c-format
+msgid "Total number processed: %lu\n"
+msgstr ""
+
+#: g10/import.c:157
+#, c-format
+msgid "          w/o user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:159
+#, c-format
+msgid "              imported: %lu"
+msgstr ""
+
+#: g10/import.c:165
+#, c-format
+msgid "             unchanged: %lu\n"
+msgstr ""
+
+#: g10/import.c:167
+#, c-format
+msgid "          new user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:169
+#, c-format
+msgid "           new subkeys: %lu\n"
+msgstr ""
+
+#: g10/import.c:171
+#, c-format
+msgid "        new signatures: %lu\n"
+msgstr ""
+
+#: g10/import.c:173
+#, c-format
+msgid "   new key revocations: %lu\n"
+msgstr ""
+
+#: g10/import.c:175
+#, c-format
+msgid "      secret keys read: %lu\n"
+msgstr ""
+
+#: g10/import.c:177
+#, c-format
+msgid "  secret keys imported: %lu\n"
+msgstr ""
+
+#: g10/import.c:179
+#, c-format
+msgid " secret keys unchanged: %lu\n"
+msgstr ""
+
+#: g10/import.c:321 g10/import.c:513
 #, c-format
 msgid "key %08lX: no user id\n"
 msgstr ""
 
-#: g10/import.c:283
+#: g10/import.c:332
 #, c-format
 msgid "key %08lX: no valid user ids\n"
 msgstr ""
 
-#: g10/import.c:285
+#: g10/import.c:334
 msgid "this may be caused by a missing self-signature\n"
 msgstr ""
 
-#: g10/import.c:294 g10/import.c:512
+#: g10/import.c:345 g10/import.c:581
 #, c-format
 msgid "key %08lX: public key not found: %s\n"
 msgstr ""
 
-#: g10/import.c:300
+#: g10/import.c:351
 msgid "no default public keyring\n"
 msgstr ""
 
-#: g10/import.c:304
+#: g10/import.c:355 g10/openfile.c:105
 #, c-format
 msgid "writing to '%s'\n"
 msgstr ""
 
-#: g10/import.c:308 g10/import.c:363 g10/import.c:566
+#: g10/import.c:359 g10/import.c:419 g10/import.c:635
 #, c-format
 msgid "can't lock public keyring: %s\n"
 msgstr ""
 
-#: g10/import.c:311
+#: g10/import.c:362
 #, c-format
 msgid "can't write to keyring: %s\n"
 msgstr ""
 
-#. we are ready
-#: g10/import.c:314
+#: g10/import.c:366
 #, c-format
 msgid "key %08lX: public key imported\n"
 msgstr ""
 
-#: g10/import.c:323
+#: g10/import.c:379
 #, c-format
 msgid "key %08lX: doesn't match our copy\n"
 msgstr ""
 
-#: g10/import.c:336 g10/import.c:521
+#: g10/import.c:392 g10/import.c:590
 #, c-format
 msgid "key %08lX: can't locate original keyblock: %s\n"
 msgstr ""
 
-#: g10/import.c:343 g10/import.c:528
+#: g10/import.c:399 g10/import.c:597
 #, c-format
 msgid "key %08lX: can't read original keyblock: %s\n"
 msgstr ""
 
-#: g10/import.c:360 g10/import.c:461 g10/import.c:563
+#: g10/import.c:416 g10/import.c:528 g10/import.c:632
 msgid "writing keyblock\n"
 msgstr ""
 
-#: g10/import.c:366 g10/import.c:569
+#: g10/import.c:422 g10/import.c:638
 #, c-format
 msgid "can't write keyblock: %s\n"
 msgstr ""
 
-#: g10/import.c:370
+#: g10/import.c:427
 #, c-format
 msgid "key %08lX: 1 new user-id\n"
 msgstr ""
 
-#: g10/import.c:373
+#: g10/import.c:430
 #, c-format
 msgid "key %08lX: %d new user-ids\n"
 msgstr ""
 
-#: g10/import.c:376
+#: g10/import.c:433
 #, c-format
 msgid "key %08lX: 1 new signature\n"
 msgstr ""
 
-#: g10/import.c:379
+#: g10/import.c:436
 #, c-format
 msgid "key %08lX: %d new signatures\n"
 msgstr ""
 
-#: g10/import.c:382
+#: g10/import.c:439
 #, c-format
 msgid "key %08lX: 1 new subkey\n"
 msgstr ""
 
-#: g10/import.c:385
+#: g10/import.c:442
 #, c-format
 msgid "key %08lX: %d new subkeys\n"
 msgstr ""
 
-#: g10/import.c:389
+#: g10/import.c:452
 #, c-format
 msgid "key %08lX: not changed\n"
 msgstr ""
 
-#: g10/import.c:464
+#: g10/import.c:531
 #, c-format
 msgid "can't lock secret keyring: %s\n"
 msgstr ""
 
-#: g10/import.c:467
+#: g10/import.c:534
 #, c-format
 msgid "can't write keyring: %s\n"
 msgstr ""
 
 #. we are ready
-#: g10/import.c:470
+#: g10/import.c:537
 #, c-format
 msgid "key %08lX: secret key imported\n"
 msgstr ""
 
 #. we can't merge secret keys
-#: g10/import.c:473
+#: g10/import.c:541
 #, c-format
 msgid "key %08lX: already in secret keyring\n"
 msgstr ""
 
-#: g10/import.c:477
+#: g10/import.c:546
 #, c-format
 msgid "key %08lX: secret key not found: %s\n"
 msgstr ""
 
-#: g10/import.c:506
+#: g10/import.c:575
 #, c-format
 msgid "key %08lX: no public key - can't apply revocation certificate\n"
 msgstr ""
 
-#: g10/import.c:539
+#: g10/import.c:608
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - rejected\n"
 msgstr ""
 
-#. we are ready
-#: g10/import.c:572
+#: g10/import.c:642
 #, c-format
 msgid "key %08lX: revocation certificate imported\n"
 msgstr ""
 
-#: g10/import.c:602
+#: g10/import.c:673
 #, c-format
 msgid "key %08lX: no user-id for signature\n"
 msgstr ""
 
-#: g10/import.c:609
+#: g10/import.c:680
 #, c-format
 msgid "key %08lX: unsupported public key algorithm\n"
 msgstr ""
 
-#: g10/import.c:610
+#: g10/import.c:681
 #, c-format
 msgid "key %08lX: invalid self-signature\n"
 msgstr ""
 
-#: g10/import.c:639
+#: g10/import.c:710
 #, c-format
 msgid "key %08lX: skipped userid '"
 msgstr ""
 
-#: g10/import.c:662
+#: g10/import.c:733
 #, c-format
 msgid "key %08lX: revocation certificate at wrong place - skipped\n"
 msgstr ""
 
-#: g10/import.c:670
+#: g10/import.c:741
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - skipped\n"
 msgstr ""
 
-#: g10/import.c:732
+#: g10/import.c:803
 #, c-format
 msgid "key %08lX: revocation certificate added\n"
 msgstr ""
 
-#: g10/import.c:795 g10/import.c:831
+#: g10/import.c:866 g10/import.c:902
 #, c-format
 msgid "key %08lX: our copy has no self-signature\n"
 msgstr ""
@@ -1715,163 +1777,163 @@
 msgid "Secret key is available.\n"
 msgstr ""
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 msgid "keyedit.cmd"
 msgstr "Please enter \"help\"."
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 msgid "Command> "
 msgstr ""
 
-#: g10/keyedit.c:600
+#: g10/keyedit.c:602
 msgid "Need the secret key to to this.\n"
 msgstr ""
 
-#: g10/keyedit.c:619
+#: g10/keyedit.c:621
 msgid "keyedit.save.okay"
 msgstr ""
 
-#: g10/keyedit.c:620
+#: g10/keyedit.c:622
 msgid "Save changes? "
 msgstr ""
 
-#: g10/keyedit.c:622
+#: g10/keyedit.c:624
 msgid "keyedit.cancel.okay"
 msgstr ""
 
-#: g10/keyedit.c:623
+#: g10/keyedit.c:625
 msgid "Quit without saving? "
 msgstr ""
 
-#: g10/keyedit.c:633
+#: g10/keyedit.c:635
 #, c-format
 msgid "update failed: %s\n"
 msgstr ""
 
-#: g10/keyedit.c:640
+#: g10/keyedit.c:642
 #, c-format
 msgid "update secret failed: %s\n"
 msgstr ""
 
-#: g10/keyedit.c:647
+#: g10/keyedit.c:649
 msgid "Key not changed so no update needed.\n"
 msgstr ""
 
-#: g10/keyedit.c:650 g10/keyedit.c:708
+#: g10/keyedit.c:652 g10/keyedit.c:710
 #, c-format
 msgid "update of trust db failed: %s\n"
 msgstr ""
 
-#: g10/keyedit.c:681
+#: g10/keyedit.c:683
 msgid "keyedit.sign_all.okay"
 msgstr ""
 
-#: g10/keyedit.c:682
+#: g10/keyedit.c:684
 msgid "Really sign all user ids? "
 msgstr ""
 
-#: g10/keyedit.c:683
+#: g10/keyedit.c:685
 msgid "Hint: Select the user ids to sign\n"
 msgstr ""
 
-#: g10/keyedit.c:719
+#: g10/keyedit.c:721
 msgid "You must select at least one user id.\n"
 msgstr ""
 
-#: g10/keyedit.c:721
+#: g10/keyedit.c:723
 msgid "You can't delete the last user id!\n"
 msgstr ""
 
-#: g10/keyedit.c:723
+#: g10/keyedit.c:725
 msgid "keyedit.remove.uid.okay"
 msgstr ""
 
-#: g10/keyedit.c:724
+#: g10/keyedit.c:726
 msgid "Really remove all selected user ids? "
 msgstr ""
 
-#: g10/keyedit.c:725
+#: g10/keyedit.c:727
 msgid "Really remove this user id? "
 msgstr ""
 
-#: g10/keyedit.c:748
+#: g10/keyedit.c:750
 msgid "You must select at least one key.\n"
 msgstr ""
 
-#: g10/keyedit.c:750
+#: g10/keyedit.c:752
 msgid "keyedit.remove.subkey.okay"
 msgstr ""
 
-#: g10/keyedit.c:752
+#: g10/keyedit.c:754
 msgid "Do you really want to delete the selected keys? "
 msgstr ""
 
-#: g10/keyedit.c:753
+#: g10/keyedit.c:755
 msgid "Do you really want to delete this key? "
 msgstr ""
 
-#: g10/keyedit.c:800
+#: g10/keyedit.c:802
 msgid "Invalid command  (try \"help\")\n"
 msgstr ""
 
-#: g10/keyedit.c:1178
+#: g10/keyedit.c:1180
 msgid "Please remove selections from the secret keys.\n"
 msgstr ""
 
-#: g10/keyedit.c:1184
+#: g10/keyedit.c:1186
 msgid "Please select at most one secondary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1188
+#: g10/keyedit.c:1190
 msgid "Changing exiration time for a secondary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1190
+#: g10/keyedit.c:1192
 msgid "Changing exiration time for the primary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1234
+#: g10/keyedit.c:1236
 msgid "No corresponding signature in secret ring\n"
 msgstr ""
 
-#: g10/keyedit.c:1294
+#: g10/keyedit.c:1296
 #, c-format
 msgid "No user id with index %d\n"
 msgstr ""
 
-#: g10/keyedit.c:1339
+#: g10/keyedit.c:1341
 #, c-format
 msgid "No secondary key with index %d\n"
 msgstr ""
 
-#: g10/mainproc.c:200
+#: g10/mainproc.c:201
 #, c-format
 msgid "public key decryption failed: %s\n"
 msgstr ""
 
-#: g10/mainproc.c:230
+#: g10/mainproc.c:231
 #, c-format
 msgid "decryption failed: %s\n"
 msgstr ""
 
-#: g10/mainproc.c:247
+#: g10/mainproc.c:248
 msgid "note: sender requested \"for-your-eyes-only\"\n"
 msgstr ""
 
-#: g10/mainproc.c:848
+#: g10/mainproc.c:842
 #, c-format
 msgid "Signature made %.*s using %s key ID %08lX\n"
 msgstr ""
 
-#: g10/mainproc.c:856
+#: g10/mainproc.c:850
 msgid "BAD signature from \""
 msgstr ""
 
-#: g10/mainproc.c:857
+#: g10/mainproc.c:851
 msgid "Good signature from \""
 msgstr ""
 
-#: g10/mainproc.c:868
+#: g10/mainproc.c:862
 #, c-format
 msgid "Can't check signature: %s\n"
 msgstr ""
@@ -1950,188 +2012,226 @@
 msgid "warning: signature key expired %s\n"
 msgstr ""
 
-#: g10/trustdb.c:122
+#: g10/trustdb.c:129
 msgid "The trust DB is corrupted; please run \"gpgm --fix-trust-db\".\n"
 msgstr ""
 
-#: g10/trustdb.c:389
+#: g10/trustdb.c:407
 #, c-format
 msgid "chained sigrec %lu has a wrong owner\n"
 msgstr ""
 
-#: g10/trustdb.c:436
+#: g10/trustdb.c:454
 #, c-format
 msgid "key %08lX: secret key without public key - skipped\n"
 msgstr ""
 
-#: g10/trustdb.c:442
+#: g10/trustdb.c:460
 #, c-format
 msgid "key %08lX: secret and public key don't match\n"
 msgstr ""
 
-#: g10/trustdb.c:452
+#: g10/trustdb.c:470
 #, c-format
 msgid "key %08lX: can't put it into the trustdb\n"
 msgstr ""
 
-#: g10/trustdb.c:458
+#: g10/trustdb.c:476
 #, c-format
 msgid "key %08lX: query record failed\n"
 msgstr ""
 
-#: g10/trustdb.c:467
+#: g10/trustdb.c:485
 #, c-format
 msgid "key %08lX: already in secret key table\n"
 msgstr ""
 
-#: g10/trustdb.c:470
+#: g10/trustdb.c:488
 #, c-format
 msgid "key %08lX: accepted as secret key.\n"
 msgstr ""
 
-#: g10/trustdb.c:477
+#: g10/trustdb.c:495
 #, c-format
 msgid "enum_secret_keys failed: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:1428
+#: g10/trustdb.c:1292 g10/trustdb.c:1360
+#, c-format
+msgid "%lu keys processed\n"
+msgstr ""
+
+#: g10/trustdb.c:1294
+#, c-format
+msgid "\t%lu keys skipped\n"
+msgstr ""
+
+#: g10/trustdb.c:1296 g10/trustdb.c:1362
+#, c-format
+msgid "\t%lu keys with errors\n"
+msgstr ""
+
+#: g10/trustdb.c:1298 g10/trustdb.c:1364
+#, c-format
+msgid "\t%lu keys updated\n"
+msgstr ""
+
+#: g10/trustdb.c:1366
+#, c-format
+msgid "\t%lu keys inserted\n"
+msgstr ""
+
+#: g10/trustdb.c:1421
 #, c-format
 msgid "key %08lX: insert trust record failed: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:1432
+#: g10/trustdb.c:1425
 #, c-format
 msgid "key %08lX.%lu: inserted into trustdb\n"
 msgstr ""
 
-#: g10/trustdb.c:1440
+#: g10/trustdb.c:1433
 #, c-format
 msgid "key %08lX.%lu: created in future (time warp or clock problem)\n"
 msgstr ""
 
-#: g10/trustdb.c:1447
+#: g10/trustdb.c:1440
 #, c-format
 msgid "key %08lX.%lu: expired at %s\n"
 msgstr ""
 
-#: g10/trustdb.c:1455
+#: g10/trustdb.c:1448
 #, c-format
 msgid "key %08lX.%lu: trust check failed: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:1718
+#: g10/trustdb.c:1666
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but marked as checked\n"
 msgstr ""
 
-#: g10/trustdb.c:1722
+#: g10/trustdb.c:1670
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but not marked\n"
 msgstr ""
 
 #. we need the dir record
-#: g10/trustdb.c:1729
+#: g10/trustdb.c:1677
 #, c-format
-msgid "sig rec %lu[%d] in hintlist of %u does not point to a dir record\n"
+msgid "sig rec %lu[%d] in hintlist of %lu does not point to a dir record\n"
 msgstr ""
 
-#: g10/trustdb.c:1735
+#: g10/trustdb.c:1683
 #, c-format
 msgid "lid %lu: no primary key\n"
 msgstr ""
 
-#: g10/trustdb.c:1764
+#: g10/trustdb.c:1716
 #, c-format
 msgid "lid %lu: user id not found in keyblock\n"
 msgstr ""
 
-#: g10/trustdb.c:1771
+#: g10/trustdb.c:1720
 #, c-format
-msgid "lid %lu: self-signature in hintlist\n"
+msgid "lid %lu: user id without signature\n"
 msgstr ""
 
-#: g10/trustdb.c:1776
+#: g10/trustdb.c:1727
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (3)\n"
+msgid "lid %lu: self-signature in hintlist\n"
 msgstr ""
 
-#: g10/trustdb.c:1783
-#, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: very strange: no public key\n"
+#: g10/trustdb.c:1738 g10/trustdb.c:2444 g10/trustdb.c:2526
+msgid "Valid certificate revocation"
 msgstr ""
 
-#: g10/trustdb.c:1790 g10/trustdb.c:2225 g10/trustdb.c:2297
-#, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: invalid signature: %s\n"
+#: g10/trustdb.c:1739 g10/trustdb.c:2445 g10/trustdb.c:2527
+msgid "Good certificate"
+msgstr ""
+
+#: g10/trustdb.c:1748
+msgid "very strange: no public key\n"
 msgstr ""
 
-#: g10/trustdb.c:1835
+#: g10/trustdb.c:1796
 #, c-format
 msgid "hintlist %lu[%d] of %lu does not point to a dir record\n"
 msgstr ""
 
-#: g10/trustdb.c:1841
+#: g10/trustdb.c:1802
 #, c-format
 msgid "lid %lu does not have a key\n"
 msgstr ""
 
-#: g10/trustdb.c:1851
+#: g10/trustdb.c:1812
 #, c-format
 msgid "lid %lu: can't get keyblock: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:2096
+#: g10/trustdb.c:2022
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X: good self-signature\n"
+msgid "key %08lX.%lu: Good subkey binding\n"
 msgstr ""
 
-#: g10/trustdb.c:2188
+#: g10/trustdb.c:2028 g10/trustdb.c:2070
 #, c-format
-msgid ""
-"key %08lX.%lu, uid %02X%02X, sig %08lX: duplicated signature - deleted\n"
+msgid "key %08lX.%lu: Invalid subkey binding: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:2211
+#: g10/trustdb.c:2043
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (1)\n"
+msgid "key %08lX.%lu: Valid key revocation\n"
 msgstr ""
 
-#: g10/trustdb.c:2218
+#: g10/trustdb.c:2049
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: weird: no public key\n"
+msgid "key %08lX.%lu: Invalid key revocation: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:2240
+#: g10/trustdb.c:2064
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X: has shadow dir %lu but not yet marked.\n"
+msgid "key %08lX.%lu: Valid subkey revocation\n"
 msgstr ""
 
-#: g10/trustdb.c:2279
-#, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (2)\n"
+#: g10/trustdb.c:2164
+msgid "Good self-signature"
 msgstr ""
 
-#: g10/trustdb.c:2290
-#, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: no public key\n"
+#: g10/trustdb.c:2172
+msgid "Invalid self-signature"
 msgstr ""
 
-#. key binding
-#: g10/trustdb.c:2386
-#, c-format
-msgid "key %08lX: bogus key binding by %08lX\n"
+#: g10/trustdb.c:2183
+msgid "Valid user ID revocation\n"
 msgstr ""
 
-#. key revocation
-#: g10/trustdb.c:2390
-#, c-format
-msgid "key %08lX: bogus key revocation by %08lX\n"
+#: g10/trustdb.c:2190
+msgid "Invalid user ID revocation"
 msgstr ""
 
-#. subkey revocation
-#: g10/trustdb.c:2394
-#, c-format
-msgid "key %08lX: bogus subkey revocation by %08lX\n"
+#: g10/trustdb.c:2273
+msgid "Too many preferences"
+msgstr ""
+
+#: g10/trustdb.c:2286
+msgid "Too many preferences items"
+msgstr ""
+
+#: g10/trustdb.c:2423
+msgid "Duplicated certificate - deleted"
+msgstr ""
+
+#: g10/trustdb.c:2455
+msgid "public key lost"
+msgstr ""
+
+#: g10/trustdb.c:2464 g10/trustdb.c:2547
+msgid "Invalid certificate revocation"
+msgstr ""
+
+#: g10/trustdb.c:2465 g10/trustdb.c:2548
+msgid "Invalid certificate"
 msgstr ""
 
 #: g10/status.c:246
@@ -2169,6 +2269,25 @@
 
 #: g10/openfile.c:60
 msgid "Overwrite (y/N)? "
+msgstr ""
+
+#: g10/openfile.c:85
+msgid "writing to stdout\n"
+msgstr ""
+
+#: g10/openfile.c:101 g10/openfile.c:165
+#, c-format
+msgid "%s: can't create: %s\n"
+msgstr ""
+
+#: g10/openfile.c:134
+#, c-format
+msgid "assuming signed data in '%s'\n"
+msgstr ""
+
+#: g10/openfile.c:181
+#, c-format
+msgid "%s: new options file created\n"
 msgstr ""
 
 #: g10/encr-data.c:74
diff -urN gnupg-0.4.2/po/fr.po gnupg-0.4.3/po/fr.po
--- gnupg-0.4.2/po/fr.po	Sun Oct 18 17:08:08 1998
+++ gnupg-0.4.3/po/fr.po	Sun Nov  8 18:23:16 1998
@@ -1,12 +1,12 @@
-# gnupg french translation
+# GnuPG french translation
 # Copyright (C) 1998 Free Software Foundation, Inc.
 # Gal Quri <gqueri@mail.dotcom.fr>, 1998.
 #
 msgid ""
 msgstr ""
-"Project-Id-Version: gnupg-0.4.1\n"
-"POT-Creation-Date: 1998-10-18 16:36+0200\n"
-"PO-Revision-Date: 1998-10-11 00:21+0200\n"
+"Project-Id-Version: gnupg-0.4.1a\n"
+"POT-Creation-Date: 1998-11-08 18:21+0100\n"
+"PO-Revision-Date: 1998-10-29 19:01+0100\n"
 "Last-Translator: Gal Quri <gqueri@mail.dotcom.fr>\n"
 "Language-Team: French <fr@li.org>\n"
 "MIME-Version: 1.0\n"
@@ -199,8 +199,8 @@
 
 #: util/logger.c:177
 #, c-format
-msgid "Ohhhh jeeee ... this is a bug (%s:%d:%s)\n"
-msgstr "Ouais ... c'est un bug (%s:%d:%s)\n"
+msgid "... this is a bug (%s:%d:%s)\n"
+msgstr "... c'est un bug (%s:%d:%s)\n"
 
 #: util/logger.c:183
 #, c-format
@@ -237,7 +237,7 @@
 "Il n'y a pas assez d'octets alatoires disponibles. Faites autre chose\n"
 "pour que l'OS puisse amasser plus d'entropie! (il faut %d octets de plus)\n"
 
-#: g10/g10.c:149
+#: g10/g10.c:152
 msgid ""
 "@Commands:\n"
 " "
@@ -245,124 +245,124 @@
 "@Commandes:\n"
 " "
 
-#: g10/g10.c:152
+#: g10/g10.c:155
 msgid "|[file]|make a signature"
 msgstr "|[fichier]|faire une signature"
 
-#: g10/g10.c:153
+#: g10/g10.c:156
 msgid "|[file]|make a clear text signature"
 msgstr "|[fichier]|faire une signature en texte clair"
 
-#: g10/g10.c:154
+#: g10/g10.c:157
 msgid "make a detached signature"
 msgstr "faire une signature dtache"
 
-#: g10/g10.c:155
+#: g10/g10.c:158
 msgid "encrypt data"
 msgstr "crypter les donnes"
 
-#: g10/g10.c:156
+#: g10/g10.c:159
 msgid "encryption only with symmetric cipher"
 msgstr "chiffrement symtrique seumement"
 
-#: g10/g10.c:157
+#: g10/g10.c:160
 msgid "store only"
 msgstr "pas d'action"
 
-#: g10/g10.c:158
+#: g10/g10.c:161
 msgid "decrypt data (default)"
 msgstr "dcrypter les donnes (dfaut)"
 
-#: g10/g10.c:159
+#: g10/g10.c:162
 msgid "verify a signature"
 msgstr "vrifier une signature"
 
-#: g10/g10.c:161
+#: g10/g10.c:164
 msgid "list keys"
 msgstr "lister les cls"
 
-#: g10/g10.c:162
+#: g10/g10.c:165
 msgid "list keys and signatures"
 msgstr "lister les cls et les signatures"
 
-#: g10/g10.c:163
+#: g10/g10.c:166
 msgid "check key signatures"
 msgstr "vrifier les signatures des cls"
 
-#: g10/g10.c:164
+#: g10/g10.c:167
 msgid "list keys and fingerprints"
 msgstr "lister les cls et les empreintes"
 
-#: g10/g10.c:165
+#: g10/g10.c:168
 msgid "list secret keys"
 msgstr "lister les cls secrtes"
 
-#: g10/g10.c:167
+#: g10/g10.c:170
 msgid "generate a new key pair"
 msgstr "gnrer une nouvelle paire de cls"
 
-#: g10/g10.c:169
+#: g10/g10.c:172
 msgid "remove key from the public keyring"
 msgstr "enlever la cl du porte-cls public"
 
-#: g10/g10.c:171
+#: g10/g10.c:174
 msgid "sign or edit a key"
 msgstr "signer ou diter une cl"
 
-#: g10/g10.c:172
+#: g10/g10.c:175
 msgid "generate a revocation certificate"
 msgstr "gnrer un certificat de rvocation"
 
-#: g10/g10.c:174
+#: g10/g10.c:177
 msgid "export keys"
 msgstr "exporter les cls"
 
-#: g10/g10.c:176
+#: g10/g10.c:179
 msgid "import/merge keys"
 msgstr "importer/fusionner les cls"
 
-#: g10/g10.c:177
+#: g10/g10.c:181
 msgid "list only the sequence of packets"
 msgstr "ne lister qu'une suite de paquets"
 
-#: g10/g10.c:180
+#: g10/g10.c:184
 msgid "export the ownertrust values"
 msgstr "exporter les valeurs de confiance"
 
-#: g10/g10.c:182
+#: g10/g10.c:186
 msgid "import ownertrust values"
 msgstr "importer les valeurs de confiance"
 
-#: g10/g10.c:184
-#, fuzzy
+#
+#: g10/g10.c:188
 msgid "|[NAMES]|update the trust database"
-msgstr "|[NOMS]|vrifier la base de confiance"
+msgstr "|[NOMS]|mettre la base de confiance  jour"
 
-#: g10/g10.c:186
+#: g10/g10.c:190
 msgid "|[NAMES]|check the trust database"
 msgstr "|[NOMS]|vrifier la base de confiance"
 
-#: g10/g10.c:187
+#: g10/g10.c:191
 msgid "fix a corrupted trust database"
 msgstr "rparer une base de confiance corrompue"
 
-#: g10/g10.c:188
+#: g10/g10.c:192
 msgid "De-Armor a file or stdin"
 msgstr "Enlever l'armure d'un fichier ou de stdin"
 
-#: g10/g10.c:189
+#: g10/g10.c:193
 msgid "En-Armor a file or stdin"
 msgstr "Mettre une armure  un fichier ou  stdin"
 
-#: g10/g10.c:190
+#: g10/g10.c:194
 msgid "|algo [files]|print message digests"
 msgstr "|alg. [fich.]|indiquer les fonctions de hachage"
 
-#: g10/g10.c:191
+#: g10/g10.c:195
 msgid "print all message digests"
 msgstr "crire toutes les fonctions de hachage"
 
-#: g10/g10.c:198
+#: g10/g10.c:202
 msgid ""
 "@\n"
 "Options:\n"
@@ -372,129 +372,133 @@
 "Options:\n"
 " "
 
-#: g10/g10.c:200
+#: g10/g10.c:204
 msgid "create ascii armored output"
 msgstr "crer une sortie ascii armure"
 
-#: g10/g10.c:202
+#: g10/g10.c:206
 msgid "use this user-id to sign or decrypt"
 msgstr "utiliser ce nom pour signer ou dcrypter"
 
-#: g10/g10.c:203
+#: g10/g10.c:207
 msgid "use this user-id for encryption"
 msgstr "utiliser ce nom d'utilisateur pour crypter"
 
-#: g10/g10.c:204
+#: g10/g10.c:208
 msgid "|N|set compress level N (0 disables)"
 msgstr "|N|niveau de compression N (0 dsactive)"
 
-#: g10/g10.c:205
+#: g10/g10.c:210
 msgid "use canonical text mode"
 msgstr "utiliser le mode de texte canonique"
 
-#: g10/g10.c:207
+#: g10/g10.c:212
 msgid "use as output file"
 msgstr "utiliser comme fichier de sortie"
 
-#: g10/g10.c:208
+#: g10/g10.c:213
 msgid "verbose"
 msgstr "bavard"
 
-#: g10/g10.c:209
-#, fuzzy
+#: g10/g10.c:214
+msgid "be somewhat more quiet"
+msgstr "devenir beaucoup plus silencieux"
+
+#
+#: g10/g10.c:215
 msgid "force v3 signatures"
-msgstr "vrifier les signatures des cls"
+msgstr "forcer les signatures en v3"
 
 #. { oDryRun, "dry-run",   0, N_("do not make any changes") },
-#: g10/g10.c:211
+#: g10/g10.c:217
 msgid "batch mode: never ask"
-msgstr "mode automatique: ne jamais demander"
+msgstr "mode automatique: ne jamais rien demander"
 
-#: g10/g10.c:212
+#: g10/g10.c:218
 msgid "assume yes on most questions"
 msgstr "supposer oui  la plupart des questions"
 
-#: g10/g10.c:213
+#: g10/g10.c:219
 msgid "assume no on most questions"
 msgstr "supposer non  la plupart des questions"
 
-#: g10/g10.c:214
+#: g10/g10.c:220
 msgid "add this keyring to the list of keyrings"
 msgstr "ajouter ce porte-cls  la liste des porte-cls"
 
-#: g10/g10.c:215
+#: g10/g10.c:221
 msgid "add this secret keyring to the list"
 msgstr "ajouter ce porte-cls secret  la liste"
 
-#: g10/g10.c:216
+#: g10/g10.c:222
 msgid "|NAME|use NAME as default secret key"
 msgstr "|NOM|utiliser NOM comme cl secrte par dfaut"
 
-#: g10/g10.c:217
+#: g10/g10.c:223
 msgid "read options from file"
 msgstr "lire les options du fichier"
 
-#: g10/g10.c:219
+#: g10/g10.c:225
 msgid "set debugging flags"
 msgstr "choisir les attributs de dboguage"
 
-#: g10/g10.c:220
+#: g10/g10.c:226
 msgid "enable full debugging"
 msgstr "permettre un dboguage complet"
 
-#: g10/g10.c:221
+#: g10/g10.c:227
 msgid "|FD|write status info to this FD"
 msgstr "|FD|crire les informations d'tat sur ce descripteur"
 
-#: g10/g10.c:222
+#: g10/g10.c:228
 msgid "do not write comment packets"
 msgstr "ne pas crire de paquets de commentaire"
 
-#: g10/g10.c:223
+#: g10/g10.c:229
 msgid "(default is 1)"
 msgstr "(1 par dfaut)"
 
-#: g10/g10.c:224
+#: g10/g10.c:230
 msgid "(default is 3)"
 msgstr "(3 par dfaut)"
 
-#: g10/g10.c:225
+#: g10/g10.c:231
 msgid "|FILE|load extension module FILE"
 msgstr "|FICH|charger le module d'extension FICH"
 
-#: g10/g10.c:226
+#: g10/g10.c:232
 msgid "emulate the mode described in RFC1991"
 msgstr "muler le mode dcrit dans la RFC1991"
 
-#: g10/g10.c:227
+#: g10/g10.c:233
 msgid "|N|use passphrase mode N"
 msgstr "|N|utiliser le mode de mots de passe N"
 
-#: g10/g10.c:229
+#: g10/g10.c:235
 msgid "|NAME|use message digest algorithm NAME for passphrases"
 msgstr "|NOM|utiliser le hachage NOM pour les mots de passe"
 
-#: g10/g10.c:231
+#: g10/g10.c:237
 msgid "|NAME|use cipher algorithm NAME for passphrases"
 msgstr "|NOM|utiliser le cryptage NOM pour les mots de passe"
 
-#: g10/g10.c:233
+#: g10/g10.c:239
 msgid "|NAME|use cipher algorithm NAME"
 msgstr "|NOM|utiliser l'algorithme de cryptage NOM"
 
-#: g10/g10.c:234
+#: g10/g10.c:240
 msgid "|NAME|use message digest algorithm NAME"
 msgstr "|NOM|utiliser la fonction de hachage NOM"
 
-#: g10/g10.c:235
+#: g10/g10.c:241
 msgid "|N|use compress algorithm N"
 msgstr "|N|utiliser l'algorithme de compression N"
 
-#: g10/g10.c:236
+#: g10/g10.c:242
 msgid "throw keyid field of encrypted packets"
 msgstr "enlever l'identification des paquets crypts"
 
-#: g10/g10.c:244
+#: g10/g10.c:250
 msgid ""
 "@\n"
 "Examples:\n"
@@ -514,28 +518,28 @@
 " --list-keys [utilisateur]    montrer les cls\n"
 " --fingerprint [utilisateur]  montrer les empreintes\n"
 
-#: g10/g10.c:319
+#: g10/g10.c:325
 msgid "Please report bugs to <gnupg-bugs@gnu.org>.\n"
 msgstr "Rapporter toutes anomalies  <gnupg-bugs@gnu.org>.\n"
 
-#: g10/g10.c:324
+#: g10/g10.c:330
 msgid "Usage: gpgm [options] [files] (-h for help)"
 msgstr "Utilisation: gpgm [options] [fichiers] (-h pour l'aide)"
 
-#: g10/g10.c:326
+#: g10/g10.c:332
 msgid "Usage: gpg [options] [files] (-h for help)"
 msgstr "Utilisation: gpg [options] [fichiers] (-h pour l'aide)"
 
-#: g10/g10.c:331
-#, fuzzy
+#
+#: g10/g10.c:337
 msgid ""
 "Syntax: gpgm [options] [files]\n"
 "GnuPG maintenance utility\n"
 msgstr ""
 "Syntaxe: gpgm [options] [fichiers]\n"
-"utilitaire de maitenance de GNUPG\n"
+"utilitaire de maitenance de GnuPG\n"
 
-#: g10/g10.c:334
+#: g10/g10.c:340
 msgid ""
 "Syntax: gpg [options] [files]\n"
 "sign, check, encrypt or decrypt\n"
@@ -545,7 +549,7 @@
 "signer, vrifier, crypter ou dcrypter\n"
 "l'opration par dfaut dpend des donnes entres\n"
 
-#: g10/g10.c:340
+#: g10/g10.c:346
 msgid ""
 "\n"
 "Supported algorithms:\n"
@@ -553,141 +557,141 @@
 "\n"
 "Algorithmes supports:\n"
 
-#: g10/g10.c:415
+#: g10/g10.c:421
 msgid "usage: gpgm [options] "
 msgstr "utilisation: gpgm [options] "
 
-#: g10/g10.c:417
+#: g10/g10.c:423
 msgid "usage: gpg [options] "
 msgstr "utilisation: gpg [options] "
 
-#: g10/g10.c:458
+#: g10/g10.c:464
 msgid "conflicting commands\n"
 msgstr "commandes en conflit\n"
 
-#: g10/g10.c:596
+#: g10/g10.c:602
 #, c-format
 msgid "note: no default option file '%s'\n"
 msgstr "note: pas de fichier d'options par dfaut '%s'\n"
 
-#: g10/g10.c:600
+#: g10/g10.c:606
 #, c-format
 msgid "option file '%s': %s\n"
 msgstr "fichier d'options '%s' : %s\n"
 
-#: g10/g10.c:607
+#: g10/g10.c:613
 #, c-format
 msgid "reading options from '%s'\n"
 msgstr "lire les options de '%s'\n"
 
-#: g10/g10.c:778 g10/g10.c:790
+#: g10/g10.c:787 g10/g10.c:799
 msgid "selected cipher algorithm is invalid\n"
 msgstr "l'algorithme de cryptage slectionn est invalide\n"
 
-#: g10/g10.c:784 g10/g10.c:796
+#: g10/g10.c:793 g10/g10.c:805
 msgid "selected digest algorithm is invalid\n"
 msgstr "la fonction de hachage slectionne est invalide\n"
 
-#: g10/g10.c:799
+#: g10/g10.c:808
 #, c-format
 msgid "compress algorithm must be in range %d..%d\n"
 msgstr "l'algorithme de compression doit faire partie de l'chelle %d..%d\n"
 
-#: g10/g10.c:801
+#: g10/g10.c:810
 msgid "completes-needed must be greater than 0\n"
 msgstr "le nombre de signatures compltes minimal doit tre suprieur  0\n"
 
-#: g10/g10.c:803
+#: g10/g10.c:812
 msgid "marginals-needed must be greater than 1\n"
 msgstr "le nombre de singatures marginales minimal doit tre suprieur  1\n"
 
-#: g10/g10.c:806
+#: g10/g10.c:815
 msgid "note: simple S2K mode (0) is strongly discouraged\n"
 msgstr "note: le mode S2K simple (0) est fortement dconseill\n"
 
-#: g10/g10.c:810
+#: g10/g10.c:819
 msgid "invalid S2K mode; must be 0, 1 or 3\n"
 msgstr "mode S2K invalide; doit tre 0, 1 ou 3\n"
 
-#: g10/g10.c:886
+#: g10/g10.c:895
 #, c-format
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr "n'a pas pu initialiser la base de confiance: %s\n"
 
-#: g10/g10.c:892
+#: g10/g10.c:901
 msgid "--store [filename]"
 msgstr "--store [nom du fichier]"
 
-#: g10/g10.c:900
+#: g10/g10.c:909
 msgid "--symmetric [filename]"
 msgstr "--symmetric [nom du fichier]"
 
-#: g10/g10.c:908
+#: g10/g10.c:917
 msgid "--encrypt [filename]"
 msgstr "--encrypt [nom du fichier]"
 
-#: g10/g10.c:921
+#: g10/g10.c:930
 msgid "--sign [filename]"
 msgstr "--sign [nom du fichier]"
 
-#: g10/g10.c:934
+#: g10/g10.c:943
 msgid "--sign --encrypt [filename]"
 msgstr "--sign --encrypt [nom du fichier]"
 
-#: g10/g10.c:948
+#: g10/g10.c:957
 msgid "--clearsign [filename]"
 msgstr "--clearsign [nom du fichier]"
 
-#: g10/g10.c:960
+#: g10/g10.c:969
 msgid "--decrypt [filename]"
 msgstr "--decrypt [nom du fichier]"
 
-#: g10/g10.c:969
+#: g10/g10.c:978
 msgid "--edit-key username"
 msgstr "--edit-key utilisateur"
 
-#: g10/g10.c:977
+#: g10/g10.c:986
 msgid "--delete-secret-key username"
 msgstr "--delete-secret-key utilisateur"
 
-#: g10/g10.c:980
+#: g10/g10.c:989
 msgid "--delete-key username"
 msgstr "--delete-key utilisateur"
 
-#: g10/encode.c:215 g10/g10.c:1003 g10/keylist.c:80
+#: g10/encode.c:216 g10/g10.c:1012
 #, c-format
 msgid "can't open %s: %s\n"
 msgstr "ne peut ouvrir %s: %s\n"
 
-#: g10/g10.c:1014
+#: g10/g10.c:1023
 msgid "-k[v][v][v][c] [userid] [keyring]"
 msgstr "-k[v][v][v][c] [utilisateur] [porte-cls]"
 
-#: g10/g10.c:1069
+#: g10/g10.c:1079
 #, c-format
 msgid "dearmoring failed: %s\n"
 msgstr "suppression d'armure non russie: %s\n"
 
-#: g10/g10.c:1077
+#: g10/g10.c:1087
 #, c-format
 msgid "enarmoring failed: %s\n"
 msgstr "mise d'armure non russie:%s \n"
 
-#: g10/g10.c:1138
+#: g10/g10.c:1148
 #, c-format
 msgid "invalid hash algorithm '%s'\n"
 msgstr "algorithme de hachage invalide '%s'\n"
 
-#: g10/g10.c:1220
+#: g10/g10.c:1230
 msgid "[filename]"
 msgstr "[nom du fichier]"
 
-#: g10/decrypt.c:59 g10/g10.c:1222 g10/verify.c:66
+#: g10/decrypt.c:59 g10/g10.c:1232 g10/verify.c:66
 #, c-format
 msgid "can't open '%s'\n"
 msgstr "ne peut ouvrir '%s'\n"
 
-#: g10/g10.c:1269
+#: g10/g10.c:1279
 msgid ""
 "RSA keys are deprecated; please consider creating a new key and use this key "
 "in the future\n"
@@ -1100,7 +1104,7 @@
 msgid "Is this correct (y/n)? "
 msgstr "Est-ce correct (o/n)? "
 
-#: g10/keygen.c:561
+#: g10/keygen.c:569
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user "
@@ -1116,51 +1120,51 @@
 "   \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de\"\n"
 "\n"
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "keygen.name"
 msgstr ""
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "Real name: "
 msgstr "Nom: "
 
-#: g10/keygen.c:576
+#: g10/keygen.c:584
 msgid "Invalid character in name\n"
 msgstr "Caractre invalide dans le nom\n"
 
-#: g10/keygen.c:578
+#: g10/keygen.c:586
 msgid "Name may not start with a digit\n"
 msgstr "Le nom ne doit pas commencer avec un chiffre\n"
 
-#: g10/keygen.c:580
+#: g10/keygen.c:588
 msgid "Name must be at least 5 characters long\n"
 msgstr "Le nom doit faire au moins 5 caractres de long\n"
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "keygen.email"
 msgstr ""
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "Email address: "
 msgstr "Adresse e-mail: "
 
-#: g10/keygen.c:600
+#: g10/keygen.c:608
 msgid "Not a valid email address\n"
 msgstr "Ce n'est pas une adresse e-mail valide\n"
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "keygen.comment"
 msgstr ""
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "Comment: "
 msgstr "Commentaire: "
 
-#: g10/keygen.c:614
+#: g10/keygen.c:622
 msgid "Invalid character in comment\n"
 msgstr "Caractre invalide dans le commentaire\n"
 
-#: g10/keygen.c:634
+#: g10/keygen.c:642
 #, c-format
 msgid ""
 "You selected this USER-ID:\n"
@@ -1171,11 +1175,11 @@
 "    \"%s\"\n"
 "\n"
 
-#: g10/keygen.c:637
+#: g10/keygen.c:645
 msgid "NnCcEeOoQq"
 msgstr "NnCcEeOoQq"
 
-#: g10/keygen.c:646
+#: g10/keygen.c:654
 msgid "keygen.userid.cmd"
 msgstr ""
 "N pour changer le nom.\n"
@@ -1184,11 +1188,11 @@
 "O pour continuer  gnrer la cl.\n"
 "Q pour arrter de gnrer de cl."
 
-#: g10/keygen.c:647
+#: g10/keygen.c:655
 msgid "Change (N)ame, (C)omment, (E)mail or (O)kay/(Q)uit? "
 msgstr "Changer le (N)om, le (C)ommentaire, l'(E)-mail ou (O)K/(Q)uitter? "
 
-#: g10/keygen.c:694
+#: g10/keygen.c:707
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
@@ -1196,11 +1200,11 @@
 "Vous avez besoin d'un mot de passe pour protger votre cl secrte.\n"
 "\n"
 
-#: g10/keyedit.c:389 g10/keygen.c:702
+#: g10/keyedit.c:389 g10/keygen.c:715
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr "le mot de passe n'a pas t correctement rpt; recommencez.\n"
 
-#: g10/keygen.c:708
+#: g10/keygen.c:721
 msgid ""
 "You don't want a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at any time,\n"
@@ -1212,7 +1216,7 @@
 "le dsirez, en utilisant ce programme avec l'option \"--edit-key\".\n"
 "\n"
 
-#: g10/keygen.c:729
+#: g10/keygen.c:742
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -1225,33 +1229,33 @@
 "premiers; cela permet au gnrateur de nombres alatoires de gagner assez\n"
 "d'entropie plus facilement.\n"
 
-#: g10/keygen.c:799
+#: g10/keygen.c:812
 msgid "Key generation can only be used in interactive mode\n"
 msgstr "La gnration de cl ne peut tre faite qu'en mode interactif\n"
 
-#: g10/keygen.c:807
+#: g10/keygen.c:820
 msgid "DSA keypair will have 1024 bits.\n"
 msgstr "La paire de cls DSA fera 1024 bits.\n"
 
-#: g10/keygen.c:813
+#: g10/keygen.c:826
 msgid "Key generation cancelled.\n"
 msgstr "La gnration a t annule.\n"
 
-#: g10/keygen.c:823
+#: g10/keygen.c:836
 #, c-format
 msgid "writing public certificate to '%s'\n"
 msgstr "criture d'un certificat public  '%s'\n"
 
-#: g10/keygen.c:824
+#: g10/keygen.c:837
 #, c-format
 msgid "writing secret certificate to '%s'\n"
 msgstr "criture d'un certificat secret  '%s'\n"
 
-#: g10/keygen.c:901
+#: g10/keygen.c:914
 msgid "public and secret key created and signed.\n"
 msgstr "les cls publique et secrte ont t cres et signes.\n"
 
-#: g10/keygen.c:903
+#: g10/keygen.c:916
 msgid ""
 "Note that this key cannot be used for encryption.  You may want to use\n"
 "the command \"--add-key\" to generate a secondary key for this purpose.\n"
@@ -1260,20 +1264,20 @@
 "utiliser\n"
 "la commande \"--add-key\" pour gnrer une cl secondaire  cette fin.\n"
 
-#: g10/keygen.c:917 g10/keygen.c:1002
+#: g10/keygen.c:930 g10/keygen.c:1015
 #, c-format
 msgid "Key generation failed: %s\n"
 msgstr "La gnration de cl a chou: %s\n"
 
-#: g10/keygen.c:979
+#: g10/keygen.c:992
 msgid "keygen.sub.okay"
 msgstr "Rpondez \"oui\" (ou simplement \"o\") pour gnrer la sous-cl"
 
-#: g10/keygen.c:980
+#: g10/keygen.c:993
 msgid "Really create? "
 msgstr "Crer vraiment? "
 
-#: g10/encode.c:88
+#: g10/encode.c:88 g10/openfile.c:81 g10/openfile.c:158
 #, c-format
 msgid "%s: can't open: %s\n"
 msgstr "%s: ne peut ouvrir: %s\n"
@@ -1283,230 +1287,288 @@
 msgid "error creating passphrase: %s\n"
 msgstr "erreur pendant la cration du mot de passe: %s\n"
 
-#: g10/encode.c:154 g10/encode.c:267
+#: g10/encode.c:155 g10/encode.c:269
 #, c-format
 msgid "%s: warning: empty file\n"
 msgstr "%s: attention: fichier vide\n"
 
-#: g10/encode.c:221
+#: g10/encode.c:222
 #, c-format
 msgid "reading from '%s'\n"
 msgstr "lecture de '%s'\n"
 
-#: g10/encode.c:395
+#: g10/encode.c:397
 #, c-format
 msgid "%s encrypted for: %s\n"
 msgstr "%s crypt pour: %s\n"
 
-#: g10/getkey.c:854
+#: g10/getkey.c:950
 #, c-format
 msgid "using secondary key %08lX instead of primary key %08lX\n"
 msgstr ""
 "utilisation de la cl secondaire %08lX  la place de la cl\n"
 "principale %08lX\n"
 
-#: g10/import.c:106 g10/trustdb.c:1100
+#: g10/import.c:125 g10/trustdb.c:1046
 #, c-format
 msgid "can't open file: %s\n"
 msgstr "ne peut ouvrir le fichier: %s\n"
 
-#: g10/import.c:122
+#: g10/import.c:141
 #, c-format
 msgid "skipping block of type %d\n"
 msgstr "ne prend pas en compte le bloc du type %d\n"
 
-#: g10/import.c:132 g10/trustdb.c:1175
+#: g10/import.c:148 g10/trustdb.c:1289 g10/trustdb.c:1358
+#, c-format
+msgid "%lu keys so far processed\n"
+msgstr "%lu cls traites jusqu'ici\n"
+
+#: g10/import.c:153 g10/trustdb.c:1122
 #, c-format
 msgid "read error: %s\n"
 msgstr "erreur de lecture: %s\n"
 
-#: g10/import.c:273 g10/import.c:446
+#: g10/import.c:155
+#, c-format
+msgid "Total number processed: %lu\n"
+msgstr "       Quantit totale traite: %lu\n"
+
+#: g10/import.c:157
+#, c-format
+msgid "          w/o user IDs: %lu\n"
+msgstr "        sans nom d'utilisateur: %lu\n"
+
+#: g10/import.c:159
+#, c-format
+msgid "              imported: %lu"
+msgstr "                       import: %lu"
+
+#: g10/import.c:165
+#, c-format
+msgid "             unchanged: %lu\n"
+msgstr "                      inchang: %lu\n"
+
+#: g10/import.c:167
+#, c-format
+msgid "          new user IDs: %lu\n"
+msgstr "   nouveaux noms d'utilisateur: %lu\n"
+
+#: g10/import.c:169
+#, c-format
+msgid "           new subkeys: %lu\n"
+msgstr "           nouvelles sous-cls: %lu\n"
+
+#: g10/import.c:171
+#, c-format
+msgid "        new signatures: %lu\n"
+msgstr "          nouvelles signatures: %lu\n"
+
+#: g10/import.c:173
+#, c-format
+msgid "   new key revocations: %lu\n"
+msgstr " nouvelles rvocations de cls: %lu\n"
+
+#: g10/import.c:175
+#, c-format
+msgid "      secret keys read: %lu\n"
+msgstr "            cls secrtes lues: %lu\n"
+
+#: g10/import.c:177
+#, c-format
+msgid "  secret keys imported: %lu\n"
+msgstr "       cls secrtes importes: %lu\n"
+
+#: g10/import.c:179
+#, c-format
+msgid " secret keys unchanged: %lu\n"
+msgstr "      cls secrtes inchanges: %lu\n"
+
+#: g10/import.c:321 g10/import.c:513
 #, c-format
 msgid "key %08lX: no user id\n"
 msgstr "cl %08lX: pas de nom d'utilisateur\n"
 
-#: g10/import.c:283
+#: g10/import.c:332
 #, c-format
 msgid "key %08lX: no valid user ids\n"
 msgstr "cl %08lX: pas de nom d'utilisateur valide\n"
 
-#: g10/import.c:285
+#: g10/import.c:334
 msgid "this may be caused by a missing self-signature\n"
 msgstr "cela peut provenir d'une auto-signature manquante\n"
 
-#: g10/import.c:294 g10/import.c:512
+#: g10/import.c:345 g10/import.c:581
 #, c-format
 msgid "key %08lX: public key not found: %s\n"
 msgstr "cl %08lX: cl publique pas trouve: %s\n"
 
-#: g10/import.c:300
+#: g10/import.c:351
 msgid "no default public keyring\n"
 msgstr "pas de porte-cls public par dfaut\n"
 
-#: g10/import.c:304
+#: g10/import.c:355 g10/openfile.c:105
 #, c-format
 msgid "writing to '%s'\n"
 msgstr "criture de '%s'\n"
 
-#: g10/import.c:308 g10/import.c:363 g10/import.c:566
+#: g10/import.c:359 g10/import.c:419 g10/import.c:635
 #, c-format
 msgid "can't lock public keyring: %s\n"
 msgstr "ne peut verrouiller le porte-cls public: %s\n"
 
-#: g10/import.c:311
+#: g10/import.c:362
 #, c-format
 msgid "can't write to keyring: %s\n"
 msgstr "ne peut crire sur le porte-cls: %s\n"
 
-#. we are ready
-#: g10/import.c:314
+#: g10/import.c:366
 #, c-format
 msgid "key %08lX: public key imported\n"
 msgstr "cl %08lX: cl publique importe\n"
 
-#: g10/import.c:323
+#: g10/import.c:379
 #, c-format
 msgid "key %08lX: doesn't match our copy\n"
 msgstr "cl %08lX: ne vrifie pas notre copie\n"
 
-#: g10/import.c:336 g10/import.c:521
+#: g10/import.c:392 g10/import.c:590
 #, c-format
 msgid "key %08lX: can't locate original keyblock: %s\n"
 msgstr "cl %08lX: ne peut trouver le bloc de cls original: %s\n"
 
-#: g10/import.c:343 g10/import.c:528
+#: g10/import.c:399 g10/import.c:597
 #, c-format
 msgid "key %08lX: can't read original keyblock: %s\n"
 msgstr "cl %08lX: ne peut lire le bloc de cls original: %s\n"
 
-#: g10/import.c:360 g10/import.c:461 g10/import.c:563
+#: g10/import.c:416 g10/import.c:528 g10/import.c:632
 msgid "writing keyblock\n"
 msgstr "criture du bloc de cls\n"
 
-#: g10/import.c:366 g10/import.c:569
+#: g10/import.c:422 g10/import.c:638
 #, c-format
 msgid "can't write keyblock: %s\n"
 msgstr "ne peut crire le bloc de cls: %s\n"
 
-#: g10/import.c:370
+#: g10/import.c:427
 #, c-format
 msgid "key %08lX: 1 new user-id\n"
 msgstr "cl %08lX: un nouvel utilisateur\n"
 
-#: g10/import.c:373
+#: g10/import.c:430
 #, c-format
 msgid "key %08lX: %d new user-ids\n"
 msgstr "cl %08lX: %d nouveaux utilisateurs\n"
 
-#: g10/import.c:376
+#: g10/import.c:433
 #, c-format
 msgid "key %08lX: 1 new signature\n"
 msgstr "cl %08lX: une nouvelle signature\n"
 
-#: g10/import.c:379
+#: g10/import.c:436
 #, c-format
 msgid "key %08lX: %d new signatures\n"
 msgstr "cl %08lX: %d nouvelles signatures\n"
 
-#: g10/import.c:382
+#: g10/import.c:439
 #, c-format
 msgid "key %08lX: 1 new subkey\n"
 msgstr "cl %08lX: une nouvelle sous-cl\n"
 
-#: g10/import.c:385
+#: g10/import.c:442
 #, c-format
 msgid "key %08lX: %d new subkeys\n"
 msgstr "cl %08lX: %d nouvelles sous-cls\n"
 
-#: g10/import.c:389
+#: g10/import.c:452
 #, c-format
 msgid "key %08lX: not changed\n"
 msgstr "cl %08lX: n'a pas chang\n"
 
-#: g10/import.c:464
+#: g10/import.c:531
 #, c-format
 msgid "can't lock secret keyring: %s\n"
 msgstr "ne peut verrouiller le porte-cls secret: %s\n"
 
-#: g10/import.c:467
+#: g10/import.c:534
 #, c-format
 msgid "can't write keyring: %s\n"
 msgstr "ne peut crire le porte-cls: %s\n"
 
 #. we are ready
-#: g10/import.c:470
+#: g10/import.c:537
 #, c-format
 msgid "key %08lX: secret key imported\n"
 msgstr "cl %08lX: cl secrte importe\n"
 
 #. we can't merge secret keys
-#: g10/import.c:473
+#: g10/import.c:541
 #, c-format
 msgid "key %08lX: already in secret keyring\n"
 msgstr "cl %08lX: dj dans le porte-cls secret\n"
 
-#: g10/import.c:477
+#: g10/import.c:546
 #, c-format
 msgid "key %08lX: secret key not found: %s\n"
 msgstr "cl %08lX: cl secrte pas trouve: %s\n"
 
-#: g10/import.c:506
+#: g10/import.c:575
 #, c-format
 msgid "key %08lX: no public key - can't apply revocation certificate\n"
 msgstr ""
 "cl %08lX: pas de cl publique - ne peut appliquer le certificat de\n"
 "rvocation\n"
 
-#: g10/import.c:539
+#: g10/import.c:608
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - rejected\n"
 msgstr "cl %08lX: certificat de rvocation invalide: %s - rejet\n"
 
-#. we are ready
-#: g10/import.c:572
+#: g10/import.c:642
 #, c-format
 msgid "key %08lX: revocation certificate imported\n"
 msgstr "cl %08lX: certificat de rvocation import\n"
 
-#: g10/import.c:602
+#: g10/import.c:673
 #, c-format
 msgid "key %08lX: no user-id for signature\n"
 msgstr "cl %08lX: pas d'utilisateur pour la signature\n"
 
-#: g10/import.c:609
+#: g10/import.c:680
 #, c-format
 msgid "key %08lX: unsupported public key algorithm\n"
 msgstr "cl %08lX: algorithme de cl publique non support\n"
 
-#: g10/import.c:610
+#: g10/import.c:681
 #, c-format
 msgid "key %08lX: invalid self-signature\n"
 msgstr "cl %08lX: auto-signature invalide\n"
 
-#: g10/import.c:639
+#: g10/import.c:710
 #, c-format
 msgid "key %08lX: skipped userid '"
 msgstr "cl %08lX: utilisateur non pris en compte '"
 
-#: g10/import.c:662
+#: g10/import.c:733
 #, c-format
 msgid "key %08lX: revocation certificate at wrong place - skipped\n"
 msgstr ""
 "cl %08lX: certificat de rvocation au mauvais endroit - non prise en "
 "compte\n"
 
-#: g10/import.c:670
+#: g10/import.c:741
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - skipped\n"
 msgstr ""
 "cl %08lX: certificat de rvocation invalide: %s - non prise en compte\n"
 
-#: g10/import.c:732
+#: g10/import.c:803
 #, c-format
 msgid "key %08lX: revocation certificate added\n"
 msgstr "cl %08lX: certificat de rvocation ajout\n"
 
-#: g10/import.c:795 g10/import.c:831
+#: g10/import.c:866 g10/import.c:902
 #, c-format
 msgid "key %08lX: our copy has no self-signature\n"
 msgstr "cl %08lX: notre copie n'a pas d'auto-signature\n"
@@ -1748,14 +1810,12 @@
 msgstr "enlever une cl secondaire"
 
 #: g10/keyedit.c:508
-#, fuzzy
 msgid "expire"
-msgstr "prf"
+msgstr "expire"
 
 #: g10/keyedit.c:508
-#, fuzzy
 msgid "change the expire date"
-msgstr "changer le mot de passe"
+msgstr "changer la date d'expiration"
 
 #: g10/keyedit.c:509
 msgid "toggle"
@@ -1803,164 +1863,163 @@
 msgid "Secret key is available.\n"
 msgstr "La cl secrte est disponible.\n"
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 msgid "keyedit.cmd"
 msgstr "Entrez \"aide\" s'il vous plat."
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 msgid "Command> "
 msgstr "Commande> "
 
-#: g10/keyedit.c:600
+#: g10/keyedit.c:602
 msgid "Need the secret key to to this.\n"
 msgstr "Il faut la cl secrte pour faire cela.\n"
 
-#: g10/keyedit.c:619
+#: g10/keyedit.c:621
 msgid "keyedit.save.okay"
 msgstr ""
 
-#: g10/keyedit.c:620
+#: g10/keyedit.c:622
 msgid "Save changes? "
 msgstr "Enregistrer les changements? "
 
-#: g10/keyedit.c:622
+#: g10/keyedit.c:624
 msgid "keyedit.cancel.okay"
 msgstr ""
 
-#: g10/keyedit.c:623
+#: g10/keyedit.c:625
 msgid "Quit without saving? "
 msgstr "Quitter sans enregistrer? "
 
-#: g10/keyedit.c:633
+#: g10/keyedit.c:635
 #, c-format
 msgid "update failed: %s\n"
 msgstr "la mise  jour a chou: %s\n"
 
-#: g10/keyedit.c:640
+#: g10/keyedit.c:642
 #, c-format
 msgid "update secret failed: %s\n"
 msgstr "la mise  jour de la cl secrte a chou: %s\n"
 
-#: g10/keyedit.c:647
+#: g10/keyedit.c:649
 msgid "Key not changed so no update needed.\n"
 msgstr "La cl n'a pas chang donc la mise  jour est inutile.\n"
 
-#: g10/keyedit.c:650 g10/keyedit.c:708
+#: g10/keyedit.c:652 g10/keyedit.c:710
 #, c-format
 msgid "update of trust db failed: %s\n"
 msgstr "la mise  jour de la base de confiance a chou: %s\n"
 
-#: g10/keyedit.c:681
+#: g10/keyedit.c:683
 msgid "keyedit.sign_all.okay"
 msgstr ""
 
-#: g10/keyedit.c:682
+#: g10/keyedit.c:684
 msgid "Really sign all user ids? "
 msgstr "Signer vraiment tous les utilisateurs? "
 
-#: g10/keyedit.c:683
+#: g10/keyedit.c:685
 msgid "Hint: Select the user ids to sign\n"
 msgstr "Aide: Slectionner les utilisateurs  signer\n"
 
-#: g10/keyedit.c:719
+#: g10/keyedit.c:721
 msgid "You must select at least one user id.\n"
 msgstr "Vous devez slectionner au moins un utilisateur.\n"
 
-#: g10/keyedit.c:721
+#: g10/keyedit.c:723
 msgid "You can't delete the last user id!\n"
 msgstr "Vous ne pouvez pas supprimer le dernier utilisateur!\n"
 
-#: g10/keyedit.c:723
+#: g10/keyedit.c:725
 msgid "keyedit.remove.uid.okay"
 msgstr ""
 
-#: g10/keyedit.c:724
+#: g10/keyedit.c:726
 msgid "Really remove all selected user ids? "
 msgstr "Enlever rellement tous les utilisateurs slectionns? "
 
-#: g10/keyedit.c:725
+#: g10/keyedit.c:727
 msgid "Really remove this user id? "
 msgstr "Enlever rellement cet utilisateur? "
 
-#: g10/keyedit.c:748
+#: g10/keyedit.c:750
 msgid "You must select at least one key.\n"
 msgstr "Vous devez slectionner au moins une cl.\n"
 
-#: g10/keyedit.c:750
+#: g10/keyedit.c:752
 msgid "keyedit.remove.subkey.okay"
 msgstr ""
 
-#: g10/keyedit.c:752
+#: g10/keyedit.c:754
 msgid "Do you really want to delete the selected keys? "
 msgstr "Voulez-vous supprimer les cls slectionnes? "
 
-#: g10/keyedit.c:753
+#: g10/keyedit.c:755
 msgid "Do you really want to delete this key? "
 msgstr "Voulez-vous vraiment supprimer cette cl? "
 
-#: g10/keyedit.c:800
+#: g10/keyedit.c:802
 msgid "Invalid command  (try \"help\")\n"
 msgstr "Commande invalide  (essayez \"help\")\n"
 
-#: g10/keyedit.c:1178
+#: g10/keyedit.c:1180
 msgid "Please remove selections from the secret keys.\n"
-msgstr ""
+msgstr "Enlevez les slections des cls secrtes.\n"
 
-#: g10/keyedit.c:1184
-#, fuzzy
+#: g10/keyedit.c:1186
 msgid "Please select at most one secondary key.\n"
-msgstr "Vous devez slectionner au moins une cl.\n"
+msgstr "Vous devez slectionner au plus une cl secondaire.\n"
 
-#: g10/keyedit.c:1188
+#: g10/keyedit.c:1190
 msgid "Changing exiration time for a secondary key.\n"
-msgstr ""
+msgstr "Changer la date d'expiration d'une cl secondaire.\n"
 
-#: g10/keyedit.c:1190
+#: g10/keyedit.c:1192
 msgid "Changing exiration time for the primary key.\n"
-msgstr ""
+msgstr "Changer la date d'expiration de la cl primaire.\n"
 
-#: g10/keyedit.c:1234
+#: g10/keyedit.c:1236
 msgid "No corresponding signature in secret ring\n"
-msgstr ""
+msgstr "Pas de signature correspondante dans le porte-cls secret\n"
 
-#: g10/keyedit.c:1294
+#: g10/keyedit.c:1296
 #, c-format
 msgid "No user id with index %d\n"
 msgstr "Pas d'utilisateur avec l'index %d\n"
 
-#: g10/keyedit.c:1339
+#: g10/keyedit.c:1341
 #, c-format
 msgid "No secondary key with index %d\n"
 msgstr "Pas de cl secondaire avec l'index %d\n"
 
-#: g10/mainproc.c:200
+#: g10/mainproc.c:201
 #, c-format
 msgid "public key decryption failed: %s\n"
 msgstr "le dcryptage de la cl publique a chou: %s\n"
 
-#: g10/mainproc.c:230
+#: g10/mainproc.c:231
 #, c-format
 msgid "decryption failed: %s\n"
 msgstr "le dcryptage a chou: %s\n"
 
-#: g10/mainproc.c:247
+#: g10/mainproc.c:248
 msgid "note: sender requested \"for-your-eyes-only\"\n"
 msgstr "note: l'expditeur a demand \"pour vos yeux seulement\"\n"
 
-#: g10/mainproc.c:848
+#: g10/mainproc.c:842
 #, c-format
 msgid "Signature made %.*s using %s key ID %08lX\n"
 msgstr "Signature faite %.*s avec %s cl ID %08lX\n"
 
-#: g10/mainproc.c:856
+#: g10/mainproc.c:850
 msgid "BAD signature from \""
 msgstr "MAUVAISE signature de \""
 
-#: g10/mainproc.c:857
+#: g10/mainproc.c:851
 msgid "Good signature from \""
 msgstr "Bonne signature de \""
 
-#: g10/mainproc.c:868
+#: g10/mainproc.c:862
 #, c-format
 msgid "Can't check signature: %s\n"
 msgstr "Ne peut vrifier la signature: %s\n"
@@ -2049,193 +2108,246 @@
 msgid "warning: signature key expired %s\n"
 msgstr "attention: la cl de signature a expir le %s\n"
 
-#: g10/trustdb.c:122
+#: g10/trustdb.c:129
 msgid "The trust DB is corrupted; please run \"gpgm --fix-trust-db\".\n"
 msgstr ""
 "La base de confiance est corrompue; excutez \"gpgm --fix-trust-db\".\n"
 
-#: g10/trustdb.c:389
+#: g10/trustdb.c:407
 #, c-format
 msgid "chained sigrec %lu has a wrong owner\n"
 msgstr "l'enregistrement de signature %lu a un mauvais propritaire\n"
 
-#: g10/trustdb.c:436
-#, fuzzy, c-format
+#: g10/trustdb.c:454
+#, c-format
 msgid "key %08lX: secret key without public key - skipped\n"
-msgstr "cl %08lX: cl secrte sans cl publique\n"
+msgstr "cl %08lX: cl secrte sans cl publique - non prise en compte\n"
 
-#: g10/trustdb.c:442
+#: g10/trustdb.c:460
 #, c-format
 msgid "key %08lX: secret and public key don't match\n"
 msgstr "cl %08lX: les cls secrte et publique ne correspondent pas\n"
 
-#: g10/trustdb.c:452
+#: g10/trustdb.c:470
 #, c-format
 msgid "key %08lX: can't put it into the trustdb\n"
 msgstr "cl %08lX: ne peut mettre cela dans la base de confiance\n"
 
-#: g10/trustdb.c:458
+#: g10/trustdb.c:476
 #, c-format
 msgid "key %08lX: query record failed\n"
 msgstr "cl %08lX: l'enregistrement de requte a chou\n"
 
-#: g10/trustdb.c:467
-#, fuzzy, c-format
+#: g10/trustdb.c:485
+#, c-format
 msgid "key %08lX: already in secret key table\n"
-msgstr "cl %08lX: dj dans le porte-cls secret\n"
+msgstr "cl %08lX: dj dans la table des cls secrtes\n"
 
-#: g10/trustdb.c:470
-#, fuzzy, c-format
+#: g10/trustdb.c:488
+#, c-format
 msgid "key %08lX: accepted as secret key.\n"
-msgstr "cl %08lX: dj dans le porte-cls secret\n"
+msgstr "cl %08lX: accepte comme cl secrte.\n"
 
-#: g10/trustdb.c:477
+#: g10/trustdb.c:495
 #, c-format
 msgid "enum_secret_keys failed: %s\n"
 msgstr "enum_secret_keys a chou: %s\n"
 
-#: g10/trustdb.c:1428
+#: g10/trustdb.c:1292 g10/trustdb.c:1360
+#, c-format
+msgid "%lu keys processed\n"
+msgstr "%lu cls traites\n"
+
+#: g10/trustdb.c:1294
+#, c-format
+msgid "\t%lu keys skipped\n"
+msgstr "\t%lu cls non prises en compte\n"
+
+#: g10/trustdb.c:1296 g10/trustdb.c:1362
+#, c-format
+msgid "\t%lu keys with errors\n"
+msgstr "\t%lu cls avec erreurs\n"
+
+#: g10/trustdb.c:1298 g10/trustdb.c:1364
+#, c-format
+msgid "\t%lu keys updated\n"
+msgstr "\t%lu cls mises  jour\n"
+
+#: g10/trustdb.c:1366
+#, c-format
+msgid "\t%lu keys inserted\n"
+msgstr "\t%lu cls insres\n"
+
+#: g10/trustdb.c:1421
 #, c-format
 msgid "key %08lX: insert trust record failed: %s\n"
 msgstr "cl %08lX: l'insertion d'enregistrement de confiance a chou: %s\n"
 
-#: g10/trustdb.c:1432
+#: g10/trustdb.c:1425
 #, c-format
 msgid "key %08lX.%lu: inserted into trustdb\n"
 msgstr "cl %08lX.%lu: insre dans la base de confiance\n"
 
-#: g10/trustdb.c:1440
+#: g10/trustdb.c:1433
 #, c-format
 msgid "key %08lX.%lu: created in future (time warp or clock problem)\n"
 msgstr "cl %08lX.%lu: cre dans le futur (problme d'horloge)\n"
 
-#: g10/trustdb.c:1447
+#: g10/trustdb.c:1440
 #, c-format
 msgid "key %08lX.%lu: expired at %s\n"
 msgstr "cl %08lX.%lu: a expir le %s\n"
 
-#: g10/trustdb.c:1455
+#: g10/trustdb.c:1448
 #, c-format
 msgid "key %08lX.%lu: trust check failed: %s\n"
 msgstr "cl %08lX.%lu: la vrification de confiance a chou: %s\n"
 
-#: g10/trustdb.c:1718
+#: g10/trustdb.c:1666
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but marked as checked\n"
 msgstr ""
+"note: enregistrement de signature %lu[%d] dans la liste d'aide de %lu mais\n"
+"mais marqu comme vrifi\n"
 
-#: g10/trustdb.c:1722
+#: g10/trustdb.c:1670
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but not marked\n"
 msgstr ""
+"note: enregistrement de signature %lu[%d] dans la liste d'aide de %lu mais\n"
+"non marqu\n"
 
 #. we need the dir record
-#: g10/trustdb.c:1729
-#, c-format
-msgid "sig rec %lu[%d] in hintlist of %u does not point to a dir record\n"
+#: g10/trustdb.c:1677
+#, fuzzy, c-format
+msgid "sig rec %lu[%d] in hintlist of %lu does not point to a dir record\n"
 msgstr ""
+"l'enregistrement de signature %lu[%d] dans la liste d'aide de %u ne pointe\n"
+"pas vers un enregistrement de rpertoire\n"
 
-#: g10/trustdb.c:1735
+#: g10/trustdb.c:1683
 #, c-format
 msgid "lid %lu: no primary key\n"
-msgstr ""
+msgstr "lid %lu: pas de cl primaire\n"
 
-#: g10/trustdb.c:1764
-#, fuzzy, c-format
+#: g10/trustdb.c:1716
+#, c-format
 msgid "lid %lu: user id not found in keyblock\n"
-msgstr "%s: utilisateur non trouv\n"
+msgstr "lid %lu: utilisateur non trouv dans le bloc de cls\n"
+
+#: g10/trustdb.c:1720
+#, c-format
+msgid "lid %lu: user id without signature\n"
+msgstr "lid %lu: utilisateur sans signature\n"
 
-#: g10/trustdb.c:1771
+#: g10/trustdb.c:1727
 #, c-format
 msgid "lid %lu: self-signature in hintlist\n"
-msgstr ""
+msgstr "lid %lu: auto-signature dans la liste d'aide\n"
 
-#: g10/trustdb.c:1776
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (3)\n"
-msgstr "cl %08lXi.%lu, uid %02X%02X: %ssignature invalide: %s\n"
+#: g10/trustdb.c:1738 g10/trustdb.c:2444 g10/trustdb.c:2526
+#, fuzzy
+msgid "Valid certificate revocation"
+msgstr "Mauvais certificat"
 
-#: g10/trustdb.c:1783
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: very strange: no public key\n"
-msgstr ""
-"cl %08lX.%lu, uid %02X%02X: pas de cl publique pour la signature %08lX\n"
+#: g10/trustdb.c:1739 g10/trustdb.c:2445 g10/trustdb.c:2527
+#, fuzzy
+msgid "Good certificate"
+msgstr "Mauvais certificat"
 
-#: g10/trustdb.c:1790 g10/trustdb.c:2225 g10/trustdb.c:2297
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: invalid signature: %s\n"
-msgstr "cl %08lXi.%lu, uid %02X%02X: %ssignature invalide: %s\n"
+#: g10/trustdb.c:1748
+msgid "very strange: no public key\n"
+msgstr ""
 
-#: g10/trustdb.c:1835
+#: g10/trustdb.c:1796
 #, c-format
 msgid "hintlist %lu[%d] of %lu does not point to a dir record\n"
 msgstr ""
+"la liste d'aide de %lu[%d] de %lu ne pointe pas vers un enregistrement\n"
+"de rpertoire\n"
 
-#: g10/trustdb.c:1841
+#: g10/trustdb.c:1802
 #, c-format
 msgid "lid %lu does not have a key\n"
-msgstr ""
+msgstr "la lid %lu n'a pas de cl\n"
 
-#: g10/trustdb.c:1851
-#, fuzzy, c-format
+#: g10/trustdb.c:1812
+#, c-format
 msgid "lid %lu: can't get keyblock: %s\n"
-msgstr "ne peut crire le bloc de cls: %s\n"
+msgstr "lid %lu: ne peut obtenir le bloc de cls: %s\n"
 
-#: g10/trustdb.c:2096
+#: g10/trustdb.c:2022
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X: good self-signature\n"
-msgstr "cl %08lXi.%lu, uid %02X%02X: %ssignature invalide: %s\n"
+msgid "key %08lX.%lu: Good subkey binding\n"
+msgstr "cl %08lX: mauvaise association avec %08lX\n"
 
-#: g10/trustdb.c:2188
+#: g10/trustdb.c:2028 g10/trustdb.c:2070
 #, fuzzy, c-format
-msgid ""
-"key %08lX.%lu, uid %02X%02X, sig %08lX: duplicated signature - deleted\n"
-msgstr "cl %08lXi.%lu, uid %02X%02X: %ssignature invalide: %s\n"
+msgid "key %08lX.%lu: Invalid subkey binding: %s\n"
+msgstr "cl %08lX: pas de nom d'utilisateur valide\n"
 
-#: g10/trustdb.c:2211
+#: g10/trustdb.c:2043
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (1)\n"
-msgstr "cl %08lXi.%lu, uid %02X%02X: %ssignature invalide: %s\n"
+msgid "key %08lX.%lu: Valid key revocation\n"
+msgstr "cl %08lX: mauvaise rvocation de cl par %08lX\n"
 
-#: g10/trustdb.c:2218
+#: g10/trustdb.c:2049
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: weird: no public key\n"
-msgstr ""
-"cl %08lX.%lu, uid %02X%02X: pas de cl publique pour la signature %08lX\n"
+msgid "key %08lX.%lu: Invalid key revocation: %s\n"
+msgstr "cl %08lX: mauvaise rvocation de cl par %08lX\n"
 
-#: g10/trustdb.c:2240
+#: g10/trustdb.c:2064
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X: has shadow dir %lu but not yet marked.\n"
-msgstr "cl %08lXi.%lu, uid %02X%02X: %ssignature invalide: %s\n"
+msgid "key %08lX.%lu: Valid subkey revocation\n"
+msgstr "cl %08lX: mauvaise rvocation de sous-cl par %08lX\n"
 
-#: g10/trustdb.c:2279
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (2)\n"
-msgstr "cl %08lXi.%lu, uid %02X%02X: %ssignature invalide: %s\n"
+#: g10/trustdb.c:2164
+#, fuzzy
+msgid "Good self-signature"
+msgstr "[auto-signature]"
 
-#: g10/trustdb.c:2290
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: no public key\n"
+#: g10/trustdb.c:2172
+#, fuzzy
+msgid "Invalid self-signature"
+msgstr "cl %08lX: auto-signature invalide\n"
+
+#: g10/trustdb.c:2183
+#, fuzzy
+msgid "Valid user ID revocation\n"
+msgstr "Choix invalide.\n"
+
+#: g10/trustdb.c:2190
+#, fuzzy
+msgid "Invalid user ID revocation"
+msgstr "Choix invalide.\n"
+
+#: g10/trustdb.c:2273
+#, fuzzy
+msgid "Too many preferences"
+msgstr "lister les prfrences"
+
+#: g10/trustdb.c:2286
+msgid "Too many preferences items"
 msgstr ""
-"cl %08lX.%lu, uid %02X%02X: pas de cl publique pour la signature %08lX\n"
 
-#. key binding
-#: g10/trustdb.c:2386
-#, fuzzy, c-format
-msgid "key %08lX: bogus key binding by %08lX\n"
-msgstr "cl %08lX: pas de nom d'utilisateur\n"
+#: g10/trustdb.c:2423
+msgid "Duplicated certificate - deleted"
+msgstr ""
 
-#. key revocation
-#: g10/trustdb.c:2390
-#, fuzzy, c-format
-msgid "key %08lX: bogus key revocation by %08lX\n"
-msgstr "cl %08lX: cl publique pas trouve: %s\n"
+#: g10/trustdb.c:2455
+#, fuzzy
+msgid "public key lost"
+msgstr "Mauvaise cl publique"
 
-#. subkey revocation
-#: g10/trustdb.c:2394
-#, fuzzy, c-format
-msgid "key %08lX: bogus subkey revocation by %08lX\n"
-msgstr "cl %08lX: cl publique pas trouve: %s\n"
+#: g10/trustdb.c:2464 g10/trustdb.c:2547
+#, fuzzy
+msgid "Invalid certificate revocation"
+msgstr "Mauvais certificat"
+
+#: g10/trustdb.c:2465 g10/trustdb.c:2548
+#, fuzzy
+msgid "Invalid certificate"
+msgstr "Mauvais certificat"
 
 #: g10/status.c:246
 msgid "No help available"
@@ -2275,6 +2387,25 @@
 msgid "Overwrite (y/N)? "
 msgstr "Rcrire (o/N)? "
 
+#: g10/openfile.c:85
+msgid "writing to stdout\n"
+msgstr "criture vers la sortie standard\n"
+
+#: g10/openfile.c:101 g10/openfile.c:165
+#, c-format
+msgid "%s: can't create: %s\n"
+msgstr "%s: ne peut crer: %s\n"
+
+#: g10/openfile.c:134
+#, c-format
+msgid "assuming signed data in '%s'\n"
+msgstr "les donnes signes sont supposes tre dans '%s'\n"
+
+#: g10/openfile.c:181
+#, c-format
+msgid "%s: new options file created\n"
+msgstr "%s: nouveau fichier d'options cr\n"
+
 #: g10/encr-data.c:74
 msgid ""
 "Warning: Message was encrypted with a weak key in the symmetric cipher.\n"
@@ -2284,7 +2415,7 @@
 
 #: g10/seskey.c:52
 msgid "weak key created - retrying\n"
-msgstr "mauvais cl gnre - nouvel essai\n"
+msgstr "mauvaise cl gnre - nouvel essai\n"
 
 #: g10/seskey.c:57
 #, c-format
@@ -2293,5 +2424,43 @@
 "ne peut viter une mauvaise cl pour le chiffrement symtrique: \n"
 "%d essais ont eu lieu!\n"
 
-#~ msgid "key %08lX: already in ultikey_table\n"
-#~ msgstr "cl %08lX: dja dans ultikey_table\n"
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: Good signature (3)\n"
+#~ msgstr "cl %08lX.%lu, uid %02X%02X, sig %08lX: Bonne signature (3)\n"
+
+#~ msgid ""
+#~ "key %08lX.%lu, uid %02X%02X, sig %08lX: very strange: no public key\n"
+#~ msgstr ""
+#~ "cl %08lX.%lu, uid %02X%02X, sig %08lX: trs trange: pas de cl publique\n"
+
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: %s\n"
+#~ msgstr "cl %08lX.%lu, uid %02X%02X, sig %08lX: %s\n"
+
+#~ msgid "key %08lX.%lu, uid %02X%02X: Good self-signature\n"
+#~ msgstr "cl %08lX.%lu, uid %02X%02X: Bonne auto-signature\n"
+
+#~ msgid "key %08lX, uid %02X%02X: Invalid self-signature: %s\n"
+#~ msgstr "cl %08lX.%lu, uid %02X%02X: Auto-signature invalide: %s\n"
+
+#~ msgid ""
+#~ "key %08lX.%lu, uid %02X%02X, sig %08lX: duplicated signature - deleted\n"
+#~ msgstr ""
+#~ "cl %08lX.%lu, uid %02X%02X, sig %08lX: signature duplique - efface\n"
+
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: Good signature (1)\n"
+#~ msgstr "cl %08lX.%lu, uid %02X%02X, sig %08lX: Bonne signature (1)\n"
+
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: weird: no public key\n"
+#~ msgstr ""
+#~ "cl %08lX.%lu, uid %02X%02X, sig %08lX: bizarre: pas de cl publique\n"
+
+#~ msgid ""
+#~ "key %08lX.%lu, uid %02X%02X: has shadow dir %lu but not yet marked.\n"
+#~ msgstr ""
+#~ "cl %08lX.%lu, uid %02X%02X: possde une ombre %lu mais pas encore\n"
+#~ "marque.\n"
+
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: Good signature (2)\n"
+#~ msgstr "cl %08lX.%lu, uid %02X%02X, sig %08lX: Bonne signature (2)\n"
+
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: no public key\n"
+#~ msgstr "cl %08lX.%lu, uid %02X%02X, sig %08lX: pas de cl publique\n"
diff -urN gnupg-0.4.2/po/gnupg.pot gnupg-0.4.3/po/gnupg.pot
--- gnupg-0.4.2/po/gnupg.pot	Sun Oct 18 16:36:37 1998
+++ gnupg-0.4.3/po/gnupg.pot	Sun Nov  8 18:21:17 1998
@@ -6,7 +6,7 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: PACKAGE VERSION\n"
-"POT-Creation-Date: 1998-10-18 16:36+0200\n"
+"POT-Creation-Date: 1998-11-08 18:21+0100\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
@@ -200,7 +200,7 @@
 
 #: util/logger.c:177
 #, c-format
-msgid "Ohhhh jeeee ... this is a bug (%s:%d:%s)\n"
+msgid "... this is a bug (%s:%d:%s)\n"
 msgstr ""
 
 #: util/logger.c:183
@@ -229,257 +229,261 @@
 "the OS a chance to collect more entropy! (Need %d more bytes)\n"
 msgstr ""
 
-#: g10/g10.c:149
+#: g10/g10.c:152
 msgid ""
 "@Commands:\n"
 " "
 msgstr ""
 
-#: g10/g10.c:152
+#: g10/g10.c:155
 msgid "|[file]|make a signature"
 msgstr ""
 
-#: g10/g10.c:153
+#: g10/g10.c:156
 msgid "|[file]|make a clear text signature"
 msgstr ""
 
-#: g10/g10.c:154
+#: g10/g10.c:157
 msgid "make a detached signature"
 msgstr ""
 
-#: g10/g10.c:155
+#: g10/g10.c:158
 msgid "encrypt data"
 msgstr ""
 
-#: g10/g10.c:156
+#: g10/g10.c:159
 msgid "encryption only with symmetric cipher"
 msgstr ""
 
-#: g10/g10.c:157
+#: g10/g10.c:160
 msgid "store only"
 msgstr ""
 
-#: g10/g10.c:158
+#: g10/g10.c:161
 msgid "decrypt data (default)"
 msgstr ""
 
-#: g10/g10.c:159
+#: g10/g10.c:162
 msgid "verify a signature"
 msgstr ""
 
-#: g10/g10.c:161
+#: g10/g10.c:164
 msgid "list keys"
 msgstr ""
 
-#: g10/g10.c:162
+#: g10/g10.c:165
 msgid "list keys and signatures"
 msgstr ""
 
-#: g10/g10.c:163
+#: g10/g10.c:166
 msgid "check key signatures"
 msgstr ""
 
-#: g10/g10.c:164
+#: g10/g10.c:167
 msgid "list keys and fingerprints"
 msgstr ""
 
-#: g10/g10.c:165
+#: g10/g10.c:168
 msgid "list secret keys"
 msgstr ""
 
-#: g10/g10.c:167
+#: g10/g10.c:170
 msgid "generate a new key pair"
 msgstr ""
 
-#: g10/g10.c:169
+#: g10/g10.c:172
 msgid "remove key from the public keyring"
 msgstr ""
 
-#: g10/g10.c:171
+#: g10/g10.c:174
 msgid "sign or edit a key"
 msgstr ""
 
-#: g10/g10.c:172
+#: g10/g10.c:175
 msgid "generate a revocation certificate"
 msgstr ""
 
-#: g10/g10.c:174
+#: g10/g10.c:177
 msgid "export keys"
 msgstr ""
 
-#: g10/g10.c:176
+#: g10/g10.c:179
 msgid "import/merge keys"
 msgstr ""
 
-#: g10/g10.c:177
+#: g10/g10.c:181
 msgid "list only the sequence of packets"
 msgstr ""
 
-#: g10/g10.c:180
+#: g10/g10.c:184
 msgid "export the ownertrust values"
 msgstr ""
 
-#: g10/g10.c:182
+#: g10/g10.c:186
 msgid "import ownertrust values"
 msgstr ""
 
-#: g10/g10.c:184
+#: g10/g10.c:188
 msgid "|[NAMES]|update the trust database"
 msgstr ""
 
-#: g10/g10.c:186
+#: g10/g10.c:190
 msgid "|[NAMES]|check the trust database"
 msgstr ""
 
-#: g10/g10.c:187
+#: g10/g10.c:191
 msgid "fix a corrupted trust database"
 msgstr ""
 
-#: g10/g10.c:188
+#: g10/g10.c:192
 msgid "De-Armor a file or stdin"
 msgstr ""
 
-#: g10/g10.c:189
+#: g10/g10.c:193
 msgid "En-Armor a file or stdin"
 msgstr ""
 
-#: g10/g10.c:190
+#: g10/g10.c:194
 msgid "|algo [files]|print message digests"
 msgstr ""
 
-#: g10/g10.c:191
+#: g10/g10.c:195
 msgid "print all message digests"
 msgstr ""
 
-#: g10/g10.c:198
+#: g10/g10.c:202
 msgid ""
 "@\n"
 "Options:\n"
 " "
 msgstr ""
 
-#: g10/g10.c:200
+#: g10/g10.c:204
 msgid "create ascii armored output"
 msgstr ""
 
-#: g10/g10.c:202
+#: g10/g10.c:206
 msgid "use this user-id to sign or decrypt"
 msgstr ""
 
-#: g10/g10.c:203
+#: g10/g10.c:207
 msgid "use this user-id for encryption"
 msgstr ""
 
-#: g10/g10.c:204
+#: g10/g10.c:208
 msgid "|N|set compress level N (0 disables)"
 msgstr ""
 
-#: g10/g10.c:205
+#: g10/g10.c:210
 msgid "use canonical text mode"
 msgstr ""
 
-#: g10/g10.c:207
+#: g10/g10.c:212
 msgid "use as output file"
 msgstr ""
 
-#: g10/g10.c:208
+#: g10/g10.c:213
 msgid "verbose"
 msgstr ""
 
-#: g10/g10.c:209
+#: g10/g10.c:214
+msgid "be somewhat more quiet"
+msgstr ""
+
+#: g10/g10.c:215
 msgid "force v3 signatures"
 msgstr ""
 
 #. { oDryRun, "dry-run",   0, N_("do not make any changes") },
-#: g10/g10.c:211
+#: g10/g10.c:217
 msgid "batch mode: never ask"
 msgstr ""
 
-#: g10/g10.c:212
+#: g10/g10.c:218
 msgid "assume yes on most questions"
 msgstr ""
 
-#: g10/g10.c:213
+#: g10/g10.c:219
 msgid "assume no on most questions"
 msgstr ""
 
-#: g10/g10.c:214
+#: g10/g10.c:220
 msgid "add this keyring to the list of keyrings"
 msgstr ""
 
-#: g10/g10.c:215
+#: g10/g10.c:221
 msgid "add this secret keyring to the list"
 msgstr ""
 
-#: g10/g10.c:216
+#: g10/g10.c:222
 msgid "|NAME|use NAME as default secret key"
 msgstr ""
 
-#: g10/g10.c:217
+#: g10/g10.c:223
 msgid "read options from file"
 msgstr ""
 
-#: g10/g10.c:219
+#: g10/g10.c:225
 msgid "set debugging flags"
 msgstr ""
 
-#: g10/g10.c:220
+#: g10/g10.c:226
 msgid "enable full debugging"
 msgstr ""
 
-#: g10/g10.c:221
+#: g10/g10.c:227
 msgid "|FD|write status info to this FD"
 msgstr ""
 
-#: g10/g10.c:222
+#: g10/g10.c:228
 msgid "do not write comment packets"
 msgstr ""
 
-#: g10/g10.c:223
+#: g10/g10.c:229
 msgid "(default is 1)"
 msgstr ""
 
-#: g10/g10.c:224
+#: g10/g10.c:230
 msgid "(default is 3)"
 msgstr ""
 
-#: g10/g10.c:225
+#: g10/g10.c:231
 msgid "|FILE|load extension module FILE"
 msgstr ""
 
-#: g10/g10.c:226
+#: g10/g10.c:232
 msgid "emulate the mode described in RFC1991"
 msgstr ""
 
-#: g10/g10.c:227
+#: g10/g10.c:233
 msgid "|N|use passphrase mode N"
 msgstr ""
 
-#: g10/g10.c:229
+#: g10/g10.c:235
 msgid "|NAME|use message digest algorithm NAME for passphrases"
 msgstr ""
 
-#: g10/g10.c:231
+#: g10/g10.c:237
 msgid "|NAME|use cipher algorithm NAME for passphrases"
 msgstr ""
 
-#: g10/g10.c:233
+#: g10/g10.c:239
 msgid "|NAME|use cipher algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:234
+#: g10/g10.c:240
 msgid "|NAME|use message digest algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:235
+#: g10/g10.c:241
 msgid "|N|use compress algorithm N"
 msgstr ""
 
-#: g10/g10.c:236
+#: g10/g10.c:242
 msgid "throw keyid field of encrypted packets"
 msgstr ""
 
-#: g10/g10.c:244
+#: g10/g10.c:250
 msgid ""
 "@\n"
 "Examples:\n"
@@ -491,172 +495,172 @@
 " --fingerprint [names]      show fingerprints\n"
 msgstr ""
 
-#: g10/g10.c:319
+#: g10/g10.c:325
 msgid "Please report bugs to <gnupg-bugs@gnu.org>.\n"
 msgstr ""
 
-#: g10/g10.c:324
+#: g10/g10.c:330
 msgid "Usage: gpgm [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:326
+#: g10/g10.c:332
 msgid "Usage: gpg [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:331
+#: g10/g10.c:337
 msgid ""
 "Syntax: gpgm [options] [files]\n"
 "GnuPG maintenance utility\n"
 msgstr ""
 
-#: g10/g10.c:334
+#: g10/g10.c:340
 msgid ""
 "Syntax: gpg [options] [files]\n"
 "sign, check, encrypt or decrypt\n"
 "default operation depends on the input data\n"
 msgstr ""
 
-#: g10/g10.c:340
+#: g10/g10.c:346
 msgid ""
 "\n"
 "Supported algorithms:\n"
 msgstr ""
 
-#: g10/g10.c:415
+#: g10/g10.c:421
 msgid "usage: gpgm [options] "
 msgstr ""
 
-#: g10/g10.c:417
+#: g10/g10.c:423
 msgid "usage: gpg [options] "
 msgstr ""
 
-#: g10/g10.c:458
+#: g10/g10.c:464
 msgid "conflicting commands\n"
 msgstr ""
 
-#: g10/g10.c:596
+#: g10/g10.c:602
 #, c-format
 msgid "note: no default option file '%s'\n"
 msgstr ""
 
-#: g10/g10.c:600
+#: g10/g10.c:606
 #, c-format
 msgid "option file '%s': %s\n"
 msgstr ""
 
-#: g10/g10.c:607
+#: g10/g10.c:613
 #, c-format
 msgid "reading options from '%s'\n"
 msgstr ""
 
-#: g10/g10.c:778 g10/g10.c:790
+#: g10/g10.c:787 g10/g10.c:799
 msgid "selected cipher algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:784 g10/g10.c:796
+#: g10/g10.c:793 g10/g10.c:805
 msgid "selected digest algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:799
+#: g10/g10.c:808
 #, c-format
 msgid "compress algorithm must be in range %d..%d\n"
 msgstr ""
 
-#: g10/g10.c:801
+#: g10/g10.c:810
 msgid "completes-needed must be greater than 0\n"
 msgstr ""
 
-#: g10/g10.c:803
+#: g10/g10.c:812
 msgid "marginals-needed must be greater than 1\n"
 msgstr ""
 
-#: g10/g10.c:806
+#: g10/g10.c:815
 msgid "note: simple S2K mode (0) is strongly discouraged\n"
 msgstr ""
 
-#: g10/g10.c:810
+#: g10/g10.c:819
 msgid "invalid S2K mode; must be 0, 1 or 3\n"
 msgstr ""
 
-#: g10/g10.c:886
+#: g10/g10.c:895
 #, c-format
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr ""
 
-#: g10/g10.c:892
+#: g10/g10.c:901
 msgid "--store [filename]"
 msgstr ""
 
-#: g10/g10.c:900
+#: g10/g10.c:909
 msgid "--symmetric [filename]"
 msgstr ""
 
-#: g10/g10.c:908
+#: g10/g10.c:917
 msgid "--encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:921
+#: g10/g10.c:930
 msgid "--sign [filename]"
 msgstr ""
 
-#: g10/g10.c:934
+#: g10/g10.c:943
 msgid "--sign --encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:948
+#: g10/g10.c:957
 msgid "--clearsign [filename]"
 msgstr ""
 
-#: g10/g10.c:960
+#: g10/g10.c:969
 msgid "--decrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:969
+#: g10/g10.c:978
 msgid "--edit-key username"
 msgstr ""
 
-#: g10/g10.c:977
+#: g10/g10.c:986
 msgid "--delete-secret-key username"
 msgstr ""
 
-#: g10/g10.c:980
+#: g10/g10.c:989
 msgid "--delete-key username"
 msgstr ""
 
-#: g10/encode.c:215 g10/g10.c:1003 g10/keylist.c:80
+#: g10/encode.c:216 g10/g10.c:1012
 #, c-format
 msgid "can't open %s: %s\n"
 msgstr ""
 
-#: g10/g10.c:1014
+#: g10/g10.c:1023
 msgid "-k[v][v][v][c] [userid] [keyring]"
 msgstr ""
 
-#: g10/g10.c:1069
+#: g10/g10.c:1079
 #, c-format
 msgid "dearmoring failed: %s\n"
 msgstr ""
 
-#: g10/g10.c:1077
+#: g10/g10.c:1087
 #, c-format
 msgid "enarmoring failed: %s\n"
 msgstr ""
 
-#: g10/g10.c:1138
+#: g10/g10.c:1148
 #, c-format
 msgid "invalid hash algorithm '%s'\n"
 msgstr ""
 
-#: g10/g10.c:1220
+#: g10/g10.c:1230
 msgid "[filename]"
 msgstr ""
 
-#: g10/decrypt.c:59 g10/g10.c:1222 g10/verify.c:66
+#: g10/decrypt.c:59 g10/g10.c:1232 g10/verify.c:66
 #, c-format
 msgid "can't open '%s'\n"
 msgstr ""
 
-#: g10/g10.c:1269
+#: g10/g10.c:1279
 msgid ""
 "RSA keys are deprecated; please consider creating a new key and use this key "
 "in the future\n"
@@ -1021,7 +1025,7 @@
 msgid "Is this correct (y/n)? "
 msgstr ""
 
-#: g10/keygen.c:561
+#: g10/keygen.c:569
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user "
@@ -1031,51 +1035,51 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "keygen.name"
 msgstr ""
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "Real name: "
 msgstr ""
 
-#: g10/keygen.c:576
+#: g10/keygen.c:584
 msgid "Invalid character in name\n"
 msgstr ""
 
-#: g10/keygen.c:578
+#: g10/keygen.c:586
 msgid "Name may not start with a digit\n"
 msgstr ""
 
-#: g10/keygen.c:580
+#: g10/keygen.c:588
 msgid "Name must be at least 5 characters long\n"
 msgstr ""
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "keygen.email"
 msgstr ""
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "Email address: "
 msgstr ""
 
-#: g10/keygen.c:600
+#: g10/keygen.c:608
 msgid "Not a valid email address\n"
 msgstr ""
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "keygen.comment"
 msgstr ""
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "Comment: "
 msgstr ""
 
-#: g10/keygen.c:614
+#: g10/keygen.c:622
 msgid "Invalid character in comment\n"
 msgstr ""
 
-#: g10/keygen.c:634
+#: g10/keygen.c:642
 #, c-format
 msgid ""
 "You selected this USER-ID:\n"
@@ -1083,29 +1087,29 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:637
+#: g10/keygen.c:645
 msgid "NnCcEeOoQq"
 msgstr ""
 
-#: g10/keygen.c:646
+#: g10/keygen.c:654
 msgid "keygen.userid.cmd"
 msgstr ""
 
-#: g10/keygen.c:647
+#: g10/keygen.c:655
 msgid "Change (N)ame, (C)omment, (E)mail or (O)kay/(Q)uit? "
 msgstr ""
 
-#: g10/keygen.c:694
+#: g10/keygen.c:707
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
 msgstr ""
 
-#: g10/keyedit.c:389 g10/keygen.c:702
+#: g10/keyedit.c:389 g10/keygen.c:715
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr ""
 
-#: g10/keygen.c:708
+#: g10/keygen.c:721
 msgid ""
 "You don't want a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at any time,\n"
@@ -1113,7 +1117,7 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:729
+#: g10/keygen.c:742
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -1121,52 +1125,52 @@
 "number generator a better chance to gain enough entropy.\n"
 msgstr ""
 
-#: g10/keygen.c:799
+#: g10/keygen.c:812
 msgid "Key generation can only be used in interactive mode\n"
 msgstr ""
 
-#: g10/keygen.c:807
+#: g10/keygen.c:820
 msgid "DSA keypair will have 1024 bits.\n"
 msgstr ""
 
-#: g10/keygen.c:813
+#: g10/keygen.c:826
 msgid "Key generation cancelled.\n"
 msgstr ""
 
-#: g10/keygen.c:823
+#: g10/keygen.c:836
 #, c-format
 msgid "writing public certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:824
+#: g10/keygen.c:837
 #, c-format
 msgid "writing secret certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:901
+#: g10/keygen.c:914
 msgid "public and secret key created and signed.\n"
 msgstr ""
 
-#: g10/keygen.c:903
+#: g10/keygen.c:916
 msgid ""
 "Note that this key cannot be used for encryption.  You may want to use\n"
 "the command \"--add-key\" to generate a secondary key for this purpose.\n"
 msgstr ""
 
-#: g10/keygen.c:917 g10/keygen.c:1002
+#: g10/keygen.c:930 g10/keygen.c:1015
 #, c-format
 msgid "Key generation failed: %s\n"
 msgstr ""
 
-#: g10/keygen.c:979
+#: g10/keygen.c:992
 msgid "keygen.sub.okay"
 msgstr ""
 
-#: g10/keygen.c:980
+#: g10/keygen.c:993
 msgid "Really create? "
 msgstr ""
 
-#: g10/encode.c:88
+#: g10/encode.c:88 g10/openfile.c:81 g10/openfile.c:158
 #, c-format
 msgid "%s: can't open: %s\n"
 msgstr ""
@@ -1176,223 +1180,281 @@
 msgid "error creating passphrase: %s\n"
 msgstr ""
 
-#: g10/encode.c:154 g10/encode.c:267
+#: g10/encode.c:155 g10/encode.c:269
 #, c-format
 msgid "%s: warning: empty file\n"
 msgstr ""
 
-#: g10/encode.c:221
+#: g10/encode.c:222
 #, c-format
 msgid "reading from '%s'\n"
 msgstr ""
 
-#: g10/encode.c:395
+#: g10/encode.c:397
 #, c-format
 msgid "%s encrypted for: %s\n"
 msgstr ""
 
-#: g10/getkey.c:854
+#: g10/getkey.c:950
 #, c-format
 msgid "using secondary key %08lX instead of primary key %08lX\n"
 msgstr ""
 
-#: g10/import.c:106 g10/trustdb.c:1100
+#: g10/import.c:125 g10/trustdb.c:1046
 #, c-format
 msgid "can't open file: %s\n"
 msgstr ""
 
-#: g10/import.c:122
+#: g10/import.c:141
 #, c-format
 msgid "skipping block of type %d\n"
 msgstr ""
 
-#: g10/import.c:132 g10/trustdb.c:1175
+#: g10/import.c:148 g10/trustdb.c:1289 g10/trustdb.c:1358
+#, c-format
+msgid "%lu keys so far processed\n"
+msgstr ""
+
+#: g10/import.c:153 g10/trustdb.c:1122
 #, c-format
 msgid "read error: %s\n"
 msgstr ""
 
-#: g10/import.c:273 g10/import.c:446
+#: g10/import.c:155
+#, c-format
+msgid "Total number processed: %lu\n"
+msgstr ""
+
+#: g10/import.c:157
+#, c-format
+msgid "          w/o user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:159
+#, c-format
+msgid "              imported: %lu"
+msgstr ""
+
+#: g10/import.c:165
+#, c-format
+msgid "             unchanged: %lu\n"
+msgstr ""
+
+#: g10/import.c:167
+#, c-format
+msgid "          new user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:169
+#, c-format
+msgid "           new subkeys: %lu\n"
+msgstr ""
+
+#: g10/import.c:171
+#, c-format
+msgid "        new signatures: %lu\n"
+msgstr ""
+
+#: g10/import.c:173
+#, c-format
+msgid "   new key revocations: %lu\n"
+msgstr ""
+
+#: g10/import.c:175
+#, c-format
+msgid "      secret keys read: %lu\n"
+msgstr ""
+
+#: g10/import.c:177
+#, c-format
+msgid "  secret keys imported: %lu\n"
+msgstr ""
+
+#: g10/import.c:179
+#, c-format
+msgid " secret keys unchanged: %lu\n"
+msgstr ""
+
+#: g10/import.c:321 g10/import.c:513
 #, c-format
 msgid "key %08lX: no user id\n"
 msgstr ""
 
-#: g10/import.c:283
+#: g10/import.c:332
 #, c-format
 msgid "key %08lX: no valid user ids\n"
 msgstr ""
 
-#: g10/import.c:285
+#: g10/import.c:334
 msgid "this may be caused by a missing self-signature\n"
 msgstr ""
 
-#: g10/import.c:294 g10/import.c:512
+#: g10/import.c:345 g10/import.c:581
 #, c-format
 msgid "key %08lX: public key not found: %s\n"
 msgstr ""
 
-#: g10/import.c:300
+#: g10/import.c:351
 msgid "no default public keyring\n"
 msgstr ""
 
-#: g10/import.c:304
+#: g10/import.c:355 g10/openfile.c:105
 #, c-format
 msgid "writing to '%s'\n"
 msgstr ""
 
-#: g10/import.c:308 g10/import.c:363 g10/import.c:566
+#: g10/import.c:359 g10/import.c:419 g10/import.c:635
 #, c-format
 msgid "can't lock public keyring: %s\n"
 msgstr ""
 
-#: g10/import.c:311
+#: g10/import.c:362
 #, c-format
 msgid "can't write to keyring: %s\n"
 msgstr ""
 
-#. we are ready
-#: g10/import.c:314
+#: g10/import.c:366
 #, c-format
 msgid "key %08lX: public key imported\n"
 msgstr ""
 
-#: g10/import.c:323
+#: g10/import.c:379
 #, c-format
 msgid "key %08lX: doesn't match our copy\n"
 msgstr ""
 
-#: g10/import.c:336 g10/import.c:521
+#: g10/import.c:392 g10/import.c:590
 #, c-format
 msgid "key %08lX: can't locate original keyblock: %s\n"
 msgstr ""
 
-#: g10/import.c:343 g10/import.c:528
+#: g10/import.c:399 g10/import.c:597
 #, c-format
 msgid "key %08lX: can't read original keyblock: %s\n"
 msgstr ""
 
-#: g10/import.c:360 g10/import.c:461 g10/import.c:563
+#: g10/import.c:416 g10/import.c:528 g10/import.c:632
 msgid "writing keyblock\n"
 msgstr ""
 
-#: g10/import.c:366 g10/import.c:569
+#: g10/import.c:422 g10/import.c:638
 #, c-format
 msgid "can't write keyblock: %s\n"
 msgstr ""
 
-#: g10/import.c:370
+#: g10/import.c:427
 #, c-format
 msgid "key %08lX: 1 new user-id\n"
 msgstr ""
 
-#: g10/import.c:373
+#: g10/import.c:430
 #, c-format
 msgid "key %08lX: %d new user-ids\n"
 msgstr ""
 
-#: g10/import.c:376
+#: g10/import.c:433
 #, c-format
 msgid "key %08lX: 1 new signature\n"
 msgstr ""
 
-#: g10/import.c:379
+#: g10/import.c:436
 #, c-format
 msgid "key %08lX: %d new signatures\n"
 msgstr ""
 
-#: g10/import.c:382
+#: g10/import.c:439
 #, c-format
 msgid "key %08lX: 1 new subkey\n"
 msgstr ""
 
-#: g10/import.c:385
+#: g10/import.c:442
 #, c-format
 msgid "key %08lX: %d new subkeys\n"
 msgstr ""
 
-#: g10/import.c:389
+#: g10/import.c:452
 #, c-format
 msgid "key %08lX: not changed\n"
 msgstr ""
 
-#: g10/import.c:464
+#: g10/import.c:531
 #, c-format
 msgid "can't lock secret keyring: %s\n"
 msgstr ""
 
-#: g10/import.c:467
+#: g10/import.c:534
 #, c-format
 msgid "can't write keyring: %s\n"
 msgstr ""
 
 #. we are ready
-#: g10/import.c:470
+#: g10/import.c:537
 #, c-format
 msgid "key %08lX: secret key imported\n"
 msgstr ""
 
 #. we can't merge secret keys
-#: g10/import.c:473
+#: g10/import.c:541
 #, c-format
 msgid "key %08lX: already in secret keyring\n"
 msgstr ""
 
-#: g10/import.c:477
+#: g10/import.c:546
 #, c-format
 msgid "key %08lX: secret key not found: %s\n"
 msgstr ""
 
-#: g10/import.c:506
+#: g10/import.c:575
 #, c-format
 msgid "key %08lX: no public key - can't apply revocation certificate\n"
 msgstr ""
 
-#: g10/import.c:539
+#: g10/import.c:608
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - rejected\n"
 msgstr ""
 
-#. we are ready
-#: g10/import.c:572
+#: g10/import.c:642
 #, c-format
 msgid "key %08lX: revocation certificate imported\n"
 msgstr ""
 
-#: g10/import.c:602
+#: g10/import.c:673
 #, c-format
 msgid "key %08lX: no user-id for signature\n"
 msgstr ""
 
-#: g10/import.c:609
+#: g10/import.c:680
 #, c-format
 msgid "key %08lX: unsupported public key algorithm\n"
 msgstr ""
 
-#: g10/import.c:610
+#: g10/import.c:681
 #, c-format
 msgid "key %08lX: invalid self-signature\n"
 msgstr ""
 
-#: g10/import.c:639
+#: g10/import.c:710
 #, c-format
 msgid "key %08lX: skipped userid '"
 msgstr ""
 
-#: g10/import.c:662
+#: g10/import.c:733
 #, c-format
 msgid "key %08lX: revocation certificate at wrong place - skipped\n"
 msgstr ""
 
-#: g10/import.c:670
+#: g10/import.c:741
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - skipped\n"
 msgstr ""
 
-#: g10/import.c:732
+#: g10/import.c:803
 #, c-format
 msgid "key %08lX: revocation certificate added\n"
 msgstr ""
 
-#: g10/import.c:795 g10/import.c:831
+#: g10/import.c:866 g10/import.c:902
 #, c-format
 msgid "key %08lX: our copy has no self-signature\n"
 msgstr ""
@@ -1682,163 +1744,163 @@
 msgid "Secret key is available.\n"
 msgstr ""
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 msgid "keyedit.cmd"
 msgstr ""
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 msgid "Command> "
 msgstr ""
 
-#: g10/keyedit.c:600
+#: g10/keyedit.c:602
 msgid "Need the secret key to to this.\n"
 msgstr ""
 
-#: g10/keyedit.c:619
+#: g10/keyedit.c:621
 msgid "keyedit.save.okay"
 msgstr ""
 
-#: g10/keyedit.c:620
+#: g10/keyedit.c:622
 msgid "Save changes? "
 msgstr ""
 
-#: g10/keyedit.c:622
+#: g10/keyedit.c:624
 msgid "keyedit.cancel.okay"
 msgstr ""
 
-#: g10/keyedit.c:623
+#: g10/keyedit.c:625
 msgid "Quit without saving? "
 msgstr ""
 
-#: g10/keyedit.c:633
+#: g10/keyedit.c:635
 #, c-format
 msgid "update failed: %s\n"
 msgstr ""
 
-#: g10/keyedit.c:640
+#: g10/keyedit.c:642
 #, c-format
 msgid "update secret failed: %s\n"
 msgstr ""
 
-#: g10/keyedit.c:647
+#: g10/keyedit.c:649
 msgid "Key not changed so no update needed.\n"
 msgstr ""
 
-#: g10/keyedit.c:650 g10/keyedit.c:708
+#: g10/keyedit.c:652 g10/keyedit.c:710
 #, c-format
 msgid "update of trust db failed: %s\n"
 msgstr ""
 
-#: g10/keyedit.c:681
+#: g10/keyedit.c:683
 msgid "keyedit.sign_all.okay"
 msgstr ""
 
-#: g10/keyedit.c:682
+#: g10/keyedit.c:684
 msgid "Really sign all user ids? "
 msgstr ""
 
-#: g10/keyedit.c:683
+#: g10/keyedit.c:685
 msgid "Hint: Select the user ids to sign\n"
 msgstr ""
 
-#: g10/keyedit.c:719
+#: g10/keyedit.c:721
 msgid "You must select at least one user id.\n"
 msgstr ""
 
-#: g10/keyedit.c:721
+#: g10/keyedit.c:723
 msgid "You can't delete the last user id!\n"
 msgstr ""
 
-#: g10/keyedit.c:723
+#: g10/keyedit.c:725
 msgid "keyedit.remove.uid.okay"
 msgstr ""
 
-#: g10/keyedit.c:724
+#: g10/keyedit.c:726
 msgid "Really remove all selected user ids? "
 msgstr ""
 
-#: g10/keyedit.c:725
+#: g10/keyedit.c:727
 msgid "Really remove this user id? "
 msgstr ""
 
-#: g10/keyedit.c:748
+#: g10/keyedit.c:750
 msgid "You must select at least one key.\n"
 msgstr ""
 
-#: g10/keyedit.c:750
+#: g10/keyedit.c:752
 msgid "keyedit.remove.subkey.okay"
 msgstr ""
 
-#: g10/keyedit.c:752
+#: g10/keyedit.c:754
 msgid "Do you really want to delete the selected keys? "
 msgstr ""
 
-#: g10/keyedit.c:753
+#: g10/keyedit.c:755
 msgid "Do you really want to delete this key? "
 msgstr ""
 
-#: g10/keyedit.c:800
+#: g10/keyedit.c:802
 msgid "Invalid command  (try \"help\")\n"
 msgstr ""
 
-#: g10/keyedit.c:1178
+#: g10/keyedit.c:1180
 msgid "Please remove selections from the secret keys.\n"
 msgstr ""
 
-#: g10/keyedit.c:1184
+#: g10/keyedit.c:1186
 msgid "Please select at most one secondary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1188
+#: g10/keyedit.c:1190
 msgid "Changing exiration time for a secondary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1190
+#: g10/keyedit.c:1192
 msgid "Changing exiration time for the primary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1234
+#: g10/keyedit.c:1236
 msgid "No corresponding signature in secret ring\n"
 msgstr ""
 
-#: g10/keyedit.c:1294
+#: g10/keyedit.c:1296
 #, c-format
 msgid "No user id with index %d\n"
 msgstr ""
 
-#: g10/keyedit.c:1339
+#: g10/keyedit.c:1341
 #, c-format
 msgid "No secondary key with index %d\n"
 msgstr ""
 
-#: g10/mainproc.c:200
+#: g10/mainproc.c:201
 #, c-format
 msgid "public key decryption failed: %s\n"
 msgstr ""
 
-#: g10/mainproc.c:230
+#: g10/mainproc.c:231
 #, c-format
 msgid "decryption failed: %s\n"
 msgstr ""
 
-#: g10/mainproc.c:247
+#: g10/mainproc.c:248
 msgid "note: sender requested \"for-your-eyes-only\"\n"
 msgstr ""
 
-#: g10/mainproc.c:848
+#: g10/mainproc.c:842
 #, c-format
 msgid "Signature made %.*s using %s key ID %08lX\n"
 msgstr ""
 
-#: g10/mainproc.c:856
+#: g10/mainproc.c:850
 msgid "BAD signature from \""
 msgstr ""
 
-#: g10/mainproc.c:857
+#: g10/mainproc.c:851
 msgid "Good signature from \""
 msgstr ""
 
-#: g10/mainproc.c:868
+#: g10/mainproc.c:862
 #, c-format
 msgid "Can't check signature: %s\n"
 msgstr ""
@@ -1915,188 +1977,226 @@
 msgid "warning: signature key expired %s\n"
 msgstr ""
 
-#: g10/trustdb.c:122
+#: g10/trustdb.c:129
 msgid "The trust DB is corrupted; please run \"gpgm --fix-trust-db\".\n"
 msgstr ""
 
-#: g10/trustdb.c:389
+#: g10/trustdb.c:407
 #, c-format
 msgid "chained sigrec %lu has a wrong owner\n"
 msgstr ""
 
-#: g10/trustdb.c:436
+#: g10/trustdb.c:454
 #, c-format
 msgid "key %08lX: secret key without public key - skipped\n"
 msgstr ""
 
-#: g10/trustdb.c:442
+#: g10/trustdb.c:460
 #, c-format
 msgid "key %08lX: secret and public key don't match\n"
 msgstr ""
 
-#: g10/trustdb.c:452
+#: g10/trustdb.c:470
 #, c-format
 msgid "key %08lX: can't put it into the trustdb\n"
 msgstr ""
 
-#: g10/trustdb.c:458
+#: g10/trustdb.c:476
 #, c-format
 msgid "key %08lX: query record failed\n"
 msgstr ""
 
-#: g10/trustdb.c:467
+#: g10/trustdb.c:485
 #, c-format
 msgid "key %08lX: already in secret key table\n"
 msgstr ""
 
-#: g10/trustdb.c:470
+#: g10/trustdb.c:488
 #, c-format
 msgid "key %08lX: accepted as secret key.\n"
 msgstr ""
 
-#: g10/trustdb.c:477
+#: g10/trustdb.c:495
 #, c-format
 msgid "enum_secret_keys failed: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:1428
+#: g10/trustdb.c:1292 g10/trustdb.c:1360
+#, c-format
+msgid "%lu keys processed\n"
+msgstr ""
+
+#: g10/trustdb.c:1294
+#, c-format
+msgid "\t%lu keys skipped\n"
+msgstr ""
+
+#: g10/trustdb.c:1296 g10/trustdb.c:1362
+#, c-format
+msgid "\t%lu keys with errors\n"
+msgstr ""
+
+#: g10/trustdb.c:1298 g10/trustdb.c:1364
+#, c-format
+msgid "\t%lu keys updated\n"
+msgstr ""
+
+#: g10/trustdb.c:1366
+#, c-format
+msgid "\t%lu keys inserted\n"
+msgstr ""
+
+#: g10/trustdb.c:1421
 #, c-format
 msgid "key %08lX: insert trust record failed: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:1432
+#: g10/trustdb.c:1425
 #, c-format
 msgid "key %08lX.%lu: inserted into trustdb\n"
 msgstr ""
 
-#: g10/trustdb.c:1440
+#: g10/trustdb.c:1433
 #, c-format
 msgid "key %08lX.%lu: created in future (time warp or clock problem)\n"
 msgstr ""
 
-#: g10/trustdb.c:1447
+#: g10/trustdb.c:1440
 #, c-format
 msgid "key %08lX.%lu: expired at %s\n"
 msgstr ""
 
-#: g10/trustdb.c:1455
+#: g10/trustdb.c:1448
 #, c-format
 msgid "key %08lX.%lu: trust check failed: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:1718
+#: g10/trustdb.c:1666
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but marked as checked\n"
 msgstr ""
 
-#: g10/trustdb.c:1722
+#: g10/trustdb.c:1670
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but not marked\n"
 msgstr ""
 
 #. we need the dir record
-#: g10/trustdb.c:1729
+#: g10/trustdb.c:1677
 #, c-format
-msgid "sig rec %lu[%d] in hintlist of %u does not point to a dir record\n"
+msgid "sig rec %lu[%d] in hintlist of %lu does not point to a dir record\n"
 msgstr ""
 
-#: g10/trustdb.c:1735
+#: g10/trustdb.c:1683
 #, c-format
 msgid "lid %lu: no primary key\n"
 msgstr ""
 
-#: g10/trustdb.c:1764
+#: g10/trustdb.c:1716
 #, c-format
 msgid "lid %lu: user id not found in keyblock\n"
 msgstr ""
 
-#: g10/trustdb.c:1771
+#: g10/trustdb.c:1720
 #, c-format
-msgid "lid %lu: self-signature in hintlist\n"
+msgid "lid %lu: user id without signature\n"
 msgstr ""
 
-#: g10/trustdb.c:1776
+#: g10/trustdb.c:1727
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (3)\n"
+msgid "lid %lu: self-signature in hintlist\n"
 msgstr ""
 
-#: g10/trustdb.c:1783
-#, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: very strange: no public key\n"
+#: g10/trustdb.c:1738 g10/trustdb.c:2444 g10/trustdb.c:2526
+msgid "Valid certificate revocation"
 msgstr ""
 
-#: g10/trustdb.c:1790 g10/trustdb.c:2225 g10/trustdb.c:2297
-#, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: invalid signature: %s\n"
+#: g10/trustdb.c:1739 g10/trustdb.c:2445 g10/trustdb.c:2527
+msgid "Good certificate"
+msgstr ""
+
+#: g10/trustdb.c:1748
+msgid "very strange: no public key\n"
 msgstr ""
 
-#: g10/trustdb.c:1835
+#: g10/trustdb.c:1796
 #, c-format
 msgid "hintlist %lu[%d] of %lu does not point to a dir record\n"
 msgstr ""
 
-#: g10/trustdb.c:1841
+#: g10/trustdb.c:1802
 #, c-format
 msgid "lid %lu does not have a key\n"
 msgstr ""
 
-#: g10/trustdb.c:1851
+#: g10/trustdb.c:1812
 #, c-format
 msgid "lid %lu: can't get keyblock: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:2096
+#: g10/trustdb.c:2022
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X: good self-signature\n"
+msgid "key %08lX.%lu: Good subkey binding\n"
 msgstr ""
 
-#: g10/trustdb.c:2188
+#: g10/trustdb.c:2028 g10/trustdb.c:2070
 #, c-format
-msgid ""
-"key %08lX.%lu, uid %02X%02X, sig %08lX: duplicated signature - deleted\n"
+msgid "key %08lX.%lu: Invalid subkey binding: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:2211
+#: g10/trustdb.c:2043
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (1)\n"
+msgid "key %08lX.%lu: Valid key revocation\n"
 msgstr ""
 
-#: g10/trustdb.c:2218
+#: g10/trustdb.c:2049
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: weird: no public key\n"
+msgid "key %08lX.%lu: Invalid key revocation: %s\n"
 msgstr ""
 
-#: g10/trustdb.c:2240
+#: g10/trustdb.c:2064
 #, c-format
-msgid "key %08lX.%lu, uid %02X%02X: has shadow dir %lu but not yet marked.\n"
+msgid "key %08lX.%lu: Valid subkey revocation\n"
 msgstr ""
 
-#: g10/trustdb.c:2279
-#, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (2)\n"
+#: g10/trustdb.c:2164
+msgid "Good self-signature"
 msgstr ""
 
-#: g10/trustdb.c:2290
-#, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: no public key\n"
+#: g10/trustdb.c:2172
+msgid "Invalid self-signature"
 msgstr ""
 
-#. key binding
-#: g10/trustdb.c:2386
-#, c-format
-msgid "key %08lX: bogus key binding by %08lX\n"
+#: g10/trustdb.c:2183
+msgid "Valid user ID revocation\n"
 msgstr ""
 
-#. key revocation
-#: g10/trustdb.c:2390
-#, c-format
-msgid "key %08lX: bogus key revocation by %08lX\n"
+#: g10/trustdb.c:2190
+msgid "Invalid user ID revocation"
 msgstr ""
 
-#. subkey revocation
-#: g10/trustdb.c:2394
-#, c-format
-msgid "key %08lX: bogus subkey revocation by %08lX\n"
+#: g10/trustdb.c:2273
+msgid "Too many preferences"
+msgstr ""
+
+#: g10/trustdb.c:2286
+msgid "Too many preferences items"
+msgstr ""
+
+#: g10/trustdb.c:2423
+msgid "Duplicated certificate - deleted"
+msgstr ""
+
+#: g10/trustdb.c:2455
+msgid "public key lost"
+msgstr ""
+
+#: g10/trustdb.c:2464 g10/trustdb.c:2547
+msgid "Invalid certificate revocation"
+msgstr ""
+
+#: g10/trustdb.c:2465 g10/trustdb.c:2548
+msgid "Invalid certificate"
 msgstr ""
 
 #: g10/status.c:246
@@ -2134,6 +2234,25 @@
 
 #: g10/openfile.c:60
 msgid "Overwrite (y/N)? "
+msgstr ""
+
+#: g10/openfile.c:85
+msgid "writing to stdout\n"
+msgstr ""
+
+#: g10/openfile.c:101 g10/openfile.c:165
+#, c-format
+msgid "%s: can't create: %s\n"
+msgstr ""
+
+#: g10/openfile.c:134
+#, c-format
+msgid "assuming signed data in '%s'\n"
+msgstr ""
+
+#: g10/openfile.c:181
+#, c-format
+msgid "%s: new options file created\n"
 msgstr ""
 
 #: g10/encr-data.c:74
diff -urN gnupg-0.4.2/po/it.po gnupg-0.4.3/po/it.po
--- gnupg-0.4.2/po/it.po	Sun Oct 18 17:07:56 1998
+++ gnupg-0.4.3/po/it.po	Sun Nov  8 18:23:10 1998
@@ -5,7 +5,7 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: gnupg-0.4.0\n"
-"POT-Creation-Date: 1998-10-18 16:36+0200\n"
+"POT-Creation-Date: 1998-11-08 18:21+0100\n"
 "PO-Revision-Date: 1998-10-11 12:34+02:00\n"
 "Last-Translator: Marco d'Itri <md@linux.it>\n"
 "Language-Team: Italian <it@li.org>\n"
@@ -198,8 +198,8 @@
 msgstr "Chiave debole"
 
 #: util/logger.c:177
-#, c-format
-msgid "Ohhhh jeeee ... this is a bug (%s:%d:%s)\n"
+#, fuzzy, c-format
+msgid "... this is a bug (%s:%d:%s)\n"
 msgstr "Ohhh... questo  un bug (%s:%d:%s)\n"
 
 #: util/logger.c:183
@@ -235,7 +235,7 @@
 "altra cosa per dare all'OS la possibilit di raccogliere altra entropia!\n"
 "(Servono ancora %d altri byte)\n"
 
-#: g10/g10.c:149
+#: g10/g10.c:152
 msgid ""
 "@Commands:\n"
 " "
@@ -243,124 +243,124 @@
 "@Comandi:\n"
 " "
 
-#: g10/g10.c:152
+#: g10/g10.c:155
 msgid "|[file]|make a signature"
 msgstr "|[file]|fai una firma"
 
-#: g10/g10.c:153
+#: g10/g10.c:156
 msgid "|[file]|make a clear text signature"
 msgstr "|[file]|fai una firma mantenendo il testo in chiaro"
 
-#: g10/g10.c:154
+#: g10/g10.c:157
 msgid "make a detached signature"
 msgstr "fai una firma separata"
 
-#: g10/g10.c:155
+#: g10/g10.c:158
 msgid "encrypt data"
 msgstr "cifra dati"
 
-#: g10/g10.c:156
+#: g10/g10.c:159
 msgid "encryption only with symmetric cipher"
 msgstr "cifra solo con un cifrario simmetrico"
 
-#: g10/g10.c:157
+#: g10/g10.c:160
 msgid "store only"
 msgstr "immagazzina soltanto"
 
-#: g10/g10.c:158
+#: g10/g10.c:161
 msgid "decrypt data (default)"
 msgstr "decifra dati (predefinito)"
 
-#: g10/g10.c:159
+#: g10/g10.c:162
 msgid "verify a signature"
 msgstr "verifica una firma"
 
-#: g10/g10.c:161
+#: g10/g10.c:164
 msgid "list keys"
 msgstr "elenca le chiavi"
 
-#: g10/g10.c:162
+#: g10/g10.c:165
 msgid "list keys and signatures"
 msgstr "elenca le chiavi e le firme"
 
-#: g10/g10.c:163
+#: g10/g10.c:166
 msgid "check key signatures"
 msgstr "controlla le firme delle chiavi"
 
-#: g10/g10.c:164
+#: g10/g10.c:167
 msgid "list keys and fingerprints"
 msgstr "elenca le chiavi e le impronte digitali"
 
-#: g10/g10.c:165
+#: g10/g10.c:168
 msgid "list secret keys"
 msgstr "elenca le chiavi segrete"
 
-#: g10/g10.c:167
+#: g10/g10.c:170
 msgid "generate a new key pair"
 msgstr "genera una nuova coppia di chiavi"
 
-#: g10/g10.c:169
+#: g10/g10.c:172
 msgid "remove key from the public keyring"
 msgstr "rimuove una chiave dal portachiavi pubblico"
 
-#: g10/g10.c:171
+#: g10/g10.c:174
 msgid "sign or edit a key"
 msgstr "firma o modifica una chiave"
 
-#: g10/g10.c:172
+#: g10/g10.c:175
 msgid "generate a revocation certificate"
 msgstr "genera un certificato di revoca"
 
-#: g10/g10.c:174
+#: g10/g10.c:177
 msgid "export keys"
 msgstr "esporta delle chiavi"
 
-#: g10/g10.c:176
+#: g10/g10.c:179
 msgid "import/merge keys"
 msgstr "importa/aggiungi delle chiavi"
 
-#: g10/g10.c:177
+#: g10/g10.c:181
 msgid "list only the sequence of packets"
 msgstr "elenca solo la sequenza dei pacchetti"
 
-#: g10/g10.c:180
+#: g10/g10.c:184
 msgid "export the ownertrust values"
 msgstr "esporta i valori di fiducia"
 
-#: g10/g10.c:182
+#: g10/g10.c:186
 msgid "import ownertrust values"
 msgstr "importa i valori di fiducia"
 
-#: g10/g10.c:184
+#: g10/g10.c:188
 #, fuzzy
 msgid "|[NAMES]|update the trust database"
 msgstr "|[NAMES]|controlla il TrustDB"
 
-#: g10/g10.c:186
+#: g10/g10.c:190
 msgid "|[NAMES]|check the trust database"
 msgstr "|[NAMES]|controlla il TrustDB"
 
-#: g10/g10.c:187
+#: g10/g10.c:191
 msgid "fix a corrupted trust database"
 msgstr "ripara un database della fiducia rovinato"
 
-#: g10/g10.c:188
+#: g10/g10.c:192
 msgid "De-Armor a file or stdin"
 msgstr "rimuovi l'armatura a un file o a stdin"
 
-#: g10/g10.c:189
+#: g10/g10.c:193
 msgid "En-Armor a file or stdin"
 msgstr "crea l'armatura a un file o a stdin"
 
-#: g10/g10.c:190
+#: g10/g10.c:194
 msgid "|algo [files]|print message digests"
 msgstr "|algo [files]|stampa tutti i message digests"
 
-#: g10/g10.c:191
+#: g10/g10.c:195
 msgid "print all message digests"
 msgstr "stampa tutti i message digests"
 
-#: g10/g10.c:198
+#: g10/g10.c:202
 msgid ""
 "@\n"
 "Options:\n"
@@ -370,129 +370,133 @@
 "Opzioni:\n"
 " "
 
-#: g10/g10.c:200
+#: g10/g10.c:204
 msgid "create ascii armored output"
 msgstr "crea un output ascii con armatura"
 
-#: g10/g10.c:202
+#: g10/g10.c:206
 msgid "use this user-id to sign or decrypt"
 msgstr "usa questo user-id per firmare o decifrare"
 
-#: g10/g10.c:203
+#: g10/g10.c:207
 msgid "use this user-id for encryption"
 msgstr "usa questo user-id per cifrare"
 
-#: g10/g10.c:204
+#: g10/g10.c:208
 msgid "|N|set compress level N (0 disables)"
 msgstr "|N|imposta il livello di compressione (0 disabilita)"
 
-#: g10/g10.c:205
+#: g10/g10.c:210
 msgid "use canonical text mode"
 msgstr "usa il modo testo canonico"
 
-#: g10/g10.c:207
+#: g10/g10.c:212
 msgid "use as output file"
 msgstr "usa come file di output"
 
-#: g10/g10.c:208
+#: g10/g10.c:213
 msgid "verbose"
 msgstr "prolisso"
 
-#: g10/g10.c:209
+#: g10/g10.c:214
+msgid "be somewhat more quiet"
+msgstr ""
+
+#: g10/g10.c:215
 #, fuzzy
 msgid "force v3 signatures"
 msgstr "controlla le firme delle chiavi"
 
 #. { oDryRun, "dry-run",   0, N_("do not make any changes") },
-#: g10/g10.c:211
+#: g10/g10.c:217
 msgid "batch mode: never ask"
 msgstr "modo batch: non fare domande"
 
-#: g10/g10.c:212
+#: g10/g10.c:218
 msgid "assume yes on most questions"
 msgstr "assumi \"s\" a quasi tutte le domande"
 
-#: g10/g10.c:213
+#: g10/g10.c:219
 msgid "assume no on most questions"
 msgstr "assumi \"no\" a quasi tutte le domande"
 
-#: g10/g10.c:214
+#: g10/g10.c:220
 msgid "add this keyring to the list of keyrings"
 msgstr "aggiungi questo portachiavi alla lista"
 
-#: g10/g10.c:215
+#: g10/g10.c:221
 msgid "add this secret keyring to the list"
 msgstr "aggiungi questo portachiavi segreto alla lista"
 
-#: g10/g10.c:216
+#: g10/g10.c:222
 msgid "|NAME|use NAME as default secret key"
 msgstr "|NOME|usa NOME come chiave segreta predefinita"
 
-#: g10/g10.c:217
+#: g10/g10.c:223
 msgid "read options from file"
 msgstr "leggi le opzioni dal file"
 
-#: g10/g10.c:219
+#: g10/g10.c:225
 msgid "set debugging flags"
 msgstr "imposta i flag di debugging"
 
-#: g10/g10.c:220
+#: g10/g10.c:226
 msgid "enable full debugging"
 msgstr "abilita il debugging completo"
 
-#: g10/g10.c:221
+#: g10/g10.c:227
 msgid "|FD|write status info to this FD"
 msgstr "|FD|scrivi le informazioni di stato su questo fd"
 
-#: g10/g10.c:222
+#: g10/g10.c:228
 msgid "do not write comment packets"
 msgstr "non scrivere pacchetti di commento"
 
-#: g10/g10.c:223
+#: g10/g10.c:229
 msgid "(default is 1)"
 msgstr "(predefinito  1)"
 
-#: g10/g10.c:224
+#: g10/g10.c:230
 msgid "(default is 3)"
 msgstr "(predefinito  3)"
 
-#: g10/g10.c:225
+#: g10/g10.c:231
 msgid "|FILE|load extension module FILE"
 msgstr "|FILE|carica il modulo di estensione FILE"
 
-#: g10/g10.c:226
+#: g10/g10.c:232
 msgid "emulate the mode described in RFC1991"
 msgstr "emula il modo descritto nel RFC1991"
 
-#: g10/g10.c:227
+#: g10/g10.c:233
 msgid "|N|use passphrase mode N"
 msgstr "|N|usa il modo N per la passphrase"
 
-#: g10/g10.c:229
+#: g10/g10.c:235
 msgid "|NAME|use message digest algorithm NAME for passphrases"
 msgstr "|NAME|usa l'algoritmo di message digest NOME"
 
-#: g10/g10.c:231
+#: g10/g10.c:237
 msgid "|NAME|use cipher algorithm NAME for passphrases"
 msgstr "|NAME|usa l'algoritmo di cifratura NOME per le passphrase"
 
-#: g10/g10.c:233
+#: g10/g10.c:239
 msgid "|NAME|use cipher algorithm NAME"
 msgstr "|NAME|usa l'algoritmo di cifratura NOME"
 
-#: g10/g10.c:234
+#: g10/g10.c:240
 msgid "|NAME|use message digest algorithm NAME"
 msgstr "|NAME|usa l'algoritmo di message digest NOME"
 
-#: g10/g10.c:235
+#: g10/g10.c:241
 msgid "|N|use compress algorithm N"
 msgstr "|N|usa l'algoritmo di compressione N"
 
-#: g10/g10.c:236
+#: g10/g10.c:242
 msgid "throw keyid field of encrypted packets"
 msgstr "elimina il campo keyid dei pacchetti crittografati"
 
-#: g10/g10.c:244
+#: g10/g10.c:250
 msgid ""
 "@\n"
 "Examples:\n"
@@ -512,19 +516,19 @@
 " --list-keys [nomi]         mostra le chiavi\n"
 " --fingerprint [nomi]       mostra le impronte digitali\n"
 
-#: g10/g10.c:319
+#: g10/g10.c:325
 msgid "Please report bugs to <gnupg-bugs@gnu.org>.\n"
 msgstr "Per favore segnala i bug a <gnupg-bugs@gnu.org>.\n"
 
-#: g10/g10.c:324
+#: g10/g10.c:330
 msgid "Usage: gpgm [options] [files] (-h for help)"
 msgstr "Uso: gpgm [opzioni] [file] (-h per l'aiuto)"
 
-#: g10/g10.c:326
+#: g10/g10.c:332
 msgid "Usage: gpg [options] [files] (-h for help)"
 msgstr "Uso: gpg [opzioni] [file] (-h per l'aiuto)"
 
-#: g10/g10.c:331
+#: g10/g10.c:337
 #, fuzzy
 msgid ""
 "Syntax: gpgm [options] [files]\n"
@@ -533,7 +537,7 @@
 "Sintassi: gpgm [opzioni] [file]\n"
 "Utility di manutenzione di GNUPG\n"
 
-#: g10/g10.c:334
+#: g10/g10.c:340
 msgid ""
 "Syntax: gpg [options] [files]\n"
 "sign, check, encrypt or decrypt\n"
@@ -543,7 +547,7 @@
 "firma, controlla, cifra o decifra\n"
 "l'operazione predefinita dipende dai dati di input\n"
 
-#: g10/g10.c:340
+#: g10/g10.c:346
 msgid ""
 "\n"
 "Supported algorithms:\n"
@@ -551,141 +555,141 @@
 "\n"
 "Algoritmi gestiti:\n"
 
-#: g10/g10.c:415
+#: g10/g10.c:421
 msgid "usage: gpgm [options] "
 msgstr "uso: gpgm [options] "
 
-#: g10/g10.c:417
+#: g10/g10.c:423
 msgid "usage: gpg [options] "
 msgstr "uso: gpg [options] "
 
-#: g10/g10.c:458
+#: g10/g10.c:464
 msgid "conflicting commands\n"
 msgstr "comandi in conflitto\n"
 
-#: g10/g10.c:596
+#: g10/g10.c:602
 #, c-format
 msgid "note: no default option file '%s'\n"
 msgstr "nota: nessun file con opzioni predefinite '%s'\n"
 
-#: g10/g10.c:600
+#: g10/g10.c:606
 #, c-format
 msgid "option file '%s': %s\n"
 msgstr "file con opzioni predefinite '%s': %s\n"
 
-#: g10/g10.c:607
+#: g10/g10.c:613
 #, c-format
 msgid "reading options from '%s'\n"
 msgstr "lettura delle opzioni da '%s'\n"
 
-#: g10/g10.c:778 g10/g10.c:790
+#: g10/g10.c:787 g10/g10.c:799
 msgid "selected cipher algorithm is invalid\n"
 msgstr "l'algoritmo di cifratura selezionato non  valido\n"
 
-#: g10/g10.c:784 g10/g10.c:796
+#: g10/g10.c:793 g10/g10.c:805
 msgid "selected digest algorithm is invalid\n"
 msgstr "l'algoritmo di digest selezionato non  valido\n"
 
-#: g10/g10.c:799
+#: g10/g10.c:808
 #, c-format
 msgid "compress algorithm must be in range %d..%d\n"
 msgstr "l'algoritmo di compressione deve essere tra %d e %d\n"
 
-#: g10/g10.c:801
+#: g10/g10.c:810
 msgid "completes-needed must be greater than 0\n"
 msgstr "completes-needed deve essere maggiore di 0\n"
 
-#: g10/g10.c:803
+#: g10/g10.c:812
 msgid "marginals-needed must be greater than 1\n"
 msgstr "marginals-needed deve essere maggiore di 1\n"
 
-#: g10/g10.c:806
+#: g10/g10.c:815
 msgid "note: simple S2K mode (0) is strongly discouraged\n"
 msgstr "nota: il modo S2K semplice (0)  fortemente scoraggiato\n"
 
-#: g10/g10.c:810
+#: g10/g10.c:819
 msgid "invalid S2K mode; must be 0, 1 or 3\n"
 msgstr "modo S2K non valido; deve essere 0, 1 o 3\n"
 
-#: g10/g10.c:886
+#: g10/g10.c:895
 #, c-format
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr "inizializzazione del trustdb fallita: %s\n"
 
-#: g10/g10.c:892
+#: g10/g10.c:901
 msgid "--store [filename]"
 msgstr "--store [nomefile]"
 
-#: g10/g10.c:900
+#: g10/g10.c:909
 msgid "--symmetric [filename]"
 msgstr "--symmetric [nomefile]"
 
-#: g10/g10.c:908
+#: g10/g10.c:917
 msgid "--encrypt [filename]"
 msgstr "--encrypt [nomefile]"
 
-#: g10/g10.c:921
+#: g10/g10.c:930
 msgid "--sign [filename]"
 msgstr "--sign [nomefile]"
 
-#: g10/g10.c:934
+#: g10/g10.c:943
 msgid "--sign --encrypt [filename]"
 msgstr "--sign --encrypt [nomefile]"
 
-#: g10/g10.c:948
+#: g10/g10.c:957
 msgid "--clearsign [filename]"
 msgstr "--clearsign [nomefile]"
 
-#: g10/g10.c:960
+#: g10/g10.c:969
 msgid "--decrypt [filename]"
 msgstr "--decrypt [nomefile]"
 
-#: g10/g10.c:969
+#: g10/g10.c:978
 msgid "--edit-key username"
 msgstr "--edit-key nomeutente"
 
-#: g10/g10.c:977
+#: g10/g10.c:986
 msgid "--delete-secret-key username"
 msgstr "--delete-secret-key nomeutente"
 
-#: g10/g10.c:980
+#: g10/g10.c:989
 msgid "--delete-key username"
 msgstr "--delete-key nomeutente"
 
-#: g10/encode.c:215 g10/g10.c:1003 g10/keylist.c:80
+#: g10/encode.c:216 g10/g10.c:1012
 #, c-format
 msgid "can't open %s: %s\n"
 msgstr "impossibile aprire '%s': %s\n"
 
-#: g10/g10.c:1014
+#: g10/g10.c:1023
 msgid "-k[v][v][v][c] [userid] [keyring]"
 msgstr "-k[v][v][v][c] [userid] [portachiavi]"
 
-#: g10/g10.c:1069
+#: g10/g10.c:1079
 #, c-format
 msgid "dearmoring failed: %s\n"
 msgstr "rimozione dell'armatura fallita: %s\n"
 
-#: g10/g10.c:1077
+#: g10/g10.c:1087
 #, c-format
 msgid "enarmoring failed: %s\n"
 msgstr "creazione dell'armatura fallita: %s\n"
 
-#: g10/g10.c:1138
+#: g10/g10.c:1148
 #, c-format
 msgid "invalid hash algorithm '%s'\n"
 msgstr "algoritmo di hash non valido '%s'\n"
 
-#: g10/g10.c:1220
+#: g10/g10.c:1230
 msgid "[filename]"
 msgstr "[nomefile]"
 
-#: g10/decrypt.c:59 g10/g10.c:1222 g10/verify.c:66
+#: g10/decrypt.c:59 g10/g10.c:1232 g10/verify.c:66
 #, c-format
 msgid "can't open '%s'\n"
 msgstr "impossibile aprire '%s'\n"
 
-#: g10/g10.c:1269
+#: g10/g10.c:1279
 msgid ""
 "RSA keys are deprecated; please consider creating a new key and use this key "
 "in the future\n"
@@ -1091,7 +1095,7 @@
 msgid "Is this correct (y/n)? "
 msgstr " giusto (s/n)? "
 
-#: g10/keygen.c:561
+#: g10/keygen.c:569
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user "
@@ -1107,51 +1111,51 @@
 "    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n"
 "\n"
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "keygen.name"
 msgstr ""
 
-#: g10/keygen.c:572
+#: g10/keygen.c:580
 msgid "Real name: "
 msgstr "Nome e Cognome: "
 
-#: g10/keygen.c:576
+#: g10/keygen.c:584
 msgid "Invalid character in name\n"
 msgstr "Carattere non valido nel nome\n"
 
-#: g10/keygen.c:578
+#: g10/keygen.c:586
 msgid "Name may not start with a digit\n"
 msgstr "Il nome non pu iniziare con una cifra\n"
 
-#: g10/keygen.c:580
+#: g10/keygen.c:588
 msgid "Name must be at least 5 characters long\n"
 msgstr "Il nome deve essere lungo almeno 5 caratteri\n"
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "keygen.email"
 msgstr ""
 
-#: g10/keygen.c:588
+#: g10/keygen.c:596
 msgid "Email address: "
 msgstr "Indirizzo di Email: "
 
-#: g10/keygen.c:600
+#: g10/keygen.c:608
 msgid "Not a valid email address\n"
 msgstr "L'indirizzo di email non  valido\n"
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "keygen.comment"
 msgstr ""
 
-#: g10/keygen.c:608
+#: g10/keygen.c:616
 msgid "Comment: "
 msgstr "Commento: "
 
-#: g10/keygen.c:614
+#: g10/keygen.c:622
 msgid "Invalid character in comment\n"
 msgstr "Carattere non valido nel commento\n"
 
-#: g10/keygen.c:634
+#: g10/keygen.c:642
 #, c-format
 msgid ""
 "You selected this USER-ID:\n"
@@ -1162,19 +1166,19 @@
 "    \"%s\"\n"
 "\n"
 
-#: g10/keygen.c:637
+#: g10/keygen.c:645
 msgid "NnCcEeOoQq"
 msgstr ""
 
-#: g10/keygen.c:646
+#: g10/keygen.c:654
 msgid "keygen.userid.cmd"
 msgstr ""
 
-#: g10/keygen.c:647
+#: g10/keygen.c:655
 msgid "Change (N)ame, (C)omment, (E)mail or (O)kay/(Q)uit? "
 msgstr "Modifica (N)ome, (C)ommento, (E)mail oppure (O)kay/(Q)uit? "
 
-#: g10/keygen.c:694
+#: g10/keygen.c:707
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
@@ -1182,11 +1186,11 @@
 "Ti serve una passphrase per proteggere la tua chiave segreta.\n"
 "\n"
 
-#: g10/keyedit.c:389 g10/keygen.c:702
+#: g10/keyedit.c:389 g10/keygen.c:715
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr "passphrase non ripetuta correttamente; riprova.\n"
 
-#: g10/keygen.c:708
+#: g10/keygen.c:721
 msgid ""
 "You don't want a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at any time,\n"
@@ -1198,7 +1202,7 @@
 "programma con l'opzione \"--edit-key\".\n"
 "\n"
 
-#: g10/keygen.c:729
+#: g10/keygen.c:742
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -1212,33 +1216,33 @@
 "generatore di numeri casuali la possibilit di raccogliere abbastanza\n"
 "entropia.\n"
 
-#: g10/keygen.c:799
+#: g10/keygen.c:812
 msgid "Key generation can only be used in interactive mode\n"
 msgstr "Una chiave pu essere generata solo in modo interattivo\n"
 
-#: g10/keygen.c:807
+#: g10/keygen.c:820
 msgid "DSA keypair will have 1024 bits.\n"
 msgstr "La coppia DSA avr 1024 bit.\n"
 
-#: g10/keygen.c:813
+#: g10/keygen.c:826
 msgid "Key generation cancelled.\n"
 msgstr "Generazione della chiave annullata.\n"
 
-#: g10/keygen.c:823
+#: g10/keygen.c:836
 #, c-format
 msgid "writing public certificate to '%s'\n"
 msgstr "scrittura del certificato pubblico in '%s'\n"
 
-#: g10/keygen.c:824
+#: g10/keygen.c:837
 #, c-format
 msgid "writing secret certificate to '%s'\n"
 msgstr "scrittura del certificato privato in '%s'\n"
 
-#: g10/keygen.c:901
+#: g10/keygen.c:914
 msgid "public and secret key created and signed.\n"
 msgstr "chiavi pubbliche e segrete create e firmate.\n"
 
-#: g10/keygen.c:903
+#: g10/keygen.c:916
 msgid ""
 "Note that this key cannot be used for encryption.  You may want to use\n"
 "the command \"--add-key\" to generate a secondary key for this purpose.\n"
@@ -1247,20 +1251,20 @@
 "vorrai usare il comando \"--add-key\" per generare una chiave secondaria\n"
 "per questo scopo.\n"
 
-#: g10/keygen.c:917 g10/keygen.c:1002
+#: g10/keygen.c:930 g10/keygen.c:1015
 #, c-format
 msgid "Key generation failed: %s\n"
 msgstr "Generazione della chiave fallita: %s\n"
 
-#: g10/keygen.c:979
+#: g10/keygen.c:992
 msgid "keygen.sub.okay"
 msgstr ""
 
-#: g10/keygen.c:980
+#: g10/keygen.c:993
 msgid "Really create? "
 msgstr "Crea davvero? "
 
-#: g10/encode.c:88
+#: g10/encode.c:88 g10/openfile.c:81 g10/openfile.c:158
 #, c-format
 msgid "%s: can't open: %s\n"
 msgstr "%s: impossibile aprire: %s\n"
@@ -1270,225 +1274,283 @@
 msgid "error creating passphrase: %s\n"
 msgstr "errore nella creazione della passhprase: %s\n"
 
-#: g10/encode.c:154 g10/encode.c:267
+#: g10/encode.c:155 g10/encode.c:269
 #, c-format
 msgid "%s: warning: empty file\n"
 msgstr "%s: attenzione: file vuoto\n"
 
-#: g10/encode.c:221
+#: g10/encode.c:222
 #, c-format
 msgid "reading from '%s'\n"
 msgstr "lettura da '%s'\n"
 
-#: g10/encode.c:395
+#: g10/encode.c:397
 #, c-format
 msgid "%s encrypted for: %s\n"
 msgstr "%s crittografato per: %s\n"
 
-#: g10/getkey.c:854
+#: g10/getkey.c:950
 #, c-format
 msgid "using secondary key %08lX instead of primary key %08lX\n"
 msgstr "uso la chiave secondaria %08lX invece della chiave primaria %08lX\n"
 
-#: g10/import.c:106 g10/trustdb.c:1100
+#: g10/import.c:125 g10/trustdb.c:1046
 #, c-format
 msgid "can't open file: %s\n"
 msgstr "impossibile aprire il file: %s\n"
 
-#: g10/import.c:122
+#: g10/import.c:141
 #, c-format
 msgid "skipping block of type %d\n"
 msgstr "salto un blocco di tipo %d\n"
 
-#: g10/import.c:132 g10/trustdb.c:1175
+#: g10/import.c:148 g10/trustdb.c:1289 g10/trustdb.c:1358
+#, c-format
+msgid "%lu keys so far processed\n"
+msgstr ""
+
+#: g10/import.c:153 g10/trustdb.c:1122
 #, c-format
 msgid "read error: %s\n"
 msgstr "errore di lettura: %s\n"
 
-#: g10/import.c:273 g10/import.c:446
+#: g10/import.c:155
+#, c-format
+msgid "Total number processed: %lu\n"
+msgstr ""
+
+#: g10/import.c:157
+#, c-format
+msgid "          w/o user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:159
+#, c-format
+msgid "              imported: %lu"
+msgstr ""
+
+#: g10/import.c:165
+#, c-format
+msgid "             unchanged: %lu\n"
+msgstr ""
+
+#: g10/import.c:167
+#, c-format
+msgid "          new user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:169
+#, c-format
+msgid "           new subkeys: %lu\n"
+msgstr ""
+
+#: g10/import.c:171
+#, fuzzy, c-format
+msgid "        new signatures: %lu\n"
+msgstr "chiave %08lX: %d nuove firme\n"
+
+#: g10/import.c:173
+#, fuzzy, c-format
+msgid "   new key revocations: %lu\n"
+msgstr "chiave %08lX: chiave pubblica non trovata: %s\n"
+
+#: g10/import.c:175
+#, fuzzy, c-format
+msgid "      secret keys read: %lu\n"
+msgstr "enum_secret_keys fallito: %s\n"
+
+#: g10/import.c:177
+#, fuzzy, c-format
+msgid "  secret keys imported: %lu\n"
+msgstr "chiave %08lX: chiave segreta importata\n"
+
+#: g10/import.c:179
+#, fuzzy, c-format
+msgid " secret keys unchanged: %lu\n"
+msgstr "enum_secret_keys fallito: %s\n"
+
+#: g10/import.c:321 g10/import.c:513
 #, c-format
 msgid "key %08lX: no user id\n"
 msgstr "chiave %08lX: nessun user id\n"
 
-#: g10/import.c:283
+#: g10/import.c:332
 #, c-format
 msgid "key %08lX: no valid user ids\n"
 msgstr "chiave %08lX: nessun user id valido\n"
 
-#: g10/import.c:285
+#: g10/import.c:334
 msgid "this may be caused by a missing self-signature\n"
 msgstr "questo pu essere causato da una autofirma mancante\n"
 
-#: g10/import.c:294 g10/import.c:512
+#: g10/import.c:345 g10/import.c:581
 #, c-format
 msgid "key %08lX: public key not found: %s\n"
 msgstr "chiave %08lX: chiave pubblica non trovata: %s\n"
 
-#: g10/import.c:300
+#: g10/import.c:351
 msgid "no default public keyring\n"
 msgstr "nessun portachiavi pubblico predefinito\n"
 
-#: g10/import.c:304
+#: g10/import.c:355 g10/openfile.c:105
 #, c-format
 msgid "writing to '%s'\n"
 msgstr "scrittura in '%s'\n"
 
-#: g10/import.c:308 g10/import.c:363 g10/import.c:566
+#: g10/import.c:359 g10/import.c:419 g10/import.c:635
 #, c-format
 msgid "can't lock public keyring: %s\n"
 msgstr "impossibile bloccare il portachiavi pubblico: %s\n"
 
-#: g10/import.c:311
+#: g10/import.c:362
 #, c-format
 msgid "can't write to keyring: %s\n"
 msgstr "impossibile scrivere sul portachiavi pubblico: %s\n"
 
-#. we are ready
-#: g10/import.c:314
+#: g10/import.c:366
 #, c-format
 msgid "key %08lX: public key imported\n"
 msgstr "chiave %08lX: chiave pubblica importata\n"
 
-#: g10/import.c:323
+#: g10/import.c:379
 #, c-format
 msgid "key %08lX: doesn't match our copy\n"
 msgstr "chiave %08lX: non corrisponde alla nostra copia\n"
 
-#: g10/import.c:336 g10/import.c:521
+#: g10/import.c:392 g10/import.c:590
 #, c-format
 msgid "key %08lX: can't locate original keyblock: %s\n"
 msgstr "chiave %08lX: impossibile individuare il keyblock originale: %s\n"
 
-#: g10/import.c:343 g10/import.c:528
+#: g10/import.c:399 g10/import.c:597
 #, c-format
 msgid "key %08lX: can't read original keyblock: %s\n"
 msgstr "chiave %08lX: impossibile leggere il keyblock originale: %s\n"
 
-#: g10/import.c:360 g10/import.c:461 g10/import.c:563
+#: g10/import.c:416 g10/import.c:528 g10/import.c:632
 msgid "writing keyblock\n"
 msgstr "scrittura del keyblock\n"
 
-#: g10/import.c:366 g10/import.c:569
+#: g10/import.c:422 g10/import.c:638
 #, c-format
 msgid "can't write keyblock: %s\n"
 msgstr "impossibile aprire il keyblock: %s\n"
 
-#: g10/import.c:370
+#: g10/import.c:427
 #, c-format
 msgid "key %08lX: 1 new user-id\n"
 msgstr "chiave %08lX: un nuovo user id\n"
 
-#: g10/import.c:373
+#: g10/import.c:430
 #, c-format
 msgid "key %08lX: %d new user-ids\n"
 msgstr "chiave %08lX: %d nuovi user id\n"
 
-#: g10/import.c:376
+#: g10/import.c:433
 #, c-format
 msgid "key %08lX: 1 new signature\n"
 msgstr "chiave %08lX: una nuova firma\n"
 
-#: g10/import.c:379
+#: g10/import.c:436
 #, c-format
 msgid "key %08lX: %d new signatures\n"
 msgstr "chiave %08lX: %d nuove firme\n"
 
-#: g10/import.c:382
+#: g10/import.c:439
 #, c-format
 msgid "key %08lX: 1 new subkey\n"
 msgstr "chiave %08lX: una nuova subchiave\n"
 
-#: g10/import.c:385
+#: g10/import.c:442
 #, c-format
 msgid "key %08lX: %d new subkeys\n"
 msgstr "chiave %08lX: %d nuove subchiavi\n"
 
-#: g10/import.c:389
+#: g10/import.c:452
 #, c-format
 msgid "key %08lX: not changed\n"
 msgstr "chiave %08lX: non cambiata\n"
 
-#: g10/import.c:464
+#: g10/import.c:531
 #, c-format
 msgid "can't lock secret keyring: %s\n"
 msgstr "impossibile bloccare il portachiavi segreto: %s\n"
 
-#: g10/import.c:467
+#: g10/import.c:534
 #, c-format
 msgid "can't write keyring: %s\n"
 msgstr "impossibile scrivere il portachiavi: %s\n"
 
 #. we are ready
-#: g10/import.c:470
+#: g10/import.c:537
 #, c-format
 msgid "key %08lX: secret key imported\n"
 msgstr "chiave %08lX: chiave segreta importata\n"
 
 #. we can't merge secret keys
-#: g10/import.c:473
+#: g10/import.c:541
 #, c-format
 msgid "key %08lX: already in secret keyring\n"
 msgstr "chiave %08lX: gi nel portachiavi segreto\n"
 
-#: g10/import.c:477
+#: g10/import.c:546
 #, c-format
 msgid "key %08lX: secret key not found: %s\n"
 msgstr "chiave %08lX: chiave segreta non trovata: %s\n"
 
-#: g10/import.c:506
+#: g10/import.c:575
 #, c-format
 msgid "key %08lX: no public key - can't apply revocation certificate\n"
 msgstr ""
 "chiave %08lX: manca la chiave pubblica - impossibile applicare il\n"
 "certificato di revoca\n"
 
-#: g10/import.c:539
+#: g10/import.c:608
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - rejected\n"
 msgstr "chiave %08lX: certificato di revoca non valido: %s - rifiutato\n"
 
-#. we are ready
-#: g10/import.c:572
+#: g10/import.c:642
 #, c-format
 msgid "key %08lX: revocation certificate imported\n"
 msgstr "chiave %08lX: certificato di revoca importato\n"
 
-#: g10/import.c:602
+#: g10/import.c:673
 #, c-format
 msgid "key %08lX: no user-id for signature\n"
 msgstr "chiave %08lX: nessun user id per la firma\n"
 
-#: g10/import.c:609
+#: g10/import.c:680
 #, c-format
 msgid "key %08lX: unsupported public key algorithm\n"
 msgstr "chiave %08lX: algoritmo a chiave pubblica non gestito\n"
 
-#: g10/import.c:610
+#: g10/import.c:681
 #, c-format
 msgid "key %08lX: invalid self-signature\n"
 msgstr "chiave %08lX: autofirma non valida\n"
 
-#: g10/import.c:639
+#: g10/import.c:710
 #, c-format
 msgid "key %08lX: skipped userid '"
 msgstr "chiave %08lX: saltato l'user id '"
 
-#: g10/import.c:662
+#: g10/import.c:733
 #, c-format
 msgid "key %08lX: revocation certificate at wrong place - skipped\n"
 msgstr "chiave %08lX: certificato di revoca nel posto sbagliato - saltato\n"
 
-#: g10/import.c:670
+#: g10/import.c:741
 #, c-format
 msgid "key %08lX: invalid revocation certificate: %s - skipped\n"
 msgstr "chiave %08lX: certificato di revoca non valido: %s - saltato\n"
 
-#: g10/import.c:732
+#: g10/import.c:803
 #, c-format
 msgid "key %08lX: revocation certificate added\n"
 msgstr "chiave %08lX: certificato di revoca aggiunto\n"
 
-#: g10/import.c:795 g10/import.c:831
+#: g10/import.c:866 g10/import.c:902
 #, c-format
 msgid "key %08lX: our copy has no self-signature\n"
 msgstr "chiave %08lX: la nostra copia non ha autofirma\n"
@@ -1785,164 +1847,164 @@
 msgid "Secret key is available.\n"
 msgstr " disponibile una chiave segreta.\n"
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 msgid "keyedit.cmd"
 msgstr ""
 
-#: g10/keyedit.c:575
+#: g10/keyedit.c:576
 msgid "Command> "
 msgstr "Comando> "
 
-#: g10/keyedit.c:600
+#: g10/keyedit.c:602
 msgid "Need the secret key to to this.\n"
 msgstr "Per fare questo serve la chiave segreta.\n"
 
-#: g10/keyedit.c:619
+#: g10/keyedit.c:621
 msgid "keyedit.save.okay"
 msgstr ""
 
-#: g10/keyedit.c:620
+#: g10/keyedit.c:622
 msgid "Save changes? "
 msgstr "Salvo i cambiamenti? "
 
-#: g10/keyedit.c:622
+#: g10/keyedit.c:624
 msgid "keyedit.cancel.okay"
 msgstr ""
 
-#: g10/keyedit.c:623
+#: g10/keyedit.c:625
 msgid "Quit without saving? "
 msgstr "Esco senza salvare? "
 
-#: g10/keyedit.c:633
+#: g10/keyedit.c:635
 #, c-format
 msgid "update failed: %s\n"
 msgstr "aggiornamento fallito: %s\n"
 
-#: g10/keyedit.c:640
+#: g10/keyedit.c:642
 #, c-format
 msgid "update secret failed: %s\n"
 msgstr "aggiornamento della chiave segreta fallito: %s\n"
 
-#: g10/keyedit.c:647
+#: g10/keyedit.c:649
 msgid "Key not changed so no update needed.\n"
 msgstr "La chiave non  cambiata quindi non sono necessari aggiornamenti.\n"
 
-#: g10/keyedit.c:650 g10/keyedit.c:708
+#: g10/keyedit.c:652 g10/keyedit.c:710
 #, c-format
 msgid "update of trust db failed: %s\n"
 msgstr "aggiornamento del trustdb fallito: %s\n"
 
-#: g10/keyedit.c:681
+#: g10/keyedit.c:683
 msgid "keyedit.sign_all.okay"
 msgstr ""
 
-#: g10/keyedit.c:682
+#: g10/keyedit.c:684
 msgid "Really sign all user ids? "
 msgstr "Firmo davvero tutti gli user id? "
 
-#: g10/keyedit.c:683
+#: g10/keyedit.c:685
 msgid "Hint: Select the user ids to sign\n"
 msgstr "Suggerimento: seleziona gli user id da firmare\n"
 
-#: g10/keyedit.c:719
+#: g10/keyedit.c:721
 msgid "You must select at least one user id.\n"
 msgstr "Devi selezionare almeno un user id.\n"
 
-#: g10/keyedit.c:721
+#: g10/keyedit.c:723
 msgid "You can't delete the last user id!\n"
 msgstr "Non puoi cancellare l'ultimo user id!\n"
 
-#: g10/keyedit.c:723
+#: g10/keyedit.c:725
 msgid "keyedit.remove.uid.okay"
 msgstr ""
 
-#: g10/keyedit.c:724
+#: g10/keyedit.c:726
 msgid "Really remove all selected user ids? "
 msgstr "Tolgo davvero tutti gli user id selezionati? "
 
-#: g10/keyedit.c:725
+#: g10/keyedit.c:727
 msgid "Really remove this user id? "
 msgstr "Tolgo davvero questo user id? "
 
-#: g10/keyedit.c:748
+#: g10/keyedit.c:750
 msgid "You must select at least one key.\n"
 msgstr "Devi selezionare almeno una chiave.\n"
 
-#: g10/keyedit.c:750
+#: g10/keyedit.c:752
 msgid "keyedit.remove.subkey.okay"
 msgstr ""
 
-#: g10/keyedit.c:752
+#: g10/keyedit.c:754
 msgid "Do you really want to delete the selected keys? "
 msgstr "Vuoi davvero cancellare le chiavi selezionate? "
 
-#: g10/keyedit.c:753
+#: g10/keyedit.c:755
 msgid "Do you really want to delete this key? "
 msgstr "Vuoi davvero cancellare questa chiave? "
 
-#: g10/keyedit.c:800
+#: g10/keyedit.c:802
 msgid "Invalid command  (try \"help\")\n"
 msgstr "Comando non valido (prova \"help\")\n"
 
-#: g10/keyedit.c:1178
+#: g10/keyedit.c:1180
 msgid "Please remove selections from the secret keys.\n"
 msgstr ""
 
-#: g10/keyedit.c:1184
+#: g10/keyedit.c:1186
 #, fuzzy
 msgid "Please select at most one secondary key.\n"
 msgstr "Devi selezionare almeno una chiave.\n"
 
-#: g10/keyedit.c:1188
+#: g10/keyedit.c:1190
 msgid "Changing exiration time for a secondary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1190
+#: g10/keyedit.c:1192
 msgid "Changing exiration time for the primary key.\n"
 msgstr ""
 
-#: g10/keyedit.c:1234
+#: g10/keyedit.c:1236
 msgid "No corresponding signature in secret ring\n"
 msgstr ""
 
-#: g10/keyedit.c:1294
+#: g10/keyedit.c:1296
 #, c-format
 msgid "No user id with index %d\n"
 msgstr "Nessun user id con l'indice %d\n"
 
-#: g10/keyedit.c:1339
+#: g10/keyedit.c:1341
 #, c-format
 msgid "No secondary key with index %d\n"
 msgstr "Nessuna chiave secondaria con l'indice %d\n"
 
-#: g10/mainproc.c:200
+#: g10/mainproc.c:201
 #, c-format
 msgid "public key decryption failed: %s\n"
 msgstr "Decifratura della chiave pubblica fallita: %s\n"
 
-#: g10/mainproc.c:230
+#: g10/mainproc.c:231
 #, c-format
 msgid "decryption failed: %s\n"
 msgstr "decifratura fallita: %s\n"
 
-#: g10/mainproc.c:247
+#: g10/mainproc.c:248
 msgid "note: sender requested \"for-your-eyes-only\"\n"
 msgstr "nota: il mittente ha richiesto \"solo-per-i-tuoi-occhi\"\n"
 
-#: g10/mainproc.c:848
+#: g10/mainproc.c:842
 #, c-format
 msgid "Signature made %.*s using %s key ID %08lX\n"
 msgstr "Firma fatta %.*s usando %s key ID %08lX\n"
 
-#: g10/mainproc.c:856
+#: g10/mainproc.c:850
 msgid "BAD signature from \""
 msgstr "Firma NON corretta da \""
 
-#: g10/mainproc.c:857
+#: g10/mainproc.c:851
 msgid "Good signature from \""
 msgstr "Buona firma da \""
 
-#: g10/mainproc.c:868
+#: g10/mainproc.c:862
 #, c-format
 msgid "Can't check signature: %s\n"
 msgstr "Impossibile controllare la firma: %s\n"
@@ -2028,194 +2090,239 @@
 msgid "warning: signature key expired %s\n"
 msgstr "attenzione: firma della chiave scaduta il %s\n"
 
-#: g10/trustdb.c:122
+#: g10/trustdb.c:129
 msgid "The trust DB is corrupted; please run \"gpgm --fix-trust-db\".\n"
 msgstr "Il trustdb  rovinato; per favore esegui \"gpgm --fix-trust-db\".\n"
 
-#: g10/trustdb.c:389
+#: g10/trustdb.c:407
 #, c-format
 msgid "chained sigrec %lu has a wrong owner\n"
 msgstr "la chained sigrec %lu ha il proprietario sbagliato\n"
 
-#: g10/trustdb.c:436
+#: g10/trustdb.c:454
 #, fuzzy, c-format
 msgid "key %08lX: secret key without public key - skipped\n"
 msgstr "chiave %08lX: chiave segreta senza chiave pubblica\n"
 
-#: g10/trustdb.c:442
+#: g10/trustdb.c:460
 #, c-format
 msgid "key %08lX: secret and public key don't match\n"
 msgstr "chiave %08lX: le chiavi segreta e pubblica non corrispondono\n"
 
-#: g10/trustdb.c:452
+#: g10/trustdb.c:470
 #, c-format
 msgid "key %08lX: can't put it into the trustdb\n"
 msgstr "chiave %08lX: impossibile metterla nel trustdb\n"
 
-#: g10/trustdb.c:458
+#: g10/trustdb.c:476
 #, c-format
 msgid "key %08lX: query record failed\n"
 msgstr "chiave %08lX: richiesta del record fallita\n"
 
-#: g10/trustdb.c:467
+#: g10/trustdb.c:485
 #, fuzzy, c-format
 msgid "key %08lX: already in secret key table\n"
 msgstr "chiave %08lX: gi nel portachiavi segreto\n"
 
-#: g10/trustdb.c:470
+#: g10/trustdb.c:488
 #, fuzzy, c-format
 msgid "key %08lX: accepted as secret key.\n"
 msgstr "chiave %08lX: gi nel portachiavi segreto\n"
 
-#: g10/trustdb.c:477
+#: g10/trustdb.c:495
 #, c-format
 msgid "enum_secret_keys failed: %s\n"
 msgstr "enum_secret_keys fallito: %s\n"
 
-#: g10/trustdb.c:1428
+#: g10/trustdb.c:1292 g10/trustdb.c:1360
+#, c-format
+msgid "%lu keys processed\n"
+msgstr ""
+
+#: g10/trustdb.c:1294
+#, fuzzy, c-format
+msgid "\t%lu keys skipped\n"
+msgstr "%s: saltata: %s\n"
+
+#: g10/trustdb.c:1296 g10/trustdb.c:1362
+#, fuzzy, c-format
+msgid "\t%lu keys with errors\n"
+msgstr "Errore durante la scrittura del file"
+
+#: g10/trustdb.c:1298 g10/trustdb.c:1364
+#, c-format
+msgid "\t%lu keys updated\n"
+msgstr ""
+
+#: g10/trustdb.c:1366
+#, c-format
+msgid "\t%lu keys inserted\n"
+msgstr ""
+
+#: g10/trustdb.c:1421
 #, c-format
 msgid "key %08lX: insert trust record failed: %s\n"
 msgstr "chiave %08lX: inserimento del record della fiducia fallito: %s\n"
 
-#: g10/trustdb.c:1432
+#: g10/trustdb.c:1425
 #, c-format
 msgid "key %08lX.%lu: inserted into trustdb\n"
 msgstr "chiave %08lX.%lu: inserita nel trustdb\n"
 
-#: g10/trustdb.c:1440
+#: g10/trustdb.c:1433
 #, c-format
 msgid "key %08lX.%lu: created in future (time warp or clock problem)\n"
 msgstr ""
 "chiave %08lX.%lu: creata nel futuro (salto nel tempo o problema\n"
 "con l'orologio)\n"
 
-#: g10/trustdb.c:1447
+#: g10/trustdb.c:1440
 #, c-format
 msgid "key %08lX.%lu: expired at %s\n"
 msgstr "chiave %08lX.%lu: scaduta il %s\n"
 
-#: g10/trustdb.c:1455
+#: g10/trustdb.c:1448
 #, c-format
 msgid "key %08lX.%lu: trust check failed: %s\n"
 msgstr "chiave %08lX.%lu: controllo della fiducia fallito: %s\n"
 
-#: g10/trustdb.c:1718
+#: g10/trustdb.c:1666
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but marked as checked\n"
 msgstr ""
 
-#: g10/trustdb.c:1722
+#: g10/trustdb.c:1670
 #, c-format
 msgid "note: sig rec %lu[%d] in hintlist of %lu but not marked\n"
 msgstr ""
 
 #. we need the dir record
-#: g10/trustdb.c:1729
+#: g10/trustdb.c:1677
 #, c-format
-msgid "sig rec %lu[%d] in hintlist of %u does not point to a dir record\n"
+msgid "sig rec %lu[%d] in hintlist of %lu does not point to a dir record\n"
 msgstr ""
 
-#: g10/trustdb.c:1735
+#: g10/trustdb.c:1683
 #, c-format
 msgid "lid %lu: no primary key\n"
 msgstr ""
 
-#: g10/trustdb.c:1764
+#: g10/trustdb.c:1716
 #, fuzzy, c-format
 msgid "lid %lu: user id not found in keyblock\n"
 msgstr "%s: utente non trovato\n"
 
-#: g10/trustdb.c:1771
+#: g10/trustdb.c:1720
+#, fuzzy, c-format
+msgid "lid %lu: user id without signature\n"
+msgstr "chiave %08lX: nessun user id per la firma\n"
+
+#: g10/trustdb.c:1727
 #, c-format
 msgid "lid %lu: self-signature in hintlist\n"
 msgstr ""
 
-#: g10/trustdb.c:1776
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (3)\n"
-msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+#: g10/trustdb.c:1738 g10/trustdb.c:2444 g10/trustdb.c:2526
+#, fuzzy
+msgid "Valid certificate revocation"
+msgstr "Certificato danneggiato"
 
-#: g10/trustdb.c:1783
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: very strange: no public key\n"
-msgstr ""
-"chiave %08lX.%lu: uid %02X%02X: nessuna chiave pubblica per la firma %08lX\n"
+#: g10/trustdb.c:1739 g10/trustdb.c:2445 g10/trustdb.c:2527
+#, fuzzy
+msgid "Good certificate"
+msgstr "Certificato danneggiato"
 
-#: g10/trustdb.c:1790 g10/trustdb.c:2225 g10/trustdb.c:2297
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: invalid signature: %s\n"
-msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+#: g10/trustdb.c:1748
+msgid "very strange: no public key\n"
+msgstr ""
 
-#: g10/trustdb.c:1835
+#: g10/trustdb.c:1796
 #, c-format
 msgid "hintlist %lu[%d] of %lu does not point to a dir record\n"
 msgstr ""
 
-#: g10/trustdb.c:1841
+#: g10/trustdb.c:1802
 #, c-format
 msgid "lid %lu does not have a key\n"
 msgstr ""
 
-#: g10/trustdb.c:1851
+#: g10/trustdb.c:1812
 #, fuzzy, c-format
 msgid "lid %lu: can't get keyblock: %s\n"
 msgstr "impossibile aprire il keyblock: %s\n"
 
-#: g10/trustdb.c:2096
+#: g10/trustdb.c:2022
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X: good self-signature\n"
-msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+msgid "key %08lX.%lu: Good subkey binding\n"
+msgstr "chiave %08lX: nessun user id\n"
 
-#: g10/trustdb.c:2188
+#: g10/trustdb.c:2028 g10/trustdb.c:2070
 #, fuzzy, c-format
-msgid ""
-"key %08lX.%lu, uid %02X%02X, sig %08lX: duplicated signature - deleted\n"
-msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+msgid "key %08lX.%lu: Invalid subkey binding: %s\n"
+msgstr "chiave %08lX: nessun user id valido\n"
 
-#: g10/trustdb.c:2211
+#: g10/trustdb.c:2043
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (1)\n"
-msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+msgid "key %08lX.%lu: Valid key revocation\n"
+msgstr "chiave %08lX: chiave pubblica non trovata: %s\n"
 
-#: g10/trustdb.c:2218
+#: g10/trustdb.c:2049
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: weird: no public key\n"
-msgstr ""
-"chiave %08lX.%lu: uid %02X%02X: nessuna chiave pubblica per la firma %08lX\n"
+msgid "key %08lX.%lu: Invalid key revocation: %s\n"
+msgstr "chiave %08lX: chiave pubblica non trovata: %s\n"
 
-#: g10/trustdb.c:2240
+#: g10/trustdb.c:2064
 #, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X: has shadow dir %lu but not yet marked.\n"
-msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+msgid "key %08lX.%lu: Valid subkey revocation\n"
+msgstr "chiave %08lX: chiave pubblica non trovata: %s\n"
 
-#: g10/trustdb.c:2279
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (2)\n"
-msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+#: g10/trustdb.c:2164
+#, fuzzy
+msgid "Good self-signature"
+msgstr "[autofirma]"
 
-#: g10/trustdb.c:2290
-#, fuzzy, c-format
-msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: no public key\n"
+#: g10/trustdb.c:2172
+#, fuzzy
+msgid "Invalid self-signature"
+msgstr "chiave %08lX: autofirma non valida\n"
+
+#: g10/trustdb.c:2183
+#, fuzzy
+msgid "Valid user ID revocation\n"
+msgstr "Scelta non valida.\n"
+
+#: g10/trustdb.c:2190
+#, fuzzy
+msgid "Invalid user ID revocation"
+msgstr "Scelta non valida.\n"
+
+#: g10/trustdb.c:2273
+#, fuzzy
+msgid "Too many preferences"
+msgstr "elenca le impostazioni"
+
+#: g10/trustdb.c:2286
+msgid "Too many preferences items"
 msgstr ""
-"chiave %08lX.%lu: uid %02X%02X: nessuna chiave pubblica per la firma %08lX\n"
 
-#. key binding
-#: g10/trustdb.c:2386
-#, fuzzy, c-format
-msgid "key %08lX: bogus key binding by %08lX\n"
-msgstr "chiave %08lX: nessun user id\n"
+#: g10/trustdb.c:2423
+msgid "Duplicated certificate - deleted"
+msgstr ""
 
-#. key revocation
-#: g10/trustdb.c:2390
-#, fuzzy, c-format
-msgid "key %08lX: bogus key revocation by %08lX\n"
-msgstr "chiave %08lX: chiave pubblica non trovata: %s\n"
+#: g10/trustdb.c:2455
+#, fuzzy
+msgid "public key lost"
+msgstr "Chiave pubblica errata o danneggiata"
 
-#. subkey revocation
-#: g10/trustdb.c:2394
-#, fuzzy, c-format
-msgid "key %08lX: bogus subkey revocation by %08lX\n"
-msgstr "chiave %08lX: chiave pubblica non trovata: %s\n"
+#: g10/trustdb.c:2464 g10/trustdb.c:2547
+#, fuzzy
+msgid "Invalid certificate revocation"
+msgstr "Certificato danneggiato"
+
+#: g10/trustdb.c:2465 g10/trustdb.c:2548
+#, fuzzy
+msgid "Invalid certificate"
+msgstr "Certificato danneggiato"
 
 #: g10/status.c:246
 msgid "No help available"
@@ -2254,6 +2361,26 @@
 msgid "Overwrite (y/N)? "
 msgstr "Sovrascrivo (y/N)? "
 
+#: g10/openfile.c:85
+#, fuzzy
+msgid "writing to stdout\n"
+msgstr "scrittura in '%s'\n"
+
+#: g10/openfile.c:101 g10/openfile.c:165
+#, fuzzy, c-format
+msgid "%s: can't create: %s\n"
+msgstr "%s: impossibile aprire: %s\n"
+
+#: g10/openfile.c:134
+#, fuzzy, c-format
+msgid "assuming signed data in '%s'\n"
+msgstr "impossibile aprire i dati firmati '%s'\n"
+
+#: g10/openfile.c:181
+#, c-format
+msgid "%s: new options file created\n"
+msgstr ""
+
 #: g10/encr-data.c:74
 msgid ""
 "Warning: Message was encrypted with a weak key in the symmetric cipher.\n"
@@ -2271,6 +2398,52 @@
 msgstr ""
 "Impossibile evitare una chiave debole per il cifrario simmetrico;\n"
 "ho provato %d volte!\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (3)\n"
+#~ msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+
+#, fuzzy
+#~ msgid ""
+#~ "key %08lX.%lu, uid %02X%02X, sig %08lX: very strange: no public key\n"
+#~ msgstr ""
+#~ "chiave %08lX.%lu: uid %02X%02X: nessuna chiave pubblica per la firma %08lX\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: invalid signature: %s\n"
+#~ msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X: good self-signature\n"
+#~ msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+
+#, fuzzy
+#~ msgid ""
+#~ "key %08lX.%lu, uid %02X%02X, sig %08lX: duplicated signature - deleted\n"
+#~ msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (1)\n"
+#~ msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: weird: no public key\n"
+#~ msgstr ""
+#~ "chiave %08lX.%lu: uid %02X%02X: nessuna chiave pubblica per la firma %08lX\n"
+
+#, fuzzy
+#~ msgid ""
+#~ "key %08lX.%lu, uid %02X%02X: has shadow dir %lu but not yet marked.\n"
+#~ msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: good signature (2)\n"
+#~ msgstr "chiave %08lX.%lu, uid %02X%02X: firma %s non valida: %s\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X, sig %08lX: no public key\n"
+#~ msgstr ""
+#~ "chiave %08lX.%lu: uid %02X%02X: nessuna chiave pubblica per la firma %08lX\n"
 
 #~ msgid "key %08lX: already in ultikey_table\n"
 #~ msgstr "chiave %08lX: gi in ultikey_table\n"
diff -urN gnupg-0.4.2/po/ru.po gnupg-0.4.3/po/ru.po
--- gnupg-0.4.2/po/ru.po	Thu Jan  1 01:00:00 1970
+++ gnupg-0.4.3/po/ru.po	Sun Nov  8 18:23:32 1998
@@ -0,0 +1,2544 @@
+# I finished the translation without looking at the contrib directory of
+# GPG site. Werner enlightened me about two previous translations and I
+# dared to look in them to correct my translation of questionable phrases.
+# So I'd like to thank:
+# Artem Belevich <artemb@usa.net>
+# Alexey Morozov <morozov@iname.com>
+# Michael Sobolev <mss@transas.com>, 1998
+# Alexey Vyskubov <alexey@alv.stud.pu.ru>, 1998
+# QingLong <qinglong@Bolizm> (couldn't send an email to let you know)
+msgid ""
+msgstr ""
+"POT-Creation-Date: 1998-11-08 18:21+0100\n"
+"Content-Type: text/plain; charset=\n"
+"Date: 1998-01-26 22:08:36+0100\n"
+"From: Gregory Steuck <steuck@iname.com>\n"
+"Xgettext-Options: --default-domain=gnupg --directory=.. --add-comments "
+"--keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
+"Files: util/secmem.c util/argparse.c cipher/random.c cipher/rand-dummy.c "
+"cipher/rand-unix.c cipher/rand-w32.c g10/g10.c g10/pkclist.c g10/keygen.c "
+"g10/decrypt.c g10/encode.c g10/import.c g10/keyedit.c g10/keylist.c "
+"g10/mainproc.c g10/passphrase.c g10/plaintext.c g10/pref.c g10/seckey-cert.c "
+"g10/sig-check.c g10/sign.c g10/trustdb.c g10/verify.c\n"
+
+#: util/secmem.c:77
+msgid "Warning: using insecure memory!\n"
+msgstr ""
+",    !\n"
+"   ,   suid(root).\n"
+"      .\n"
+
+#: util/miscutil.c:110
+msgid "yes"
+msgstr "(y)"
+
+#: util/miscutil.c:111
+msgid "yY"
+msgstr "yY"
+
+#: util/errors.c:54
+msgid "General error"
+msgstr " "
+
+#: util/errors.c:55
+msgid "Unknown packet type"
+msgstr "  "
+
+#: util/errors.c:56
+msgid "Unknown version"
+msgstr " "
+
+#: util/errors.c:57
+msgid "Unknown pubkey algorithm"
+msgstr "     "
+
+#: util/errors.c:58
+msgid "Unknown digest algorithm"
+msgstr "   "
+
+#: util/errors.c:59
+msgid "Bad public key"
+msgstr "  "
+
+#: util/errors.c:60
+msgid "Bad secret key"
+msgstr "  "
+
+#: util/errors.c:61
+msgid "Bad signature"
+msgstr " "
+
+#: util/errors.c:62
+msgid "Checksum error"
+msgstr "  "
+
+#: util/errors.c:63
+msgid "Bad passphrase"
+msgstr " \" \""
+
+#: util/errors.c:64
+msgid "Public key not found"
+msgstr "   "
+
+#: util/errors.c:65
+msgid "Unknown cipher algorithm"
+msgstr "  "
+
+#: util/errors.c:66
+msgid "Can't open the keyring"
+msgstr "  \" \""
+
+#: util/errors.c:67
+msgid "Invalid packet"
+msgstr " "
+
+#: util/errors.c:68
+msgid "Invalid armor"
+msgstr " ASCII-"
+
+#: util/errors.c:69
+msgid "No such user id"
+msgstr "  "
+
+#: util/errors.c:70
+msgid "Secret key not available"
+msgstr "   "
+
+#: util/errors.c:71
+msgid "Wrong secret key used"
+msgstr "   "
+
+#: util/errors.c:72
+msgid "Not supported"
+msgstr " "
+
+#: util/errors.c:73
+msgid "Bad key"
+msgstr " "
+
+#: util/errors.c:74
+msgid "File read error"
+msgstr "  "
+
+#: util/errors.c:75
+msgid "File write error"
+msgstr "  "
+
+#: util/errors.c:76
+msgid "Unknown compress algorithm"
+msgstr "  "
+
+#: util/errors.c:77
+msgid "File open error"
+msgstr "  "
+
+#: util/errors.c:78
+msgid "File create error"
+msgstr "  "
+
+#: util/errors.c:79
+msgid "Invalid passphrase"
+msgstr " \" \""
+
+#: util/errors.c:80
+msgid "Unimplemented pubkey algorithm"
+msgstr "     "
+
+#: util/errors.c:81
+msgid "Unimplemented cipher algorithm"
+msgstr "  "
+
+#: util/errors.c:82
+msgid "Unknown signature class"
+msgstr "  "
+
+#: util/errors.c:83
+msgid "Trust database error"
+msgstr "  Trust-DB (  )"
+
+#: util/errors.c:84
+msgid "Bad MPI"
+msgstr ""
+
+#: util/errors.c:85
+msgid "Resource limit"
+msgstr " "
+
+#: util/errors.c:86
+msgid "Invalid keyring"
+msgstr " \" \""
+
+#: util/errors.c:87
+msgid "Bad certificate"
+msgstr " "
+
+#: util/errors.c:88
+msgid "Malformed user id"
+msgstr "   "
+
+#: util/errors.c:89
+msgid "File close error"
+msgstr "  "
+
+#: util/errors.c:90
+msgid "File rename error"
+msgstr "  "
+
+#: util/errors.c:91
+msgid "File delete error"
+msgstr "  "
+
+#: util/errors.c:92
+msgid "Unexpected data"
+msgstr " "
+
+#: util/errors.c:93
+msgid "Timestamp conflict"
+msgstr "   (timestamp)"
+
+#: util/errors.c:94
+msgid "Unusable pubkey algorithm"
+msgstr "     "
+
+#: util/errors.c:95
+msgid "File exists"
+msgstr " "
+
+#: util/errors.c:96
+msgid "Weak key"
+msgstr " "
+
+#: util/logger.c:177
+#, fuzzy, c-format
+msgid "... this is a bug (%s:%d:%s)\n"
+msgstr "- ...    (%s:%d:%s)\n"
+
+#: util/logger.c:183
+#, c-format
+msgid "you found a bug ... (%s:%d)\n"
+msgstr "     ... (%s:%d)\n"
+
+#: cipher/rand-dummy.c:112
+msgid "warning: using insecure random number generator!!\n"
+msgstr ":     !\n"
+
+#: cipher/rand-dummy.c:113
+msgid ""
+"The random number generator is only a kludge to let\n"
+"it compile - it is in no way a strong RNG!\n"
+"\n"
+"DON'T USE ANY DATA GENERATED BY THIS PROGRAM!!\n"
+"\n"
+msgstr ""
+"    --  ,\n"
+"  ,    !\n"
+"\n"
+"     !\n"
+"\n"
+
+#: cipher/rand-unix.c:149
+#, c-format
+msgid ""
+"\n"
+"Not enough random bytes available.  Please do some other work to give\n"
+"the OS a chance to collect more entropy! (Need %d more bytes)\n"
+msgstr ""
+"\n"
+"  . ,  -, \n"
+"     ! (  %d )\n"
+
+#: g10/g10.c:152
+msgid ""
+"@Commands:\n"
+" "
+msgstr ""
+"@:\n"
+" "
+
+#: g10/g10.c:155
+#, fuzzy
+msgid "|[file]|make a signature"
+msgstr "|[]| "
+
+#: g10/g10.c:156
+#, fuzzy
+msgid "|[file]|make a clear text signature"
+msgstr "|[]|  "
+
+#: g10/g10.c:157
+msgid "make a detached signature"
+msgstr "  "
+
+#: g10/g10.c:158
+msgid "encrypt data"
+msgstr " "
+
+#: g10/g10.c:159
+msgid "encryption only with symmetric cipher"
+msgstr "  "
+
+#: g10/g10.c:160
+msgid "store only"
+msgstr " "
+
+#: g10/g10.c:161
+msgid "decrypt data (default)"
+msgstr "  ( )"
+
+#: g10/g10.c:162
+msgid "verify a signature"
+msgstr " "
+
+#: g10/g10.c:164
+msgid "list keys"
+msgstr " "
+
+#: g10/g10.c:165
+msgid "list keys and signatures"
+msgstr "   "
+
+#: g10/g10.c:166
+msgid "check key signatures"
+msgstr "   "
+
+#: g10/g10.c:167
+msgid "list keys and fingerprints"
+msgstr "    \" \""
+
+#: g10/g10.c:168
+msgid "list secret keys"
+msgstr "  "
+
+#: g10/g10.c:170
+msgid "generate a new key pair"
+msgstr "    (  )"
+
+#: g10/g10.c:172
+msgid "remove key from the public keyring"
+msgstr "   "
+
+#: g10/g10.c:174
+msgid "sign or edit a key"
+msgstr "   "
+
+#: g10/g10.c:175
+msgid "generate a revocation certificate"
+msgstr "  "
+
+#: g10/g10.c:177
+msgid "export keys"
+msgstr " "
+
+#: g10/g10.c:179
+msgid "import/merge keys"
+msgstr "/ "
+
+#: g10/g10.c:181
+msgid "list only the sequence of packets"
+msgstr "   "
+
+#: g10/g10.c:184
+#, fuzzy
+msgid "export the ownertrust values"
+msgstr "  \n"
+
+#: g10/g10.c:186
+#, fuzzy
+msgid "import ownertrust values"
+msgstr "  \n"
+
+#: g10/g10.c:188
+#, fuzzy
+msgid "|[NAMES]|update the trust database"
+msgstr "|[]|   "
+
+#: g10/g10.c:190
+msgid "|[NAMES]|check the trust database"
+msgstr "|[]|   "
+
+#: g10/g10.c:191
+msgid "fix a corrupted trust database"
+msgstr "    "
+
+#: g10/g10.c:192
+msgid "De-Armor a file or stdin"
+msgstr " stdin    ASCII-"
+
+#: g10/g10.c:193
+msgid "En-Armor a file or stdin"
+msgstr " stdin    ASCII-"
+
+#: g10/g10.c:194
+msgid "|algo [files]|print message digests"
+msgstr "|algo [files]|  "
+
+#: g10/g10.c:195
+msgid "print all message digests"
+msgstr "   "
+
+#: g10/g10.c:202
+msgid ""
+"@\n"
+"Options:\n"
+" "
+msgstr ""
+"@\n"
+":\n"
+" "
+
+#: g10/g10.c:204
+msgid "create ascii armored output"
+msgstr "  ASCII-"
+
+#: g10/g10.c:206
+msgid "use this user-id to sign or decrypt"
+msgstr ""
+"       "
+
+#: g10/g10.c:207
+msgid "use this user-id for encryption"
+msgstr "     "
+
+#: g10/g10.c:208
+msgid "|N|set compress level N (0 disables)"
+msgstr "|N|   (0 -  )"
+
+#: g10/g10.c:210
+msgid "use canonical text mode"
+msgstr "   "
+
+#: g10/g10.c:212
+msgid "use as output file"
+msgstr "    "
+
+#: g10/g10.c:213
+msgid "verbose"
+msgstr ""
+
+#: g10/g10.c:214
+msgid "be somewhat more quiet"
+msgstr ""
+
+#: g10/g10.c:215
+#, fuzzy
+msgid "force v3 signatures"
+msgstr "   "
+
+#. { oDryRun, "dry-run",   0, N_("do not make any changes") },
+#: g10/g10.c:217
+msgid "batch mode: never ask"
+msgstr " :   "
+
+#: g10/g10.c:218
+msgid "assume yes on most questions"
+msgstr " \"\"   "
+
+#: g10/g10.c:219
+msgid "assume no on most questions"
+msgstr " \"\"   "
+
+#: g10/g10.c:220
+msgid "add this keyring to the list of keyrings"
+msgstr "      "
+
+#: g10/g10.c:221
+msgid "add this secret keyring to the list"
+msgstr "       "
+
+#: g10/g10.c:222
+msgid "|NAME|use NAME as default secret key"
+msgstr "||       "
+
+#: g10/g10.c:223
+msgid "read options from file"
+msgstr "   "
+
+#: g10/g10.c:225
+msgid "set debugging flags"
+msgstr "  "
+
+#: g10/g10.c:226
+msgid "enable full debugging"
+msgstr "  "
+
+#: g10/g10.c:227
+msgid "|FD|write status info to this FD"
+msgstr "|FD|       (FD)"
+
+#: g10/g10.c:228
+msgid "do not write comment packets"
+msgstr "    "
+
+#: g10/g10.c:229
+msgid "(default is 1)"
+msgstr "(  1)"
+
+#: g10/g10.c:230
+msgid "(default is 3)"
+msgstr "(  3)"
+
+#: g10/g10.c:231
+#, fuzzy
+msgid "|FILE|load extension module FILE"
+msgstr "||    "
+
+#: g10/g10.c:232
+msgid "emulate the mode described in RFC1991"
+msgstr "    RFC1991"
+
+#: g10/g10.c:233
+#, fuzzy
+msgid "|N|use passphrase mode N"
+msgstr "|N|    N\n"
+
+#: g10/g10.c:235
+#, fuzzy
+msgid "|NAME|use message digest algorithm NAME for passphrases"
+msgstr "|| -    "
+
+#: g10/g10.c:237
+#, fuzzy
+msgid "|NAME|use cipher algorithm NAME for passphrases"
+msgstr "||      "
+
+#: g10/g10.c:239
+msgid "|NAME|use cipher algorithm NAME"
+msgstr "||   "
+
+#: g10/g10.c:240
+msgid "|NAME|use message digest algorithm NAME"
+msgstr "|| - "
+
+#: g10/g10.c:241
+msgid "|N|use compress algorithm N"
+msgstr "|N|   N"
+
+#: g10/g10.c:242
+msgid "throw keyid field of encrypted packets"
+msgstr "  keyid   "
+
+#: g10/g10.c:250
+#, fuzzy
+msgid ""
+"@\n"
+"Examples:\n"
+"\n"
+" -se -r Bob [file]          sign and encrypt for user Bob\n"
+" --clearsign [file]         make a clear text signature\n"
+" --detach-sign [file]       make a detached signature\n"
+" --list-keys [names]        show keys\n"
+" --fingerprint [names]      show fingerprints\n"
+msgstr ""
+"@\n"
+":\n"
+"\n"
+" -se -r Bob [file]               Bob\n"
+" --clearsign [file]           \n"
+" --detach-sign [file]         \n"
+" --list-keys [names]          \n"
+" --fingerprint [names]       \" \" \n"
+
+#: g10/g10.c:325
+msgid "Please report bugs to <gnupg-bugs@gnu.org>.\n"
+msgstr ""
+",       "
+"<gnupg-bugs@gnu.org>.\n"
+
+#: g10/g10.c:330
+msgid "Usage: gpgm [options] [files] (-h for help)"
+msgstr ": gpgm [] [] (-h  )"
+
+#: g10/g10.c:332
+msgid "Usage: gpg [options] [files] (-h for help)"
+msgstr ": gpg [] [] (-h  )"
+
+#: g10/g10.c:337
+#, fuzzy
+msgid ""
+"Syntax: gpgm [options] [files]\n"
+"GnuPG maintenance utility\n"
+msgstr ""
+": gpgm [] []\n"
+"  GNUPG\n"
+
+#: g10/g10.c:340
+msgid ""
+"Syntax: gpg [options] [files]\n"
+"sign, check, encrypt or decrypt\n"
+"default operation depends on the input data\n"
+msgstr ""
+": gpg [] []\n"
+",  ,   \n"
+"     \n"
+
+#: g10/g10.c:346
+msgid ""
+"\n"
+"Supported algorithms:\n"
+msgstr ""
+"\n"
+" :\n"
+
+#: g10/g10.c:421
+msgid "usage: gpgm [options] "
+msgstr ": gpgm [] "
+
+#: g10/g10.c:423
+msgid "usage: gpg [options] "
+msgstr ": gpg [] "
+
+#: g10/g10.c:464
+msgid "conflicting commands\n"
+msgstr "Widersprchliche Kommandos\n"
+
+#: g10/g10.c:602
+#, c-format
+msgid "note: no default option file '%s'\n"
+msgstr ":     '%s' \n"
+
+#: g10/g10.c:606
+#, c-format
+msgid "option file '%s': %s\n"
+msgstr "  '%s': %s\n"
+
+#: g10/g10.c:613
+#, c-format
+msgid "reading options from '%s'\n"
+msgstr "   '%s'\n"
+
+#: g10/g10.c:787 g10/g10.c:799
+msgid "selected cipher algorithm is invalid\n"
+msgstr "   \n"
+
+#: g10/g10.c:793 g10/g10.c:805
+msgid "selected digest algorithm is invalid\n"
+msgstr "  -\n"
+
+#: g10/g10.c:808
+#, c-format
+msgid "compress algorithm must be in range %d..%d\n"
+msgstr "      %d  %d\n"
+
+#: g10/g10.c:810
+msgid "completes-needed must be greater than 0\n"
+msgstr "completes-needed    0\n"
+
+#: g10/g10.c:812
+msgid "marginals-needed must be greater than 1\n"
+msgstr "marginals-needed    1\n"
+
+#: g10/g10.c:815
+msgid "note: simple S2K mode (0) is strongly discouraged\n"
+msgstr ":  S2K  (0)   \n"
+
+#: g10/g10.c:819
+msgid "invalid S2K mode; must be 0, 1 or 3\n"
+msgstr "  S2K:   0, 1  3\n"
+
+#: g10/g10.c:895
+#, c-format
+msgid "failed to initialize the TrustDB: %s\n"
+msgstr "    : %s\n"
+
+#: g10/g10.c:901
+msgid "--store [filename]"
+msgstr "--store [ ]"
+
+#: g10/g10.c:909
+msgid "--symmetric [filename]"
+msgstr "--symmetric [ ]"
+
+#: g10/g10.c:917
+msgid "--encrypt [filename]"
+msgstr "--encrypt [ ]"
+
+#: g10/g10.c:930
+msgid "--sign [filename]"
+msgstr "--sign [ ]"
+
+#: g10/g10.c:943
+msgid "--sign --encrypt [filename]"
+msgstr "--sign --encrypt [ ]"
+
+#: g10/g10.c:957
+msgid "--clearsign [filename]"
+msgstr "--clearsign [ ]"
+
+#: g10/g10.c:969
+msgid "--decrypt [filename]"
+msgstr "--decrypt [ ]"
+
+#: g10/g10.c:978
+msgid "--edit-key username"
+msgstr "--edit-key -"
+
+#: g10/g10.c:986
+msgid "--delete-secret-key username"
+msgstr "--delete-secret-key -"
+
+#: g10/g10.c:989
+msgid "--delete-key username"
+msgstr "--delete-key -"
+
+#: g10/encode.c:216 g10/g10.c:1012
+#, c-format
+msgid "can't open %s: %s\n"
+msgstr "   '%s': %s\n"
+
+#: g10/g10.c:1023
+msgid "-k[v][v][v][c] [userid] [keyring]"
+msgstr "-k[v][v][v][c] [ ] [ ]"
+
+#: g10/g10.c:1079
+#, c-format
+msgid "dearmoring failed: %s\n"
+msgstr " : %s\n"
+
+#: g10/g10.c:1087
+#, c-format
+msgid "enarmoring failed: %s\n"
+msgstr " : %s\n"
+
+#: g10/g10.c:1148
+#, c-format
+msgid "invalid hash algorithm '%s'\n"
+msgstr " - '%s'\n"
+
+#: g10/g10.c:1230
+msgid "[filename]"
+msgstr "[ ]"
+
+#: g10/decrypt.c:59 g10/g10.c:1232 g10/verify.c:66
+#, c-format
+msgid "can't open '%s'\n"
+msgstr "   '%s'\n"
+
+#: g10/g10.c:1279
+msgid ""
+"RSA keys are deprecated; please consider creating a new key and use this key "
+"in the future\n"
+msgstr ""
+" RSA   , ,   \n"
+"     \n"
+
+#: g10/armor.c:341 g10/armor.c:381
+msgid "armor header: "
+msgstr ""
+
+#: g10/armor.c:346
+#, fuzzy
+msgid "invalid clearsig header\n"
+msgstr "   \n"
+
+#: g10/armor.c:372
+msgid "invalid armor header: "
+msgstr ""
+
+#: g10/armor.c:449
+#, fuzzy, c-format
+msgid "armor: %s\n"
+msgstr ": %s\n"
+
+#: g10/armor.c:493
+msgid "invalid dash escaped line: "
+msgstr "    : "
+
+#: g10/armor.c:562
+msgid "invalid clear text header: "
+msgstr "  : "
+
+#: g10/armor.c:794
+#, fuzzy, c-format
+msgid "invalid radix64 character %02x skipped\n"
+msgstr "   radix64  %02x \n"
+
+#: g10/armor.c:827
+msgid "premature eof (no CRC)\n"
+msgstr "   ( CRC)\n"
+
+#: g10/armor.c:846
+msgid "premature eof (in CRC)\n"
+msgstr "   ( CRC)\n"
+
+#: g10/armor.c:850
+msgid "malformed CRC\n"
+msgstr "  CRC\n"
+
+#: g10/armor.c:854
+#, c-format
+msgid "CRC error; %06lx - %06lx\n"
+msgstr " CRC; %06lx - %06lx\n"
+
+#: g10/armor.c:873
+msgid "premature eof (in Trailer)\n"
+msgstr "   ( )\n"
+
+#: g10/armor.c:877
+msgid "error in trailer line\n"
+msgstr "   \n"
+
+#: g10/armor.c:1131
+msgid "no valid RFC1991 or OpenPGP data found.\n"
+msgstr "   RFC1991  OpenPGP .\n"
+
+#: g10/pkclist.c:71
+#, c-format
+msgid ""
+"No owner trust defined for %lu:\n"
+"%4u%c/%08lX %s \""
+msgstr ""
+"     %lu:\n"
+"%4u%c/%08lX %s \""
+
+#: g10/pkclist.c:81
+#, fuzzy
+msgid ""
+"Please decide how far you trust this user to correctly\n"
+"verify other users' keys (by looking at passports,\n"
+"checking fingerprints from different sources...)?\n"
+"\n"
+" 1 = Don't know\n"
+" 2 = I do NOT trust\n"
+" 3 = I trust marginally\n"
+" 4 = I trust fully\n"
+" s = please show me more information\n"
+msgstr ""
+"\"\n"
+"\n"
+" ,      \n"
+"  (  ,  \" \"  \n"
+")?\n"
+"\n"
+" 1 =  \n"
+" 2 = ,  \n"
+" 3 =  \n"
+" 4 =  \n"
+" s = ,   \n"
+
+#: g10/pkclist.c:90
+msgid " m = back to the main menu\n"
+msgstr " m =    \n"
+
+# valid user replies (not including 1..4)
+#. a string with valid answers
+#: g10/pkclist.c:95
+msgid "sSmM"
+msgstr "sSmM"
+
+#: g10/pkclist.c:99
+msgid "edit_ownertrust.value"
+msgstr ""
+
+#: g10/pkclist.c:99
+msgid "Your decision? "
+msgstr " ? "
+
+#: g10/pkclist.c:118
+msgid "You will see a list of signators etc. here\n"
+msgstr "      ..\n"
+
+#: g10/pkclist.c:145
+msgid ""
+"Could not find a valid trust path to the key.  Let's see whether we\n"
+"can assign some missing owner trust values.\n"
+"\n"
+msgstr ""
+"      . ,   "
+"\n"
+"   \" \"\n"
+"\n"
+
+#: g10/pkclist.c:168
+msgid ""
+"No owner trust values changed.\n"
+"\n"
+msgstr "    .\n"
+
+#: g10/pkclist.c:188
+msgid "revoked_key.override"
+msgstr ""
+
+#: g10/pkclist.c:189 g10/pkclist.c:279
+msgid "Use this key anyway? "
+msgstr "    ?"
+
+#: g10/pkclist.c:274
+msgid ""
+"It is NOT certain that the key belongs to its owner.\n"
+"If you *really* know what you are doing, you may answer\n"
+"the next question with yes\n"
+"\n"
+msgstr ""
+"  ,    ,\n"
+"   .  \"\"   ,\n"
+"   **   .\n"
+
+#: g10/pkclist.c:278
+msgid "untrusted_key.override"
+msgstr ""
+
+#: g10/pkclist.c:283
+msgid "WARNING: Using untrusted key!\n"
+msgstr ":      !\n"
+
+#: g10/pkclist.c:319
+msgid "WARNING: This key has been revoked by its owner!\n"
+msgstr ":     !\n"
+
+#: g10/pkclist.c:320
+msgid "         This could mean that the signature is forgery.\n"
+msgstr "            ,   .\n"
+
+#: g10/pkclist.c:341
+msgid "Note: This key has expired!\n"
+msgstr ":     !\n"
+
+#: g10/pkclist.c:348
+msgid "WARNING: This key is not certified with a trusted signature!\n"
+msgstr ":      !\n"
+
+#: g10/pkclist.c:350
+msgid ""
+"         There is no indication that the signature belongs to the owner.\n"
+msgstr ""
+"             ,     .\n"
+
+#: g10/pkclist.c:365
+msgid "WARNING: We do NOT trust this key!\n"
+msgstr ":     !\n"
+
+#: g10/pkclist.c:366
+msgid "         The signature is probably a FORGERY.\n"
+msgstr "           -- .\n"
+
+#: g10/pkclist.c:373
+msgid ""
+"WARNING: This key is not certified with sufficiently trusted signatures!\n"
+msgstr ":       !\n"
+
+#: g10/pkclist.c:376
+msgid "         It is not certain that the signature belongs to the owner.\n"
+msgstr "           ,    .\n"
+
+#: g10/pkclist.c:421
+msgid ""
+"You did not specify a user ID. (you may use \"-r\")\n"
+"\n"
+msgstr ""
+"     (  "
+"\"-r\").\n"
+"\n"
+
+#: g10/pkclist.c:425
+msgid "pklist.user_id.enter"
+msgstr ""
+
+#: g10/pkclist.c:426
+msgid "Enter the user ID: "
+msgstr "  : "
+
+#: g10/pkclist.c:437
+msgid "No such user ID.\n"
+msgstr "   .\n"
+
+#: g10/pkclist.c:471 g10/pkclist.c:498
+#, c-format
+msgid "%s: skipped: %s\n"
+msgstr "%s: : %s\n"
+
+#: g10/pkclist.c:479
+#, c-format
+msgid "%s: error checking key: %s\n"
+msgstr "%s:    : %s\n"
+
+#: g10/pkclist.c:505
+msgid "no valid addressees\n"
+msgstr "  \n"
+
+#: g10/keygen.c:123
+msgid "writing self signature\n"
+msgstr " -\n"
+
+#: g10/keygen.c:161
+msgid "writing key binding signature\n"
+msgstr " \"key-binding\" \n"
+
+#: g10/keygen.c:387
+msgid "Please select what kind of key you want:\n"
+msgstr "   :\n"
+
+#: g10/keygen.c:389
+#, c-format
+msgid "   (%d) DSA and ElGamal (default)\n"
+msgstr "   (%d) DSA  ElGamal ( )\n"
+
+#: g10/keygen.c:390
+#, c-format
+msgid "   (%d) ElGamal (sign and encrypt)\n"
+msgstr "   (%d) ElGamal (  )\n"
+
+#: g10/keygen.c:392
+#, c-format
+msgid "   (%d) ElGamal (encrypt only)\n"
+msgstr "   (%d) ElGamal ( )\n"
+
+#: g10/keygen.c:393
+#, c-format
+msgid "   (%d) DSA (sign only)\n"
+msgstr "   (%d) DSA ( )\n"
+
+#: g10/keygen.c:394
+#, c-format
+msgid "   (%d) ElGamal in a v3 packet\n"
+msgstr "   (%d) ElGamal  v3-\n"
+
+#: g10/keygen.c:398
+msgid "keygen.algo"
+msgstr ""
+
+#: g10/keygen.c:398
+msgid "Your selection? "
+msgstr " ? "
+
+#: g10/keygen.c:424
+msgid "Invalid selection.\n"
+msgstr " .\n"
+
+#: g10/keygen.c:436
+#, c-format
+msgid ""
+"About to generate a new %s keypair.\n"
+"              minimum keysize is  768 bits\n"
+"              default keysize is 1024 bits\n"
+"    highest suggested keysize is 2048 bits\n"
+msgstr ""
+"  %s  .\n"
+"                   : 768 \n"
+"                  : 1024 \n"
+"    : 2048 \n"
+
+#: g10/keygen.c:442
+msgid "keygen.size"
+msgstr ""
+
+#: g10/keygen.c:443
+msgid "What keysize do you want? (1024) "
+msgstr "    ? (1024)"
+
+#: g10/keygen.c:448
+msgid "DSA only allows keysizes from 512 to 1024\n"
+msgstr "  DSA  -  512  1024 \n"
+
+#: g10/keygen.c:450
+msgid "keysize too small; 768 is smallest value allowed.\n"
+msgstr "   ,   - 768.\n"
+
+#: g10/keygen.c:453
+#, fuzzy
+msgid ""
+"Keysizes larger than 2048 are not suggested because\n"
+"computations take REALLY long!\n"
+msgstr ""
+"   2048  ,    "
+"  !\n"
+
+#: g10/keygen.c:455
+msgid "keygen.size.huge.okay"
+msgstr ""
+
+#: g10/keygen.c:456
+msgid "Are you sure that you want this keysize? "
+msgstr "     ? "
+
+#: g10/keygen.c:457
+msgid ""
+"Okay, but keep in mind that your monitor and keyboard radiation is also very "
+"vulnerable to attacks!\n"
+msgstr ""
+",   ,       \n"
+"    .\n"
+
+#: g10/keygen.c:464
+msgid "keygen.size.large.okay"
+msgstr ""
+
+#: g10/keygen.c:465
+msgid "Do you really need such a large keysize? "
+msgstr "     ? "
+
+#: g10/keygen.c:471
+#, c-format
+msgid "Requested keysize is %u bits\n"
+msgstr "    %u \n"
+
+#: g10/keygen.c:474 g10/keygen.c:478
+#, c-format
+msgid "rounded up to %u bits\n"
+msgstr "  %u \n"
+
+#: g10/keygen.c:491
+msgid ""
+"Please specify how long the key should be valid.\n"
+"         0 = key does not expire\n"
+"      <n>  = key expires in n days\n"
+"      <n>w = key expires in n weeks\n"
+"      <n>m = key expires in n months\n"
+"      <n>y = key expires in n years\n"
+msgstr ""
+",     .\n"
+"         0 =  \n"
+"      <n>  =    n \n"
+"      <n>w =    n \n"
+"      <n>m =    n \n"
+"      <n>y =    n \n"
+
+#: g10/keygen.c:506
+msgid "keygen.valid"
+msgstr ""
+
+#: g10/keygen.c:506
+msgid "Key is valid for? (0) "
+msgstr "   ? (0) "
+
+#: g10/keygen.c:517
+msgid "invalid value\n"
+msgstr " .\n"
+
+#: g10/keygen.c:522
+msgid "Key does not expire at all\n"
+msgstr " .\n"
+
+#. print the date when the key expires
+#: g10/keygen.c:528
+#, c-format
+msgid "Key expires at %s\n"
+msgstr "   %s\n"
+
+#: g10/keygen.c:532
+msgid "keygen.valid.okay"
+msgstr ""
+
+#: g10/keygen.c:533
+msgid "Is this correct (y/n)? "
+msgstr " ? (y/n) "
+
+#: g10/keygen.c:569
+msgid ""
+"\n"
+"You need a User-ID to identify your key; the software constructs the user "
+"id\n"
+"from Real Name, Comment and Email Address in this form:\n"
+"    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n"
+"\n"
+msgstr ""
+"\n"
+"     ; \n"
+"     ,    email "
+":\n"
+"    \"Vasya Pupkin (KRUTOI) <vasya@mega-cool.ru>\"\n"
+"\n"
+
+#: g10/keygen.c:580
+msgid "keygen.name"
+msgstr ""
+
+#: g10/keygen.c:580
+msgid "Real name: "
+msgstr "  (\" \"): "
+
+#: g10/keygen.c:584
+msgid "Invalid character in name\n"
+msgstr "   \n"
+
+#: g10/keygen.c:586
+msgid "Name may not start with a digit\n"
+msgstr "      .\n"
+
+#: g10/keygen.c:588
+msgid "Name must be at least 5 characters long\n"
+msgstr "        5 .\n"
+
+#: g10/keygen.c:596
+msgid "keygen.email"
+msgstr ""
+
+#: g10/keygen.c:596
+msgid "Email address: "
+msgstr "E-Mail: "
+
+#: g10/keygen.c:608
+msgid "Not a valid email address\n"
+msgstr " E-Mail\n"
+
+#: g10/keygen.c:616
+msgid "keygen.comment"
+msgstr ""
+
+#: g10/keygen.c:616
+msgid "Comment: "
+msgstr ": "
+
+#: g10/keygen.c:622
+msgid "Invalid character in comment\n"
+msgstr "   .\n"
+
+#: g10/keygen.c:642
+#, c-format
+msgid ""
+"You selected this USER-ID:\n"
+"    \"%s\"\n"
+"\n"
+msgstr ""
+"   :\n"
+"    \"%s\"\n"
+"\n"
+
+#: g10/keygen.c:645
+msgid "NnCcEeOoQq"
+msgstr ""
+
+#: g10/keygen.c:654
+msgid "keygen.userid.cmd"
+msgstr ""
+
+#: g10/keygen.c:655
+#, fuzzy
+msgid "Change (N)ame, (C)omment, (E)mail or (O)kay/(Q)uit? "
+msgstr ": N=, C=, E=E-Mail, O=Okay/Q=? "
+
+#: g10/keygen.c:707
+msgid ""
+"You need a Passphrase to protect your secret key.\n"
+"\n"
+msgstr ""
+"      .\n"
+"\n"
+
+#: g10/keyedit.c:389 g10/keygen.c:715
+msgid "passphrase not correctly repeated; try again.\n"
+msgstr "    ,  .\n"
+
+#: g10/keygen.c:721
+msgid ""
+"You don't want a passphrase - this is probably a *bad* idea!\n"
+"I will do it anyway.  You can change your passphrase at any time,\n"
+"using this program with the option \"--edit-key\".\n"
+"\n"
+msgstr ""
+"      - ,  , **\n"
+".   ,   .      \n"
+",      \"--edit-key\".\n"
+"\n"
+
+#: g10/keygen.c:742
+msgid ""
+"We need to generate a lot of random bytes. It is a good idea to perform\n"
+"some other action (work in another window, move the mouse, utilize the\n"
+"network and the disks) during the prime generation; this gives the random\n"
+"number generator a better chance to gain enough entropy.\n"
+msgstr ""
+"     .     \n"
+"-    (   ,  ,\n"
+"    ).    \n"
+"    .\n"
+
+#: g10/keygen.c:812
+msgid "Key generation can only be used in interactive mode\n"
+msgstr "        .\n"
+
+#: g10/keygen.c:820
+msgid "DSA keypair will have 1024 bits.\n"
+msgstr "  DSA    1024 .\n"
+
+#: g10/keygen.c:826
+#, fuzzy
+msgid "Key generation cancelled.\n"
+msgstr "  : %s\n"
+
+#: g10/keygen.c:836
+#, c-format
+msgid "writing public certificate to '%s'\n"
+msgstr "    '%s'\n"
+
+#: g10/keygen.c:837
+#, c-format
+msgid "writing secret certificate to '%s'\n"
+msgstr "    '%s'\n"
+
+#: g10/keygen.c:914
+msgid "public and secret key created and signed.\n"
+msgstr "      .\n"
+
+#: g10/keygen.c:916
+msgid ""
+"Note that this key cannot be used for encryption.  You may want to use\n"
+"the command \"--add-key\" to generate a secondary key for this purpose.\n"
+msgstr ""
+" ,         .\n"
+"    --add-key   "
+"\n"
+"  .\n"
+
+#: g10/keygen.c:930 g10/keygen.c:1015
+#, c-format
+msgid "Key generation failed: %s\n"
+msgstr "   : %s\n"
+
+#: g10/keygen.c:992
+msgid "keygen.sub.okay"
+msgstr ""
+
+#: g10/keygen.c:993
+#, fuzzy
+msgid "Really create? "
+msgstr " ? "
+
+#: g10/encode.c:88 g10/openfile.c:81 g10/openfile.c:158
+#, c-format
+msgid "%s: can't open: %s\n"
+msgstr "%s:  : %s\n"
+
+#: g10/encode.c:107
+#, c-format
+msgid "error creating passphrase: %s\n"
+msgstr "    : %s\n"
+
+#: g10/encode.c:155 g10/encode.c:269
+#, c-format
+msgid "%s: warning: empty file\n"
+msgstr "%s: :  .\n"
+
+#: g10/encode.c:222
+#, c-format
+msgid "reading from '%s'\n"
+msgstr "  '%s'\n"
+
+#: g10/encode.c:397
+#, c-format
+msgid "%s encrypted for: %s\n"
+msgstr "%s  : %s\n"
+
+#: g10/getkey.c:950
+#, c-format
+msgid "using secondary key %08lX instead of primary key %08lX\n"
+msgstr "   %09lX   %08lX%\n"
+
+#: g10/import.c:125 g10/trustdb.c:1046
+#, c-format
+msgid "can't open file: %s\n"
+msgstr "  : %s\n"
+
+#: g10/import.c:141
+#, c-format
+msgid "skipping block of type %d\n"
+msgstr "   %d\n"
+
+#: g10/import.c:148 g10/trustdb.c:1289 g10/trustdb.c:1358
+#, c-format
+msgid "%lu keys so far processed\n"
+msgstr ""
+
+#: g10/import.c:153 g10/trustdb.c:1122
+#, c-format
+msgid "read error: %s\n"
+msgstr " : %s\n"
+
+#: g10/import.c:155
+#, c-format
+msgid "Total number processed: %lu\n"
+msgstr ""
+
+#: g10/import.c:157
+#, c-format
+msgid "          w/o user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:159
+#, c-format
+msgid "              imported: %lu"
+msgstr ""
+
+#: g10/import.c:165
+#, c-format
+msgid "             unchanged: %lu\n"
+msgstr ""
+
+#: g10/import.c:167
+#, c-format
+msgid "          new user IDs: %lu\n"
+msgstr ""
+
+#: g10/import.c:169
+#, c-format
+msgid "           new subkeys: %lu\n"
+msgstr ""
+
+#: g10/import.c:171
+#, fuzzy, c-format
+msgid "        new signatures: %lu\n"
+msgstr " %08lX: %d  \n"
+
+#: g10/import.c:173
+#, c-format
+msgid "   new key revocations: %lu\n"
+msgstr ""
+
+#: g10/import.c:175
+#, c-format
+msgid "      secret keys read: %lu\n"
+msgstr ""
+
+#: g10/import.c:177
+#, fuzzy, c-format
+msgid "  secret keys imported: %lu\n"
+msgstr " %08lX:   \n"
+
+#: g10/import.c:179
+#, fuzzy, c-format
+msgid " secret keys unchanged: %lu\n"
+msgstr "   "
+
+#: g10/import.c:321 g10/import.c:513
+#, c-format
+msgid "key %08lX: no user id\n"
+msgstr " %08lX:   \n"
+
+#: g10/import.c:332
+#, c-format
+msgid "key %08lX: no valid user ids\n"
+msgstr " %08lX:    \n"
+
+#: g10/import.c:334
+msgid "this may be caused by a missing self-signature\n"
+msgstr "     -\n"
+
+#: g10/import.c:345 g10/import.c:581
+#, c-format
+msgid "key %08lX: public key not found: %s\n"
+msgstr " %08lX:    : %s\n"
+
+#: g10/import.c:351
+msgid "no default public keyring\n"
+msgstr "     \n"
+
+#: g10/import.c:355 g10/openfile.c:105
+#, c-format
+msgid "writing to '%s'\n"
+msgstr "  '%s'\n"
+
+#: g10/import.c:359 g10/import.c:419 g10/import.c:635
+#, c-format
+msgid "can't lock public keyring: %s\n"
+msgstr "    : %s\n"
+
+#: g10/import.c:362
+#, c-format
+msgid "can't write to keyring: %s\n"
+msgstr "    : %s\n"
+
+#: g10/import.c:366
+#, c-format
+msgid "key %08lX: public key imported\n"
+msgstr " %08lX:   \n"
+
+#: g10/import.c:379
+#, c-format
+msgid "key %08lX: doesn't match our copy\n"
+msgstr " %08lX:     \n"
+
+#: g10/import.c:392 g10/import.c:590
+#, c-format
+msgid "key %08lX: can't locate original keyblock: %s\n"
+msgstr " %08lX:   original keyblock: %s\n"
+
+#: g10/import.c:399 g10/import.c:597
+#, c-format
+msgid "key %08lX: can't read original keyblock: %s\n"
+msgstr " %08lX:   original keyblock: %s\n"
+
+#: g10/import.c:416 g10/import.c:528 g10/import.c:632
+msgid "writing keyblock\n"
+msgstr "  \n"
+
+#: g10/import.c:422 g10/import.c:638
+#, c-format
+msgid "can't write keyblock: %s\n"
+msgstr "   : %s\n"
+
+#: g10/import.c:427
+#, c-format
+msgid "key %08lX: 1 new user-id\n"
+msgstr " %08lX: 1   \n"
+
+#: g10/import.c:430
+#, c-format
+msgid "key %08lX: %d new user-ids\n"
+msgstr " %08lX: %d   \n"
+
+#: g10/import.c:433
+#, c-format
+msgid "key %08lX: 1 new signature\n"
+msgstr " %08lX: 1  \n"
+
+#: g10/import.c:436
+#, c-format
+msgid "key %08lX: %d new signatures\n"
+msgstr " %08lX: %d  \n"
+
+#: g10/import.c:439
+#, c-format
+msgid "key %08lX: 1 new subkey\n"
+msgstr " %08lX: 1  -\n"
+
+#: g10/import.c:442
+#, c-format
+msgid "key %08lX: %d new subkeys\n"
+msgstr " %08lX: %d  -\n"
+
+#: g10/import.c:452
+#, c-format
+msgid "key %08lX: not changed\n"
+msgstr " %08lX:  \n"
+
+#: g10/import.c:531
+#, c-format
+msgid "can't lock secret keyring: %s\n"
+msgstr "    : %s\n"
+
+#: g10/import.c:534
+#, fuzzy, c-format
+msgid "can't write keyring: %s\n"
+msgstr "   : %s\n"
+
+#. we are ready
+#: g10/import.c:537
+#, c-format
+msgid "key %08lX: secret key imported\n"
+msgstr " %08lX:   \n"
+
+#. we can't merge secret keys
+#: g10/import.c:541
+#, c-format
+msgid "key %08lX: already in secret keyring\n"
+msgstr " %08lX:     \n"
+
+#: g10/import.c:546
+#, c-format
+msgid "key %08lX: secret key not found: %s\n"
+msgstr " %08lX:    : %s\n"
+
+#: g10/import.c:575
+#, c-format
+msgid "key %08lX: no public key - can't apply revocation certificate\n"
+msgstr ""
+" %08lX:    -    "
+"\n"
+
+#: g10/import.c:608
+#, c-format
+msgid "key %08lX: invalid revocation certificate: %s - rejected\n"
+msgstr " %08lX:   : %s - \n"
+
+#: g10/import.c:642
+#, c-format
+msgid "key %08lX: revocation certificate imported\n"
+msgstr " %08lX:   \n"
+
+#: g10/import.c:673
+#, c-format
+msgid "key %08lX: no user-id for signature\n"
+msgstr " %08lX:     \n"
+
+#: g10/import.c:680
+#, c-format
+msgid "key %08lX: unsupported public key algorithm\n"
+msgstr " %08lX:    \n"
+
+#: g10/import.c:681
+#, c-format
+msgid "key %08lX: invalid self-signature\n"
+msgstr " %08lX:  -\n"
+
+#: g10/import.c:710
+#, c-format
+msgid "key %08lX: skipped userid '"
+msgstr " %08lX:    '"
+
+#: g10/import.c:733
+#, c-format
+msgid "key %08lX: revocation certificate at wrong place - skipped\n"
+msgstr " %08lX:      - \n"
+
+#: g10/import.c:741
+#, c-format
+msgid "key %08lX: invalid revocation certificate: %s - skipped\n"
+msgstr " %08lX:   : %s - \n"
+
+#: g10/import.c:803
+#, c-format
+msgid "key %08lX: revocation certificate added\n"
+msgstr " %08lX:   \n"
+
+#: g10/import.c:866 g10/import.c:902
+#, c-format
+msgid "key %08lX: our copy has no self-signature\n"
+msgstr " %08lX:     -\n"
+
+#: g10/keyedit.c:81
+#, c-format
+msgid "%s: user not found\n"
+msgstr "%s:   \n"
+
+#: g10/keyedit.c:164
+#, fuzzy
+msgid "[self-signature]"
+msgstr "[-]\n"
+
+#: g10/keyedit.c:182
+#, fuzzy
+msgid "1 bad signature\n"
+msgstr "1  \n"
+
+#: g10/keyedit.c:184
+#, c-format
+msgid "%d bad signatures\n"
+msgstr "%d  \n"
+
+#: g10/keyedit.c:186
+#, fuzzy
+msgid "1 signature not checked due to a missing key\n"
+msgstr "1    -  \n"
+
+#: g10/keyedit.c:188
+#, fuzzy, c-format
+msgid "%d signatures not checked due to missing keys\n"
+msgstr "%s    -  \n"
+
+#: g10/keyedit.c:190
+#, fuzzy
+msgid "1 signature not checked due to an error\n"
+msgstr "1    - \n"
+
+#: g10/keyedit.c:192
+#, c-format
+msgid "%d signatures not checked due to errors\n"
+msgstr "%s    - \n"
+
+#: g10/keyedit.c:194
+#, fuzzy
+msgid "1 user id without valid self-signature detected\n"
+msgstr " 1     -\n"
+
+#: g10/keyedit.c:196
+#, c-format
+msgid "%d user ids without valid self-signatures detected\n"
+msgstr ""
+" %d     -\n"
+
+#: g10/keyedit.c:258
+#, fuzzy, c-format
+msgid "Already signed by key %08lX\n"
+msgstr "   %08lX.\n"
+
+#: g10/keyedit.c:266
+#, fuzzy, c-format
+msgid "Nothing to sign with key %08lX\n"
+msgstr "   %08lX\n"
+
+#: g10/keyedit.c:275
+#, fuzzy
+msgid ""
+"Are you really sure that you want to sign this key\n"
+"with your key: \""
+msgstr "  ,      :\n"
+
+#: g10/keyedit.c:282
+msgid "sign_uid.okay"
+msgstr ""
+
+#: g10/keyedit.c:282
+msgid "Really sign? "
+msgstr " ? "
+
+#: g10/keyedit.c:303
+#, fuzzy, c-format
+msgid "signing failed: %s\n"
+msgstr " : %s\n"
+
+#: g10/keyedit.c:356
+msgid "This key is not protected.\n"
+msgstr "   .\n"
+
+#: g10/keyedit.c:359
+msgid "Key is protected.\n"
+msgstr "  .\n"
+
+#: g10/keyedit.c:376
+#, c-format
+msgid "Can't edit this key: %s\n"
+msgstr "   : %s\n"
+
+#: g10/keyedit.c:381
+msgid ""
+"Enter the new passphrase for this secret key.\n"
+"\n"
+msgstr ""
+"       .\n"
+"\n"
+
+#: g10/keyedit.c:393
+msgid ""
+"You don't want a passphrase - this is probably a *bad* idea!\n"
+"\n"
+msgstr ""
+"     -    ** !\n"
+"\n"
+
+#: g10/keyedit.c:395
+msgid "change_passwd.empty.okay"
+msgstr ""
+
+#: g10/keyedit.c:396
+msgid "Do you really want to do this? "
+msgstr "   ? "
+
+#: g10/keyedit.c:489
+msgid "quit"
+msgstr ""
+
+#: g10/keyedit.c:489
+msgid "quit this menu"
+msgstr "  "
+
+#: g10/keyedit.c:490
+msgid "q"
+msgstr ""
+
+#: g10/keyedit.c:491
+msgid "save"
+msgstr ""
+
+#: g10/keyedit.c:491
+msgid "save and quit"
+msgstr "  "
+
+#: g10/keyedit.c:492
+msgid "help"
+msgstr ""
+
+#: g10/keyedit.c:492
+msgid "show this help"
+msgstr " "
+
+#: g10/keyedit.c:494
+msgid "fpr"
+msgstr ""
+
+#: g10/keyedit.c:494
+#, fuzzy
+msgid "show fingerprint"
+msgstr " \" \""
+
+#: g10/keyedit.c:495
+#, fuzzy
+msgid "list"
+msgstr ""
+
+#: g10/keyedit.c:495
+#, fuzzy
+msgid "list key and user ids"
+msgstr "    "
+
+#: g10/keyedit.c:496
+msgid "l"
+msgstr ""
+
+#: g10/keyedit.c:497
+msgid "uid"
+msgstr ""
+
+#: g10/keyedit.c:497
+msgid "select user id N"
+msgstr "   N"
+
+#: g10/keyedit.c:498
+msgid "key"
+msgstr ""
+
+#: g10/keyedit.c:498
+msgid "select secondary key N"
+msgstr "   N"
+
+#: g10/keyedit.c:499
+msgid "check"
+msgstr ""
+
+#: g10/keyedit.c:499
+#, fuzzy
+msgid "list signatures"
+msgstr "    "
+
+#: g10/keyedit.c:500
+msgid "c"
+msgstr ""
+
+#: g10/keyedit.c:501
+msgid "sign"
+msgstr ""
+
+#: g10/keyedit.c:501
+#, fuzzy
+msgid "sign the key"
+msgstr " "
+
+#: g10/keyedit.c:502
+msgid "s"
+msgstr ""
+
+#: g10/keyedit.c:503
+msgid "debug"
+msgstr ""
+
+#: g10/keyedit.c:504
+msgid "adduid"
+msgstr ""
+
+#: g10/keyedit.c:504
+msgid "add a user id"
+msgstr "  "
+
+#: g10/keyedit.c:505
+msgid "deluid"
+msgstr ""
+
+#: g10/keyedit.c:505
+#, fuzzy
+msgid "delete user id"
+msgstr "  "
+
+#: g10/keyedit.c:506
+msgid "addkey"
+msgstr ""
+
+#: g10/keyedit.c:506
+#, fuzzy
+msgid "add a secondary key"
+msgstr "  "
+
+#: g10/keyedit.c:507
+msgid "delkey"
+msgstr ""
+
+#: g10/keyedit.c:507
+msgid "delete a secondary key"
+msgstr "  "
+
+#: g10/keyedit.c:508
+msgid "expire"
+msgstr ""
+
+#: g10/keyedit.c:508
+#, fuzzy
+msgid "change the expire date"
+msgstr "  "
+
+#: g10/keyedit.c:509
+msgid "toggle"
+msgstr ""
+
+#: g10/keyedit.c:509
+msgid "toggle between secret and public key listing"
+msgstr "      "
+
+#: g10/keyedit.c:511
+msgid "t"
+msgstr ""
+
+#: g10/keyedit.c:512
+msgid "pref"
+msgstr ""
+
+#: g10/keyedit.c:512
+msgid "list preferences"
+msgstr ""
+
+#: g10/keyedit.c:513
+msgid "passwd"
+msgstr ""
+
+#: g10/keyedit.c:513
+#, fuzzy
+msgid "change the passphrase"
+msgstr "  "
+
+#: g10/keyedit.c:514
+msgid "trust"
+msgstr ""
+
+#: g10/keyedit.c:514
+msgid "change the ownertrust"
+msgstr "  "
+
+#: g10/keyedit.c:532
+msgid "can't do that in batchmode\n"
+msgstr "     .\n"
+
+#. check that they match
+#. FIXME: check that they both match
+#: g10/keyedit.c:559
+#, fuzzy
+msgid "Secret key is available.\n"
+msgstr "  .\n"
+
+#: g10/keyedit.c:576
+msgid "keyedit.cmd"
+msgstr ""
+
+#: g10/keyedit.c:576
+#, fuzzy
+msgid "Command> "
+msgstr "> "
+
+#: g10/keyedit.c:602
+#, fuzzy
+msgid "Need the secret key to to this.\n"
+msgstr "  ,   .\n"
+
+#: g10/keyedit.c:621
+msgid "keyedit.save.okay"
+msgstr ""
+
+#: g10/keyedit.c:622
+msgid "Save changes? "
+msgstr " ? "
+
+#: g10/keyedit.c:624
+msgid "keyedit.cancel.okay"
+msgstr ""
+
+#: g10/keyedit.c:625
+msgid "Quit without saving? "
+msgstr "  ? "
+
+#: g10/keyedit.c:635
+#, fuzzy, c-format
+msgid "update failed: %s\n"
+msgstr "  : %s\n"
+
+#: g10/keyedit.c:642
+#, fuzzy, c-format
+msgid "update secret failed: %s\n"
+msgstr "   : %s\n"
+
+#: g10/keyedit.c:649
+msgid "Key not changed so no update needed.\n"
+msgstr "  ,   .\n"
+
+#: g10/keyedit.c:652 g10/keyedit.c:710
+#, fuzzy, c-format
+msgid "update of trust db failed: %s\n"
+msgstr "     : %s\n"
+
+#: g10/keyedit.c:683
+msgid "keyedit.sign_all.okay"
+msgstr ""
+
+#: g10/keyedit.c:684
+msgid "Really sign all user ids? "
+msgstr "    ? "
+
+#: g10/keyedit.c:685
+msgid "Hint: Select the user ids to sign\n"
+msgstr ""
+":      \n"
+
+#: g10/keyedit.c:721
+msgid "You must select at least one user id.\n"
+msgstr "       .\n"
+
+#: g10/keyedit.c:723
+msgid "You can't delete the last user id!\n"
+msgstr "      !\n"
+
+#: g10/keyedit.c:725
+msgid "keyedit.remove.uid.okay"
+msgstr ""
+
+#: g10/keyedit.c:726
+#, fuzzy
+msgid "Really remove all selected user ids? "
+msgstr "     ? "
+
+#: g10/keyedit.c:727
+#, fuzzy
+msgid "Really remove this user id? "
+msgstr "    ? "
+
+#: g10/keyedit.c:750
+msgid "You must select at least one key.\n"
+msgstr "      .\n"
+
+#: g10/keyedit.c:752
+msgid "keyedit.remove.subkey.okay"
+msgstr ""
+
+#: g10/keyedit.c:754
+#, fuzzy
+msgid "Do you really want to delete the selected keys? "
+msgstr "     ? "
+
+#: g10/keyedit.c:755
+#, fuzzy
+msgid "Do you really want to delete this key? "
+msgstr "     ? "
+
+#: g10/keyedit.c:802
+msgid "Invalid command  (try \"help\")\n"
+msgstr "  ( \"help\")\n"
+
+#: g10/keyedit.c:1180
+msgid "Please remove selections from the secret keys.\n"
+msgstr ""
+
+#: g10/keyedit.c:1186
+#, fuzzy
+msgid "Please select at most one secondary key.\n"
+msgstr "      .\n"
+
+#: g10/keyedit.c:1190
+msgid "Changing exiration time for a secondary key.\n"
+msgstr ""
+
+#: g10/keyedit.c:1192
+msgid "Changing exiration time for the primary key.\n"
+msgstr ""
+
+#: g10/keyedit.c:1236
+msgid "No corresponding signature in secret ring\n"
+msgstr ""
+
+#: g10/keyedit.c:1296
+#, c-format
+msgid "No user id with index %d\n"
+msgstr "     %d\n"
+
+#: g10/keyedit.c:1341
+#, c-format
+msgid "No secondary key with index %d\n"
+msgstr "     %d\n"
+
+#: g10/mainproc.c:201
+#, c-format
+msgid "public key decryption failed: %s\n"
+msgstr "     %s\n"
+
+#: g10/mainproc.c:231
+#, c-format
+msgid "decryption failed: %s\n"
+msgstr "  : %s\n"
+
+#: g10/mainproc.c:248
+msgid "note: sender requested \"for-your-eyes-only\"\n"
+msgstr ":   \"---\"\n"
+
+#: g10/mainproc.c:842
+#, c-format
+msgid "Signature made %.*s using %s key ID %08lX\n"
+msgstr "  %.*s,  %s  %08lX\n"
+
+#: g10/mainproc.c:850
+msgid "BAD signature from \""
+msgstr "   \""
+
+#: g10/mainproc.c:851
+msgid "Good signature from \""
+msgstr "   \""
+
+#: g10/mainproc.c:862
+#, c-format
+msgid "Can't check signature: %s\n"
+msgstr "  : %s\n"
+
+#: g10/passphrase.c:141
+msgid ""
+"\n"
+"You need a passphrase to unlock the secret key for\n"
+"user: \""
+msgstr ""
+"\n"
+"   ,   \n"
+": \""
+
+#: g10/passphrase.c:150
+#, c-format
+msgid "(%u-bit %s key, ID %08lX, created %s)\n"
+msgstr "(%u- %s , ID %08lX,  %s)\n"
+
+# ################################
+# ####### Help msgids ############
+# ################################
+#: g10/passphrase.c:174
+msgid "passphrase.enter"
+msgstr ""
+"Bitte geben Sie die \"Passhrase\" ein; dies ist ein geheimer Satz der aus\n"
+"beliebigen Zeichen bestehen kann.  Was Sie eingegeben wird nicht angezeigt.\n"
+"Zur ihrer eigenen Sicherbeit benutzen Sie biite einen Satz, den sie sich\n"
+"gut merken knne, der aber nicht leicht zu raten ist; Zitate und andere\n"
+"bekannte Texte sind eine SCHLECHTE Wahl, da diese mit Sicherheit online\n"
+"verfgbar sind und durch entsprechende Programme zum Raten der "
+"\"Passphrase\"\n"
+"benutzt werden.  Stze mit persnlicher Bedeutung, die auch noch durch\n"
+"falsche Gro-/Kleinschreibung und eingestreute Sonderzeichen verndert "
+"werden,\n"
+"sind i.d.R. eine gute Wahl"
+
+#: g10/passphrase.c:174
+#, fuzzy
+msgid "Enter pass phrase: "
+msgstr "  : %s\n"
+
+#: g10/passphrase.c:177
+msgid "passphrase.repeat"
+msgstr ""
+"Um sicher zu gehen, da Sie sich bei der Eingabe der \"Passphrase\" nicht\n"
+"vertippt haben, geben Sie diese bitte nochmal ein.  Nur wenn beide Eingaben\n"
+"bereinstimmen, wird die \"Passphrase\" akzeptiert."
+
+#: g10/passphrase.c:178
+#, fuzzy
+msgid "Repeat pass phrase: "
+msgstr "  : %s\n"
+
+#: g10/plaintext.c:102
+msgid "data not saved; use option \"--output\" to save it\n"
+msgstr "   ;  --\"output\"  \n"
+
+#: g10/plaintext.c:214
+#, fuzzy
+msgid "detached_signature.filename"
+msgstr "    "
+
+#: g10/plaintext.c:215
+msgid "Please enter name of data file: "
+msgstr ",    : "
+
+#: g10/plaintext.c:299
+#, c-format
+msgid "can't open signed data '%s'\n"
+msgstr "    '%s' .\n"
+
+#: g10/seckey-cert.c:56
+#, fuzzy, c-format
+msgid "protection algorithm %d is not supported\n"
+msgstr "  %d  \n"
+
+#: g10/seckey-cert.c:169
+msgid "Invalid passphrase; please try again ...\n"
+msgstr "  ,   ...\n"
+
+#: g10/seckey-cert.c:215
+msgid "Warning: Weak key detected - please change passphrase again.\n"
+msgstr ":    -   .\n"
+
+#: g10/sig-check.c:155
+msgid ""
+"this is a PGP generated ElGamal key which is NOT secure for signatures!\n"
+msgstr " ElGamal ,  PGP,     !\n"
+
+#: g10/sig-check.c:165
+msgid "public key created in future (time warp or clock problem)\n"
+msgstr ""
+"     (    "
+" )\n"
+
+#: g10/sig-check.c:170
+#, c-format
+msgid "warning: signature key expired %s\n"
+msgstr ":    %s\n"
+
+#: g10/trustdb.c:129
+msgid "The trust DB is corrupted; please run \"gpgm --fix-trust-db\".\n"
+msgstr "   :  \"gpgm --fix-trust-db\".\n"
+
+#: g10/trustdb.c:407
+#, c-format
+msgid "chained sigrec %lu has a wrong owner\n"
+msgstr ""
+
+#: g10/trustdb.c:454
+#, fuzzy, c-format
+msgid "key %08lX: secret key without public key - skipped\n"
+msgstr "  %08lX:     .\n"
+
+#: g10/trustdb.c:460
+#, c-format
+msgid "key %08lX: secret and public key don't match\n"
+msgstr " %08lX:      .\n"
+
+#: g10/trustdb.c:470
+#, fuzzy, c-format
+msgid "key %08lX: can't put it into the trustdb\n"
+msgstr " %08lX.%lu:      \n"
+
+#: g10/trustdb.c:476
+#, fuzzy, c-format
+msgid "key %08lX: query record failed\n"
+msgstr " %08lX:    \n"
+
+#: g10/trustdb.c:485
+#, fuzzy, c-format
+msgid "key %08lX: already in secret key table\n"
+msgstr " %08lX:     \n"
+
+#: g10/trustdb.c:488
+#, fuzzy, c-format
+msgid "key %08lX: accepted as secret key.\n"
+msgstr " %08lX:     \n"
+
+#: g10/trustdb.c:495
+#, c-format
+msgid "enum_secret_keys failed: %s\n"
+msgstr ""
+
+#: g10/trustdb.c:1292 g10/trustdb.c:1360
+#, c-format
+msgid "%lu keys processed\n"
+msgstr ""
+
+#: g10/trustdb.c:1294
+#, fuzzy, c-format
+msgid "\t%lu keys skipped\n"
+msgstr "%s: : %s\n"
+
+#: g10/trustdb.c:1296 g10/trustdb.c:1362
+#, fuzzy, c-format
+msgid "\t%lu keys with errors\n"
+msgstr "  "
+
+#: g10/trustdb.c:1298 g10/trustdb.c:1364
+#, c-format
+msgid "\t%lu keys updated\n"
+msgstr ""
+
+#: g10/trustdb.c:1366
+#, c-format
+msgid "\t%lu keys inserted\n"
+msgstr ""
+
+#: g10/trustdb.c:1421
+#, fuzzy, c-format
+msgid "key %08lX: insert trust record failed: %s\n"
+msgstr " %08lX.%lu:     : %s\n"
+
+#: g10/trustdb.c:1425
+#, c-format
+msgid "key %08lX.%lu: inserted into trustdb\n"
+msgstr " %08lX.%lu:     \n"
+
+#: g10/trustdb.c:1433
+#, c-format
+msgid "key %08lX.%lu: created in future (time warp or clock problem)\n"
+msgstr ""
+" %08lX.%lu:    (  )\n"
+
+#: g10/trustdb.c:1440
+#, c-format
+msgid "key %08lX.%lu: expired at %s\n"
+msgstr " %08lX.%lu:    %s\n"
+
+#: g10/trustdb.c:1448
+#, c-format
+msgid "key %08lX.%lu: trust check failed: %s\n"
+msgstr " %08lX.%lu:    : %s\n"
+
+#: g10/trustdb.c:1666
+#, c-format
+msgid "note: sig rec %lu[%d] in hintlist of %lu but marked as checked\n"
+msgstr ""
+
+#: g10/trustdb.c:1670
+#, c-format
+msgid "note: sig rec %lu[%d] in hintlist of %lu but not marked\n"
+msgstr ""
+
+#. we need the dir record
+#: g10/trustdb.c:1677
+#, c-format
+msgid "sig rec %lu[%d] in hintlist of %lu does not point to a dir record\n"
+msgstr ""
+
+#: g10/trustdb.c:1683
+#, c-format
+msgid "lid %lu: no primary key\n"
+msgstr ""
+
+#: g10/trustdb.c:1716
+#, fuzzy, c-format
+msgid "lid %lu: user id not found in keyblock\n"
+msgstr "%s:   \n"
+
+#: g10/trustdb.c:1720
+#, fuzzy, c-format
+msgid "lid %lu: user id without signature\n"
+msgstr " %08lX:     \n"
+
+#: g10/trustdb.c:1727
+#, fuzzy, c-format
+msgid "lid %lu: self-signature in hintlist\n"
+msgstr "build_sigrecs: Selbst-Signatur fehlt\n"
+
+#: g10/trustdb.c:1738 g10/trustdb.c:2444 g10/trustdb.c:2526
+#, fuzzy
+msgid "Valid certificate revocation"
+msgstr " "
+
+#: g10/trustdb.c:1739 g10/trustdb.c:2445 g10/trustdb.c:2527
+#, fuzzy
+msgid "Good certificate"
+msgstr " "
+
+#: g10/trustdb.c:1748
+msgid "very strange: no public key\n"
+msgstr ""
+
+#: g10/trustdb.c:1796
+#, c-format
+msgid "hintlist %lu[%d] of %lu does not point to a dir record\n"
+msgstr ""
+
+#: g10/trustdb.c:1802
+#, c-format
+msgid "lid %lu does not have a key\n"
+msgstr ""
+
+#: g10/trustdb.c:1812
+#, fuzzy, c-format
+msgid "lid %lu: can't get keyblock: %s\n"
+msgstr "   : %s\n"
+
+#: g10/trustdb.c:2022
+#, fuzzy, c-format
+msgid "key %08lX.%lu: Good subkey binding\n"
+msgstr " %08lX:   \n"
+
+#: g10/trustdb.c:2028 g10/trustdb.c:2070
+#, fuzzy, c-format
+msgid "key %08lX.%lu: Invalid subkey binding: %s\n"
+msgstr " %08lX:    \n"
+
+#: g10/trustdb.c:2043
+#, fuzzy, c-format
+msgid "key %08lX.%lu: Valid key revocation\n"
+msgstr " %08lX.%lu:    %s\n"
+
+#: g10/trustdb.c:2049
+#, fuzzy, c-format
+msgid "key %08lX.%lu: Invalid key revocation: %s\n"
+msgstr " %08lX:    : %s\n"
+
+#: g10/trustdb.c:2064
+#, fuzzy, c-format
+msgid "key %08lX.%lu: Valid subkey revocation\n"
+msgstr " %08lX:    \n"
+
+#: g10/trustdb.c:2164
+#, fuzzy
+msgid "Good self-signature"
+msgstr "[-]\n"
+
+#: g10/trustdb.c:2172
+#, fuzzy
+msgid "Invalid self-signature"
+msgstr " %08lX:  -\n"
+
+#: g10/trustdb.c:2183
+#, fuzzy
+msgid "Valid user ID revocation\n"
+msgstr " .\n"
+
+#: g10/trustdb.c:2190
+#, fuzzy
+msgid "Invalid user ID revocation"
+msgstr " .\n"
+
+#: g10/trustdb.c:2273
+msgid "Too many preferences"
+msgstr ""
+
+#: g10/trustdb.c:2286
+msgid "Too many preferences items"
+msgstr ""
+
+#: g10/trustdb.c:2423
+msgid "Duplicated certificate - deleted"
+msgstr ""
+
+#: g10/trustdb.c:2455
+#, fuzzy
+msgid "public key lost"
+msgstr "  "
+
+#: g10/trustdb.c:2464 g10/trustdb.c:2547
+#, fuzzy
+msgid "Invalid certificate revocation"
+msgstr " "
+
+#: g10/trustdb.c:2465 g10/trustdb.c:2548
+#, fuzzy
+msgid "Invalid certificate"
+msgstr " "
+
+#: g10/status.c:246
+msgid "No help available"
+msgstr " ."
+
+#: g10/status.c:252
+#, c-format
+msgid "No help available for '%s'"
+msgstr "  '%s' ."
+
+#: g10/pubkey-enc.c:78
+#, c-format
+msgid "anonymous receiver; trying secret key %08lX ...\n"
+msgstr " ,    %08lX ...\n"
+
+#: g10/pubkey-enc.c:84
+msgid "okay, we are the anonymous receiver.\n"
+msgstr ",  --  .\n"
+
+#: g10/pubkey-enc.c:183
+#, c-format
+msgid "note: cipher algorithm %d not found in preferences\n"
+msgstr ":   %d    \n"
+
+#. do not overwrite
+#: g10/openfile.c:58
+#, c-format
+msgid "File '%s' exists. "
+msgstr " '%s' . "
+
+#: g10/openfile.c:59
+msgid "openfile.overwrite.okay"
+msgstr "    (  )"
+
+#: g10/openfile.c:60
+msgid "Overwrite (y/N)? "
+msgstr " (y/N)? "
+
+#: g10/openfile.c:85
+#, fuzzy
+msgid "writing to stdout\n"
+msgstr "  '%s'\n"
+
+#: g10/openfile.c:101 g10/openfile.c:165
+#, fuzzy, c-format
+msgid "%s: can't create: %s\n"
+msgstr "%s:  : %s\n"
+
+#: g10/openfile.c:134
+#, fuzzy, c-format
+msgid "assuming signed data in '%s'\n"
+msgstr "    '%s' .\n"
+
+#: g10/openfile.c:181
+#, c-format
+msgid "%s: new options file created\n"
+msgstr ""
+
+#: g10/encr-data.c:74
+msgid ""
+"Warning: Message was encrypted with a weak key in the symmetric cipher.\n"
+msgstr ""
+":   ,   ,  "
+"  .\n"
+
+#: g10/seskey.c:52
+msgid "weak key created - retrying\n"
+msgstr "  ,   \n"
+
+#: g10/seskey.c:57
+#, c-format
+msgid "cannot avoid weak key for symmetric cipher; tried %d times!\n"
+msgstr ""
+"       ;  %d "
+"!\n"
+
+#~ msgid "key %08lX: already in ultikey_table\n"
+#~ msgstr " %08lX:   ultikey_table\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X: no public key for signature %08lX\n"
+#~ msgstr ""
+#~ " %08lX.%lu, uid %02X%02X:      %08lX\n"
+
+#, fuzzy
+#~ msgid "key %08lX.%lu, uid %02X%02X: invalid %ssignature: %s\n"
+#~ msgstr " %08lX:  -\n"
+
+#, fuzzy
+#~ msgid "error reading sigrec: %s\n"
+#~ msgstr "Fehler beim Erzeugen der \"Passphrase\": %s\n"
+
+#~ msgid "can't write keyring\n"
+#~ msgstr "kann ring nicht schreiben\n"
+
+#~ msgid "make a signature on a key in the keyring"
+#~ msgstr " signieren"
+
+#~ msgid "edit a key signature"
+#~ msgstr "Bearbeiten der Signaturen eines s"
+
+#~ msgid "do not make any changes"
+#~ msgstr "Keine wirklichen nderungen durchfhren"
+
+#~ msgid ""
+#~ "It's up to you to assign a value here; this value will never be exported\n"
+#~ "to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n"
+#~ "to do with the (implicitly created) web-of-certificates.\n"
+#~ msgstr ""
+#~ "Sie mssen selbt entscheiden, welchen Wert Sie hier eintragen; dieser Wert\n"
+#~ "wird niemals an eine dritte Seite weitergegeben.  Wir brauchen diesen Wert,\n"
+#~ "um das \"Netz des Vertrauens\" aufzubauen.  Dieses hat nichts mit dem "
+#~ "(implizit\n"
+#~ "erzeugten) \"Netz der Zertifikate\" zu tun.\n"
+
+#~ msgid "public and secret subkey created.\n"
+#~ msgstr "ffentlicher und privater  erzeugt.\n"
+
+#~ msgid "No public key for %d signatures\n"
+#~ msgstr "Kein ffentlicher  fr %d Signaturen\n"
+
+#~ msgid "[User name not available] "
+#~ msgstr "[Benuzername nicht verfgbar] "
+
+#~ msgid "This is a BAD signature!\n"
+#~ msgstr "Dies ist eine FALSCHE Signatur!\n"
+
+#~ msgid "The signature could not be checked!\n"
+#~ msgstr "Die Signatur konnte nicht geprft werden!\n"
+
+#~ msgid "Checking signatures of this public key certificate:\n"
+#~ msgstr "Die Signaturen dieses Zertifikats werden berprft:\n"
+
+#~ msgid "Do you want to remove some of the invalid signatures? "
+#~ msgstr "Mchten Sie einige der ungltigen Signaturen entfernen? "
+
+#~ msgid "there is a secret key for this public key!\n"
+#~ msgstr "Es gibt einen privaten  zu diesem ffentlichen !\n"
+
+#~ msgid "use option \"--delete-secret-key\" to delete it first.\n"
+#~ msgstr ""
+#~ "Benutzen Sie das Kommando \"--delete-secret-key\", um ihn vorab zu "
+#~ "entfernen.\n"
+
+#~ msgid "can't do that in batchmode without \"--yes\"\n"
+#~ msgstr "Dies kann im Batchmodus ohne \"--yes\" nicht durchgefhrt werden.\n"
+
+#~ msgid "Delete this key from the keyring? "
+#~ msgstr "Diesen  aus dem ring lschen? "
+
+#~ msgid "This is a secret key! - really delete? "
+#~ msgstr "Dies ist ein privater ! - Wirklich lschen? "
+
+#~ msgid "build_sigrecs: key has been revoked\n"
+#~ msgstr "build_sigrecs:  ist widerrufen\n"
diff -urN gnupg-0.4.2/scripts/autogen.sh gnupg-0.4.3/scripts/autogen.sh
--- gnupg-0.4.2/scripts/autogen.sh	Sat Oct 17 17:21:41 1998
+++ gnupg-0.4.3/scripts/autogen.sh	Wed Oct 21 18:08:06 1998
@@ -9,19 +9,25 @@
 else
     echo
     echo "**Error**: You must have "\`autoconf\'" installed to compile $PGM."
-    echo '           (version 2.10 or newer is required'
+    echo '           (version 2.10 or newer is required)'
     DIE="yes"
 fi
 
 if (automake --version) < /dev/null > /dev/null 2>&1 ; then
   if (aclocal --version) < /dev/null > /dev/null 2>&1; then
-    :
+    if (aclocal --version | awk 'NR==1 { if( $4 >= 1.3 ) exit 1; exit 0; }');
+    then
+      echo "**Error**: "\`aclocal\'" is too old."
+      echo '           (version 1.3 or newer is required)'
+      DIE="yes"
+    fi
   else
     echo
     echo "**Error**: Missing "\`aclocal\'".  The version of "\`automake\'
     echo "           installed doesn't appear recent enough."
     DIE="yes"
   fi
+
 else
     echo
     echo "**Error**: You must have "\`automake\'" installed to compile $PGM."
@@ -39,4 +45,6 @@
 automake --gnu;
 autoheader
 autoconf
+
+echo "Ready to run ./configure"
 
diff -urN gnupg-0.4.2/scripts/gnupg-0.4.2.spec gnupg-0.4.3/scripts/gnupg-0.4.2.spec
--- gnupg-0.4.2/scripts/gnupg-0.4.2.spec	Sun Oct 18 17:08:45 1998
+++ gnupg-0.4.3/scripts/gnupg-0.4.2.spec	Thu Jan  1 01:00:00 1970
@@ -1,60 +0,0 @@
-#
-# gnupg -- gnu privacy guard
-# This is a template.  The dist target uses it to create the real file.
-#
-Summary: GPL public key crypto
-Name: gnupg
-Version: 0.4.2
-Release: 3
-Copyright: GPL
-Group: Applications/Cryptography
-Source: ftp://ftp.guug.de/pub/gcrypt/
-URL: http://www.d.shuttle.de/isil/crypt/gnupg.html
-Vendor: TechnoCage
-Packager: Caskey L. Dickson <caskey-at-technocage.com>
-Provides: gpg openpgp
-
-%description
-GNUPG is a complete and free replacement for PGP. Because it does not use
-IDEA or RSA it can be used without any restrictions. GNUPG is nearly in
-compliance with the OpenPGP draft.
-
-%prep
-rm -rf $RPM_BUILD_DIR/gnupg-0.4.2
-tar -xvzf $RPM_SOURCE_DIR/gnupg-0.4.2.tar.gz
-
-%build
-cd gnupg-0.4.2
-chown -R root.root *
-./configure  --prefix=/usr
-make
-
-%install
-cd gnupg-0.4.2
-make install
-
-%files
-%doc gnupg-0.4.2/doc/DETAILS
-%doc gnupg-0.4.2/INSTALL
-%doc gnupg-0.4.2/doc/rfcs
-%doc gnupg-0.4.2/AUTHORS
-%doc gnupg-0.4.2/ABOUT-NLS
-%doc gnupg-0.4.2/COPYING
-%doc gnupg-0.4.2/ChangeLog
-%doc gnupg-0.4.2/NEWS
-%doc gnupg-0.4.2/README
-%doc gnupg-0.4.2/THANKS
-%doc gnupg-0.4.2/TODO
-/usr/man/man1/gpg.1
-/usr/bin/gpg
-/usr/bin/gpgm
-/usr/share/locale/en/LC_MESSAGES/gnupg.mo
-/usr/share/locale/de/LC_MESSAGES/gnupg.mo
-/usr/share/locale/it/LC_MESSAGES/gnupg.mo
-/usr/share/locale/fr/LC_MESSAGES/gnupg.mo
-/usr/lib/gnupg/tiger
-/usr/lib/gnupg/twofish
-
-%attr (4755,root,root) /usr/bin/gpg
-%attr (4755,root,root) /usr/bin/gpgm
-
diff -urN gnupg-0.4.2/scripts/gnupg-0.4.3.spec gnupg-0.4.3/scripts/gnupg-0.4.3.spec
--- gnupg-0.4.2/scripts/gnupg-0.4.3.spec	Thu Jan  1 01:00:00 1970
+++ gnupg-0.4.3/scripts/gnupg-0.4.3.spec	Sun Nov  8 18:24:07 1998
@@ -0,0 +1,60 @@
+#
+# gnupg -- gnu privacy guard
+# This is a template.  The dist target uses it to create the real file.
+#
+Summary: GPL public key crypto
+Name: gnupg
+Version: 0.4.3
+Release: 3
+Copyright: GPL
+Group: Applications/Cryptography
+Source: ftp://ftp.guug.de/pub/gcrypt/
+URL: http://www.d.shuttle.de/isil/crypt/gnupg.html
+Vendor: TechnoCage
+Packager: Caskey L. Dickson <caskey-at-technocage.com>
+Provides: gpg openpgp
+
+%description
+GNUPG is a complete and free replacement for PGP. Because it does not use
+IDEA or RSA it can be used without any restrictions. GNUPG is nearly in
+compliance with the OpenPGP draft.
+
+%prep
+rm -rf $RPM_BUILD_DIR/gnupg-0.4.3
+tar -xvzf $RPM_SOURCE_DIR/gnupg-0.4.3.tar.gz
+
+%build
+cd gnupg-0.4.3
+chown -R root.root *
+./configure  --prefix=/usr
+make
+
+%install
+cd gnupg-0.4.3
+make install
+
+%files
+%doc gnupg-0.4.3/doc/DETAILS
+%doc gnupg-0.4.3/INSTALL
+%doc gnupg-0.4.3/doc/rfcs
+%doc gnupg-0.4.3/AUTHORS
+%doc gnupg-0.4.3/ABOUT-NLS
+%doc gnupg-0.4.3/COPYING
+%doc gnupg-0.4.3/ChangeLog
+%doc gnupg-0.4.3/NEWS
+%doc gnupg-0.4.3/README
+%doc gnupg-0.4.3/THANKS
+%doc gnupg-0.4.3/TODO
+/usr/man/man1/gpg.1
+/usr/bin/gpg
+/usr/bin/gpgm
+/usr/share/locale/en/LC_MESSAGES/gnupg.mo
+/usr/share/locale/de/LC_MESSAGES/gnupg.mo
+/usr/share/locale/it/LC_MESSAGES/gnupg.mo
+/usr/share/locale/fr/LC_MESSAGES/gnupg.mo
+/usr/lib/gnupg/tiger
+/usr/lib/gnupg/twofish
+
+%attr (4755,root,root) /usr/bin/gpg
+%attr (4755,root,root) /usr/bin/gpgm
+
diff -urN gnupg-0.4.2/tools/Makefile.am gnupg-0.4.3/tools/Makefile.am
--- gnupg-0.4.2/tools/Makefile.am	Mon Sep 21 21:37:55 1998
+++ gnupg-0.4.3/tools/Makefile.am	Tue Oct 20 18:22:50 1998
@@ -1,8 +1,8 @@
 ## Process this file with automake to produce Makefile.in
 
-INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl
+INCLUDES = -I$(top_srcdir)/include
 needed_libs = ../cipher/libcipher.a  ../util/libutil.a \
-	      ../mpi/libmpi.a ../util/libutil.a
+	      ../mpi/libmpi.a ../util/libutil.a @INTLLIBS@
 
 noinst_PROGRAMS = mpicalc bftest clean-sat mk-tdata shmtest
 
@@ -15,10 +15,10 @@
 shmtest_SOURCES = shmtest.c
 
 
-mpicalc_LDADD = @INTLLIBS@  $(needed_libs)
-bftest_LDADD = @INTLLIBS@  $(needed_libs)
+mpicalc_LDADD =  $(needed_libs)
+bftest_LDADD =	$(needed_libs)
 
-shmtest_LDADD = @INTLLIBS@ $(needed_libs)
+shmtest_LDADD =  $(needed_libs)
 
 mpicalc bftest shmtest: $(needed_libs)
 
diff -urN gnupg-0.4.2/tools/Makefile.in gnupg-0.4.3/tools/Makefile.in
--- gnupg-0.4.2/tools/Makefile.in	Sun Oct 18 17:08:26 1998
+++ gnupg-0.4.3/tools/Makefile.in	Sun Nov  8 18:23:50 1998
@@ -1,4 +1,4 @@
-# Makefile.in generated automatically by automake 1.2f from Makefile.am
+# Makefile.in generated automatically by automake 1.3 from Makefile.am
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 # This Makefile.in is free software; the Free Software Foundation
@@ -32,6 +32,8 @@
 includedir = @includedir@
 oldincludedir = /usr/include
 
+DISTDIR =
+
 pkgdatadir = $(datadir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
@@ -91,9 +93,9 @@
 ZLIBS = @ZLIBS@
 l = @l@
 
-INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl
+INCLUDES = -I$(top_srcdir)/include
 needed_libs = ../cipher/libcipher.a  ../util/libutil.a \
-	      ../mpi/libmpi.a ../util/libutil.a
+	      ../mpi/libmpi.a ../util/libutil.a @INTLLIBS@
 
 noinst_PROGRAMS = mpicalc bftest clean-sat mk-tdata shmtest
 
@@ -105,10 +107,10 @@
 mk_tdata_SOURCES = mk-tdata.c
 shmtest_SOURCES = shmtest.c
 
-mpicalc_LDADD = @INTLLIBS@  $(needed_libs)
-bftest_LDADD = @INTLLIBS@  $(needed_libs)
+mpicalc_LDADD =  $(needed_libs)
+bftest_LDADD =	$(needed_libs)
 
-shmtest_LDADD = @INTLLIBS@ $(needed_libs)
+shmtest_LDADD =  $(needed_libs)
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
 CONFIG_CLEAN_FILES = 
@@ -152,14 +154,14 @@
 SOURCES = $(mpicalc_SOURCES) $(bftest_SOURCES) $(clean_sat_SOURCES) $(mk_tdata_SOURCES) $(shmtest_SOURCES)
 OBJECTS = $(mpicalc_OBJECTS) $(bftest_OBJECTS) $(clean_sat_OBJECTS) $(mk_tdata_OBJECTS) $(shmtest_OBJECTS)
 
-default: all
+all: Makefile $(PROGRAMS)
 
 .SUFFIXES:
 .SUFFIXES: .S .c .o .s
-$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) 
+$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4)
 	cd $(top_srcdir) && $(AUTOMAKE) --gnu --include-deps tools/Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status
 	cd $(top_builddir) \
 	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
 
@@ -278,8 +280,6 @@
 
 uninstall: 
 
-all: Makefile $(PROGRAMS)
-
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs:
@@ -315,7 +315,7 @@
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
-.PHONY: default mostlyclean-noinstPROGRAMS distclean-noinstPROGRAMS \
+.PHONY: mostlyclean-noinstPROGRAMS distclean-noinstPROGRAMS \
 clean-noinstPROGRAMS maintainer-clean-noinstPROGRAMS \
 mostlyclean-compile distclean-compile clean-compile \
 maintainer-clean-compile tags mostlyclean-tags distclean-tags \
diff -urN gnupg-0.4.2/util/ChangeLog gnupg-0.4.3/util/ChangeLog
--- gnupg-0.4.2/util/ChangeLog	Tue Oct 13 12:40:43 1998
+++ gnupg-0.4.3/util/ChangeLog	Tue Nov  3 19:32:28 1998
@@ -1,3 +1,27 @@
+Tue Nov  3 16:17:56 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* strgutil.c (native_to_utf8): New.
+	(utf8_to_native): New, but only as a stub.
+
+	* argparse.c (optfile_parse): Trimmed spaces from args.
+
+
+Wed Oct 28 08:01:49 1998  me,,,  (wk@tobold)
+
+	* argparse.c (find_long_option): New.
+	(arg_parse): option=value is now allowed. Add a new internal
+	option "--dump-options".
+
+Thu Oct 22 16:25:49 1998  Michael Roth	(mroth@nessie.de)
+
+	* fileutil.c (make_basename): New.
+	(make_dirname): New.
+
+Wed Oct 21 12:20:29 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* util.c (iobuf_flush): autoincreasing of a temp. iobuf
+	(iobuf_temp_with_content): New.
+
 Tue Oct 13 12:40:13 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* util.c (.nofast): set this variable
diff -urN gnupg-0.4.2/util/Makefile.am gnupg-0.4.3/util/Makefile.am
--- gnupg-0.4.2/util/Makefile.am	Thu Oct  8 19:06:23 1998
+++ gnupg-0.4.3/util/Makefile.am	Tue Oct 20 16:21:15 1998
@@ -1,6 +1,6 @@
 ## Process this file with automake to produce Makefile.in
 
-INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl
 
 noinst_LIBRARIES = libutil.a
 
diff -urN gnupg-0.4.2/util/Makefile.in gnupg-0.4.3/util/Makefile.in
--- gnupg-0.4.2/util/Makefile.in	Sun Oct 18 17:08:15 1998
+++ gnupg-0.4.3/util/Makefile.in	Sun Nov  8 18:23:39 1998
@@ -1,4 +1,4 @@
-# Makefile.in generated automatically by automake 1.2f from Makefile.am
+# Makefile.in generated automatically by automake 1.3 from Makefile.am
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 # This Makefile.in is free software; the Free Software Foundation
@@ -32,6 +32,8 @@
 includedir = @includedir@
 oldincludedir = /usr/include
 
+DISTDIR =
+
 pkgdatadir = $(datadir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
@@ -91,7 +93,7 @@
 ZLIBS = @ZLIBS@
 l = @l@
 
-INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl -I../intl
+INCLUDES = -I$(top_srcdir)/include -I$(top_srcdir)/intl
 
 noinst_LIBRARIES = libutil.a
 
@@ -125,14 +127,14 @@
 SOURCES = $(libutil_a_SOURCES)
 OBJECTS = $(libutil_a_OBJECTS)
 
-default: all
+all: Makefile $(LIBRARIES)
 
 .SUFFIXES:
 .SUFFIXES: .S .c .o .s
-$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) 
+$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4)
 	cd $(top_srcdir) && $(AUTOMAKE) --gnu --include-deps util/Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status
 	cd $(top_builddir) \
 	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
 
@@ -258,8 +260,6 @@
 
 uninstall: 
 
-all: Makefile $(LIBRARIES)
-
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs:
@@ -295,7 +295,7 @@
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
-.PHONY: default mostlyclean-noinstLIBRARIES distclean-noinstLIBRARIES \
+.PHONY: mostlyclean-noinstLIBRARIES distclean-noinstLIBRARIES \
 clean-noinstLIBRARIES maintainer-clean-noinstLIBRARIES \
 mostlyclean-compile distclean-compile clean-compile \
 maintainer-clean-compile tags mostlyclean-tags distclean-tags \
diff -urN gnupg-0.4.2/util/argparse.c gnupg-0.4.3/util/argparse.c
--- gnupg-0.4.2/util/argparse.c	Wed Oct  7 19:34:08 1998
+++ gnupg-0.4.3/util/argparse.c	Tue Nov  3 19:32:34 1998
@@ -1,13 +1,13 @@
 /* [argparse.c wk 17.06.97] Argument Parser for option handling
  *	Copyright (C) 1998 Free Software Foundation, Inc.
- *  This file is part of WkLib.
+ *  This file is part of GnuPG.
  *
- *  WkLib is free software; you can redistribute it and/or modify
+ *  GnuPG is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
- *  WkLib is distributed in the hope that it will be useful,
+ *  GnuPG is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
@@ -73,8 +73,8 @@
  *     Bit 4 : Do not skip the first arg.
  *     Bit 5 : allow usage of long option with only one dash
  *     Bit 6 : ignore --version
- *     all other bits must be set to zero, this value is modified by the function
- *     so assume this is write only.
+ *     all other bits must be set to zero, this value is modified by the
+ *     function, so assume this is write only.
  *  Local flags (for each option):
  *     Bit 2-0 : 0 = does not take an argument
  *		 1 = takes int argument
@@ -83,8 +83,8 @@
  *		 4 = takes ulong argument
  *     Bit 3 : argument is optional (r_type will the be set to 0)
  *     Bit 4 : allow 0x etc. prefixed values.
- *     Bit 7 : this is an command and not an option
- *  If can stop the option processing by setting opts to NULL, the function will
+ *     Bit 7 : this is a command and not an option
+ *  You stop the option processing by setting opts to NULL, the function will
  *  then return 0.
  * @Return Value
  *   Returns the args.r_opt or 0 if ready
@@ -167,8 +167,14 @@
 	else {
 	    if( arg->r_opt == -3 )
 		s = "Missing argument for option \"%.50s\"\n";
+	    else if( arg->r_opt == -6 )
+		s = "Option \"%.50s\" does not expect an argument\n";
 	    else if( arg->r_opt == -7 )
 		s = "Invalid command \"%.50s\"\n";
+	    else if( arg->r_opt == -8 )
+		s = "Option \"%.50s\" is ambiguous\n";
+	    else if( arg->r_opt == -9 )
+		s = "Command \"%.50s\" is ambiguous\n";
 	    else
 		s = "Invalid option \"%.50s\"\n";
 	    log_error(s, arg->internal.last? arg->internal.last:"[??]" );
@@ -186,10 +192,15 @@
  * Lines starting with '#' are comment lines.
  * Syntax is simply a keyword and the argument.
  * Valid keywords are all keywords from the long_opt list without
- * the leading dashes. The special keywords help, warranty and version
+ * the leading dashes. The special keywords "help", "warranty" and "version"
  * are not valid here.
  * Caller must free returned strings.
  * If called with FP set to NULL command line args are parse instead.
+ *
+ * Q: Should we allow the syntax
+ *     keyword = value
+ *    and accept for boolean options a value of 1/0, yes/no or true/false?
+ * Note: Abbreviation of options is here not allowed.
  */
 int
 optfile_parse( FILE *fp, const char *filename, unsigned *lineno,
@@ -229,7 +240,7 @@
 		    arg->r_opt = (opts[index].flags & 256)? -7:-2;
 		else if( (opts[index].flags & 8) ) /* no argument */
 		    arg->r_opt = -3;	       /* error */
-		else			       /* no or optiona argument */
+		else			       /* no or optional argument */
 		    arg->r_type = 0;	       /* okay */
 		break;
 	    }
@@ -253,6 +264,7 @@
 		    else
 			buffer[i] = 0;
 
+		    trim_spaces( buffer );
 		    if( !set_opt_arg(arg, opts[index].flags, buffer) )
 			m_free(buffer);
 		}
@@ -331,6 +343,37 @@
 
 
 
+static int
+find_long_option( ARGPARSE_OPTS *opts, const char *keyword )
+{
+    int i;
+    size_t n;
+
+    /* Would be better if we can do a binary search, but it is not
+       possible to reorder our option table because we would mess
+       up our help strings - What we can do is: Build a nice option
+       lookup table wehn this function is first invoked */
+    if( !*keyword )
+	return -1;
+    for(i=0; opts[i].short_opt; i++ )
+	if( opts[i].long_opt && !strcmp( opts[i].long_opt, keyword) )
+	    return i;
+    /* not found, see whether it is an abbreviation */
+    n = strlen( keyword );
+    for(i=0; opts[i].short_opt; i++ ) {
+	if( opts[i].long_opt && !strncmp( opts[i].long_opt, keyword, n ) ) {
+	    int j;
+	    for(j=i+1; opts[j].short_opt; j++ ) {
+		if( opts[j].long_opt
+		    && !strncmp( opts[j].long_opt, keyword, n ) )
+		    return -2;	/* abbreviation is ambiguous */
+	    }
+	    return i;
+	}
+    }
+    return -1;
+}
+
 int
 arg_parse( ARGPARSE_ARGS *arg, ARGPARSE_OPTS *opts)
 {
@@ -369,6 +412,8 @@
 	goto leave;
     }
     else if( *s == '-' && s[1] == '-' ) { /* long option */
+	char *argpos;
+
 	arg->internal.inarg = 0;
 	if( !s[2] && !(arg->flags & (1<<3)) ) { /* stop option processing */
 	    arg->internal.stopped = 1;
@@ -376,37 +421,57 @@
 	    goto next_one;
 	}
 
-	for(i=0; opts[i].short_opt; i++ )
-	    if( opts[i].long_opt && !strcmp( opts[i].long_opt, s+2) )
-		break;
+	argpos = strchr( s+2, '=' );
+	if( argpos )
+	    *argpos = 0;
+	i = find_long_option( opts, s+2 );
+	if( argpos )
+	    *argpos = '=';
 
-	if( !opts[i].short_opt && !strcmp( "help", s+2) )
+	if( i < 0 && !strcmp( "help", s+2) )
 	    show_help(opts, arg->flags);
-	else if( !opts[i].short_opt && !strcmp( "version", s+2) ) {
+	else if( i < 0 && !strcmp( "version", s+2) ) {
 	    if( !(arg->flags & (1<<6)) ) {
 		show_version();
 		exit(0);
 	    }
 	}
-	else if( !opts[i].short_opt && !strcmp( "warranty", s+2) ) {
+	else if( i < 0 && !strcmp( "warranty", s+2) ) {
 	    puts( strusage(16) );
 	    exit(0);
 	}
+	else if( i < 0 && !strcmp( "dump-options", s+2) ) {
+	    for(i=0; opts[i].short_opt; i++ )
+		if( opts[i].long_opt )
+		    printf( "--%s\n", opts[i].long_opt );
+	    exit(0);
+	}
 
-	arg->r_opt = opts[i].short_opt;
-	if( !opts[i].short_opt ) {
+	if( i == -2 ) /* ambiguous option */
+	    arg->r_opt = (opts[i].flags & 256)? -9:-8;
+	else if( i == -1 ) {
 	    arg->r_opt = (opts[i].flags & 256)? -7:-2;
 	    arg->r.ret_str = s+2;
 	}
+	else
+	    arg->r_opt = opts[i].short_opt;
+	if( i < 0 )
+	    ;
 	else if( (opts[i].flags & 7) ) {
-	    s2 = argv[1];
+	    if( argpos ) {
+		s2 = argpos+1;
+		if( !*s2 )
+		    s2 = NULL;
+	    }
+	    else
+		s2 = argv[1];
 	    if( !s2 && (opts[i].flags & 8) ) { /* no argument but it is okay*/
 		arg->r_type = 0;	       /* because it is optional */
 	    }
 	    else if( !s2 ) {
 		arg->r_opt = -3; /* missing argument */
 	    }
-	    else if( *s2 == '-' && (opts[i].flags & 8) ) {
+	    else if( !argpos && *s2 == '-' && (opts[i].flags & 8) ) {
 		/* the argument is optional and the next seems to be
 		 * an option. We do not check this possible option
 		 * but assume no argument */
@@ -414,11 +479,16 @@
 	    }
 	    else {
 		set_opt_arg(arg, opts[i].flags, s2);
-		argc--; argv++; index++; /* skip one */
+		if( !argpos ) {
+		    argc--; argv++; index++; /* skip one */
+		}
 	    }
 	}
 	else { /* does not take an argument */
-	    arg->r_type = 0;
+	    if( argpos )
+		arg->r_type = -6; /* argument not expected */
+	    else
+		arg->r_type = 0;
 	}
 	argc--; argv++; index++; /* set to next one */
     }
diff -urN gnupg-0.4.2/util/fileutil.c gnupg-0.4.3/util/fileutil.c
--- gnupg-0.4.2/util/fileutil.c	Wed Oct  7 19:34:08 1998
+++ gnupg-0.4.3/util/fileutil.c	Sat Oct 24 14:21:55 1998
@@ -30,6 +30,61 @@
 #include "ttyio.h"
 
 
+/***************
+ * Extract from a given path the filename component.
+ *
+ */
+char *
+make_basename(const char *filepath)
+{
+    char *p;
+    
+    if ( !(p=strrchr(filepath, '/')) )
+      #ifdef __MINGW32__
+        if ( !(p=strrchr(filepath, '\\')) )
+            if ( !(p=strrchr(filepath, ':')) )
+      #endif
+              {
+                return m_strdup(filepath);
+              }
+    
+    return m_strdup(p+1);
+}
+
+
+
+/***************
+ * Extract from a given filename the path prepended to it.
+ * If their isn't a path prepended to the filename, a dot
+ * is returned ('.').
+ *
+ */
+char *
+make_dirname(const char *filepath)
+{
+    char *dirname;
+    int  dirname_length;
+    char *p;
+    
+    if ( !(p=strrchr(filepath, '/')) )
+      #ifdef __MINGW32__
+        if ( !(p=strrchr(filepath, '\\')) )
+            if ( !(p=strrchr(filepath, ':')) )
+      #endif
+              {
+                return m_strdup(".");
+              }
+    
+    dirname_length = p-filepath;
+    dirname = m_alloc(dirname_length+1);
+    strncpy(dirname, filepath, dirname_length);
+    dirname[dirname_length] = 0;
+    
+    return dirname;
+}
+
+
+
 /****************
  * Construct a filename from the NULL terminated list of parts.
  * Tilde expansion is done here.
diff -urN gnupg-0.4.2/util/iobuf.c gnupg-0.4.3/util/iobuf.c
--- gnupg-0.4.2/util/iobuf.c	Sat Oct 17 19:00:12 1998
+++ gnupg-0.4.3/util/iobuf.c	Wed Oct 21 12:21:37 1998
@@ -483,6 +483,18 @@
     return a;
 }
 
+IOBUF
+iobuf_temp_with_content( const char *buffer, size_t length )
+{
+    IOBUF a;
+
+    a = iobuf_alloc(3, length );
+    memcpy( a->d.buf, buffer, length );
+    a->d.len = length;
+
+    return a;
+}
+
 
 /****************
  * Create a head iobuf for reading from a file
@@ -877,8 +889,19 @@
 	return 0;
 
     /*log_debug("iobuf-%d.%d: flush\n", a->no, a->subno );*/
-    if( a->usage == 3 )
-	log_bug("temp buffer too short\n");
+    if( a->usage == 3 ) { /* must increase the size of the temp buffer */
+	char *newbuf;
+	size_t newsize = a->d.size + 8192;
+
+	log_debug("increasing temp iobuf from %lu to %lu\n",
+		    (ulong)a->d.size, (ulong)newsize );
+	newbuf = m_alloc( newsize );
+	memcpy( newbuf, a->d.buf, a->d.len );
+	m_free(a->d.buf);
+	a->d.buf = newbuf;
+	a->d.size = newsize;
+	return 0;
+    }
     else if( a->usage != 2 )
 	log_bug("flush on non-output iobuf\n");
     else if( !a->filter )
diff -urN gnupg-0.4.2/util/logger.c gnupg-0.4.3/util/logger.c
--- gnupg-0.4.2/util/logger.c	Wed Oct  7 19:34:08 1998
+++ gnupg-0.4.3/util/logger.c	Tue Oct 20 19:37:14 1998
@@ -161,7 +161,7 @@
     va_list arg_ptr ;
 
     putc('\n', stderr );
-    print_prefix("Ooops: ");
+    print_prefix("Ohhhh jeeee: ");
     va_start( arg_ptr, fmt ) ;
     vfprintf(stderr,fmt,arg_ptr) ;
     va_end(arg_ptr);
@@ -174,7 +174,7 @@
 void
 g10_log_bug0( const char *file, int line, const char *func )
 {
-    log_bug(_("Ohhhh jeeee ... this is a bug (%s:%d:%s)\n"), file, line, func );
+    log_bug(_("... this is a bug (%s:%d:%s)\n"), file, line, func );
 }
 #else
 void
diff -urN gnupg-0.4.2/util/strgutil.c gnupg-0.4.3/util/strgutil.c
--- gnupg-0.4.2/util/strgutil.c	Wed Oct  7 19:34:08 1998
+++ gnupg-0.4.3/util/strgutil.c	Tue Nov  3 17:17:37 1998
@@ -179,6 +179,52 @@
     return count;
 }
 
+
+/****************
+ * Convert string, which is in native encoding to UTF8 and return the
+ * new allocated UTF8 string.
+ * This code assumes that native is iso-8859-1.
+ */
+char *
+native_to_utf8( const char *string )
+{
+    const byte *s;
+    char *buffer;
+    byte *p;
+    size_t length=0;
+
+    for(s=string; *s; s++ ) {
+	length++;
+	if( *s & 0x80 )
+	    length++;
+    }
+    buffer = m_alloc( length + 1 );
+    for(p=buffer, s=string; *s; s++ ) {
+	if( *s & 0x80 ) {
+	    *p++ = 0xc0 | ((*s >> 6) & 3);
+	    *p++ = 0x80 | ( *s & 0x3f );
+	}
+	else
+	    *p++ = *s;
+    }
+    *p = 0;
+    return buffer;
+}
+
+
+/****************
+ * Convert string, which is in UTF8 to native encoding.  Replace
+ * illegal encodings by some "\xnn".
+ * This code assumes that native is iso-8859-1.
+ */
+char *
+utf8_to_native( const char *string )
+{
+    /* FIXME: Not yet done */
+    return m_strdup(string);
+}
+
+
 /*********************************************
  ********** missing string functions *********
  *********************************************/
diff -urN gnupg-0.4.2/zlib/Makefile.in gnupg-0.4.3/zlib/Makefile.in
--- gnupg-0.4.2/zlib/Makefile.in	Sun Oct 18 17:08:12 1998
+++ gnupg-0.4.3/zlib/Makefile.in	Sun Nov  8 18:23:36 1998
@@ -1,4 +1,4 @@
-# Makefile.in generated automatically by automake 1.2f from Makefile.am
+# Makefile.in generated automatically by automake 1.3 from Makefile.am
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998 Free Software Foundation, Inc.
 # This Makefile.in is free software; the Free Software Foundation
@@ -37,6 +37,8 @@
 includedir = @includedir@
 oldincludedir = /usr/include
 
+DISTDIR =
+
 pkgdatadir = $(datadir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
@@ -140,14 +142,14 @@
 SOURCES = $(libzlib_a_SOURCES)
 OBJECTS = $(libzlib_a_OBJECTS)
 
-default: all
+all: Makefile $(LIBRARIES)
 
 .SUFFIXES:
 .SUFFIXES: .S .c .o .s
-$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4) 
+$(srcdir)/Makefile.in: Makefile.am $(top_srcdir)/configure.in $(ACLOCAL_M4)
 	cd $(top_srcdir) && $(AUTOMAKE) --gnu --include-deps zlib/Makefile
 
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+Makefile: $(srcdir)/Makefile.in  $(top_builddir)/config.status
 	cd $(top_builddir) \
 	  && CONFIG_FILES=$(subdir)/$@ CONFIG_HEADERS= $(SHELL) ./config.status
 
@@ -221,24 +223,6 @@
 	  || ln $$d/$$file $(distdir)/$$file 2> /dev/null \
 	  || cp -p $$d/$$file $(distdir)/$$file; \
 	done
-adler32.o: adler32.c zlib.h zconf.h
-compress.o: compress.c zlib.h zconf.h
-crc32.o: crc32.c zlib.h zconf.h
-deflate.o: deflate.c deflate.h zutil.h zlib.h zconf.h
-gzio.o: gzio.c zutil.h zlib.h zconf.h
-infblock.o: infblock.c zutil.h zlib.h zconf.h infblock.h inftrees.h \
-	infcodes.h infutil.h
-infcodes.o: infcodes.c zutil.h zlib.h zconf.h inftrees.h infblock.h \
-	infcodes.h infutil.h inffast.h
-inffast.o: inffast.c zutil.h zlib.h zconf.h inftrees.h infblock.h \
-	infcodes.h infutil.h inffast.h
-inflate.o: inflate.c zutil.h zlib.h zconf.h infblock.h
-inftrees.o: inftrees.c zutil.h zlib.h zconf.h inftrees.h
-infutil.o: infutil.c zutil.h zlib.h zconf.h infblock.h inftrees.h \
-	infcodes.h infutil.h
-trees.o: trees.c deflate.h zutil.h zlib.h zconf.h
-uncompr.o: uncompr.c zlib.h zconf.h
-zutil.o: zutil.c zutil.h zlib.h zconf.h
 
 info:
 dvi:
@@ -256,8 +240,6 @@
 
 uninstall: 
 
-all: Makefile $(LIBRARIES)
-
 install-strip:
 	$(MAKE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' INSTALL_SCRIPT='$(INSTALL_PROGRAM)' install
 installdirs:
@@ -293,7 +275,7 @@
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
-.PHONY: default mostlyclean-noinstLIBRARIES distclean-noinstLIBRARIES \
+.PHONY: mostlyclean-noinstLIBRARIES distclean-noinstLIBRARIES \
 clean-noinstLIBRARIES maintainer-clean-noinstLIBRARIES \
 mostlyclean-compile distclean-compile clean-compile \
 maintainer-clean-compile tags mostlyclean-tags distclean-tags \
